import { AST_NODE_TYPES } from '@typescript-eslint/types';
import { ASTUtils, ESLintUtils } from '@typescript-eslint/utils';
import { ScopeType, DefinitionType } from '@typescript-eslint/scope-manager';
import { toLowerCase, delimiterCase, replace } from 'string-ts';
import { parse } from 'valibot';
import { getConstrainedTypeAtLocation } from '@typescript-eslint/type-utils';
import * as tsutils from 'ts-api-utils';
import ts from 'typescript';

var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export = (target, all12) => {
  for (var name2 in all12)
    __defProp(target, name2, { get: all12[name2], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  __defProp(target, "default", { value: mod, enumerable: true }) ,
  mod
));

// ../../../node_modules/.pnpm/short-unique-id@5.2.0/node_modules/short-unique-id/dist/short-unique-id.js
var require_short_unique_id = __commonJS({
  "../../../node_modules/.pnpm/short-unique-id@5.2.0/node_modules/short-unique-id/dist/short-unique-id.js"(exports, module) {
    var ShortUniqueId2 = (() => {
      var __defProp7 = Object.defineProperty;
      var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
      var __getOwnPropNames2 = Object.getOwnPropertyNames;
      var __getOwnPropSymbols = Object.getOwnPropertySymbols;
      var __hasOwnProp2 = Object.prototype.hasOwnProperty;
      var __propIsEnum = Object.prototype.propertyIsEnumerable;
      var __defNormalProp = (obj, key, value) => key in obj ? __defProp7(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
      var __spreadValues = (a5, b5) => {
        for (var prop in b5 || (b5 = {}))
          if (__hasOwnProp2.call(b5, prop))
            __defNormalProp(a5, prop, b5[prop]);
        if (__getOwnPropSymbols)
          for (var prop of __getOwnPropSymbols(b5)) {
            if (__propIsEnum.call(b5, prop))
              __defNormalProp(a5, prop, b5[prop]);
          }
        return a5;
      };
      var __export7 = (target, all12) => {
        for (var name2 in all12)
          __defProp7(target, name2, { get: all12[name2], enumerable: true });
      };
      var __copyProps2 = (to, from, except, desc) => {
        if (from && typeof from === "object" || typeof from === "function") {
          for (let key of __getOwnPropNames2(from))
            if (!__hasOwnProp2.call(to, key) && key !== except)
              __defProp7(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc2(from, key)) || desc.enumerable });
        }
        return to;
      };
      var __toCommonJS = (mod) => __copyProps2(__defProp7({}, "__esModule", { value: true }), mod);
      var __publicField = (obj, key, value) => {
        __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
        return value;
      };
      var src_exports = {};
      __export7(src_exports, {
        DEFAULT_OPTIONS: () => DEFAULT_OPTIONS,
        DEFAULT_UUID_LENGTH: () => DEFAULT_UUID_LENGTH,
        default: () => ShortUniqueId3
      });
      var version2 = "5.2.0";
      var DEFAULT_UUID_LENGTH = 6;
      var DEFAULT_OPTIONS = {
        dictionary: "alphanum",
        shuffle: true,
        debug: false,
        length: DEFAULT_UUID_LENGTH,
        counter: 0
      };
      var _ShortUniqueId = class _ShortUniqueId {
        constructor(argOptions = {}) {
          __publicField(this, "counter");
          __publicField(this, "debug");
          __publicField(this, "dict");
          __publicField(this, "version");
          __publicField(this, "dictIndex", 0);
          __publicField(this, "dictRange", []);
          __publicField(this, "lowerBound", 0);
          __publicField(this, "upperBound", 0);
          __publicField(this, "dictLength", 0);
          __publicField(this, "uuidLength");
          __publicField(this, "_digit_first_ascii", 48);
          __publicField(this, "_digit_last_ascii", 58);
          __publicField(this, "_alpha_lower_first_ascii", 97);
          __publicField(this, "_alpha_lower_last_ascii", 123);
          __publicField(this, "_hex_last_ascii", 103);
          __publicField(this, "_alpha_upper_first_ascii", 65);
          __publicField(this, "_alpha_upper_last_ascii", 91);
          __publicField(this, "_number_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii]
          });
          __publicField(this, "_alpha_dict_ranges", {
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii],
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_alpha_lower_dict_ranges", {
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii]
          });
          __publicField(this, "_alpha_upper_dict_ranges", {
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_alphanum_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii],
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii],
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_alphanum_lower_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii],
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii]
          });
          __publicField(this, "_alphanum_upper_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii],
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_hex_dict_ranges", {
            decDigits: [this._digit_first_ascii, this._digit_last_ascii],
            alphaDigits: [this._alpha_lower_first_ascii, this._hex_last_ascii]
          });
          __publicField(this, "_dict_ranges", {
            _number_dict_ranges: this._number_dict_ranges,
            _alpha_dict_ranges: this._alpha_dict_ranges,
            _alpha_lower_dict_ranges: this._alpha_lower_dict_ranges,
            _alpha_upper_dict_ranges: this._alpha_upper_dict_ranges,
            _alphanum_dict_ranges: this._alphanum_dict_ranges,
            _alphanum_lower_dict_ranges: this._alphanum_lower_dict_ranges,
            _alphanum_upper_dict_ranges: this._alphanum_upper_dict_ranges,
            _hex_dict_ranges: this._hex_dict_ranges
          });
          __publicField(this, "log", (...args) => {
            const finalArgs = [...args];
            finalArgs[0] = `[short-unique-id] ${args[0]}`;
            if (this.debug === true) {
              if (typeof console !== "undefined" && console !== null) {
                return console.log(...finalArgs);
              }
            }
          });
          __publicField(this, "_normalizeDictionary", (dictionary2, shuffle2) => {
            let finalDict;
            if (dictionary2 && Array.isArray(dictionary2) && dictionary2.length > 1) {
              finalDict = dictionary2;
            } else {
              finalDict = [];
              let i5;
              this.dictIndex = i5 = 0;
              const rangesName = `_${dictionary2}_dict_ranges`;
              const ranges = this._dict_ranges[rangesName];
              Object.keys(ranges).forEach((rangeType) => {
                const rangeTypeKey = rangeType;
                this.dictRange = ranges[rangeTypeKey];
                this.lowerBound = this.dictRange[0];
                this.upperBound = this.dictRange[1];
                for (this.dictIndex = i5 = this.lowerBound; this.lowerBound <= this.upperBound ? i5 < this.upperBound : i5 > this.upperBound; this.dictIndex = this.lowerBound <= this.upperBound ? i5 += 1 : i5 -= 1) {
                  finalDict.push(String.fromCharCode(this.dictIndex));
                }
              });
            }
            if (shuffle2) {
              const PROBABILITY = 0.5;
              finalDict = finalDict.sort(() => Math.random() - PROBABILITY);
            }
            return finalDict;
          });
          __publicField(this, "setDictionary", (dictionary2, shuffle2) => {
            this.dict = this._normalizeDictionary(dictionary2, shuffle2);
            this.dictLength = this.dict.length;
            this.setCounter(0);
          });
          __publicField(this, "seq", () => {
            return this.sequentialUUID();
          });
          __publicField(this, "sequentialUUID", () => {
            let counterDiv;
            let counterRem;
            let id = "";
            counterDiv = this.counter;
            do {
              counterRem = counterDiv % this.dictLength;
              counterDiv = Math.trunc(counterDiv / this.dictLength);
              id += this.dict[counterRem];
            } while (counterDiv !== 0);
            this.counter += 1;
            return id;
          });
          __publicField(this, "rnd", (uuidLength = this.uuidLength || DEFAULT_UUID_LENGTH) => {
            return this.randomUUID(uuidLength);
          });
          __publicField(this, "randomUUID", (uuidLength = this.uuidLength || DEFAULT_UUID_LENGTH) => {
            let id;
            let randomPartIdx;
            let j5;
            if (uuidLength === null || typeof uuidLength === "undefined" || uuidLength < 1) {
              throw new Error("Invalid UUID Length Provided");
            }
            id = "";
            for (j5 = 0; j5 < uuidLength; j5 += 1) {
              randomPartIdx = parseInt(
                (Math.random() * this.dictLength).toFixed(0),
                10
              ) % this.dictLength;
              id += this.dict[randomPartIdx];
            }
            return id;
          });
          __publicField(this, "fmt", (format8, date) => {
            return this.formattedUUID(format8, date);
          });
          __publicField(this, "formattedUUID", (format8, date) => {
            const fnMap = {
              "$r": this.randomUUID,
              "$s": this.sequentialUUID,
              "$t": this.stamp
            };
            const result = format8.replace(
              /\$[rs]\d{0,}|\$t0|\$t[1-9]\d{1,}/g,
              (m5) => {
                const fn = m5.slice(0, 2);
                const len = parseInt(m5.slice(2), 10);
                if (fn === "$s") {
                  return fnMap[fn]().padStart(len, "0");
                }
                if (fn === "$t" && date) {
                  return fnMap[fn](len, date);
                }
                return fnMap[fn](len);
              }
            );
            return result;
          });
          __publicField(this, "availableUUIDs", (uuidLength = this.uuidLength) => {
            return parseFloat(
              Math.pow([...new Set(this.dict)].length, uuidLength).toFixed(0)
            );
          });
          __publicField(this, "approxMaxBeforeCollision", (rounds = this.availableUUIDs(this.uuidLength)) => {
            return parseFloat(
              Math.sqrt(Math.PI / 2 * rounds).toFixed(20)
            );
          });
          __publicField(this, "collisionProbability", (rounds = this.availableUUIDs(this.uuidLength), uuidLength = this.uuidLength) => {
            return parseFloat(
              (this.approxMaxBeforeCollision(rounds) / this.availableUUIDs(uuidLength)).toFixed(20)
            );
          });
          __publicField(this, "uniqueness", (rounds = this.availableUUIDs(this.uuidLength)) => {
            const score = parseFloat(
              (1 - this.approxMaxBeforeCollision(rounds) / rounds).toFixed(20)
            );
            return score > 1 ? 1 : score < 0 ? 0 : score;
          });
          __publicField(this, "getVersion", () => {
            return this.version;
          });
          __publicField(this, "stamp", (finalLength, date) => {
            const hexStamp = Math.floor(+(date || /* @__PURE__ */ new Date()) / 1e3).toString(16);
            if (typeof finalLength === "number" && finalLength === 0) {
              return hexStamp;
            }
            if (typeof finalLength !== "number" || finalLength < 10) {
              throw new Error(
                [
                  "Param finalLength must be a number greater than or equal to 10,",
                  "or 0 if you want the raw hexadecimal timestamp"
                ].join("\n")
              );
            }
            const idLength = finalLength - 9;
            const rndIdx = Math.round(Math.random() * (idLength > 15 ? 15 : idLength));
            const id = this.randomUUID(idLength);
            return `${id.substring(0, rndIdx)}${hexStamp}${id.substring(rndIdx)}${rndIdx.toString(16)}`;
          });
          __publicField(this, "parseStamp", (suid, format8) => {
            if (format8 && !/t0|t[1-9]\d{1,}/.test(format8)) {
              throw new Error("Cannot extract date from a formated UUID with no timestamp in the format");
            }
            const stamp = format8 ? format8.replace(
              /\$[rs]\d{0,}|\$t0|\$t[1-9]\d{1,}/g,
              (m5) => {
                const fnMap = {
                  "$r": (len2) => [...Array(len2)].map(() => "r").join(""),
                  "$s": (len2) => [...Array(len2)].map(() => "s").join(""),
                  "$t": (len2) => [...Array(len2)].map(() => "t").join("")
                };
                const fn = m5.slice(0, 2);
                const len = parseInt(m5.slice(2), 10);
                return fnMap[fn](len);
              }
            ).replace(
              /^(.*?)(t{8,})(.*)$/g,
              (_m, p1, p23) => {
                return suid.substring(p1.length, p1.length + p23.length);
              }
            ) : suid;
            if (stamp.length === 8) {
              return new Date(parseInt(stamp, 16) * 1e3);
            }
            if (stamp.length < 10) {
              throw new Error("Stamp length invalid");
            }
            const rndIdx = parseInt(stamp.substring(stamp.length - 1), 16);
            return new Date(parseInt(stamp.substring(rndIdx, rndIdx + 8), 16) * 1e3);
          });
          __publicField(this, "setCounter", (counter2) => {
            this.counter = counter2;
          });
          __publicField(this, "validate", (uid4, dictionary2) => {
            const finalDictionary = dictionary2 ? this._normalizeDictionary(dictionary2) : this.dict;
            return uid4.split("").every((c5) => finalDictionary.includes(c5));
          });
          const options = __spreadValues(__spreadValues({}, DEFAULT_OPTIONS), argOptions);
          this.counter = 0;
          this.debug = false;
          this.dict = [];
          this.version = version2;
          const {
            dictionary,
            shuffle,
            length: length4,
            counter
          } = options;
          this.uuidLength = length4;
          this.setDictionary(dictionary, shuffle);
          this.setCounter(counter);
          this.debug = options.debug;
          this.log(this.dict);
          this.log(
            `Generator instantiated with Dictionary Size ${this.dictLength} and counter set to ${this.counter}`
          );
          this.log = this.log.bind(this);
          this.setDictionary = this.setDictionary.bind(this);
          this.setCounter = this.setCounter.bind(this);
          this.seq = this.seq.bind(this);
          this.sequentialUUID = this.sequentialUUID.bind(this);
          this.rnd = this.rnd.bind(this);
          this.randomUUID = this.randomUUID.bind(this);
          this.fmt = this.fmt.bind(this);
          this.formattedUUID = this.formattedUUID.bind(this);
          this.availableUUIDs = this.availableUUIDs.bind(this);
          this.approxMaxBeforeCollision = this.approxMaxBeforeCollision.bind(this);
          this.collisionProbability = this.collisionProbability.bind(this);
          this.uniqueness = this.uniqueness.bind(this);
          this.getVersion = this.getVersion.bind(this);
          this.stamp = this.stamp.bind(this);
          this.parseStamp = this.parseStamp.bind(this);
          return this;
        }
      };
      __publicField(_ShortUniqueId, "default", _ShortUniqueId);
      var ShortUniqueId3 = _ShortUniqueId;
      return __toCommonJS(src_exports);
    })();
    "undefined" != typeof module && (module.exports = ShortUniqueId2.default), "undefined" != typeof window && (ShortUniqueId2 = ShortUniqueId2.default);
  }
});

// package.json
var name = "@neetly-eslint-react/eslint-plugin-react-core";
var version = "1.5.15-beta.1";

// ../../../node_modules/.pnpm/ts-pattern@5.1.2/node_modules/ts-pattern/dist/index.js
var t = Symbol.for("@ts-pattern/matcher");
var e = Symbol.for("@ts-pattern/isVariadic");
var n = "@ts-pattern/anonymous-select-key";
var r = (t5) => Boolean(t5 && "object" == typeof t5);
var i = (e5) => e5 && !!e5[t];
var o = (n5, s5, c5) => {
  if (i(n5)) {
    const e5 = n5[t](), { matched: r5, selections: i5 } = e5.match(s5);
    return r5 && i5 && Object.keys(i5).forEach((t5) => c5(t5, i5[t5])), r5;
  }
  if (r(n5)) {
    if (!r(s5)) return false;
    if (Array.isArray(n5)) {
      if (!Array.isArray(s5)) return false;
      let t5 = [], r5 = [], a5 = [];
      for (const o5 of n5.keys()) {
        const s6 = n5[o5];
        i(s6) && s6[e] ? a5.push(s6) : a5.length ? r5.push(s6) : t5.push(s6);
      }
      if (a5.length) {
        if (a5.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s5.length < t5.length + r5.length) return false;
        const e5 = s5.slice(0, t5.length), n6 = 0 === r5.length ? [] : s5.slice(-r5.length), i5 = s5.slice(t5.length, 0 === r5.length ? Infinity : -r5.length);
        return t5.every((t6, n7) => o(t6, e5[n7], c5)) && r5.every((t6, e6) => o(t6, n6[e6], c5)) && (0 === a5.length || o(a5[0], i5, c5));
      }
      return n5.length === s5.length && n5.every((t6, e5) => o(t6, s5[e5], c5));
    }
    return Object.keys(n5).every((e5) => {
      const r5 = n5[e5];
      return (e5 in s5 || i(a5 = r5) && "optional" === a5[t]().matcherType) && o(r5, s5[e5], c5);
      var a5;
    });
  }
  return Object.is(s5, n5);
};
var s = (e5) => {
  var n5, o5, a5;
  return r(e5) ? i(e5) ? null != (n5 = null == (o5 = (a5 = e5[t]()).getSelectionKeys) ? void 0 : o5.call(a5)) ? n5 : [] : Array.isArray(e5) ? c(e5, s) : c(Object.values(e5), s) : [];
};
var c = (t5, e5) => t5.reduce((t6, n5) => t6.concat(e5(n5)), []);
function a(...t5) {
  if (1 === t5.length) {
    const [e5] = t5;
    return (t6) => o(e5, t6, () => {
    });
  }
  if (2 === t5.length) {
    const [e5, n5] = t5;
    return o(e5, n5, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t5.length}.`);
}
function u(t5) {
  return Object.assign(t5, { optional: () => l(t5), and: (e5) => m(t5, e5), or: (e5) => d(t5, e5), select: (e5) => void 0 === e5 ? p(t5) : p(e5, t5) });
}
function h(t5) {
  return Object.assign(((t6) => Object.assign(t6, { [Symbol.iterator]() {
    let n5 = 0;
    const r5 = [{ value: Object.assign(t6, { [e]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t7;
      return null != (t7 = r5[n5++]) ? t7 : r5.at(-1);
    } };
  } }))(t5), { optional: () => h(l(t5)), select: (e5) => h(void 0 === e5 ? p(t5) : p(e5, t5)) });
}
function l(e5) {
  return u({ [t]: () => ({ match: (t5) => {
    let n5 = {};
    const r5 = (t6, e6) => {
      n5[t6] = e6;
    };
    return void 0 === t5 ? (s(e5).forEach((t6) => r5(t6, void 0)), { matched: true, selections: n5 }) : { matched: o(e5, t5, r5), selections: n5 };
  }, getSelectionKeys: () => s(e5), matcherType: "optional" }) });
}
var f = (t5, e5) => {
  for (const n5 of t5) if (!e5(n5)) return false;
  return true;
};
var g = (t5, e5) => {
  for (const [n5, r5] of t5.entries()) if (!e5(r5, n5)) return false;
  return true;
};
function m(...e5) {
  return u({ [t]: () => ({ match: (t5) => {
    let n5 = {};
    const r5 = (t6, e6) => {
      n5[t6] = e6;
    };
    return { matched: e5.every((e6) => o(e6, t5, r5)), selections: n5 };
  }, getSelectionKeys: () => c(e5, s), matcherType: "and" }) });
}
function d(...e5) {
  return u({ [t]: () => ({ match: (t5) => {
    let n5 = {};
    const r5 = (t6, e6) => {
      n5[t6] = e6;
    };
    return c(e5, s).forEach((t6) => r5(t6, void 0)), { matched: e5.some((e6) => o(e6, t5, r5)), selections: n5 };
  }, getSelectionKeys: () => c(e5, s), matcherType: "or" }) });
}
function y(e5) {
  return { [t]: () => ({ match: (t5) => ({ matched: Boolean(e5(t5)) }) }) };
}
function p(...e5) {
  const r5 = "string" == typeof e5[0] ? e5[0] : void 0, i5 = 2 === e5.length ? e5[1] : "string" == typeof e5[0] ? void 0 : e5[0];
  return u({ [t]: () => ({ match: (t5) => {
    let e6 = { [null != r5 ? r5 : n]: t5 };
    return { matched: void 0 === i5 || o(i5, t5, (t6, n5) => {
      e6[t6] = n5;
    }), selections: e6 };
  }, getSelectionKeys: () => [null != r5 ? r5 : n].concat(void 0 === i5 ? [] : s(i5)) }) });
}
function v(t5) {
  return "number" == typeof t5;
}
function b(t5) {
  return "string" == typeof t5;
}
function w(t5) {
  return "bigint" == typeof t5;
}
var S = u(y(function(t5) {
  return true;
}));
var O = S;
var j = (t5) => Object.assign(u(t5), { startsWith: (e5) => {
  return j(m(t5, (n5 = e5, y((t6) => b(t6) && t6.startsWith(n5)))));
  var n5;
}, endsWith: (e5) => {
  return j(m(t5, (n5 = e5, y((t6) => b(t6) && t6.endsWith(n5)))));
  var n5;
}, minLength: (e5) => j(m(t5, ((t6) => y((e6) => b(e6) && e6.length >= t6))(e5))), maxLength: (e5) => j(m(t5, ((t6) => y((e6) => b(e6) && e6.length <= t6))(e5))), includes: (e5) => {
  return j(m(t5, (n5 = e5, y((t6) => b(t6) && t6.includes(n5)))));
  var n5;
}, regex: (e5) => {
  return j(m(t5, (n5 = e5, y((t6) => b(t6) && Boolean(t6.match(n5))))));
  var n5;
} });
var E = j(y(b));
var K = (t5) => Object.assign(u(t5), { between: (e5, n5) => K(m(t5, ((t6, e6) => y((n6) => v(n6) && t6 <= n6 && e6 >= n6))(e5, n5))), lt: (e5) => K(m(t5, ((t6) => y((e6) => v(e6) && e6 < t6))(e5))), gt: (e5) => K(m(t5, ((t6) => y((e6) => v(e6) && e6 > t6))(e5))), lte: (e5) => K(m(t5, ((t6) => y((e6) => v(e6) && e6 <= t6))(e5))), gte: (e5) => K(m(t5, ((t6) => y((e6) => v(e6) && e6 >= t6))(e5))), int: () => K(m(t5, y((t6) => v(t6) && Number.isInteger(t6)))), finite: () => K(m(t5, y((t6) => v(t6) && Number.isFinite(t6)))), positive: () => K(m(t5, y((t6) => v(t6) && t6 > 0))), negative: () => K(m(t5, y((t6) => v(t6) && t6 < 0))) });
var x = K(y(v));
var A = (t5) => Object.assign(u(t5), { between: (e5, n5) => A(m(t5, ((t6, e6) => y((n6) => w(n6) && t6 <= n6 && e6 >= n6))(e5, n5))), lt: (e5) => A(m(t5, ((t6) => y((e6) => w(e6) && e6 < t6))(e5))), gt: (e5) => A(m(t5, ((t6) => y((e6) => w(e6) && e6 > t6))(e5))), lte: (e5) => A(m(t5, ((t6) => y((e6) => w(e6) && e6 <= t6))(e5))), gte: (e5) => A(m(t5, ((t6) => y((e6) => w(e6) && e6 >= t6))(e5))), positive: () => A(m(t5, y((t6) => w(t6) && t6 > 0))), negative: () => A(m(t5, y((t6) => w(t6) && t6 < 0))) });
var P = A(y(w));
var T = u(y(function(t5) {
  return "boolean" == typeof t5;
}));
var k = u(y(function(t5) {
  return "symbol" == typeof t5;
}));
var B = u(y(function(t5) {
  return null == t5;
}));
var _ = u(y(function(t5) {
  return null != t5;
}));
var N = { __proto__: null, matcher: t, optional: l, array: function(...e5) {
  return h({ [t]: () => ({ match: (t5) => {
    if (!Array.isArray(t5)) return { matched: false };
    if (0 === e5.length) return { matched: true };
    const n5 = e5[0];
    let r5 = {};
    if (0 === t5.length) return s(n5).forEach((t6) => {
      r5[t6] = [];
    }), { matched: true, selections: r5 };
    const i5 = (t6, e6) => {
      r5[t6] = (r5[t6] || []).concat([e6]);
    };
    return { matched: t5.every((t6) => o(n5, t6, i5)), selections: r5 };
  }, getSelectionKeys: () => 0 === e5.length ? [] : s(e5[0]) }) });
}, set: function(...e5) {
  return u({ [t]: () => ({ match: (t5) => {
    if (!(t5 instanceof Set)) return { matched: false };
    let n5 = {};
    if (0 === t5.size) return { matched: true, selections: n5 };
    if (0 === e5.length) return { matched: true };
    const r5 = (t6, e6) => {
      n5[t6] = (n5[t6] || []).concat([e6]);
    }, i5 = e5[0];
    return { matched: f(t5, (t6) => o(i5, t6, r5)), selections: n5 };
  }, getSelectionKeys: () => 0 === e5.length ? [] : s(e5[0]) }) });
}, map: function(...e5) {
  return u({ [t]: () => ({ match: (t5) => {
    if (!(t5 instanceof Map)) return { matched: false };
    let n5 = {};
    if (0 === t5.size) return { matched: true, selections: n5 };
    const r5 = (t6, e6) => {
      n5[t6] = (n5[t6] || []).concat([e6]);
    };
    if (0 === e5.length) return { matched: true };
    var i5;
    if (1 === e5.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i5 = e5[0]) ? void 0 : i5.toString()}`);
    const [s5, c5] = e5;
    return { matched: g(t5, (t6, e6) => {
      const n6 = o(s5, e6, r5), i6 = o(c5, t6, r5);
      return n6 && i6;
    }), selections: n5 };
  }, getSelectionKeys: () => 0 === e5.length ? [] : [...s(e5[0]), ...s(e5[1])] }) });
}, intersection: m, union: d, not: function(e5) {
  return u({ [t]: () => ({ match: (t5) => ({ matched: !o(e5, t5, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y, select: p, any: S, _: O, string: E, number: x, bigint: P, boolean: T, symbol: k, nullish: B, nonNullable: _, instanceOf: function(t5) {
  return u(y(/* @__PURE__ */ function(t6) {
    return (e5) => e5 instanceof t6;
  }(t5)));
}, shape: function(t5) {
  return u(y(a(t5)));
} };
var W = { matched: false, value: void 0 };
function $(t5) {
  return new z(t5, W);
}
var z = class _z {
  constructor(t5, e5) {
    this.input = void 0, this.state = void 0, this.input = t5, this.state = e5;
  }
  with(...t5) {
    if (this.state.matched) return this;
    const e5 = t5[t5.length - 1], r5 = [t5[0]];
    let i5;
    3 === t5.length && "function" == typeof t5[1] ? i5 = t5[1] : t5.length > 2 && r5.push(...t5.slice(1, t5.length - 1));
    let s5 = false, c5 = {};
    const a5 = (t6, e6) => {
      s5 = true, c5[t6] = e6;
    }, u5 = !r5.some((t6) => o(t6, this.input, a5)) || i5 && !Boolean(i5(this.input)) ? W : { matched: true, value: e5(s5 ? n in c5 ? c5[n] : c5 : this.input, this.input) };
    return new _z(this.input, u5);
  }
  when(t5, e5) {
    if (this.state.matched) return this;
    const n5 = Boolean(t5(this.input));
    return new _z(this.input, n5 ? { matched: true, value: e5(this.input, this.input) } : W);
  }
  otherwise(t5) {
    return this.state.matched ? this.state.value : t5(this.input);
  }
  exhaustive() {
    if (this.state.matched) return this.state.value;
    let t5;
    try {
      t5 = JSON.stringify(this.input);
    } catch (e5) {
      t5 = this.input;
    }
    throw new Error(`Pattern matching error: no pattern matches value ${t5}`);
  }
  run() {
    return this.exhaustive();
  }
  returnType() {
    return this;
  }
};
var __defProp2 = Object.defineProperty;
var __export2 = (target, all63) => {
  for (var name2 in all63)
    __defProp2(target, name2, { get: all63[name2], enumerable: true });
};
var KEYS = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES = Object.keys(KEYS);
for (const type of NODE_TYPES) {
  Object.freeze(KEYS[type]);
}
Object.freeze(KEYS);
var visitor_keys_default = KEYS;
var KEY_BLACKLIST = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey(key) {
  return !KEY_BLACKLIST.has(key) && key[0] !== "_";
}
function getKeys(node) {
  return Object.keys(node).filter(filterKey);
}
function getInnermostScope(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range22 = childScope.block.range;
      if (range22[0] <= location && location < range22[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable(initialScope, nameOrNode) {
  let name2 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name2 = nameOrNode;
  } else {
    name2 = nameOrNode.name;
    scope = getInnermostScope(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name2);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate0(token) {
  return !this(token);
}
function negate(f23) {
  return negate0.bind(f23);
}
function isPunctuatorTokenWithValue(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken(token) {
  return isPunctuatorTokenWithValue(token, "=>");
}
function isCommaToken(token) {
  return isPunctuatorTokenWithValue(token, ",");
}
function isSemicolonToken(token) {
  return isPunctuatorTokenWithValue(token, ";");
}
function isColonToken(token) {
  return isPunctuatorTokenWithValue(token, ":");
}
function isOpeningParenToken(token) {
  return isPunctuatorTokenWithValue(token, "(");
}
function isClosingParenToken(token) {
  return isPunctuatorTokenWithValue(token, ")");
}
function isOpeningBracketToken(token) {
  return isPunctuatorTokenWithValue(token, "[");
}
function isClosingBracketToken(token) {
  return isPunctuatorTokenWithValue(token, "]");
}
function isOpeningBraceToken(token) {
  return isPunctuatorTokenWithValue(token, "{");
}
function isClosingBraceToken(token) {
  return isPunctuatorTokenWithValue(token, "}");
}
function isCommentToken(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate(isArrowToken);
negate(isCommaToken);
negate(isSemicolonToken);
negate(isColonToken);
negate(isOpeningParenToken);
negate(isClosingParenToken);
negate(isOpeningBracketToken);
negate(isClosingBracketToken);
negate(isOpeningBraceToken);
negate(isClosingBraceToken);
negate(isCommentToken);
function getOpeningParenOfParams(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken) : sourceCode.getFirstToken(node, isOpeningParenToken);
}
function getFunctionHeadLocation(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k23) => k23 !== "random").map((k23) => Math[k23]).filter((f23) => typeof f23 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f23) => typeof f23 === "function")
);
var callPassThrough = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor(object3, name2) {
  let x23 = object3;
  while ((typeof x23 === "object" || typeof x23 === "function") && x23 !== null) {
    const d23 = Object.getOwnPropertyDescriptor(x23, name2);
    if (d23) {
      return d23;
    }
    x23 = Object.getPrototypeOf(x23);
  }
  return null;
}
function isGetter(object3, name2) {
  const d23 = getPropertyDescriptor(object3, name2);
  return d23 != null && d23.get != null;
}
function getElementValues(nodeList, initialScope) {
  const valueList = [];
  for (let i23 = 0; i23 < nodeList.length; ++i23) {
    const elementNode = nodeList[i23];
    if (elementNode == null) {
      valueList.length = i23 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst(variable) {
  const refs = variable.references;
  const inits = refs.filter((r23) => r23.init).length;
  const reads = refs.filter((r23) => r23.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left53 = getStaticValueR(node.left, initialScope);
    const right53 = getStaticValueR(node.right, initialScope);
    if (left53 != null && right53 != null) {
      switch (node.operator) {
        case "==":
          return { value: left53.value == right53.value };
        case "!=":
          return { value: left53.value != right53.value };
        case "===":
          return { value: left53.value === right53.value };
        case "!==":
          return { value: left53.value !== right53.value };
        case "<":
          return { value: left53.value < right53.value };
        case "<=":
          return { value: left53.value <= right53.value };
        case ">":
          return { value: left53.value > right53.value };
        case ">=":
          return { value: left53.value >= right53.value };
        case "<<":
          return { value: left53.value << right53.value };
        case ">>":
          return { value: left53.value >> right53.value };
        case ">>>":
          return { value: left53.value >>> right53.value };
        case "+":
          return { value: left53.value + right53.value };
        case "-":
          return { value: left53.value - right53.value };
        case "*":
          return { value: left53.value * right53.value };
        case "/":
          return { value: left53.value / right53.value };
        case "%":
          return { value: left53.value % right53.value };
        case "**":
          return { value: left53.value ** right53.value };
        case "|":
          return { value: left53.value | right53.value };
        case "^":
          return { value: left53.value ^ right53.value };
        case "&":
          return { value: left53.value & right53.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object3 = getStaticValueR(calleeNode.object, initialScope);
        if (object3 != null) {
          if (object3.value == null && (object3.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object3.value;
            const methodName = property.value;
            if (callAllowed.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR(node.consequent, initialScope) : getStaticValueR(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames.has(variable.name) && variable.name in globalObject) {
        return { value: globalObject[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left53 = getStaticValueR(node.left, initialScope);
    if (left53 != null) {
      if (node.operator === "||" && Boolean(left53.value) === true || node.operator === "&&" && Boolean(left53.value) === false || node.operator === "??" && left53.value != null) {
        return left53;
      }
      const right53 = getStaticValueR(node.right, initialScope);
      if (right53 != null) {
        return right53;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object3 = getStaticValueR(node.object, initialScope);
    if (object3 != null) {
      if (object3.value == null && (object3.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue(node, initialScope);
      if (property != null) {
        if (!isGetter(object3.value, property.value)) {
          return { value: object3.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed) {
          if (object3.value instanceof classFn && allowed.has(property.value)) {
            return { value: object3.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR(node.callee, initialScope);
    const args = getElementValues(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object3 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object3[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object3, argument.value);
      } else {
        return null;
      }
    }
    return { value: object3 };
  },
  SequenceExpression(node, initialScope) {
    const last22 = node.expressions[node.expressions.length - 1];
    return getStaticValueR(last22, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR(node.tag, initialScope);
    const expressions = getElementValues(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i23 = 0; i23 < expressions.length; ++i23) {
        value += expressions[i23];
        value += node.quasis[i23 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations, node.type)) {
    return operations[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue(node, initialScope = null) {
  try {
    return getStaticValueR(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name2 = getPropertyName(parent);
      if (name2) {
        tokens.push(`'${name2}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode(x23) {
  return x23 !== null && typeof x23 === "object" && typeof x23.type === "string";
}
var visitor = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default
  );
}
function getParentSyntaxParen(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken(maybeLeftParen) && isClosingParenToken(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp22 = Object.defineProperty;
var __export22 = (target, all323) => {
  for (var name2 in all323)
    __defProp22(target, name2, { get: all323[name2], enumerable: true });
};
var NodeType = AST_NODE_TYPES;
var is = ASTUtils.isNodeOfType;
var isOneOf = ASTUtils.isNodeOfTypes;
isOneOf([
  NodeType.ArrowFunctionExpression,
  NodeType.FunctionDeclaration,
  NodeType.FunctionExpression
]);
isOneOf([
  NodeType.ArrowFunctionExpression,
  NodeType.FunctionDeclaration,
  NodeType.FunctionExpression,
  NodeType.TSCallSignatureDeclaration,
  NodeType.TSConstructSignatureDeclaration,
  NodeType.TSDeclareFunction,
  NodeType.TSEmptyBodyFunctionExpression,
  NodeType.TSFunctionType,
  NodeType.TSMethodSignature
]);
isOneOf([NodeType.ClassDeclaration, NodeType.ClassExpression]);
isOneOf([
  NodeType.DoWhileStatement,
  NodeType.ForInStatement,
  NodeType.ForOfStatement,
  NodeType.ForStatement,
  NodeType.WhileStatement
]);
isOneOf([NodeType.TSArrayType, NodeType.TSTupleType]);
isOneOf([
  NodeType.PropertyDefinition,
  NodeType.TSIndexSignature,
  NodeType.TSParameterProperty,
  NodeType.TSPropertySignature
]);
is(NodeType.JSXElement);
is(NodeType.JSXFragment);
isOneOf([
  NodeType.JSXAttribute,
  NodeType.JSXSpreadChild,
  NodeType.JSXClosingElement,
  NodeType.JSXClosingFragment,
  NodeType.JSXElement,
  NodeType.JSXEmptyExpression,
  NodeType.JSXExpressionContainer,
  NodeType.JSXFragment,
  NodeType.JSXIdentifier,
  NodeType.JSXMemberExpression,
  NodeType.JSXNamespacedName,
  NodeType.JSXOpeningElement,
  NodeType.JSXOpeningFragment,
  NodeType.JSXSpreadAttribute,
  NodeType.JSXSpreadChild,
  NodeType.JSXText
]);
isOneOf([
  NodeType.JSXIdentifier,
  NodeType.JSXMemberExpression,
  NodeType.JSXNamespacedName
]);
isOneOf([
  NodeType.ArrayPattern,
  NodeType.AssignmentPattern,
  NodeType.ObjectPattern,
  NodeType.RestElement
]);
isOneOf([
  NodeType.TSInterfaceDeclaration,
  NodeType.TSTypeAliasDeclaration
]);
isOneOf([
  NodeType.ArrayExpression,
  NodeType.ArrayPattern,
  NodeType.ArrowFunctionExpression,
  NodeType.CallExpression,
  NodeType.ClassExpression,
  NodeType.FunctionExpression,
  NodeType.Identifier,
  NodeType.JSXElement,
  NodeType.JSXFragment,
  NodeType.Literal,
  NodeType.TemplateLiteral,
  NodeType.MemberExpression,
  NodeType.MetaProperty,
  NodeType.ObjectExpression,
  NodeType.ObjectPattern,
  NodeType.SequenceExpression,
  NodeType.Super,
  NodeType.TaggedTemplateExpression,
  NodeType.ThisExpression
]);
isOneOf([
  NodeType.ArrayExpression,
  NodeType.ArrayPattern,
  NodeType.ArrowFunctionExpression,
  NodeType.CallExpression,
  NodeType.ClassExpression,
  NodeType.FunctionExpression,
  NodeType.Identifier,
  NodeType.JSXElement,
  NodeType.JSXFragment,
  NodeType.Literal,
  NodeType.TemplateLiteral,
  NodeType.MemberExpression,
  NodeType.MetaProperty,
  NodeType.ObjectExpression,
  NodeType.ObjectPattern,
  NodeType.SequenceExpression,
  NodeType.Super,
  NodeType.TaggedTemplateExpression,
  NodeType.ThisExpression,
  NodeType.TSAsExpression,
  NodeType.TSNonNullExpression,
  NodeType.TSTypeAssertion
]);
var Function_exports = {};
__export22(Function_exports, {
  SK: () => SK,
  absurd: () => absurd,
  apply: () => apply,
  compose: () => compose,
  constFalse: () => constFalse,
  constNull: () => constNull,
  constTrue: () => constTrue,
  constUndefined: () => constUndefined,
  constVoid: () => constVoid,
  constant: () => constant,
  dual: () => dual,
  flip: () => flip,
  flow: () => flow,
  hole: () => hole,
  identity: () => identity,
  isFunction: () => isFunction2,
  pipe: () => pipe,
  satisfies: () => satisfies,
  tupled: () => tupled,
  unsafeCoerce: () => unsafeCoerce,
  untupled: () => untupled
});
var isFunction2 = (input) => typeof input === "function";
var dual = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a23, b23) {
        if (arguments.length >= 2) {
          return body(a23, b23);
        }
        return function(self2) {
          return body(self2, a23);
        };
      };
    case 3:
      return function(a23, b23, c23) {
        if (arguments.length >= 3) {
          return body(a23, b23, c23);
        }
        return function(self2) {
          return body(self2, a23, b23);
        };
      };
    case 4:
      return function(a23, b23, c23, d23) {
        if (arguments.length >= 4) {
          return body(a23, b23, c23, d23);
        }
        return function(self2) {
          return body(self2, a23, b23, c23);
        };
      };
    case 5:
      return function(a23, b23, c23, d23, e23) {
        if (arguments.length >= 5) {
          return body(a23, b23, c23, d23, e23);
        }
        return function(self2) {
          return body(self2, a23, b23, c23, d23);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply = (a23) => (self2) => self2(a23);
var identity = (a23) => a23;
var satisfies = () => (b23) => b23;
var unsafeCoerce = identity;
var constant = (value) => () => value;
var constTrue = /* @__PURE__ */ constant(true);
var constFalse = /* @__PURE__ */ constant(false);
var constNull = /* @__PURE__ */ constant(null);
var constUndefined = /* @__PURE__ */ constant(void 0);
var constVoid = constUndefined;
var flip = (f23) => (...b23) => (...a23) => f23(...a23)(...b23);
var compose = /* @__PURE__ */ dual(2, (ab, bc) => (a23) => bc(ab(a23)));
var absurd = (_23) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled = (f23) => (a23) => f23(...a23);
var untupled = (f23) => (...a23) => f23(a23);
function pipe(a23, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a23;
    case 2:
      return ab(a23);
    case 3:
      return bc(ab(a23));
    case 4:
      return cd(bc(ab(a23)));
    case 5:
      return de(cd(bc(ab(a23))));
    case 6:
      return ef(de(cd(bc(ab(a23)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a23))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a23)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a23))))))));
    default: {
      let ret = arguments[0];
      for (let i23 = 1; i23 < arguments.length; i23++) {
        ret = arguments[i23](ret);
      }
      return ret;
    }
  }
}
function flow(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole = /* @__PURE__ */ unsafeCoerce(absurd);
var SK = (_23, b23) => b23;
var make = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_ = (map63) => dual(3, (self2, name2, f23) => map63(self2, (a23) => Object.assign({}, a23, {
  [name2]: f23(a23)
})));
var bindTo = (map63) => dual(2, (self2, name2) => map63(self2, (a23) => ({
  [name2]: a23
})));
var bind = (map63, flatMap422) => dual(3, (self2, name2, f23) => flatMap422(self2, (a23) => map63(f23(a23), (b23) => Object.assign({}, a23, {
  [name2]: b23
}))));
var moduleVersion = "3.2.8";
var getCurrentVersion = () => moduleVersion;
var globalStoreId = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion()}`);
if (!(globalStoreId in globalThis)) {
  globalThis[globalStoreId] = /* @__PURE__ */ new Map();
}
var globalStore = globalThis[globalStoreId];
var globalValue = (id, compute) => {
  if (!globalStore.has(id)) {
    globalStore.set(id, compute());
  }
  return globalStore.get(id);
};
var Predicate_exports = {};
__export22(Predicate_exports, {
  all: () => all,
  and: () => and,
  compose: () => compose2,
  eqv: () => eqv,
  every: () => every,
  hasProperty: () => hasProperty,
  implies: () => implies,
  isBigInt: () => isBigInt,
  isBoolean: () => isBoolean,
  isDate: () => isDate,
  isError: () => isError,
  isFunction: () => isFunction3,
  isIterable: () => isIterable,
  isMap: () => isMap,
  isNever: () => isNever,
  isNotNull: () => isNotNull,
  isNotNullable: () => isNotNullable,
  isNotUndefined: () => isNotUndefined,
  isNull: () => isNull,
  isNullable: () => isNullable,
  isNumber: () => isNumber,
  isObject: () => isObject,
  isPromise: () => isPromise,
  isPromiseLike: () => isPromiseLike,
  isReadonlyRecord: () => isReadonlyRecord,
  isRecord: () => isRecord,
  isSet: () => isSet,
  isString: () => isString,
  isSymbol: () => isSymbol,
  isTagged: () => isTagged,
  isTruthy: () => isTruthy,
  isUint8Array: () => isUint8Array,
  isUndefined: () => isUndefined,
  isUnknown: () => isUnknown,
  mapInput: () => mapInput,
  nand: () => nand,
  nor: () => nor,
  not: () => not,
  or: () => or,
  product: () => product,
  productMany: () => productMany,
  some: () => some,
  struct: () => struct,
  tuple: () => tuple,
  xor: () => xor
});
var mapInput = /* @__PURE__ */ dual(2, (self2, f23) => (b23) => self2(f23(b23)));
var isTruthy = (input) => !!input;
var isSet = (input) => input instanceof Set;
var isMap = (input) => input instanceof Map;
var isString = (input) => typeof input === "string";
var isNumber = (input) => typeof input === "number";
var isBoolean = (input) => typeof input === "boolean";
var isBigInt = (input) => typeof input === "bigint";
var isSymbol = (input) => typeof input === "symbol";
var isFunction3 = isFunction2;
var isUndefined = (input) => input === void 0;
var isNotUndefined = (input) => input !== void 0;
var isNull = (input) => input === null;
var isNotNull = (input) => input !== null;
var isNever = (_23) => false;
var isUnknown = (_23) => true;
var isRecordOrArray = (input) => typeof input === "object" && input !== null;
var isObject = (input) => isRecordOrArray(input) || isFunction3(input);
var hasProperty = /* @__PURE__ */ dual(2, (self2, property) => isObject(self2) && property in self2);
var isTagged = /* @__PURE__ */ dual(2, (self2, tag) => hasProperty(self2, "_tag") && self2["_tag"] === tag);
var isNullable = (input) => input === null || input === void 0;
var isNotNullable = (input) => input !== null && input !== void 0;
var isError = (input) => input instanceof Error;
var isUint8Array = (input) => input instanceof Uint8Array;
var isDate = (input) => input instanceof Date;
var isIterable = (input) => hasProperty(input, Symbol.iterator);
var isRecord = (input) => isRecordOrArray(input) && !Array.isArray(input);
var isReadonlyRecord = isRecord;
var isPromise = (input) => hasProperty(input, "then") && "catch" in input && isFunction3(input.then) && isFunction3(input.catch);
var isPromiseLike = (input) => hasProperty(input, "then") && isFunction3(input.then);
var compose2 = /* @__PURE__ */ dual(2, (ab, bc) => (a23) => ab(a23) && bc(a23));
var product = (self2, that) => ([a23, b23]) => self2(a23) && that(b23);
var all = (collection) => {
  return (as233) => {
    let collectionIndex = 0;
    for (const p23 of collection) {
      if (collectionIndex >= as233.length) {
        break;
      }
      if (p23(as233[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany = (self2, collection) => {
  const rest = all(collection);
  return ([head23, ...tail23]) => self2(head23) === false ? false : rest(tail23);
};
var tuple = (...elements) => all(elements);
var struct = (fields) => {
  const keys223 = Object.keys(fields);
  return (a23) => {
    for (const key of keys223) {
      if (!fields[key](a23[key])) {
        return false;
      }
    }
    return true;
  };
};
var not = (self2) => (a23) => !self2(a23);
var or = /* @__PURE__ */ dual(2, (self2, that) => (a23) => self2(a23) || that(a23));
var and = /* @__PURE__ */ dual(2, (self2, that) => (a23) => self2(a23) && that(a23));
var xor = /* @__PURE__ */ dual(2, (self2, that) => (a23) => self2(a23) !== that(a23));
var eqv = /* @__PURE__ */ dual(2, (self2, that) => (a23) => self2(a23) === that(a23));
var implies = /* @__PURE__ */ dual(2, (self2, that) => (a23) => self2(a23) ? that(a23) : true);
var nor = /* @__PURE__ */ dual(2, (self2, that) => (a23) => !(self2(a23) || that(a23)));
var nand = /* @__PURE__ */ dual(2, (self2, that) => (a23) => !(self2(a23) && that(a23)));
var every = (collection) => (a23) => {
  for (const p23 of collection) {
    if (!p23(a23)) {
      return false;
    }
  }
  return true;
};
var some = (collection) => (a23) => {
  for (const p23 of collection) {
    if (p23(a23)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind = (u23) => isObject(u23) && GenKindTypeId in u23;
var GenKindImpl = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_23) => _23;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_23) => _23;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_23) => _23;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId] = GenKindTypeId;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen(this);
  }
};
var SingleShotGen = class _SingleShotGen {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a23) {
    return this.called ? {
      value: a23,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a23) {
    return {
      value: a23,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e23) {
    throw e23;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen(this.self);
  }
};
var adapter = () => function() {
  let x23 = arguments[0];
  for (let i23 = 1; i23 < arguments.length; i23++) {
    x23 = arguments[i23](x23);
  }
  return new GenKindImpl(x23);
};
var defaultIncHi = 335903614;
var defaultIncLo = 4150755663;
var MUL_HI = 1481765933 >>> 0;
var MUL_LO = 1284865837 >>> 0;
var BIT_53 = 9007199254740992;
var BIT_27 = 134217728;
var PCGRandom = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable(seedLo) && isNullable(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable(incLo) && isNullable(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo;
      incHi = this._state ? this._state[2] : defaultIncHi;
    } else if (isNullable(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add64(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max32) {
    if (!max32) {
      return this._next();
    }
    max32 = max32 >>> 0;
    if ((max32 & max32 - 1) === 0) {
      return this._next() & max32 - 1;
    }
    let num = 0;
    const skew = (-max32 >>> 0) % max32 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max32;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_27 + lo) / BIT_53;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul64(this._state, oldHi, oldLo, MUL_HI, MUL_LO);
    add64(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul64(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add64(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId]() {
    return this.#value;
  }
};
function yieldWrapGet(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId in self2) {
    return self2[YieldWrapTypeId]();
  }
  throw new Error(getBugErrorMessage("yieldWrapGet"));
}
var structuralRegionState = /* @__PURE__ */ globalValue("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache = /* @__PURE__ */ globalValue(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr = /* @__PURE__ */ globalValue(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom());
var symbol = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash = (self2) => {
  if (structuralRegionState.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number(self2);
    case "bigint":
      return string(self2.toString(10));
    case "boolean":
      return string(String(self2));
    case "symbol":
      return string(String(self2));
    case "string":
      return string(self2);
    case "undefined":
      return string("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string("null");
      } else if (self2 instanceof Date) {
        return hash(self2.toISOString());
      } else if (isHash(self2)) {
        return self2[symbol]();
      } else {
        return random(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random = (self2) => {
  if (!randomHashCache.has(self2)) {
    randomHashCache.set(self2, number(pcgr.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache.get(self2);
};
var combine = (b23) => (self2) => self2 * 53 ^ b23;
var optimize = (n23) => n23 & 3221225471 | n23 >>> 1 & 1073741824;
var isHash = (u23) => hasProperty(u23, symbol);
var number = (n23) => {
  if (n23 !== n23 || n23 === Infinity) {
    return 0;
  }
  let h23 = n23 | 0;
  if (h23 !== n23) {
    h23 ^= n23 * 4294967295;
  }
  while (n23 > 4294967295) {
    h23 ^= n23 /= 4294967295;
  }
  return optimize(n23);
};
var string = (str) => {
  let h23 = 5381, i23 = str.length;
  while (i23) {
    h23 = h23 * 33 ^ str.charCodeAt(--i23);
  }
  return optimize(h23);
};
var structureKeys = (o23, keys223) => {
  let h23 = 12289;
  for (let i23 = 0; i23 < keys223.length; i23++) {
    h23 ^= pipe(string(keys223[i23]), combine(hash(o23[keys223[i23]])));
  }
  return optimize(h23);
};
var structure = (o23) => structureKeys(o23, Object.keys(o23));
var array = (arr) => {
  let h23 = 6151;
  for (let i23 = 0; i23 < arr.length; i23++) {
    h23 = pipe(h23, combine(hash(arr[i23])));
  }
  return optimize(h23);
};
var cached = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash322) {
      Object.defineProperty(self22, symbol, {
        value() {
          return hash322;
        },
        enumerable: false
      });
      return hash322;
    };
  }
  const self2 = arguments[0];
  const hash233 = arguments[1];
  Object.defineProperty(self2, symbol, {
    value() {
      return hash233;
    },
    enumerable: false
  });
  return hash233;
};
var symbol2 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals() {
  if (arguments.length === 1) {
    return (self2) => compareBoth(self2, arguments[0]);
  }
  return compareBoth(arguments[0], arguments[1]);
}
function compareBoth(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual(self2) && isEqual(that)) {
        if (hash(self2) === hash(that) && self2[symbol2](that)) {
          return true;
        } else {
          return structuralRegionState.enabled && structuralRegionState.tester ? structuralRegionState.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v23, i23) => compareBoth(v23, that[i23]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth(self2[key], that[key]))) {
              return structuralRegionState.tester ? structuralRegionState.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState.tester ? structuralRegionState.tester(self2, that) : false;
    }
  }
  return structuralRegionState.enabled && structuralRegionState.tester ? structuralRegionState.tester(self2, that) : false;
}
var isEqual = (u23) => hasProperty(u23, symbol2);
var equivalence = () => equals;
var NodeInspectSymbol = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON = (x23) => {
  if (hasProperty(x23, "toJSON") && isFunction3(x23["toJSON"]) && x23["toJSON"].length === 0) {
    return x23.toJSON();
  } else if (Array.isArray(x23)) {
    return x23.map(toJSON);
  }
  return x23;
};
var format = (x23) => JSON.stringify(x23, null, 2);
var pipeArguments = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i23 = 0, len = args.length; i23 < len; i23++) {
        ret = args[i23](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT = "Commit";
var OP_FAILURE = "Failure";
var OP_WITH_RUNTIME = "WithRuntime";
var EffectTypeId = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance = {
  /* c8 ignore next */
  _R: (_23) => _23,
  /* c8 ignore next */
  _E: (_23) => _23,
  /* c8 ignore next */
  _A: (_23) => _23,
  _V: /* @__PURE__ */ getCurrentVersion()
};
var sinkVariance = {
  /* c8 ignore next */
  _A: (_23) => _23,
  /* c8 ignore next */
  _In: (_23) => _23,
  /* c8 ignore next */
  _L: (_23) => _23,
  /* c8 ignore next */
  _E: (_23) => _23,
  /* c8 ignore next */
  _R: (_23) => _23
};
var channelVariance = {
  /* c8 ignore next */
  _Env: (_23) => _23,
  /* c8 ignore next */
  _InErr: (_23) => _23,
  /* c8 ignore next */
  _InElem: (_23) => _23,
  /* c8 ignore next */
  _InDone: (_23) => _23,
  /* c8 ignore next */
  _OutErr: (_23) => _23,
  /* c8 ignore next */
  _OutElem: (_23) => _23,
  /* c8 ignore next */
  _OutDone: (_23) => _23
};
var EffectPrototype = {
  [EffectTypeId]: effectVariance,
  [StreamTypeId]: effectVariance,
  [SinkTypeId]: sinkVariance,
  [ChannelTypeId]: channelVariance,
  [symbol2](that) {
    return this === that;
  },
  [symbol]() {
    return cached(this, random(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen(new YieldWrap(this));
  },
  pipe() {
    return pipeArguments(this, arguments);
  }
};
var StructuralPrototype = {
  [symbol]() {
    return cached(this, structure(this));
  },
  [symbol2](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype = {
  ...EffectPrototype,
  _op: OP_COMMIT
};
var StructuralCommitPrototype = {
  ...CommitPrototype,
  ...StructuralPrototype
};
var TypeId = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto = {
  ...EffectPrototype,
  [TypeId]: {
    _A: (_23) => _23
  },
  [NodeInspectSymbol]() {
    return this.toJSON();
  },
  toString() {
    return format(this.toJSON());
  }
};
var SomeProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto), {
  _tag: "Some",
  _op: "Some",
  [symbol2](that) {
    return isOption(that) && isSome(that) && equals(this.value, that.value);
  },
  [symbol]() {
    return cached(this, combine(hash(this._tag))(hash(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON(this.value)
    };
  }
});
var NoneHash = /* @__PURE__ */ hash("None");
var NoneProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto), {
  _tag: "None",
  _op: "None",
  [symbol2](that) {
    return isOption(that) && isNone(that);
  },
  [symbol]() {
    return NoneHash;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption = (input) => hasProperty(input, TypeId);
var isNone = (fa) => fa._tag === "None";
var isSome = (fa) => fa._tag === "Some";
var none = /* @__PURE__ */ Object.create(NoneProto);
var some2 = (value) => {
  const a23 = Object.create(SomeProto);
  a23.value = value;
  return a23;
};
var TypeId2 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto2 = {
  ...EffectPrototype,
  [TypeId2]: {
    _R: (_23) => _23
  },
  [NodeInspectSymbol]() {
    return this.toJSON();
  },
  toString() {
    return format(this.toJSON());
  }
};
var RightProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2), {
  _tag: "Right",
  _op: "Right",
  [symbol2](that) {
    return isEither(that) && isRight(that) && equals(this.right, that.right);
  },
  [symbol]() {
    return combine(hash(this._tag))(hash(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON(this.right)
    };
  }
});
var LeftProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2), {
  _tag: "Left",
  _op: "Left",
  [symbol2](that) {
    return isEither(that) && isLeft(that) && equals(this.left, that.left);
  },
  [symbol]() {
    return combine(hash(this._tag))(hash(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON(this.left)
    };
  }
});
var isEither = (input) => hasProperty(input, TypeId2);
var isLeft = (ma) => ma._tag === "Left";
var isRight = (ma) => ma._tag === "Right";
var left = (left323) => {
  const a23 = Object.create(LeftProto);
  a23.left = left323;
  return a23;
};
var right = (right323) => {
  const a23 = Object.create(RightProto);
  a23.right = right323;
  return a23;
};
var getLeft = (self2) => isRight(self2) ? none : some2(self2.left);
var getRight = (self2) => isLeft(self2) ? none : some2(self2.right);
var right2 = right;
var left2 = left;
var Option_exports = {};
__export22(Option_exports, {
  Do: () => Do,
  TypeId: () => TypeId3,
  all: () => all2,
  andThen: () => andThen,
  ap: () => ap,
  as: () => as,
  asVoid: () => asVoid,
  bind: () => bind2,
  bindTo: () => bindTo2,
  composeK: () => composeK,
  contains: () => contains,
  containsWith: () => containsWith,
  exists: () => exists,
  filter: () => filter,
  filterMap: () => filterMap,
  firstSomeOf: () => firstSomeOf,
  flatMap: () => flatMap,
  flatMapNullable: () => flatMapNullable,
  flatten: () => flatten,
  fromIterable: () => fromIterable,
  fromNullable: () => fromNullable,
  gen: () => gen,
  getEquivalence: () => getEquivalence,
  getLeft: () => getLeft2,
  getOrElse: () => getOrElse,
  getOrNull: () => getOrNull,
  getOrThrow: () => getOrThrow,
  getOrThrowWith: () => getOrThrowWith,
  getOrUndefined: () => getOrUndefined,
  getOrder: () => getOrder,
  getRight: () => getRight2,
  isNone: () => isNone2,
  isOption: () => isOption2,
  isSome: () => isSome2,
  let: () => let_2,
  lift2: () => lift2,
  liftNullable: () => liftNullable,
  liftPredicate: () => liftPredicate,
  liftThrowable: () => liftThrowable,
  map: () => map,
  match: () => match2,
  none: () => none2,
  orElse: () => orElse,
  orElseEither: () => orElseEither,
  orElseSome: () => orElseSome,
  partitionMap: () => partitionMap,
  product: () => product2,
  productMany: () => productMany2,
  reduceCompact: () => reduceCompact,
  some: () => some3,
  tap: () => tap,
  toArray: () => toArray,
  toRefinement: () => toRefinement,
  void: () => void_,
  zipLeft: () => zipLeft,
  zipRight: () => zipRight,
  zipWith: () => zipWith
});
var make2 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId3 = /* @__PURE__ */ Symbol.for("effect/Option");
var none2 = () => none;
var some3 = some2;
var isOption2 = isOption;
var isNone2 = isNone;
var isSome2 = isSome;
var match2 = /* @__PURE__ */ dual(2, (self2, {
  onNone,
  onSome
}) => isNone2(self2) ? onNone() : onSome(self2.value));
var toRefinement = (f23) => (a23) => isSome2(f23(a23));
var fromIterable = (collection) => {
  for (const a23 of collection) {
    return some3(a23);
  }
  return none2();
};
var getRight2 = getRight;
var getLeft2 = getLeft;
var getOrElse = /* @__PURE__ */ dual(2, (self2, onNone) => isNone2(self2) ? onNone() : self2.value);
var orElse = /* @__PURE__ */ dual(2, (self2, that) => isNone2(self2) ? that() : self2);
var orElseSome = /* @__PURE__ */ dual(2, (self2, onNone) => isNone2(self2) ? some3(onNone()) : self2);
var orElseEither = /* @__PURE__ */ dual(2, (self2, that) => isNone2(self2) ? map(that(), right) : map(self2, left));
var firstSomeOf = (collection) => {
  let out = none2();
  for (out of collection) {
    if (isSome2(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable = (nullableValue) => nullableValue == null ? none2() : some3(nullableValue);
var liftNullable = (f23) => (...a23) => fromNullable(f23(...a23));
var getOrNull = /* @__PURE__ */ getOrElse(constNull);
var getOrUndefined = /* @__PURE__ */ getOrElse(constUndefined);
var liftThrowable = (f23) => (...a23) => {
  try {
    return some3(f23(...a23));
  } catch (e23) {
    return none2();
  }
};
var getOrThrowWith = /* @__PURE__ */ dual(2, (self2, onNone) => {
  if (isSome2(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow = /* @__PURE__ */ getOrThrowWith(() => new Error("getOrThrow called on a None"));
var map = /* @__PURE__ */ dual(2, (self2, f23) => isNone2(self2) ? none2() : some3(f23(self2.value)));
var as = /* @__PURE__ */ dual(2, (self2, b23) => map(self2, () => b23));
var asVoid = /* @__PURE__ */ as(void 0);
var void_ = /* @__PURE__ */ some3(void 0);
var flatMap = /* @__PURE__ */ dual(2, (self2, f23) => isNone2(self2) ? none2() : f23(self2.value));
var andThen = /* @__PURE__ */ dual(2, (self2, f23) => flatMap(self2, (a23) => {
  const b23 = isFunction2(f23) ? f23(a23) : f23;
  return isOption2(b23) ? b23 : some3(b23);
}));
var flatMapNullable = /* @__PURE__ */ dual(2, (self2, f23) => isNone2(self2) ? none2() : fromNullable(f23(self2.value)));
var flatten = /* @__PURE__ */ flatMap(identity);
var zipRight = /* @__PURE__ */ dual(2, (self2, that) => flatMap(self2, () => that));
var composeK = /* @__PURE__ */ dual(2, (afb, bfc) => (a23) => flatMap(afb(a23), bfc));
var zipLeft = /* @__PURE__ */ dual(2, (self2, that) => tap(self2, () => that));
var tap = /* @__PURE__ */ dual(2, (self2, f23) => flatMap(self2, (a23) => map(f23(a23), () => a23)));
var product2 = (self2, that) => isSome2(self2) && isSome2(that) ? some3([self2.value, that.value]) : none2();
var productMany2 = (self2, collection) => {
  if (isNone2(self2)) {
    return none2();
  }
  const out = [self2.value];
  for (const o23 of collection) {
    if (isNone2(o23)) {
      return none2();
    }
    out.push(o23.value);
  }
  return some3(out);
};
var all2 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o23 of input) {
      if (isNone2(o23)) {
        return none2();
      }
      out2.push(o23.value);
    }
    return some3(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o23 = input[key];
    if (isNone2(o23)) {
      return none2();
    }
    out[key] = o23.value;
  }
  return some3(out);
};
var zipWith = /* @__PURE__ */ dual(3, (self2, that, f23) => map(product2(self2, that), ([a23, b23]) => f23(a23, b23)));
var ap = /* @__PURE__ */ dual(2, (self2, that) => zipWith(self2, that, (f23, a23) => f23(a23)));
var reduceCompact = /* @__PURE__ */ dual(3, (self2, b23, f23) => {
  let out = b23;
  for (const oa of self2) {
    if (isSome2(oa)) {
      out = f23(out, oa.value);
    }
  }
  return out;
});
var toArray = (self2) => isNone2(self2) ? [] : [self2.value];
var partitionMap = /* @__PURE__ */ dual(2, (self2, f23) => {
  if (isNone2(self2)) {
    return [none2(), none2()];
  }
  const e23 = f23(self2.value);
  return isLeft(e23) ? [some3(e23.left), none2()] : [none2(), some3(e23.right)];
});
var filterMap = /* @__PURE__ */ dual(2, (self2, f23) => isNone2(self2) ? none2() : f23(self2.value));
var filter = /* @__PURE__ */ dual(2, (self2, predicate) => filterMap(self2, (b23) => predicate(b23) ? some2(b23) : none));
var getEquivalence = (isEquivalent) => make((x23, y23) => x23 === y23 || (isNone2(x23) ? isNone2(y23) : isNone2(y23) ? false : isEquivalent(x23.value, y23.value)));
var getOrder = (O23) => make2((self2, that) => isSome2(self2) ? isSome2(that) ? O23(self2.value, that.value) : 1 : -1);
var lift2 = (f23) => dual(2, (self2, that) => zipWith(self2, that, f23));
var liftPredicate = (predicate) => (b23) => predicate(b23) ? some3(b23) : none2();
var containsWith = (isEquivalent) => dual(2, (self2, a23) => isNone2(self2) ? false : isEquivalent(self2.value, a23));
var _equivalence = /* @__PURE__ */ equivalence();
var contains = /* @__PURE__ */ containsWith(_equivalence);
var exists = /* @__PURE__ */ dual(2, (self2, refinement) => isNone2(self2) ? false : refinement(self2.value));
var bindTo2 = /* @__PURE__ */ bindTo(map);
var let_2 = /* @__PURE__ */ let_(map);
var bind2 = /* @__PURE__ */ bind(map, flatMap);
var Do = /* @__PURE__ */ some3({});
var adapter2 = /* @__PURE__ */ adapter();
var gen = (f23) => {
  const iterator = f23(adapter2);
  let state = iterator.next();
  if (state.done) {
    return some3(state.value);
  } else {
    let current = state.value;
    if (isGenKind(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet(current);
    }
    if (isNone2(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet(current);
        }
        if (isNone2(current)) {
          return current;
        }
      }
    }
    return some3(state.value);
  }
};
var fromIterable2 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse = (self2) => Array.from(self2).reverse();
var reduce = /* @__PURE__ */ dual(3, (self2, b23, f23) => fromIterable2(self2).reduce((b222, a23, i23) => f23(b222, a23, i23), b23));
var TagTypeId = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey = "effect/STM";
var STMTypeId = /* @__PURE__ */ Symbol.for(STMSymbolKey);
var TagProto = {
  ...EffectPrototype,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId]: effectVariance,
  [TagTypeId]: {
    _Service: (_23) => _23,
    _Identifier: (_23) => _23
  },
  toString() {
    return format(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make3(this, self2);
  }
};
var makeGenericTag = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId4 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto = {
  [TypeId4]: {
    _Services: (_23) => _23
  },
  [symbol2](that) {
    if (isContext(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k23 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k23) || !equals(this.unsafeMap.get(k23), that.unsafeMap.get(k23))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol]() {
    return cached(this, number(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments(this, arguments);
  },
  toString() {
    return format(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON)
    };
  },
  [NodeInspectSymbol]() {
    return this.toJSON();
  }
};
var makeContext = (unsafeMap) => {
  const context = Object.create(ContextProto);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext = (u23) => hasProperty(u23, TypeId4);
var _empty = /* @__PURE__ */ makeContext(/* @__PURE__ */ new Map());
var empty = () => _empty;
var make3 = (tag, service) => makeContext(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag = makeGenericTag;
var empty2 = empty;
var TypeId5 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy(src, srcPos, dest, destPos, len) {
  for (let i23 = srcPos; i23 < Math.min(src.length, srcPos + len); i23++) {
    dest[destPos + i23 - srcPos] = src[i23];
  }
  return dest;
}
var emptyArray = [];
var getEquivalence2 = (isEquivalent) => make((self2, that) => self2.length === that.length && toReadonlyArray(self2).every((value, i23) => isEquivalent(value, unsafeGet2(that, i23))));
var _equivalence2 = /* @__PURE__ */ getEquivalence2(equals);
var ChunkProto = {
  [TypeId5]: {
    _A: (_23) => _23
  },
  toString() {
    return format(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray(this).map(toJSON)
    };
  },
  [NodeInspectSymbol]() {
    return this.toJSON();
  },
  [symbol2](that) {
    return isChunk(that) && _equivalence2(this, that);
  },
  [symbol]() {
    return cached(this, array(toReadonlyArray(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments(this, arguments);
  }
};
var makeChunk = (backing) => {
  const chunk = Object.create(ChunkProto);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty2;
      chunk.right = _empty2;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty2;
      chunk.right = _empty2;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty2;
      chunk.right = _empty2;
      break;
    }
  }
  return chunk;
};
var isChunk = (u23) => hasProperty(u23, TypeId5);
var _empty2 = /* @__PURE__ */ makeChunk({
  _tag: "IEmpty"
});
var empty3 = () => _empty2;
var make4 = (...as233) => as233.length === 1 ? of(as233[0]) : unsafeFromNonEmptyArray(as233);
var of = (a23) => makeChunk({
  _tag: "ISingleton",
  a: a23
});
var copyToArray = (self2, array323, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy(self2.backing.array, 0, array323, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray(self2.left, array323, initial);
      copyToArray(self2.right, array323, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array323[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i23 = 0;
      let j23 = initial;
      while (i23 < self2.length) {
        array323[j23] = unsafeGet2(self2, i23);
        i23 += 1;
        j23 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty2;
      self2.right = _empty2;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse2 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk({
        _tag: "IArray",
        array: reverse(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk({
        _tag: "IConcat",
        left: reverse2(self2.backing.right),
        right: reverse2(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray(reverse(toReadonlyArray(self2)));
  }
};
var unsafeFromArray = (self2) => makeChunk({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray = (self2) => unsafeFromArray(self2);
var unsafeGet2 = /* @__PURE__ */ dual(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet2(self2.left, index) : unsafeGet2(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet2(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend = /* @__PURE__ */ dual(2, (self2, elem) => appendAll(of(elem), self2));
var drop = /* @__PURE__ */ dual(2, (self2, n23) => {
  if (n23 <= 0) {
    return self2;
  } else if (n23 >= self2.length) {
    return _empty2;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n23,
          length: self2.backing.length - n23
        });
      }
      case "IConcat": {
        if (n23 > self2.left.length) {
          return drop(self2.right, n23 - self2.left.length);
        }
        return makeChunk({
          _tag: "IConcat",
          left: drop(self2.left, n23),
          right: self2.right
        });
      }
      default: {
        return makeChunk({
          _tag: "ISlice",
          chunk: self2,
          offset: n23,
          length: self2.length - n23
        });
      }
    }
  }
});
var appendAll = /* @__PURE__ */ dual(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff223 = that.depth - self2.depth;
  if (Math.abs(diff223) <= 1) {
    return makeChunk({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff223 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll(self2.right, that);
      return makeChunk({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll(self2, that.left);
      return makeChunk({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty = (self2) => self2.length === 0;
var isNonEmpty = (self2) => self2.length > 0;
var unsafeHead = (self2) => unsafeGet2(self2, 0);
var headNonEmpty = unsafeHead;
var tailNonEmpty = (self2) => drop(self2, 1);
var SIZE = 5;
var BUCKET_SIZE = /* @__PURE__ */ Math.pow(2, SIZE);
var MASK = BUCKET_SIZE - 1;
var MAX_INDEX_NODE = BUCKET_SIZE / 2;
var MIN_ARRAY_NODE = BUCKET_SIZE / 4;
function popcount(x23) {
  x23 -= x23 >> 1 & 1431655765;
  x23 = (x23 & 858993459) + (x23 >> 2 & 858993459);
  x23 = x23 + (x23 >> 4) & 252645135;
  x23 += x23 >> 8;
  x23 += x23 >> 16;
  return x23 & 127;
}
function hashFragment(shift3, h23) {
  return h23 >>> shift3 & MASK;
}
function toBitmap(x23) {
  return 1 << x23;
}
function fromBitmap(bitmap, bit) {
  return popcount(bitmap & bit - 1);
}
var make5 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate(mutate223, at, v23, arr) {
  let out = arr;
  if (!mutate223) {
    const len = arr.length;
    out = new Array(len);
    for (let i23 = 0; i23 < len; ++i23) out[i23] = arr[i23];
  }
  out[at] = v23;
  return out;
}
function arraySpliceOut(mutate223, at, arr) {
  const newLen = arr.length - 1;
  let i23 = 0;
  let g23 = 0;
  let out = arr;
  if (mutate223) {
    i23 = g23 = at;
  } else {
    out = new Array(newLen);
    while (i23 < at) out[g23++] = arr[i23++];
  }
  ++i23;
  while (i23 <= newLen) out[g23++] = arr[i23++];
  if (mutate223) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn(mutate223, at, v23, arr) {
  const len = arr.length;
  if (mutate223) {
    let i222 = len;
    while (i222 >= at) arr[i222--] = arr[i222];
    arr[at] = v23;
    return arr;
  }
  let i23 = 0, g23 = 0;
  const out = new Array(len + 1);
  while (i23 < at) out[g23++] = arr[i23++];
  out[at] = v23;
  while (i23 < len) out[++g23] = arr[i23++];
  return out;
}
var EmptyNode = class _EmptyNode {
  _tag = "EmptyNode";
  modify(edit, _shift, f23, hash233, key, size423) {
    const v23 = f23(none2());
    if (isNone2(v23)) return new _EmptyNode();
    ++size423.value;
    return new LeafNode(edit, hash233, key, v23);
  }
};
function isEmptyNode(a23) {
  return isTagged(a23, "EmptyNode");
}
function isLeafNode(node) {
  return isEmptyNode(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode(node, edit) {
  return isEmptyNode(node) ? false : edit === node.edit;
}
var LeafNode = class _LeafNode {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash233, key, value) {
    this.edit = edit;
    this.hash = hash233;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift3, f23, hash233, key, size423) {
    if (equals(key, this.key)) {
      const v222 = f23(this.value);
      if (v222 === this.value) return this;
      else if (isNone2(v222)) {
        --size423.value;
        return new EmptyNode();
      }
      if (canEditNode(this, edit)) {
        this.value = v222;
        return this;
      }
      return new _LeafNode(edit, hash233, key, v222);
    }
    const v23 = f23(none2());
    if (isNone2(v23)) return this;
    ++size423.value;
    return mergeLeaves(edit, shift3, this.hash, this, hash233, new _LeafNode(edit, hash233, key, v23));
  }
};
var CollisionNode = class _CollisionNode {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash233, children) {
    this.edit = edit;
    this.hash = hash233;
    this.children = children;
  }
  modify(edit, shift3, f23, hash233, key, size423) {
    if (hash233 === this.hash) {
      const canEdit = canEditNode(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f23, key, size423);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode(edit, this.hash, list) : list[0];
    }
    const v23 = f23(none2());
    if (isNone2(v23)) return this;
    ++size423.value;
    return mergeLeaves(edit, shift3, this.hash, this, hash233, new LeafNode(edit, hash233, key, v23));
  }
  updateCollisionList(mutate223, edit, hash233, list, f23, key, size423) {
    const len = list.length;
    for (let i23 = 0; i23 < len; ++i23) {
      const child = list[i23];
      if ("key" in child && equals(key, child.key)) {
        const value = child.value;
        const newValue2 = f23(value);
        if (newValue2 === value) return list;
        if (isNone2(newValue2)) {
          --size423.value;
          return arraySpliceOut(mutate223, i23, list);
        }
        return arrayUpdate(mutate223, i23, new LeafNode(edit, hash233, key, newValue2), list);
      }
    }
    const newValue = f23(none2());
    if (isNone2(newValue)) return list;
    ++size423.value;
    return arrayUpdate(mutate223, len, new LeafNode(edit, hash233, key, newValue), list);
  }
};
var IndexedNode = class _IndexedNode {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift3, f23, hash233, key, size423) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment(shift3, hash233);
    const bit = toBitmap(frag);
    const indx = fromBitmap(mask, bit);
    const exists233 = mask & bit;
    const canEdit = canEditNode(this, edit);
    if (!exists233) {
      const _newChild = new EmptyNode().modify(edit, shift3 + SIZE, f23, hash233, key, size423);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE ? expand(edit, frag, _newChild, mask, children) : new _IndexedNode(edit, mask | bit, arraySpliceIn(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift3 + SIZE, f23, hash233, key, size423);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode();
      if (children.length <= 2 && isLeafNode(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode(edit, bitmap, newChildren);
  }
};
var ArrayNode = class _ArrayNode {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size423, children) {
    this.edit = edit;
    this.size = size423;
    this.children = children;
  }
  modify(edit, shift3, f23, hash233, key, size423) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment(shift3, hash233);
    const child = children[frag];
    const newChild = (child || new EmptyNode()).modify(edit, shift3 + SIZE, f23, hash233, key, size423);
    if (child === newChild) return this;
    const canEdit = canEditNode(this, edit);
    let newChildren;
    if (isEmptyNode(child) && !isEmptyNode(newChild)) {
      ++count;
      newChildren = arrayUpdate(canEdit, frag, newChild, children);
    } else if (!isEmptyNode(child) && isEmptyNode(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE) {
        return pack(edit, count, frag, children);
      }
      newChildren = arrayUpdate(canEdit, frag, new EmptyNode(), children);
    } else {
      newChildren = arrayUpdate(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode(edit, count, newChildren);
  }
};
function pack(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g23 = 0;
  let bitmap = 0;
  for (let i23 = 0, len = elements.length; i23 < len; ++i23) {
    if (i23 !== removed) {
      const elem = elements[i23];
      if (elem && !isEmptyNode(elem)) {
        children[g23++] = elem;
        bitmap |= 1 << i23;
      }
    }
  }
  return new IndexedNode(edit, bitmap, children);
}
function expand(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i23 = 0; bit; ++i23) {
    if (bit & 1) arr[i23] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode(edit, count + 1, arr);
}
function mergeLeavesInner(edit, shift3, h1, n1, h23, n23) {
  if (h1 === h23) return new CollisionNode(edit, h1, [n23, n1]);
  const subH1 = hashFragment(shift3, h1);
  const subH2 = hashFragment(shift3, h23);
  if (subH1 === subH2) {
    return (child) => new IndexedNode(edit, toBitmap(subH1) | toBitmap(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n23] : [n23, n1];
    return new IndexedNode(edit, toBitmap(subH1) | toBitmap(subH2), children);
  }
}
function mergeLeaves(edit, shift3, h1, n1, h23, n23) {
  let stack = void 0;
  let currentShift = shift3;
  while (true) {
    const res = mergeLeavesInner(edit, currentShift, h1, n1, h23, n23);
    if (typeof res === "function") {
      stack = make5(res, stack);
      currentShift = currentShift + SIZE;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey = "effect/HashMap";
var HashMapTypeId = /* @__PURE__ */ Symbol.for(HashMapSymbolKey);
var HashMapProto = {
  [HashMapTypeId]: HashMapTypeId,
  [Symbol.iterator]() {
    return new HashMapIterator(this, (k23, v23) => [k23, v23]);
  },
  [symbol]() {
    let hash233 = hash(HashMapSymbolKey);
    for (const item of this) {
      hash233 ^= pipe(hash(item[0]), combine(hash(item[1])));
    }
    return cached(this, hash233);
  },
  [symbol2](that) {
    if (isHashMap(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe(that, getHash(item[0], hash(item[0])));
        if (isNone2(elem)) {
          return false;
        } else {
          if (!equals(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON)
    };
  },
  [NodeInspectSymbol]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments(this, arguments);
  }
};
var makeImpl = (editable, edit, root, size423) => {
  const map63 = Object.create(HashMapProto);
  map63._editable = editable;
  map63._edit = edit;
  map63._root = root;
  map63._size = size423;
  return map63;
};
var HashMapIterator = class _HashMapIterator {
  map;
  f;
  v;
  constructor(map63, f23) {
    this.map = map63;
    this.f = f23;
    this.v = visitLazy(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone2(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator(this.map, this.f);
  }
};
var applyCont = (cont) => cont ? visitLazyChildren(cont[0], cont[1], cont[2], cont[3], cont[4]) : none2();
var visitLazy = (node, f23, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome2(node.value)) {
        return some3({
          value: f23(node.key, node.value.value),
          cont
        });
      }
      return applyCont(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren(children.length, children, 0, f23, cont);
    }
    default: {
      return applyCont(cont);
    }
  }
};
var visitLazyChildren = (len, children, i23, f23, cont) => {
  while (i23 < len) {
    const child = children[i23++];
    if (child && !isEmptyNode(child)) {
      return visitLazy(child, f23, [len, children, i23, f23, cont]);
    }
  }
  return applyCont(cont);
};
var _empty3 = /* @__PURE__ */ makeImpl(false, 0, /* @__PURE__ */ new EmptyNode(), 0);
var empty4 = () => _empty3;
var isHashMap = (u23) => hasProperty(u23, HashMapTypeId);
var getHash = /* @__PURE__ */ dual(3, (self2, key, hash233) => {
  let node = self2._root;
  let shift3 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals(key, node.key) ? node.value : none2();
      }
      case "CollisionNode": {
        if (hash233 === node.hash) {
          const children = node.children;
          for (let i23 = 0, len = children.length; i23 < len; ++i23) {
            const child = children[i23];
            if ("key" in child && equals(key, child.key)) {
              return child.value;
            }
          }
        }
        return none2();
      }
      case "IndexedNode": {
        const frag = hashFragment(shift3, hash233);
        const bit = toBitmap(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap(node.mask, bit)];
          shift3 += SIZE;
          break;
        }
        return none2();
      }
      case "ArrayNode": {
        node = node.children[hashFragment(shift3, hash233)];
        if (node) {
          shift3 += SIZE;
          break;
        }
        return none2();
      }
      default:
        return none2();
    }
  }
});
var set = /* @__PURE__ */ dual(3, (self2, key, value) => modifyAt(self2, key, () => some3(value)));
var setTree = /* @__PURE__ */ dual(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl(self2._editable, self2._edit, newRoot, newSize);
});
var keys = (self2) => new HashMapIterator(self2, (key) => key);
var size = (self2) => self2._size;
var beginMutation = (self2) => makeImpl(true, self2._edit + 1, self2._root, self2._size);
var modifyAt = /* @__PURE__ */ dual(3, (self2, key, f23) => modifyHash(self2, key, hash(key), f23));
var modifyHash = /* @__PURE__ */ dual(4, (self2, key, hash233, f23) => {
  const size423 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f23, hash233, key, size423);
  return pipe(self2, setTree(newRoot, size423.value));
});
var forEach = /* @__PURE__ */ dual(2, (self2, f23) => reduce2(self2, void 0, (_23, value, key) => f23(value, key)));
var reduce2 = /* @__PURE__ */ dual(3, (self2, zero, f23) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome2(root.value) ? f23(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i23 = 0, len = children.length; i23 < len; ) {
      const child = children[i23++];
      if (child && !isEmptyNode(child)) {
        if (child._tag === "LeafNode") {
          if (isSome2(child.value)) {
            zero = f23(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey = "effect/HashSet";
var HashSetTypeId = /* @__PURE__ */ Symbol.for(HashSetSymbolKey);
var HashSetProto = {
  [HashSetTypeId]: HashSetTypeId,
  [Symbol.iterator]() {
    return keys(this._keyMap);
  },
  [symbol]() {
    return cached(this, combine(hash(this._keyMap))(hash(HashSetSymbolKey)));
  },
  [symbol2](that) {
    if (isHashSet(that)) {
      return size(this._keyMap) === size(that._keyMap) && equals(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON)
    };
  },
  [NodeInspectSymbol]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments(this, arguments);
  }
};
var makeImpl2 = (keyMap) => {
  const set233 = Object.create(HashSetProto);
  set233._keyMap = keyMap;
  return set233;
};
var isHashSet = (u23) => hasProperty(u23, HashSetTypeId);
var _empty4 = /* @__PURE__ */ makeImpl2(/* @__PURE__ */ empty4());
var empty5 = () => _empty4;
var size2 = (self2) => size(self2._keyMap);
var beginMutation2 = (self2) => makeImpl2(beginMutation(self2._keyMap));
var endMutation = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate = /* @__PURE__ */ dual(2, (self2, f23) => {
  const transient = beginMutation2(self2);
  f23(transient);
  return endMutation(transient);
});
var add2 = /* @__PURE__ */ dual(2, (self2, value) => self2._keyMap._editable ? (set(value, true)(self2._keyMap), self2) : makeImpl2(set(value, true)(self2._keyMap)));
var union2 = /* @__PURE__ */ dual(2, (self2, that) => mutate(empty5(), (set233) => {
  forEach2(self2, (value) => add2(set233, value));
  for (const value of that) {
    add2(set233, value);
  }
}));
var forEach2 = /* @__PURE__ */ dual(2, (self2, f23) => forEach(self2._keyMap, (_23, k23) => f23(k23)));
var empty6 = empty5;
var size3 = size2;
var add3 = add2;
var union3 = union2;
var ArrayProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol]() {
    return cached(this, array(this));
  },
  [symbol2](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v23, i23) => equals(v23, that[i23]));
    } else {
      return false;
    }
  }
});
var Structural = /* @__PURE__ */ function() {
  function Structural323(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural323.prototype = StructuralPrototype;
  return Structural323;
}();
var struct2 = (as233) => Object.assign(Object.create(StructuralPrototype), as233);
var ContextPatchTypeId = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance(a23) {
  return a23;
}
var PatchProto = {
  ...Structural.prototype,
  [ContextPatchTypeId]: {
    _Value: variance,
    _Patch: variance
  }
};
var EmptyProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto), {
  _tag: "Empty"
});
var _empty5 = /* @__PURE__ */ Object.create(EmptyProto);
var empty7 = () => _empty5;
var AndThenProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto), {
  _tag: "AndThen"
});
var makeAndThen = (first, second) => {
  const o23 = Object.create(AndThenProto);
  o23.first = first;
  o23.second = second;
  return o23;
};
var AddServiceProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto), {
  _tag: "AddService"
});
var makeAddService = (key, service) => {
  const o23 = Object.create(AddServiceProto);
  o23.key = key;
  o23.service = service;
  return o23;
};
var RemoveServiceProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto), {
  _tag: "RemoveService"
});
var makeRemoveService = (key) => {
  const o23 = Object.create(RemoveServiceProto);
  o23.key = key;
  return o23;
};
var UpdateServiceProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto), {
  _tag: "UpdateService"
});
var makeUpdateService = (key, update23) => {
  const o23 = Object.create(UpdateServiceProto);
  o23.key = key;
  o23.update = update23;
  return o23;
};
var diff = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch223 = empty7();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals(old, newService)) {
        patch223 = combine2(makeUpdateService(tag, () => newService))(patch223);
      }
    } else {
      missingServices.delete(tag);
      patch223 = combine2(makeAddService(tag, newService))(patch223);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch223 = combine2(makeRemoveService(tag))(patch223);
  }
  return patch223;
};
var combine2 = /* @__PURE__ */ dual(2, (self2, that) => makeAndThen(self2, that));
var patch = /* @__PURE__ */ dual(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty(patches)) {
    const head23 = headNonEmpty(patches);
    const tail23 = tailNonEmpty(patches);
    switch (head23._tag) {
      case "Empty": {
        patches = tail23;
        break;
      }
      case "AddService": {
        updatedContext.set(head23.key, head23.service);
        patches = tail23;
        break;
      }
      case "AndThen": {
        patches = prepend(prepend(tail23, head23.second), head23.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head23.key);
        patches = tail23;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head23.key, head23.update(updatedContext.get(head23.key)));
        wasServiceUpdated = true;
        patches = tail23;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext(updatedContext);
  }
  const map63 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map63.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s23] of updatedContext) {
    map63.set(tag, s23);
  }
  return makeContext(map63);
});
var DifferTypeId = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto = {
  [DifferTypeId]: {
    _P: identity,
    _V: identity
  }
};
var make7 = (params) => {
  const differ = Object.create(DifferProto);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment = () => make7({
  empty: empty7(),
  combine: (first, second) => combine2(second)(first),
  diff: (oldValue, newValue) => diff(oldValue, newValue),
  patch: (patch223, oldValue) => patch(oldValue)(patch223)
});
var OP_DIE = "Die";
var OP_EMPTY = "Empty";
var OP_FAIL = "Fail";
var OP_INTERRUPT = "Interrupt";
var OP_PARALLEL = "Parallel";
var OP_SEQUENTIAL = "Sequential";
var CauseSymbolKey = "effect/Cause";
var CauseTypeId = /* @__PURE__ */ Symbol.for(CauseSymbolKey);
var variance2 = {
  /* c8 ignore next */
  _E: (_23) => _23
};
var proto = {
  [CauseTypeId]: variance2,
  [symbol]() {
    return pipe(hash(CauseSymbolKey), combine(hash(flattenCause(this))), cached(this));
  },
  [symbol2](that) {
    return isCause(that) && causeEquals(this, that);
  },
  pipe() {
    return pipeArguments(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON(this.left),
          right: toJSON(this.right)
        };
    }
  },
  toString() {
    return pretty(this);
  },
  [NodeInspectSymbol]() {
    return this.toJSON();
  }
};
var fail = (error) => {
  const o23 = Object.create(proto);
  o23._tag = OP_FAIL;
  o23.error = error;
  return o23;
};
var parallel = (left323, right323) => {
  const o23 = Object.create(proto);
  o23._tag = OP_PARALLEL;
  o23.left = left323;
  o23.right = right323;
  return o23;
};
var sequential = (left323, right323) => {
  const o23 = Object.create(proto);
  o23._tag = OP_SEQUENTIAL;
  o23.left = left323;
  o23.right = right323;
  return o23;
};
var isCause = (u23) => hasProperty(u23, CauseTypeId);
var isInterruptedOnly = (self2) => reduceWithContext(void 0, IsInterruptedOnlyCauseReducer)(self2);
var causeEquals = (left323, right323) => {
  let leftStack = of(left323);
  let rightStack = of(right323);
  while (isNonEmpty(leftStack) && isNonEmpty(rightStack)) {
    const [leftParallel, leftSequential] = pipe(headNonEmpty(leftStack), reduce4([empty6(), empty3()], ([parallel223, sequential223], cause) => {
      const [par, seq] = evaluateCause(cause);
      return some3([pipe(parallel223, union3(par)), pipe(sequential223, appendAll(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe(headNonEmpty(rightStack), reduce4([empty6(), empty3()], ([parallel223, sequential223], cause) => {
      const [par, seq] = evaluateCause(cause);
      return some3([pipe(parallel223, union3(par)), pipe(sequential223, appendAll(seq))]);
    }));
    if (!equals(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause = (cause) => {
  return flattenCauseLoop(of(cause), empty3());
};
var flattenCauseLoop = (causes, flattened) => {
  while (1) {
    const [parallel223, sequential223] = pipe(causes, reduce([empty6(), empty3()], ([parallel33, sequential33], cause) => {
      const [par, seq] = evaluateCause(cause);
      return [pipe(parallel33, union3(par)), pipe(sequential33, appendAll(seq))];
    }));
    const updated = size3(parallel223) > 0 ? pipe(flattened, prepend(parallel223)) : flattened;
    if (isEmpty(sequential223)) {
      return reverse2(updated);
    }
    causes = sequential223;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage("Cause.flattenCauseLoop"));
};
var evaluateCause = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty6();
  let _sequential = empty3();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL: {
        _parallel = add3(_parallel, make4(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE: {
        _parallel = add3(_parallel, make4(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT: {
        _parallel = add3(_parallel, make4(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL: {
        switch (cause.left._tag) {
          case OP_EMPTY: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL: {
            cause = sequential(cause.left.left, sequential(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL: {
            cause = parallel(sequential(cause.left.left, cause.right), sequential(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer = {
  emptyCase: constTrue,
  failCase: constFalse,
  dieCase: constFalse,
  interruptCase: constTrue,
  sequentialCase: (_23, left323, right323) => left323 && right323,
  parallelCase: (_23, left323, right323) => left323 && right323
};
var OP_SEQUENTIAL_CASE = "SequentialCase";
var OP_PARALLEL_CASE = "ParallelCase";
var reduce4 = /* @__PURE__ */ dual(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome2(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext = /* @__PURE__ */ dual(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY: {
        output.push(right2(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL: {
        output.push(right2(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE: {
        output.push(right2(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT: {
        output.push(right2(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2({
          _tag: OP_SEQUENTIAL_CASE
        }));
        break;
      }
      case OP_PARALLEL: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2({
          _tag: OP_PARALLEL_CASE
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE: {
            const left323 = accumulator.pop();
            const right323 = accumulator.pop();
            const value = reducer.sequentialCase(context, left323, right323);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE: {
            const left323 = accumulator.pop();
            const right323 = accumulator.pop();
            const value = reducer.parallelCase(context, left323, right323);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty = (cause) => {
  if (isInterruptedOnly(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors(cause).map((e23) => e23.stack).join("\n");
};
var PrettyError = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol in originalError) {
        this.span = originalError[spanSymbol];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage = (u23) => {
  if (typeof u23 === "string") {
    return `Error: ${u23}`;
  }
  try {
    if (hasProperty(u23, "toString") && isFunction3(u23["toString"]) && u23["toString"] !== Object.prototype.toString && u23["toString"] !== globalThis.Array.prototype.toString) {
      return u23["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u23)}`;
};
var locationRegex = /\((.*)\)/;
var spanToTrace = /* @__PURE__ */ globalValue("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack = (message, stack, span22) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i23 = 1; i23 < lines.length; i23++) {
    if (lines[i23].includes("Generator.next")) {
      break;
    }
    if (lines[i23].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i23].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span22) {
    let current = span22;
    let i23 = 0;
    while (current && current._tag === "Span" && i23 < 10) {
      const stackFn = spanToTrace.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined(current.parent);
      i23++;
    }
  }
  return out.join("\n");
};
var spanSymbol = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors = (cause) => reduceWithContext(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_23, unknownError) => {
    return [new PrettyError(unknownError)];
  },
  failCase: (_23, error) => {
    return [new PrettyError(error)];
  },
  interruptCase: () => [],
  parallelCase: (_23, l23, r23) => [...l23, ...r23],
  sequentialCase: (_23, l23, r23) => [...l23, ...r23]
});
var SingleShotGen2 = class _SingleShotGen2 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a23) {
    return this.called ? {
      value: a23,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a23) {
    return {
      value: a23,
      done: true
    };
  }
  throw(e23) {
    throw e23;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen2(this.self);
  }
};
var spanTag = /* @__PURE__ */ GenericTag("effect/ParentSpan");
var EffectTypeId2 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2] = effectVariance;
  constructor(_op) {
    this._op = _op;
  }
  [symbol2](that) {
    return this === that;
  }
  [symbol]() {
    return cached(this, random(this));
  }
  pipe() {
    return pipeArguments(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON(this.effect_instruction_i0),
      effect_instruction_i1: toJSON(this.effect_instruction_i1),
      effect_instruction_i2: toJSON(this.effect_instruction_i2)
    };
  }
  toString() {
    return format(this.toJSON());
  }
  [NodeInspectSymbol]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2(new YieldWrap(this));
  }
};
var EffectPrimitiveFailure = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2] = effectVariance;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol2](that) {
    return exitIsExit(that) && that._op === "Failure" && // @ts-expect-error
    equals(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol]() {
    return pipe(
      // @ts-expect-error
      string(this._tag),
      // @ts-expect-error
      combine(hash(this.effect_instruction_i0)),
      cached(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format(this.toJSON());
  }
  [NodeInspectSymbol]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2(new YieldWrap(this));
  }
};
var isEffect = (u23) => hasProperty(u23, EffectTypeId2);
var withFiberRuntime = (withRuntime) => {
  const effect = new EffectPrimitive(OP_WITH_RUNTIME);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol2 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture = (obj, span22) => {
  if (isSome2(span22)) {
    return new Proxy(obj, {
      has(target, p23) {
        return p23 === spanSymbol2 || p23 === originalSymbol || p23 in target;
      },
      get(target, p23) {
        if (p23 === spanSymbol2) {
          return span22.value;
        }
        if (p23 === originalSymbol) {
          return obj;
        }
        return target[p23];
      }
    });
  }
  return obj;
};
var fail2 = (error) => isObject(error) && !(spanSymbol2 in error) ? withFiberRuntime((fiber) => failCause(fail(capture(error, currentSpanFromFiber(fiber))))) : failCause(fail(error));
var failCause = (cause) => {
  const effect = new EffectPrimitiveFailure(OP_FAILURE);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey = "effect/FiberRef";
var FiberRefTypeId = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey);
var fiberRefVariance = {
  /* c8 ignore next */
  _A: (_23) => _23
};
var fiberRefUnsafeMakeContext = (initial) => {
  const differ = environment();
  return fiberRefUnsafeMakePatch(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch = (initial, options) => ({
  [FiberRefTypeId]: fiberRefVariance,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch223) => (oldValue) => options.differ.patch(patch223, oldValue),
  fork: options.fork,
  join: options.join ?? ((_23, n23) => n23),
  pipe() {
    return pipeArguments(this, arguments);
  }
});
var currentContext = /* @__PURE__ */ globalValue(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext(empty2()));
var YieldableError = /* @__PURE__ */ function() {
  class YieldableError223 extends globalThis.Error {
    commit() {
      return fail2(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError223.prototype, StructuralCommitPrototype);
  return YieldableError223;
}();
var exitIsExit = (u23) => isEffect(u23) && "_tag" in u23 && (u23._tag === "Success" || u23._tag === "Failure");
var currentSpanFromFiber = (fiber) => {
  const span22 = fiber.getFiberRef(currentContext).unsafeMap.get(spanTag.key);
  return span22 !== void 0 && span22._tag === "Span" ? some3(span22) : none2();
};
var Data_exports = {};
__export22(Data_exports, {
  Class: () => Class2,
  Error: () => Error2,
  Structural: () => Structural2,
  TaggedClass: () => TaggedClass,
  TaggedError: () => TaggedError,
  array: () => array2,
  case: () => _case,
  struct: () => struct3,
  tagged: () => tagged,
  taggedEnum: () => taggedEnum,
  tuple: () => tuple2,
  unsafeArray: () => unsafeArray,
  unsafeStruct: () => unsafeStruct
});
var struct3 = struct2;
var unsafeStruct = (as233) => Object.setPrototypeOf(as233, StructuralPrototype);
var tuple2 = (...as233) => unsafeArray(as233);
var array2 = (as233) => unsafeArray(as233.slice(0));
var unsafeArray = (as233) => Object.setPrototypeOf(as233, ArrayProto);
var _case = () => (args) => args === void 0 ? Object.create(StructuralPrototype) : struct3(args);
var tagged = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype) : struct3(args);
  value._tag = tag;
  return value;
};
var Class2 = Structural;
var TaggedClass = (tag) => {
  class Base extends Class2 {
    _tag = tag;
  }
  return Base;
};
var Structural2 = Structural;
var taggedEnum = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged;
    } else if (tag === "$match") {
      return taggedMatch;
    }
    return tagged(tag);
  }
});
function taggedMatch() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error2 = /* @__PURE__ */ function() {
  return class Base extends YieldableError {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError = (tag) => {
  class Base extends Error2 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp = Function_exports.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType.Program) return Option_exports.none();
  return predicate(parent) ? Option_exports.some(parent) : traverseUp(parent, predicate);
});
var traverseUpGuard = Function_exports.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType.Program) return Option_exports.none();
  return predicate(parent) ? Option_exports.some(parent) : traverseUpGuard(parent, predicate);
});
var ESLintCommunityESLintUtils;
((ESLintCommunityESLintUtils223) => {
  ESLintCommunityESLintUtils223.getFunctionHeadLocation = getFunctionHeadLocation;
  ESLintCommunityESLintUtils223.getFunctionNameWithKind = getFunctionNameWithKind;
  ESLintCommunityESLintUtils223.getPropertyName = getPropertyName;
  ESLintCommunityESLintUtils223.getStaticValue = getStaticValue;
  ESLintCommunityESLintUtils223.getStringIfConstant = getStringIfConstant;
  ESLintCommunityESLintUtils223.hasSideEffect = hasSideEffect;
  ESLintCommunityESLintUtils223.isParenthesized = isParenthesized;
})(ESLintCommunityESLintUtils || (ESLintCommunityESLintUtils = {}));
var Construction = Data_exports.taggedEnum();
Construction.None();
a({
  type: N.union([NodeType.FunctionExpression, NodeType.ArrowFunctionExpression]),
  parent: {
    type: NodeType.Property,
    parent: {
      type: NodeType.ObjectExpression
    }
  }
});
a({
  type: N.union([NodeType.FunctionExpression, NodeType.ArrowFunctionExpression]),
  parent: {
    type: NodeType.MethodDefinition,
    parent: {
      type: NodeType.ClassBody
    }
  }
});
a({
  type: N.union([NodeType.FunctionExpression, NodeType.ArrowFunctionExpression]),
  parent: {
    type: NodeType.Property,
    parent: {
      type: NodeType.ClassBody
    }
  }
});
function isStringLiteral(node) {
  return node.type === NodeType.Literal && Predicate_exports.isString(node.value);
}
function isJSXElementOfBuiltinComponent(node) {
  return node.openingElement.name.type === NodeType.JSXIdentifier && node.openingElement.name.name.toLowerCase() === node.openingElement.name.name && /^[a-z]/u.test(node.openingElement.name.name);
}
var Function_exports2 = {};
__export2(Function_exports2, {
  SK: () => SK2,
  absurd: () => absurd2,
  apply: () => apply2,
  compose: () => compose3,
  constFalse: () => constFalse2,
  constNull: () => constNull2,
  constTrue: () => constTrue2,
  constUndefined: () => constUndefined2,
  constVoid: () => constVoid2,
  constant: () => constant2,
  dual: () => dual2,
  flip: () => flip2,
  flow: () => flow2,
  hole: () => hole2,
  identity: () => identity2,
  isFunction: () => isFunction4,
  pipe: () => pipe2,
  satisfies: () => satisfies2,
  tupled: () => tupled2,
  unsafeCoerce: () => unsafeCoerce2,
  untupled: () => untupled2
});
var isFunction4 = (input) => typeof input === "function";
var dual2 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a23, b23) {
        if (arguments.length >= 2) {
          return body(a23, b23);
        }
        return function(self2) {
          return body(self2, a23);
        };
      };
    case 3:
      return function(a23, b23, c23) {
        if (arguments.length >= 3) {
          return body(a23, b23, c23);
        }
        return function(self2) {
          return body(self2, a23, b23);
        };
      };
    case 4:
      return function(a23, b23, c23, d23) {
        if (arguments.length >= 4) {
          return body(a23, b23, c23, d23);
        }
        return function(self2) {
          return body(self2, a23, b23, c23);
        };
      };
    case 5:
      return function(a23, b23, c23, d23, e23) {
        if (arguments.length >= 5) {
          return body(a23, b23, c23, d23, e23);
        }
        return function(self2) {
          return body(self2, a23, b23, c23, d23);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply2 = (a23) => (self2) => self2(a23);
var identity2 = (a23) => a23;
var satisfies2 = () => (b23) => b23;
var unsafeCoerce2 = identity2;
var constant2 = (value) => () => value;
var constTrue2 = /* @__PURE__ */ constant2(true);
var constFalse2 = /* @__PURE__ */ constant2(false);
var constNull2 = /* @__PURE__ */ constant2(null);
var constUndefined2 = /* @__PURE__ */ constant2(void 0);
var constVoid2 = constUndefined2;
var flip2 = (f23) => (...b23) => (...a23) => f23(...a23)(...b23);
var compose3 = /* @__PURE__ */ dual2(2, (ab, bc) => (a23) => bc(ab(a23)));
var absurd2 = (_23) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled2 = (f23) => (a23) => f23(...a23);
var untupled2 = (f23) => (...a23) => f23(a23);
function pipe2(a23, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a23;
    case 2:
      return ab(a23);
    case 3:
      return bc(ab(a23));
    case 4:
      return cd(bc(ab(a23)));
    case 5:
      return de(cd(bc(ab(a23))));
    case 6:
      return ef(de(cd(bc(ab(a23)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a23))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a23)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a23))))))));
    default: {
      let ret = arguments[0];
      for (let i23 = 1; i23 < arguments.length; i23++) {
        ret = arguments[i23](ret);
      }
      return ret;
    }
  }
}
function flow2(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole2 = /* @__PURE__ */ unsafeCoerce2(absurd2);
var SK2 = (_23, b23) => b23;
var Array_exports = {};
__export2(Array_exports, {
  Do: () => Do3,
  allocate: () => allocate,
  append: () => append,
  appendAll: () => appendAll2,
  bind: () => bind5,
  bindTo: () => bindTo5,
  cartesian: () => cartesian,
  cartesianWith: () => cartesianWith,
  chop: () => chop,
  chunksOf: () => chunksOf,
  contains: () => contains3,
  containsWith: () => containsWith3,
  copy: () => copy2,
  dedupe: () => dedupe,
  dedupeAdjacent: () => dedupeAdjacent,
  dedupeAdjacentWith: () => dedupeAdjacentWith,
  dedupeWith: () => dedupeWith,
  difference: () => difference,
  differenceWith: () => differenceWith,
  drop: () => drop2,
  dropRight: () => dropRight,
  dropWhile: () => dropWhile,
  empty: () => empty9,
  every: () => every3,
  extend: () => extend,
  filter: () => filter3,
  filterMap: () => filterMap3,
  filterMapWhile: () => filterMapWhile,
  findFirst: () => findFirst2,
  findFirstIndex: () => findFirstIndex,
  findLast: () => findLast,
  findLastIndex: () => findLastIndex,
  flatMap: () => flatMap3,
  flatMapNullable: () => flatMapNullable3,
  flatten: () => flatten3,
  forEach: () => forEach3,
  fromIterable: () => fromIterable4,
  fromNullable: () => fromNullable3,
  fromOption: () => fromOption2,
  fromRecord: () => fromRecord,
  get: () => get,
  getEquivalence: () => getEquivalence4,
  getLefts: () => getLefts,
  getOrder: () => getOrder3,
  getRights: () => getRights,
  getSomes: () => getSomes,
  group: () => group,
  groupBy: () => groupBy,
  groupWith: () => groupWith,
  head: () => head,
  headNonEmpty: () => headNonEmpty2,
  init: () => init,
  initNonEmpty: () => initNonEmpty,
  insertAt: () => insertAt,
  intersection: () => intersection,
  intersectionWith: () => intersectionWith,
  intersperse: () => intersperse,
  isArray: () => isArray,
  isEmptyArray: () => isEmptyArray,
  isEmptyReadonlyArray: () => isEmptyReadonlyArray,
  isNonEmptyArray: () => isNonEmptyArray2,
  isNonEmptyReadonlyArray: () => isNonEmptyReadonlyArray,
  join: () => join,
  last: () => last,
  lastNonEmpty: () => lastNonEmpty,
  length: () => length,
  let: () => let_5,
  liftEither: () => liftEither,
  liftNullable: () => liftNullable3,
  liftOption: () => liftOption,
  liftPredicate: () => liftPredicate3,
  make: () => make10,
  makeBy: () => makeBy,
  map: () => map3,
  mapAccum: () => mapAccum,
  match: () => match4,
  matchLeft: () => matchLeft,
  matchRight: () => matchRight,
  max: () => max2,
  min: () => min2,
  modify: () => modify,
  modifyNonEmptyHead: () => modifyNonEmptyHead,
  modifyNonEmptyLast: () => modifyNonEmptyLast,
  modifyOption: () => modifyOption,
  of: () => of2,
  partition: () => partition,
  partitionMap: () => partitionMap3,
  prepend: () => prepend2,
  prependAll: () => prependAll,
  range: () => range,
  reduce: () => reduce3,
  reduceRight: () => reduceRight,
  remove: () => remove,
  replace: () => replace2,
  replaceOption: () => replaceOption,
  replicate: () => replicate,
  reverse: () => reverse3,
  rotate: () => rotate,
  scan: () => scan,
  scanRight: () => scanRight,
  separate: () => separate,
  setNonEmptyHead: () => setNonEmptyHead,
  setNonEmptyLast: () => setNonEmptyLast,
  some: () => some7,
  sort: () => sort,
  sortBy: () => sortBy,
  sortWith: () => sortWith,
  span: () => span,
  split: () => split,
  splitAt: () => splitAt,
  splitNonEmptyAt: () => splitNonEmptyAt,
  splitWhere: () => splitWhere,
  tail: () => tail,
  tailNonEmpty: () => tailNonEmpty2,
  take: () => take,
  takeRight: () => takeRight,
  takeWhile: () => takeWhile,
  unappend: () => unappend,
  unfold: () => unfold,
  union: () => union,
  unionWith: () => unionWith,
  unprepend: () => unprepend,
  unsafeGet: () => unsafeGet,
  unzip: () => unzip,
  zip: () => zip,
  zipWith: () => zipWith3
});
var make6 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var array3 = (item) => make6((self2, that) => {
  if (self2.length !== that.length) {
    return false;
  }
  for (let i23 = 0; i23 < self2.length; i23++) {
    const isEq = item(self2[i23], that[i23]);
    if (!isEq) {
      return false;
    }
  }
  return true;
});
var let_3 = (map53) => dual2(3, (self2, name2, f23) => map53(self2, (a23) => Object.assign({}, a23, {
  [name2]: f23(a23)
})));
var bindTo3 = (map53) => dual2(2, (self2, name2) => map53(self2, (a23) => ({
  [name2]: a23
})));
var bind3 = (map53, flatMap53) => dual2(3, (self2, name2, f23) => flatMap53(self2, (a23) => map53(f23(a23), (b23) => Object.assign({}, a23, {
  [name2]: b23
}))));
var moduleVersion2 = "3.2.8";
var getCurrentVersion2 = () => moduleVersion2;
var globalStoreId2 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion2()}`);
if (!(globalStoreId2 in globalThis)) {
  globalThis[globalStoreId2] = /* @__PURE__ */ new Map();
}
var globalStore2 = globalThis[globalStoreId2];
var globalValue2 = (id, compute) => {
  if (!globalStore2.has(id)) {
    globalStore2.set(id, compute());
  }
  return globalStore2.get(id);
};
var Predicate_exports2 = {};
__export2(Predicate_exports2, {
  all: () => all3,
  and: () => and2,
  compose: () => compose4,
  eqv: () => eqv2,
  every: () => every2,
  hasProperty: () => hasProperty2,
  implies: () => implies2,
  isBigInt: () => isBigInt2,
  isBoolean: () => isBoolean2,
  isDate: () => isDate2,
  isError: () => isError2,
  isFunction: () => isFunction5,
  isIterable: () => isIterable2,
  isMap: () => isMap2,
  isNever: () => isNever2,
  isNotNull: () => isNotNull2,
  isNotNullable: () => isNotNullable2,
  isNotUndefined: () => isNotUndefined2,
  isNull: () => isNull2,
  isNullable: () => isNullable2,
  isNumber: () => isNumber2,
  isObject: () => isObject2,
  isPromise: () => isPromise2,
  isPromiseLike: () => isPromiseLike2,
  isReadonlyRecord: () => isReadonlyRecord2,
  isRecord: () => isRecord2,
  isSet: () => isSet2,
  isString: () => isString2,
  isSymbol: () => isSymbol2,
  isTagged: () => isTagged2,
  isTruthy: () => isTruthy2,
  isUint8Array: () => isUint8Array2,
  isUndefined: () => isUndefined2,
  isUnknown: () => isUnknown2,
  mapInput: () => mapInput2,
  nand: () => nand2,
  nor: () => nor2,
  not: () => not2,
  or: () => or2,
  product: () => product3,
  productMany: () => productMany3,
  some: () => some4,
  struct: () => struct4,
  tuple: () => tuple3,
  xor: () => xor2
});
var mapInput2 = /* @__PURE__ */ dual2(2, (self2, f23) => (b23) => self2(f23(b23)));
var isTruthy2 = (input) => !!input;
var isSet2 = (input) => input instanceof Set;
var isMap2 = (input) => input instanceof Map;
var isString2 = (input) => typeof input === "string";
var isNumber2 = (input) => typeof input === "number";
var isBoolean2 = (input) => typeof input === "boolean";
var isBigInt2 = (input) => typeof input === "bigint";
var isSymbol2 = (input) => typeof input === "symbol";
var isFunction5 = isFunction4;
var isUndefined2 = (input) => input === void 0;
var isNotUndefined2 = (input) => input !== void 0;
var isNull2 = (input) => input === null;
var isNotNull2 = (input) => input !== null;
var isNever2 = (_23) => false;
var isUnknown2 = (_23) => true;
var isRecordOrArray2 = (input) => typeof input === "object" && input !== null;
var isObject2 = (input) => isRecordOrArray2(input) || isFunction5(input);
var hasProperty2 = /* @__PURE__ */ dual2(2, (self2, property) => isObject2(self2) && property in self2);
var isTagged2 = /* @__PURE__ */ dual2(2, (self2, tag) => hasProperty2(self2, "_tag") && self2["_tag"] === tag);
var isNullable2 = (input) => input === null || input === void 0;
var isNotNullable2 = (input) => input !== null && input !== void 0;
var isError2 = (input) => input instanceof Error;
var isUint8Array2 = (input) => input instanceof Uint8Array;
var isDate2 = (input) => input instanceof Date;
var isIterable2 = (input) => hasProperty2(input, Symbol.iterator);
var isRecord2 = (input) => isRecordOrArray2(input) && !Array.isArray(input);
var isReadonlyRecord2 = isRecord2;
var isPromise2 = (input) => hasProperty2(input, "then") && "catch" in input && isFunction5(input.then) && isFunction5(input.catch);
var isPromiseLike2 = (input) => hasProperty2(input, "then") && isFunction5(input.then);
var compose4 = /* @__PURE__ */ dual2(2, (ab, bc) => (a23) => ab(a23) && bc(a23));
var product3 = (self2, that) => ([a23, b23]) => self2(a23) && that(b23);
var all3 = (collection) => {
  return (as43) => {
    let collectionIndex = 0;
    for (const p23 of collection) {
      if (collectionIndex >= as43.length) {
        break;
      }
      if (p23(as43[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany3 = (self2, collection) => {
  const rest = all3(collection);
  return ([head23, ...tail23]) => self2(head23) === false ? false : rest(tail23);
};
var tuple3 = (...elements) => all3(elements);
var struct4 = (fields) => {
  const keys43 = Object.keys(fields);
  return (a23) => {
    for (const key of keys43) {
      if (!fields[key](a23[key])) {
        return false;
      }
    }
    return true;
  };
};
var not2 = (self2) => (a23) => !self2(a23);
var or2 = /* @__PURE__ */ dual2(2, (self2, that) => (a23) => self2(a23) || that(a23));
var and2 = /* @__PURE__ */ dual2(2, (self2, that) => (a23) => self2(a23) && that(a23));
var xor2 = /* @__PURE__ */ dual2(2, (self2, that) => (a23) => self2(a23) !== that(a23));
var eqv2 = /* @__PURE__ */ dual2(2, (self2, that) => (a23) => self2(a23) === that(a23));
var implies2 = /* @__PURE__ */ dual2(2, (self2, that) => (a23) => self2(a23) ? that(a23) : true);
var nor2 = /* @__PURE__ */ dual2(2, (self2, that) => (a23) => !(self2(a23) || that(a23)));
var nand2 = /* @__PURE__ */ dual2(2, (self2, that) => (a23) => !(self2(a23) && that(a23)));
var every2 = (collection) => (a23) => {
  for (const p23 of collection) {
    if (!p23(a23)) {
      return false;
    }
  }
  return true;
};
var some4 = (collection) => (a23) => {
  for (const p23 of collection) {
    if (p23(a23)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage2 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId2 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind2 = (u23) => isObject2(u23) && GenKindTypeId2 in u23;
var GenKindImpl2 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity2;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_23) => _23;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_23) => _23;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_23) => _23;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId2] = GenKindTypeId2;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen3(this);
  }
};
var SingleShotGen3 = class _SingleShotGen5 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a23) {
    return this.called ? {
      value: a23,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a23) {
    return {
      value: a23,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e23) {
    throw e23;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen5(this.self);
  }
};
var adapter3 = () => function() {
  let x23 = arguments[0];
  for (let i23 = 1; i23 < arguments.length; i23++) {
    x23 = arguments[i23](x23);
  }
  return new GenKindImpl2(x23);
};
var defaultIncHi2 = 335903614;
var defaultIncLo2 = 4150755663;
var MUL_HI2 = 1481765933 >>> 0;
var MUL_LO2 = 1284865837 >>> 0;
var BIT_532 = 9007199254740992;
var BIT_272 = 134217728;
var PCGRandom2 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable2(seedLo) && isNullable2(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable2(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable2(incLo) && isNullable2(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo2;
      incHi = this._state ? this._state[2] : defaultIncHi2;
    } else if (isNullable2(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add642(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max32) {
    if (!max32) {
      return this._next();
    }
    max32 = max32 >>> 0;
    if ((max32 & max32 - 1) === 0) {
      return this._next() & max32 - 1;
    }
    let num = 0;
    const skew = (-max32 >>> 0) % max32 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max32;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_272 + lo) / BIT_532;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul642(this._state, oldHi, oldLo, MUL_HI2, MUL_LO2);
    add642(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul642(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add642(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId2 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap2 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId2]() {
    return this.#value;
  }
};
function yieldWrapGet2(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId2 in self2) {
    return self2[YieldWrapTypeId2]();
  }
  throw new Error(getBugErrorMessage2("yieldWrapGet"));
}
var structuralRegionState2 = /* @__PURE__ */ globalValue2("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache2 = /* @__PURE__ */ globalValue2(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr2 = /* @__PURE__ */ globalValue2(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom2());
var symbol3 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash2 = (self2) => {
  if (structuralRegionState2.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number2(self2);
    case "bigint":
      return string2(self2.toString(10));
    case "boolean":
      return string2(String(self2));
    case "symbol":
      return string2(String(self2));
    case "string":
      return string2(self2);
    case "undefined":
      return string2("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string2("null");
      } else if (self2 instanceof Date) {
        return hash2(self2.toISOString());
      } else if (isHash2(self2)) {
        return self2[symbol3]();
      } else {
        return random2(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random2 = (self2) => {
  if (!randomHashCache2.has(self2)) {
    randomHashCache2.set(self2, number2(pcgr2.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache2.get(self2);
};
var combine3 = (b23) => (self2) => self2 * 53 ^ b23;
var optimize2 = (n23) => n23 & 3221225471 | n23 >>> 1 & 1073741824;
var isHash2 = (u23) => hasProperty2(u23, symbol3);
var number2 = (n23) => {
  if (n23 !== n23 || n23 === Infinity) {
    return 0;
  }
  let h23 = n23 | 0;
  if (h23 !== n23) {
    h23 ^= n23 * 4294967295;
  }
  while (n23 > 4294967295) {
    h23 ^= n23 /= 4294967295;
  }
  return optimize2(n23);
};
var string2 = (str) => {
  let h23 = 5381, i23 = str.length;
  while (i23) {
    h23 = h23 * 33 ^ str.charCodeAt(--i23);
  }
  return optimize2(h23);
};
var cached2 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash53) {
      Object.defineProperty(self3, symbol3, {
        value() {
          return hash53;
        },
        enumerable: false
      });
      return hash53;
    };
  }
  const self2 = arguments[0];
  const hash43 = arguments[1];
  Object.defineProperty(self2, symbol3, {
    value() {
      return hash43;
    },
    enumerable: false
  });
  return hash43;
};
var symbol4 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals2() {
  if (arguments.length === 1) {
    return (self2) => compareBoth2(self2, arguments[0]);
  }
  return compareBoth2(arguments[0], arguments[1]);
}
function compareBoth2(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual2(self2) && isEqual2(that)) {
        if (hash2(self2) === hash2(that) && self2[symbol4](that)) {
          return true;
        } else {
          return structuralRegionState2.enabled && structuralRegionState2.tester ? structuralRegionState2.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState2.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v23, i23) => compareBoth2(v23, that[i23]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth2(self2[key], that[key]))) {
              return structuralRegionState2.tester ? structuralRegionState2.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState2.tester ? structuralRegionState2.tester(self2, that) : false;
    }
  }
  return structuralRegionState2.enabled && structuralRegionState2.tester ? structuralRegionState2.tester(self2, that) : false;
}
var isEqual2 = (u23) => hasProperty2(u23, symbol4);
var equivalence2 = () => equals2;
var NodeInspectSymbol2 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON2 = (x23) => {
  if (hasProperty2(x23, "toJSON") && isFunction5(x23["toJSON"]) && x23["toJSON"].length === 0) {
    return x23.toJSON();
  } else if (Array.isArray(x23)) {
    return x23.map(toJSON2);
  }
  return x23;
};
var format2 = (x23) => JSON.stringify(x23, null, 2);
var pipeArguments2 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i23 = 0, len = args.length; i23 < len; i23++) {
        ret = args[i23](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId3 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId2 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId2 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId2 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance2 = {
  /* c8 ignore next */
  _R: (_23) => _23,
  /* c8 ignore next */
  _E: (_23) => _23,
  /* c8 ignore next */
  _A: (_23) => _23,
  _V: /* @__PURE__ */ getCurrentVersion2()
};
var sinkVariance2 = {
  /* c8 ignore next */
  _A: (_23) => _23,
  /* c8 ignore next */
  _In: (_23) => _23,
  /* c8 ignore next */
  _L: (_23) => _23,
  /* c8 ignore next */
  _E: (_23) => _23,
  /* c8 ignore next */
  _R: (_23) => _23
};
var channelVariance2 = {
  /* c8 ignore next */
  _Env: (_23) => _23,
  /* c8 ignore next */
  _InErr: (_23) => _23,
  /* c8 ignore next */
  _InElem: (_23) => _23,
  /* c8 ignore next */
  _InDone: (_23) => _23,
  /* c8 ignore next */
  _OutErr: (_23) => _23,
  /* c8 ignore next */
  _OutElem: (_23) => _23,
  /* c8 ignore next */
  _OutDone: (_23) => _23
};
var EffectPrototype2 = {
  [EffectTypeId3]: effectVariance2,
  [StreamTypeId2]: effectVariance2,
  [SinkTypeId2]: sinkVariance2,
  [ChannelTypeId2]: channelVariance2,
  [symbol4](that) {
    return this === that;
  },
  [symbol3]() {
    return cached2(this, random2(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen3(new YieldWrap2(this));
  },
  pipe() {
    return pipeArguments2(this, arguments);
  }
};
var TypeId6 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto3 = {
  ...EffectPrototype2,
  [TypeId6]: {
    _A: (_23) => _23
  },
  [NodeInspectSymbol2]() {
    return this.toJSON();
  },
  toString() {
    return format2(this.toJSON());
  }
};
var SomeProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto3), {
  _tag: "Some",
  _op: "Some",
  [symbol4](that) {
    return isOption3(that) && isSome3(that) && equals2(this.value, that.value);
  },
  [symbol3]() {
    return cached2(this, combine3(hash2(this._tag))(hash2(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON2(this.value)
    };
  }
});
var NoneHash2 = /* @__PURE__ */ hash2("None");
var NoneProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto3), {
  _tag: "None",
  _op: "None",
  [symbol4](that) {
    return isOption3(that) && isNone3(that);
  },
  [symbol3]() {
    return NoneHash2;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption3 = (input) => hasProperty2(input, TypeId6);
var isNone3 = (fa) => fa._tag === "None";
var isSome3 = (fa) => fa._tag === "Some";
var none3 = /* @__PURE__ */ Object.create(NoneProto2);
var some5 = (value) => {
  const a23 = Object.create(SomeProto2);
  a23.value = value;
  return a23;
};
var TypeId7 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto4 = {
  ...EffectPrototype2,
  [TypeId7]: {
    _R: (_23) => _23
  },
  [NodeInspectSymbol2]() {
    return this.toJSON();
  },
  toString() {
    return format2(this.toJSON());
  }
};
var RightProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto4), {
  _tag: "Right",
  _op: "Right",
  [symbol4](that) {
    return isEither2(that) && isRight2(that) && equals2(this.right, that.right);
  },
  [symbol3]() {
    return combine3(hash2(this._tag))(hash2(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON2(this.right)
    };
  }
});
var LeftProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto4), {
  _tag: "Left",
  _op: "Left",
  [symbol4](that) {
    return isEither2(that) && isLeft2(that) && equals2(this.left, that.left);
  },
  [symbol3]() {
    return combine3(hash2(this._tag))(hash2(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON2(this.left)
    };
  }
});
var isEither2 = (input) => hasProperty2(input, TypeId7);
var isLeft2 = (ma) => ma._tag === "Left";
var isRight2 = (ma) => ma._tag === "Right";
var left3 = (left53) => {
  const a23 = Object.create(LeftProto2);
  a23.left = left53;
  return a23;
};
var right3 = (right53) => {
  const a23 = Object.create(RightProto2);
  a23.right = right53;
  return a23;
};
var getLeft3 = (self2) => isRight2(self2) ? none3 : some5(self2.left);
var getRight3 = (self2) => isLeft2(self2) ? none3 : some5(self2.right);
var isLeft3 = isLeft2;
var isRight3 = isRight2;
var isNonEmptyArray = (self2) => self2.length > 0;
var Option_exports2 = {};
__export2(Option_exports2, {
  Do: () => Do2,
  TypeId: () => TypeId8,
  all: () => all4,
  andThen: () => andThen2,
  ap: () => ap2,
  as: () => as2,
  asVoid: () => asVoid2,
  bind: () => bind4,
  bindTo: () => bindTo4,
  composeK: () => composeK2,
  contains: () => contains2,
  containsWith: () => containsWith2,
  exists: () => exists2,
  filter: () => filter2,
  filterMap: () => filterMap2,
  firstSomeOf: () => firstSomeOf2,
  flatMap: () => flatMap2,
  flatMapNullable: () => flatMapNullable2,
  flatten: () => flatten2,
  fromIterable: () => fromIterable3,
  fromNullable: () => fromNullable2,
  gen: () => gen2,
  getEquivalence: () => getEquivalence3,
  getLeft: () => getLeft4,
  getOrElse: () => getOrElse2,
  getOrNull: () => getOrNull2,
  getOrThrow: () => getOrThrow2,
  getOrThrowWith: () => getOrThrowWith2,
  getOrUndefined: () => getOrUndefined2,
  getOrder: () => getOrder2,
  getRight: () => getRight4,
  isNone: () => isNone4,
  isOption: () => isOption4,
  isSome: () => isSome4,
  let: () => let_4,
  lift2: () => lift22,
  liftNullable: () => liftNullable2,
  liftPredicate: () => liftPredicate2,
  liftThrowable: () => liftThrowable2,
  map: () => map2,
  match: () => match3,
  none: () => none4,
  orElse: () => orElse2,
  orElseEither: () => orElseEither2,
  orElseSome: () => orElseSome2,
  partitionMap: () => partitionMap2,
  product: () => product4,
  productMany: () => productMany4,
  reduceCompact: () => reduceCompact2,
  some: () => some6,
  tap: () => tap2,
  toArray: () => toArray2,
  toRefinement: () => toRefinement2,
  void: () => void_2,
  zipLeft: () => zipLeft2,
  zipRight: () => zipRight2,
  zipWith: () => zipWith2
});
var make8 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var number3 = /* @__PURE__ */ make8((self2, that) => self2 < that ? -1 : 1);
var combineMany = /* @__PURE__ */ dual2(2, (self2, collection) => make8((a1, a23) => {
  let out = self2(a1, a23);
  if (out !== 0) {
    return out;
  }
  for (const O23 of collection) {
    out = O23(a1, a23);
    if (out !== 0) {
      return out;
    }
  }
  return out;
}));
var empty8 = () => make8(() => 0);
var combineAll = (collection) => combineMany(empty8(), collection);
var mapInput3 = /* @__PURE__ */ dual2(2, (self2, f23) => make8((b1, b23) => self2(f23(b1), f23(b23))));
var array4 = (O23) => make8((self2, that) => {
  const aLen = self2.length;
  const bLen = that.length;
  const len = Math.min(aLen, bLen);
  for (let i23 = 0; i23 < len; i23++) {
    const o23 = O23(self2[i23], that[i23]);
    if (o23 !== 0) {
      return o23;
    }
  }
  return number3(aLen, bLen);
});
var min = (O23) => dual2(2, (self2, that) => self2 === that || O23(self2, that) < 1 ? self2 : that);
var max = (O23) => dual2(2, (self2, that) => self2 === that || O23(self2, that) > -1 ? self2 : that);
var TypeId8 = /* @__PURE__ */ Symbol.for("effect/Option");
var none4 = () => none3;
var some6 = some5;
var isOption4 = isOption3;
var isNone4 = isNone3;
var isSome4 = isSome3;
var match3 = /* @__PURE__ */ dual2(2, (self2, {
  onNone,
  onSome
}) => isNone4(self2) ? onNone() : onSome(self2.value));
var toRefinement2 = (f23) => (a23) => isSome4(f23(a23));
var fromIterable3 = (collection) => {
  for (const a23 of collection) {
    return some6(a23);
  }
  return none4();
};
var getRight4 = getRight3;
var getLeft4 = getLeft3;
var getOrElse2 = /* @__PURE__ */ dual2(2, (self2, onNone) => isNone4(self2) ? onNone() : self2.value);
var orElse2 = /* @__PURE__ */ dual2(2, (self2, that) => isNone4(self2) ? that() : self2);
var orElseSome2 = /* @__PURE__ */ dual2(2, (self2, onNone) => isNone4(self2) ? some6(onNone()) : self2);
var orElseEither2 = /* @__PURE__ */ dual2(2, (self2, that) => isNone4(self2) ? map2(that(), right3) : map2(self2, left3));
var firstSomeOf2 = (collection) => {
  let out = none4();
  for (out of collection) {
    if (isSome4(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable2 = (nullableValue) => nullableValue == null ? none4() : some6(nullableValue);
var liftNullable2 = (f23) => (...a23) => fromNullable2(f23(...a23));
var getOrNull2 = /* @__PURE__ */ getOrElse2(constNull2);
var getOrUndefined2 = /* @__PURE__ */ getOrElse2(constUndefined2);
var liftThrowable2 = (f23) => (...a23) => {
  try {
    return some6(f23(...a23));
  } catch (e23) {
    return none4();
  }
};
var getOrThrowWith2 = /* @__PURE__ */ dual2(2, (self2, onNone) => {
  if (isSome4(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow2 = /* @__PURE__ */ getOrThrowWith2(() => new Error("getOrThrow called on a None"));
var map2 = /* @__PURE__ */ dual2(2, (self2, f23) => isNone4(self2) ? none4() : some6(f23(self2.value)));
var as2 = /* @__PURE__ */ dual2(2, (self2, b23) => map2(self2, () => b23));
var asVoid2 = /* @__PURE__ */ as2(void 0);
var void_2 = /* @__PURE__ */ some6(void 0);
var flatMap2 = /* @__PURE__ */ dual2(2, (self2, f23) => isNone4(self2) ? none4() : f23(self2.value));
var andThen2 = /* @__PURE__ */ dual2(2, (self2, f23) => flatMap2(self2, (a23) => {
  const b23 = isFunction4(f23) ? f23(a23) : f23;
  return isOption4(b23) ? b23 : some6(b23);
}));
var flatMapNullable2 = /* @__PURE__ */ dual2(2, (self2, f23) => isNone4(self2) ? none4() : fromNullable2(f23(self2.value)));
var flatten2 = /* @__PURE__ */ flatMap2(identity2);
var zipRight2 = /* @__PURE__ */ dual2(2, (self2, that) => flatMap2(self2, () => that));
var composeK2 = /* @__PURE__ */ dual2(2, (afb, bfc) => (a23) => flatMap2(afb(a23), bfc));
var zipLeft2 = /* @__PURE__ */ dual2(2, (self2, that) => tap2(self2, () => that));
var tap2 = /* @__PURE__ */ dual2(2, (self2, f23) => flatMap2(self2, (a23) => map2(f23(a23), () => a23)));
var product4 = (self2, that) => isSome4(self2) && isSome4(that) ? some6([self2.value, that.value]) : none4();
var productMany4 = (self2, collection) => {
  if (isNone4(self2)) {
    return none4();
  }
  const out = [self2.value];
  for (const o23 of collection) {
    if (isNone4(o23)) {
      return none4();
    }
    out.push(o23.value);
  }
  return some6(out);
};
var all4 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o23 of input) {
      if (isNone4(o23)) {
        return none4();
      }
      out2.push(o23.value);
    }
    return some6(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o23 = input[key];
    if (isNone4(o23)) {
      return none4();
    }
    out[key] = o23.value;
  }
  return some6(out);
};
var zipWith2 = /* @__PURE__ */ dual2(3, (self2, that, f23) => map2(product4(self2, that), ([a23, b23]) => f23(a23, b23)));
var ap2 = /* @__PURE__ */ dual2(2, (self2, that) => zipWith2(self2, that, (f23, a23) => f23(a23)));
var reduceCompact2 = /* @__PURE__ */ dual2(3, (self2, b23, f23) => {
  let out = b23;
  for (const oa of self2) {
    if (isSome4(oa)) {
      out = f23(out, oa.value);
    }
  }
  return out;
});
var toArray2 = (self2) => isNone4(self2) ? [] : [self2.value];
var partitionMap2 = /* @__PURE__ */ dual2(2, (self2, f23) => {
  if (isNone4(self2)) {
    return [none4(), none4()];
  }
  const e23 = f23(self2.value);
  return isLeft2(e23) ? [some6(e23.left), none4()] : [none4(), some6(e23.right)];
});
var filterMap2 = /* @__PURE__ */ dual2(2, (self2, f23) => isNone4(self2) ? none4() : f23(self2.value));
var filter2 = /* @__PURE__ */ dual2(2, (self2, predicate) => filterMap2(self2, (b23) => predicate(b23) ? some5(b23) : none3));
var getEquivalence3 = (isEquivalent) => make6((x23, y23) => x23 === y23 || (isNone4(x23) ? isNone4(y23) : isNone4(y23) ? false : isEquivalent(x23.value, y23.value)));
var getOrder2 = (O23) => make8((self2, that) => isSome4(self2) ? isSome4(that) ? O23(self2.value, that.value) : 1 : -1);
var lift22 = (f23) => dual2(2, (self2, that) => zipWith2(self2, that, f23));
var liftPredicate2 = (predicate) => (b23) => predicate(b23) ? some6(b23) : none4();
var containsWith2 = (isEquivalent) => dual2(2, (self2, a23) => isNone4(self2) ? false : isEquivalent(self2.value, a23));
var _equivalence3 = /* @__PURE__ */ equivalence2();
var contains2 = /* @__PURE__ */ containsWith2(_equivalence3);
var exists2 = /* @__PURE__ */ dual2(2, (self2, refinement) => isNone4(self2) ? false : refinement(self2.value));
var bindTo4 = /* @__PURE__ */ bindTo3(map2);
var let_4 = /* @__PURE__ */ let_3(map2);
var bind4 = /* @__PURE__ */ bind3(map2, flatMap2);
var Do2 = /* @__PURE__ */ some6({});
var adapter4 = /* @__PURE__ */ adapter3();
var gen2 = (f23) => {
  const iterator = f23(adapter4);
  let state = iterator.next();
  if (state.done) {
    return some6(state.value);
  } else {
    let current = state.value;
    if (isGenKind2(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet2(current);
    }
    if (isNone4(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind2(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet2(current);
        }
        if (isNone4(current)) {
          return current;
        }
      }
    }
    return some6(state.value);
  }
};
var make9 = (...elements) => elements;
var findFirst = /* @__PURE__ */ dual2(2, (self2, f23) => {
  let i23 = 0;
  for (const a23 of self2) {
    const o23 = f23(a23, i23);
    if (isBoolean2(o23)) {
      if (o23) {
        return some6(a23);
      }
    } else {
      if (isSome4(o23)) {
        return o23;
      }
    }
    i23++;
  }
  return none4();
});
var collect = /* @__PURE__ */ dual2(2, (self2, f23) => {
  const out = [];
  for (const key of keys2(self2)) {
    out.push(f23(key, self2[key]));
  }
  return out;
});
var toEntries = /* @__PURE__ */ collect((key, value) => [key, value]);
var keys2 = (self2) => Object.keys(self2);
var make10 = (...elements) => elements;
var allocate = (n23) => new Array(n23);
var makeBy = (n23, f23) => {
  const max32 = Math.max(1, Math.floor(n23));
  const out = new Array(max32);
  for (let i23 = 0; i23 < max32; i23++) {
    out[i23] = f23(i23);
  }
  return out;
};
var range = (start, end) => start <= end ? makeBy(end - start + 1, (i23) => start + i23) : [start];
var replicate = /* @__PURE__ */ dual2(2, (a23, n23) => makeBy(n23, () => a23));
var fromIterable4 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var fromRecord = toEntries;
var fromOption2 = toArray2;
var match4 = /* @__PURE__ */ dual2(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray(self2) ? onNonEmpty(self2) : onEmpty());
var matchLeft = /* @__PURE__ */ dual2(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray(self2) ? onNonEmpty(headNonEmpty2(self2), tailNonEmpty2(self2)) : onEmpty());
var matchRight = /* @__PURE__ */ dual2(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray(self2) ? onNonEmpty(initNonEmpty(self2), lastNonEmpty(self2)) : onEmpty());
var prepend2 = /* @__PURE__ */ dual2(2, (self2, head23) => [head23, ...self2]);
var prependAll = /* @__PURE__ */ dual2(2, (self2, that) => fromIterable4(that).concat(fromIterable4(self2)));
var append = /* @__PURE__ */ dual2(2, (self2, last22) => [...self2, last22]);
var appendAll2 = /* @__PURE__ */ dual2(2, (self2, that) => fromIterable4(self2).concat(fromIterable4(that)));
var scan = /* @__PURE__ */ dual2(3, (self2, b23, f23) => {
  const out = [b23];
  let i23 = 0;
  for (const a23 of self2) {
    out[i23 + 1] = f23(out[i23], a23);
    i23++;
  }
  return out;
});
var scanRight = /* @__PURE__ */ dual2(3, (self2, b23, f23) => {
  const input = fromIterable4(self2);
  const out = new Array(input.length + 1);
  out[input.length] = b23;
  for (let i23 = input.length - 1; i23 >= 0; i23--) {
    out[i23] = f23(out[i23 + 1], input[i23]);
  }
  return out;
});
var isArray = Array.isArray;
var isEmptyArray = (self2) => self2.length === 0;
var isEmptyReadonlyArray = isEmptyArray;
var isNonEmptyArray2 = isNonEmptyArray;
var isNonEmptyReadonlyArray = isNonEmptyArray;
var length = (self2) => self2.length;
var isOutOfBound = (i23, as43) => i23 < 0 || i23 >= as43.length;
var clamp = (i23, as43) => Math.floor(Math.min(Math.max(0, i23), as43.length));
var get = /* @__PURE__ */ dual2(2, (self2, index) => {
  const i23 = Math.floor(index);
  return isOutOfBound(i23, self2) ? none4() : some6(self2[i23]);
});
var unsafeGet = /* @__PURE__ */ dual2(2, (self2, index) => {
  const i23 = Math.floor(index);
  if (isOutOfBound(i23, self2)) {
    throw new Error(`Index ${i23} out of bounds`);
  }
  return self2[i23];
});
var unprepend = (self2) => [headNonEmpty2(self2), tailNonEmpty2(self2)];
var unappend = (self2) => [initNonEmpty(self2), lastNonEmpty(self2)];
var head = /* @__PURE__ */ get(0);
var headNonEmpty2 = /* @__PURE__ */ unsafeGet(0);
var last = (self2) => isNonEmptyReadonlyArray(self2) ? some6(lastNonEmpty(self2)) : none4();
var lastNonEmpty = (self2) => self2[self2.length - 1];
var tail = (self2) => {
  const input = fromIterable4(self2);
  return isNonEmptyReadonlyArray(input) ? some6(tailNonEmpty2(input)) : none4();
};
var tailNonEmpty2 = (self2) => self2.slice(1);
var init = (self2) => {
  const input = fromIterable4(self2);
  return isNonEmptyReadonlyArray(input) ? some6(initNonEmpty(input)) : none4();
};
var initNonEmpty = (self2) => self2.slice(0, -1);
var take = /* @__PURE__ */ dual2(2, (self2, n23) => {
  const input = fromIterable4(self2);
  return input.slice(0, clamp(n23, input));
});
var takeRight = /* @__PURE__ */ dual2(2, (self2, n23) => {
  const input = fromIterable4(self2);
  const i23 = clamp(n23, input);
  return i23 === 0 ? [] : input.slice(-i23);
});
var takeWhile = /* @__PURE__ */ dual2(2, (self2, predicate) => {
  let i23 = 0;
  const out = [];
  for (const a23 of self2) {
    if (!predicate(a23, i23)) {
      break;
    }
    out.push(a23);
    i23++;
  }
  return out;
});
var spanIndex = (self2, predicate) => {
  let i23 = 0;
  for (const a23 of self2) {
    if (!predicate(a23, i23)) {
      break;
    }
    i23++;
  }
  return i23;
};
var span = /* @__PURE__ */ dual2(2, (self2, predicate) => splitAt(self2, spanIndex(self2, predicate)));
var drop2 = /* @__PURE__ */ dual2(2, (self2, n23) => {
  const input = fromIterable4(self2);
  return input.slice(clamp(n23, input), input.length);
});
var dropRight = /* @__PURE__ */ dual2(2, (self2, n23) => {
  const input = fromIterable4(self2);
  return input.slice(0, input.length - clamp(n23, input));
});
var dropWhile = /* @__PURE__ */ dual2(2, (self2, predicate) => fromIterable4(self2).slice(spanIndex(self2, predicate)));
var findFirstIndex = /* @__PURE__ */ dual2(2, (self2, predicate) => {
  let i23 = 0;
  for (const a23 of self2) {
    if (predicate(a23, i23)) {
      return some6(i23);
    }
    i23++;
  }
  return none4();
});
var findLastIndex = /* @__PURE__ */ dual2(2, (self2, predicate) => {
  const input = fromIterable4(self2);
  for (let i23 = input.length - 1; i23 >= 0; i23--) {
    if (predicate(input[i23], i23)) {
      return some6(i23);
    }
  }
  return none4();
});
var findFirst2 = findFirst;
var findLast = /* @__PURE__ */ dual2(2, (self2, f23) => {
  const input = fromIterable4(self2);
  for (let i23 = input.length - 1; i23 >= 0; i23--) {
    const a23 = input[i23];
    const o23 = f23(a23, i23);
    if (isBoolean2(o23)) {
      if (o23) {
        return some6(a23);
      }
    } else {
      if (isSome4(o23)) {
        return o23;
      }
    }
  }
  return none4();
});
var insertAt = /* @__PURE__ */ dual2(3, (self2, i23, b23) => {
  const out = Array.from(self2);
  if (i23 < 0 || i23 > out.length) {
    return none4();
  }
  out.splice(i23, 0, b23);
  return some6(out);
});
var replace2 = /* @__PURE__ */ dual2(3, (self2, i23, b23) => modify(self2, i23, () => b23));
var replaceOption = /* @__PURE__ */ dual2(3, (self2, i23, b23) => modifyOption(self2, i23, () => b23));
var modify = /* @__PURE__ */ dual2(3, (self2, i23, f23) => getOrElse2(modifyOption(self2, i23, f23), () => Array.from(self2)));
var modifyOption = /* @__PURE__ */ dual2(3, (self2, i23, f23) => {
  const out = Array.from(self2);
  if (isOutOfBound(i23, out)) {
    return none4();
  }
  const next = f23(out[i23]);
  out[i23] = next;
  return some6(out);
});
var remove = /* @__PURE__ */ dual2(2, (self2, i23) => {
  const out = Array.from(self2);
  if (isOutOfBound(i23, out)) {
    return out;
  }
  out.splice(i23, 1);
  return out;
});
var reverse3 = (self2) => Array.from(self2).reverse();
var sort = /* @__PURE__ */ dual2(2, (self2, O23) => {
  const out = Array.from(self2);
  out.sort(O23);
  return out;
});
var sortWith = /* @__PURE__ */ dual2(3, (self2, f23, order) => sort(self2, mapInput3(order, f23)));
var sortBy = (...orders) => {
  const sortByAll = sort(combineAll(orders));
  return (self2) => {
    const input = fromIterable4(self2);
    if (isNonEmptyReadonlyArray(input)) {
      return sortByAll(input);
    }
    return [];
  };
};
var zip = /* @__PURE__ */ dual2(2, (self2, that) => zipWith3(self2, that, make9));
var zipWith3 = /* @__PURE__ */ dual2(3, (self2, that, f23) => {
  const as43 = fromIterable4(self2);
  const bs = fromIterable4(that);
  if (isNonEmptyReadonlyArray(as43) && isNonEmptyReadonlyArray(bs)) {
    const out = [f23(headNonEmpty2(as43), headNonEmpty2(bs))];
    const len = Math.min(as43.length, bs.length);
    for (let i23 = 1; i23 < len; i23++) {
      out[i23] = f23(as43[i23], bs[i23]);
    }
    return out;
  }
  return [];
});
var unzip = (self2) => {
  const input = fromIterable4(self2);
  if (isNonEmptyReadonlyArray(input)) {
    const fa = [input[0][0]];
    const fb = [input[0][1]];
    for (let i23 = 1; i23 < input.length; i23++) {
      fa[i23] = input[i23][0];
      fb[i23] = input[i23][1];
    }
    return [fa, fb];
  }
  return [[], []];
};
var intersperse = /* @__PURE__ */ dual2(2, (self2, middle) => {
  const input = fromIterable4(self2);
  if (isNonEmptyReadonlyArray(input)) {
    const out = [headNonEmpty2(input)];
    const tail23 = tailNonEmpty2(input);
    for (let i23 = 0; i23 < tail23.length; i23++) {
      if (i23 < tail23.length) {
        out.push(middle);
      }
      out.push(tail23[i23]);
    }
    return out;
  }
  return [];
});
var modifyNonEmptyHead = /* @__PURE__ */ dual2(2, (self2, f23) => [f23(headNonEmpty2(self2)), ...tailNonEmpty2(self2)]);
var setNonEmptyHead = /* @__PURE__ */ dual2(2, (self2, b23) => modifyNonEmptyHead(self2, () => b23));
var modifyNonEmptyLast = /* @__PURE__ */ dual2(2, (self2, f23) => append(initNonEmpty(self2), f23(lastNonEmpty(self2))));
var setNonEmptyLast = /* @__PURE__ */ dual2(2, (self2, b23) => modifyNonEmptyLast(self2, () => b23));
var rotate = /* @__PURE__ */ dual2(2, (self2, n23) => {
  const input = fromIterable4(self2);
  if (isNonEmptyReadonlyArray(input)) {
    const len = input.length;
    const m23 = Math.round(n23) % len;
    if (isOutOfBound(Math.abs(m23), input) || m23 === 0) {
      return copy2(input);
    }
    if (m23 < 0) {
      const [f23, s23] = splitNonEmptyAt(input, -m23);
      return appendAll2(s23, f23);
    } else {
      return rotate(self2, m23 - len);
    }
  }
  return [];
});
var containsWith3 = (isEquivalent) => dual2(2, (self2, a23) => {
  for (const i23 of self2) {
    if (isEquivalent(a23, i23)) {
      return true;
    }
  }
  return false;
});
var _equivalence4 = /* @__PURE__ */ equivalence2();
var contains3 = /* @__PURE__ */ containsWith3(_equivalence4);
var chop = /* @__PURE__ */ dual2(2, (self2, f23) => {
  const input = fromIterable4(self2);
  if (isNonEmptyReadonlyArray(input)) {
    const [b23, rest] = f23(input);
    const out = [b23];
    let next = rest;
    while (isNonEmptyArray(next)) {
      const [b32, rest2] = f23(next);
      out.push(b32);
      next = rest2;
    }
    return out;
  }
  return [];
});
var splitAt = /* @__PURE__ */ dual2(2, (self2, n23) => {
  const input = Array.from(self2);
  const _n = Math.floor(n23);
  if (isNonEmptyReadonlyArray(input)) {
    if (_n >= 1) {
      return splitNonEmptyAt(input, _n);
    }
    return [[], input];
  }
  return [input, []];
});
var splitNonEmptyAt = /* @__PURE__ */ dual2(2, (self2, n23) => {
  const _n = Math.max(1, Math.floor(n23));
  return _n >= self2.length ? [copy2(self2), []] : [prepend2(self2.slice(1, _n), headNonEmpty2(self2)), self2.slice(_n)];
});
var split = /* @__PURE__ */ dual2(2, (self2, n23) => {
  const input = fromIterable4(self2);
  return chunksOf(input, Math.ceil(input.length / Math.floor(n23)));
});
var splitWhere = /* @__PURE__ */ dual2(2, (self2, predicate) => span(self2, (a23, i23) => !predicate(a23, i23)));
var copy2 = (self2) => self2.slice();
var chunksOf = /* @__PURE__ */ dual2(2, (self2, n23) => {
  const input = fromIterable4(self2);
  if (isNonEmptyReadonlyArray(input)) {
    return chop(input, splitNonEmptyAt(n23));
  }
  return [];
});
var groupWith = /* @__PURE__ */ dual2(2, (self2, isEquivalent) => chop(self2, (as43) => {
  const h23 = headNonEmpty2(as43);
  const out = [h23];
  let i23 = 1;
  for (; i23 < as43.length; i23++) {
    const a23 = as43[i23];
    if (isEquivalent(a23, h23)) {
      out.push(a23);
    } else {
      break;
    }
  }
  return [out, as43.slice(i23)];
}));
var group = /* @__PURE__ */ groupWith(/* @__PURE__ */ equivalence2());
var groupBy = /* @__PURE__ */ dual2(2, (self2, f23) => {
  const out = {};
  for (const a23 of self2) {
    const k23 = f23(a23);
    if (Object.prototype.hasOwnProperty.call(out, k23)) {
      out[k23].push(a23);
    } else {
      out[k23] = [a23];
    }
  }
  return out;
});
var unionWith = /* @__PURE__ */ dual2(3, (self2, that, isEquivalent) => {
  const a23 = fromIterable4(self2);
  const b23 = fromIterable4(that);
  if (isNonEmptyReadonlyArray(a23)) {
    if (isNonEmptyReadonlyArray(b23)) {
      const dedupe22 = dedupeWith(isEquivalent);
      return dedupe22(appendAll2(a23, b23));
    }
    return a23;
  }
  return b23;
});
var union = /* @__PURE__ */ dual2(2, (self2, that) => unionWith(self2, that, _equivalence4));
var intersectionWith = (isEquivalent) => {
  const has22 = containsWith3(isEquivalent);
  return dual2(2, (self2, that) => fromIterable4(self2).filter((a23) => has22(that, a23)));
};
var intersection = /* @__PURE__ */ intersectionWith(_equivalence4);
var differenceWith = (isEquivalent) => {
  const has22 = containsWith3(isEquivalent);
  return dual2(2, (self2, that) => fromIterable4(self2).filter((a23) => !has22(that, a23)));
};
var difference = /* @__PURE__ */ differenceWith(_equivalence4);
var empty9 = () => [];
var of2 = (a23) => [a23];
var map3 = /* @__PURE__ */ dual2(2, (self2, f23) => self2.map(f23));
var flatMap3 = /* @__PURE__ */ dual2(2, (self2, f23) => {
  if (isEmptyReadonlyArray(self2)) {
    return [];
  }
  const out = [];
  for (let i23 = 0; i23 < self2.length; i23++) {
    const inner = f23(self2[i23], i23);
    for (let j23 = 0; j23 < inner.length; j23++) {
      out.push(inner[j23]);
    }
  }
  return out;
});
var flatten3 = /* @__PURE__ */ flatMap3(identity2);
var filterMap3 = /* @__PURE__ */ dual2(2, (self2, f23) => {
  const as43 = fromIterable4(self2);
  const out = [];
  for (let i23 = 0; i23 < as43.length; i23++) {
    const o23 = f23(as43[i23], i23);
    if (isSome4(o23)) {
      out.push(o23.value);
    }
  }
  return out;
});
var filterMapWhile = /* @__PURE__ */ dual2(2, (self2, f23) => {
  let i23 = 0;
  const out = [];
  for (const a23 of self2) {
    const b23 = f23(a23, i23);
    if (isSome4(b23)) {
      out.push(b23.value);
    } else {
      break;
    }
    i23++;
  }
  return out;
});
var partitionMap3 = /* @__PURE__ */ dual2(2, (self2, f23) => {
  const left53 = [];
  const right53 = [];
  const as43 = fromIterable4(self2);
  for (let i23 = 0; i23 < as43.length; i23++) {
    const e23 = f23(as43[i23], i23);
    if (isLeft3(e23)) {
      left53.push(e23.left);
    } else {
      right53.push(e23.right);
    }
  }
  return [left53, right53];
});
var getSomes = /* @__PURE__ */ filterMap3(identity2);
var getLefts = (self2) => {
  const out = [];
  for (const a23 of self2) {
    if (isLeft3(a23)) {
      out.push(a23.left);
    }
  }
  return out;
};
var getRights = (self2) => {
  const out = [];
  for (const a23 of self2) {
    if (isRight3(a23)) {
      out.push(a23.right);
    }
  }
  return out;
};
var filter3 = /* @__PURE__ */ dual2(2, (self2, predicate) => {
  const as43 = fromIterable4(self2);
  const out = [];
  for (let i23 = 0; i23 < as43.length; i23++) {
    if (predicate(as43[i23], i23)) {
      out.push(as43[i23]);
    }
  }
  return out;
});
var partition = /* @__PURE__ */ dual2(2, (self2, predicate) => {
  const left53 = [];
  const right53 = [];
  const as43 = fromIterable4(self2);
  for (let i23 = 0; i23 < as43.length; i23++) {
    if (predicate(as43[i23], i23)) {
      right53.push(as43[i23]);
    } else {
      left53.push(as43[i23]);
    }
  }
  return [left53, right53];
});
var separate = /* @__PURE__ */ partitionMap3(identity2);
var reduce3 = /* @__PURE__ */ dual2(3, (self2, b23, f23) => fromIterable4(self2).reduce((b32, a23, i23) => f23(b32, a23, i23), b23));
var reduceRight = /* @__PURE__ */ dual2(3, (self2, b23, f23) => fromIterable4(self2).reduceRight((b32, a23, i23) => f23(b32, a23, i23), b23));
var liftPredicate3 = (predicate) => (b23) => predicate(b23) ? [b23] : [];
var liftOption = (f23) => (...a23) => fromOption2(f23(...a23));
var fromNullable3 = (a23) => a23 == null ? empty9() : [a23];
var liftNullable3 = (f23) => (...a23) => fromNullable3(f23(...a23));
var flatMapNullable3 = /* @__PURE__ */ dual2(2, (self2, f23) => flatMap3(self2, (a23) => fromNullable3(f23(a23))));
var liftEither = (f23) => (...a23) => {
  const e23 = f23(...a23);
  return isLeft3(e23) ? [] : [e23.right];
};
var every3 = /* @__PURE__ */ dual2(2, (self2, refinement) => self2.every(refinement));
var some7 = /* @__PURE__ */ dual2(2, (self2, predicate) => self2.some(predicate));
var extend = /* @__PURE__ */ dual2(2, (self2, f23) => self2.map((_23, i23, as43) => f23(as43.slice(i23))));
var min2 = /* @__PURE__ */ dual2(2, (self2, O23) => self2.reduce(min(O23)));
var max2 = /* @__PURE__ */ dual2(2, (self2, O23) => self2.reduce(max(O23)));
var unfold = (b23, f23) => {
  const out = [];
  let next = b23;
  let o23;
  while (isSome4(o23 = f23(next))) {
    const [a23, b32] = o23.value;
    out.push(a23);
    next = b32;
  }
  return out;
};
var getOrder3 = array4;
var getEquivalence4 = array3;
var forEach3 = /* @__PURE__ */ dual2(2, (self2, f23) => fromIterable4(self2).forEach((a23, i23) => f23(a23, i23)));
var dedupeWith = /* @__PURE__ */ dual2(2, (self2, isEquivalent) => {
  const input = fromIterable4(self2);
  if (isNonEmptyReadonlyArray(input)) {
    const out = [headNonEmpty2(input)];
    const rest = tailNonEmpty2(input);
    for (const r23 of rest) {
      if (out.every((a23) => !isEquivalent(r23, a23))) {
        out.push(r23);
      }
    }
    return out;
  }
  return [];
});
var dedupe = (self2) => dedupeWith(self2, equivalence2());
var dedupeAdjacentWith = /* @__PURE__ */ dual2(2, (self2, isEquivalent) => {
  const out = [];
  let lastA = none4();
  for (const a23 of self2) {
    if (isNone4(lastA) || !isEquivalent(a23, lastA.value)) {
      out.push(a23);
      lastA = some6(a23);
    }
  }
  return out;
});
var dedupeAdjacent = /* @__PURE__ */ dedupeAdjacentWith(/* @__PURE__ */ equivalence2());
var join = /* @__PURE__ */ dual2(2, (self2, sep) => fromIterable4(self2).join(sep));
var mapAccum = /* @__PURE__ */ dual2(3, (self2, s23, f23) => {
  let i23 = 0;
  let s1 = s23;
  const out = [];
  for (const a23 of self2) {
    const r23 = f23(s1, a23, i23);
    s1 = r23[0];
    out.push(r23[1]);
    i23++;
  }
  return [s1, out];
});
var cartesianWith = /* @__PURE__ */ dual2(3, (self2, that, f23) => flatMap3(self2, (a23) => map3(that, (b23) => f23(a23, b23))));
var cartesian = /* @__PURE__ */ dual2(2, (self2, that) => cartesianWith(self2, that, (a23, b23) => [a23, b23]));
var Do3 = /* @__PURE__ */ of2({});
var bind5 = /* @__PURE__ */ bind3(map3, flatMap3);
var bindTo5 = /* @__PURE__ */ bindTo3(map3);
var let_5 = /* @__PURE__ */ let_3(map3);
var __defProp3 = Object.defineProperty;
var __export3 = (target, all323) => {
  for (var name2 in all323)
    __defProp3(target, name2, { get: all323[name2], enumerable: true });
};
var Function_exports3 = {};
__export3(Function_exports3, {
  SK: () => SK3,
  absurd: () => absurd3,
  apply: () => apply3,
  compose: () => compose5,
  constFalse: () => constFalse3,
  constNull: () => constNull3,
  constTrue: () => constTrue3,
  constUndefined: () => constUndefined3,
  constVoid: () => constVoid3,
  constant: () => constant3,
  dual: () => dual3,
  flip: () => flip3,
  flow: () => flow3,
  hole: () => hole3,
  identity: () => identity3,
  isFunction: () => isFunction6,
  pipe: () => pipe3,
  satisfies: () => satisfies3,
  tupled: () => tupled3,
  unsafeCoerce: () => unsafeCoerce3,
  untupled: () => untupled3
});
var isFunction6 = (input) => typeof input === "function";
var dual3 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a23, b23) {
        if (arguments.length >= 2) {
          return body(a23, b23);
        }
        return function(self2) {
          return body(self2, a23);
        };
      };
    case 3:
      return function(a23, b23, c23) {
        if (arguments.length >= 3) {
          return body(a23, b23, c23);
        }
        return function(self2) {
          return body(self2, a23, b23);
        };
      };
    case 4:
      return function(a23, b23, c23, d23) {
        if (arguments.length >= 4) {
          return body(a23, b23, c23, d23);
        }
        return function(self2) {
          return body(self2, a23, b23, c23);
        };
      };
    case 5:
      return function(a23, b23, c23, d23, e23) {
        if (arguments.length >= 5) {
          return body(a23, b23, c23, d23, e23);
        }
        return function(self2) {
          return body(self2, a23, b23, c23, d23);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply3 = (a23) => (self2) => self2(a23);
var identity3 = (a23) => a23;
var satisfies3 = () => (b23) => b23;
var unsafeCoerce3 = identity3;
var constant3 = (value) => () => value;
var constTrue3 = /* @__PURE__ */ constant3(true);
var constFalse3 = /* @__PURE__ */ constant3(false);
var constNull3 = /* @__PURE__ */ constant3(null);
var constUndefined3 = /* @__PURE__ */ constant3(void 0);
var constVoid3 = constUndefined3;
var flip3 = (f23) => (...b23) => (...a23) => f23(...a23)(...b23);
var compose5 = /* @__PURE__ */ dual3(2, (ab, bc) => (a23) => bc(ab(a23)));
var absurd3 = (_23) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled3 = (f23) => (a23) => f23(...a23);
var untupled3 = (f23) => (...a23) => f23(a23);
function pipe3(a23, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a23;
    case 2:
      return ab(a23);
    case 3:
      return bc(ab(a23));
    case 4:
      return cd(bc(ab(a23)));
    case 5:
      return de(cd(bc(ab(a23))));
    case 6:
      return ef(de(cd(bc(ab(a23)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a23))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a23)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a23))))))));
    default: {
      let ret = arguments[0];
      for (let i23 = 1; i23 < arguments.length; i23++) {
        ret = arguments[i23](ret);
      }
      return ret;
    }
  }
}
function flow3(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole3 = /* @__PURE__ */ unsafeCoerce3(absurd3);
var SK3 = (_23, b23) => b23;
var make11 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_6 = (map322) => dual3(3, (self2, name2, f23) => map322(self2, (a23) => Object.assign({}, a23, {
  [name2]: f23(a23)
})));
var bindTo6 = (map322) => dual3(2, (self2, name2) => map322(self2, (a23) => ({
  [name2]: a23
})));
var bind6 = (map322, flatMap322) => dual3(3, (self2, name2, f23) => flatMap322(self2, (a23) => map322(f23(a23), (b23) => Object.assign({}, a23, {
  [name2]: b23
}))));
var moduleVersion3 = "3.2.8";
var getCurrentVersion3 = () => moduleVersion3;
var globalStoreId3 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion3()}`);
if (!(globalStoreId3 in globalThis)) {
  globalThis[globalStoreId3] = /* @__PURE__ */ new Map();
}
var globalStore3 = globalThis[globalStoreId3];
var globalValue3 = (id, compute) => {
  if (!globalStore3.has(id)) {
    globalStore3.set(id, compute());
  }
  return globalStore3.get(id);
};
var isFunction22 = isFunction6;
var isRecordOrArray3 = (input) => typeof input === "object" && input !== null;
var isObject3 = (input) => isRecordOrArray3(input) || isFunction22(input);
var hasProperty3 = /* @__PURE__ */ dual3(2, (self2, property) => isObject3(self2) && property in self2);
var isNullable3 = (input) => input === null || input === void 0;
var getBugErrorMessage3 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId3 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind3 = (u23) => isObject3(u23) && GenKindTypeId3 in u23;
var GenKindImpl3 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity3;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_23) => _23;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_23) => _23;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_23) => _23;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId3] = GenKindTypeId3;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen4(this);
  }
};
var SingleShotGen4 = class _SingleShotGen3 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a23) {
    return this.called ? {
      value: a23,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a23) {
    return {
      value: a23,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e23) {
    throw e23;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen3(this.self);
  }
};
var adapter5 = () => function() {
  let x23 = arguments[0];
  for (let i23 = 1; i23 < arguments.length; i23++) {
    x23 = arguments[i23](x23);
  }
  return new GenKindImpl3(x23);
};
var defaultIncHi3 = 335903614;
var defaultIncLo3 = 4150755663;
var MUL_HI3 = 1481765933 >>> 0;
var MUL_LO3 = 1284865837 >>> 0;
var BIT_533 = 9007199254740992;
var BIT_273 = 134217728;
var PCGRandom3 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable3(seedLo) && isNullable3(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable3(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable3(incLo) && isNullable3(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo3;
      incHi = this._state ? this._state[2] : defaultIncHi3;
    } else if (isNullable3(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add643(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max32) {
    if (!max32) {
      return this._next();
    }
    max32 = max32 >>> 0;
    if ((max32 & max32 - 1) === 0) {
      return this._next() & max32 - 1;
    }
    let num = 0;
    const skew = (-max32 >>> 0) % max32 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max32;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_273 + lo) / BIT_533;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul643(this._state, oldHi, oldLo, MUL_HI3, MUL_LO3);
    add643(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul643(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add643(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId3 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap3 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId3]() {
    return this.#value;
  }
};
function yieldWrapGet3(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId3 in self2) {
    return self2[YieldWrapTypeId3]();
  }
  throw new Error(getBugErrorMessage3("yieldWrapGet"));
}
var structuralRegionState3 = /* @__PURE__ */ globalValue3("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache3 = /* @__PURE__ */ globalValue3(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr3 = /* @__PURE__ */ globalValue3(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom3());
var symbol5 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash3 = (self2) => {
  if (structuralRegionState3.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number4(self2);
    case "bigint":
      return string3(self2.toString(10));
    case "boolean":
      return string3(String(self2));
    case "symbol":
      return string3(String(self2));
    case "string":
      return string3(self2);
    case "undefined":
      return string3("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string3("null");
      } else if (self2 instanceof Date) {
        return hash3(self2.toISOString());
      } else if (isHash3(self2)) {
        return self2[symbol5]();
      } else {
        return random3(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random3 = (self2) => {
  if (!randomHashCache3.has(self2)) {
    randomHashCache3.set(self2, number4(pcgr3.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache3.get(self2);
};
var combine4 = (b23) => (self2) => self2 * 53 ^ b23;
var optimize3 = (n23) => n23 & 3221225471 | n23 >>> 1 & 1073741824;
var isHash3 = (u23) => hasProperty3(u23, symbol5);
var number4 = (n23) => {
  if (n23 !== n23 || n23 === Infinity) {
    return 0;
  }
  let h23 = n23 | 0;
  if (h23 !== n23) {
    h23 ^= n23 * 4294967295;
  }
  while (n23 > 4294967295) {
    h23 ^= n23 /= 4294967295;
  }
  return optimize3(n23);
};
var string3 = (str) => {
  let h23 = 5381, i23 = str.length;
  while (i23) {
    h23 = h23 * 33 ^ str.charCodeAt(--i23);
  }
  return optimize3(h23);
};
var cached3 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash43) {
      Object.defineProperty(self3, symbol5, {
        value() {
          return hash43;
        },
        enumerable: false
      });
      return hash43;
    };
  }
  const self2 = arguments[0];
  const hash322 = arguments[1];
  Object.defineProperty(self2, symbol5, {
    value() {
      return hash322;
    },
    enumerable: false
  });
  return hash322;
};
var symbol22 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals3() {
  if (arguments.length === 1) {
    return (self2) => compareBoth3(self2, arguments[0]);
  }
  return compareBoth3(arguments[0], arguments[1]);
}
function compareBoth3(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual3(self2) && isEqual3(that)) {
        if (hash3(self2) === hash3(that) && self2[symbol22](that)) {
          return true;
        } else {
          return structuralRegionState3.enabled && structuralRegionState3.tester ? structuralRegionState3.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState3.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v23, i23) => compareBoth3(v23, that[i23]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth3(self2[key], that[key]))) {
              return structuralRegionState3.tester ? structuralRegionState3.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState3.tester ? structuralRegionState3.tester(self2, that) : false;
    }
  }
  return structuralRegionState3.enabled && structuralRegionState3.tester ? structuralRegionState3.tester(self2, that) : false;
}
var isEqual3 = (u23) => hasProperty3(u23, symbol22);
var equivalence3 = () => equals3;
var NodeInspectSymbol3 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON3 = (x23) => {
  if (hasProperty3(x23, "toJSON") && isFunction22(x23["toJSON"]) && x23["toJSON"].length === 0) {
    return x23.toJSON();
  } else if (Array.isArray(x23)) {
    return x23.map(toJSON3);
  }
  return x23;
};
var format3 = (x23) => JSON.stringify(x23, null, 2);
var pipeArguments3 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i23 = 0, len = args.length; i23 < len; i23++) {
        ret = args[i23](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId4 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId3 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId3 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId3 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance3 = {
  /* c8 ignore next */
  _R: (_23) => _23,
  /* c8 ignore next */
  _E: (_23) => _23,
  /* c8 ignore next */
  _A: (_23) => _23,
  _V: /* @__PURE__ */ getCurrentVersion3()
};
var sinkVariance3 = {
  /* c8 ignore next */
  _A: (_23) => _23,
  /* c8 ignore next */
  _In: (_23) => _23,
  /* c8 ignore next */
  _L: (_23) => _23,
  /* c8 ignore next */
  _E: (_23) => _23,
  /* c8 ignore next */
  _R: (_23) => _23
};
var channelVariance3 = {
  /* c8 ignore next */
  _Env: (_23) => _23,
  /* c8 ignore next */
  _InErr: (_23) => _23,
  /* c8 ignore next */
  _InElem: (_23) => _23,
  /* c8 ignore next */
  _InDone: (_23) => _23,
  /* c8 ignore next */
  _OutErr: (_23) => _23,
  /* c8 ignore next */
  _OutElem: (_23) => _23,
  /* c8 ignore next */
  _OutDone: (_23) => _23
};
var EffectPrototype3 = {
  [EffectTypeId4]: effectVariance3,
  [StreamTypeId3]: effectVariance3,
  [SinkTypeId3]: sinkVariance3,
  [ChannelTypeId3]: channelVariance3,
  [symbol22](that) {
    return this === that;
  },
  [symbol5]() {
    return cached3(this, random3(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen4(new YieldWrap3(this));
  },
  pipe() {
    return pipeArguments3(this, arguments);
  }
};
var TypeId9 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto5 = {
  ...EffectPrototype3,
  [TypeId9]: {
    _A: (_23) => _23
  },
  [NodeInspectSymbol3]() {
    return this.toJSON();
  },
  toString() {
    return format3(this.toJSON());
  }
};
var SomeProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto5), {
  _tag: "Some",
  _op: "Some",
  [symbol22](that) {
    return isOption5(that) && isSome5(that) && equals3(this.value, that.value);
  },
  [symbol5]() {
    return cached3(this, combine4(hash3(this._tag))(hash3(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON3(this.value)
    };
  }
});
var NoneHash3 = /* @__PURE__ */ hash3("None");
var NoneProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto5), {
  _tag: "None",
  _op: "None",
  [symbol22](that) {
    return isOption5(that) && isNone5(that);
  },
  [symbol5]() {
    return NoneHash3;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption5 = (input) => hasProperty3(input, TypeId9);
var isNone5 = (fa) => fa._tag === "None";
var isSome5 = (fa) => fa._tag === "Some";
var none5 = /* @__PURE__ */ Object.create(NoneProto3);
var some8 = (value) => {
  const a23 = Object.create(SomeProto3);
  a23.value = value;
  return a23;
};
var TypeId22 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto22 = {
  ...EffectPrototype3,
  [TypeId22]: {
    _R: (_23) => _23
  },
  [NodeInspectSymbol3]() {
    return this.toJSON();
  },
  toString() {
    return format3(this.toJSON());
  }
};
var RightProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto22), {
  _tag: "Right",
  _op: "Right",
  [symbol22](that) {
    return isEither3(that) && isRight4(that) && equals3(this.right, that.right);
  },
  [symbol5]() {
    return combine4(hash3(this._tag))(hash3(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON3(this.right)
    };
  }
});
var LeftProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto22), {
  _tag: "Left",
  _op: "Left",
  [symbol22](that) {
    return isEither3(that) && isLeft4(that) && equals3(this.left, that.left);
  },
  [symbol5]() {
    return combine4(hash3(this._tag))(hash3(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON3(this.left)
    };
  }
});
var isEither3 = (input) => hasProperty3(input, TypeId22);
var isLeft4 = (ma) => ma._tag === "Left";
var isRight4 = (ma) => ma._tag === "Right";
var left4 = (left323) => {
  const a23 = Object.create(LeftProto3);
  a23.left = left323;
  return a23;
};
var right4 = (right323) => {
  const a23 = Object.create(RightProto3);
  a23.right = right323;
  return a23;
};
var getLeft5 = (self2) => isRight4(self2) ? none5 : some8(self2.left);
var getRight5 = (self2) => isLeft4(self2) ? none5 : some8(self2.right);
var Option_exports3 = {};
__export3(Option_exports3, {
  Do: () => Do4,
  TypeId: () => TypeId32,
  all: () => all5,
  andThen: () => andThen3,
  ap: () => ap3,
  as: () => as3,
  asVoid: () => asVoid3,
  bind: () => bind22,
  bindTo: () => bindTo22,
  composeK: () => composeK3,
  contains: () => contains4,
  containsWith: () => containsWith4,
  exists: () => exists3,
  filter: () => filter4,
  filterMap: () => filterMap4,
  firstSomeOf: () => firstSomeOf3,
  flatMap: () => flatMap4,
  flatMapNullable: () => flatMapNullable4,
  flatten: () => flatten4,
  fromIterable: () => fromIterable5,
  fromNullable: () => fromNullable4,
  gen: () => gen3,
  getEquivalence: () => getEquivalence5,
  getLeft: () => getLeft22,
  getOrElse: () => getOrElse3,
  getOrNull: () => getOrNull3,
  getOrThrow: () => getOrThrow3,
  getOrThrowWith: () => getOrThrowWith3,
  getOrUndefined: () => getOrUndefined3,
  getOrder: () => getOrder4,
  getRight: () => getRight22,
  isNone: () => isNone22,
  isOption: () => isOption22,
  isSome: () => isSome22,
  let: () => let_22,
  lift2: () => lift23,
  liftNullable: () => liftNullable4,
  liftPredicate: () => liftPredicate4,
  liftThrowable: () => liftThrowable3,
  map: () => map4,
  match: () => match5,
  none: () => none22,
  orElse: () => orElse3,
  orElseEither: () => orElseEither3,
  orElseSome: () => orElseSome3,
  partitionMap: () => partitionMap4,
  product: () => product5,
  productMany: () => productMany5,
  reduceCompact: () => reduceCompact3,
  some: () => some22,
  tap: () => tap3,
  toArray: () => toArray3,
  toRefinement: () => toRefinement3,
  void: () => void_3,
  zipLeft: () => zipLeft3,
  zipRight: () => zipRight3,
  zipWith: () => zipWith4
});
var make22 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId32 = /* @__PURE__ */ Symbol.for("effect/Option");
var none22 = () => none5;
var some22 = some8;
var isOption22 = isOption5;
var isNone22 = isNone5;
var isSome22 = isSome5;
var match5 = /* @__PURE__ */ dual3(2, (self2, {
  onNone,
  onSome
}) => isNone22(self2) ? onNone() : onSome(self2.value));
var toRefinement3 = (f23) => (a23) => isSome22(f23(a23));
var fromIterable5 = (collection) => {
  for (const a23 of collection) {
    return some22(a23);
  }
  return none22();
};
var getRight22 = getRight5;
var getLeft22 = getLeft5;
var getOrElse3 = /* @__PURE__ */ dual3(2, (self2, onNone) => isNone22(self2) ? onNone() : self2.value);
var orElse3 = /* @__PURE__ */ dual3(2, (self2, that) => isNone22(self2) ? that() : self2);
var orElseSome3 = /* @__PURE__ */ dual3(2, (self2, onNone) => isNone22(self2) ? some22(onNone()) : self2);
var orElseEither3 = /* @__PURE__ */ dual3(2, (self2, that) => isNone22(self2) ? map4(that(), right4) : map4(self2, left4));
var firstSomeOf3 = (collection) => {
  let out = none22();
  for (out of collection) {
    if (isSome22(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable4 = (nullableValue) => nullableValue == null ? none22() : some22(nullableValue);
var liftNullable4 = (f23) => (...a23) => fromNullable4(f23(...a23));
var getOrNull3 = /* @__PURE__ */ getOrElse3(constNull3);
var getOrUndefined3 = /* @__PURE__ */ getOrElse3(constUndefined3);
var liftThrowable3 = (f23) => (...a23) => {
  try {
    return some22(f23(...a23));
  } catch (e23) {
    return none22();
  }
};
var getOrThrowWith3 = /* @__PURE__ */ dual3(2, (self2, onNone) => {
  if (isSome22(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow3 = /* @__PURE__ */ getOrThrowWith3(() => new Error("getOrThrow called on a None"));
var map4 = /* @__PURE__ */ dual3(2, (self2, f23) => isNone22(self2) ? none22() : some22(f23(self2.value)));
var as3 = /* @__PURE__ */ dual3(2, (self2, b23) => map4(self2, () => b23));
var asVoid3 = /* @__PURE__ */ as3(void 0);
var void_3 = /* @__PURE__ */ some22(void 0);
var flatMap4 = /* @__PURE__ */ dual3(2, (self2, f23) => isNone22(self2) ? none22() : f23(self2.value));
var andThen3 = /* @__PURE__ */ dual3(2, (self2, f23) => flatMap4(self2, (a23) => {
  const b23 = isFunction6(f23) ? f23(a23) : f23;
  return isOption22(b23) ? b23 : some22(b23);
}));
var flatMapNullable4 = /* @__PURE__ */ dual3(2, (self2, f23) => isNone22(self2) ? none22() : fromNullable4(f23(self2.value)));
var flatten4 = /* @__PURE__ */ flatMap4(identity3);
var zipRight3 = /* @__PURE__ */ dual3(2, (self2, that) => flatMap4(self2, () => that));
var composeK3 = /* @__PURE__ */ dual3(2, (afb, bfc) => (a23) => flatMap4(afb(a23), bfc));
var zipLeft3 = /* @__PURE__ */ dual3(2, (self2, that) => tap3(self2, () => that));
var tap3 = /* @__PURE__ */ dual3(2, (self2, f23) => flatMap4(self2, (a23) => map4(f23(a23), () => a23)));
var product5 = (self2, that) => isSome22(self2) && isSome22(that) ? some22([self2.value, that.value]) : none22();
var productMany5 = (self2, collection) => {
  if (isNone22(self2)) {
    return none22();
  }
  const out = [self2.value];
  for (const o23 of collection) {
    if (isNone22(o23)) {
      return none22();
    }
    out.push(o23.value);
  }
  return some22(out);
};
var all5 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o23 of input) {
      if (isNone22(o23)) {
        return none22();
      }
      out2.push(o23.value);
    }
    return some22(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o23 = input[key];
    if (isNone22(o23)) {
      return none22();
    }
    out[key] = o23.value;
  }
  return some22(out);
};
var zipWith4 = /* @__PURE__ */ dual3(3, (self2, that, f23) => map4(product5(self2, that), ([a23, b23]) => f23(a23, b23)));
var ap3 = /* @__PURE__ */ dual3(2, (self2, that) => zipWith4(self2, that, (f23, a23) => f23(a23)));
var reduceCompact3 = /* @__PURE__ */ dual3(3, (self2, b23, f23) => {
  let out = b23;
  for (const oa of self2) {
    if (isSome22(oa)) {
      out = f23(out, oa.value);
    }
  }
  return out;
});
var toArray3 = (self2) => isNone22(self2) ? [] : [self2.value];
var partitionMap4 = /* @__PURE__ */ dual3(2, (self2, f23) => {
  if (isNone22(self2)) {
    return [none22(), none22()];
  }
  const e23 = f23(self2.value);
  return isLeft4(e23) ? [some22(e23.left), none22()] : [none22(), some22(e23.right)];
});
var filterMap4 = /* @__PURE__ */ dual3(2, (self2, f23) => isNone22(self2) ? none22() : f23(self2.value));
var filter4 = /* @__PURE__ */ dual3(2, (self2, predicate) => filterMap4(self2, (b23) => predicate(b23) ? some8(b23) : none5));
var getEquivalence5 = (isEquivalent) => make11((x23, y23) => x23 === y23 || (isNone22(x23) ? isNone22(y23) : isNone22(y23) ? false : isEquivalent(x23.value, y23.value)));
var getOrder4 = (O23) => make22((self2, that) => isSome22(self2) ? isSome22(that) ? O23(self2.value, that.value) : 1 : -1);
var lift23 = (f23) => dual3(2, (self2, that) => zipWith4(self2, that, f23));
var liftPredicate4 = (predicate) => (b23) => predicate(b23) ? some22(b23) : none22();
var containsWith4 = (isEquivalent) => dual3(2, (self2, a23) => isNone22(self2) ? false : isEquivalent(self2.value, a23));
var _equivalence5 = /* @__PURE__ */ equivalence3();
var contains4 = /* @__PURE__ */ containsWith4(_equivalence5);
var exists3 = /* @__PURE__ */ dual3(2, (self2, refinement) => isNone22(self2) ? false : refinement(self2.value));
var bindTo22 = /* @__PURE__ */ bindTo6(map4);
var let_22 = /* @__PURE__ */ let_6(map4);
var bind22 = /* @__PURE__ */ bind6(map4, flatMap4);
var Do4 = /* @__PURE__ */ some22({});
var adapter22 = /* @__PURE__ */ adapter5();
var gen3 = (f23) => {
  const iterator = f23(adapter22);
  let state = iterator.next();
  if (state.done) {
    return some22(state.value);
  } else {
    let current = state.value;
    if (isGenKind3(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet3(current);
    }
    if (isNone22(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind3(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet3(current);
        }
        if (isNone22(current)) {
          return current;
        }
      }
    }
    return some22(state.value);
  }
};
var MutableRef_exports2 = {};
__export3(MutableRef_exports2, {
  compareAndSet: () => compareAndSet,
  decrement: () => decrement,
  decrementAndGet: () => decrementAndGet,
  get: () => get2,
  getAndDecrement: () => getAndDecrement,
  getAndIncrement: () => getAndIncrement,
  getAndSet: () => getAndSet,
  getAndUpdate: () => getAndUpdate,
  increment: () => increment,
  incrementAndGet: () => incrementAndGet,
  make: () => make32,
  set: () => set2,
  setAndGet: () => setAndGet,
  toggle: () => toggle,
  update: () => update,
  updateAndGet: () => updateAndGet
});
var TypeId42 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto = {
  [TypeId42]: TypeId42,
  toString() {
    return format3(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON3(this.current)
    };
  },
  [NodeInspectSymbol3]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments3(this, arguments);
  }
};
var make32 = (value) => {
  const ref = Object.create(MutableRefProto);
  ref.current = value;
  return ref;
};
var compareAndSet = /* @__PURE__ */ dual3(3, (self2, oldValue, newValue) => {
  if (equals3(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement = (self2) => update(self2, (n23) => n23 - 1);
var decrementAndGet = (self2) => updateAndGet(self2, (n23) => n23 - 1);
var get2 = (self2) => self2.current;
var getAndDecrement = (self2) => getAndUpdate(self2, (n23) => n23 - 1);
var getAndIncrement = (self2) => getAndUpdate(self2, (n23) => n23 + 1);
var getAndSet = /* @__PURE__ */ dual3(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate = /* @__PURE__ */ dual3(2, (self2, f23) => getAndSet(self2, f23(get2(self2))));
var increment = (self2) => update(self2, (n23) => n23 + 1);
var incrementAndGet = (self2) => updateAndGet(self2, (n23) => n23 + 1);
var set2 = /* @__PURE__ */ dual3(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet = /* @__PURE__ */ dual3(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update = /* @__PURE__ */ dual3(2, (self2, f23) => set2(self2, f23(get2(self2))));
var updateAndGet = /* @__PURE__ */ dual3(2, (self2, f23) => setAndGet(self2, f23(get2(self2))));
var toggle = (self2) => update(self2, (_23) => !_23);
function getVariables(initialScope) {
  const scopeRef = MutableRef_exports2.make(initialScope);
  const variablesRef = MutableRef_exports2.make(MutableRef_exports2.get(scopeRef).variables);
  while (MutableRef_exports2.get(scopeRef).type !== ScopeType.global) {
    MutableRef_exports2.set(scopeRef, MutableRef_exports2.get(scopeRef).upper);
    MutableRef_exports2.update(variablesRef, (variables) => variables.concat(MutableRef_exports2.get(scopeRef).variables));
  }
  return MutableRef_exports2.get(variablesRef).reverse();
}
var findVariable2 = Function_exports3.dual(2, (name2, initialScope) => {
  return Option_exports3.fromNullable(getVariables(initialScope).find((variable) => variable.name === name2));
});
var t2 = Symbol.for("@ts-pattern/matcher");
var e2 = Symbol.for("@ts-pattern/isVariadic");
var n2 = "@ts-pattern/anonymous-select-key";
var r2 = (t23) => Boolean(t23 && "object" == typeof t23);
var i2 = (e23) => e23 && !!e23[t2];
var o2 = (n23, s23, c23) => {
  if (i2(n23)) {
    const e23 = n23[t2](), { matched: r23, selections: i23 } = e23.match(s23);
    return r23 && i23 && Object.keys(i23).forEach((t23) => c23(t23, i23[t23])), r23;
  }
  if (r2(n23)) {
    if (!r2(s23)) return false;
    if (Array.isArray(n23)) {
      if (!Array.isArray(s23)) return false;
      let t23 = [], r23 = [], a23 = [];
      for (const o23 of n23.keys()) {
        const s32 = n23[o23];
        i2(s32) && s32[e2] ? a23.push(s32) : a23.length ? r23.push(s32) : t23.push(s32);
      }
      if (a23.length) {
        if (a23.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s23.length < t23.length + r23.length) return false;
        const e23 = s23.slice(0, t23.length), n32 = 0 === r23.length ? [] : s23.slice(-r23.length), i23 = s23.slice(t23.length, 0 === r23.length ? Infinity : -r23.length);
        return t23.every((t32, n42) => o2(t32, e23[n42], c23)) && r23.every((t32, e32) => o2(t32, n32[e32], c23)) && (0 === a23.length || o2(a23[0], i23, c23));
      }
      return n23.length === s23.length && n23.every((t32, e23) => o2(t32, s23[e23], c23));
    }
    return Object.keys(n23).every((e23) => {
      const r23 = n23[e23];
      return (e23 in s23 || i2(a23 = r23) && "optional" === a23[t2]().matcherType) && o2(r23, s23[e23], c23);
      var a23;
    });
  }
  return Object.is(s23, n23);
};
var s2 = (e23) => {
  var n23, o23, a23;
  return r2(e23) ? i2(e23) ? null != (n23 = null == (o23 = (a23 = e23[t2]()).getSelectionKeys) ? void 0 : o23.call(a23)) ? n23 : [] : Array.isArray(e23) ? c2(e23, s2) : c2(Object.values(e23), s2) : [];
};
var c2 = (t23, e23) => t23.reduce((t32, n23) => t32.concat(e23(n23)), []);
function a2(...t23) {
  if (1 === t23.length) {
    const [e23] = t23;
    return (t32) => o2(e23, t32, () => {
    });
  }
  if (2 === t23.length) {
    const [e23, n23] = t23;
    return o2(e23, n23, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t23.length}.`);
}
function u2(t23) {
  return Object.assign(t23, { optional: () => l2(t23), and: (e23) => m2(t23, e23), or: (e23) => d2(t23, e23), select: (e23) => void 0 === e23 ? p2(t23) : p2(e23, t23) });
}
function h2(t23) {
  return Object.assign(((t32) => Object.assign(t32, { [Symbol.iterator]() {
    let n23 = 0;
    const r23 = [{ value: Object.assign(t32, { [e2]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t42;
      return null != (t42 = r23[n23++]) ? t42 : r23.at(-1);
    } };
  } }))(t23), { optional: () => h2(l2(t23)), select: (e23) => h2(void 0 === e23 ? p2(t23) : p2(e23, t23)) });
}
function l2(e23) {
  return u2({ [t2]: () => ({ match: (t23) => {
    let n23 = {};
    const r23 = (t32, e32) => {
      n23[t32] = e32;
    };
    return void 0 === t23 ? (s2(e23).forEach((t32) => r23(t32, void 0)), { matched: true, selections: n23 }) : { matched: o2(e23, t23, r23), selections: n23 };
  }, getSelectionKeys: () => s2(e23), matcherType: "optional" }) });
}
var f2 = (t23, e23) => {
  for (const n23 of t23) if (!e23(n23)) return false;
  return true;
};
var g2 = (t23, e23) => {
  for (const [n23, r23] of t23.entries()) if (!e23(r23, n23)) return false;
  return true;
};
function m2(...e23) {
  return u2({ [t2]: () => ({ match: (t23) => {
    let n23 = {};
    const r23 = (t32, e32) => {
      n23[t32] = e32;
    };
    return { matched: e23.every((e32) => o2(e32, t23, r23)), selections: n23 };
  }, getSelectionKeys: () => c2(e23, s2), matcherType: "and" }) });
}
function d2(...e23) {
  return u2({ [t2]: () => ({ match: (t23) => {
    let n23 = {};
    const r23 = (t32, e32) => {
      n23[t32] = e32;
    };
    return c2(e23, s2).forEach((t32) => r23(t32, void 0)), { matched: e23.some((e32) => o2(e32, t23, r23)), selections: n23 };
  }, getSelectionKeys: () => c2(e23, s2), matcherType: "or" }) });
}
function y2(e23) {
  return { [t2]: () => ({ match: (t23) => ({ matched: Boolean(e23(t23)) }) }) };
}
function p2(...e23) {
  const r23 = "string" == typeof e23[0] ? e23[0] : void 0, i23 = 2 === e23.length ? e23[1] : "string" == typeof e23[0] ? void 0 : e23[0];
  return u2({ [t2]: () => ({ match: (t23) => {
    let e32 = { [null != r23 ? r23 : n2]: t23 };
    return { matched: void 0 === i23 || o2(i23, t23, (t32, n23) => {
      e32[t32] = n23;
    }), selections: e32 };
  }, getSelectionKeys: () => [null != r23 ? r23 : n2].concat(void 0 === i23 ? [] : s2(i23)) }) });
}
function v2(t23) {
  return "number" == typeof t23;
}
function b2(t23) {
  return "string" == typeof t23;
}
function w2(t23) {
  return "bigint" == typeof t23;
}
var S2 = u2(y2(function(t23) {
  return true;
}));
var O2 = S2;
var j2 = (t23) => Object.assign(u2(t23), { startsWith: (e23) => {
  return j2(m2(t23, (n23 = e23, y2((t32) => b2(t32) && t32.startsWith(n23)))));
  var n23;
}, endsWith: (e23) => {
  return j2(m2(t23, (n23 = e23, y2((t32) => b2(t32) && t32.endsWith(n23)))));
  var n23;
}, minLength: (e23) => j2(m2(t23, ((t32) => y2((e32) => b2(e32) && e32.length >= t32))(e23))), maxLength: (e23) => j2(m2(t23, ((t32) => y2((e32) => b2(e32) && e32.length <= t32))(e23))), includes: (e23) => {
  return j2(m2(t23, (n23 = e23, y2((t32) => b2(t32) && t32.includes(n23)))));
  var n23;
}, regex: (e23) => {
  return j2(m2(t23, (n23 = e23, y2((t32) => b2(t32) && Boolean(t32.match(n23))))));
  var n23;
} });
var E2 = j2(y2(b2));
var K2 = (t23) => Object.assign(u2(t23), { between: (e23, n23) => K2(m2(t23, ((t32, e32) => y2((n32) => v2(n32) && t32 <= n32 && e32 >= n32))(e23, n23))), lt: (e23) => K2(m2(t23, ((t32) => y2((e32) => v2(e32) && e32 < t32))(e23))), gt: (e23) => K2(m2(t23, ((t32) => y2((e32) => v2(e32) && e32 > t32))(e23))), lte: (e23) => K2(m2(t23, ((t32) => y2((e32) => v2(e32) && e32 <= t32))(e23))), gte: (e23) => K2(m2(t23, ((t32) => y2((e32) => v2(e32) && e32 >= t32))(e23))), int: () => K2(m2(t23, y2((t32) => v2(t32) && Number.isInteger(t32)))), finite: () => K2(m2(t23, y2((t32) => v2(t32) && Number.isFinite(t32)))), positive: () => K2(m2(t23, y2((t32) => v2(t32) && t32 > 0))), negative: () => K2(m2(t23, y2((t32) => v2(t32) && t32 < 0))) });
var x2 = K2(y2(v2));
var A2 = (t23) => Object.assign(u2(t23), { between: (e23, n23) => A2(m2(t23, ((t32, e32) => y2((n32) => w2(n32) && t32 <= n32 && e32 >= n32))(e23, n23))), lt: (e23) => A2(m2(t23, ((t32) => y2((e32) => w2(e32) && e32 < t32))(e23))), gt: (e23) => A2(m2(t23, ((t32) => y2((e32) => w2(e32) && e32 > t32))(e23))), lte: (e23) => A2(m2(t23, ((t32) => y2((e32) => w2(e32) && e32 <= t32))(e23))), gte: (e23) => A2(m2(t23, ((t32) => y2((e32) => w2(e32) && e32 >= t32))(e23))), positive: () => A2(m2(t23, y2((t32) => w2(t32) && t32 > 0))), negative: () => A2(m2(t23, y2((t32) => w2(t32) && t32 < 0))) });
var P2 = A2(y2(w2));
var T2 = u2(y2(function(t23) {
  return "boolean" == typeof t23;
}));
var k2 = u2(y2(function(t23) {
  return "symbol" == typeof t23;
}));
var B2 = u2(y2(function(t23) {
  return null == t23;
}));
var _2 = u2(y2(function(t23) {
  return null != t23;
}));
var N2 = { __proto__: null, matcher: t2, optional: l2, array: function(...e23) {
  return h2({ [t2]: () => ({ match: (t23) => {
    if (!Array.isArray(t23)) return { matched: false };
    if (0 === e23.length) return { matched: true };
    const n23 = e23[0];
    let r23 = {};
    if (0 === t23.length) return s2(n23).forEach((t32) => {
      r23[t32] = [];
    }), { matched: true, selections: r23 };
    const i23 = (t32, e32) => {
      r23[t32] = (r23[t32] || []).concat([e32]);
    };
    return { matched: t23.every((t32) => o2(n23, t32, i23)), selections: r23 };
  }, getSelectionKeys: () => 0 === e23.length ? [] : s2(e23[0]) }) });
}, set: function(...e23) {
  return u2({ [t2]: () => ({ match: (t23) => {
    if (!(t23 instanceof Set)) return { matched: false };
    let n23 = {};
    if (0 === t23.size) return { matched: true, selections: n23 };
    if (0 === e23.length) return { matched: true };
    const r23 = (t32, e32) => {
      n23[t32] = (n23[t32] || []).concat([e32]);
    }, i23 = e23[0];
    return { matched: f2(t23, (t32) => o2(i23, t32, r23)), selections: n23 };
  }, getSelectionKeys: () => 0 === e23.length ? [] : s2(e23[0]) }) });
}, map: function(...e23) {
  return u2({ [t2]: () => ({ match: (t23) => {
    if (!(t23 instanceof Map)) return { matched: false };
    let n23 = {};
    if (0 === t23.size) return { matched: true, selections: n23 };
    const r23 = (t32, e32) => {
      n23[t32] = (n23[t32] || []).concat([e32]);
    };
    if (0 === e23.length) return { matched: true };
    var i23;
    if (1 === e23.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i23 = e23[0]) ? void 0 : i23.toString()}`);
    const [s23, c23] = e23;
    return { matched: g2(t23, (t32, e32) => {
      const n32 = o2(s23, e32, r23), i32 = o2(c23, t32, r23);
      return n32 && i32;
    }), selections: n23 };
  }, getSelectionKeys: () => 0 === e23.length ? [] : [...s2(e23[0]), ...s2(e23[1])] }) });
}, intersection: m2, union: d2, not: function(e23) {
  return u2({ [t2]: () => ({ match: (t23) => ({ matched: !o2(e23, t23, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y2, select: p2, any: S2, _: O2, string: E2, number: x2, bigint: P2, boolean: T2, symbol: k2, nullish: B2, nonNullable: _2, instanceOf: function(t23) {
  return u2(y2(/* @__PURE__ */ function(t32) {
    return (e23) => e23 instanceof t32;
  }(t23)));
}, shape: function(t23) {
  return u2(y2(a2(t23)));
} };
var KEYS2 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES2 = Object.keys(KEYS2);
for (const type of NODE_TYPES2) {
  Object.freeze(KEYS2[type]);
}
Object.freeze(KEYS2);
var visitor_keys_default2 = KEYS2;
var KEY_BLACKLIST2 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey2(key) {
  return !KEY_BLACKLIST2.has(key) && key[0] !== "_";
}
function getKeys2(node) {
  return Object.keys(node).filter(filterKey2);
}
function getInnermostScope2(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range22 = childScope.block.range;
      if (range22[0] <= location && location < range22[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable22(initialScope, nameOrNode) {
  let name2 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name2 = nameOrNode;
  } else {
    name2 = nameOrNode.name;
    scope = getInnermostScope2(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name2);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate02(token) {
  return !this(token);
}
function negate2(f23) {
  return negate02.bind(f23);
}
function isPunctuatorTokenWithValue2(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken2(token) {
  return isPunctuatorTokenWithValue2(token, "=>");
}
function isCommaToken2(token) {
  return isPunctuatorTokenWithValue2(token, ",");
}
function isSemicolonToken2(token) {
  return isPunctuatorTokenWithValue2(token, ";");
}
function isColonToken2(token) {
  return isPunctuatorTokenWithValue2(token, ":");
}
function isOpeningParenToken2(token) {
  return isPunctuatorTokenWithValue2(token, "(");
}
function isClosingParenToken2(token) {
  return isPunctuatorTokenWithValue2(token, ")");
}
function isOpeningBracketToken2(token) {
  return isPunctuatorTokenWithValue2(token, "[");
}
function isClosingBracketToken2(token) {
  return isPunctuatorTokenWithValue2(token, "]");
}
function isOpeningBraceToken2(token) {
  return isPunctuatorTokenWithValue2(token, "{");
}
function isClosingBraceToken2(token) {
  return isPunctuatorTokenWithValue2(token, "}");
}
function isCommentToken2(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate2(isArrowToken2);
negate2(isCommaToken2);
negate2(isSemicolonToken2);
negate2(isColonToken2);
negate2(isOpeningParenToken2);
negate2(isClosingParenToken2);
negate2(isOpeningBracketToken2);
negate2(isClosingBracketToken2);
negate2(isOpeningBraceToken2);
negate2(isClosingBraceToken2);
negate2(isCommentToken2);
function getOpeningParenOfParams2(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken2) : sourceCode.getFirstToken(node, isOpeningParenToken2);
}
function getFunctionHeadLocation2(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken2);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams2(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams2(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject2 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames2 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed2 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k23) => k23 !== "random").map((k23) => Math[k23]).filter((f23) => typeof f23 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f23) => typeof f23 === "function")
);
var callPassThrough2 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed2 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor2(object3, name2) {
  let x23 = object3;
  while ((typeof x23 === "object" || typeof x23 === "function") && x23 !== null) {
    const d23 = Object.getOwnPropertyDescriptor(x23, name2);
    if (d23) {
      return d23;
    }
    x23 = Object.getPrototypeOf(x23);
  }
  return null;
}
function isGetter2(object3, name2) {
  const d23 = getPropertyDescriptor2(object3, name2);
  return d23 != null && d23.get != null;
}
function getElementValues2(nodeList, initialScope) {
  const valueList = [];
  for (let i23 = 0; i23 < nodeList.length; ++i23) {
    const elementNode = nodeList[i23];
    if (elementNode == null) {
      valueList.length = i23 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR2(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR2(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst2(variable) {
  const refs = variable.references;
  const inits = refs.filter((r23) => r23.init).length;
  const reads = refs.filter((r23) => r23.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations2 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues2(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR2(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left323 = getStaticValueR2(node.left, initialScope);
    const right323 = getStaticValueR2(node.right, initialScope);
    if (left323 != null && right323 != null) {
      switch (node.operator) {
        case "==":
          return { value: left323.value == right323.value };
        case "!=":
          return { value: left323.value != right323.value };
        case "===":
          return { value: left323.value === right323.value };
        case "!==":
          return { value: left323.value !== right323.value };
        case "<":
          return { value: left323.value < right323.value };
        case "<=":
          return { value: left323.value <= right323.value };
        case ">":
          return { value: left323.value > right323.value };
        case ">=":
          return { value: left323.value >= right323.value };
        case "<<":
          return { value: left323.value << right323.value };
        case ">>":
          return { value: left323.value >> right323.value };
        case ">>>":
          return { value: left323.value >>> right323.value };
        case "+":
          return { value: left323.value + right323.value };
        case "-":
          return { value: left323.value - right323.value };
        case "*":
          return { value: left323.value * right323.value };
        case "/":
          return { value: left323.value / right323.value };
        case "%":
          return { value: left323.value % right323.value };
        case "**":
          return { value: left323.value ** right323.value };
        case "|":
          return { value: left323.value | right323.value };
        case "^":
          return { value: left323.value ^ right323.value };
        case "&":
          return { value: left323.value & right323.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues2(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object3 = getStaticValueR2(calleeNode.object, initialScope);
        if (object3 != null) {
          if (object3.value == null && (object3.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue2(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object3.value;
            const methodName = property.value;
            if (callAllowed2.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough2.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR2(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed2.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough2.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR2(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR2(node.consequent, initialScope) : getStaticValueR2(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR2(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable22(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames2.has(variable.name) && variable.name in globalObject2) {
        return { value: globalObject2[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst2(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR2(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left323 = getStaticValueR2(node.left, initialScope);
    if (left323 != null) {
      if (node.operator === "||" && Boolean(left323.value) === true || node.operator === "&&" && Boolean(left323.value) === false || node.operator === "??" && left323.value != null) {
        return left323;
      }
      const right323 = getStaticValueR2(node.right, initialScope);
      if (right323 != null) {
        return right323;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object3 = getStaticValueR2(node.object, initialScope);
    if (object3 != null) {
      if (object3.value == null && (object3.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue2(node, initialScope);
      if (property != null) {
        if (!isGetter2(object3.value, property.value)) {
          return { value: object3.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed2) {
          if (object3.value instanceof classFn && allowed.has(property.value)) {
            return { value: object3.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR2(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR2(node.callee, initialScope);
    const args = getElementValues2(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed2.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object3 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue2(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR2(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object3[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR2(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object3, argument.value);
      } else {
        return null;
      }
    }
    return { value: object3 };
  },
  SequenceExpression(node, initialScope) {
    const last22 = node.expressions[node.expressions.length - 1];
    return getStaticValueR2(last22, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR2(node.tag, initialScope);
    const expressions = getElementValues2(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues2(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i23 = 0; i23 < expressions.length; ++i23) {
        value += expressions[i23];
        value += node.quasis[i23 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR2(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR2(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations2, node.type)) {
    return operations2[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue2(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR2(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue2(node, initialScope = null) {
  try {
    return getStaticValueR2(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant2(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue2(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName2(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant2(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant2(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind2(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name2 = getPropertyName2(parent);
      if (name2) {
        tokens.push(`'${name2}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps2 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps2 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode2(x23) {
  return x23 !== null && typeof x23 === "object" && typeof x23.type === "string";
}
var visitor2 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys2(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode2(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode2(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps2.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps2.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect2(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor2.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default2
  );
}
function getParentSyntaxParen2(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken2
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken2
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized2(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken2(maybeLeftParen) && isClosingParenToken2(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen2(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp222 = Object.defineProperty;
var __export222 = (target, all323) => {
  for (var name2 in all323)
    __defProp222(target, name2, { get: all323[name2], enumerable: true });
};
var NodeType2 = AST_NODE_TYPES;
var is2 = ASTUtils.isNodeOfType;
var isOneOf2 = ASTUtils.isNodeOfTypes;
isOneOf2([
  NodeType2.ArrowFunctionExpression,
  NodeType2.FunctionDeclaration,
  NodeType2.FunctionExpression
]);
isOneOf2([
  NodeType2.ArrowFunctionExpression,
  NodeType2.FunctionDeclaration,
  NodeType2.FunctionExpression,
  NodeType2.TSCallSignatureDeclaration,
  NodeType2.TSConstructSignatureDeclaration,
  NodeType2.TSDeclareFunction,
  NodeType2.TSEmptyBodyFunctionExpression,
  NodeType2.TSFunctionType,
  NodeType2.TSMethodSignature
]);
isOneOf2([NodeType2.ClassDeclaration, NodeType2.ClassExpression]);
isOneOf2([
  NodeType2.DoWhileStatement,
  NodeType2.ForInStatement,
  NodeType2.ForOfStatement,
  NodeType2.ForStatement,
  NodeType2.WhileStatement
]);
isOneOf2([NodeType2.TSArrayType, NodeType2.TSTupleType]);
isOneOf2([
  NodeType2.PropertyDefinition,
  NodeType2.TSIndexSignature,
  NodeType2.TSParameterProperty,
  NodeType2.TSPropertySignature
]);
is2(NodeType2.JSXElement);
is2(NodeType2.JSXFragment);
isOneOf2([
  NodeType2.JSXAttribute,
  NodeType2.JSXSpreadChild,
  NodeType2.JSXClosingElement,
  NodeType2.JSXClosingFragment,
  NodeType2.JSXElement,
  NodeType2.JSXEmptyExpression,
  NodeType2.JSXExpressionContainer,
  NodeType2.JSXFragment,
  NodeType2.JSXIdentifier,
  NodeType2.JSXMemberExpression,
  NodeType2.JSXNamespacedName,
  NodeType2.JSXOpeningElement,
  NodeType2.JSXOpeningFragment,
  NodeType2.JSXSpreadAttribute,
  NodeType2.JSXSpreadChild,
  NodeType2.JSXText
]);
isOneOf2([
  NodeType2.JSXIdentifier,
  NodeType2.JSXMemberExpression,
  NodeType2.JSXNamespacedName
]);
isOneOf2([
  NodeType2.ArrayPattern,
  NodeType2.AssignmentPattern,
  NodeType2.ObjectPattern,
  NodeType2.RestElement
]);
isOneOf2([
  NodeType2.TSInterfaceDeclaration,
  NodeType2.TSTypeAliasDeclaration
]);
isOneOf2([
  NodeType2.ArrayExpression,
  NodeType2.ArrayPattern,
  NodeType2.ArrowFunctionExpression,
  NodeType2.CallExpression,
  NodeType2.ClassExpression,
  NodeType2.FunctionExpression,
  NodeType2.Identifier,
  NodeType2.JSXElement,
  NodeType2.JSXFragment,
  NodeType2.Literal,
  NodeType2.TemplateLiteral,
  NodeType2.MemberExpression,
  NodeType2.MetaProperty,
  NodeType2.ObjectExpression,
  NodeType2.ObjectPattern,
  NodeType2.SequenceExpression,
  NodeType2.Super,
  NodeType2.TaggedTemplateExpression,
  NodeType2.ThisExpression
]);
isOneOf2([
  NodeType2.ArrayExpression,
  NodeType2.ArrayPattern,
  NodeType2.ArrowFunctionExpression,
  NodeType2.CallExpression,
  NodeType2.ClassExpression,
  NodeType2.FunctionExpression,
  NodeType2.Identifier,
  NodeType2.JSXElement,
  NodeType2.JSXFragment,
  NodeType2.Literal,
  NodeType2.TemplateLiteral,
  NodeType2.MemberExpression,
  NodeType2.MetaProperty,
  NodeType2.ObjectExpression,
  NodeType2.ObjectPattern,
  NodeType2.SequenceExpression,
  NodeType2.Super,
  NodeType2.TaggedTemplateExpression,
  NodeType2.ThisExpression,
  NodeType2.TSAsExpression,
  NodeType2.TSNonNullExpression,
  NodeType2.TSTypeAssertion
]);
var Function_exports22 = {};
__export222(Function_exports22, {
  SK: () => SK22,
  absurd: () => absurd22,
  apply: () => apply22,
  compose: () => compose22,
  constFalse: () => constFalse22,
  constNull: () => constNull22,
  constTrue: () => constTrue22,
  constUndefined: () => constUndefined22,
  constVoid: () => constVoid22,
  constant: () => constant22,
  dual: () => dual22,
  flip: () => flip22,
  flow: () => flow22,
  hole: () => hole22,
  identity: () => identity22,
  isFunction: () => isFunction222,
  pipe: () => pipe22,
  satisfies: () => satisfies22,
  tupled: () => tupled22,
  unsafeCoerce: () => unsafeCoerce22,
  untupled: () => untupled22
});
var isFunction222 = (input) => typeof input === "function";
var dual22 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a23, b23) {
        if (arguments.length >= 2) {
          return body(a23, b23);
        }
        return function(self2) {
          return body(self2, a23);
        };
      };
    case 3:
      return function(a23, b23, c23) {
        if (arguments.length >= 3) {
          return body(a23, b23, c23);
        }
        return function(self2) {
          return body(self2, a23, b23);
        };
      };
    case 4:
      return function(a23, b23, c23, d23) {
        if (arguments.length >= 4) {
          return body(a23, b23, c23, d23);
        }
        return function(self2) {
          return body(self2, a23, b23, c23);
        };
      };
    case 5:
      return function(a23, b23, c23, d23, e23) {
        if (arguments.length >= 5) {
          return body(a23, b23, c23, d23, e23);
        }
        return function(self2) {
          return body(self2, a23, b23, c23, d23);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply22 = (a23) => (self2) => self2(a23);
var identity22 = (a23) => a23;
var satisfies22 = () => (b23) => b23;
var unsafeCoerce22 = identity22;
var constant22 = (value) => () => value;
var constTrue22 = /* @__PURE__ */ constant22(true);
var constFalse22 = /* @__PURE__ */ constant22(false);
var constNull22 = /* @__PURE__ */ constant22(null);
var constUndefined22 = /* @__PURE__ */ constant22(void 0);
var constVoid22 = constUndefined22;
var flip22 = (f23) => (...b23) => (...a23) => f23(...a23)(...b23);
var compose22 = /* @__PURE__ */ dual22(2, (ab, bc) => (a23) => bc(ab(a23)));
var absurd22 = (_23) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled22 = (f23) => (a23) => f23(...a23);
var untupled22 = (f23) => (...a23) => f23(a23);
function pipe22(a23, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a23;
    case 2:
      return ab(a23);
    case 3:
      return bc(ab(a23));
    case 4:
      return cd(bc(ab(a23)));
    case 5:
      return de(cd(bc(ab(a23))));
    case 6:
      return ef(de(cd(bc(ab(a23)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a23))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a23)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a23))))))));
    default: {
      let ret = arguments[0];
      for (let i23 = 1; i23 < arguments.length; i23++) {
        ret = arguments[i23](ret);
      }
      return ret;
    }
  }
}
function flow22(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole22 = /* @__PURE__ */ unsafeCoerce22(absurd22);
var SK22 = (_23, b23) => b23;
var make42 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_32 = (map63) => dual22(3, (self2, name2, f23) => map63(self2, (a23) => Object.assign({}, a23, {
  [name2]: f23(a23)
})));
var bindTo32 = (map63) => dual22(2, (self2, name2) => map63(self2, (a23) => ({
  [name2]: a23
})));
var bind32 = (map63, flatMap422) => dual22(3, (self2, name2, f23) => flatMap422(self2, (a23) => map63(f23(a23), (b23) => Object.assign({}, a23, {
  [name2]: b23
}))));
var moduleVersion22 = "3.2.8";
var getCurrentVersion22 = () => moduleVersion22;
var globalStoreId22 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion22()}`);
if (!(globalStoreId22 in globalThis)) {
  globalThis[globalStoreId22] = /* @__PURE__ */ new Map();
}
var globalStore22 = globalThis[globalStoreId22];
var globalValue22 = (id, compute) => {
  if (!globalStore22.has(id)) {
    globalStore22.set(id, compute());
  }
  return globalStore22.get(id);
};
var Predicate_exports22 = {};
__export222(Predicate_exports22, {
  all: () => all22,
  and: () => and3,
  compose: () => compose222,
  eqv: () => eqv3,
  every: () => every4,
  hasProperty: () => hasProperty22,
  implies: () => implies3,
  isBigInt: () => isBigInt3,
  isBoolean: () => isBoolean3,
  isDate: () => isDate3,
  isError: () => isError3,
  isFunction: () => isFunction32,
  isIterable: () => isIterable3,
  isMap: () => isMap3,
  isNever: () => isNever3,
  isNotNull: () => isNotNull3,
  isNotNullable: () => isNotNullable3,
  isNotUndefined: () => isNotUndefined3,
  isNull: () => isNull3,
  isNullable: () => isNullable22,
  isNumber: () => isNumber3,
  isObject: () => isObject22,
  isPromise: () => isPromise3,
  isPromiseLike: () => isPromiseLike3,
  isReadonlyRecord: () => isReadonlyRecord3,
  isRecord: () => isRecord3,
  isSet: () => isSet3,
  isString: () => isString3,
  isSymbol: () => isSymbol3,
  isTagged: () => isTagged3,
  isTruthy: () => isTruthy3,
  isUint8Array: () => isUint8Array3,
  isUndefined: () => isUndefined3,
  isUnknown: () => isUnknown3,
  mapInput: () => mapInput4,
  nand: () => nand3,
  nor: () => nor3,
  not: () => not3,
  or: () => or3,
  product: () => product22,
  productMany: () => productMany22,
  some: () => some32,
  struct: () => struct5,
  tuple: () => tuple4,
  xor: () => xor3
});
var mapInput4 = /* @__PURE__ */ dual22(2, (self2, f23) => (b23) => self2(f23(b23)));
var isTruthy3 = (input) => !!input;
var isSet3 = (input) => input instanceof Set;
var isMap3 = (input) => input instanceof Map;
var isString3 = (input) => typeof input === "string";
var isNumber3 = (input) => typeof input === "number";
var isBoolean3 = (input) => typeof input === "boolean";
var isBigInt3 = (input) => typeof input === "bigint";
var isSymbol3 = (input) => typeof input === "symbol";
var isFunction32 = isFunction222;
var isUndefined3 = (input) => input === void 0;
var isNotUndefined3 = (input) => input !== void 0;
var isNull3 = (input) => input === null;
var isNotNull3 = (input) => input !== null;
var isNever3 = (_23) => false;
var isUnknown3 = (_23) => true;
var isRecordOrArray22 = (input) => typeof input === "object" && input !== null;
var isObject22 = (input) => isRecordOrArray22(input) || isFunction32(input);
var hasProperty22 = /* @__PURE__ */ dual22(2, (self2, property) => isObject22(self2) && property in self2);
var isTagged3 = /* @__PURE__ */ dual22(2, (self2, tag) => hasProperty22(self2, "_tag") && self2["_tag"] === tag);
var isNullable22 = (input) => input === null || input === void 0;
var isNotNullable3 = (input) => input !== null && input !== void 0;
var isError3 = (input) => input instanceof Error;
var isUint8Array3 = (input) => input instanceof Uint8Array;
var isDate3 = (input) => input instanceof Date;
var isIterable3 = (input) => hasProperty22(input, Symbol.iterator);
var isRecord3 = (input) => isRecordOrArray22(input) && !Array.isArray(input);
var isReadonlyRecord3 = isRecord3;
var isPromise3 = (input) => hasProperty22(input, "then") && "catch" in input && isFunction32(input.then) && isFunction32(input.catch);
var isPromiseLike3 = (input) => hasProperty22(input, "then") && isFunction32(input.then);
var compose222 = /* @__PURE__ */ dual22(2, (ab, bc) => (a23) => ab(a23) && bc(a23));
var product22 = (self2, that) => ([a23, b23]) => self2(a23) && that(b23);
var all22 = (collection) => {
  return (as2223) => {
    let collectionIndex = 0;
    for (const p23 of collection) {
      if (collectionIndex >= as2223.length) {
        break;
      }
      if (p23(as2223[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany22 = (self2, collection) => {
  const rest = all22(collection);
  return ([head23, ...tail23]) => self2(head23) === false ? false : rest(tail23);
};
var tuple4 = (...elements) => all22(elements);
var struct5 = (fields) => {
  const keys223 = Object.keys(fields);
  return (a23) => {
    for (const key of keys223) {
      if (!fields[key](a23[key])) {
        return false;
      }
    }
    return true;
  };
};
var not3 = (self2) => (a23) => !self2(a23);
var or3 = /* @__PURE__ */ dual22(2, (self2, that) => (a23) => self2(a23) || that(a23));
var and3 = /* @__PURE__ */ dual22(2, (self2, that) => (a23) => self2(a23) && that(a23));
var xor3 = /* @__PURE__ */ dual22(2, (self2, that) => (a23) => self2(a23) !== that(a23));
var eqv3 = /* @__PURE__ */ dual22(2, (self2, that) => (a23) => self2(a23) === that(a23));
var implies3 = /* @__PURE__ */ dual22(2, (self2, that) => (a23) => self2(a23) ? that(a23) : true);
var nor3 = /* @__PURE__ */ dual22(2, (self2, that) => (a23) => !(self2(a23) || that(a23)));
var nand3 = /* @__PURE__ */ dual22(2, (self2, that) => (a23) => !(self2(a23) && that(a23)));
var every4 = (collection) => (a23) => {
  for (const p23 of collection) {
    if (!p23(a23)) {
      return false;
    }
  }
  return true;
};
var some32 = (collection) => (a23) => {
  for (const p23 of collection) {
    if (p23(a23)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage22 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId22 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind22 = (u23) => isObject22(u23) && GenKindTypeId22 in u23;
var GenKindImpl22 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity22;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_23) => _23;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_23) => _23;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_23) => _23;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId22] = GenKindTypeId22;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen22(this);
  }
};
var SingleShotGen22 = class _SingleShotGen4 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a23) {
    return this.called ? {
      value: a23,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a23) {
    return {
      value: a23,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e23) {
    throw e23;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen4(this.self);
  }
};
var adapter32 = () => function() {
  let x23 = arguments[0];
  for (let i23 = 1; i23 < arguments.length; i23++) {
    x23 = arguments[i23](x23);
  }
  return new GenKindImpl22(x23);
};
var defaultIncHi22 = 335903614;
var defaultIncLo22 = 4150755663;
var MUL_HI22 = 1481765933 >>> 0;
var MUL_LO22 = 1284865837 >>> 0;
var BIT_5322 = 9007199254740992;
var BIT_2722 = 134217728;
var PCGRandom22 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable22(seedLo) && isNullable22(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable22(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable22(incLo) && isNullable22(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo22;
      incHi = this._state ? this._state[2] : defaultIncHi22;
    } else if (isNullable22(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6422(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max32) {
    if (!max32) {
      return this._next();
    }
    max32 = max32 >>> 0;
    if ((max32 & max32 - 1) === 0) {
      return this._next() & max32 - 1;
    }
    let num = 0;
    const skew = (-max32 >>> 0) % max32 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max32;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2722 + lo) / BIT_5322;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6422(this._state, oldHi, oldLo, MUL_HI22, MUL_LO22);
    add6422(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6422(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6422(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId22 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap22 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId22]() {
    return this.#value;
  }
};
function yieldWrapGet22(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId22 in self2) {
    return self2[YieldWrapTypeId22]();
  }
  throw new Error(getBugErrorMessage22("yieldWrapGet"));
}
var structuralRegionState22 = /* @__PURE__ */ globalValue22("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache22 = /* @__PURE__ */ globalValue22(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr22 = /* @__PURE__ */ globalValue22(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom22());
var symbol32 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash22 = (self2) => {
  if (structuralRegionState22.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number22(self2);
    case "bigint":
      return string22(self2.toString(10));
    case "boolean":
      return string22(String(self2));
    case "symbol":
      return string22(String(self2));
    case "string":
      return string22(self2);
    case "undefined":
      return string22("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string22("null");
      } else if (self2 instanceof Date) {
        return hash22(self2.toISOString());
      } else if (isHash22(self2)) {
        return self2[symbol32]();
      } else {
        return random22(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random22 = (self2) => {
  if (!randomHashCache22.has(self2)) {
    randomHashCache22.set(self2, number22(pcgr22.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache22.get(self2);
};
var combine22 = (b23) => (self2) => self2 * 53 ^ b23;
var optimize22 = (n23) => n23 & 3221225471 | n23 >>> 1 & 1073741824;
var isHash22 = (u23) => hasProperty22(u23, symbol32);
var number22 = (n23) => {
  if (n23 !== n23 || n23 === Infinity) {
    return 0;
  }
  let h23 = n23 | 0;
  if (h23 !== n23) {
    h23 ^= n23 * 4294967295;
  }
  while (n23 > 4294967295) {
    h23 ^= n23 /= 4294967295;
  }
  return optimize22(n23);
};
var string22 = (str) => {
  let h23 = 5381, i23 = str.length;
  while (i23) {
    h23 = h23 * 33 ^ str.charCodeAt(--i23);
  }
  return optimize22(h23);
};
var structureKeys22 = (o23, keys223) => {
  let h23 = 12289;
  for (let i23 = 0; i23 < keys223.length; i23++) {
    h23 ^= pipe22(string22(keys223[i23]), combine22(hash22(o23[keys223[i23]])));
  }
  return optimize22(h23);
};
var structure22 = (o23) => structureKeys22(o23, Object.keys(o23));
var array5 = (arr) => {
  let h23 = 6151;
  for (let i23 = 0; i23 < arr.length; i23++) {
    h23 = pipe22(h23, combine22(hash22(arr[i23])));
  }
  return optimize22(h23);
};
var cached22 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash322) {
      Object.defineProperty(self22, symbol32, {
        value() {
          return hash322;
        },
        enumerable: false
      });
      return hash322;
    };
  }
  const self2 = arguments[0];
  const hash2223 = arguments[1];
  Object.defineProperty(self2, symbol32, {
    value() {
      return hash2223;
    },
    enumerable: false
  });
  return hash2223;
};
var symbol222 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals22() {
  if (arguments.length === 1) {
    return (self2) => compareBoth22(self2, arguments[0]);
  }
  return compareBoth22(arguments[0], arguments[1]);
}
function compareBoth22(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual22(self2) && isEqual22(that)) {
        if (hash22(self2) === hash22(that) && self2[symbol222](that)) {
          return true;
        } else {
          return structuralRegionState22.enabled && structuralRegionState22.tester ? structuralRegionState22.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState22.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v23, i23) => compareBoth22(v23, that[i23]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth22(self2[key], that[key]))) {
              return structuralRegionState22.tester ? structuralRegionState22.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState22.tester ? structuralRegionState22.tester(self2, that) : false;
    }
  }
  return structuralRegionState22.enabled && structuralRegionState22.tester ? structuralRegionState22.tester(self2, that) : false;
}
var isEqual22 = (u23) => hasProperty22(u23, symbol222);
var equivalence22 = () => equals22;
var NodeInspectSymbol22 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON22 = (x23) => {
  if (hasProperty22(x23, "toJSON") && isFunction32(x23["toJSON"]) && x23["toJSON"].length === 0) {
    return x23.toJSON();
  } else if (Array.isArray(x23)) {
    return x23.map(toJSON22);
  }
  return x23;
};
var format22 = (x23) => JSON.stringify(x23, null, 2);
var pipeArguments22 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i23 = 0, len = args.length; i23 < len; i23++) {
        ret = args[i23](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT22 = "Commit";
var OP_FAILURE2 = "Failure";
var OP_WITH_RUNTIME2 = "WithRuntime";
var EffectTypeId22 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId22 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId22 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId22 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance22 = {
  /* c8 ignore next */
  _R: (_23) => _23,
  /* c8 ignore next */
  _E: (_23) => _23,
  /* c8 ignore next */
  _A: (_23) => _23,
  _V: /* @__PURE__ */ getCurrentVersion22()
};
var sinkVariance22 = {
  /* c8 ignore next */
  _A: (_23) => _23,
  /* c8 ignore next */
  _In: (_23) => _23,
  /* c8 ignore next */
  _L: (_23) => _23,
  /* c8 ignore next */
  _E: (_23) => _23,
  /* c8 ignore next */
  _R: (_23) => _23
};
var channelVariance22 = {
  /* c8 ignore next */
  _Env: (_23) => _23,
  /* c8 ignore next */
  _InErr: (_23) => _23,
  /* c8 ignore next */
  _InElem: (_23) => _23,
  /* c8 ignore next */
  _InDone: (_23) => _23,
  /* c8 ignore next */
  _OutErr: (_23) => _23,
  /* c8 ignore next */
  _OutElem: (_23) => _23,
  /* c8 ignore next */
  _OutDone: (_23) => _23
};
var EffectPrototype22 = {
  [EffectTypeId22]: effectVariance22,
  [StreamTypeId22]: effectVariance22,
  [SinkTypeId22]: sinkVariance22,
  [ChannelTypeId22]: channelVariance22,
  [symbol222](that) {
    return this === that;
  },
  [symbol32]() {
    return cached22(this, random22(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen22(new YieldWrap22(this));
  },
  pipe() {
    return pipeArguments22(this, arguments);
  }
};
var StructuralPrototype22 = {
  [symbol32]() {
    return cached22(this, structure22(this));
  },
  [symbol222](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals22(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype22 = {
  ...EffectPrototype22,
  _op: OP_COMMIT22
};
var StructuralCommitPrototype22 = {
  ...CommitPrototype22,
  ...StructuralPrototype22
};
var TypeId52 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto32 = {
  ...EffectPrototype22,
  [TypeId52]: {
    _A: (_23) => _23
  },
  [NodeInspectSymbol22]() {
    return this.toJSON();
  },
  toString() {
    return format22(this.toJSON());
  }
};
var SomeProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto32), {
  _tag: "Some",
  _op: "Some",
  [symbol222](that) {
    return isOption32(that) && isSome32(that) && equals22(this.value, that.value);
  },
  [symbol32]() {
    return cached22(this, combine22(hash22(this._tag))(hash22(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON22(this.value)
    };
  }
});
var NoneHash22 = /* @__PURE__ */ hash22("None");
var NoneProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto32), {
  _tag: "None",
  _op: "None",
  [symbol222](that) {
    return isOption32(that) && isNone32(that);
  },
  [symbol32]() {
    return NoneHash22;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption32 = (input) => hasProperty22(input, TypeId52);
var isNone32 = (fa) => fa._tag === "None";
var isSome32 = (fa) => fa._tag === "Some";
var none32 = /* @__PURE__ */ Object.create(NoneProto22);
var some222 = (value) => {
  const a23 = Object.create(SomeProto22);
  a23.value = value;
  return a23;
};
var TypeId222 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto222 = {
  ...EffectPrototype22,
  [TypeId222]: {
    _R: (_23) => _23
  },
  [NodeInspectSymbol22]() {
    return this.toJSON();
  },
  toString() {
    return format22(this.toJSON());
  }
};
var RightProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto222), {
  _tag: "Right",
  _op: "Right",
  [symbol222](that) {
    return isEither22(that) && isRight22(that) && equals22(this.right, that.right);
  },
  [symbol32]() {
    return combine22(hash22(this._tag))(hash22(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON22(this.right)
    };
  }
});
var LeftProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto222), {
  _tag: "Left",
  _op: "Left",
  [symbol222](that) {
    return isEither22(that) && isLeft22(that) && equals22(this.left, that.left);
  },
  [symbol32]() {
    return combine22(hash22(this._tag))(hash22(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON22(this.left)
    };
  }
});
var isEither22 = (input) => hasProperty22(input, TypeId222);
var isLeft22 = (ma) => ma._tag === "Left";
var isRight22 = (ma) => ma._tag === "Right";
var left22 = (left323) => {
  const a23 = Object.create(LeftProto22);
  a23.left = left323;
  return a23;
};
var right22 = (right323) => {
  const a23 = Object.create(RightProto22);
  a23.right = right323;
  return a23;
};
var getLeft32 = (self2) => isRight22(self2) ? none32 : some222(self2.left);
var getRight32 = (self2) => isLeft22(self2) ? none32 : some222(self2.right);
var right222 = right22;
var left222 = left22;
var Option_exports22 = {};
__export222(Option_exports22, {
  Do: () => Do22,
  TypeId: () => TypeId322,
  all: () => all222,
  andThen: () => andThen22,
  ap: () => ap22,
  as: () => as22,
  asVoid: () => asVoid22,
  bind: () => bind222,
  bindTo: () => bindTo222,
  composeK: () => composeK22,
  contains: () => contains22,
  containsWith: () => containsWith22,
  exists: () => exists22,
  filter: () => filter22,
  filterMap: () => filterMap22,
  firstSomeOf: () => firstSomeOf22,
  flatMap: () => flatMap22,
  flatMapNullable: () => flatMapNullable22,
  flatten: () => flatten22,
  fromIterable: () => fromIterable22,
  fromNullable: () => fromNullable22,
  gen: () => gen22,
  getEquivalence: () => getEquivalence22,
  getLeft: () => getLeft222,
  getOrElse: () => getOrElse22,
  getOrNull: () => getOrNull22,
  getOrThrow: () => getOrThrow22,
  getOrThrowWith: () => getOrThrowWith22,
  getOrUndefined: () => getOrUndefined22,
  getOrder: () => getOrder22,
  getRight: () => getRight222,
  isNone: () => isNone222,
  isOption: () => isOption222,
  isSome: () => isSome222,
  let: () => let_222,
  lift2: () => lift222,
  liftNullable: () => liftNullable22,
  liftPredicate: () => liftPredicate22,
  liftThrowable: () => liftThrowable22,
  map: () => map22,
  match: () => match22,
  none: () => none222,
  orElse: () => orElse22,
  orElseEither: () => orElseEither22,
  orElseSome: () => orElseSome22,
  partitionMap: () => partitionMap22,
  product: () => product222,
  productMany: () => productMany222,
  reduceCompact: () => reduceCompact22,
  some: () => some322,
  tap: () => tap22,
  toArray: () => toArray22,
  toRefinement: () => toRefinement22,
  void: () => void_22,
  zipLeft: () => zipLeft22,
  zipRight: () => zipRight22,
  zipWith: () => zipWith22
});
var make222 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId322 = /* @__PURE__ */ Symbol.for("effect/Option");
var none222 = () => none32;
var some322 = some222;
var isOption222 = isOption32;
var isNone222 = isNone32;
var isSome222 = isSome32;
var match22 = /* @__PURE__ */ dual22(2, (self2, {
  onNone,
  onSome
}) => isNone222(self2) ? onNone() : onSome(self2.value));
var toRefinement22 = (f23) => (a23) => isSome222(f23(a23));
var fromIterable22 = (collection) => {
  for (const a23 of collection) {
    return some322(a23);
  }
  return none222();
};
var getRight222 = getRight32;
var getLeft222 = getLeft32;
var getOrElse22 = /* @__PURE__ */ dual22(2, (self2, onNone) => isNone222(self2) ? onNone() : self2.value);
var orElse22 = /* @__PURE__ */ dual22(2, (self2, that) => isNone222(self2) ? that() : self2);
var orElseSome22 = /* @__PURE__ */ dual22(2, (self2, onNone) => isNone222(self2) ? some322(onNone()) : self2);
var orElseEither22 = /* @__PURE__ */ dual22(2, (self2, that) => isNone222(self2) ? map22(that(), right22) : map22(self2, left22));
var firstSomeOf22 = (collection) => {
  let out = none222();
  for (out of collection) {
    if (isSome222(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable22 = (nullableValue) => nullableValue == null ? none222() : some322(nullableValue);
var liftNullable22 = (f23) => (...a23) => fromNullable22(f23(...a23));
var getOrNull22 = /* @__PURE__ */ getOrElse22(constNull22);
var getOrUndefined22 = /* @__PURE__ */ getOrElse22(constUndefined22);
var liftThrowable22 = (f23) => (...a23) => {
  try {
    return some322(f23(...a23));
  } catch (e23) {
    return none222();
  }
};
var getOrThrowWith22 = /* @__PURE__ */ dual22(2, (self2, onNone) => {
  if (isSome222(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow22 = /* @__PURE__ */ getOrThrowWith22(() => new Error("getOrThrow called on a None"));
var map22 = /* @__PURE__ */ dual22(2, (self2, f23) => isNone222(self2) ? none222() : some322(f23(self2.value)));
var as22 = /* @__PURE__ */ dual22(2, (self2, b23) => map22(self2, () => b23));
var asVoid22 = /* @__PURE__ */ as22(void 0);
var void_22 = /* @__PURE__ */ some322(void 0);
var flatMap22 = /* @__PURE__ */ dual22(2, (self2, f23) => isNone222(self2) ? none222() : f23(self2.value));
var andThen22 = /* @__PURE__ */ dual22(2, (self2, f23) => flatMap22(self2, (a23) => {
  const b23 = isFunction222(f23) ? f23(a23) : f23;
  return isOption222(b23) ? b23 : some322(b23);
}));
var flatMapNullable22 = /* @__PURE__ */ dual22(2, (self2, f23) => isNone222(self2) ? none222() : fromNullable22(f23(self2.value)));
var flatten22 = /* @__PURE__ */ flatMap22(identity22);
var zipRight22 = /* @__PURE__ */ dual22(2, (self2, that) => flatMap22(self2, () => that));
var composeK22 = /* @__PURE__ */ dual22(2, (afb, bfc) => (a23) => flatMap22(afb(a23), bfc));
var zipLeft22 = /* @__PURE__ */ dual22(2, (self2, that) => tap22(self2, () => that));
var tap22 = /* @__PURE__ */ dual22(2, (self2, f23) => flatMap22(self2, (a23) => map22(f23(a23), () => a23)));
var product222 = (self2, that) => isSome222(self2) && isSome222(that) ? some322([self2.value, that.value]) : none222();
var productMany222 = (self2, collection) => {
  if (isNone222(self2)) {
    return none222();
  }
  const out = [self2.value];
  for (const o23 of collection) {
    if (isNone222(o23)) {
      return none222();
    }
    out.push(o23.value);
  }
  return some322(out);
};
var all222 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o23 of input) {
      if (isNone222(o23)) {
        return none222();
      }
      out2.push(o23.value);
    }
    return some322(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o23 = input[key];
    if (isNone222(o23)) {
      return none222();
    }
    out[key] = o23.value;
  }
  return some322(out);
};
var zipWith22 = /* @__PURE__ */ dual22(3, (self2, that, f23) => map22(product222(self2, that), ([a23, b23]) => f23(a23, b23)));
var ap22 = /* @__PURE__ */ dual22(2, (self2, that) => zipWith22(self2, that, (f23, a23) => f23(a23)));
var reduceCompact22 = /* @__PURE__ */ dual22(3, (self2, b23, f23) => {
  let out = b23;
  for (const oa of self2) {
    if (isSome222(oa)) {
      out = f23(out, oa.value);
    }
  }
  return out;
});
var toArray22 = (self2) => isNone222(self2) ? [] : [self2.value];
var partitionMap22 = /* @__PURE__ */ dual22(2, (self2, f23) => {
  if (isNone222(self2)) {
    return [none222(), none222()];
  }
  const e23 = f23(self2.value);
  return isLeft22(e23) ? [some322(e23.left), none222()] : [none222(), some322(e23.right)];
});
var filterMap22 = /* @__PURE__ */ dual22(2, (self2, f23) => isNone222(self2) ? none222() : f23(self2.value));
var filter22 = /* @__PURE__ */ dual22(2, (self2, predicate) => filterMap22(self2, (b23) => predicate(b23) ? some222(b23) : none32));
var getEquivalence22 = (isEquivalent) => make42((x23, y23) => x23 === y23 || (isNone222(x23) ? isNone222(y23) : isNone222(y23) ? false : isEquivalent(x23.value, y23.value)));
var getOrder22 = (O23) => make222((self2, that) => isSome222(self2) ? isSome222(that) ? O23(self2.value, that.value) : 1 : -1);
var lift222 = (f23) => dual22(2, (self2, that) => zipWith22(self2, that, f23));
var liftPredicate22 = (predicate) => (b23) => predicate(b23) ? some322(b23) : none222();
var containsWith22 = (isEquivalent) => dual22(2, (self2, a23) => isNone222(self2) ? false : isEquivalent(self2.value, a23));
var _equivalence22 = /* @__PURE__ */ equivalence22();
var contains22 = /* @__PURE__ */ containsWith22(_equivalence22);
var exists22 = /* @__PURE__ */ dual22(2, (self2, refinement) => isNone222(self2) ? false : refinement(self2.value));
var bindTo222 = /* @__PURE__ */ bindTo32(map22);
var let_222 = /* @__PURE__ */ let_32(map22);
var bind222 = /* @__PURE__ */ bind32(map22, flatMap22);
var Do22 = /* @__PURE__ */ some322({});
var adapter222 = /* @__PURE__ */ adapter32();
var gen22 = (f23) => {
  const iterator = f23(adapter222);
  let state = iterator.next();
  if (state.done) {
    return some322(state.value);
  } else {
    let current = state.value;
    if (isGenKind22(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet22(current);
    }
    if (isNone222(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind22(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet22(current);
        }
        if (isNone222(current)) {
          return current;
        }
      }
    }
    return some322(state.value);
  }
};
var fromIterable222 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse4 = (self2) => Array.from(self2).reverse();
var reduce5 = /* @__PURE__ */ dual22(3, (self2, b23, f23) => fromIterable222(self2).reduce((b222, a23, i23) => f23(b222, a23, i23), b23));
var TagTypeId2 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey2 = "effect/STM";
var STMTypeId2 = /* @__PURE__ */ Symbol.for(STMSymbolKey2);
var TagProto2 = {
  ...EffectPrototype22,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId2]: effectVariance22,
  [TagTypeId2]: {
    _Service: (_23) => _23,
    _Identifier: (_23) => _23
  },
  toString() {
    return format22(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol22]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make322(this, self2);
  }
};
var makeGenericTag2 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto2);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId422 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto2 = {
  [TypeId422]: {
    _Services: (_23) => _23
  },
  [symbol222](that) {
    if (isContext2(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k23 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k23) || !equals22(this.unsafeMap.get(k23), that.unsafeMap.get(k23))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol32]() {
    return cached22(this, number22(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments22(this, arguments);
  },
  toString() {
    return format22(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON22)
    };
  },
  [NodeInspectSymbol22]() {
    return this.toJSON();
  }
};
var makeContext2 = (unsafeMap) => {
  const context = Object.create(ContextProto2);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext2 = (u23) => hasProperty22(u23, TypeId422);
var _empty6 = /* @__PURE__ */ makeContext2(/* @__PURE__ */ new Map());
var empty10 = () => _empty6;
var make322 = (tag, service) => makeContext2(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag2 = makeGenericTag2;
var empty22 = empty10;
var TypeId522 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy3(src, srcPos, dest, destPos, len) {
  for (let i23 = srcPos; i23 < Math.min(src.length, srcPos + len); i23++) {
    dest[destPos + i23 - srcPos] = src[i23];
  }
  return dest;
}
var emptyArray2 = [];
var getEquivalence222 = (isEquivalent) => make42((self2, that) => self2.length === that.length && toReadonlyArray2(self2).every((value, i23) => isEquivalent(value, unsafeGet22(that, i23))));
var _equivalence222 = /* @__PURE__ */ getEquivalence222(equals22);
var ChunkProto2 = {
  [TypeId522]: {
    _A: (_23) => _23
  },
  toString() {
    return format22(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray2(this).map(toJSON22)
    };
  },
  [NodeInspectSymbol22]() {
    return this.toJSON();
  },
  [symbol222](that) {
    return isChunk2(that) && _equivalence222(this, that);
  },
  [symbol32]() {
    return cached22(this, array5(toReadonlyArray2(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray2[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray2(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments22(this, arguments);
  }
};
var makeChunk2 = (backing) => {
  const chunk = Object.create(ChunkProto2);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty22;
      chunk.right = _empty22;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty22;
      chunk.right = _empty22;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty22;
      chunk.right = _empty22;
      break;
    }
  }
  return chunk;
};
var isChunk2 = (u23) => hasProperty22(u23, TypeId522);
var _empty22 = /* @__PURE__ */ makeChunk2({
  _tag: "IEmpty"
});
var empty32 = () => _empty22;
var make422 = (...as2223) => as2223.length === 1 ? of3(as2223[0]) : unsafeFromNonEmptyArray2(as2223);
var of3 = (a23) => makeChunk2({
  _tag: "ISingleton",
  a: a23
});
var copyToArray2 = (self2, array323, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy3(self2.backing.array, 0, array323, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray2(self2.left, array323, initial);
      copyToArray2(self2.right, array323, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array323[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i23 = 0;
      let j23 = initial;
      while (i23 < self2.length) {
        array323[j23] = unsafeGet22(self2, i23);
        i23 += 1;
        j23 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray2 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray2;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray2(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty22;
      self2.right = _empty22;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse22 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk2({
        _tag: "IArray",
        array: reverse4(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk2({
        _tag: "IConcat",
        left: reverse22(self2.backing.right),
        right: reverse22(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray2(reverse4(toReadonlyArray2(self2)));
  }
};
var unsafeFromArray2 = (self2) => makeChunk2({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray2 = (self2) => unsafeFromArray2(self2);
var unsafeGet22 = /* @__PURE__ */ dual22(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet22(self2.left, index) : unsafeGet22(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet22(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend3 = /* @__PURE__ */ dual22(2, (self2, elem) => appendAll3(of3(elem), self2));
var drop3 = /* @__PURE__ */ dual22(2, (self2, n23) => {
  if (n23 <= 0) {
    return self2;
  } else if (n23 >= self2.length) {
    return _empty22;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk2({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n23,
          length: self2.backing.length - n23
        });
      }
      case "IConcat": {
        if (n23 > self2.left.length) {
          return drop3(self2.right, n23 - self2.left.length);
        }
        return makeChunk2({
          _tag: "IConcat",
          left: drop3(self2.left, n23),
          right: self2.right
        });
      }
      default: {
        return makeChunk2({
          _tag: "ISlice",
          chunk: self2,
          offset: n23,
          length: self2.length - n23
        });
      }
    }
  }
});
var appendAll3 = /* @__PURE__ */ dual22(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff223 = that.depth - self2.depth;
  if (Math.abs(diff223) <= 1) {
    return makeChunk2({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff223 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll3(self2.right, that);
      return makeChunk2({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll3(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk2({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk2({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk2({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk2({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll3(self2, that.left);
      return makeChunk2({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll3(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk2({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk2({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk2({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk2({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty2 = (self2) => self2.length === 0;
var isNonEmpty2 = (self2) => self2.length > 0;
var unsafeHead2 = (self2) => unsafeGet22(self2, 0);
var headNonEmpty3 = unsafeHead2;
var tailNonEmpty3 = (self2) => drop3(self2, 1);
var SIZE2 = 5;
var BUCKET_SIZE2 = /* @__PURE__ */ Math.pow(2, SIZE2);
var MASK2 = BUCKET_SIZE2 - 1;
var MAX_INDEX_NODE2 = BUCKET_SIZE2 / 2;
var MIN_ARRAY_NODE2 = BUCKET_SIZE2 / 4;
function popcount2(x23) {
  x23 -= x23 >> 1 & 1431655765;
  x23 = (x23 & 858993459) + (x23 >> 2 & 858993459);
  x23 = x23 + (x23 >> 4) & 252645135;
  x23 += x23 >> 8;
  x23 += x23 >> 16;
  return x23 & 127;
}
function hashFragment2(shift3, h23) {
  return h23 >>> shift3 & MASK2;
}
function toBitmap2(x23) {
  return 1 << x23;
}
function fromBitmap2(bitmap, bit) {
  return popcount2(bitmap & bit - 1);
}
var make52 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate2(mutate223, at, v23, arr) {
  let out = arr;
  if (!mutate223) {
    const len = arr.length;
    out = new Array(len);
    for (let i23 = 0; i23 < len; ++i23) out[i23] = arr[i23];
  }
  out[at] = v23;
  return out;
}
function arraySpliceOut2(mutate223, at, arr) {
  const newLen = arr.length - 1;
  let i23 = 0;
  let g23 = 0;
  let out = arr;
  if (mutate223) {
    i23 = g23 = at;
  } else {
    out = new Array(newLen);
    while (i23 < at) out[g23++] = arr[i23++];
  }
  ++i23;
  while (i23 <= newLen) out[g23++] = arr[i23++];
  if (mutate223) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn2(mutate223, at, v23, arr) {
  const len = arr.length;
  if (mutate223) {
    let i222 = len;
    while (i222 >= at) arr[i222--] = arr[i222];
    arr[at] = v23;
    return arr;
  }
  let i23 = 0, g23 = 0;
  const out = new Array(len + 1);
  while (i23 < at) out[g23++] = arr[i23++];
  out[at] = v23;
  while (i23 < len) out[++g23] = arr[i23++];
  return out;
}
var EmptyNode2 = class _EmptyNode2 {
  _tag = "EmptyNode";
  modify(edit, _shift, f23, hash2223, key, size423) {
    const v23 = f23(none222());
    if (isNone222(v23)) return new _EmptyNode2();
    ++size423.value;
    return new LeafNode2(edit, hash2223, key, v23);
  }
};
function isEmptyNode2(a23) {
  return isTagged3(a23, "EmptyNode");
}
function isLeafNode2(node) {
  return isEmptyNode2(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode2(node, edit) {
  return isEmptyNode2(node) ? false : edit === node.edit;
}
var LeafNode2 = class _LeafNode2 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash2223, key, value) {
    this.edit = edit;
    this.hash = hash2223;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift3, f23, hash2223, key, size423) {
    if (equals22(key, this.key)) {
      const v222 = f23(this.value);
      if (v222 === this.value) return this;
      else if (isNone222(v222)) {
        --size423.value;
        return new EmptyNode2();
      }
      if (canEditNode2(this, edit)) {
        this.value = v222;
        return this;
      }
      return new _LeafNode2(edit, hash2223, key, v222);
    }
    const v23 = f23(none222());
    if (isNone222(v23)) return this;
    ++size423.value;
    return mergeLeaves2(edit, shift3, this.hash, this, hash2223, new _LeafNode2(edit, hash2223, key, v23));
  }
};
var CollisionNode2 = class _CollisionNode2 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash2223, children) {
    this.edit = edit;
    this.hash = hash2223;
    this.children = children;
  }
  modify(edit, shift3, f23, hash2223, key, size423) {
    if (hash2223 === this.hash) {
      const canEdit = canEditNode2(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f23, key, size423);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode2(edit, this.hash, list) : list[0];
    }
    const v23 = f23(none222());
    if (isNone222(v23)) return this;
    ++size423.value;
    return mergeLeaves2(edit, shift3, this.hash, this, hash2223, new LeafNode2(edit, hash2223, key, v23));
  }
  updateCollisionList(mutate223, edit, hash2223, list, f23, key, size423) {
    const len = list.length;
    for (let i23 = 0; i23 < len; ++i23) {
      const child = list[i23];
      if ("key" in child && equals22(key, child.key)) {
        const value = child.value;
        const newValue2 = f23(value);
        if (newValue2 === value) return list;
        if (isNone222(newValue2)) {
          --size423.value;
          return arraySpliceOut2(mutate223, i23, list);
        }
        return arrayUpdate2(mutate223, i23, new LeafNode2(edit, hash2223, key, newValue2), list);
      }
    }
    const newValue = f23(none222());
    if (isNone222(newValue)) return list;
    ++size423.value;
    return arrayUpdate2(mutate223, len, new LeafNode2(edit, hash2223, key, newValue), list);
  }
};
var IndexedNode2 = class _IndexedNode2 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift3, f23, hash2223, key, size423) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment2(shift3, hash2223);
    const bit = toBitmap2(frag);
    const indx = fromBitmap2(mask, bit);
    const exists2223 = mask & bit;
    const canEdit = canEditNode2(this, edit);
    if (!exists2223) {
      const _newChild = new EmptyNode2().modify(edit, shift3 + SIZE2, f23, hash2223, key, size423);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE2 ? expand2(edit, frag, _newChild, mask, children) : new _IndexedNode2(edit, mask | bit, arraySpliceIn2(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift3 + SIZE2, f23, hash2223, key, size423);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode2(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode2();
      if (children.length <= 2 && isLeafNode2(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut2(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate2(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode2(edit, bitmap, newChildren);
  }
};
var ArrayNode2 = class _ArrayNode2 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size423, children) {
    this.edit = edit;
    this.size = size423;
    this.children = children;
  }
  modify(edit, shift3, f23, hash2223, key, size423) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment2(shift3, hash2223);
    const child = children[frag];
    const newChild = (child || new EmptyNode2()).modify(edit, shift3 + SIZE2, f23, hash2223, key, size423);
    if (child === newChild) return this;
    const canEdit = canEditNode2(this, edit);
    let newChildren;
    if (isEmptyNode2(child) && !isEmptyNode2(newChild)) {
      ++count;
      newChildren = arrayUpdate2(canEdit, frag, newChild, children);
    } else if (!isEmptyNode2(child) && isEmptyNode2(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE2) {
        return pack2(edit, count, frag, children);
      }
      newChildren = arrayUpdate2(canEdit, frag, new EmptyNode2(), children);
    } else {
      newChildren = arrayUpdate2(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode2(edit, count, newChildren);
  }
};
function pack2(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g23 = 0;
  let bitmap = 0;
  for (let i23 = 0, len = elements.length; i23 < len; ++i23) {
    if (i23 !== removed) {
      const elem = elements[i23];
      if (elem && !isEmptyNode2(elem)) {
        children[g23++] = elem;
        bitmap |= 1 << i23;
      }
    }
  }
  return new IndexedNode2(edit, bitmap, children);
}
function expand2(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i23 = 0; bit; ++i23) {
    if (bit & 1) arr[i23] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode2(edit, count + 1, arr);
}
function mergeLeavesInner2(edit, shift3, h1, n1, h23, n23) {
  if (h1 === h23) return new CollisionNode2(edit, h1, [n23, n1]);
  const subH1 = hashFragment2(shift3, h1);
  const subH2 = hashFragment2(shift3, h23);
  if (subH1 === subH2) {
    return (child) => new IndexedNode2(edit, toBitmap2(subH1) | toBitmap2(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n23] : [n23, n1];
    return new IndexedNode2(edit, toBitmap2(subH1) | toBitmap2(subH2), children);
  }
}
function mergeLeaves2(edit, shift3, h1, n1, h23, n23) {
  let stack = void 0;
  let currentShift = shift3;
  while (true) {
    const res = mergeLeavesInner2(edit, currentShift, h1, n1, h23, n23);
    if (typeof res === "function") {
      stack = make52(res, stack);
      currentShift = currentShift + SIZE2;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey2 = "effect/HashMap";
var HashMapTypeId2 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey2);
var HashMapProto2 = {
  [HashMapTypeId2]: HashMapTypeId2,
  [Symbol.iterator]() {
    return new HashMapIterator2(this, (k23, v23) => [k23, v23]);
  },
  [symbol32]() {
    let hash2223 = hash22(HashMapSymbolKey2);
    for (const item of this) {
      hash2223 ^= pipe22(hash22(item[0]), combine22(hash22(item[1])));
    }
    return cached22(this, hash2223);
  },
  [symbol222](that) {
    if (isHashMap2(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe22(that, getHash2(item[0], hash22(item[0])));
        if (isNone222(elem)) {
          return false;
        } else {
          if (!equals22(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format22(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON22)
    };
  },
  [NodeInspectSymbol22]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments22(this, arguments);
  }
};
var makeImpl3 = (editable, edit, root, size423) => {
  const map63 = Object.create(HashMapProto2);
  map63._editable = editable;
  map63._edit = edit;
  map63._root = root;
  map63._size = size423;
  return map63;
};
var HashMapIterator2 = class _HashMapIterator2 {
  map;
  f;
  v;
  constructor(map63, f23) {
    this.map = map63;
    this.f = f23;
    this.v = visitLazy2(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone222(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont2(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator2(this.map, this.f);
  }
};
var applyCont2 = (cont) => cont ? visitLazyChildren2(cont[0], cont[1], cont[2], cont[3], cont[4]) : none222();
var visitLazy2 = (node, f23, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome222(node.value)) {
        return some322({
          value: f23(node.key, node.value.value),
          cont
        });
      }
      return applyCont2(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren2(children.length, children, 0, f23, cont);
    }
    default: {
      return applyCont2(cont);
    }
  }
};
var visitLazyChildren2 = (len, children, i23, f23, cont) => {
  while (i23 < len) {
    const child = children[i23++];
    if (child && !isEmptyNode2(child)) {
      return visitLazy2(child, f23, [len, children, i23, f23, cont]);
    }
  }
  return applyCont2(cont);
};
var _empty32 = /* @__PURE__ */ makeImpl3(false, 0, /* @__PURE__ */ new EmptyNode2(), 0);
var empty42 = () => _empty32;
var isHashMap2 = (u23) => hasProperty22(u23, HashMapTypeId2);
var getHash2 = /* @__PURE__ */ dual22(3, (self2, key, hash2223) => {
  let node = self2._root;
  let shift3 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals22(key, node.key) ? node.value : none222();
      }
      case "CollisionNode": {
        if (hash2223 === node.hash) {
          const children = node.children;
          for (let i23 = 0, len = children.length; i23 < len; ++i23) {
            const child = children[i23];
            if ("key" in child && equals22(key, child.key)) {
              return child.value;
            }
          }
        }
        return none222();
      }
      case "IndexedNode": {
        const frag = hashFragment2(shift3, hash2223);
        const bit = toBitmap2(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap2(node.mask, bit)];
          shift3 += SIZE2;
          break;
        }
        return none222();
      }
      case "ArrayNode": {
        node = node.children[hashFragment2(shift3, hash2223)];
        if (node) {
          shift3 += SIZE2;
          break;
        }
        return none222();
      }
      default:
        return none222();
    }
  }
});
var set22 = /* @__PURE__ */ dual22(3, (self2, key, value) => modifyAt2(self2, key, () => some322(value)));
var setTree2 = /* @__PURE__ */ dual22(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl3(self2._editable, self2._edit, newRoot, newSize);
});
var keys3 = (self2) => new HashMapIterator2(self2, (key) => key);
var size4 = (self2) => self2._size;
var beginMutation3 = (self2) => makeImpl3(true, self2._edit + 1, self2._root, self2._size);
var modifyAt2 = /* @__PURE__ */ dual22(3, (self2, key, f23) => modifyHash2(self2, key, hash22(key), f23));
var modifyHash2 = /* @__PURE__ */ dual22(4, (self2, key, hash2223, f23) => {
  const size423 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f23, hash2223, key, size423);
  return pipe22(self2, setTree2(newRoot, size423.value));
});
var forEach4 = /* @__PURE__ */ dual22(2, (self2, f23) => reduce22(self2, void 0, (_23, value, key) => f23(value, key)));
var reduce22 = /* @__PURE__ */ dual22(3, (self2, zero, f23) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome222(root.value) ? f23(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i23 = 0, len = children.length; i23 < len; ) {
      const child = children[i23++];
      if (child && !isEmptyNode2(child)) {
        if (child._tag === "LeafNode") {
          if (isSome222(child.value)) {
            zero = f23(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey2 = "effect/HashSet";
var HashSetTypeId2 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey2);
var HashSetProto2 = {
  [HashSetTypeId2]: HashSetTypeId2,
  [Symbol.iterator]() {
    return keys3(this._keyMap);
  },
  [symbol32]() {
    return cached22(this, combine22(hash22(this._keyMap))(hash22(HashSetSymbolKey2)));
  },
  [symbol222](that) {
    if (isHashSet2(that)) {
      return size4(this._keyMap) === size4(that._keyMap) && equals22(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format22(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON22)
    };
  },
  [NodeInspectSymbol22]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments22(this, arguments);
  }
};
var makeImpl22 = (keyMap) => {
  const set2223 = Object.create(HashSetProto2);
  set2223._keyMap = keyMap;
  return set2223;
};
var isHashSet2 = (u23) => hasProperty22(u23, HashSetTypeId2);
var _empty42 = /* @__PURE__ */ makeImpl22(/* @__PURE__ */ empty42());
var empty52 = () => _empty42;
var size22 = (self2) => size4(self2._keyMap);
var beginMutation22 = (self2) => makeImpl22(beginMutation3(self2._keyMap));
var endMutation2 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate2 = /* @__PURE__ */ dual22(2, (self2, f23) => {
  const transient = beginMutation22(self2);
  f23(transient);
  return endMutation2(transient);
});
var add22 = /* @__PURE__ */ dual22(2, (self2, value) => self2._keyMap._editable ? (set22(value, true)(self2._keyMap), self2) : makeImpl22(set22(value, true)(self2._keyMap)));
var union22 = /* @__PURE__ */ dual22(2, (self2, that) => mutate2(empty52(), (set2223) => {
  forEach22(self2, (value) => add22(set2223, value));
  for (const value of that) {
    add22(set2223, value);
  }
}));
var forEach22 = /* @__PURE__ */ dual22(2, (self2, f23) => forEach4(self2._keyMap, (_23, k23) => f23(k23)));
var empty62 = empty52;
var size32 = size22;
var add32 = add22;
var union32 = union22;
var ArrayProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol32]() {
    return cached22(this, array5(this));
  },
  [symbol222](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v23, i23) => equals22(v23, that[i23]));
    } else {
      return false;
    }
  }
});
var Structural3 = /* @__PURE__ */ function() {
  function Structural323(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural323.prototype = StructuralPrototype22;
  return Structural323;
}();
var struct22 = (as2223) => Object.assign(Object.create(StructuralPrototype22), as2223);
var ContextPatchTypeId2 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance3(a23) {
  return a23;
}
var PatchProto2 = {
  ...Structural3.prototype,
  [ContextPatchTypeId2]: {
    _Value: variance3,
    _Patch: variance3
  }
};
var EmptyProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2), {
  _tag: "Empty"
});
var _empty52 = /* @__PURE__ */ Object.create(EmptyProto2);
var empty72 = () => _empty52;
var AndThenProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2), {
  _tag: "AndThen"
});
var makeAndThen2 = (first, second) => {
  const o23 = Object.create(AndThenProto2);
  o23.first = first;
  o23.second = second;
  return o23;
};
var AddServiceProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2), {
  _tag: "AddService"
});
var makeAddService2 = (key, service) => {
  const o23 = Object.create(AddServiceProto2);
  o23.key = key;
  o23.service = service;
  return o23;
};
var RemoveServiceProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2), {
  _tag: "RemoveService"
});
var makeRemoveService2 = (key) => {
  const o23 = Object.create(RemoveServiceProto2);
  o23.key = key;
  return o23;
};
var UpdateServiceProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2), {
  _tag: "UpdateService"
});
var makeUpdateService2 = (key, update23) => {
  const o23 = Object.create(UpdateServiceProto2);
  o23.key = key;
  o23.update = update23;
  return o23;
};
var diff2 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch223 = empty72();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals22(old, newService)) {
        patch223 = combine222(makeUpdateService2(tag, () => newService))(patch223);
      }
    } else {
      missingServices.delete(tag);
      patch223 = combine222(makeAddService2(tag, newService))(patch223);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch223 = combine222(makeRemoveService2(tag))(patch223);
  }
  return patch223;
};
var combine222 = /* @__PURE__ */ dual22(2, (self2, that) => makeAndThen2(self2, that));
var patch2 = /* @__PURE__ */ dual22(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of3(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty2(patches)) {
    const head23 = headNonEmpty3(patches);
    const tail23 = tailNonEmpty3(patches);
    switch (head23._tag) {
      case "Empty": {
        patches = tail23;
        break;
      }
      case "AddService": {
        updatedContext.set(head23.key, head23.service);
        patches = tail23;
        break;
      }
      case "AndThen": {
        patches = prepend3(prepend3(tail23, head23.second), head23.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head23.key);
        patches = tail23;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head23.key, head23.update(updatedContext.get(head23.key)));
        wasServiceUpdated = true;
        patches = tail23;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext2(updatedContext);
  }
  const map63 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map63.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s23] of updatedContext) {
    map63.set(tag, s23);
  }
  return makeContext2(map63);
});
var DifferTypeId2 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto2 = {
  [DifferTypeId2]: {
    _P: identity22,
    _V: identity22
  }
};
var make72 = (params) => {
  const differ = Object.create(DifferProto2);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment2 = () => make72({
  empty: empty72(),
  combine: (first, second) => combine222(second)(first),
  diff: (oldValue, newValue) => diff2(oldValue, newValue),
  patch: (patch223, oldValue) => patch2(oldValue)(patch223)
});
var OP_DIE2 = "Die";
var OP_EMPTY2 = "Empty";
var OP_FAIL2 = "Fail";
var OP_INTERRUPT2 = "Interrupt";
var OP_PARALLEL2 = "Parallel";
var OP_SEQUENTIAL2 = "Sequential";
var CauseSymbolKey2 = "effect/Cause";
var CauseTypeId2 = /* @__PURE__ */ Symbol.for(CauseSymbolKey2);
var variance22 = {
  /* c8 ignore next */
  _E: (_23) => _23
};
var proto2 = {
  [CauseTypeId2]: variance22,
  [symbol32]() {
    return pipe22(hash22(CauseSymbolKey2), combine22(hash22(flattenCause2(this))), cached22(this));
  },
  [symbol222](that) {
    return isCause2(that) && causeEquals2(this, that);
  },
  pipe() {
    return pipeArguments22(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON22(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON22(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON22(this.left),
          right: toJSON22(this.right)
        };
    }
  },
  toString() {
    return pretty2(this);
  },
  [NodeInspectSymbol22]() {
    return this.toJSON();
  }
};
var fail3 = (error) => {
  const o23 = Object.create(proto2);
  o23._tag = OP_FAIL2;
  o23.error = error;
  return o23;
};
var parallel2 = (left323, right323) => {
  const o23 = Object.create(proto2);
  o23._tag = OP_PARALLEL2;
  o23.left = left323;
  o23.right = right323;
  return o23;
};
var sequential2 = (left323, right323) => {
  const o23 = Object.create(proto2);
  o23._tag = OP_SEQUENTIAL2;
  o23.left = left323;
  o23.right = right323;
  return o23;
};
var isCause2 = (u23) => hasProperty22(u23, CauseTypeId2);
var isInterruptedOnly2 = (self2) => reduceWithContext2(void 0, IsInterruptedOnlyCauseReducer2)(self2);
var causeEquals2 = (left323, right323) => {
  let leftStack = of3(left323);
  let rightStack = of3(right323);
  while (isNonEmpty2(leftStack) && isNonEmpty2(rightStack)) {
    const [leftParallel, leftSequential] = pipe22(headNonEmpty3(leftStack), reduce42([empty62(), empty32()], ([parallel223, sequential223], cause) => {
      const [par, seq] = evaluateCause2(cause);
      return some322([pipe22(parallel223, union32(par)), pipe22(sequential223, appendAll3(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe22(headNonEmpty3(rightStack), reduce42([empty62(), empty32()], ([parallel223, sequential223], cause) => {
      const [par, seq] = evaluateCause2(cause);
      return some322([pipe22(parallel223, union32(par)), pipe22(sequential223, appendAll3(seq))]);
    }));
    if (!equals22(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause2 = (cause) => {
  return flattenCauseLoop2(of3(cause), empty32());
};
var flattenCauseLoop2 = (causes, flattened) => {
  while (1) {
    const [parallel223, sequential223] = pipe22(causes, reduce5([empty62(), empty32()], ([parallel33, sequential33], cause) => {
      const [par, seq] = evaluateCause2(cause);
      return [pipe22(parallel33, union32(par)), pipe22(sequential33, appendAll3(seq))];
    }));
    const updated = size32(parallel223) > 0 ? pipe22(flattened, prepend3(parallel223)) : flattened;
    if (isEmpty2(sequential223)) {
      return reverse22(updated);
    }
    causes = sequential223;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage22("Cause.flattenCauseLoop"));
};
var evaluateCause2 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty62();
  let _sequential = empty32();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY2: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL2: {
        _parallel = add32(_parallel, make422(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE2: {
        _parallel = add32(_parallel, make422(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT2: {
        _parallel = add32(_parallel, make422(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL2: {
        switch (cause.left._tag) {
          case OP_EMPTY2: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL2: {
            cause = sequential2(cause.left.left, sequential2(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL2: {
            cause = parallel2(sequential2(cause.left.left, cause.right), sequential2(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend3(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL2: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage22("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer2 = {
  emptyCase: constTrue22,
  failCase: constFalse22,
  dieCase: constFalse22,
  interruptCase: constTrue22,
  sequentialCase: (_23, left323, right323) => left323 && right323,
  parallelCase: (_23, left323, right323) => left323 && right323
};
var OP_SEQUENTIAL_CASE2 = "SequentialCase";
var OP_PARALLEL_CASE2 = "ParallelCase";
var reduce42 = /* @__PURE__ */ dual22(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome222(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL2: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL2: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext2 = /* @__PURE__ */ dual22(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY2: {
        output.push(right222(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL2: {
        output.push(right222(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE2: {
        output.push(right222(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT2: {
        output.push(right222(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL2: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left222({
          _tag: OP_SEQUENTIAL_CASE2
        }));
        break;
      }
      case OP_PARALLEL2: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left222({
          _tag: OP_PARALLEL_CASE2
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE2: {
            const left323 = accumulator.pop();
            const right323 = accumulator.pop();
            const value = reducer.sequentialCase(context, left323, right323);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE2: {
            const left323 = accumulator.pop();
            const right323 = accumulator.pop();
            const value = reducer.parallelCase(context, left323, right323);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty2 = (cause) => {
  if (isInterruptedOnly2(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors2(cause).map((e23) => e23.stack).join("\n");
};
var PrettyError2 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage2(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol3 in originalError) {
        this.span = originalError[spanSymbol3];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack2(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage2 = (u23) => {
  if (typeof u23 === "string") {
    return `Error: ${u23}`;
  }
  try {
    if (hasProperty22(u23, "toString") && isFunction32(u23["toString"]) && u23["toString"] !== Object.prototype.toString && u23["toString"] !== globalThis.Array.prototype.toString) {
      return u23["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u23)}`;
};
var locationRegex2 = /\((.*)\)/;
var spanToTrace2 = /* @__PURE__ */ globalValue22("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack2 = (message, stack, span22) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i23 = 1; i23 < lines.length; i23++) {
    if (lines[i23].includes("Generator.next")) {
      break;
    }
    if (lines[i23].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i23].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span22) {
    let current = span22;
    let i23 = 0;
    while (current && current._tag === "Span" && i23 < 10) {
      const stackFn = spanToTrace2.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex2);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined22(current.parent);
      i23++;
    }
  }
  return out.join("\n");
};
var spanSymbol3 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors2 = (cause) => reduceWithContext2(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_23, unknownError) => {
    return [new PrettyError2(unknownError)];
  },
  failCase: (_23, error) => {
    return [new PrettyError2(error)];
  },
  interruptCase: () => [],
  parallelCase: (_23, l23, r23) => [...l23, ...r23],
  sequentialCase: (_23, l23, r23) => [...l23, ...r23]
});
var SingleShotGen222 = class _SingleShotGen22 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a23) {
    return this.called ? {
      value: a23,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a23) {
    return {
      value: a23,
      done: true
    };
  }
  throw(e23) {
    throw e23;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen22(this.self);
  }
};
var spanTag2 = /* @__PURE__ */ GenericTag2("effect/ParentSpan");
var EffectTypeId222 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive2 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId222] = effectVariance22;
  constructor(_op) {
    this._op = _op;
  }
  [symbol222](that) {
    return this === that;
  }
  [symbol32]() {
    return cached22(this, random22(this));
  }
  pipe() {
    return pipeArguments22(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON22(this.effect_instruction_i0),
      effect_instruction_i1: toJSON22(this.effect_instruction_i1),
      effect_instruction_i2: toJSON22(this.effect_instruction_i2)
    };
  }
  toString() {
    return format22(this.toJSON());
  }
  [NodeInspectSymbol22]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen222(new YieldWrap22(this));
  }
};
var EffectPrimitiveFailure2 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId222] = effectVariance22;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol222](that) {
    return exitIsExit2(that) && that._op === "Failure" && // @ts-expect-error
    equals22(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol32]() {
    return pipe22(
      // @ts-expect-error
      string22(this._tag),
      // @ts-expect-error
      combine22(hash22(this.effect_instruction_i0)),
      cached22(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments22(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format22(this.toJSON());
  }
  [NodeInspectSymbol22]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen222(new YieldWrap22(this));
  }
};
var isEffect2 = (u23) => hasProperty22(u23, EffectTypeId222);
var withFiberRuntime2 = (withRuntime) => {
  const effect = new EffectPrimitive2(OP_WITH_RUNTIME2);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol22 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol2 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture2 = (obj, span22) => {
  if (isSome222(span22)) {
    return new Proxy(obj, {
      has(target, p23) {
        return p23 === spanSymbol22 || p23 === originalSymbol2 || p23 in target;
      },
      get(target, p23) {
        if (p23 === spanSymbol22) {
          return span22.value;
        }
        if (p23 === originalSymbol2) {
          return obj;
        }
        return target[p23];
      }
    });
  }
  return obj;
};
var fail22 = (error) => isObject22(error) && !(spanSymbol22 in error) ? withFiberRuntime2((fiber) => failCause2(fail3(capture2(error, currentSpanFromFiber2(fiber))))) : failCause2(fail3(error));
var failCause2 = (cause) => {
  const effect = new EffectPrimitiveFailure2(OP_FAILURE2);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey2 = "effect/FiberRef";
var FiberRefTypeId2 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey2);
var fiberRefVariance2 = {
  /* c8 ignore next */
  _A: (_23) => _23
};
var fiberRefUnsafeMakeContext2 = (initial) => {
  const differ = environment2();
  return fiberRefUnsafeMakePatch2(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch2 = (initial, options) => ({
  [FiberRefTypeId2]: fiberRefVariance2,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch223) => (oldValue) => options.differ.patch(patch223, oldValue),
  fork: options.fork,
  join: options.join ?? ((_23, n23) => n23),
  pipe() {
    return pipeArguments22(this, arguments);
  }
});
var currentContext2 = /* @__PURE__ */ globalValue22(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext2(empty22()));
var YieldableError2 = /* @__PURE__ */ function() {
  class YieldableError223 extends globalThis.Error {
    commit() {
      return fail22(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol22]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError223.prototype, StructuralCommitPrototype22);
  return YieldableError223;
}();
var exitIsExit2 = (u23) => isEffect2(u23) && "_tag" in u23 && (u23._tag === "Success" || u23._tag === "Failure");
var currentSpanFromFiber2 = (fiber) => {
  const span22 = fiber.getFiberRef(currentContext2).unsafeMap.get(spanTag2.key);
  return span22 !== void 0 && span22._tag === "Span" ? some322(span22) : none222();
};
var Data_exports22 = {};
__export222(Data_exports22, {
  Class: () => Class22,
  Error: () => Error22,
  Structural: () => Structural22,
  TaggedClass: () => TaggedClass2,
  TaggedError: () => TaggedError2,
  array: () => array22,
  case: () => _case2,
  struct: () => struct32,
  tagged: () => tagged2,
  taggedEnum: () => taggedEnum2,
  tuple: () => tuple22,
  unsafeArray: () => unsafeArray2,
  unsafeStruct: () => unsafeStruct2
});
var struct32 = struct22;
var unsafeStruct2 = (as2223) => Object.setPrototypeOf(as2223, StructuralPrototype22);
var tuple22 = (...as2223) => unsafeArray2(as2223);
var array22 = (as2223) => unsafeArray2(as2223.slice(0));
var unsafeArray2 = (as2223) => Object.setPrototypeOf(as2223, ArrayProto2);
var _case2 = () => (args) => args === void 0 ? Object.create(StructuralPrototype22) : struct32(args);
var tagged2 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype22) : struct32(args);
  value._tag = tag;
  return value;
};
var Class22 = Structural3;
var TaggedClass2 = (tag) => {
  class Base extends Class22 {
    _tag = tag;
  }
  return Base;
};
var Structural22 = Structural3;
var taggedEnum2 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged3;
    } else if (tag === "$match") {
      return taggedMatch2;
    }
    return tagged2(tag);
  }
});
function taggedMatch2() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error22 = /* @__PURE__ */ function() {
  return class Base extends YieldableError2 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError2 = (tag) => {
  class Base extends Error22 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp2 = Function_exports22.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType2.Program) return Option_exports22.none();
  return predicate(parent) ? Option_exports22.some(parent) : traverseUp2(parent, predicate);
});
var traverseUpGuard2 = Function_exports22.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType2.Program) return Option_exports22.none();
  return predicate(parent) ? Option_exports22.some(parent) : traverseUpGuard2(parent, predicate);
});
var ESLintCommunityESLintUtils2;
((ESLintCommunityESLintUtils223) => {
  ESLintCommunityESLintUtils223.getFunctionHeadLocation = getFunctionHeadLocation2;
  ESLintCommunityESLintUtils223.getFunctionNameWithKind = getFunctionNameWithKind2;
  ESLintCommunityESLintUtils223.getPropertyName = getPropertyName2;
  ESLintCommunityESLintUtils223.getStaticValue = getStaticValue2;
  ESLintCommunityESLintUtils223.getStringIfConstant = getStringIfConstant2;
  ESLintCommunityESLintUtils223.hasSideEffect = hasSideEffect2;
  ESLintCommunityESLintUtils223.isParenthesized = isParenthesized2;
})(ESLintCommunityESLintUtils2 || (ESLintCommunityESLintUtils2 = {}));
var Construction2 = Data_exports22.taggedEnum();
Construction2.None();
a2({
  type: N2.union([NodeType2.FunctionExpression, NodeType2.ArrowFunctionExpression]),
  parent: {
    type: NodeType2.Property,
    parent: {
      type: NodeType2.ObjectExpression
    }
  }
});
a2({
  type: N2.union([NodeType2.FunctionExpression, NodeType2.ArrowFunctionExpression]),
  parent: {
    type: NodeType2.MethodDefinition,
    parent: {
      type: NodeType2.ClassBody
    }
  }
});
a2({
  type: N2.union([NodeType2.FunctionExpression, NodeType2.ArrowFunctionExpression]),
  parent: {
    type: NodeType2.Property,
    parent: {
      type: NodeType2.ClassBody
    }
  }
});
function getVariableInit(at) {
  return (variable) => {
    return Function_exports3.pipe(
      Option_exports3.some(variable),
      Option_exports3.flatMapNullable((v23) => v23.defs.at(at)),
      Option_exports3.flatMap(
        (d23) => "init" in d23.node ? Option_exports3.fromNullable(d23.node.init) : Option_exports3.none()
      )
    );
  };
}
function getPropName(node) {
  return $(node.name).when(is(NodeType.JSXIdentifier), (n23) => n23.name).when(is(NodeType.JSXNamespacedName), (n23) => `${n23.namespace.name}:${n23.name.name}`).exhaustive();
}
function getProp(props, propName, context, initialScope) {
  return findPropInAttributes(props, context, initialScope)(propName);
}
function findPropInProperties(properties, context, initialScope, seenProps = []) {
  return (propName) => {
    return Option_exports2.fromNullable(
      properties.find((prop) => {
        return $(prop).when(is(NodeType.Property), (prop2) => {
          return "name" in prop2.key && prop2.key.name === propName;
        }).when(is(NodeType.SpreadElement), (prop2) => {
          return $(prop2.argument).when(is(NodeType.Identifier), (argument) => {
            const { name: name2 } = argument;
            const maybeInit = Option_exports2.flatMap(
              findVariable2(name2, initialScope),
              getVariableInit(0)
            );
            if (Option_exports2.isNone(maybeInit)) return false;
            const init22 = maybeInit.value;
            if (init22.type !== NodeType.ObjectExpression) return false;
            if (seenProps.includes(name2)) return false;
            return Option_exports2.isSome(
              findPropInProperties(init22.properties, context, initialScope, [...seenProps, name2])(propName)
            );
          }).when(is(NodeType.ObjectExpression), (argument) => {
            return Option_exports2.isSome(findPropInProperties(argument.properties, context, initialScope, seenProps)(propName));
          }).when(is(NodeType.MemberExpression), () => {
          }).when(is(NodeType.CallExpression), () => {
          }).otherwise(Function_exports2.constFalse);
        }).when(is(NodeType.RestElement), () => {
          return false;
        }).otherwise(Function_exports2.constFalse);
      })
    );
  };
}
function findPropInAttributes(attributes, context, initialScope) {
  return (propName) => {
    return Option_exports2.fromNullable(
      attributes.find((attr) => {
        return $(attr).when(is(NodeType.JSXAttribute), (attr2) => getPropName(attr2) === propName).when(is(NodeType.JSXSpreadAttribute), (attr2) => {
          return $(attr2.argument).with({ type: NodeType.Identifier }, (argument) => {
            const { name: name2 } = argument;
            const maybeInit = Option_exports2.flatMap(
              findVariable2(name2, initialScope),
              getVariableInit(0)
            );
            if (Option_exports2.isNone(maybeInit)) return false;
            const init22 = maybeInit.value;
            if (!("properties" in init22)) return false;
            return Option_exports2.isSome(findPropInProperties(init22.properties, context, initialScope)(propName));
          }).when(is(NodeType.ObjectExpression), (argument) => {
            return Option_exports2.isSome(findPropInProperties(argument.properties, context, initialScope)(propName));
          }).when(is(NodeType.MemberExpression), () => {
            return false;
          }).when(is(NodeType.CallExpression), () => {
            return false;
          }).otherwise(Function_exports2.constFalse);
        }).otherwise(Function_exports2.constFalse);
      })
    );
  };
}
function hasProp(attributes, propName, context, initialScope) {
  return Option_exports2.isSome(findPropInAttributes(attributes, context, initialScope)(propName));
}
function traverseUpProp(node, predicate = Function_exports2.constTrue) {
  const guard = (node2) => {
    return node2.type === NodeType.JSXAttribute && predicate(node2);
  };
  return traverseUpGuard(node, guard);
}
function isInsidePropValue(node) {
  if (isStringLiteral(node)) return node.parent.type === NodeType.JSXAttribute;
  return Option_exports2.isSome(traverseUpProp(node, (n23) => n23.value?.type === NodeType.JSXExpressionContainer));
}
var isLiteral = isOneOf([NodeType.Literal, NodeType.JSXText]);
function isWhiteSpace(node) {
  return Predicate_exports2.isString(node.value) && node.value.trim() === "";
}
function isPaddingSpaces(node) {
  return isLiteral(node) && isWhiteSpace(node) && node.raw.includes("\n");
}
var WEBSITE_URL = "https://eslint-react.xyz";
var getDocsUrl = (pluginName) => (ruleName) => {
  return `${WEBSITE_URL}/rules/${ruleName}`;
};
var createRuleForPlugin = (pluginName) => ESLintUtils.RuleCreator(getDocsUrl());
var store2;
function getGlobalMessage(lang) {
  return store2?.get(lang);
}
var store3;
function getSchemaMessage(lang) {
  return store3?.get(lang);
}
var store4;
function getSpecificMessage(reference, lang) {
  return store4?.get(reference)?.get(lang);
}
function _stringify(input) {
  let type = typeof input;
  if (type === "object") {
    type = (input && Object.getPrototypeOf(input)?.constructor?.name) ?? "null";
  }
  return type === "string" ? `"${input}"` : type === "number" || type === "bigint" || type === "boolean" ? `${input}` : type;
}
function _addIssue(context, label, dataset, config2, other) {
  const input = dataset.value;
  const expected = context.expects;
  const received = _stringify(input);
  const issue = {
    kind: context.kind,
    type: context.type,
    input,
    expected,
    received,
    message: `Invalid ${label}: ${expected ? `Expected ${expected} but r` : "R"}eceived ${received}`,
    // @ts-expect-error
    requirement: context.requirement,
    path: other?.path,
    issues: other?.issues,
    lang: config2.lang,
    abortEarly: config2.abortEarly,
    abortPipeEarly: config2.abortPipeEarly,
    skipPipe: config2.skipPipe
  };
  const isSchema = context.kind === "schema";
  const message = (
    // @ts-expect-error
    context.message ?? getSpecificMessage(context.reference, issue.lang) ?? (isSchema ? getSchemaMessage(issue.lang) : null) ?? config2.message ?? getGlobalMessage(issue.lang)
  );
  if (message) {
    issue.message = typeof message === "function" ? message(issue) : message;
  }
  if (isSchema) {
    dataset.typed = false;
  }
  if (dataset.issues) {
    dataset.issues.push(issue);
  } else {
    dataset.issues = [issue];
  }
}
function getDefault(schema, dataset, config2) {
  return typeof schema.default === "function" ? (
    // @ts-expect-error
    schema.default(dataset, config2)
  ) : (
    // @ts-expect-error
    schema.default
  );
}
function array6(item, message) {
  return {
    kind: "schema",
    type: "array",
    reference: array6,
    expects: "Array",
    async: false,
    item,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (Array.isArray(input)) {
        dataset.typed = true;
        dataset.value = [];
        for (let key = 0; key < input.length; key++) {
          const value2 = input[key];
          const itemDataset = this.item._run({ typed: false, value: value2 }, config2);
          if (itemDataset.issues) {
            const pathItem = {
              type: "array",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of itemDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = itemDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!itemDataset.typed) {
            dataset.typed = false;
          }
          dataset.value.push(itemDataset.value);
        }
      } else {
        _addIssue(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function object(entries, message) {
  return {
    kind: "schema",
    type: "object",
    reference: object,
    expects: "Object",
    async: false,
    entries,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (input && typeof input === "object") {
        dataset.typed = true;
        dataset.value = {};
        for (const key in this.entries) {
          const value2 = input[key];
          const valueDataset = this.entries[key]._run(
            { typed: false, value: value2 },
            config2
          );
          if (valueDataset.issues) {
            const pathItem = {
              type: "object",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of valueDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = valueDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!valueDataset.typed) {
            dataset.typed = false;
          }
          if (valueDataset.value !== void 0 || key in input) {
            dataset.value[key] = valueDataset.value;
          }
        }
      } else {
        _addIssue(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function optional(wrapped, ...args) {
  const schema = {
    kind: "schema",
    type: "optional",
    reference: optional,
    expects: `${wrapped.expects} | undefined`,
    async: false,
    wrapped,
    _run(dataset, config2) {
      if (dataset.value === void 0) {
        if ("default" in this) {
          dataset.value = getDefault(
            this,
            dataset,
            config2
          );
        }
        if (dataset.value === void 0) {
          dataset.typed = true;
          return dataset;
        }
      }
      return this.wrapped._run(dataset, config2);
    }
  };
  if (0 in args) {
    schema.default = args[0];
  }
  return schema;
}
function string4(message) {
  return {
    kind: "schema",
    type: "string",
    reference: string4,
    expects: "string",
    async: false,
    message,
    _run(dataset, config2) {
      if (typeof dataset.value === "string") {
        dataset.typed = true;
      } else {
        _addIssue(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
var ESLintReactSettingsSchema = object({
  additionalHooks: optional(object({
    use: optional(string4()),
    useCallback: optional(array6(string4())),
    useContext: optional(array6(string4())),
    useDebugValue: optional(array6(string4())),
    useDeferredValue: optional(array6(string4())),
    useEffect: optional(array6(string4())),
    useId: optional(array6(string4())),
    useImperativeHandle: optional(array6(string4())),
    useInsertionEffect: optional(array6(string4())),
    useLayoutEffect: optional(array6(string4())),
    useMemo: optional(array6(string4())),
    useOptimistic: optional(array6(string4())),
    useReducer: optional(array6(string4())),
    useRef: optional(array6(string4())),
    useState: optional(array6(string4())),
    useSyncExternalStore: optional(array6(string4())),
    useTransition: optional(array6(string4()))
  })),
  importSource: optional(string4()),
  jsxPragma: optional(string4()),
  jsxPragmaFrag: optional(string4()),
  version: optional(string4())
});
object({
  reactOptions: optional(ESLintReactSettingsSchema)
});

// src/utils/create-rule.ts
var createRule = createRuleForPlugin();

// src/utils/get-children-to-array-selector.ts
function getChildrenToArraySelector() {
  return [
    ":matches(",
    "CallExpression",
    "[callee.object.property.name=Children]",
    "[callee.property.name=toArray]",
    ",",
    "CallExpression",
    "[callee.object.name=Children]",
    "[callee.property.name=toArray]",
    ")"
  ].join("");
}

// ../../../node_modules/.pnpm/eslint-visitor-keys@3.4.3/node_modules/eslint-visitor-keys/lib/visitor-keys.js
var KEYS3 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES3 = Object.keys(KEYS3);
for (const type of NODE_TYPES3) {
  Object.freeze(KEYS3[type]);
}
Object.freeze(KEYS3);
var visitor_keys_default3 = KEYS3;

// ../../../node_modules/.pnpm/eslint-visitor-keys@3.4.3/node_modules/eslint-visitor-keys/lib/index.js
var KEY_BLACKLIST3 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey3(key) {
  return !KEY_BLACKLIST3.has(key) && key[0] !== "_";
}
function getKeys3(node) {
  return Object.keys(node).filter(filterKey3);
}

// ../../../node_modules/.pnpm/@eslint-community+eslint-utils@4.4.0_eslint@9.4.0/node_modules/@eslint-community/eslint-utils/index.mjs
function getInnermostScope3(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range3 = childScope.block.range;
      if (range3[0] <= location && location < range3[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable3(initialScope, nameOrNode) {
  let name2 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name2 = nameOrNode;
  } else {
    name2 = nameOrNode.name;
    scope = getInnermostScope3(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name2);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate03(token) {
  return !this(token);
}
function negate3(f5) {
  return negate03.bind(f5);
}
function isPunctuatorTokenWithValue3(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken3(token) {
  return isPunctuatorTokenWithValue3(token, "=>");
}
function isCommaToken3(token) {
  return isPunctuatorTokenWithValue3(token, ",");
}
function isSemicolonToken3(token) {
  return isPunctuatorTokenWithValue3(token, ";");
}
function isColonToken3(token) {
  return isPunctuatorTokenWithValue3(token, ":");
}
function isOpeningParenToken3(token) {
  return isPunctuatorTokenWithValue3(token, "(");
}
function isClosingParenToken3(token) {
  return isPunctuatorTokenWithValue3(token, ")");
}
function isOpeningBracketToken3(token) {
  return isPunctuatorTokenWithValue3(token, "[");
}
function isClosingBracketToken3(token) {
  return isPunctuatorTokenWithValue3(token, "]");
}
function isOpeningBraceToken3(token) {
  return isPunctuatorTokenWithValue3(token, "{");
}
function isClosingBraceToken3(token) {
  return isPunctuatorTokenWithValue3(token, "}");
}
function isCommentToken3(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate3(isArrowToken3);
negate3(isCommaToken3);
negate3(isSemicolonToken3);
negate3(isColonToken3);
negate3(isOpeningParenToken3);
negate3(isClosingParenToken3);
negate3(isOpeningBracketToken3);
negate3(isClosingBracketToken3);
negate3(isOpeningBraceToken3);
negate3(isClosingBraceToken3);
negate3(isCommentToken3);
function getOpeningParenOfParams3(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken3) : sourceCode.getFirstToken(node, isOpeningParenToken3);
}
function getFunctionHeadLocation3(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken3);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams3(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams3(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject3 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames3 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed3 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k5) => k5 !== "random").map((k5) => Math[k5]).filter((f5) => typeof f5 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f5) => typeof f5 === "function")
);
var callPassThrough3 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed3 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor3(object3, name2) {
  let x5 = object3;
  while ((typeof x5 === "object" || typeof x5 === "function") && x5 !== null) {
    const d5 = Object.getOwnPropertyDescriptor(x5, name2);
    if (d5) {
      return d5;
    }
    x5 = Object.getPrototypeOf(x5);
  }
  return null;
}
function isGetter3(object3, name2) {
  const d5 = getPropertyDescriptor3(object3, name2);
  return d5 != null && d5.get != null;
}
function getElementValues3(nodeList, initialScope) {
  const valueList = [];
  for (let i5 = 0; i5 < nodeList.length; ++i5) {
    const elementNode = nodeList[i5];
    if (elementNode == null) {
      valueList.length = i5 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR3(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR3(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst3(variable) {
  const refs = variable.references;
  const inits = refs.filter((r5) => r5.init).length;
  const reads = refs.filter((r5) => r5.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations3 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues3(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR3(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left9 = getStaticValueR3(node.left, initialScope);
    const right9 = getStaticValueR3(node.right, initialScope);
    if (left9 != null && right9 != null) {
      switch (node.operator) {
        case "==":
          return { value: left9.value == right9.value };
        case "!=":
          return { value: left9.value != right9.value };
        case "===":
          return { value: left9.value === right9.value };
        case "!==":
          return { value: left9.value !== right9.value };
        case "<":
          return { value: left9.value < right9.value };
        case "<=":
          return { value: left9.value <= right9.value };
        case ">":
          return { value: left9.value > right9.value };
        case ">=":
          return { value: left9.value >= right9.value };
        case "<<":
          return { value: left9.value << right9.value };
        case ">>":
          return { value: left9.value >> right9.value };
        case ">>>":
          return { value: left9.value >>> right9.value };
        case "+":
          return { value: left9.value + right9.value };
        case "-":
          return { value: left9.value - right9.value };
        case "*":
          return { value: left9.value * right9.value };
        case "/":
          return { value: left9.value / right9.value };
        case "%":
          return { value: left9.value % right9.value };
        case "**":
          return { value: left9.value ** right9.value };
        case "|":
          return { value: left9.value | right9.value };
        case "^":
          return { value: left9.value ^ right9.value };
        case "&":
          return { value: left9.value & right9.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues3(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object3 = getStaticValueR3(calleeNode.object, initialScope);
        if (object3 != null) {
          if (object3.value == null && (object3.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue3(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object3.value;
            const methodName = property.value;
            if (callAllowed3.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough3.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR3(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed3.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough3.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR3(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR3(node.consequent, initialScope) : getStaticValueR3(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR3(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable3(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames3.has(variable.name) && variable.name in globalObject3) {
        return { value: globalObject3[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst3(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR3(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left9 = getStaticValueR3(node.left, initialScope);
    if (left9 != null) {
      if (node.operator === "||" && Boolean(left9.value) === true || node.operator === "&&" && Boolean(left9.value) === false || node.operator === "??" && left9.value != null) {
        return left9;
      }
      const right9 = getStaticValueR3(node.right, initialScope);
      if (right9 != null) {
        return right9;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object3 = getStaticValueR3(node.object, initialScope);
    if (object3 != null) {
      if (object3.value == null && (object3.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue3(node, initialScope);
      if (property != null) {
        if (!isGetter3(object3.value, property.value)) {
          return { value: object3.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed3) {
          if (object3.value instanceof classFn && allowed.has(property.value)) {
            return { value: object3.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR3(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR3(node.callee, initialScope);
    const args = getElementValues3(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed3.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object3 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue3(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR3(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object3[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR3(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object3, argument.value);
      } else {
        return null;
      }
    }
    return { value: object3 };
  },
  SequenceExpression(node, initialScope) {
    const last3 = node.expressions[node.expressions.length - 1];
    return getStaticValueR3(last3, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR3(node.tag, initialScope);
    const expressions = getElementValues3(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues3(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i5 = 0; i5 < expressions.length; ++i5) {
        value += expressions[i5];
        value += node.quasis[i5 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR3(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR3(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations3, node.type)) {
    return operations3[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue3(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR3(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue4(node, initialScope = null) {
  try {
    return getStaticValueR3(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant3(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue4(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName3(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant3(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant3(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind3(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name2 = getPropertyName3(parent);
      if (name2) {
        tokens.push(`'${name2}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps3 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps3 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode3(x5) {
  return x5 !== null && typeof x5 === "object" && typeof x5.type === "string";
}
var visitor3 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys3(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode3(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode3(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps3.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps3.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect3(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor3.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default3
  );
}
function getParentSyntaxParen3(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken3
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken3
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized3(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken3(maybeLeftParen) && isClosingParenToken3(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen3(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp4 = Object.defineProperty;
var __export4 = (target, all33) => {
  for (var name2 in all33)
    __defProp4(target, name2, { get: all33[name2], enumerable: true });
};
var NodeType3 = AST_NODE_TYPES;
var is3 = ASTUtils.isNodeOfType;
var isOneOf3 = ASTUtils.isNodeOfTypes;
var isFunction = isOneOf3([
  NodeType3.ArrowFunctionExpression,
  NodeType3.FunctionDeclaration,
  NodeType3.FunctionExpression
]);
isOneOf3([
  NodeType3.ArrowFunctionExpression,
  NodeType3.FunctionDeclaration,
  NodeType3.FunctionExpression,
  NodeType3.TSCallSignatureDeclaration,
  NodeType3.TSConstructSignatureDeclaration,
  NodeType3.TSDeclareFunction,
  NodeType3.TSEmptyBodyFunctionExpression,
  NodeType3.TSFunctionType,
  NodeType3.TSMethodSignature
]);
var isClass = isOneOf3([NodeType3.ClassDeclaration, NodeType3.ClassExpression]);
isOneOf3([
  NodeType3.DoWhileStatement,
  NodeType3.ForInStatement,
  NodeType3.ForOfStatement,
  NodeType3.ForStatement,
  NodeType3.WhileStatement
]);
isOneOf3([NodeType3.TSArrayType, NodeType3.TSTupleType]);
isOneOf3([
  NodeType3.PropertyDefinition,
  NodeType3.TSIndexSignature,
  NodeType3.TSParameterProperty,
  NodeType3.TSPropertySignature
]);
is3(NodeType3.JSXElement);
is3(NodeType3.JSXFragment);
var isJSX = isOneOf3([
  NodeType3.JSXAttribute,
  NodeType3.JSXSpreadChild,
  NodeType3.JSXClosingElement,
  NodeType3.JSXClosingFragment,
  NodeType3.JSXElement,
  NodeType3.JSXEmptyExpression,
  NodeType3.JSXExpressionContainer,
  NodeType3.JSXFragment,
  NodeType3.JSXIdentifier,
  NodeType3.JSXMemberExpression,
  NodeType3.JSXNamespacedName,
  NodeType3.JSXOpeningElement,
  NodeType3.JSXOpeningFragment,
  NodeType3.JSXSpreadAttribute,
  NodeType3.JSXSpreadChild,
  NodeType3.JSXText
]);
isOneOf3([
  NodeType3.JSXIdentifier,
  NodeType3.JSXMemberExpression,
  NodeType3.JSXNamespacedName
]);
isOneOf3([
  NodeType3.ArrayPattern,
  NodeType3.AssignmentPattern,
  NodeType3.ObjectPattern,
  NodeType3.RestElement
]);
isOneOf3([
  NodeType3.TSInterfaceDeclaration,
  NodeType3.TSTypeAliasDeclaration
]);
isOneOf3([
  NodeType3.ArrayExpression,
  NodeType3.ArrayPattern,
  NodeType3.ArrowFunctionExpression,
  NodeType3.CallExpression,
  NodeType3.ClassExpression,
  NodeType3.FunctionExpression,
  NodeType3.Identifier,
  NodeType3.JSXElement,
  NodeType3.JSXFragment,
  NodeType3.Literal,
  NodeType3.TemplateLiteral,
  NodeType3.MemberExpression,
  NodeType3.MetaProperty,
  NodeType3.ObjectExpression,
  NodeType3.ObjectPattern,
  NodeType3.SequenceExpression,
  NodeType3.Super,
  NodeType3.TaggedTemplateExpression,
  NodeType3.ThisExpression
]);
isOneOf3([
  NodeType3.ArrayExpression,
  NodeType3.ArrayPattern,
  NodeType3.ArrowFunctionExpression,
  NodeType3.CallExpression,
  NodeType3.ClassExpression,
  NodeType3.FunctionExpression,
  NodeType3.Identifier,
  NodeType3.JSXElement,
  NodeType3.JSXFragment,
  NodeType3.Literal,
  NodeType3.TemplateLiteral,
  NodeType3.MemberExpression,
  NodeType3.MetaProperty,
  NodeType3.ObjectExpression,
  NodeType3.ObjectPattern,
  NodeType3.SequenceExpression,
  NodeType3.Super,
  NodeType3.TaggedTemplateExpression,
  NodeType3.ThisExpression,
  NodeType3.TSAsExpression,
  NodeType3.TSNonNullExpression,
  NodeType3.TSTypeAssertion
]);
function isNodeEqual(a5, b5) {
  if (a5.type !== b5.type) return false;
  if (a5.type === NodeType3.ThisExpression && b5.type === NodeType3.ThisExpression) return true;
  if (a5.type === NodeType3.Literal && b5.type === NodeType3.Literal) return a5.value === b5.value;
  if (a5.type === NodeType3.Identifier && b5.type === NodeType3.Identifier) return a5.name === b5.name;
  if (a5.type === NodeType3.MemberExpression && b5.type === NodeType3.MemberExpression) {
    return isNodeEqual(a5.property, b5.property) && isNodeEqual(a5.object, b5.object);
  }
  return false;
}
function getLiteralValueType(input) {
  return $(input).with(null, () => "Null").with(N.boolean, () => "Boolean").with(N.number, () => "Number").with(N.string, () => "String").with(N.bigint, () => "BigInt").with(N.symbol, () => "Symbol").exhaustive();
}
function readableNodeType(node) {
  if (node.type === NodeType3.Literal) {
    if ("regex" in node) return "RegExp literal";
    return `${getLiteralValueType(node.value)} literal`;
  }
  if (isJSX(node)) return `JSX ${toLowerCase(delimiterCase(replace(node.type, "JSX", ""), " "))}`;
  return toLowerCase(delimiterCase(node.type, " "));
}
var Function_exports4 = {};
__export4(Function_exports4, {
  SK: () => SK4,
  absurd: () => absurd4,
  apply: () => apply4,
  compose: () => compose6,
  constFalse: () => constFalse4,
  constNull: () => constNull4,
  constTrue: () => constTrue4,
  constUndefined: () => constUndefined4,
  constVoid: () => constVoid4,
  constant: () => constant4,
  dual: () => dual4,
  flip: () => flip4,
  flow: () => flow4,
  hole: () => hole4,
  identity: () => identity4,
  isFunction: () => isFunction23,
  pipe: () => pipe4,
  satisfies: () => satisfies4,
  tupled: () => tupled4,
  unsafeCoerce: () => unsafeCoerce4,
  untupled: () => untupled4
});
var isFunction23 = (input) => typeof input === "function";
var dual4 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a5, b5) {
        if (arguments.length >= 2) {
          return body(a5, b5);
        }
        return function(self2) {
          return body(self2, a5);
        };
      };
    case 3:
      return function(a5, b5, c5) {
        if (arguments.length >= 3) {
          return body(a5, b5, c5);
        }
        return function(self2) {
          return body(self2, a5, b5);
        };
      };
    case 4:
      return function(a5, b5, c5, d5) {
        if (arguments.length >= 4) {
          return body(a5, b5, c5, d5);
        }
        return function(self2) {
          return body(self2, a5, b5, c5);
        };
      };
    case 5:
      return function(a5, b5, c5, d5, e5) {
        if (arguments.length >= 5) {
          return body(a5, b5, c5, d5, e5);
        }
        return function(self2) {
          return body(self2, a5, b5, c5, d5);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply4 = (a5) => (self2) => self2(a5);
var identity4 = (a5) => a5;
var satisfies4 = () => (b5) => b5;
var unsafeCoerce4 = identity4;
var constant4 = (value) => () => value;
var constTrue4 = /* @__PURE__ */ constant4(true);
var constFalse4 = /* @__PURE__ */ constant4(false);
var constNull4 = /* @__PURE__ */ constant4(null);
var constUndefined4 = /* @__PURE__ */ constant4(void 0);
var constVoid4 = constUndefined4;
var flip4 = (f5) => (...b5) => (...a5) => f5(...a5)(...b5);
var compose6 = /* @__PURE__ */ dual4(2, (ab, bc) => (a5) => bc(ab(a5)));
var absurd4 = (_5) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled4 = (f5) => (a5) => f5(...a5);
var untupled4 = (f5) => (...a5) => f5(a5);
function pipe4(a5, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a5;
    case 2:
      return ab(a5);
    case 3:
      return bc(ab(a5));
    case 4:
      return cd(bc(ab(a5)));
    case 5:
      return de(cd(bc(ab(a5))));
    case 6:
      return ef(de(cd(bc(ab(a5)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a5))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a5)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a5))))))));
    default: {
      let ret = arguments[0];
      for (let i5 = 1; i5 < arguments.length; i5++) {
        ret = arguments[i5](ret);
      }
      return ret;
    }
  }
}
function flow4(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole4 = /* @__PURE__ */ unsafeCoerce4(absurd4);
var SK4 = (_5, b5) => b5;
var make12 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_7 = (map63) => dual4(3, (self2, name2, f5) => map63(self2, (a5) => Object.assign({}, a5, {
  [name2]: f5(a5)
})));
var bindTo7 = (map63) => dual4(2, (self2, name2) => map63(self2, (a5) => ({
  [name2]: a5
})));
var bind7 = (map63, flatMap43) => dual4(3, (self2, name2, f5) => flatMap43(self2, (a5) => map63(f5(a5), (b5) => Object.assign({}, a5, {
  [name2]: b5
}))));
var moduleVersion4 = "3.2.8";
var getCurrentVersion4 = () => moduleVersion4;
var globalStoreId4 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion4()}`);
if (!(globalStoreId4 in globalThis)) {
  globalThis[globalStoreId4] = /* @__PURE__ */ new Map();
}
var globalStore4 = globalThis[globalStoreId4];
var globalValue4 = (id, compute) => {
  if (!globalStore4.has(id)) {
    globalStore4.set(id, compute());
  }
  return globalStore4.get(id);
};
var Predicate_exports3 = {};
__export4(Predicate_exports3, {
  all: () => all6,
  and: () => and4,
  compose: () => compose23,
  eqv: () => eqv4,
  every: () => every5,
  hasProperty: () => hasProperty4,
  implies: () => implies4,
  isBigInt: () => isBigInt4,
  isBoolean: () => isBoolean4,
  isDate: () => isDate4,
  isError: () => isError4,
  isFunction: () => isFunction33,
  isIterable: () => isIterable4,
  isMap: () => isMap4,
  isNever: () => isNever4,
  isNotNull: () => isNotNull4,
  isNotNullable: () => isNotNullable4,
  isNotUndefined: () => isNotUndefined4,
  isNull: () => isNull4,
  isNullable: () => isNullable4,
  isNumber: () => isNumber4,
  isObject: () => isObject4,
  isPromise: () => isPromise4,
  isPromiseLike: () => isPromiseLike4,
  isReadonlyRecord: () => isReadonlyRecord4,
  isRecord: () => isRecord4,
  isSet: () => isSet4,
  isString: () => isString4,
  isSymbol: () => isSymbol4,
  isTagged: () => isTagged4,
  isTruthy: () => isTruthy4,
  isUint8Array: () => isUint8Array4,
  isUndefined: () => isUndefined4,
  isUnknown: () => isUnknown4,
  mapInput: () => mapInput5,
  nand: () => nand4,
  nor: () => nor4,
  not: () => not4,
  or: () => or4,
  product: () => product6,
  productMany: () => productMany6,
  some: () => some9,
  struct: () => struct6,
  tuple: () => tuple5,
  xor: () => xor4
});
var mapInput5 = /* @__PURE__ */ dual4(2, (self2, f5) => (b5) => self2(f5(b5)));
var isTruthy4 = (input) => !!input;
var isSet4 = (input) => input instanceof Set;
var isMap4 = (input) => input instanceof Map;
var isString4 = (input) => typeof input === "string";
var isNumber4 = (input) => typeof input === "number";
var isBoolean4 = (input) => typeof input === "boolean";
var isBigInt4 = (input) => typeof input === "bigint";
var isSymbol4 = (input) => typeof input === "symbol";
var isFunction33 = isFunction23;
var isUndefined4 = (input) => input === void 0;
var isNotUndefined4 = (input) => input !== void 0;
var isNull4 = (input) => input === null;
var isNotNull4 = (input) => input !== null;
var isNever4 = (_5) => false;
var isUnknown4 = (_5) => true;
var isRecordOrArray4 = (input) => typeof input === "object" && input !== null;
var isObject4 = (input) => isRecordOrArray4(input) || isFunction33(input);
var hasProperty4 = /* @__PURE__ */ dual4(2, (self2, property) => isObject4(self2) && property in self2);
var isTagged4 = /* @__PURE__ */ dual4(2, (self2, tag) => hasProperty4(self2, "_tag") && self2["_tag"] === tag);
var isNullable4 = (input) => input === null || input === void 0;
var isNotNullable4 = (input) => input !== null && input !== void 0;
var isError4 = (input) => input instanceof Error;
var isUint8Array4 = (input) => input instanceof Uint8Array;
var isDate4 = (input) => input instanceof Date;
var isIterable4 = (input) => hasProperty4(input, Symbol.iterator);
var isRecord4 = (input) => isRecordOrArray4(input) && !Array.isArray(input);
var isReadonlyRecord4 = isRecord4;
var isPromise4 = (input) => hasProperty4(input, "then") && "catch" in input && isFunction33(input.then) && isFunction33(input.catch);
var isPromiseLike4 = (input) => hasProperty4(input, "then") && isFunction33(input.then);
var compose23 = /* @__PURE__ */ dual4(2, (ab, bc) => (a5) => ab(a5) && bc(a5));
var product6 = (self2, that) => ([a5, b5]) => self2(a5) && that(b5);
var all6 = (collection) => {
  return (as25) => {
    let collectionIndex = 0;
    for (const p5 of collection) {
      if (collectionIndex >= as25.length) {
        break;
      }
      if (p5(as25[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany6 = (self2, collection) => {
  const rest = all6(collection);
  return ([head23, ...tail4]) => self2(head23) === false ? false : rest(tail4);
};
var tuple5 = (...elements) => all6(elements);
var struct6 = (fields) => {
  const keys23 = Object.keys(fields);
  return (a5) => {
    for (const key of keys23) {
      if (!fields[key](a5[key])) {
        return false;
      }
    }
    return true;
  };
};
var not4 = (self2) => (a5) => !self2(a5);
var or4 = /* @__PURE__ */ dual4(2, (self2, that) => (a5) => self2(a5) || that(a5));
var and4 = /* @__PURE__ */ dual4(2, (self2, that) => (a5) => self2(a5) && that(a5));
var xor4 = /* @__PURE__ */ dual4(2, (self2, that) => (a5) => self2(a5) !== that(a5));
var eqv4 = /* @__PURE__ */ dual4(2, (self2, that) => (a5) => self2(a5) === that(a5));
var implies4 = /* @__PURE__ */ dual4(2, (self2, that) => (a5) => self2(a5) ? that(a5) : true);
var nor4 = /* @__PURE__ */ dual4(2, (self2, that) => (a5) => !(self2(a5) || that(a5)));
var nand4 = /* @__PURE__ */ dual4(2, (self2, that) => (a5) => !(self2(a5) && that(a5)));
var every5 = (collection) => (a5) => {
  for (const p5 of collection) {
    if (!p5(a5)) {
      return false;
    }
  }
  return true;
};
var some9 = (collection) => (a5) => {
  for (const p5 of collection) {
    if (p5(a5)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage4 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId4 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind4 = (u5) => isObject4(u5) && GenKindTypeId4 in u5;
var GenKindImpl4 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity4;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_5) => _5;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_5) => _5;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_5) => _5;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId4] = GenKindTypeId4;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen5(this);
  }
};
var SingleShotGen5 = class _SingleShotGen6 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a5) {
    return this.called ? {
      value: a5,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a5) {
    return {
      value: a5,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e5) {
    throw e5;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen6(this.self);
  }
};
var adapter6 = () => function() {
  let x5 = arguments[0];
  for (let i5 = 1; i5 < arguments.length; i5++) {
    x5 = arguments[i5](x5);
  }
  return new GenKindImpl4(x5);
};
var defaultIncHi4 = 335903614;
var defaultIncLo4 = 4150755663;
var MUL_HI4 = 1481765933 >>> 0;
var MUL_LO4 = 1284865837 >>> 0;
var BIT_534 = 9007199254740992;
var BIT_274 = 134217728;
var PCGRandom4 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable4(seedLo) && isNullable4(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable4(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable4(incLo) && isNullable4(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo4;
      incHi = this._state ? this._state[2] : defaultIncHi4;
    } else if (isNullable4(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add644(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max4) {
    if (!max4) {
      return this._next();
    }
    max4 = max4 >>> 0;
    if ((max4 & max4 - 1) === 0) {
      return this._next() & max4 - 1;
    }
    let num = 0;
    const skew = (-max4 >>> 0) % max4 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max4;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_274 + lo) / BIT_534;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul644(this._state, oldHi, oldLo, MUL_HI4, MUL_LO4);
    add644(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul644(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add644(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId4 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap4 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId4]() {
    return this.#value;
  }
};
function yieldWrapGet4(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId4 in self2) {
    return self2[YieldWrapTypeId4]();
  }
  throw new Error(getBugErrorMessage4("yieldWrapGet"));
}
var structuralRegionState4 = /* @__PURE__ */ globalValue4("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache4 = /* @__PURE__ */ globalValue4(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr4 = /* @__PURE__ */ globalValue4(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom4());
var symbol6 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash4 = (self2) => {
  if (structuralRegionState4.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number5(self2);
    case "bigint":
      return string5(self2.toString(10));
    case "boolean":
      return string5(String(self2));
    case "symbol":
      return string5(String(self2));
    case "string":
      return string5(self2);
    case "undefined":
      return string5("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string5("null");
      } else if (self2 instanceof Date) {
        return hash4(self2.toISOString());
      } else if (isHash4(self2)) {
        return self2[symbol6]();
      } else {
        return random4(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random4 = (self2) => {
  if (!randomHashCache4.has(self2)) {
    randomHashCache4.set(self2, number5(pcgr4.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache4.get(self2);
};
var combine5 = (b5) => (self2) => self2 * 53 ^ b5;
var optimize4 = (n5) => n5 & 3221225471 | n5 >>> 1 & 1073741824;
var isHash4 = (u5) => hasProperty4(u5, symbol6);
var number5 = (n5) => {
  if (n5 !== n5 || n5 === Infinity) {
    return 0;
  }
  let h5 = n5 | 0;
  if (h5 !== n5) {
    h5 ^= n5 * 4294967295;
  }
  while (n5 > 4294967295) {
    h5 ^= n5 /= 4294967295;
  }
  return optimize4(n5);
};
var string5 = (str) => {
  let h5 = 5381, i5 = str.length;
  while (i5) {
    h5 = h5 * 33 ^ str.charCodeAt(--i5);
  }
  return optimize4(h5);
};
var structureKeys2 = (o5, keys23) => {
  let h5 = 12289;
  for (let i5 = 0; i5 < keys23.length; i5++) {
    h5 ^= pipe4(string5(keys23[i5]), combine5(hash4(o5[keys23[i5]])));
  }
  return optimize4(h5);
};
var structure2 = (o5) => structureKeys2(o5, Object.keys(o5));
var array7 = (arr) => {
  let h5 = 6151;
  for (let i5 = 0; i5 < arr.length; i5++) {
    h5 = pipe4(h5, combine5(hash4(arr[i5])));
  }
  return optimize4(h5);
};
var cached4 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash33) {
      Object.defineProperty(self22, symbol6, {
        value() {
          return hash33;
        },
        enumerable: false
      });
      return hash33;
    };
  }
  const self2 = arguments[0];
  const hash25 = arguments[1];
  Object.defineProperty(self2, symbol6, {
    value() {
      return hash25;
    },
    enumerable: false
  });
  return hash25;
};
var symbol23 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals4() {
  if (arguments.length === 1) {
    return (self2) => compareBoth4(self2, arguments[0]);
  }
  return compareBoth4(arguments[0], arguments[1]);
}
function compareBoth4(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual4(self2) && isEqual4(that)) {
        if (hash4(self2) === hash4(that) && self2[symbol23](that)) {
          return true;
        } else {
          return structuralRegionState4.enabled && structuralRegionState4.tester ? structuralRegionState4.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState4.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v5, i5) => compareBoth4(v5, that[i5]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth4(self2[key], that[key]))) {
              return structuralRegionState4.tester ? structuralRegionState4.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState4.tester ? structuralRegionState4.tester(self2, that) : false;
    }
  }
  return structuralRegionState4.enabled && structuralRegionState4.tester ? structuralRegionState4.tester(self2, that) : false;
}
var isEqual4 = (u5) => hasProperty4(u5, symbol23);
var equivalence4 = () => equals4;
var NodeInspectSymbol4 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON4 = (x5) => {
  if (hasProperty4(x5, "toJSON") && isFunction33(x5["toJSON"]) && x5["toJSON"].length === 0) {
    return x5.toJSON();
  } else if (Array.isArray(x5)) {
    return x5.map(toJSON4);
  }
  return x5;
};
var format4 = (x5) => JSON.stringify(x5, null, 2);
var pipeArguments4 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i5 = 0, len = args.length; i5 < len; i5++) {
        ret = args[i5](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT2 = "Commit";
var OP_FAILURE3 = "Failure";
var OP_WITH_RUNTIME3 = "WithRuntime";
var EffectTypeId5 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId4 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId4 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId4 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance4 = {
  /* c8 ignore next */
  _R: (_5) => _5,
  /* c8 ignore next */
  _E: (_5) => _5,
  /* c8 ignore next */
  _A: (_5) => _5,
  _V: /* @__PURE__ */ getCurrentVersion4()
};
var sinkVariance4 = {
  /* c8 ignore next */
  _A: (_5) => _5,
  /* c8 ignore next */
  _In: (_5) => _5,
  /* c8 ignore next */
  _L: (_5) => _5,
  /* c8 ignore next */
  _E: (_5) => _5,
  /* c8 ignore next */
  _R: (_5) => _5
};
var channelVariance4 = {
  /* c8 ignore next */
  _Env: (_5) => _5,
  /* c8 ignore next */
  _InErr: (_5) => _5,
  /* c8 ignore next */
  _InElem: (_5) => _5,
  /* c8 ignore next */
  _InDone: (_5) => _5,
  /* c8 ignore next */
  _OutErr: (_5) => _5,
  /* c8 ignore next */
  _OutElem: (_5) => _5,
  /* c8 ignore next */
  _OutDone: (_5) => _5
};
var EffectPrototype4 = {
  [EffectTypeId5]: effectVariance4,
  [StreamTypeId4]: effectVariance4,
  [SinkTypeId4]: sinkVariance4,
  [ChannelTypeId4]: channelVariance4,
  [symbol23](that) {
    return this === that;
  },
  [symbol6]() {
    return cached4(this, random4(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen5(new YieldWrap4(this));
  },
  pipe() {
    return pipeArguments4(this, arguments);
  }
};
var StructuralPrototype2 = {
  [symbol6]() {
    return cached4(this, structure2(this));
  },
  [symbol23](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals4(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype2 = {
  ...EffectPrototype4,
  _op: OP_COMMIT2
};
var StructuralCommitPrototype2 = {
  ...CommitPrototype2,
  ...StructuralPrototype2
};
var TypeId10 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto6 = {
  ...EffectPrototype4,
  [TypeId10]: {
    _A: (_5) => _5
  },
  [NodeInspectSymbol4]() {
    return this.toJSON();
  },
  toString() {
    return format4(this.toJSON());
  }
};
var SomeProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto6), {
  _tag: "Some",
  _op: "Some",
  [symbol23](that) {
    return isOption6(that) && isSome6(that) && equals4(this.value, that.value);
  },
  [symbol6]() {
    return cached4(this, combine5(hash4(this._tag))(hash4(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON4(this.value)
    };
  }
});
var NoneHash4 = /* @__PURE__ */ hash4("None");
var NoneProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto6), {
  _tag: "None",
  _op: "None",
  [symbol23](that) {
    return isOption6(that) && isNone6(that);
  },
  [symbol6]() {
    return NoneHash4;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption6 = (input) => hasProperty4(input, TypeId10);
var isNone6 = (fa) => fa._tag === "None";
var isSome6 = (fa) => fa._tag === "Some";
var none6 = /* @__PURE__ */ Object.create(NoneProto4);
var some23 = (value) => {
  const a5 = Object.create(SomeProto4);
  a5.value = value;
  return a5;
};
var TypeId23 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto23 = {
  ...EffectPrototype4,
  [TypeId23]: {
    _R: (_5) => _5
  },
  [NodeInspectSymbol4]() {
    return this.toJSON();
  },
  toString() {
    return format4(this.toJSON());
  }
};
var RightProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto23), {
  _tag: "Right",
  _op: "Right",
  [symbol23](that) {
    return isEither4(that) && isRight5(that) && equals4(this.right, that.right);
  },
  [symbol6]() {
    return combine5(hash4(this._tag))(hash4(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON4(this.right)
    };
  }
});
var LeftProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto23), {
  _tag: "Left",
  _op: "Left",
  [symbol23](that) {
    return isEither4(that) && isLeft5(that) && equals4(this.left, that.left);
  },
  [symbol6]() {
    return combine5(hash4(this._tag))(hash4(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON4(this.left)
    };
  }
});
var isEither4 = (input) => hasProperty4(input, TypeId23);
var isLeft5 = (ma) => ma._tag === "Left";
var isRight5 = (ma) => ma._tag === "Right";
var left5 = (left33) => {
  const a5 = Object.create(LeftProto4);
  a5.left = left33;
  return a5;
};
var right5 = (right33) => {
  const a5 = Object.create(RightProto4);
  a5.right = right33;
  return a5;
};
var getLeft6 = (self2) => isRight5(self2) ? none6 : some23(self2.left);
var getRight6 = (self2) => isLeft5(self2) ? none6 : some23(self2.right);
var right23 = right5;
var left23 = left5;
var Option_exports4 = {};
__export4(Option_exports4, {
  Do: () => Do5,
  TypeId: () => TypeId33,
  all: () => all23,
  andThen: () => andThen4,
  ap: () => ap4,
  as: () => as4,
  asVoid: () => asVoid4,
  bind: () => bind23,
  bindTo: () => bindTo23,
  composeK: () => composeK4,
  contains: () => contains5,
  containsWith: () => containsWith5,
  exists: () => exists4,
  filter: () => filter5,
  filterMap: () => filterMap5,
  firstSomeOf: () => firstSomeOf4,
  flatMap: () => flatMap5,
  flatMapNullable: () => flatMapNullable5,
  flatten: () => flatten5,
  fromIterable: () => fromIterable6,
  fromNullable: () => fromNullable5,
  gen: () => gen4,
  getEquivalence: () => getEquivalence6,
  getLeft: () => getLeft23,
  getOrElse: () => getOrElse4,
  getOrNull: () => getOrNull4,
  getOrThrow: () => getOrThrow4,
  getOrThrowWith: () => getOrThrowWith4,
  getOrUndefined: () => getOrUndefined4,
  getOrder: () => getOrder5,
  getRight: () => getRight23,
  isNone: () => isNone23,
  isOption: () => isOption23,
  isSome: () => isSome23,
  let: () => let_23,
  lift2: () => lift24,
  liftNullable: () => liftNullable5,
  liftPredicate: () => liftPredicate5,
  liftThrowable: () => liftThrowable4,
  map: () => map5,
  match: () => match23,
  none: () => none23,
  orElse: () => orElse4,
  orElseEither: () => orElseEither4,
  orElseSome: () => orElseSome4,
  partitionMap: () => partitionMap5,
  product: () => product23,
  productMany: () => productMany23,
  reduceCompact: () => reduceCompact4,
  some: () => some33,
  tap: () => tap4,
  toArray: () => toArray4,
  toRefinement: () => toRefinement4,
  void: () => void_4,
  zipLeft: () => zipLeft4,
  zipRight: () => zipRight4,
  zipWith: () => zipWith5
});
var make23 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId33 = /* @__PURE__ */ Symbol.for("effect/Option");
var none23 = () => none6;
var some33 = some23;
var isOption23 = isOption6;
var isNone23 = isNone6;
var isSome23 = isSome6;
var match23 = /* @__PURE__ */ dual4(2, (self2, {
  onNone,
  onSome
}) => isNone23(self2) ? onNone() : onSome(self2.value));
var toRefinement4 = (f5) => (a5) => isSome23(f5(a5));
var fromIterable6 = (collection) => {
  for (const a5 of collection) {
    return some33(a5);
  }
  return none23();
};
var getRight23 = getRight6;
var getLeft23 = getLeft6;
var getOrElse4 = /* @__PURE__ */ dual4(2, (self2, onNone) => isNone23(self2) ? onNone() : self2.value);
var orElse4 = /* @__PURE__ */ dual4(2, (self2, that) => isNone23(self2) ? that() : self2);
var orElseSome4 = /* @__PURE__ */ dual4(2, (self2, onNone) => isNone23(self2) ? some33(onNone()) : self2);
var orElseEither4 = /* @__PURE__ */ dual4(2, (self2, that) => isNone23(self2) ? map5(that(), right5) : map5(self2, left5));
var firstSomeOf4 = (collection) => {
  let out = none23();
  for (out of collection) {
    if (isSome23(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable5 = (nullableValue) => nullableValue == null ? none23() : some33(nullableValue);
var liftNullable5 = (f5) => (...a5) => fromNullable5(f5(...a5));
var getOrNull4 = /* @__PURE__ */ getOrElse4(constNull4);
var getOrUndefined4 = /* @__PURE__ */ getOrElse4(constUndefined4);
var liftThrowable4 = (f5) => (...a5) => {
  try {
    return some33(f5(...a5));
  } catch (e5) {
    return none23();
  }
};
var getOrThrowWith4 = /* @__PURE__ */ dual4(2, (self2, onNone) => {
  if (isSome23(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow4 = /* @__PURE__ */ getOrThrowWith4(() => new Error("getOrThrow called on a None"));
var map5 = /* @__PURE__ */ dual4(2, (self2, f5) => isNone23(self2) ? none23() : some33(f5(self2.value)));
var as4 = /* @__PURE__ */ dual4(2, (self2, b5) => map5(self2, () => b5));
var asVoid4 = /* @__PURE__ */ as4(void 0);
var void_4 = /* @__PURE__ */ some33(void 0);
var flatMap5 = /* @__PURE__ */ dual4(2, (self2, f5) => isNone23(self2) ? none23() : f5(self2.value));
var andThen4 = /* @__PURE__ */ dual4(2, (self2, f5) => flatMap5(self2, (a5) => {
  const b5 = isFunction23(f5) ? f5(a5) : f5;
  return isOption23(b5) ? b5 : some33(b5);
}));
var flatMapNullable5 = /* @__PURE__ */ dual4(2, (self2, f5) => isNone23(self2) ? none23() : fromNullable5(f5(self2.value)));
var flatten5 = /* @__PURE__ */ flatMap5(identity4);
var zipRight4 = /* @__PURE__ */ dual4(2, (self2, that) => flatMap5(self2, () => that));
var composeK4 = /* @__PURE__ */ dual4(2, (afb, bfc) => (a5) => flatMap5(afb(a5), bfc));
var zipLeft4 = /* @__PURE__ */ dual4(2, (self2, that) => tap4(self2, () => that));
var tap4 = /* @__PURE__ */ dual4(2, (self2, f5) => flatMap5(self2, (a5) => map5(f5(a5), () => a5)));
var product23 = (self2, that) => isSome23(self2) && isSome23(that) ? some33([self2.value, that.value]) : none23();
var productMany23 = (self2, collection) => {
  if (isNone23(self2)) {
    return none23();
  }
  const out = [self2.value];
  for (const o5 of collection) {
    if (isNone23(o5)) {
      return none23();
    }
    out.push(o5.value);
  }
  return some33(out);
};
var all23 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o5 of input) {
      if (isNone23(o5)) {
        return none23();
      }
      out2.push(o5.value);
    }
    return some33(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o5 = input[key];
    if (isNone23(o5)) {
      return none23();
    }
    out[key] = o5.value;
  }
  return some33(out);
};
var zipWith5 = /* @__PURE__ */ dual4(3, (self2, that, f5) => map5(product23(self2, that), ([a5, b5]) => f5(a5, b5)));
var ap4 = /* @__PURE__ */ dual4(2, (self2, that) => zipWith5(self2, that, (f5, a5) => f5(a5)));
var reduceCompact4 = /* @__PURE__ */ dual4(3, (self2, b5, f5) => {
  let out = b5;
  for (const oa of self2) {
    if (isSome23(oa)) {
      out = f5(out, oa.value);
    }
  }
  return out;
});
var toArray4 = (self2) => isNone23(self2) ? [] : [self2.value];
var partitionMap5 = /* @__PURE__ */ dual4(2, (self2, f5) => {
  if (isNone23(self2)) {
    return [none23(), none23()];
  }
  const e5 = f5(self2.value);
  return isLeft5(e5) ? [some33(e5.left), none23()] : [none23(), some33(e5.right)];
});
var filterMap5 = /* @__PURE__ */ dual4(2, (self2, f5) => isNone23(self2) ? none23() : f5(self2.value));
var filter5 = /* @__PURE__ */ dual4(2, (self2, predicate) => filterMap5(self2, (b5) => predicate(b5) ? some23(b5) : none6));
var getEquivalence6 = (isEquivalent) => make12((x5, y5) => x5 === y5 || (isNone23(x5) ? isNone23(y5) : isNone23(y5) ? false : isEquivalent(x5.value, y5.value)));
var getOrder5 = (O5) => make23((self2, that) => isSome23(self2) ? isSome23(that) ? O5(self2.value, that.value) : 1 : -1);
var lift24 = (f5) => dual4(2, (self2, that) => zipWith5(self2, that, f5));
var liftPredicate5 = (predicate) => (b5) => predicate(b5) ? some33(b5) : none23();
var containsWith5 = (isEquivalent) => dual4(2, (self2, a5) => isNone23(self2) ? false : isEquivalent(self2.value, a5));
var _equivalence6 = /* @__PURE__ */ equivalence4();
var contains5 = /* @__PURE__ */ containsWith5(_equivalence6);
var exists4 = /* @__PURE__ */ dual4(2, (self2, refinement) => isNone23(self2) ? false : refinement(self2.value));
var bindTo23 = /* @__PURE__ */ bindTo7(map5);
var let_23 = /* @__PURE__ */ let_7(map5);
var bind23 = /* @__PURE__ */ bind7(map5, flatMap5);
var Do5 = /* @__PURE__ */ some33({});
var adapter23 = /* @__PURE__ */ adapter6();
var gen4 = (f5) => {
  const iterator = f5(adapter23);
  let state = iterator.next();
  if (state.done) {
    return some33(state.value);
  } else {
    let current = state.value;
    if (isGenKind4(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet4(current);
    }
    if (isNone23(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind4(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet4(current);
        }
        if (isNone23(current)) {
          return current;
        }
      }
    }
    return some33(state.value);
  }
};
var fromIterable23 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse5 = (self2) => Array.from(self2).reverse();
var reduce6 = /* @__PURE__ */ dual4(3, (self2, b5, f5) => fromIterable23(self2).reduce((b23, a5, i5) => f5(b23, a5, i5), b5));
var TagTypeId3 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey3 = "effect/STM";
var STMTypeId3 = /* @__PURE__ */ Symbol.for(STMSymbolKey3);
var TagProto3 = {
  ...EffectPrototype4,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId3]: effectVariance4,
  [TagTypeId3]: {
    _Service: (_5) => _5,
    _Identifier: (_5) => _5
  },
  toString() {
    return format4(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol4]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make33(this, self2);
  }
};
var makeGenericTag3 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto3);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId43 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto3 = {
  [TypeId43]: {
    _Services: (_5) => _5
  },
  [symbol23](that) {
    if (isContext3(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k5 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k5) || !equals4(this.unsafeMap.get(k5), that.unsafeMap.get(k5))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol6]() {
    return cached4(this, number5(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments4(this, arguments);
  },
  toString() {
    return format4(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON4)
    };
  },
  [NodeInspectSymbol4]() {
    return this.toJSON();
  }
};
var makeContext3 = (unsafeMap) => {
  const context = Object.create(ContextProto3);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext3 = (u5) => hasProperty4(u5, TypeId43);
var _empty7 = /* @__PURE__ */ makeContext3(/* @__PURE__ */ new Map());
var empty11 = () => _empty7;
var make33 = (tag, service) => makeContext3(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag3 = makeGenericTag3;
var empty23 = empty11;
var TypeId53 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy4(src, srcPos, dest, destPos, len) {
  for (let i5 = srcPos; i5 < Math.min(src.length, srcPos + len); i5++) {
    dest[destPos + i5 - srcPos] = src[i5];
  }
  return dest;
}
var emptyArray3 = [];
var getEquivalence23 = (isEquivalent) => make12((self2, that) => self2.length === that.length && toReadonlyArray3(self2).every((value, i5) => isEquivalent(value, unsafeGet23(that, i5))));
var _equivalence23 = /* @__PURE__ */ getEquivalence23(equals4);
var ChunkProto3 = {
  [TypeId53]: {
    _A: (_5) => _5
  },
  toString() {
    return format4(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray3(this).map(toJSON4)
    };
  },
  [NodeInspectSymbol4]() {
    return this.toJSON();
  },
  [symbol23](that) {
    return isChunk3(that) && _equivalence23(this, that);
  },
  [symbol6]() {
    return cached4(this, array7(toReadonlyArray3(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray3[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray3(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments4(this, arguments);
  }
};
var makeChunk3 = (backing) => {
  const chunk = Object.create(ChunkProto3);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty23;
      chunk.right = _empty23;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty23;
      chunk.right = _empty23;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty23;
      chunk.right = _empty23;
      break;
    }
  }
  return chunk;
};
var isChunk3 = (u5) => hasProperty4(u5, TypeId53);
var _empty23 = /* @__PURE__ */ makeChunk3({
  _tag: "IEmpty"
});
var empty33 = () => _empty23;
var make43 = (...as25) => as25.length === 1 ? of4(as25[0]) : unsafeFromNonEmptyArray3(as25);
var of4 = (a5) => makeChunk3({
  _tag: "ISingleton",
  a: a5
});
var copyToArray3 = (self2, array33, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy4(self2.backing.array, 0, array33, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray3(self2.left, array33, initial);
      copyToArray3(self2.right, array33, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array33[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i5 = 0;
      let j5 = initial;
      while (i5 < self2.length) {
        array33[j5] = unsafeGet23(self2, i5);
        i5 += 1;
        j5 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray3 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray3;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray3(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty23;
      self2.right = _empty23;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse23 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk3({
        _tag: "IArray",
        array: reverse5(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk3({
        _tag: "IConcat",
        left: reverse23(self2.backing.right),
        right: reverse23(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray3(reverse5(toReadonlyArray3(self2)));
  }
};
var unsafeFromArray3 = (self2) => makeChunk3({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray3 = (self2) => unsafeFromArray3(self2);
var unsafeGet23 = /* @__PURE__ */ dual4(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet23(self2.left, index) : unsafeGet23(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet23(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend4 = /* @__PURE__ */ dual4(2, (self2, elem) => appendAll4(of4(elem), self2));
var drop4 = /* @__PURE__ */ dual4(2, (self2, n5) => {
  if (n5 <= 0) {
    return self2;
  } else if (n5 >= self2.length) {
    return _empty23;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk3({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n5,
          length: self2.backing.length - n5
        });
      }
      case "IConcat": {
        if (n5 > self2.left.length) {
          return drop4(self2.right, n5 - self2.left.length);
        }
        return makeChunk3({
          _tag: "IConcat",
          left: drop4(self2.left, n5),
          right: self2.right
        });
      }
      default: {
        return makeChunk3({
          _tag: "ISlice",
          chunk: self2,
          offset: n5,
          length: self2.length - n5
        });
      }
    }
  }
});
var appendAll4 = /* @__PURE__ */ dual4(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff23 = that.depth - self2.depth;
  if (Math.abs(diff23) <= 1) {
    return makeChunk3({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff23 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll4(self2.right, that);
      return makeChunk3({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll4(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk3({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk3({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk3({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk3({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll4(self2, that.left);
      return makeChunk3({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll4(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk3({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk3({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk3({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk3({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty3 = (self2) => self2.length === 0;
var isNonEmpty3 = (self2) => self2.length > 0;
var unsafeHead3 = (self2) => unsafeGet23(self2, 0);
var headNonEmpty4 = unsafeHead3;
var tailNonEmpty4 = (self2) => drop4(self2, 1);
var SIZE3 = 5;
var BUCKET_SIZE3 = /* @__PURE__ */ Math.pow(2, SIZE3);
var MASK3 = BUCKET_SIZE3 - 1;
var MAX_INDEX_NODE3 = BUCKET_SIZE3 / 2;
var MIN_ARRAY_NODE3 = BUCKET_SIZE3 / 4;
function popcount3(x5) {
  x5 -= x5 >> 1 & 1431655765;
  x5 = (x5 & 858993459) + (x5 >> 2 & 858993459);
  x5 = x5 + (x5 >> 4) & 252645135;
  x5 += x5 >> 8;
  x5 += x5 >> 16;
  return x5 & 127;
}
function hashFragment3(shift3, h5) {
  return h5 >>> shift3 & MASK3;
}
function toBitmap3(x5) {
  return 1 << x5;
}
function fromBitmap3(bitmap, bit) {
  return popcount3(bitmap & bit - 1);
}
var make53 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate3(mutate23, at, v5, arr) {
  let out = arr;
  if (!mutate23) {
    const len = arr.length;
    out = new Array(len);
    for (let i5 = 0; i5 < len; ++i5) out[i5] = arr[i5];
  }
  out[at] = v5;
  return out;
}
function arraySpliceOut3(mutate23, at, arr) {
  const newLen = arr.length - 1;
  let i5 = 0;
  let g5 = 0;
  let out = arr;
  if (mutate23) {
    i5 = g5 = at;
  } else {
    out = new Array(newLen);
    while (i5 < at) out[g5++] = arr[i5++];
  }
  ++i5;
  while (i5 <= newLen) out[g5++] = arr[i5++];
  if (mutate23) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn3(mutate23, at, v5, arr) {
  const len = arr.length;
  if (mutate23) {
    let i23 = len;
    while (i23 >= at) arr[i23--] = arr[i23];
    arr[at] = v5;
    return arr;
  }
  let i5 = 0, g5 = 0;
  const out = new Array(len + 1);
  while (i5 < at) out[g5++] = arr[i5++];
  out[at] = v5;
  while (i5 < len) out[++g5] = arr[i5++];
  return out;
}
var EmptyNode3 = class _EmptyNode3 {
  _tag = "EmptyNode";
  modify(edit, _shift, f5, hash25, key, size43) {
    const v5 = f5(none23());
    if (isNone23(v5)) return new _EmptyNode3();
    ++size43.value;
    return new LeafNode3(edit, hash25, key, v5);
  }
};
function isEmptyNode3(a5) {
  return isTagged4(a5, "EmptyNode");
}
function isLeafNode3(node) {
  return isEmptyNode3(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode3(node, edit) {
  return isEmptyNode3(node) ? false : edit === node.edit;
}
var LeafNode3 = class _LeafNode3 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash25, key, value) {
    this.edit = edit;
    this.hash = hash25;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift3, f5, hash25, key, size43) {
    if (equals4(key, this.key)) {
      const v23 = f5(this.value);
      if (v23 === this.value) return this;
      else if (isNone23(v23)) {
        --size43.value;
        return new EmptyNode3();
      }
      if (canEditNode3(this, edit)) {
        this.value = v23;
        return this;
      }
      return new _LeafNode3(edit, hash25, key, v23);
    }
    const v5 = f5(none23());
    if (isNone23(v5)) return this;
    ++size43.value;
    return mergeLeaves3(edit, shift3, this.hash, this, hash25, new _LeafNode3(edit, hash25, key, v5));
  }
};
var CollisionNode3 = class _CollisionNode3 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash25, children) {
    this.edit = edit;
    this.hash = hash25;
    this.children = children;
  }
  modify(edit, shift3, f5, hash25, key, size43) {
    if (hash25 === this.hash) {
      const canEdit = canEditNode3(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f5, key, size43);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode3(edit, this.hash, list) : list[0];
    }
    const v5 = f5(none23());
    if (isNone23(v5)) return this;
    ++size43.value;
    return mergeLeaves3(edit, shift3, this.hash, this, hash25, new LeafNode3(edit, hash25, key, v5));
  }
  updateCollisionList(mutate23, edit, hash25, list, f5, key, size43) {
    const len = list.length;
    for (let i5 = 0; i5 < len; ++i5) {
      const child = list[i5];
      if ("key" in child && equals4(key, child.key)) {
        const value = child.value;
        const newValue2 = f5(value);
        if (newValue2 === value) return list;
        if (isNone23(newValue2)) {
          --size43.value;
          return arraySpliceOut3(mutate23, i5, list);
        }
        return arrayUpdate3(mutate23, i5, new LeafNode3(edit, hash25, key, newValue2), list);
      }
    }
    const newValue = f5(none23());
    if (isNone23(newValue)) return list;
    ++size43.value;
    return arrayUpdate3(mutate23, len, new LeafNode3(edit, hash25, key, newValue), list);
  }
};
var IndexedNode3 = class _IndexedNode3 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift3, f5, hash25, key, size43) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment3(shift3, hash25);
    const bit = toBitmap3(frag);
    const indx = fromBitmap3(mask, bit);
    const exists25 = mask & bit;
    const canEdit = canEditNode3(this, edit);
    if (!exists25) {
      const _newChild = new EmptyNode3().modify(edit, shift3 + SIZE3, f5, hash25, key, size43);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE3 ? expand3(edit, frag, _newChild, mask, children) : new _IndexedNode3(edit, mask | bit, arraySpliceIn3(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift3 + SIZE3, f5, hash25, key, size43);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode3(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode3();
      if (children.length <= 2 && isLeafNode3(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut3(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate3(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode3(edit, bitmap, newChildren);
  }
};
var ArrayNode3 = class _ArrayNode3 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size43, children) {
    this.edit = edit;
    this.size = size43;
    this.children = children;
  }
  modify(edit, shift3, f5, hash25, key, size43) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment3(shift3, hash25);
    const child = children[frag];
    const newChild = (child || new EmptyNode3()).modify(edit, shift3 + SIZE3, f5, hash25, key, size43);
    if (child === newChild) return this;
    const canEdit = canEditNode3(this, edit);
    let newChildren;
    if (isEmptyNode3(child) && !isEmptyNode3(newChild)) {
      ++count;
      newChildren = arrayUpdate3(canEdit, frag, newChild, children);
    } else if (!isEmptyNode3(child) && isEmptyNode3(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE3) {
        return pack3(edit, count, frag, children);
      }
      newChildren = arrayUpdate3(canEdit, frag, new EmptyNode3(), children);
    } else {
      newChildren = arrayUpdate3(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode3(edit, count, newChildren);
  }
};
function pack3(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g5 = 0;
  let bitmap = 0;
  for (let i5 = 0, len = elements.length; i5 < len; ++i5) {
    if (i5 !== removed) {
      const elem = elements[i5];
      if (elem && !isEmptyNode3(elem)) {
        children[g5++] = elem;
        bitmap |= 1 << i5;
      }
    }
  }
  return new IndexedNode3(edit, bitmap, children);
}
function expand3(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i5 = 0; bit; ++i5) {
    if (bit & 1) arr[i5] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode3(edit, count + 1, arr);
}
function mergeLeavesInner3(edit, shift3, h1, n1, h23, n23) {
  if (h1 === h23) return new CollisionNode3(edit, h1, [n23, n1]);
  const subH1 = hashFragment3(shift3, h1);
  const subH2 = hashFragment3(shift3, h23);
  if (subH1 === subH2) {
    return (child) => new IndexedNode3(edit, toBitmap3(subH1) | toBitmap3(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n23] : [n23, n1];
    return new IndexedNode3(edit, toBitmap3(subH1) | toBitmap3(subH2), children);
  }
}
function mergeLeaves3(edit, shift3, h1, n1, h23, n23) {
  let stack = void 0;
  let currentShift = shift3;
  while (true) {
    const res = mergeLeavesInner3(edit, currentShift, h1, n1, h23, n23);
    if (typeof res === "function") {
      stack = make53(res, stack);
      currentShift = currentShift + SIZE3;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey3 = "effect/HashMap";
var HashMapTypeId3 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey3);
var HashMapProto3 = {
  [HashMapTypeId3]: HashMapTypeId3,
  [Symbol.iterator]() {
    return new HashMapIterator3(this, (k5, v5) => [k5, v5]);
  },
  [symbol6]() {
    let hash25 = hash4(HashMapSymbolKey3);
    for (const item of this) {
      hash25 ^= pipe4(hash4(item[0]), combine5(hash4(item[1])));
    }
    return cached4(this, hash25);
  },
  [symbol23](that) {
    if (isHashMap3(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe4(that, getHash3(item[0], hash4(item[0])));
        if (isNone23(elem)) {
          return false;
        } else {
          if (!equals4(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format4(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON4)
    };
  },
  [NodeInspectSymbol4]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments4(this, arguments);
  }
};
var makeImpl4 = (editable, edit, root, size43) => {
  const map63 = Object.create(HashMapProto3);
  map63._editable = editable;
  map63._edit = edit;
  map63._root = root;
  map63._size = size43;
  return map63;
};
var HashMapIterator3 = class _HashMapIterator3 {
  map;
  f;
  v;
  constructor(map63, f5) {
    this.map = map63;
    this.f = f5;
    this.v = visitLazy3(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone23(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont3(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator3(this.map, this.f);
  }
};
var applyCont3 = (cont) => cont ? visitLazyChildren3(cont[0], cont[1], cont[2], cont[3], cont[4]) : none23();
var visitLazy3 = (node, f5, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome23(node.value)) {
        return some33({
          value: f5(node.key, node.value.value),
          cont
        });
      }
      return applyCont3(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren3(children.length, children, 0, f5, cont);
    }
    default: {
      return applyCont3(cont);
    }
  }
};
var visitLazyChildren3 = (len, children, i5, f5, cont) => {
  while (i5 < len) {
    const child = children[i5++];
    if (child && !isEmptyNode3(child)) {
      return visitLazy3(child, f5, [len, children, i5, f5, cont]);
    }
  }
  return applyCont3(cont);
};
var _empty33 = /* @__PURE__ */ makeImpl4(false, 0, /* @__PURE__ */ new EmptyNode3(), 0);
var empty43 = () => _empty33;
var isHashMap3 = (u5) => hasProperty4(u5, HashMapTypeId3);
var getHash3 = /* @__PURE__ */ dual4(3, (self2, key, hash25) => {
  let node = self2._root;
  let shift3 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals4(key, node.key) ? node.value : none23();
      }
      case "CollisionNode": {
        if (hash25 === node.hash) {
          const children = node.children;
          for (let i5 = 0, len = children.length; i5 < len; ++i5) {
            const child = children[i5];
            if ("key" in child && equals4(key, child.key)) {
              return child.value;
            }
          }
        }
        return none23();
      }
      case "IndexedNode": {
        const frag = hashFragment3(shift3, hash25);
        const bit = toBitmap3(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap3(node.mask, bit)];
          shift3 += SIZE3;
          break;
        }
        return none23();
      }
      case "ArrayNode": {
        node = node.children[hashFragment3(shift3, hash25)];
        if (node) {
          shift3 += SIZE3;
          break;
        }
        return none23();
      }
      default:
        return none23();
    }
  }
});
var set3 = /* @__PURE__ */ dual4(3, (self2, key, value) => modifyAt3(self2, key, () => some33(value)));
var setTree3 = /* @__PURE__ */ dual4(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl4(self2._editable, self2._edit, newRoot, newSize);
});
var keys4 = (self2) => new HashMapIterator3(self2, (key) => key);
var size5 = (self2) => self2._size;
var beginMutation4 = (self2) => makeImpl4(true, self2._edit + 1, self2._root, self2._size);
var modifyAt3 = /* @__PURE__ */ dual4(3, (self2, key, f5) => modifyHash3(self2, key, hash4(key), f5));
var modifyHash3 = /* @__PURE__ */ dual4(4, (self2, key, hash25, f5) => {
  const size43 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f5, hash25, key, size43);
  return pipe4(self2, setTree3(newRoot, size43.value));
});
var forEach5 = /* @__PURE__ */ dual4(2, (self2, f5) => reduce23(self2, void 0, (_5, value, key) => f5(value, key)));
var reduce23 = /* @__PURE__ */ dual4(3, (self2, zero, f5) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome23(root.value) ? f5(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i5 = 0, len = children.length; i5 < len; ) {
      const child = children[i5++];
      if (child && !isEmptyNode3(child)) {
        if (child._tag === "LeafNode") {
          if (isSome23(child.value)) {
            zero = f5(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey3 = "effect/HashSet";
var HashSetTypeId3 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey3);
var HashSetProto3 = {
  [HashSetTypeId3]: HashSetTypeId3,
  [Symbol.iterator]() {
    return keys4(this._keyMap);
  },
  [symbol6]() {
    return cached4(this, combine5(hash4(this._keyMap))(hash4(HashSetSymbolKey3)));
  },
  [symbol23](that) {
    if (isHashSet3(that)) {
      return size5(this._keyMap) === size5(that._keyMap) && equals4(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format4(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON4)
    };
  },
  [NodeInspectSymbol4]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments4(this, arguments);
  }
};
var makeImpl23 = (keyMap) => {
  const set25 = Object.create(HashSetProto3);
  set25._keyMap = keyMap;
  return set25;
};
var isHashSet3 = (u5) => hasProperty4(u5, HashSetTypeId3);
var _empty43 = /* @__PURE__ */ makeImpl23(/* @__PURE__ */ empty43());
var empty53 = () => _empty43;
var size23 = (self2) => size5(self2._keyMap);
var beginMutation23 = (self2) => makeImpl23(beginMutation4(self2._keyMap));
var endMutation3 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate3 = /* @__PURE__ */ dual4(2, (self2, f5) => {
  const transient = beginMutation23(self2);
  f5(transient);
  return endMutation3(transient);
});
var add23 = /* @__PURE__ */ dual4(2, (self2, value) => self2._keyMap._editable ? (set3(value, true)(self2._keyMap), self2) : makeImpl23(set3(value, true)(self2._keyMap)));
var union23 = /* @__PURE__ */ dual4(2, (self2, that) => mutate3(empty53(), (set25) => {
  forEach23(self2, (value) => add23(set25, value));
  for (const value of that) {
    add23(set25, value);
  }
}));
var forEach23 = /* @__PURE__ */ dual4(2, (self2, f5) => forEach5(self2._keyMap, (_5, k5) => f5(k5)));
var empty63 = empty53;
var size33 = size23;
var add33 = add23;
var union33 = union23;
var ArrayProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol6]() {
    return cached4(this, array7(this));
  },
  [symbol23](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v5, i5) => equals4(v5, that[i5]));
    } else {
      return false;
    }
  }
});
var Structural4 = /* @__PURE__ */ function() {
  function Structural33(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural33.prototype = StructuralPrototype2;
  return Structural33;
}();
var struct23 = (as25) => Object.assign(Object.create(StructuralPrototype2), as25);
var ContextPatchTypeId3 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance4(a5) {
  return a5;
}
var PatchProto3 = {
  ...Structural4.prototype,
  [ContextPatchTypeId3]: {
    _Value: variance4,
    _Patch: variance4
  }
};
var EmptyProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto3), {
  _tag: "Empty"
});
var _empty53 = /* @__PURE__ */ Object.create(EmptyProto3);
var empty73 = () => _empty53;
var AndThenProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto3), {
  _tag: "AndThen"
});
var makeAndThen3 = (first, second) => {
  const o5 = Object.create(AndThenProto3);
  o5.first = first;
  o5.second = second;
  return o5;
};
var AddServiceProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto3), {
  _tag: "AddService"
});
var makeAddService3 = (key, service) => {
  const o5 = Object.create(AddServiceProto3);
  o5.key = key;
  o5.service = service;
  return o5;
};
var RemoveServiceProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto3), {
  _tag: "RemoveService"
});
var makeRemoveService3 = (key) => {
  const o5 = Object.create(RemoveServiceProto3);
  o5.key = key;
  return o5;
};
var UpdateServiceProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto3), {
  _tag: "UpdateService"
});
var makeUpdateService3 = (key, update23) => {
  const o5 = Object.create(UpdateServiceProto3);
  o5.key = key;
  o5.update = update23;
  return o5;
};
var diff3 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch23 = empty73();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals4(old, newService)) {
        patch23 = combine23(makeUpdateService3(tag, () => newService))(patch23);
      }
    } else {
      missingServices.delete(tag);
      patch23 = combine23(makeAddService3(tag, newService))(patch23);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch23 = combine23(makeRemoveService3(tag))(patch23);
  }
  return patch23;
};
var combine23 = /* @__PURE__ */ dual4(2, (self2, that) => makeAndThen3(self2, that));
var patch3 = /* @__PURE__ */ dual4(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of4(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty3(patches)) {
    const head23 = headNonEmpty4(patches);
    const tail4 = tailNonEmpty4(patches);
    switch (head23._tag) {
      case "Empty": {
        patches = tail4;
        break;
      }
      case "AddService": {
        updatedContext.set(head23.key, head23.service);
        patches = tail4;
        break;
      }
      case "AndThen": {
        patches = prepend4(prepend4(tail4, head23.second), head23.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head23.key);
        patches = tail4;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head23.key, head23.update(updatedContext.get(head23.key)));
        wasServiceUpdated = true;
        patches = tail4;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext3(updatedContext);
  }
  const map63 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map63.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s5] of updatedContext) {
    map63.set(tag, s5);
  }
  return makeContext3(map63);
});
var DifferTypeId3 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto3 = {
  [DifferTypeId3]: {
    _P: identity4,
    _V: identity4
  }
};
var make73 = (params) => {
  const differ = Object.create(DifferProto3);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment3 = () => make73({
  empty: empty73(),
  combine: (first, second) => combine23(second)(first),
  diff: (oldValue, newValue) => diff3(oldValue, newValue),
  patch: (patch23, oldValue) => patch3(oldValue)(patch23)
});
var OP_DIE3 = "Die";
var OP_EMPTY3 = "Empty";
var OP_FAIL3 = "Fail";
var OP_INTERRUPT3 = "Interrupt";
var OP_PARALLEL3 = "Parallel";
var OP_SEQUENTIAL3 = "Sequential";
var CauseSymbolKey3 = "effect/Cause";
var CauseTypeId3 = /* @__PURE__ */ Symbol.for(CauseSymbolKey3);
var variance23 = {
  /* c8 ignore next */
  _E: (_5) => _5
};
var proto3 = {
  [CauseTypeId3]: variance23,
  [symbol6]() {
    return pipe4(hash4(CauseSymbolKey3), combine5(hash4(flattenCause3(this))), cached4(this));
  },
  [symbol23](that) {
    return isCause3(that) && causeEquals3(this, that);
  },
  pipe() {
    return pipeArguments4(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON4(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON4(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON4(this.left),
          right: toJSON4(this.right)
        };
    }
  },
  toString() {
    return pretty3(this);
  },
  [NodeInspectSymbol4]() {
    return this.toJSON();
  }
};
var fail4 = (error) => {
  const o5 = Object.create(proto3);
  o5._tag = OP_FAIL3;
  o5.error = error;
  return o5;
};
var parallel3 = (left33, right33) => {
  const o5 = Object.create(proto3);
  o5._tag = OP_PARALLEL3;
  o5.left = left33;
  o5.right = right33;
  return o5;
};
var sequential3 = (left33, right33) => {
  const o5 = Object.create(proto3);
  o5._tag = OP_SEQUENTIAL3;
  o5.left = left33;
  o5.right = right33;
  return o5;
};
var isCause3 = (u5) => hasProperty4(u5, CauseTypeId3);
var isInterruptedOnly3 = (self2) => reduceWithContext3(void 0, IsInterruptedOnlyCauseReducer3)(self2);
var causeEquals3 = (left33, right33) => {
  let leftStack = of4(left33);
  let rightStack = of4(right33);
  while (isNonEmpty3(leftStack) && isNonEmpty3(rightStack)) {
    const [leftParallel, leftSequential] = pipe4(headNonEmpty4(leftStack), reduce43([empty63(), empty33()], ([parallel23, sequential23], cause) => {
      const [par, seq] = evaluateCause3(cause);
      return some33([pipe4(parallel23, union33(par)), pipe4(sequential23, appendAll4(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe4(headNonEmpty4(rightStack), reduce43([empty63(), empty33()], ([parallel23, sequential23], cause) => {
      const [par, seq] = evaluateCause3(cause);
      return some33([pipe4(parallel23, union33(par)), pipe4(sequential23, appendAll4(seq))]);
    }));
    if (!equals4(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause3 = (cause) => {
  return flattenCauseLoop3(of4(cause), empty33());
};
var flattenCauseLoop3 = (causes, flattened) => {
  while (1) {
    const [parallel23, sequential23] = pipe4(causes, reduce6([empty63(), empty33()], ([parallel33, sequential33], cause) => {
      const [par, seq] = evaluateCause3(cause);
      return [pipe4(parallel33, union33(par)), pipe4(sequential33, appendAll4(seq))];
    }));
    const updated = size33(parallel23) > 0 ? pipe4(flattened, prepend4(parallel23)) : flattened;
    if (isEmpty3(sequential23)) {
      return reverse23(updated);
    }
    causes = sequential23;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage4("Cause.flattenCauseLoop"));
};
var evaluateCause3 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty63();
  let _sequential = empty33();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY3: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL3: {
        _parallel = add33(_parallel, make43(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE3: {
        _parallel = add33(_parallel, make43(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT3: {
        _parallel = add33(_parallel, make43(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL3: {
        switch (cause.left._tag) {
          case OP_EMPTY3: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL3: {
            cause = sequential3(cause.left.left, sequential3(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL3: {
            cause = parallel3(sequential3(cause.left.left, cause.right), sequential3(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend4(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL3: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage4("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer3 = {
  emptyCase: constTrue4,
  failCase: constFalse4,
  dieCase: constFalse4,
  interruptCase: constTrue4,
  sequentialCase: (_5, left33, right33) => left33 && right33,
  parallelCase: (_5, left33, right33) => left33 && right33
};
var OP_SEQUENTIAL_CASE3 = "SequentialCase";
var OP_PARALLEL_CASE3 = "ParallelCase";
var reduce43 = /* @__PURE__ */ dual4(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome23(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL3: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL3: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext3 = /* @__PURE__ */ dual4(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY3: {
        output.push(right23(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL3: {
        output.push(right23(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE3: {
        output.push(right23(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT3: {
        output.push(right23(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL3: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left23({
          _tag: OP_SEQUENTIAL_CASE3
        }));
        break;
      }
      case OP_PARALLEL3: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left23({
          _tag: OP_PARALLEL_CASE3
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE3: {
            const left33 = accumulator.pop();
            const right33 = accumulator.pop();
            const value = reducer.sequentialCase(context, left33, right33);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE3: {
            const left33 = accumulator.pop();
            const right33 = accumulator.pop();
            const value = reducer.parallelCase(context, left33, right33);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty3 = (cause) => {
  if (isInterruptedOnly3(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors3(cause).map((e5) => e5.stack).join("\n");
};
var PrettyError3 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage3(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol4 in originalError) {
        this.span = originalError[spanSymbol4];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack3(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage3 = (u5) => {
  if (typeof u5 === "string") {
    return `Error: ${u5}`;
  }
  try {
    if (hasProperty4(u5, "toString") && isFunction33(u5["toString"]) && u5["toString"] !== Object.prototype.toString && u5["toString"] !== globalThis.Array.prototype.toString) {
      return u5["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u5)}`;
};
var locationRegex3 = /\((.*)\)/;
var spanToTrace3 = /* @__PURE__ */ globalValue4("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack3 = (message, stack, span3) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i5 = 1; i5 < lines.length; i5++) {
    if (lines[i5].includes("Generator.next")) {
      break;
    }
    if (lines[i5].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i5].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span3) {
    let current = span3;
    let i5 = 0;
    while (current && current._tag === "Span" && i5 < 10) {
      const stackFn = spanToTrace3.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex3);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined4(current.parent);
      i5++;
    }
  }
  return out.join("\n");
};
var spanSymbol4 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors3 = (cause) => reduceWithContext3(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_5, unknownError) => {
    return [new PrettyError3(unknownError)];
  },
  failCase: (_5, error) => {
    return [new PrettyError3(error)];
  },
  interruptCase: () => [],
  parallelCase: (_5, l5, r5) => [...l5, ...r5],
  sequentialCase: (_5, l5, r5) => [...l5, ...r5]
});
var SingleShotGen23 = class _SingleShotGen7 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a5) {
    return this.called ? {
      value: a5,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a5) {
    return {
      value: a5,
      done: true
    };
  }
  throw(e5) {
    throw e5;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen7(this.self);
  }
};
var spanTag3 = /* @__PURE__ */ GenericTag3("effect/ParentSpan");
var EffectTypeId23 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive3 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId23] = effectVariance4;
  constructor(_op) {
    this._op = _op;
  }
  [symbol23](that) {
    return this === that;
  }
  [symbol6]() {
    return cached4(this, random4(this));
  }
  pipe() {
    return pipeArguments4(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON4(this.effect_instruction_i0),
      effect_instruction_i1: toJSON4(this.effect_instruction_i1),
      effect_instruction_i2: toJSON4(this.effect_instruction_i2)
    };
  }
  toString() {
    return format4(this.toJSON());
  }
  [NodeInspectSymbol4]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen23(new YieldWrap4(this));
  }
};
var EffectPrimitiveFailure3 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId23] = effectVariance4;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol23](that) {
    return exitIsExit3(that) && that._op === "Failure" && // @ts-expect-error
    equals4(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol6]() {
    return pipe4(
      // @ts-expect-error
      string5(this._tag),
      // @ts-expect-error
      combine5(hash4(this.effect_instruction_i0)),
      cached4(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments4(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format4(this.toJSON());
  }
  [NodeInspectSymbol4]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen23(new YieldWrap4(this));
  }
};
var isEffect3 = (u5) => hasProperty4(u5, EffectTypeId23);
var withFiberRuntime3 = (withRuntime) => {
  const effect = new EffectPrimitive3(OP_WITH_RUNTIME3);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol23 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol3 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture3 = (obj, span3) => {
  if (isSome23(span3)) {
    return new Proxy(obj, {
      has(target, p5) {
        return p5 === spanSymbol23 || p5 === originalSymbol3 || p5 in target;
      },
      get(target, p5) {
        if (p5 === spanSymbol23) {
          return span3.value;
        }
        if (p5 === originalSymbol3) {
          return obj;
        }
        return target[p5];
      }
    });
  }
  return obj;
};
var fail23 = (error) => isObject4(error) && !(spanSymbol23 in error) ? withFiberRuntime3((fiber) => failCause3(fail4(capture3(error, currentSpanFromFiber3(fiber))))) : failCause3(fail4(error));
var failCause3 = (cause) => {
  const effect = new EffectPrimitiveFailure3(OP_FAILURE3);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey3 = "effect/FiberRef";
var FiberRefTypeId3 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey3);
var fiberRefVariance3 = {
  /* c8 ignore next */
  _A: (_5) => _5
};
var fiberRefUnsafeMakeContext3 = (initial) => {
  const differ = environment3();
  return fiberRefUnsafeMakePatch3(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch3 = (initial, options) => ({
  [FiberRefTypeId3]: fiberRefVariance3,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch23) => (oldValue) => options.differ.patch(patch23, oldValue),
  fork: options.fork,
  join: options.join ?? ((_5, n5) => n5),
  pipe() {
    return pipeArguments4(this, arguments);
  }
});
var currentContext3 = /* @__PURE__ */ globalValue4(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext3(empty23()));
var YieldableError3 = /* @__PURE__ */ function() {
  class YieldableError23 extends globalThis.Error {
    commit() {
      return fail23(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol4]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError23.prototype, StructuralCommitPrototype2);
  return YieldableError23;
}();
var exitIsExit3 = (u5) => isEffect3(u5) && "_tag" in u5 && (u5._tag === "Success" || u5._tag === "Failure");
var currentSpanFromFiber3 = (fiber) => {
  const span3 = fiber.getFiberRef(currentContext3).unsafeMap.get(spanTag3.key);
  return span3 !== void 0 && span3._tag === "Span" ? some33(span3) : none23();
};
var Data_exports2 = {};
__export4(Data_exports2, {
  Class: () => Class23,
  Error: () => Error23,
  Structural: () => Structural23,
  TaggedClass: () => TaggedClass3,
  TaggedError: () => TaggedError3,
  array: () => array23,
  case: () => _case3,
  struct: () => struct33,
  tagged: () => tagged3,
  taggedEnum: () => taggedEnum3,
  tuple: () => tuple23,
  unsafeArray: () => unsafeArray3,
  unsafeStruct: () => unsafeStruct3
});
var struct33 = struct23;
var unsafeStruct3 = (as25) => Object.setPrototypeOf(as25, StructuralPrototype2);
var tuple23 = (...as25) => unsafeArray3(as25);
var array23 = (as25) => unsafeArray3(as25.slice(0));
var unsafeArray3 = (as25) => Object.setPrototypeOf(as25, ArrayProto3);
var _case3 = () => (args) => args === void 0 ? Object.create(StructuralPrototype2) : struct33(args);
var tagged3 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype2) : struct33(args);
  value._tag = tag;
  return value;
};
var Class23 = Structural4;
var TaggedClass3 = (tag) => {
  class Base extends Class23 {
    _tag = tag;
  }
  return Base;
};
var Structural23 = Structural4;
var taggedEnum3 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged4;
    } else if (tag === "$match") {
      return taggedMatch3;
    }
    return tagged3(tag);
  }
});
function taggedMatch3() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error23 = /* @__PURE__ */ function() {
  return class Base extends YieldableError3 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError3 = (tag) => {
  class Base extends Error23 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp3 = Function_exports4.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType3.Program) return Option_exports4.none();
  return predicate(parent) ? Option_exports4.some(parent) : traverseUp3(parent, predicate);
});
var traverseUpGuard3 = Function_exports4.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType3.Program) return Option_exports4.none();
  return predicate(parent) ? Option_exports4.some(parent) : traverseUpGuard3(parent, predicate);
});
var ESLintCommunityESLintUtils3;
((ESLintCommunityESLintUtils23) => {
  ESLintCommunityESLintUtils23.getFunctionHeadLocation = getFunctionHeadLocation3;
  ESLintCommunityESLintUtils23.getFunctionNameWithKind = getFunctionNameWithKind3;
  ESLintCommunityESLintUtils23.getPropertyName = getPropertyName3;
  ESLintCommunityESLintUtils23.getStaticValue = getStaticValue4;
  ESLintCommunityESLintUtils23.getStringIfConstant = getStringIfConstant3;
  ESLintCommunityESLintUtils23.hasSideEffect = hasSideEffect3;
  ESLintCommunityESLintUtils23.isParenthesized = isParenthesized3;
})(ESLintCommunityESLintUtils3 || (ESLintCommunityESLintUtils3 = {}));
var Construction3 = Data_exports2.taggedEnum();
var ConstructionHint = {
  None: 0n,
  StrictCallExpression: 1n << 0n
};
var None = Construction3.None();
function inspectConstruction(node, context, hint = ConstructionHint.None) {
  const detect = (node2) => {
    const scope = context.sourceCode.getScope(node2);
    return $(node2).when(is3(NodeType3.ArrayExpression), (node3) => Construction3.Array({ node: node3, usage: Option_exports4.none() })).when(is3(NodeType3.ObjectExpression), (node3) => Construction3.ObjectExpression({ node: node3, usage: Option_exports4.none() })).when(is3(NodeType3.ClassExpression), (node3) => Construction3.ClassExpression({ node: node3, usage: Option_exports4.none() })).when(is3(NodeType3.JSXElement), (node3) => Construction3.JSXElement({ node: node3, usage: Option_exports4.none() })).when(is3(NodeType3.JSXFragment), (node3) => Construction3.JSXFragment({ node: node3, usage: Option_exports4.none() })).when(is3(NodeType3.CallExpression), (node3) => {
      if (hint & ConstructionHint.StrictCallExpression) {
        return Construction3.CallExpression({ node: node3, usage: Option_exports4.none() });
      }
      return None;
    }).when(is3(NodeType3.NewExpression), (node3) => Construction3.NewExpression({ node: node3, usage: Option_exports4.none() })).when(isOneOf3([NodeType3.FunctionExpression, NodeType3.ArrowFunctionExpression]), (node3) => {
      return Construction3.FunctionExpression({ node: node3, usage: Option_exports4.none() });
    }).when(is3(NodeType3.MemberExpression), (node3) => {
      if (!("object" in node3)) return None;
      const object3 = detect(node3.object);
      if (object3._tag === "None") return object3;
      return {
        ...object3,
        usage: Option_exports4.some(node3.object)
      };
    }).when(is3(NodeType3.AssignmentExpression), (node3) => {
      if (!("right" in node3)) return None;
      const right33 = detect(node3.right);
      if (right33._tag === "None") return right33;
      return Construction3.AssignmentExpression({
        node: right33.node,
        usage: Option_exports4.some(node3)
      });
    }).when(is3(NodeType3.AssignmentPattern), (node3) => {
      if (!("right" in node3)) return None;
      const right33 = detect(node3.right);
      if (right33._tag === "None") return right33;
      return Construction3.AssignmentPattern({
        node: right33.node,
        usage: Option_exports4.some(node3)
      });
    }).when(is3(NodeType3.LogicalExpression), (node3) => {
      if (!("left" in node3 && "right" in node3)) return None;
      const left33 = detect(node3.left);
      if (left33._tag !== "None") return left33;
      return detect(node3.right);
    }).when(is3(NodeType3.ConditionalExpression), (node3) => {
      if (!("consequent" in node3 && "alternate" in node3 && !Predicate_exports3.isNullable(node3.alternate))) {
        return None;
      }
      const consequent = detect(node3.consequent);
      if (consequent._tag !== "None") return None;
      return detect(node3.alternate);
    }).when(is3(NodeType3.Identifier), (node3) => {
      if (!("name" in node3 && Predicate_exports3.isString(node3.name))) return None;
      const maybeLatestDef = Option_exports4.fromNullable(scope.set.get(node3.name)?.defs.at(-1));
      if (Option_exports4.isNone(maybeLatestDef)) return None;
      const latestDef = maybeLatestDef.value;
      if (latestDef.type !== DefinitionType.Variable && latestDef.type !== DefinitionType.FunctionName) {
        return None;
      }
      if (latestDef.node.type === NodeType3.FunctionDeclaration) {
        return Construction3.FunctionDeclaration({
          node: latestDef.node,
          usage: Option_exports4.some(node3)
        });
      }
      if (!("init" in latestDef.node) || latestDef.node.init === null) return None;
      return detect(latestDef.node.init);
    }).when(is3(NodeType3.Literal), (node3) => {
      if ("regex" in node3) return Construction3.RegExpLiteral({ node: node3, usage: Option_exports4.none() });
      return None;
    }).when(isOneOf3([NodeType3.TSAsExpression, NodeType3.TSTypeAssertion]), () => {
      if (!("expression" in node2) || !Predicate_exports3.isObject(node2.expression)) return None;
      return detect(node2.expression);
    }).otherwise(() => None);
  };
  return detect(node);
}
function getClassIdentifier(node) {
  if (node.id) return Option_exports4.fromNullable(node.id);
  if (node.parent.type === NodeType3.VariableDeclarator && node.parent.id.type === NodeType3.Identifier) {
    return Option_exports4.fromNullable(node.parent.id);
  }
  return Option_exports4.none();
}
function getFunctionIdentifier(node) {
  if (node.id) return Option_exports4.some(node.id);
  if (node.parent.type === NodeType3.VariableDeclarator && node.parent.init === node && node.parent.id.type === NodeType3.Identifier) {
    return Option_exports4.some(node.parent.id);
  }
  if (node.parent.type === NodeType3.AssignmentExpression && node.parent.right === node && node.parent.operator === "=" && node.parent.left.type === NodeType3.Identifier) {
    return Option_exports4.some(node.parent.left);
  }
  if (node.parent.type === NodeType3.Property && node.parent.value === node && !node.parent.computed && node.parent.key.type === NodeType3.Identifier) {
    return Option_exports4.some(node.parent.key);
  }
  if (isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node.parent) && node.parent.value === node && node.parent.key.type === NodeType3.Identifier) {
    return Option_exports4.some(node.parent.key);
  }
  if (node.parent.type === NodeType3.AssignmentPattern && node.parent.right === node && node.parent.left.type === NodeType3.Identifier) {
    return Option_exports4.some(node.parent.left);
  }
  return Option_exports4.none();
}
a({
  type: N.union([NodeType3.FunctionExpression, NodeType3.ArrowFunctionExpression]),
  parent: {
    type: NodeType3.Property,
    parent: {
      type: NodeType3.ObjectExpression
    }
  }
});
a({
  type: N.union([NodeType3.FunctionExpression, NodeType3.ArrowFunctionExpression]),
  parent: {
    type: NodeType3.MethodDefinition,
    parent: {
      type: NodeType3.ClassBody
    }
  }
});
a({
  type: N.union([NodeType3.FunctionExpression, NodeType3.ArrowFunctionExpression]),
  parent: {
    type: NodeType3.Property,
    parent: {
      type: NodeType3.ClassBody
    }
  }
});
function getNestedReturnStatements(node) {
  const returnStatements = [];
  if (node.type === NodeType3.ReturnStatement) {
    returnStatements.push(node);
  }
  if ("body" in node && !Predicate_exports3.isNullable(node.body)) {
    Array.isArray(node.body) ? node.body.forEach((x5) => {
      returnStatements.push(...getNestedReturnStatements(x5));
    }) : returnStatements.push(
      ...getNestedReturnStatements(node.body)
    );
  }
  if ("consequent" in node) {
    Array.isArray(node.consequent) ? node.consequent.forEach((x5) => {
      returnStatements.push(...getNestedReturnStatements(x5));
    }) : returnStatements.push(
      ...getNestedReturnStatements(node.consequent)
    );
  }
  if ("alternate" in node && node.alternate !== null) {
    Array.isArray(node.alternate) ? node.alternate.forEach((x5) => {
      returnStatements.push(...getNestedReturnStatements(x5));
    }) : returnStatements.push(
      ...getNestedReturnStatements(node.alternate)
    );
  }
  if ("cases" in node) {
    node.cases.forEach((x5) => {
      returnStatements.push(...getNestedReturnStatements(x5));
    });
  }
  if ("block" in node) {
    returnStatements.push(...getNestedReturnStatements(node.block));
  }
  if ("handler" in node && node.handler !== null) {
    returnStatements.push(...getNestedReturnStatements(node.handler));
  }
  if ("finalizer" in node && node.finalizer !== null) {
    returnStatements.push(
      ...getNestedReturnStatements(node.finalizer)
    );
  }
  if ("expression" in node && node.expression !== true && node.expression !== false) {
    returnStatements.push(
      ...getNestedReturnStatements(node.expression)
    );
  }
  if ("test" in node && node.test !== null) {
    returnStatements.push(...getNestedReturnStatements(node.test));
  }
  return returnStatements;
}
function isThisExpression(node) {
  if (node.type === NodeType3.TSAsExpression) {
    return isThisExpression(node.expression);
  }
  return node.type === NodeType3.ThisExpression;
}
var import_short_unique_id = __toESM(require_short_unique_id());
var __defProp5 = Object.defineProperty;
var __export5 = (target, all92) => {
  for (var name2 in all92)
    __defProp5(target, name2, { get: all92[name2], enumerable: true });
};
var KEYS4 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES4 = Object.keys(KEYS4);
for (const type of NODE_TYPES4) {
  Object.freeze(KEYS4[type]);
}
Object.freeze(KEYS4);
var visitor_keys_default4 = KEYS4;
var KEY_BLACKLIST4 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey4(key) {
  return !KEY_BLACKLIST4.has(key) && key[0] !== "_";
}
function getKeys4(node) {
  return Object.keys(node).filter(filterKey4);
}
function getInnermostScope4(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range22 = childScope.block.range;
      if (range22[0] <= location && location < range22[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable4(initialScope, nameOrNode) {
  let name2 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name2 = nameOrNode;
  } else {
    name2 = nameOrNode.name;
    scope = getInnermostScope4(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name2);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate04(token) {
  return !this(token);
}
function negate4(f32) {
  return negate04.bind(f32);
}
function isPunctuatorTokenWithValue4(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken4(token) {
  return isPunctuatorTokenWithValue4(token, "=>");
}
function isCommaToken4(token) {
  return isPunctuatorTokenWithValue4(token, ",");
}
function isSemicolonToken4(token) {
  return isPunctuatorTokenWithValue4(token, ";");
}
function isColonToken4(token) {
  return isPunctuatorTokenWithValue4(token, ":");
}
function isOpeningParenToken4(token) {
  return isPunctuatorTokenWithValue4(token, "(");
}
function isClosingParenToken4(token) {
  return isPunctuatorTokenWithValue4(token, ")");
}
function isOpeningBracketToken4(token) {
  return isPunctuatorTokenWithValue4(token, "[");
}
function isClosingBracketToken4(token) {
  return isPunctuatorTokenWithValue4(token, "]");
}
function isOpeningBraceToken4(token) {
  return isPunctuatorTokenWithValue4(token, "{");
}
function isClosingBraceToken4(token) {
  return isPunctuatorTokenWithValue4(token, "}");
}
function isCommentToken4(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate4(isArrowToken4);
negate4(isCommaToken4);
negate4(isSemicolonToken4);
negate4(isColonToken4);
negate4(isOpeningParenToken4);
negate4(isClosingParenToken4);
negate4(isOpeningBracketToken4);
negate4(isClosingBracketToken4);
negate4(isOpeningBraceToken4);
negate4(isClosingBraceToken4);
negate4(isCommentToken4);
function getOpeningParenOfParams4(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken4) : sourceCode.getFirstToken(node, isOpeningParenToken4);
}
function getFunctionHeadLocation4(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken4);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams4(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams4(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject4 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames4 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed4 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k32) => k32 !== "random").map((k32) => Math[k32]).filter((f32) => typeof f32 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f32) => typeof f32 === "function")
);
var callPassThrough4 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed4 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor4(object22, name2) {
  let x32 = object22;
  while ((typeof x32 === "object" || typeof x32 === "function") && x32 !== null) {
    const d32 = Object.getOwnPropertyDescriptor(x32, name2);
    if (d32) {
      return d32;
    }
    x32 = Object.getPrototypeOf(x32);
  }
  return null;
}
function isGetter4(object22, name2) {
  const d32 = getPropertyDescriptor4(object22, name2);
  return d32 != null && d32.get != null;
}
function getElementValues4(nodeList, initialScope) {
  const valueList = [];
  for (let i32 = 0; i32 < nodeList.length; ++i32) {
    const elementNode = nodeList[i32];
    if (elementNode == null) {
      valueList.length = i32 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR4(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR4(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst4(variable) {
  const refs = variable.references;
  const inits = refs.filter((r32) => r32.init).length;
  const reads = refs.filter((r32) => r32.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations4 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues4(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR4(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left72 = getStaticValueR4(node.left, initialScope);
    const right72 = getStaticValueR4(node.right, initialScope);
    if (left72 != null && right72 != null) {
      switch (node.operator) {
        case "==":
          return { value: left72.value == right72.value };
        case "!=":
          return { value: left72.value != right72.value };
        case "===":
          return { value: left72.value === right72.value };
        case "!==":
          return { value: left72.value !== right72.value };
        case "<":
          return { value: left72.value < right72.value };
        case "<=":
          return { value: left72.value <= right72.value };
        case ">":
          return { value: left72.value > right72.value };
        case ">=":
          return { value: left72.value >= right72.value };
        case "<<":
          return { value: left72.value << right72.value };
        case ">>":
          return { value: left72.value >> right72.value };
        case ">>>":
          return { value: left72.value >>> right72.value };
        case "+":
          return { value: left72.value + right72.value };
        case "-":
          return { value: left72.value - right72.value };
        case "*":
          return { value: left72.value * right72.value };
        case "/":
          return { value: left72.value / right72.value };
        case "%":
          return { value: left72.value % right72.value };
        case "**":
          return { value: left72.value ** right72.value };
        case "|":
          return { value: left72.value | right72.value };
        case "^":
          return { value: left72.value ^ right72.value };
        case "&":
          return { value: left72.value & right72.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues4(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object22 = getStaticValueR4(calleeNode.object, initialScope);
        if (object22 != null) {
          if (object22.value == null && (object22.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue4(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object22.value;
            const methodName = property.value;
            if (callAllowed4.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough4.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR4(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed4.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough4.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR4(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR4(node.consequent, initialScope) : getStaticValueR4(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR4(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable4(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames4.has(variable.name) && variable.name in globalObject4) {
        return { value: globalObject4[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst4(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR4(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left72 = getStaticValueR4(node.left, initialScope);
    if (left72 != null) {
      if (node.operator === "||" && Boolean(left72.value) === true || node.operator === "&&" && Boolean(left72.value) === false || node.operator === "??" && left72.value != null) {
        return left72;
      }
      const right72 = getStaticValueR4(node.right, initialScope);
      if (right72 != null) {
        return right72;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object22 = getStaticValueR4(node.object, initialScope);
    if (object22 != null) {
      if (object22.value == null && (object22.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue4(node, initialScope);
      if (property != null) {
        if (!isGetter4(object22.value, property.value)) {
          return { value: object22.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed4) {
          if (object22.value instanceof classFn && allowed.has(property.value)) {
            return { value: object22.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR4(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR4(node.callee, initialScope);
    const args = getElementValues4(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed4.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object22 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue4(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR4(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object22[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR4(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object22, argument.value);
      } else {
        return null;
      }
    }
    return { value: object22 };
  },
  SequenceExpression(node, initialScope) {
    const last22 = node.expressions[node.expressions.length - 1];
    return getStaticValueR4(last22, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR4(node.tag, initialScope);
    const expressions = getElementValues4(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues4(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i32 = 0; i32 < expressions.length; ++i32) {
        value += expressions[i32];
        value += node.quasis[i32 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR4(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR4(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations4, node.type)) {
    return operations4[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue4(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR4(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue5(node, initialScope = null) {
  try {
    return getStaticValueR4(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant4(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue5(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName4(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant4(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant4(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind4(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name2 = getPropertyName4(parent);
      if (name2) {
        tokens.push(`'${name2}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps4 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps4 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode4(x32) {
  return x32 !== null && typeof x32 === "object" && typeof x32.type === "string";
}
var visitor4 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys4(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode4(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode4(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps4.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps4.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect4(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor4.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default4
  );
}
function getParentSyntaxParen4(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken4
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken4
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized4(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken4(maybeLeftParen) && isClosingParenToken4(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen4(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp23 = Object.defineProperty;
var __export23 = (target, all33) => {
  for (var name2 in all33)
    __defProp23(target, name2, { get: all33[name2], enumerable: true });
};
var NodeType4 = AST_NODE_TYPES;
var is4 = ASTUtils.isNodeOfType;
var isOneOf4 = ASTUtils.isNodeOfTypes;
isOneOf4([
  NodeType4.ArrowFunctionExpression,
  NodeType4.FunctionDeclaration,
  NodeType4.FunctionExpression
]);
isOneOf4([
  NodeType4.ArrowFunctionExpression,
  NodeType4.FunctionDeclaration,
  NodeType4.FunctionExpression,
  NodeType4.TSCallSignatureDeclaration,
  NodeType4.TSConstructSignatureDeclaration,
  NodeType4.TSDeclareFunction,
  NodeType4.TSEmptyBodyFunctionExpression,
  NodeType4.TSFunctionType,
  NodeType4.TSMethodSignature
]);
isOneOf4([NodeType4.ClassDeclaration, NodeType4.ClassExpression]);
isOneOf4([
  NodeType4.DoWhileStatement,
  NodeType4.ForInStatement,
  NodeType4.ForOfStatement,
  NodeType4.ForStatement,
  NodeType4.WhileStatement
]);
isOneOf4([NodeType4.TSArrayType, NodeType4.TSTupleType]);
isOneOf4([
  NodeType4.PropertyDefinition,
  NodeType4.TSIndexSignature,
  NodeType4.TSParameterProperty,
  NodeType4.TSPropertySignature
]);
is4(NodeType4.JSXElement);
is4(NodeType4.JSXFragment);
isOneOf4([
  NodeType4.JSXAttribute,
  NodeType4.JSXSpreadChild,
  NodeType4.JSXClosingElement,
  NodeType4.JSXClosingFragment,
  NodeType4.JSXElement,
  NodeType4.JSXEmptyExpression,
  NodeType4.JSXExpressionContainer,
  NodeType4.JSXFragment,
  NodeType4.JSXIdentifier,
  NodeType4.JSXMemberExpression,
  NodeType4.JSXNamespacedName,
  NodeType4.JSXOpeningElement,
  NodeType4.JSXOpeningFragment,
  NodeType4.JSXSpreadAttribute,
  NodeType4.JSXSpreadChild,
  NodeType4.JSXText
]);
isOneOf4([
  NodeType4.JSXIdentifier,
  NodeType4.JSXMemberExpression,
  NodeType4.JSXNamespacedName
]);
isOneOf4([
  NodeType4.ArrayPattern,
  NodeType4.AssignmentPattern,
  NodeType4.ObjectPattern,
  NodeType4.RestElement
]);
isOneOf4([
  NodeType4.TSInterfaceDeclaration,
  NodeType4.TSTypeAliasDeclaration
]);
isOneOf4([
  NodeType4.ArrayExpression,
  NodeType4.ArrayPattern,
  NodeType4.ArrowFunctionExpression,
  NodeType4.CallExpression,
  NodeType4.ClassExpression,
  NodeType4.FunctionExpression,
  NodeType4.Identifier,
  NodeType4.JSXElement,
  NodeType4.JSXFragment,
  NodeType4.Literal,
  NodeType4.TemplateLiteral,
  NodeType4.MemberExpression,
  NodeType4.MetaProperty,
  NodeType4.ObjectExpression,
  NodeType4.ObjectPattern,
  NodeType4.SequenceExpression,
  NodeType4.Super,
  NodeType4.TaggedTemplateExpression,
  NodeType4.ThisExpression
]);
isOneOf4([
  NodeType4.ArrayExpression,
  NodeType4.ArrayPattern,
  NodeType4.ArrowFunctionExpression,
  NodeType4.CallExpression,
  NodeType4.ClassExpression,
  NodeType4.FunctionExpression,
  NodeType4.Identifier,
  NodeType4.JSXElement,
  NodeType4.JSXFragment,
  NodeType4.Literal,
  NodeType4.TemplateLiteral,
  NodeType4.MemberExpression,
  NodeType4.MetaProperty,
  NodeType4.ObjectExpression,
  NodeType4.ObjectPattern,
  NodeType4.SequenceExpression,
  NodeType4.Super,
  NodeType4.TaggedTemplateExpression,
  NodeType4.ThisExpression,
  NodeType4.TSAsExpression,
  NodeType4.TSNonNullExpression,
  NodeType4.TSTypeAssertion
]);
var Function_exports5 = {};
__export23(Function_exports5, {
  SK: () => SK5,
  absurd: () => absurd5,
  apply: () => apply5,
  compose: () => compose7,
  constFalse: () => constFalse5,
  constNull: () => constNull5,
  constTrue: () => constTrue5,
  constUndefined: () => constUndefined5,
  constVoid: () => constVoid5,
  constant: () => constant5,
  dual: () => dual5,
  flip: () => flip5,
  flow: () => flow5,
  hole: () => hole5,
  identity: () => identity5,
  isFunction: () => isFunction24,
  pipe: () => pipe5,
  satisfies: () => satisfies5,
  tupled: () => tupled5,
  unsafeCoerce: () => unsafeCoerce5,
  untupled: () => untupled5
});
var isFunction24 = (input) => typeof input === "function";
var dual5 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a32, b32) {
        if (arguments.length >= 2) {
          return body(a32, b32);
        }
        return function(self2) {
          return body(self2, a32);
        };
      };
    case 3:
      return function(a32, b32, c32) {
        if (arguments.length >= 3) {
          return body(a32, b32, c32);
        }
        return function(self2) {
          return body(self2, a32, b32);
        };
      };
    case 4:
      return function(a32, b32, c32, d32) {
        if (arguments.length >= 4) {
          return body(a32, b32, c32, d32);
        }
        return function(self2) {
          return body(self2, a32, b32, c32);
        };
      };
    case 5:
      return function(a32, b32, c32, d32, e32) {
        if (arguments.length >= 5) {
          return body(a32, b32, c32, d32, e32);
        }
        return function(self2) {
          return body(self2, a32, b32, c32, d32);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply5 = (a32) => (self2) => self2(a32);
var identity5 = (a32) => a32;
var satisfies5 = () => (b32) => b32;
var unsafeCoerce5 = identity5;
var constant5 = (value) => () => value;
var constTrue5 = /* @__PURE__ */ constant5(true);
var constFalse5 = /* @__PURE__ */ constant5(false);
var constNull5 = /* @__PURE__ */ constant5(null);
var constUndefined5 = /* @__PURE__ */ constant5(void 0);
var constVoid5 = constUndefined5;
var flip5 = (f32) => (...b32) => (...a32) => f32(...a32)(...b32);
var compose7 = /* @__PURE__ */ dual5(2, (ab, bc) => (a32) => bc(ab(a32)));
var absurd5 = (_32) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled5 = (f32) => (a32) => f32(...a32);
var untupled5 = (f32) => (...a32) => f32(a32);
function pipe5(a32, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a32;
    case 2:
      return ab(a32);
    case 3:
      return bc(ab(a32));
    case 4:
      return cd(bc(ab(a32)));
    case 5:
      return de(cd(bc(ab(a32))));
    case 6:
      return ef(de(cd(bc(ab(a32)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a32))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a32)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a32))))))));
    default: {
      let ret = arguments[0];
      for (let i32 = 1; i32 < arguments.length; i32++) {
        ret = arguments[i32](ret);
      }
      return ret;
    }
  }
}
function flow5(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole5 = /* @__PURE__ */ unsafeCoerce5(absurd5);
var SK5 = (_32, b32) => b32;
var make13 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_8 = (map622) => dual5(3, (self2, name2, f32) => map622(self2, (a32) => Object.assign({}, a32, {
  [name2]: f32(a32)
})));
var bindTo8 = (map622) => dual5(2, (self2, name2) => map622(self2, (a32) => ({
  [name2]: a32
})));
var bind8 = (map622, flatMap422) => dual5(3, (self2, name2, f32) => flatMap422(self2, (a32) => map622(f32(a32), (b32) => Object.assign({}, a32, {
  [name2]: b32
}))));
var moduleVersion5 = "3.2.8";
var getCurrentVersion5 = () => moduleVersion5;
var globalStoreId5 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion5()}`);
if (!(globalStoreId5 in globalThis)) {
  globalThis[globalStoreId5] = /* @__PURE__ */ new Map();
}
var globalStore5 = globalThis[globalStoreId5];
var globalValue5 = (id, compute) => {
  if (!globalStore5.has(id)) {
    globalStore5.set(id, compute());
  }
  return globalStore5.get(id);
};
var Predicate_exports4 = {};
__export23(Predicate_exports4, {
  all: () => all7,
  and: () => and5,
  compose: () => compose24,
  eqv: () => eqv5,
  every: () => every6,
  hasProperty: () => hasProperty5,
  implies: () => implies5,
  isBigInt: () => isBigInt5,
  isBoolean: () => isBoolean5,
  isDate: () => isDate5,
  isError: () => isError5,
  isFunction: () => isFunction34,
  isIterable: () => isIterable5,
  isMap: () => isMap5,
  isNever: () => isNever5,
  isNotNull: () => isNotNull5,
  isNotNullable: () => isNotNullable5,
  isNotUndefined: () => isNotUndefined5,
  isNull: () => isNull5,
  isNullable: () => isNullable5,
  isNumber: () => isNumber5,
  isObject: () => isObject5,
  isPromise: () => isPromise5,
  isPromiseLike: () => isPromiseLike5,
  isReadonlyRecord: () => isReadonlyRecord5,
  isRecord: () => isRecord5,
  isSet: () => isSet5,
  isString: () => isString5,
  isSymbol: () => isSymbol5,
  isTagged: () => isTagged5,
  isTruthy: () => isTruthy5,
  isUint8Array: () => isUint8Array5,
  isUndefined: () => isUndefined5,
  isUnknown: () => isUnknown5,
  mapInput: () => mapInput6,
  nand: () => nand5,
  nor: () => nor5,
  not: () => not5,
  or: () => or5,
  product: () => product7,
  productMany: () => productMany7,
  some: () => some10,
  struct: () => struct7,
  tuple: () => tuple6,
  xor: () => xor5
});
var mapInput6 = /* @__PURE__ */ dual5(2, (self2, f32) => (b32) => self2(f32(b32)));
var isTruthy5 = (input) => !!input;
var isSet5 = (input) => input instanceof Set;
var isMap5 = (input) => input instanceof Map;
var isString5 = (input) => typeof input === "string";
var isNumber5 = (input) => typeof input === "number";
var isBoolean5 = (input) => typeof input === "boolean";
var isBigInt5 = (input) => typeof input === "bigint";
var isSymbol5 = (input) => typeof input === "symbol";
var isFunction34 = isFunction24;
var isUndefined5 = (input) => input === void 0;
var isNotUndefined5 = (input) => input !== void 0;
var isNull5 = (input) => input === null;
var isNotNull5 = (input) => input !== null;
var isNever5 = (_32) => false;
var isUnknown5 = (_32) => true;
var isRecordOrArray5 = (input) => typeof input === "object" && input !== null;
var isObject5 = (input) => isRecordOrArray5(input) || isFunction34(input);
var hasProperty5 = /* @__PURE__ */ dual5(2, (self2, property) => isObject5(self2) && property in self2);
var isTagged5 = /* @__PURE__ */ dual5(2, (self2, tag) => hasProperty5(self2, "_tag") && self2["_tag"] === tag);
var isNullable5 = (input) => input === null || input === void 0;
var isNotNullable5 = (input) => input !== null && input !== void 0;
var isError5 = (input) => input instanceof Error;
var isUint8Array5 = (input) => input instanceof Uint8Array;
var isDate5 = (input) => input instanceof Date;
var isIterable5 = (input) => hasProperty5(input, Symbol.iterator);
var isRecord5 = (input) => isRecordOrArray5(input) && !Array.isArray(input);
var isReadonlyRecord5 = isRecord5;
var isPromise5 = (input) => hasProperty5(input, "then") && "catch" in input && isFunction34(input.then) && isFunction34(input.catch);
var isPromiseLike5 = (input) => hasProperty5(input, "then") && isFunction34(input.then);
var compose24 = /* @__PURE__ */ dual5(2, (ab, bc) => (a32) => ab(a32) && bc(a32));
var product7 = (self2, that) => ([a32, b32]) => self2(a32) && that(b32);
var all7 = (collection) => {
  return (as242) => {
    let collectionIndex = 0;
    for (const p32 of collection) {
      if (collectionIndex >= as242.length) {
        break;
      }
      if (p32(as242[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany7 = (self2, collection) => {
  const rest = all7(collection);
  return ([head222, ...tail32]) => self2(head222) === false ? false : rest(tail32);
};
var tuple6 = (...elements) => all7(elements);
var struct7 = (fields) => {
  const keys23 = Object.keys(fields);
  return (a32) => {
    for (const key of keys23) {
      if (!fields[key](a32[key])) {
        return false;
      }
    }
    return true;
  };
};
var not5 = (self2) => (a32) => !self2(a32);
var or5 = /* @__PURE__ */ dual5(2, (self2, that) => (a32) => self2(a32) || that(a32));
var and5 = /* @__PURE__ */ dual5(2, (self2, that) => (a32) => self2(a32) && that(a32));
var xor5 = /* @__PURE__ */ dual5(2, (self2, that) => (a32) => self2(a32) !== that(a32));
var eqv5 = /* @__PURE__ */ dual5(2, (self2, that) => (a32) => self2(a32) === that(a32));
var implies5 = /* @__PURE__ */ dual5(2, (self2, that) => (a32) => self2(a32) ? that(a32) : true);
var nor5 = /* @__PURE__ */ dual5(2, (self2, that) => (a32) => !(self2(a32) || that(a32)));
var nand5 = /* @__PURE__ */ dual5(2, (self2, that) => (a32) => !(self2(a32) && that(a32)));
var every6 = (collection) => (a32) => {
  for (const p32 of collection) {
    if (!p32(a32)) {
      return false;
    }
  }
  return true;
};
var some10 = (collection) => (a32) => {
  for (const p32 of collection) {
    if (p32(a32)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage5 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId5 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind5 = (u32) => isObject5(u32) && GenKindTypeId5 in u32;
var GenKindImpl5 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity5;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_32) => _32;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_32) => _32;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_32) => _32;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId5] = GenKindTypeId5;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen6(this);
  }
};
var SingleShotGen6 = class _SingleShotGen8 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a32) {
    return this.called ? {
      value: a32,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a32) {
    return {
      value: a32,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e32) {
    throw e32;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen8(this.self);
  }
};
var adapter7 = () => function() {
  let x32 = arguments[0];
  for (let i32 = 1; i32 < arguments.length; i32++) {
    x32 = arguments[i32](x32);
  }
  return new GenKindImpl5(x32);
};
var defaultIncHi5 = 335903614;
var defaultIncLo5 = 4150755663;
var MUL_HI5 = 1481765933 >>> 0;
var MUL_LO5 = 1284865837 >>> 0;
var BIT_535 = 9007199254740992;
var BIT_275 = 134217728;
var PCGRandom5 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable5(seedLo) && isNullable5(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable5(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable5(incLo) && isNullable5(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo5;
      incHi = this._state ? this._state[2] : defaultIncHi5;
    } else if (isNullable5(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add645(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max32) {
    if (!max32) {
      return this._next();
    }
    max32 = max32 >>> 0;
    if ((max32 & max32 - 1) === 0) {
      return this._next() & max32 - 1;
    }
    let num = 0;
    const skew = (-max32 >>> 0) % max32 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max32;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_275 + lo) / BIT_535;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul645(this._state, oldHi, oldLo, MUL_HI5, MUL_LO5);
    add645(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul645(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add645(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId5 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap5 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId5]() {
    return this.#value;
  }
};
function yieldWrapGet5(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId5 in self2) {
    return self2[YieldWrapTypeId5]();
  }
  throw new Error(getBugErrorMessage5("yieldWrapGet"));
}
var structuralRegionState5 = /* @__PURE__ */ globalValue5("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache5 = /* @__PURE__ */ globalValue5(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr5 = /* @__PURE__ */ globalValue5(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom5());
var symbol7 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash5 = (self2) => {
  if (structuralRegionState5.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number6(self2);
    case "bigint":
      return string6(self2.toString(10));
    case "boolean":
      return string6(String(self2));
    case "symbol":
      return string6(String(self2));
    case "string":
      return string6(self2);
    case "undefined":
      return string6("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string6("null");
      } else if (self2 instanceof Date) {
        return hash5(self2.toISOString());
      } else if (isHash5(self2)) {
        return self2[symbol7]();
      } else {
        return random5(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random5 = (self2) => {
  if (!randomHashCache5.has(self2)) {
    randomHashCache5.set(self2, number6(pcgr5.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache5.get(self2);
};
var combine6 = (b32) => (self2) => self2 * 53 ^ b32;
var optimize5 = (n32) => n32 & 3221225471 | n32 >>> 1 & 1073741824;
var isHash5 = (u32) => hasProperty5(u32, symbol7);
var number6 = (n32) => {
  if (n32 !== n32 || n32 === Infinity) {
    return 0;
  }
  let h32 = n32 | 0;
  if (h32 !== n32) {
    h32 ^= n32 * 4294967295;
  }
  while (n32 > 4294967295) {
    h32 ^= n32 /= 4294967295;
  }
  return optimize5(n32);
};
var string6 = (str) => {
  let h32 = 5381, i32 = str.length;
  while (i32) {
    h32 = h32 * 33 ^ str.charCodeAt(--i32);
  }
  return optimize5(h32);
};
var structureKeys3 = (o32, keys23) => {
  let h32 = 12289;
  for (let i32 = 0; i32 < keys23.length; i32++) {
    h32 ^= pipe5(string6(keys23[i32]), combine6(hash5(o32[keys23[i32]])));
  }
  return optimize5(h32);
};
var structure3 = (o32) => structureKeys3(o32, Object.keys(o32));
var array8 = (arr) => {
  let h32 = 6151;
  for (let i32 = 0; i32 < arr.length; i32++) {
    h32 = pipe5(h32, combine6(hash5(arr[i32])));
  }
  return optimize5(h32);
};
var cached5 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash322) {
      Object.defineProperty(self22, symbol7, {
        value() {
          return hash322;
        },
        enumerable: false
      });
      return hash322;
    };
  }
  const self2 = arguments[0];
  const hash242 = arguments[1];
  Object.defineProperty(self2, symbol7, {
    value() {
      return hash242;
    },
    enumerable: false
  });
  return hash242;
};
var symbol24 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals5() {
  if (arguments.length === 1) {
    return (self2) => compareBoth5(self2, arguments[0]);
  }
  return compareBoth5(arguments[0], arguments[1]);
}
function compareBoth5(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual5(self2) && isEqual5(that)) {
        if (hash5(self2) === hash5(that) && self2[symbol24](that)) {
          return true;
        } else {
          return structuralRegionState5.enabled && structuralRegionState5.tester ? structuralRegionState5.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState5.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v32, i32) => compareBoth5(v32, that[i32]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth5(self2[key], that[key]))) {
              return structuralRegionState5.tester ? structuralRegionState5.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState5.tester ? structuralRegionState5.tester(self2, that) : false;
    }
  }
  return structuralRegionState5.enabled && structuralRegionState5.tester ? structuralRegionState5.tester(self2, that) : false;
}
var isEqual5 = (u32) => hasProperty5(u32, symbol24);
var equivalence5 = () => equals5;
var NodeInspectSymbol5 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON5 = (x32) => {
  if (hasProperty5(x32, "toJSON") && isFunction34(x32["toJSON"]) && x32["toJSON"].length === 0) {
    return x32.toJSON();
  } else if (Array.isArray(x32)) {
    return x32.map(toJSON5);
  }
  return x32;
};
var format5 = (x32) => JSON.stringify(x32, null, 2);
var pipeArguments5 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i32 = 0, len = args.length; i32 < len; i32++) {
        ret = args[i32](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT3 = "Commit";
var OP_FAILURE4 = "Failure";
var OP_WITH_RUNTIME4 = "WithRuntime";
var EffectTypeId6 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId5 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId5 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId5 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance5 = {
  /* c8 ignore next */
  _R: (_32) => _32,
  /* c8 ignore next */
  _E: (_32) => _32,
  /* c8 ignore next */
  _A: (_32) => _32,
  _V: /* @__PURE__ */ getCurrentVersion5()
};
var sinkVariance5 = {
  /* c8 ignore next */
  _A: (_32) => _32,
  /* c8 ignore next */
  _In: (_32) => _32,
  /* c8 ignore next */
  _L: (_32) => _32,
  /* c8 ignore next */
  _E: (_32) => _32,
  /* c8 ignore next */
  _R: (_32) => _32
};
var channelVariance5 = {
  /* c8 ignore next */
  _Env: (_32) => _32,
  /* c8 ignore next */
  _InErr: (_32) => _32,
  /* c8 ignore next */
  _InElem: (_32) => _32,
  /* c8 ignore next */
  _InDone: (_32) => _32,
  /* c8 ignore next */
  _OutErr: (_32) => _32,
  /* c8 ignore next */
  _OutElem: (_32) => _32,
  /* c8 ignore next */
  _OutDone: (_32) => _32
};
var EffectPrototype5 = {
  [EffectTypeId6]: effectVariance5,
  [StreamTypeId5]: effectVariance5,
  [SinkTypeId5]: sinkVariance5,
  [ChannelTypeId5]: channelVariance5,
  [symbol24](that) {
    return this === that;
  },
  [symbol7]() {
    return cached5(this, random5(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen6(new YieldWrap5(this));
  },
  pipe() {
    return pipeArguments5(this, arguments);
  }
};
var StructuralPrototype3 = {
  [symbol7]() {
    return cached5(this, structure3(this));
  },
  [symbol24](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals5(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype3 = {
  ...EffectPrototype5,
  _op: OP_COMMIT3
};
var StructuralCommitPrototype3 = {
  ...CommitPrototype3,
  ...StructuralPrototype3
};
var TypeId11 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto7 = {
  ...EffectPrototype5,
  [TypeId11]: {
    _A: (_32) => _32
  },
  [NodeInspectSymbol5]() {
    return this.toJSON();
  },
  toString() {
    return format5(this.toJSON());
  }
};
var SomeProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto7), {
  _tag: "Some",
  _op: "Some",
  [symbol24](that) {
    return isOption7(that) && isSome7(that) && equals5(this.value, that.value);
  },
  [symbol7]() {
    return cached5(this, combine6(hash5(this._tag))(hash5(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON5(this.value)
    };
  }
});
var NoneHash5 = /* @__PURE__ */ hash5("None");
var NoneProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto7), {
  _tag: "None",
  _op: "None",
  [symbol24](that) {
    return isOption7(that) && isNone7(that);
  },
  [symbol7]() {
    return NoneHash5;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption7 = (input) => hasProperty5(input, TypeId11);
var isNone7 = (fa) => fa._tag === "None";
var isSome7 = (fa) => fa._tag === "Some";
var none7 = /* @__PURE__ */ Object.create(NoneProto5);
var some24 = (value) => {
  const a32 = Object.create(SomeProto5);
  a32.value = value;
  return a32;
};
var TypeId24 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto24 = {
  ...EffectPrototype5,
  [TypeId24]: {
    _R: (_32) => _32
  },
  [NodeInspectSymbol5]() {
    return this.toJSON();
  },
  toString() {
    return format5(this.toJSON());
  }
};
var RightProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto24), {
  _tag: "Right",
  _op: "Right",
  [symbol24](that) {
    return isEither5(that) && isRight6(that) && equals5(this.right, that.right);
  },
  [symbol7]() {
    return combine6(hash5(this._tag))(hash5(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON5(this.right)
    };
  }
});
var LeftProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto24), {
  _tag: "Left",
  _op: "Left",
  [symbol24](that) {
    return isEither5(that) && isLeft6(that) && equals5(this.left, that.left);
  },
  [symbol7]() {
    return combine6(hash5(this._tag))(hash5(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON5(this.left)
    };
  }
});
var isEither5 = (input) => hasProperty5(input, TypeId24);
var isLeft6 = (ma) => ma._tag === "Left";
var isRight6 = (ma) => ma._tag === "Right";
var left6 = (left33) => {
  const a32 = Object.create(LeftProto5);
  a32.left = left33;
  return a32;
};
var right6 = (right33) => {
  const a32 = Object.create(RightProto5);
  a32.right = right33;
  return a32;
};
var getLeft7 = (self2) => isRight6(self2) ? none7 : some24(self2.left);
var getRight7 = (self2) => isLeft6(self2) ? none7 : some24(self2.right);
var right24 = right6;
var left24 = left6;
var Option_exports5 = {};
__export23(Option_exports5, {
  Do: () => Do6,
  TypeId: () => TypeId34,
  all: () => all24,
  andThen: () => andThen5,
  ap: () => ap5,
  as: () => as5,
  asVoid: () => asVoid5,
  bind: () => bind24,
  bindTo: () => bindTo24,
  composeK: () => composeK5,
  contains: () => contains6,
  containsWith: () => containsWith6,
  exists: () => exists5,
  filter: () => filter6,
  filterMap: () => filterMap6,
  firstSomeOf: () => firstSomeOf5,
  flatMap: () => flatMap6,
  flatMapNullable: () => flatMapNullable6,
  flatten: () => flatten6,
  fromIterable: () => fromIterable7,
  fromNullable: () => fromNullable6,
  gen: () => gen5,
  getEquivalence: () => getEquivalence7,
  getLeft: () => getLeft24,
  getOrElse: () => getOrElse5,
  getOrNull: () => getOrNull5,
  getOrThrow: () => getOrThrow5,
  getOrThrowWith: () => getOrThrowWith5,
  getOrUndefined: () => getOrUndefined5,
  getOrder: () => getOrder6,
  getRight: () => getRight24,
  isNone: () => isNone24,
  isOption: () => isOption24,
  isSome: () => isSome24,
  let: () => let_24,
  lift2: () => lift25,
  liftNullable: () => liftNullable6,
  liftPredicate: () => liftPredicate6,
  liftThrowable: () => liftThrowable5,
  map: () => map6,
  match: () => match24,
  none: () => none24,
  orElse: () => orElse5,
  orElseEither: () => orElseEither5,
  orElseSome: () => orElseSome5,
  partitionMap: () => partitionMap6,
  product: () => product24,
  productMany: () => productMany24,
  reduceCompact: () => reduceCompact5,
  some: () => some34,
  tap: () => tap5,
  toArray: () => toArray5,
  toRefinement: () => toRefinement5,
  void: () => void_5,
  zipLeft: () => zipLeft5,
  zipRight: () => zipRight5,
  zipWith: () => zipWith6
});
var make24 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId34 = /* @__PURE__ */ Symbol.for("effect/Option");
var none24 = () => none7;
var some34 = some24;
var isOption24 = isOption7;
var isNone24 = isNone7;
var isSome24 = isSome7;
var match24 = /* @__PURE__ */ dual5(2, (self2, {
  onNone,
  onSome
}) => isNone24(self2) ? onNone() : onSome(self2.value));
var toRefinement5 = (f32) => (a32) => isSome24(f32(a32));
var fromIterable7 = (collection) => {
  for (const a32 of collection) {
    return some34(a32);
  }
  return none24();
};
var getRight24 = getRight7;
var getLeft24 = getLeft7;
var getOrElse5 = /* @__PURE__ */ dual5(2, (self2, onNone) => isNone24(self2) ? onNone() : self2.value);
var orElse5 = /* @__PURE__ */ dual5(2, (self2, that) => isNone24(self2) ? that() : self2);
var orElseSome5 = /* @__PURE__ */ dual5(2, (self2, onNone) => isNone24(self2) ? some34(onNone()) : self2);
var orElseEither5 = /* @__PURE__ */ dual5(2, (self2, that) => isNone24(self2) ? map6(that(), right6) : map6(self2, left6));
var firstSomeOf5 = (collection) => {
  let out = none24();
  for (out of collection) {
    if (isSome24(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable6 = (nullableValue) => nullableValue == null ? none24() : some34(nullableValue);
var liftNullable6 = (f32) => (...a32) => fromNullable6(f32(...a32));
var getOrNull5 = /* @__PURE__ */ getOrElse5(constNull5);
var getOrUndefined5 = /* @__PURE__ */ getOrElse5(constUndefined5);
var liftThrowable5 = (f32) => (...a32) => {
  try {
    return some34(f32(...a32));
  } catch (e32) {
    return none24();
  }
};
var getOrThrowWith5 = /* @__PURE__ */ dual5(2, (self2, onNone) => {
  if (isSome24(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow5 = /* @__PURE__ */ getOrThrowWith5(() => new Error("getOrThrow called on a None"));
var map6 = /* @__PURE__ */ dual5(2, (self2, f32) => isNone24(self2) ? none24() : some34(f32(self2.value)));
var as5 = /* @__PURE__ */ dual5(2, (self2, b32) => map6(self2, () => b32));
var asVoid5 = /* @__PURE__ */ as5(void 0);
var void_5 = /* @__PURE__ */ some34(void 0);
var flatMap6 = /* @__PURE__ */ dual5(2, (self2, f32) => isNone24(self2) ? none24() : f32(self2.value));
var andThen5 = /* @__PURE__ */ dual5(2, (self2, f32) => flatMap6(self2, (a32) => {
  const b32 = isFunction24(f32) ? f32(a32) : f32;
  return isOption24(b32) ? b32 : some34(b32);
}));
var flatMapNullable6 = /* @__PURE__ */ dual5(2, (self2, f32) => isNone24(self2) ? none24() : fromNullable6(f32(self2.value)));
var flatten6 = /* @__PURE__ */ flatMap6(identity5);
var zipRight5 = /* @__PURE__ */ dual5(2, (self2, that) => flatMap6(self2, () => that));
var composeK5 = /* @__PURE__ */ dual5(2, (afb, bfc) => (a32) => flatMap6(afb(a32), bfc));
var zipLeft5 = /* @__PURE__ */ dual5(2, (self2, that) => tap5(self2, () => that));
var tap5 = /* @__PURE__ */ dual5(2, (self2, f32) => flatMap6(self2, (a32) => map6(f32(a32), () => a32)));
var product24 = (self2, that) => isSome24(self2) && isSome24(that) ? some34([self2.value, that.value]) : none24();
var productMany24 = (self2, collection) => {
  if (isNone24(self2)) {
    return none24();
  }
  const out = [self2.value];
  for (const o32 of collection) {
    if (isNone24(o32)) {
      return none24();
    }
    out.push(o32.value);
  }
  return some34(out);
};
var all24 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o32 of input) {
      if (isNone24(o32)) {
        return none24();
      }
      out2.push(o32.value);
    }
    return some34(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o32 = input[key];
    if (isNone24(o32)) {
      return none24();
    }
    out[key] = o32.value;
  }
  return some34(out);
};
var zipWith6 = /* @__PURE__ */ dual5(3, (self2, that, f32) => map6(product24(self2, that), ([a32, b32]) => f32(a32, b32)));
var ap5 = /* @__PURE__ */ dual5(2, (self2, that) => zipWith6(self2, that, (f32, a32) => f32(a32)));
var reduceCompact5 = /* @__PURE__ */ dual5(3, (self2, b32, f32) => {
  let out = b32;
  for (const oa of self2) {
    if (isSome24(oa)) {
      out = f32(out, oa.value);
    }
  }
  return out;
});
var toArray5 = (self2) => isNone24(self2) ? [] : [self2.value];
var partitionMap6 = /* @__PURE__ */ dual5(2, (self2, f32) => {
  if (isNone24(self2)) {
    return [none24(), none24()];
  }
  const e32 = f32(self2.value);
  return isLeft6(e32) ? [some34(e32.left), none24()] : [none24(), some34(e32.right)];
});
var filterMap6 = /* @__PURE__ */ dual5(2, (self2, f32) => isNone24(self2) ? none24() : f32(self2.value));
var filter6 = /* @__PURE__ */ dual5(2, (self2, predicate) => filterMap6(self2, (b32) => predicate(b32) ? some24(b32) : none7));
var getEquivalence7 = (isEquivalent) => make13((x32, y32) => x32 === y32 || (isNone24(x32) ? isNone24(y32) : isNone24(y32) ? false : isEquivalent(x32.value, y32.value)));
var getOrder6 = (O32) => make24((self2, that) => isSome24(self2) ? isSome24(that) ? O32(self2.value, that.value) : 1 : -1);
var lift25 = (f32) => dual5(2, (self2, that) => zipWith6(self2, that, f32));
var liftPredicate6 = (predicate) => (b32) => predicate(b32) ? some34(b32) : none24();
var containsWith6 = (isEquivalent) => dual5(2, (self2, a32) => isNone24(self2) ? false : isEquivalent(self2.value, a32));
var _equivalence7 = /* @__PURE__ */ equivalence5();
var contains6 = /* @__PURE__ */ containsWith6(_equivalence7);
var exists5 = /* @__PURE__ */ dual5(2, (self2, refinement) => isNone24(self2) ? false : refinement(self2.value));
var bindTo24 = /* @__PURE__ */ bindTo8(map6);
var let_24 = /* @__PURE__ */ let_8(map6);
var bind24 = /* @__PURE__ */ bind8(map6, flatMap6);
var Do6 = /* @__PURE__ */ some34({});
var adapter24 = /* @__PURE__ */ adapter7();
var gen5 = (f32) => {
  const iterator = f32(adapter24);
  let state = iterator.next();
  if (state.done) {
    return some34(state.value);
  } else {
    let current = state.value;
    if (isGenKind5(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet5(current);
    }
    if (isNone24(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind5(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet5(current);
        }
        if (isNone24(current)) {
          return current;
        }
      }
    }
    return some34(state.value);
  }
};
var fromIterable24 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse6 = (self2) => Array.from(self2).reverse();
var reduce7 = /* @__PURE__ */ dual5(3, (self2, b32, f32) => fromIterable24(self2).reduce((b222, a32, i32) => f32(b222, a32, i32), b32));
var TagTypeId4 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey4 = "effect/STM";
var STMTypeId4 = /* @__PURE__ */ Symbol.for(STMSymbolKey4);
var TagProto4 = {
  ...EffectPrototype5,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId4]: effectVariance5,
  [TagTypeId4]: {
    _Service: (_32) => _32,
    _Identifier: (_32) => _32
  },
  toString() {
    return format5(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol5]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make34(this, self2);
  }
};
var makeGenericTag4 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto4);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId44 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto4 = {
  [TypeId44]: {
    _Services: (_32) => _32
  },
  [symbol24](that) {
    if (isContext4(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k32 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k32) || !equals5(this.unsafeMap.get(k32), that.unsafeMap.get(k32))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol7]() {
    return cached5(this, number6(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments5(this, arguments);
  },
  toString() {
    return format5(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON5)
    };
  },
  [NodeInspectSymbol5]() {
    return this.toJSON();
  }
};
var makeContext4 = (unsafeMap) => {
  const context = Object.create(ContextProto4);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext4 = (u32) => hasProperty5(u32, TypeId44);
var _empty8 = /* @__PURE__ */ makeContext4(/* @__PURE__ */ new Map());
var empty12 = () => _empty8;
var make34 = (tag, service) => makeContext4(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag4 = makeGenericTag4;
var empty24 = empty12;
var TypeId54 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy5(src, srcPos, dest, destPos, len) {
  for (let i32 = srcPos; i32 < Math.min(src.length, srcPos + len); i32++) {
    dest[destPos + i32 - srcPos] = src[i32];
  }
  return dest;
}
var emptyArray4 = [];
var getEquivalence24 = (isEquivalent) => make13((self2, that) => self2.length === that.length && toReadonlyArray4(self2).every((value, i32) => isEquivalent(value, unsafeGet24(that, i32))));
var _equivalence24 = /* @__PURE__ */ getEquivalence24(equals5);
var ChunkProto4 = {
  [TypeId54]: {
    _A: (_32) => _32
  },
  toString() {
    return format5(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray4(this).map(toJSON5)
    };
  },
  [NodeInspectSymbol5]() {
    return this.toJSON();
  },
  [symbol24](that) {
    return isChunk4(that) && _equivalence24(this, that);
  },
  [symbol7]() {
    return cached5(this, array8(toReadonlyArray4(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray4[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray4(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments5(this, arguments);
  }
};
var makeChunk4 = (backing) => {
  const chunk = Object.create(ChunkProto4);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty24;
      chunk.right = _empty24;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty24;
      chunk.right = _empty24;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty24;
      chunk.right = _empty24;
      break;
    }
  }
  return chunk;
};
var isChunk4 = (u32) => hasProperty5(u32, TypeId54);
var _empty24 = /* @__PURE__ */ makeChunk4({
  _tag: "IEmpty"
});
var empty34 = () => _empty24;
var make44 = (...as242) => as242.length === 1 ? of5(as242[0]) : unsafeFromNonEmptyArray4(as242);
var of5 = (a32) => makeChunk4({
  _tag: "ISingleton",
  a: a32
});
var copyToArray4 = (self2, array33, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy5(self2.backing.array, 0, array33, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray4(self2.left, array33, initial);
      copyToArray4(self2.right, array33, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array33[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i32 = 0;
      let j32 = initial;
      while (i32 < self2.length) {
        array33[j32] = unsafeGet24(self2, i32);
        i32 += 1;
        j32 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray4 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray4;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray4(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty24;
      self2.right = _empty24;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse24 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk4({
        _tag: "IArray",
        array: reverse6(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk4({
        _tag: "IConcat",
        left: reverse24(self2.backing.right),
        right: reverse24(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray4(reverse6(toReadonlyArray4(self2)));
  }
};
var unsafeFromArray4 = (self2) => makeChunk4({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray4 = (self2) => unsafeFromArray4(self2);
var unsafeGet24 = /* @__PURE__ */ dual5(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet24(self2.left, index) : unsafeGet24(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet24(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend5 = /* @__PURE__ */ dual5(2, (self2, elem) => appendAll5(of5(elem), self2));
var drop5 = /* @__PURE__ */ dual5(2, (self2, n32) => {
  if (n32 <= 0) {
    return self2;
  } else if (n32 >= self2.length) {
    return _empty24;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk4({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n32,
          length: self2.backing.length - n32
        });
      }
      case "IConcat": {
        if (n32 > self2.left.length) {
          return drop5(self2.right, n32 - self2.left.length);
        }
        return makeChunk4({
          _tag: "IConcat",
          left: drop5(self2.left, n32),
          right: self2.right
        });
      }
      default: {
        return makeChunk4({
          _tag: "ISlice",
          chunk: self2,
          offset: n32,
          length: self2.length - n32
        });
      }
    }
  }
});
var appendAll5 = /* @__PURE__ */ dual5(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff23 = that.depth - self2.depth;
  if (Math.abs(diff23) <= 1) {
    return makeChunk4({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff23 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll5(self2.right, that);
      return makeChunk4({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll5(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk4({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk4({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk4({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk4({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll5(self2, that.left);
      return makeChunk4({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll5(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk4({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk4({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk4({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk4({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty4 = (self2) => self2.length === 0;
var isNonEmpty4 = (self2) => self2.length > 0;
var unsafeHead4 = (self2) => unsafeGet24(self2, 0);
var headNonEmpty5 = unsafeHead4;
var tailNonEmpty5 = (self2) => drop5(self2, 1);
var SIZE4 = 5;
var BUCKET_SIZE4 = /* @__PURE__ */ Math.pow(2, SIZE4);
var MASK4 = BUCKET_SIZE4 - 1;
var MAX_INDEX_NODE4 = BUCKET_SIZE4 / 2;
var MIN_ARRAY_NODE4 = BUCKET_SIZE4 / 4;
function popcount4(x32) {
  x32 -= x32 >> 1 & 1431655765;
  x32 = (x32 & 858993459) + (x32 >> 2 & 858993459);
  x32 = x32 + (x32 >> 4) & 252645135;
  x32 += x32 >> 8;
  x32 += x32 >> 16;
  return x32 & 127;
}
function hashFragment4(shift22, h32) {
  return h32 >>> shift22 & MASK4;
}
function toBitmap4(x32) {
  return 1 << x32;
}
function fromBitmap4(bitmap, bit) {
  return popcount4(bitmap & bit - 1);
}
var make54 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate4(mutate23, at, v32, arr) {
  let out = arr;
  if (!mutate23) {
    const len = arr.length;
    out = new Array(len);
    for (let i32 = 0; i32 < len; ++i32) out[i32] = arr[i32];
  }
  out[at] = v32;
  return out;
}
function arraySpliceOut4(mutate23, at, arr) {
  const newLen = arr.length - 1;
  let i32 = 0;
  let g32 = 0;
  let out = arr;
  if (mutate23) {
    i32 = g32 = at;
  } else {
    out = new Array(newLen);
    while (i32 < at) out[g32++] = arr[i32++];
  }
  ++i32;
  while (i32 <= newLen) out[g32++] = arr[i32++];
  if (mutate23) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn4(mutate23, at, v32, arr) {
  const len = arr.length;
  if (mutate23) {
    let i222 = len;
    while (i222 >= at) arr[i222--] = arr[i222];
    arr[at] = v32;
    return arr;
  }
  let i32 = 0, g32 = 0;
  const out = new Array(len + 1);
  while (i32 < at) out[g32++] = arr[i32++];
  out[at] = v32;
  while (i32 < len) out[++g32] = arr[i32++];
  return out;
}
var EmptyNode4 = class _EmptyNode4 {
  _tag = "EmptyNode";
  modify(edit, _shift, f32, hash242, key, size43) {
    const v32 = f32(none24());
    if (isNone24(v32)) return new _EmptyNode4();
    ++size43.value;
    return new LeafNode4(edit, hash242, key, v32);
  }
};
function isEmptyNode4(a32) {
  return isTagged5(a32, "EmptyNode");
}
function isLeafNode4(node) {
  return isEmptyNode4(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode4(node, edit) {
  return isEmptyNode4(node) ? false : edit === node.edit;
}
var LeafNode4 = class _LeafNode4 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash242, key, value) {
    this.edit = edit;
    this.hash = hash242;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f32, hash242, key, size43) {
    if (equals5(key, this.key)) {
      const v222 = f32(this.value);
      if (v222 === this.value) return this;
      else if (isNone24(v222)) {
        --size43.value;
        return new EmptyNode4();
      }
      if (canEditNode4(this, edit)) {
        this.value = v222;
        return this;
      }
      return new _LeafNode4(edit, hash242, key, v222);
    }
    const v32 = f32(none24());
    if (isNone24(v32)) return this;
    ++size43.value;
    return mergeLeaves4(edit, shift22, this.hash, this, hash242, new _LeafNode4(edit, hash242, key, v32));
  }
};
var CollisionNode4 = class _CollisionNode4 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash242, children) {
    this.edit = edit;
    this.hash = hash242;
    this.children = children;
  }
  modify(edit, shift22, f32, hash242, key, size43) {
    if (hash242 === this.hash) {
      const canEdit = canEditNode4(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f32, key, size43);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode4(edit, this.hash, list) : list[0];
    }
    const v32 = f32(none24());
    if (isNone24(v32)) return this;
    ++size43.value;
    return mergeLeaves4(edit, shift22, this.hash, this, hash242, new LeafNode4(edit, hash242, key, v32));
  }
  updateCollisionList(mutate23, edit, hash242, list, f32, key, size43) {
    const len = list.length;
    for (let i32 = 0; i32 < len; ++i32) {
      const child = list[i32];
      if ("key" in child && equals5(key, child.key)) {
        const value = child.value;
        const newValue2 = f32(value);
        if (newValue2 === value) return list;
        if (isNone24(newValue2)) {
          --size43.value;
          return arraySpliceOut4(mutate23, i32, list);
        }
        return arrayUpdate4(mutate23, i32, new LeafNode4(edit, hash242, key, newValue2), list);
      }
    }
    const newValue = f32(none24());
    if (isNone24(newValue)) return list;
    ++size43.value;
    return arrayUpdate4(mutate23, len, new LeafNode4(edit, hash242, key, newValue), list);
  }
};
var IndexedNode4 = class _IndexedNode4 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f32, hash242, key, size43) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment4(shift22, hash242);
    const bit = toBitmap4(frag);
    const indx = fromBitmap4(mask, bit);
    const exists242 = mask & bit;
    const canEdit = canEditNode4(this, edit);
    if (!exists242) {
      const _newChild = new EmptyNode4().modify(edit, shift22 + SIZE4, f32, hash242, key, size43);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE4 ? expand4(edit, frag, _newChild, mask, children) : new _IndexedNode4(edit, mask | bit, arraySpliceIn4(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE4, f32, hash242, key, size43);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode4(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode4();
      if (children.length <= 2 && isLeafNode4(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut4(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate4(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode4(edit, bitmap, newChildren);
  }
};
var ArrayNode4 = class _ArrayNode4 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size43, children) {
    this.edit = edit;
    this.size = size43;
    this.children = children;
  }
  modify(edit, shift22, f32, hash242, key, size43) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment4(shift22, hash242);
    const child = children[frag];
    const newChild = (child || new EmptyNode4()).modify(edit, shift22 + SIZE4, f32, hash242, key, size43);
    if (child === newChild) return this;
    const canEdit = canEditNode4(this, edit);
    let newChildren;
    if (isEmptyNode4(child) && !isEmptyNode4(newChild)) {
      ++count;
      newChildren = arrayUpdate4(canEdit, frag, newChild, children);
    } else if (!isEmptyNode4(child) && isEmptyNode4(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE4) {
        return pack4(edit, count, frag, children);
      }
      newChildren = arrayUpdate4(canEdit, frag, new EmptyNode4(), children);
    } else {
      newChildren = arrayUpdate4(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode4(edit, count, newChildren);
  }
};
function pack4(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g32 = 0;
  let bitmap = 0;
  for (let i32 = 0, len = elements.length; i32 < len; ++i32) {
    if (i32 !== removed) {
      const elem = elements[i32];
      if (elem && !isEmptyNode4(elem)) {
        children[g32++] = elem;
        bitmap |= 1 << i32;
      }
    }
  }
  return new IndexedNode4(edit, bitmap, children);
}
function expand4(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i32 = 0; bit; ++i32) {
    if (bit & 1) arr[i32] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode4(edit, count + 1, arr);
}
function mergeLeavesInner4(edit, shift22, h1, n1, h222, n222) {
  if (h1 === h222) return new CollisionNode4(edit, h1, [n222, n1]);
  const subH1 = hashFragment4(shift22, h1);
  const subH2 = hashFragment4(shift22, h222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode4(edit, toBitmap4(subH1) | toBitmap4(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n222] : [n222, n1];
    return new IndexedNode4(edit, toBitmap4(subH1) | toBitmap4(subH2), children);
  }
}
function mergeLeaves4(edit, shift22, h1, n1, h222, n222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner4(edit, currentShift, h1, n1, h222, n222);
    if (typeof res === "function") {
      stack = make54(res, stack);
      currentShift = currentShift + SIZE4;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey4 = "effect/HashMap";
var HashMapTypeId4 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey4);
var HashMapProto4 = {
  [HashMapTypeId4]: HashMapTypeId4,
  [Symbol.iterator]() {
    return new HashMapIterator4(this, (k32, v32) => [k32, v32]);
  },
  [symbol7]() {
    let hash242 = hash5(HashMapSymbolKey4);
    for (const item of this) {
      hash242 ^= pipe5(hash5(item[0]), combine6(hash5(item[1])));
    }
    return cached5(this, hash242);
  },
  [symbol24](that) {
    if (isHashMap4(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe5(that, getHash4(item[0], hash5(item[0])));
        if (isNone24(elem)) {
          return false;
        } else {
          if (!equals5(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format5(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON5)
    };
  },
  [NodeInspectSymbol5]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments5(this, arguments);
  }
};
var makeImpl5 = (editable, edit, root, size43) => {
  const map622 = Object.create(HashMapProto4);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size43;
  return map622;
};
var HashMapIterator4 = class _HashMapIterator4 {
  map;
  f;
  v;
  constructor(map622, f32) {
    this.map = map622;
    this.f = f32;
    this.v = visitLazy4(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone24(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont4(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator4(this.map, this.f);
  }
};
var applyCont4 = (cont) => cont ? visitLazyChildren4(cont[0], cont[1], cont[2], cont[3], cont[4]) : none24();
var visitLazy4 = (node, f32, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome24(node.value)) {
        return some34({
          value: f32(node.key, node.value.value),
          cont
        });
      }
      return applyCont4(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren4(children.length, children, 0, f32, cont);
    }
    default: {
      return applyCont4(cont);
    }
  }
};
var visitLazyChildren4 = (len, children, i32, f32, cont) => {
  while (i32 < len) {
    const child = children[i32++];
    if (child && !isEmptyNode4(child)) {
      return visitLazy4(child, f32, [len, children, i32, f32, cont]);
    }
  }
  return applyCont4(cont);
};
var _empty34 = /* @__PURE__ */ makeImpl5(false, 0, /* @__PURE__ */ new EmptyNode4(), 0);
var empty44 = () => _empty34;
var isHashMap4 = (u32) => hasProperty5(u32, HashMapTypeId4);
var getHash4 = /* @__PURE__ */ dual5(3, (self2, key, hash242) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals5(key, node.key) ? node.value : none24();
      }
      case "CollisionNode": {
        if (hash242 === node.hash) {
          const children = node.children;
          for (let i32 = 0, len = children.length; i32 < len; ++i32) {
            const child = children[i32];
            if ("key" in child && equals5(key, child.key)) {
              return child.value;
            }
          }
        }
        return none24();
      }
      case "IndexedNode": {
        const frag = hashFragment4(shift22, hash242);
        const bit = toBitmap4(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap4(node.mask, bit)];
          shift22 += SIZE4;
          break;
        }
        return none24();
      }
      case "ArrayNode": {
        node = node.children[hashFragment4(shift22, hash242)];
        if (node) {
          shift22 += SIZE4;
          break;
        }
        return none24();
      }
      default:
        return none24();
    }
  }
});
var set4 = /* @__PURE__ */ dual5(3, (self2, key, value) => modifyAt4(self2, key, () => some34(value)));
var setTree4 = /* @__PURE__ */ dual5(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl5(self2._editable, self2._edit, newRoot, newSize);
});
var keys5 = (self2) => new HashMapIterator4(self2, (key) => key);
var size6 = (self2) => self2._size;
var beginMutation5 = (self2) => makeImpl5(true, self2._edit + 1, self2._root, self2._size);
var modifyAt4 = /* @__PURE__ */ dual5(3, (self2, key, f32) => modifyHash4(self2, key, hash5(key), f32));
var modifyHash4 = /* @__PURE__ */ dual5(4, (self2, key, hash242, f32) => {
  const size43 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f32, hash242, key, size43);
  return pipe5(self2, setTree4(newRoot, size43.value));
});
var forEach6 = /* @__PURE__ */ dual5(2, (self2, f32) => reduce24(self2, void 0, (_32, value, key) => f32(value, key)));
var reduce24 = /* @__PURE__ */ dual5(3, (self2, zero, f32) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome24(root.value) ? f32(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i32 = 0, len = children.length; i32 < len; ) {
      const child = children[i32++];
      if (child && !isEmptyNode4(child)) {
        if (child._tag === "LeafNode") {
          if (isSome24(child.value)) {
            zero = f32(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey4 = "effect/HashSet";
var HashSetTypeId4 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey4);
var HashSetProto4 = {
  [HashSetTypeId4]: HashSetTypeId4,
  [Symbol.iterator]() {
    return keys5(this._keyMap);
  },
  [symbol7]() {
    return cached5(this, combine6(hash5(this._keyMap))(hash5(HashSetSymbolKey4)));
  },
  [symbol24](that) {
    if (isHashSet4(that)) {
      return size6(this._keyMap) === size6(that._keyMap) && equals5(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format5(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON5)
    };
  },
  [NodeInspectSymbol5]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments5(this, arguments);
  }
};
var makeImpl24 = (keyMap) => {
  const set242 = Object.create(HashSetProto4);
  set242._keyMap = keyMap;
  return set242;
};
var isHashSet4 = (u32) => hasProperty5(u32, HashSetTypeId4);
var _empty44 = /* @__PURE__ */ makeImpl24(/* @__PURE__ */ empty44());
var empty54 = () => _empty44;
var size24 = (self2) => size6(self2._keyMap);
var beginMutation24 = (self2) => makeImpl24(beginMutation5(self2._keyMap));
var endMutation4 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate4 = /* @__PURE__ */ dual5(2, (self2, f32) => {
  const transient = beginMutation24(self2);
  f32(transient);
  return endMutation4(transient);
});
var add24 = /* @__PURE__ */ dual5(2, (self2, value) => self2._keyMap._editable ? (set4(value, true)(self2._keyMap), self2) : makeImpl24(set4(value, true)(self2._keyMap)));
var union24 = /* @__PURE__ */ dual5(2, (self2, that) => mutate4(empty54(), (set242) => {
  forEach24(self2, (value) => add24(set242, value));
  for (const value of that) {
    add24(set242, value);
  }
}));
var forEach24 = /* @__PURE__ */ dual5(2, (self2, f32) => forEach6(self2._keyMap, (_32, k32) => f32(k32)));
var empty64 = empty54;
var size34 = size24;
var add34 = add24;
var union34 = union24;
var ArrayProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol7]() {
    return cached5(this, array8(this));
  },
  [symbol24](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v32, i32) => equals5(v32, that[i32]));
    } else {
      return false;
    }
  }
});
var Structural5 = /* @__PURE__ */ function() {
  function Structural33(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural33.prototype = StructuralPrototype3;
  return Structural33;
}();
var struct24 = (as242) => Object.assign(Object.create(StructuralPrototype3), as242);
var ContextPatchTypeId4 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance5(a32) {
  return a32;
}
var PatchProto4 = {
  ...Structural5.prototype,
  [ContextPatchTypeId4]: {
    _Value: variance5,
    _Patch: variance5
  }
};
var EmptyProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto4), {
  _tag: "Empty"
});
var _empty54 = /* @__PURE__ */ Object.create(EmptyProto4);
var empty74 = () => _empty54;
var AndThenProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto4), {
  _tag: "AndThen"
});
var makeAndThen4 = (first, second) => {
  const o32 = Object.create(AndThenProto4);
  o32.first = first;
  o32.second = second;
  return o32;
};
var AddServiceProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto4), {
  _tag: "AddService"
});
var makeAddService4 = (key, service) => {
  const o32 = Object.create(AddServiceProto4);
  o32.key = key;
  o32.service = service;
  return o32;
};
var RemoveServiceProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto4), {
  _tag: "RemoveService"
});
var makeRemoveService4 = (key) => {
  const o32 = Object.create(RemoveServiceProto4);
  o32.key = key;
  return o32;
};
var UpdateServiceProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto4), {
  _tag: "UpdateService"
});
var makeUpdateService4 = (key, update222) => {
  const o32 = Object.create(UpdateServiceProto4);
  o32.key = key;
  o32.update = update222;
  return o32;
};
var diff4 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch23 = empty74();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals5(old, newService)) {
        patch23 = combine24(makeUpdateService4(tag, () => newService))(patch23);
      }
    } else {
      missingServices.delete(tag);
      patch23 = combine24(makeAddService4(tag, newService))(patch23);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch23 = combine24(makeRemoveService4(tag))(patch23);
  }
  return patch23;
};
var combine24 = /* @__PURE__ */ dual5(2, (self2, that) => makeAndThen4(self2, that));
var patch4 = /* @__PURE__ */ dual5(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of5(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty4(patches)) {
    const head222 = headNonEmpty5(patches);
    const tail32 = tailNonEmpty5(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail32;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail32;
        break;
      }
      case "AndThen": {
        patches = prepend5(prepend5(tail32, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail32;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail32;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext4(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s32] of updatedContext) {
    map622.set(tag, s32);
  }
  return makeContext4(map622);
});
var DifferTypeId4 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto4 = {
  [DifferTypeId4]: {
    _P: identity5,
    _V: identity5
  }
};
var make74 = (params) => {
  const differ = Object.create(DifferProto4);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment4 = () => make74({
  empty: empty74(),
  combine: (first, second) => combine24(second)(first),
  diff: (oldValue, newValue) => diff4(oldValue, newValue),
  patch: (patch23, oldValue) => patch4(oldValue)(patch23)
});
var OP_DIE4 = "Die";
var OP_EMPTY4 = "Empty";
var OP_FAIL4 = "Fail";
var OP_INTERRUPT4 = "Interrupt";
var OP_PARALLEL4 = "Parallel";
var OP_SEQUENTIAL4 = "Sequential";
var CauseSymbolKey4 = "effect/Cause";
var CauseTypeId4 = /* @__PURE__ */ Symbol.for(CauseSymbolKey4);
var variance24 = {
  /* c8 ignore next */
  _E: (_32) => _32
};
var proto4 = {
  [CauseTypeId4]: variance24,
  [symbol7]() {
    return pipe5(hash5(CauseSymbolKey4), combine6(hash5(flattenCause4(this))), cached5(this));
  },
  [symbol24](that) {
    return isCause4(that) && causeEquals4(this, that);
  },
  pipe() {
    return pipeArguments5(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON5(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON5(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON5(this.left),
          right: toJSON5(this.right)
        };
    }
  },
  toString() {
    return pretty4(this);
  },
  [NodeInspectSymbol5]() {
    return this.toJSON();
  }
};
var fail5 = (error) => {
  const o32 = Object.create(proto4);
  o32._tag = OP_FAIL4;
  o32.error = error;
  return o32;
};
var parallel4 = (left33, right33) => {
  const o32 = Object.create(proto4);
  o32._tag = OP_PARALLEL4;
  o32.left = left33;
  o32.right = right33;
  return o32;
};
var sequential4 = (left33, right33) => {
  const o32 = Object.create(proto4);
  o32._tag = OP_SEQUENTIAL4;
  o32.left = left33;
  o32.right = right33;
  return o32;
};
var isCause4 = (u32) => hasProperty5(u32, CauseTypeId4);
var isInterruptedOnly4 = (self2) => reduceWithContext4(void 0, IsInterruptedOnlyCauseReducer4)(self2);
var causeEquals4 = (left33, right33) => {
  let leftStack = of5(left33);
  let rightStack = of5(right33);
  while (isNonEmpty4(leftStack) && isNonEmpty4(rightStack)) {
    const [leftParallel, leftSequential] = pipe5(headNonEmpty5(leftStack), reduce44([empty64(), empty34()], ([parallel23, sequential23], cause) => {
      const [par, seq] = evaluateCause4(cause);
      return some34([pipe5(parallel23, union34(par)), pipe5(sequential23, appendAll5(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe5(headNonEmpty5(rightStack), reduce44([empty64(), empty34()], ([parallel23, sequential23], cause) => {
      const [par, seq] = evaluateCause4(cause);
      return some34([pipe5(parallel23, union34(par)), pipe5(sequential23, appendAll5(seq))]);
    }));
    if (!equals5(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause4 = (cause) => {
  return flattenCauseLoop4(of5(cause), empty34());
};
var flattenCauseLoop4 = (causes, flattened) => {
  while (1) {
    const [parallel23, sequential23] = pipe5(causes, reduce7([empty64(), empty34()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause4(cause);
      return [pipe5(parallel322, union34(par)), pipe5(sequential322, appendAll5(seq))];
    }));
    const updated = size34(parallel23) > 0 ? pipe5(flattened, prepend5(parallel23)) : flattened;
    if (isEmpty4(sequential23)) {
      return reverse24(updated);
    }
    causes = sequential23;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage5("Cause.flattenCauseLoop"));
};
var evaluateCause4 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty64();
  let _sequential = empty34();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY4: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL4: {
        _parallel = add34(_parallel, make44(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE4: {
        _parallel = add34(_parallel, make44(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT4: {
        _parallel = add34(_parallel, make44(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL4: {
        switch (cause.left._tag) {
          case OP_EMPTY4: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL4: {
            cause = sequential4(cause.left.left, sequential4(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL4: {
            cause = parallel4(sequential4(cause.left.left, cause.right), sequential4(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend5(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL4: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage5("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer4 = {
  emptyCase: constTrue5,
  failCase: constFalse5,
  dieCase: constFalse5,
  interruptCase: constTrue5,
  sequentialCase: (_32, left33, right33) => left33 && right33,
  parallelCase: (_32, left33, right33) => left33 && right33
};
var OP_SEQUENTIAL_CASE4 = "SequentialCase";
var OP_PARALLEL_CASE4 = "ParallelCase";
var reduce44 = /* @__PURE__ */ dual5(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome24(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL4: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL4: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext4 = /* @__PURE__ */ dual5(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY4: {
        output.push(right24(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL4: {
        output.push(right24(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE4: {
        output.push(right24(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT4: {
        output.push(right24(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL4: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left24({
          _tag: OP_SEQUENTIAL_CASE4
        }));
        break;
      }
      case OP_PARALLEL4: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left24({
          _tag: OP_PARALLEL_CASE4
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE4: {
            const left33 = accumulator.pop();
            const right33 = accumulator.pop();
            const value = reducer.sequentialCase(context, left33, right33);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE4: {
            const left33 = accumulator.pop();
            const right33 = accumulator.pop();
            const value = reducer.parallelCase(context, left33, right33);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty4 = (cause) => {
  if (isInterruptedOnly4(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors4(cause).map((e32) => e32.stack).join("\n");
};
var PrettyError4 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage4(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol5 in originalError) {
        this.span = originalError[spanSymbol5];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack4(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage4 = (u32) => {
  if (typeof u32 === "string") {
    return `Error: ${u32}`;
  }
  try {
    if (hasProperty5(u32, "toString") && isFunction34(u32["toString"]) && u32["toString"] !== Object.prototype.toString && u32["toString"] !== globalThis.Array.prototype.toString) {
      return u32["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u32)}`;
};
var locationRegex4 = /\((.*)\)/;
var spanToTrace4 = /* @__PURE__ */ globalValue5("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack4 = (message, stack, span22) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i32 = 1; i32 < lines.length; i32++) {
    if (lines[i32].includes("Generator.next")) {
      break;
    }
    if (lines[i32].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i32].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span22) {
    let current = span22;
    let i32 = 0;
    while (current && current._tag === "Span" && i32 < 10) {
      const stackFn = spanToTrace4.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex4);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined5(current.parent);
      i32++;
    }
  }
  return out.join("\n");
};
var spanSymbol5 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors4 = (cause) => reduceWithContext4(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_32, unknownError) => {
    return [new PrettyError4(unknownError)];
  },
  failCase: (_32, error) => {
    return [new PrettyError4(error)];
  },
  interruptCase: () => [],
  parallelCase: (_32, l32, r32) => [...l32, ...r32],
  sequentialCase: (_32, l32, r32) => [...l32, ...r32]
});
var SingleShotGen24 = class _SingleShotGen23 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a32) {
    return this.called ? {
      value: a32,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a32) {
    return {
      value: a32,
      done: true
    };
  }
  throw(e32) {
    throw e32;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen23(this.self);
  }
};
var spanTag4 = /* @__PURE__ */ GenericTag4("effect/ParentSpan");
var EffectTypeId24 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive4 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId24] = effectVariance5;
  constructor(_op) {
    this._op = _op;
  }
  [symbol24](that) {
    return this === that;
  }
  [symbol7]() {
    return cached5(this, random5(this));
  }
  pipe() {
    return pipeArguments5(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON5(this.effect_instruction_i0),
      effect_instruction_i1: toJSON5(this.effect_instruction_i1),
      effect_instruction_i2: toJSON5(this.effect_instruction_i2)
    };
  }
  toString() {
    return format5(this.toJSON());
  }
  [NodeInspectSymbol5]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen24(new YieldWrap5(this));
  }
};
var EffectPrimitiveFailure4 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId24] = effectVariance5;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol24](that) {
    return exitIsExit4(that) && that._op === "Failure" && // @ts-expect-error
    equals5(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol7]() {
    return pipe5(
      // @ts-expect-error
      string6(this._tag),
      // @ts-expect-error
      combine6(hash5(this.effect_instruction_i0)),
      cached5(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments5(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format5(this.toJSON());
  }
  [NodeInspectSymbol5]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen24(new YieldWrap5(this));
  }
};
var isEffect4 = (u32) => hasProperty5(u32, EffectTypeId24);
var withFiberRuntime4 = (withRuntime) => {
  const effect = new EffectPrimitive4(OP_WITH_RUNTIME4);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol24 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol4 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture4 = (obj, span22) => {
  if (isSome24(span22)) {
    return new Proxy(obj, {
      has(target, p32) {
        return p32 === spanSymbol24 || p32 === originalSymbol4 || p32 in target;
      },
      get(target, p32) {
        if (p32 === spanSymbol24) {
          return span22.value;
        }
        if (p32 === originalSymbol4) {
          return obj;
        }
        return target[p32];
      }
    });
  }
  return obj;
};
var fail24 = (error) => isObject5(error) && !(spanSymbol24 in error) ? withFiberRuntime4((fiber) => failCause4(fail5(capture4(error, currentSpanFromFiber4(fiber))))) : failCause4(fail5(error));
var failCause4 = (cause) => {
  const effect = new EffectPrimitiveFailure4(OP_FAILURE4);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey4 = "effect/FiberRef";
var FiberRefTypeId4 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey4);
var fiberRefVariance4 = {
  /* c8 ignore next */
  _A: (_32) => _32
};
var fiberRefUnsafeMakeContext4 = (initial) => {
  const differ = environment4();
  return fiberRefUnsafeMakePatch4(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch4 = (initial, options) => ({
  [FiberRefTypeId4]: fiberRefVariance4,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch23) => (oldValue) => options.differ.patch(patch23, oldValue),
  fork: options.fork,
  join: options.join ?? ((_32, n32) => n32),
  pipe() {
    return pipeArguments5(this, arguments);
  }
});
var currentContext4 = /* @__PURE__ */ globalValue5(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext4(empty24()));
var YieldableError4 = /* @__PURE__ */ function() {
  class YieldableError23 extends globalThis.Error {
    commit() {
      return fail24(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol5]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError23.prototype, StructuralCommitPrototype3);
  return YieldableError23;
}();
var exitIsExit4 = (u32) => isEffect4(u32) && "_tag" in u32 && (u32._tag === "Success" || u32._tag === "Failure");
var currentSpanFromFiber4 = (fiber) => {
  const span22 = fiber.getFiberRef(currentContext4).unsafeMap.get(spanTag4.key);
  return span22 !== void 0 && span22._tag === "Span" ? some34(span22) : none24();
};
var Data_exports3 = {};
__export23(Data_exports3, {
  Class: () => Class24,
  Error: () => Error24,
  Structural: () => Structural24,
  TaggedClass: () => TaggedClass4,
  TaggedError: () => TaggedError4,
  array: () => array24,
  case: () => _case4,
  struct: () => struct34,
  tagged: () => tagged4,
  taggedEnum: () => taggedEnum4,
  tuple: () => tuple24,
  unsafeArray: () => unsafeArray4,
  unsafeStruct: () => unsafeStruct4
});
var struct34 = struct24;
var unsafeStruct4 = (as242) => Object.setPrototypeOf(as242, StructuralPrototype3);
var tuple24 = (...as242) => unsafeArray4(as242);
var array24 = (as242) => unsafeArray4(as242.slice(0));
var unsafeArray4 = (as242) => Object.setPrototypeOf(as242, ArrayProto4);
var _case4 = () => (args) => args === void 0 ? Object.create(StructuralPrototype3) : struct34(args);
var tagged4 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype3) : struct34(args);
  value._tag = tag;
  return value;
};
var Class24 = Structural5;
var TaggedClass4 = (tag) => {
  class Base extends Class24 {
    _tag = tag;
  }
  return Base;
};
var Structural24 = Structural5;
var taggedEnum4 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged5;
    } else if (tag === "$match") {
      return taggedMatch4;
    }
    return tagged4(tag);
  }
});
function taggedMatch4() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error24 = /* @__PURE__ */ function() {
  return class Base extends YieldableError4 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError4 = (tag) => {
  class Base extends Error24 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp4 = Function_exports5.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType4.Program) return Option_exports5.none();
  return predicate(parent) ? Option_exports5.some(parent) : traverseUp4(parent, predicate);
});
var traverseUpGuard4 = Function_exports5.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType4.Program) return Option_exports5.none();
  return predicate(parent) ? Option_exports5.some(parent) : traverseUpGuard4(parent, predicate);
});
var ESLintCommunityESLintUtils4;
((ESLintCommunityESLintUtils23) => {
  ESLintCommunityESLintUtils23.getFunctionHeadLocation = getFunctionHeadLocation4;
  ESLintCommunityESLintUtils23.getFunctionNameWithKind = getFunctionNameWithKind4;
  ESLintCommunityESLintUtils23.getPropertyName = getPropertyName4;
  ESLintCommunityESLintUtils23.getStaticValue = getStaticValue5;
  ESLintCommunityESLintUtils23.getStringIfConstant = getStringIfConstant4;
  ESLintCommunityESLintUtils23.hasSideEffect = hasSideEffect4;
  ESLintCommunityESLintUtils23.isParenthesized = isParenthesized4;
})(ESLintCommunityESLintUtils4 || (ESLintCommunityESLintUtils4 = {}));
var Construction4 = Data_exports3.taggedEnum();
Construction4.None();
function getClassIdentifier2(node) {
  if (node.id) return Option_exports5.fromNullable(node.id);
  if (node.parent.type === NodeType4.VariableDeclarator && node.parent.id.type === NodeType4.Identifier) {
    return Option_exports5.fromNullable(node.parent.id);
  }
  return Option_exports5.none();
}
function getFunctionIdentifier2(node) {
  if (node.id) return Option_exports5.some(node.id);
  if (node.parent.type === NodeType4.VariableDeclarator && node.parent.init === node && node.parent.id.type === NodeType4.Identifier) {
    return Option_exports5.some(node.parent.id);
  }
  if (node.parent.type === NodeType4.AssignmentExpression && node.parent.right === node && node.parent.operator === "=" && node.parent.left.type === NodeType4.Identifier) {
    return Option_exports5.some(node.parent.left);
  }
  if (node.parent.type === NodeType4.Property && node.parent.value === node && !node.parent.computed && node.parent.key.type === NodeType4.Identifier) {
    return Option_exports5.some(node.parent.key);
  }
  if (isOneOf4([NodeType4.MethodDefinition, NodeType4.PropertyDefinition])(node.parent) && node.parent.value === node && node.parent.key.type === NodeType4.Identifier) {
    return Option_exports5.some(node.parent.key);
  }
  if (node.parent.type === NodeType4.AssignmentPattern && node.parent.right === node && node.parent.left.type === NodeType4.Identifier) {
    return Option_exports5.some(node.parent.left);
  }
  return Option_exports5.none();
}
var isFunctionOfObjectMethod2 = a({
  type: N.union([NodeType4.FunctionExpression, NodeType4.ArrowFunctionExpression]),
  parent: {
    type: NodeType4.Property,
    parent: {
      type: NodeType4.ObjectExpression
    }
  }
});
var isFunctionOfClassMethod2 = a({
  type: N.union([NodeType4.FunctionExpression, NodeType4.ArrowFunctionExpression]),
  parent: {
    type: NodeType4.MethodDefinition,
    parent: {
      type: NodeType4.ClassBody
    }
  }
});
var isFunctionOfClassProperty2 = a({
  type: N.union([NodeType4.FunctionExpression, NodeType4.ArrowFunctionExpression]),
  parent: {
    type: NodeType4.Property,
    parent: {
      type: NodeType4.ClassBody
    }
  }
});
var __defProp32 = Object.defineProperty;
var __export32 = (target, all622) => {
  for (var name2 in all622)
    __defProp32(target, name2, { get: all622[name2], enumerable: true });
};
var KEYS22 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES22 = Object.keys(KEYS22);
for (const type of NODE_TYPES22) {
  Object.freeze(KEYS22[type]);
}
Object.freeze(KEYS22);
var visitor_keys_default22 = KEYS22;
var KEY_BLACKLIST22 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey22(key) {
  return !KEY_BLACKLIST22.has(key) && key[0] !== "_";
}
function getKeys22(node) {
  return Object.keys(node).filter(filterKey22);
}
function getInnermostScope22(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range22 = childScope.block.range;
      if (range22[0] <= location && location < range22[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable23(initialScope, nameOrNode) {
  let name2 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name2 = nameOrNode;
  } else {
    name2 = nameOrNode.name;
    scope = getInnermostScope22(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name2);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate022(token) {
  return !this(token);
}
function negate22(f222) {
  return negate022.bind(f222);
}
function isPunctuatorTokenWithValue22(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken22(token) {
  return isPunctuatorTokenWithValue22(token, "=>");
}
function isCommaToken22(token) {
  return isPunctuatorTokenWithValue22(token, ",");
}
function isSemicolonToken22(token) {
  return isPunctuatorTokenWithValue22(token, ";");
}
function isColonToken22(token) {
  return isPunctuatorTokenWithValue22(token, ":");
}
function isOpeningParenToken22(token) {
  return isPunctuatorTokenWithValue22(token, "(");
}
function isClosingParenToken22(token) {
  return isPunctuatorTokenWithValue22(token, ")");
}
function isOpeningBracketToken22(token) {
  return isPunctuatorTokenWithValue22(token, "[");
}
function isClosingBracketToken22(token) {
  return isPunctuatorTokenWithValue22(token, "]");
}
function isOpeningBraceToken22(token) {
  return isPunctuatorTokenWithValue22(token, "{");
}
function isClosingBraceToken22(token) {
  return isPunctuatorTokenWithValue22(token, "}");
}
function isCommentToken22(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate22(isArrowToken22);
negate22(isCommaToken22);
negate22(isSemicolonToken22);
negate22(isColonToken22);
negate22(isOpeningParenToken22);
negate22(isClosingParenToken22);
negate22(isOpeningBracketToken22);
negate22(isClosingBracketToken22);
negate22(isOpeningBraceToken22);
negate22(isClosingBraceToken22);
negate22(isCommentToken22);
function getOpeningParenOfParams22(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken22) : sourceCode.getFirstToken(node, isOpeningParenToken22);
}
function getFunctionHeadLocation22(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken22);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams22(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams22(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject22 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames22 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed22 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k222) => k222 !== "random").map((k222) => Math[k222]).filter((f222) => typeof f222 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f222) => typeof f222 === "function")
);
var callPassThrough22 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed22 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor22(object22, name2) {
  let x222 = object22;
  while ((typeof x222 === "object" || typeof x222 === "function") && x222 !== null) {
    const d222 = Object.getOwnPropertyDescriptor(x222, name2);
    if (d222) {
      return d222;
    }
    x222 = Object.getPrototypeOf(x222);
  }
  return null;
}
function isGetter22(object22, name2) {
  const d222 = getPropertyDescriptor22(object22, name2);
  return d222 != null && d222.get != null;
}
function getElementValues22(nodeList, initialScope) {
  const valueList = [];
  for (let i222 = 0; i222 < nodeList.length; ++i222) {
    const elementNode = nodeList[i222];
    if (elementNode == null) {
      valueList.length = i222 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR22(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR22(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst22(variable) {
  const refs = variable.references;
  const inits = refs.filter((r222) => r222.init).length;
  const reads = refs.filter((r222) => r222.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations22 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues22(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR22(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left522 = getStaticValueR22(node.left, initialScope);
    const right522 = getStaticValueR22(node.right, initialScope);
    if (left522 != null && right522 != null) {
      switch (node.operator) {
        case "==":
          return { value: left522.value == right522.value };
        case "!=":
          return { value: left522.value != right522.value };
        case "===":
          return { value: left522.value === right522.value };
        case "!==":
          return { value: left522.value !== right522.value };
        case "<":
          return { value: left522.value < right522.value };
        case "<=":
          return { value: left522.value <= right522.value };
        case ">":
          return { value: left522.value > right522.value };
        case ">=":
          return { value: left522.value >= right522.value };
        case "<<":
          return { value: left522.value << right522.value };
        case ">>":
          return { value: left522.value >> right522.value };
        case ">>>":
          return { value: left522.value >>> right522.value };
        case "+":
          return { value: left522.value + right522.value };
        case "-":
          return { value: left522.value - right522.value };
        case "*":
          return { value: left522.value * right522.value };
        case "/":
          return { value: left522.value / right522.value };
        case "%":
          return { value: left522.value % right522.value };
        case "**":
          return { value: left522.value ** right522.value };
        case "|":
          return { value: left522.value | right522.value };
        case "^":
          return { value: left522.value ^ right522.value };
        case "&":
          return { value: left522.value & right522.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues22(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object22 = getStaticValueR22(calleeNode.object, initialScope);
        if (object22 != null) {
          if (object22.value == null && (object22.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue22(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object22.value;
            const methodName = property.value;
            if (callAllowed22.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough22.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR22(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed22.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough22.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR22(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR22(node.consequent, initialScope) : getStaticValueR22(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR22(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable23(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames22.has(variable.name) && variable.name in globalObject22) {
        return { value: globalObject22[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst22(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR22(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left522 = getStaticValueR22(node.left, initialScope);
    if (left522 != null) {
      if (node.operator === "||" && Boolean(left522.value) === true || node.operator === "&&" && Boolean(left522.value) === false || node.operator === "??" && left522.value != null) {
        return left522;
      }
      const right522 = getStaticValueR22(node.right, initialScope);
      if (right522 != null) {
        return right522;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object22 = getStaticValueR22(node.object, initialScope);
    if (object22 != null) {
      if (object22.value == null && (object22.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue22(node, initialScope);
      if (property != null) {
        if (!isGetter22(object22.value, property.value)) {
          return { value: object22.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed22) {
          if (object22.value instanceof classFn && allowed.has(property.value)) {
            return { value: object22.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR22(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR22(node.callee, initialScope);
    const args = getElementValues22(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed22.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object22 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue22(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR22(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object22[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR22(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object22, argument.value);
      } else {
        return null;
      }
    }
    return { value: object22 };
  },
  SequenceExpression(node, initialScope) {
    const last22 = node.expressions[node.expressions.length - 1];
    return getStaticValueR22(last22, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR22(node.tag, initialScope);
    const expressions = getElementValues22(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues22(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i222 = 0; i222 < expressions.length; ++i222) {
        value += expressions[i222];
        value += node.quasis[i222 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR22(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR22(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations22, node.type)) {
    return operations22[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue22(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR22(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue22(node, initialScope = null) {
  try {
    return getStaticValueR22(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant22(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue22(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName22(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant22(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant22(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind22(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name2 = getPropertyName22(parent);
      if (name2) {
        tokens.push(`'${name2}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps22 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps22 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode22(x222) {
  return x222 !== null && typeof x222 === "object" && typeof x222.type === "string";
}
var visitor22 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys22(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode22(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode22(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps22.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps22.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect22(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor22.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default22
  );
}
function getParentSyntaxParen22(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken22
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken22
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized22(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken22(maybeLeftParen) && isClosingParenToken22(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen22(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp223 = Object.defineProperty;
var __export223 = (target, all3222) => {
  for (var name2 in all3222)
    __defProp223(target, name2, { get: all3222[name2], enumerable: true });
};
var NodeType22 = AST_NODE_TYPES;
var is22 = ASTUtils.isNodeOfType;
var isOneOf22 = ASTUtils.isNodeOfTypes;
isOneOf22([
  NodeType22.ArrowFunctionExpression,
  NodeType22.FunctionDeclaration,
  NodeType22.FunctionExpression
]);
isOneOf22([
  NodeType22.ArrowFunctionExpression,
  NodeType22.FunctionDeclaration,
  NodeType22.FunctionExpression,
  NodeType22.TSCallSignatureDeclaration,
  NodeType22.TSConstructSignatureDeclaration,
  NodeType22.TSDeclareFunction,
  NodeType22.TSEmptyBodyFunctionExpression,
  NodeType22.TSFunctionType,
  NodeType22.TSMethodSignature
]);
isOneOf22([NodeType22.ClassDeclaration, NodeType22.ClassExpression]);
isOneOf22([
  NodeType22.DoWhileStatement,
  NodeType22.ForInStatement,
  NodeType22.ForOfStatement,
  NodeType22.ForStatement,
  NodeType22.WhileStatement
]);
isOneOf22([NodeType22.TSArrayType, NodeType22.TSTupleType]);
isOneOf22([
  NodeType22.PropertyDefinition,
  NodeType22.TSIndexSignature,
  NodeType22.TSParameterProperty,
  NodeType22.TSPropertySignature
]);
is22(NodeType22.JSXElement);
is22(NodeType22.JSXFragment);
isOneOf22([
  NodeType22.JSXAttribute,
  NodeType22.JSXSpreadChild,
  NodeType22.JSXClosingElement,
  NodeType22.JSXClosingFragment,
  NodeType22.JSXElement,
  NodeType22.JSXEmptyExpression,
  NodeType22.JSXExpressionContainer,
  NodeType22.JSXFragment,
  NodeType22.JSXIdentifier,
  NodeType22.JSXMemberExpression,
  NodeType22.JSXNamespacedName,
  NodeType22.JSXOpeningElement,
  NodeType22.JSXOpeningFragment,
  NodeType22.JSXSpreadAttribute,
  NodeType22.JSXSpreadChild,
  NodeType22.JSXText
]);
var isJSXTagNameExpression22 = isOneOf22([
  NodeType22.JSXIdentifier,
  NodeType22.JSXMemberExpression,
  NodeType22.JSXNamespacedName
]);
isOneOf22([
  NodeType22.ArrayPattern,
  NodeType22.AssignmentPattern,
  NodeType22.ObjectPattern,
  NodeType22.RestElement
]);
isOneOf22([
  NodeType22.TSInterfaceDeclaration,
  NodeType22.TSTypeAliasDeclaration
]);
isOneOf22([
  NodeType22.ArrayExpression,
  NodeType22.ArrayPattern,
  NodeType22.ArrowFunctionExpression,
  NodeType22.CallExpression,
  NodeType22.ClassExpression,
  NodeType22.FunctionExpression,
  NodeType22.Identifier,
  NodeType22.JSXElement,
  NodeType22.JSXFragment,
  NodeType22.Literal,
  NodeType22.TemplateLiteral,
  NodeType22.MemberExpression,
  NodeType22.MetaProperty,
  NodeType22.ObjectExpression,
  NodeType22.ObjectPattern,
  NodeType22.SequenceExpression,
  NodeType22.Super,
  NodeType22.TaggedTemplateExpression,
  NodeType22.ThisExpression
]);
isOneOf22([
  NodeType22.ArrayExpression,
  NodeType22.ArrayPattern,
  NodeType22.ArrowFunctionExpression,
  NodeType22.CallExpression,
  NodeType22.ClassExpression,
  NodeType22.FunctionExpression,
  NodeType22.Identifier,
  NodeType22.JSXElement,
  NodeType22.JSXFragment,
  NodeType22.Literal,
  NodeType22.TemplateLiteral,
  NodeType22.MemberExpression,
  NodeType22.MetaProperty,
  NodeType22.ObjectExpression,
  NodeType22.ObjectPattern,
  NodeType22.SequenceExpression,
  NodeType22.Super,
  NodeType22.TaggedTemplateExpression,
  NodeType22.ThisExpression,
  NodeType22.TSAsExpression,
  NodeType22.TSNonNullExpression,
  NodeType22.TSTypeAssertion
]);
var Function_exports23 = {};
__export223(Function_exports23, {
  SK: () => SK23,
  absurd: () => absurd23,
  apply: () => apply23,
  compose: () => compose32,
  constFalse: () => constFalse23,
  constNull: () => constNull23,
  constTrue: () => constTrue23,
  constUndefined: () => constUndefined23,
  constVoid: () => constVoid23,
  constant: () => constant23,
  dual: () => dual23,
  flip: () => flip23,
  flow: () => flow23,
  hole: () => hole23,
  identity: () => identity23,
  isFunction: () => isFunction223,
  pipe: () => pipe23,
  satisfies: () => satisfies23,
  tupled: () => tupled23,
  unsafeCoerce: () => unsafeCoerce23,
  untupled: () => untupled23
});
var isFunction223 = (input) => typeof input === "function";
var dual23 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a222, b222) {
        if (arguments.length >= 2) {
          return body(a222, b222);
        }
        return function(self2) {
          return body(self2, a222);
        };
      };
    case 3:
      return function(a222, b222, c222) {
        if (arguments.length >= 3) {
          return body(a222, b222, c222);
        }
        return function(self2) {
          return body(self2, a222, b222);
        };
      };
    case 4:
      return function(a222, b222, c222, d222) {
        if (arguments.length >= 4) {
          return body(a222, b222, c222, d222);
        }
        return function(self2) {
          return body(self2, a222, b222, c222);
        };
      };
    case 5:
      return function(a222, b222, c222, d222, e222) {
        if (arguments.length >= 5) {
          return body(a222, b222, c222, d222, e222);
        }
        return function(self2) {
          return body(self2, a222, b222, c222, d222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply23 = (a222) => (self2) => self2(a222);
var identity23 = (a222) => a222;
var satisfies23 = () => (b222) => b222;
var unsafeCoerce23 = identity23;
var constant23 = (value) => () => value;
var constTrue23 = /* @__PURE__ */ constant23(true);
var constFalse23 = /* @__PURE__ */ constant23(false);
var constNull23 = /* @__PURE__ */ constant23(null);
var constUndefined23 = /* @__PURE__ */ constant23(void 0);
var constVoid23 = constUndefined23;
var flip23 = (f222) => (...b222) => (...a222) => f222(...a222)(...b222);
var compose32 = /* @__PURE__ */ dual23(2, (ab, bc) => (a222) => bc(ab(a222)));
var absurd23 = (_222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled23 = (f222) => (a222) => f222(...a222);
var untupled23 = (f222) => (...a222) => f222(a222);
function pipe23(a222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a222;
    case 2:
      return ab(a222);
    case 3:
      return bc(ab(a222));
    case 4:
      return cd(bc(ab(a222)));
    case 5:
      return de(cd(bc(ab(a222))));
    case 6:
      return ef(de(cd(bc(ab(a222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a222))))))));
    default: {
      let ret = arguments[0];
      for (let i222 = 1; i222 < arguments.length; i222++) {
        ret = arguments[i222](ret);
      }
      return ret;
    }
  }
}
function flow23(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole23 = /* @__PURE__ */ unsafeCoerce23(absurd23);
var SK23 = (_222, b222) => b222;
var make62 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_33 = (map622) => dual23(3, (self2, name2, f222) => map622(self2, (a222) => Object.assign({}, a222, {
  [name2]: f222(a222)
})));
var bindTo33 = (map622) => dual23(2, (self2, name2) => map622(self2, (a222) => ({
  [name2]: a222
})));
var bind33 = (map622, flatMap422) => dual23(3, (self2, name2, f222) => flatMap422(self2, (a222) => map622(f222(a222), (b222) => Object.assign({}, a222, {
  [name2]: b222
}))));
var moduleVersion23 = "3.2.8";
var getCurrentVersion23 = () => moduleVersion23;
var globalStoreId23 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion23()}`);
if (!(globalStoreId23 in globalThis)) {
  globalThis[globalStoreId23] = /* @__PURE__ */ new Map();
}
var globalStore23 = globalThis[globalStoreId23];
var globalValue23 = (id, compute) => {
  if (!globalStore23.has(id)) {
    globalStore23.set(id, compute());
  }
  return globalStore23.get(id);
};
var Predicate_exports23 = {};
__export223(Predicate_exports23, {
  all: () => all32,
  and: () => and22,
  compose: () => compose223,
  eqv: () => eqv22,
  every: () => every22,
  hasProperty: () => hasProperty23,
  implies: () => implies22,
  isBigInt: () => isBigInt22,
  isBoolean: () => isBoolean22,
  isDate: () => isDate22,
  isError: () => isError22,
  isFunction: () => isFunction322,
  isIterable: () => isIterable22,
  isMap: () => isMap22,
  isNever: () => isNever22,
  isNotNull: () => isNotNull22,
  isNotNullable: () => isNotNullable22,
  isNotUndefined: () => isNotUndefined22,
  isNull: () => isNull22,
  isNullable: () => isNullable23,
  isNumber: () => isNumber22,
  isObject: () => isObject23,
  isPromise: () => isPromise22,
  isPromiseLike: () => isPromiseLike22,
  isReadonlyRecord: () => isReadonlyRecord22,
  isRecord: () => isRecord22,
  isSet: () => isSet22,
  isString: () => isString22,
  isSymbol: () => isSymbol22,
  isTagged: () => isTagged22,
  isTruthy: () => isTruthy22,
  isUint8Array: () => isUint8Array22,
  isUndefined: () => isUndefined22,
  isUnknown: () => isUnknown22,
  mapInput: () => mapInput22,
  nand: () => nand22,
  nor: () => nor22,
  not: () => not22,
  or: () => or22,
  product: () => product32,
  productMany: () => productMany32,
  some: () => some42,
  struct: () => struct42,
  tuple: () => tuple32,
  xor: () => xor22
});
var mapInput22 = /* @__PURE__ */ dual23(2, (self2, f222) => (b222) => self2(f222(b222)));
var isTruthy22 = (input) => !!input;
var isSet22 = (input) => input instanceof Set;
var isMap22 = (input) => input instanceof Map;
var isString22 = (input) => typeof input === "string";
var isNumber22 = (input) => typeof input === "number";
var isBoolean22 = (input) => typeof input === "boolean";
var isBigInt22 = (input) => typeof input === "bigint";
var isSymbol22 = (input) => typeof input === "symbol";
var isFunction322 = isFunction223;
var isUndefined22 = (input) => input === void 0;
var isNotUndefined22 = (input) => input !== void 0;
var isNull22 = (input) => input === null;
var isNotNull22 = (input) => input !== null;
var isNever22 = (_222) => false;
var isUnknown22 = (_222) => true;
var isRecordOrArray23 = (input) => typeof input === "object" && input !== null;
var isObject23 = (input) => isRecordOrArray23(input) || isFunction322(input);
var hasProperty23 = /* @__PURE__ */ dual23(2, (self2, property) => isObject23(self2) && property in self2);
var isTagged22 = /* @__PURE__ */ dual23(2, (self2, tag) => hasProperty23(self2, "_tag") && self2["_tag"] === tag);
var isNullable23 = (input) => input === null || input === void 0;
var isNotNullable22 = (input) => input !== null && input !== void 0;
var isError22 = (input) => input instanceof Error;
var isUint8Array22 = (input) => input instanceof Uint8Array;
var isDate22 = (input) => input instanceof Date;
var isIterable22 = (input) => hasProperty23(input, Symbol.iterator);
var isRecord22 = (input) => isRecordOrArray23(input) && !Array.isArray(input);
var isReadonlyRecord22 = isRecord22;
var isPromise22 = (input) => hasProperty23(input, "then") && "catch" in input && isFunction322(input.then) && isFunction322(input.catch);
var isPromiseLike22 = (input) => hasProperty23(input, "then") && isFunction322(input.then);
var compose223 = /* @__PURE__ */ dual23(2, (ab, bc) => (a222) => ab(a222) && bc(a222));
var product32 = (self2, that) => ([a222, b222]) => self2(a222) && that(b222);
var all32 = (collection) => {
  return (as2322) => {
    let collectionIndex = 0;
    for (const p222 of collection) {
      if (collectionIndex >= as2322.length) {
        break;
      }
      if (p222(as2322[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany32 = (self2, collection) => {
  const rest = all32(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple32 = (...elements) => all32(elements);
var struct42 = (fields) => {
  const keys2222 = Object.keys(fields);
  return (a222) => {
    for (const key of keys2222) {
      if (!fields[key](a222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not22 = (self2) => (a222) => !self2(a222);
var or22 = /* @__PURE__ */ dual23(2, (self2, that) => (a222) => self2(a222) || that(a222));
var and22 = /* @__PURE__ */ dual23(2, (self2, that) => (a222) => self2(a222) && that(a222));
var xor22 = /* @__PURE__ */ dual23(2, (self2, that) => (a222) => self2(a222) !== that(a222));
var eqv22 = /* @__PURE__ */ dual23(2, (self2, that) => (a222) => self2(a222) === that(a222));
var implies22 = /* @__PURE__ */ dual23(2, (self2, that) => (a222) => self2(a222) ? that(a222) : true);
var nor22 = /* @__PURE__ */ dual23(2, (self2, that) => (a222) => !(self2(a222) || that(a222)));
var nand22 = /* @__PURE__ */ dual23(2, (self2, that) => (a222) => !(self2(a222) && that(a222)));
var every22 = (collection) => (a222) => {
  for (const p222 of collection) {
    if (!p222(a222)) {
      return false;
    }
  }
  return true;
};
var some42 = (collection) => (a222) => {
  for (const p222 of collection) {
    if (p222(a222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage23 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId23 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind23 = (u222) => isObject23(u222) && GenKindTypeId23 in u222;
var GenKindImpl23 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity23;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_222) => _222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_222) => _222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_222) => _222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId23] = GenKindTypeId23;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen32(this);
  }
};
var SingleShotGen32 = class _SingleShotGen32 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a222) {
    return this.called ? {
      value: a222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a222) {
    return {
      value: a222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e222) {
    throw e222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen32(this.self);
  }
};
var adapter33 = () => function() {
  let x222 = arguments[0];
  for (let i222 = 1; i222 < arguments.length; i222++) {
    x222 = arguments[i222](x222);
  }
  return new GenKindImpl23(x222);
};
var defaultIncHi23 = 335903614;
var defaultIncLo23 = 4150755663;
var MUL_HI23 = 1481765933 >>> 0;
var MUL_LO23 = 1284865837 >>> 0;
var BIT_5323 = 9007199254740992;
var BIT_2723 = 134217728;
var PCGRandom23 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable23(seedLo) && isNullable23(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable23(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable23(incLo) && isNullable23(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo23;
      incHi = this._state ? this._state[2] : defaultIncHi23;
    } else if (isNullable23(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6423(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max32) {
    if (!max32) {
      return this._next();
    }
    max32 = max32 >>> 0;
    if ((max32 & max32 - 1) === 0) {
      return this._next() & max32 - 1;
    }
    let num = 0;
    const skew = (-max32 >>> 0) % max32 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max32;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2723 + lo) / BIT_5323;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6423(this._state, oldHi, oldLo, MUL_HI23, MUL_LO23);
    add6423(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6423(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6423(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId23 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap23 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId23]() {
    return this.#value;
  }
};
function yieldWrapGet23(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId23 in self2) {
    return self2[YieldWrapTypeId23]();
  }
  throw new Error(getBugErrorMessage23("yieldWrapGet"));
}
var structuralRegionState23 = /* @__PURE__ */ globalValue23("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache23 = /* @__PURE__ */ globalValue23(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr23 = /* @__PURE__ */ globalValue23(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom23());
var symbol33 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash23 = (self2) => {
  if (structuralRegionState23.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number23(self2);
    case "bigint":
      return string23(self2.toString(10));
    case "boolean":
      return string23(String(self2));
    case "symbol":
      return string23(String(self2));
    case "string":
      return string23(self2);
    case "undefined":
      return string23("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string23("null");
      } else if (self2 instanceof Date) {
        return hash23(self2.toISOString());
      } else if (isHash23(self2)) {
        return self2[symbol33]();
      } else {
        return random23(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random23 = (self2) => {
  if (!randomHashCache23.has(self2)) {
    randomHashCache23.set(self2, number23(pcgr23.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache23.get(self2);
};
var combine32 = (b222) => (self2) => self2 * 53 ^ b222;
var optimize23 = (n222) => n222 & 3221225471 | n222 >>> 1 & 1073741824;
var isHash23 = (u222) => hasProperty23(u222, symbol33);
var number23 = (n222) => {
  if (n222 !== n222 || n222 === Infinity) {
    return 0;
  }
  let h222 = n222 | 0;
  if (h222 !== n222) {
    h222 ^= n222 * 4294967295;
  }
  while (n222 > 4294967295) {
    h222 ^= n222 /= 4294967295;
  }
  return optimize23(n222);
};
var string23 = (str) => {
  let h222 = 5381, i222 = str.length;
  while (i222) {
    h222 = h222 * 33 ^ str.charCodeAt(--i222);
  }
  return optimize23(h222);
};
var structureKeys23 = (o222, keys2222) => {
  let h222 = 12289;
  for (let i222 = 0; i222 < keys2222.length; i222++) {
    h222 ^= pipe23(string23(keys2222[i222]), combine32(hash23(o222[keys2222[i222]])));
  }
  return optimize23(h222);
};
var structure23 = (o222) => structureKeys23(o222, Object.keys(o222));
var array32 = (arr) => {
  let h222 = 6151;
  for (let i222 = 0; i222 < arr.length; i222++) {
    h222 = pipe23(h222, combine32(hash23(arr[i222])));
  }
  return optimize23(h222);
};
var cached23 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash322) {
      Object.defineProperty(self22, symbol33, {
        value() {
          return hash322;
        },
        enumerable: false
      });
      return hash322;
    };
  }
  const self2 = arguments[0];
  const hash2322 = arguments[1];
  Object.defineProperty(self2, symbol33, {
    value() {
      return hash2322;
    },
    enumerable: false
  });
  return hash2322;
};
var symbol223 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals23() {
  if (arguments.length === 1) {
    return (self2) => compareBoth23(self2, arguments[0]);
  }
  return compareBoth23(arguments[0], arguments[1]);
}
function compareBoth23(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual23(self2) && isEqual23(that)) {
        if (hash23(self2) === hash23(that) && self2[symbol223](that)) {
          return true;
        } else {
          return structuralRegionState23.enabled && structuralRegionState23.tester ? structuralRegionState23.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState23.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v222, i222) => compareBoth23(v222, that[i222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth23(self2[key], that[key]))) {
              return structuralRegionState23.tester ? structuralRegionState23.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState23.tester ? structuralRegionState23.tester(self2, that) : false;
    }
  }
  return structuralRegionState23.enabled && structuralRegionState23.tester ? structuralRegionState23.tester(self2, that) : false;
}
var isEqual23 = (u222) => hasProperty23(u222, symbol223);
var equivalence23 = () => equals23;
var NodeInspectSymbol23 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON23 = (x222) => {
  if (hasProperty23(x222, "toJSON") && isFunction322(x222["toJSON"]) && x222["toJSON"].length === 0) {
    return x222.toJSON();
  } else if (Array.isArray(x222)) {
    return x222.map(toJSON23);
  }
  return x222;
};
var format23 = (x222) => JSON.stringify(x222, null, 2);
var pipeArguments23 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i222 = 0, len = args.length; i222 < len; i222++) {
        ret = args[i222](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT23 = "Commit";
var OP_FAILURE22 = "Failure";
var OP_WITH_RUNTIME22 = "WithRuntime";
var EffectTypeId32 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId23 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId23 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId23 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance23 = {
  /* c8 ignore next */
  _R: (_222) => _222,
  /* c8 ignore next */
  _E: (_222) => _222,
  /* c8 ignore next */
  _A: (_222) => _222,
  _V: /* @__PURE__ */ getCurrentVersion23()
};
var sinkVariance23 = {
  /* c8 ignore next */
  _A: (_222) => _222,
  /* c8 ignore next */
  _In: (_222) => _222,
  /* c8 ignore next */
  _L: (_222) => _222,
  /* c8 ignore next */
  _E: (_222) => _222,
  /* c8 ignore next */
  _R: (_222) => _222
};
var channelVariance23 = {
  /* c8 ignore next */
  _Env: (_222) => _222,
  /* c8 ignore next */
  _InErr: (_222) => _222,
  /* c8 ignore next */
  _InElem: (_222) => _222,
  /* c8 ignore next */
  _InDone: (_222) => _222,
  /* c8 ignore next */
  _OutErr: (_222) => _222,
  /* c8 ignore next */
  _OutElem: (_222) => _222,
  /* c8 ignore next */
  _OutDone: (_222) => _222
};
var EffectPrototype23 = {
  [EffectTypeId32]: effectVariance23,
  [StreamTypeId23]: effectVariance23,
  [SinkTypeId23]: sinkVariance23,
  [ChannelTypeId23]: channelVariance23,
  [symbol223](that) {
    return this === that;
  },
  [symbol33]() {
    return cached23(this, random23(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen32(new YieldWrap23(this));
  },
  pipe() {
    return pipeArguments23(this, arguments);
  }
};
var StructuralPrototype23 = {
  [symbol33]() {
    return cached23(this, structure23(this));
  },
  [symbol223](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals23(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype23 = {
  ...EffectPrototype23,
  _op: OP_COMMIT23
};
var StructuralCommitPrototype23 = {
  ...CommitPrototype23,
  ...StructuralPrototype23
};
var TypeId62 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto33 = {
  ...EffectPrototype23,
  [TypeId62]: {
    _A: (_222) => _222
  },
  [NodeInspectSymbol23]() {
    return this.toJSON();
  },
  toString() {
    return format23(this.toJSON());
  }
};
var SomeProto23 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto33), {
  _tag: "Some",
  _op: "Some",
  [symbol223](that) {
    return isOption33(that) && isSome33(that) && equals23(this.value, that.value);
  },
  [symbol33]() {
    return cached23(this, combine32(hash23(this._tag))(hash23(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON23(this.value)
    };
  }
});
var NoneHash23 = /* @__PURE__ */ hash23("None");
var NoneProto23 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto33), {
  _tag: "None",
  _op: "None",
  [symbol223](that) {
    return isOption33(that) && isNone33(that);
  },
  [symbol33]() {
    return NoneHash23;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption33 = (input) => hasProperty23(input, TypeId62);
var isNone33 = (fa) => fa._tag === "None";
var isSome33 = (fa) => fa._tag === "Some";
var none33 = /* @__PURE__ */ Object.create(NoneProto23);
var some223 = (value) => {
  const a222 = Object.create(SomeProto23);
  a222.value = value;
  return a222;
};
var TypeId223 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto223 = {
  ...EffectPrototype23,
  [TypeId223]: {
    _R: (_222) => _222
  },
  [NodeInspectSymbol23]() {
    return this.toJSON();
  },
  toString() {
    return format23(this.toJSON());
  }
};
var RightProto23 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto223), {
  _tag: "Right",
  _op: "Right",
  [symbol223](that) {
    return isEither23(that) && isRight23(that) && equals23(this.right, that.right);
  },
  [symbol33]() {
    return combine32(hash23(this._tag))(hash23(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON23(this.right)
    };
  }
});
var LeftProto23 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto223), {
  _tag: "Left",
  _op: "Left",
  [symbol223](that) {
    return isEither23(that) && isLeft23(that) && equals23(this.left, that.left);
  },
  [symbol33]() {
    return combine32(hash23(this._tag))(hash23(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON23(this.left)
    };
  }
});
var isEither23 = (input) => hasProperty23(input, TypeId223);
var isLeft23 = (ma) => ma._tag === "Left";
var isRight23 = (ma) => ma._tag === "Right";
var left32 = (left3222) => {
  const a222 = Object.create(LeftProto23);
  a222.left = left3222;
  return a222;
};
var right32 = (right3222) => {
  const a222 = Object.create(RightProto23);
  a222.right = right3222;
  return a222;
};
var getLeft33 = (self2) => isRight23(self2) ? none33 : some223(self2.left);
var getRight33 = (self2) => isLeft23(self2) ? none33 : some223(self2.right);
var right223 = right32;
var left223 = left32;
var Option_exports23 = {};
__export223(Option_exports23, {
  Do: () => Do23,
  TypeId: () => TypeId323,
  all: () => all223,
  andThen: () => andThen23,
  ap: () => ap23,
  as: () => as23,
  asVoid: () => asVoid23,
  bind: () => bind223,
  bindTo: () => bindTo223,
  composeK: () => composeK23,
  contains: () => contains23,
  containsWith: () => containsWith23,
  exists: () => exists23,
  filter: () => filter23,
  filterMap: () => filterMap23,
  firstSomeOf: () => firstSomeOf23,
  flatMap: () => flatMap23,
  flatMapNullable: () => flatMapNullable23,
  flatten: () => flatten23,
  fromIterable: () => fromIterable32,
  fromNullable: () => fromNullable23,
  gen: () => gen23,
  getEquivalence: () => getEquivalence32,
  getLeft: () => getLeft223,
  getOrElse: () => getOrElse23,
  getOrNull: () => getOrNull23,
  getOrThrow: () => getOrThrow23,
  getOrThrowWith: () => getOrThrowWith23,
  getOrUndefined: () => getOrUndefined23,
  getOrder: () => getOrder23,
  getRight: () => getRight223,
  isNone: () => isNone223,
  isOption: () => isOption223,
  isSome: () => isSome223,
  let: () => let_223,
  lift2: () => lift223,
  liftNullable: () => liftNullable23,
  liftPredicate: () => liftPredicate23,
  liftThrowable: () => liftThrowable23,
  map: () => map23,
  match: () => match222,
  none: () => none223,
  orElse: () => orElse23,
  orElseEither: () => orElseEither23,
  orElseSome: () => orElseSome23,
  partitionMap: () => partitionMap23,
  product: () => product223,
  productMany: () => productMany223,
  reduceCompact: () => reduceCompact23,
  some: () => some323,
  tap: () => tap23,
  toArray: () => toArray23,
  toRefinement: () => toRefinement23,
  void: () => void_23,
  zipLeft: () => zipLeft23,
  zipRight: () => zipRight23,
  zipWith: () => zipWith23
});
var make223 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId323 = /* @__PURE__ */ Symbol.for("effect/Option");
var none223 = () => none33;
var some323 = some223;
var isOption223 = isOption33;
var isNone223 = isNone33;
var isSome223 = isSome33;
var match222 = /* @__PURE__ */ dual23(2, (self2, {
  onNone,
  onSome
}) => isNone223(self2) ? onNone() : onSome(self2.value));
var toRefinement23 = (f222) => (a222) => isSome223(f222(a222));
var fromIterable32 = (collection) => {
  for (const a222 of collection) {
    return some323(a222);
  }
  return none223();
};
var getRight223 = getRight33;
var getLeft223 = getLeft33;
var getOrElse23 = /* @__PURE__ */ dual23(2, (self2, onNone) => isNone223(self2) ? onNone() : self2.value);
var orElse23 = /* @__PURE__ */ dual23(2, (self2, that) => isNone223(self2) ? that() : self2);
var orElseSome23 = /* @__PURE__ */ dual23(2, (self2, onNone) => isNone223(self2) ? some323(onNone()) : self2);
var orElseEither23 = /* @__PURE__ */ dual23(2, (self2, that) => isNone223(self2) ? map23(that(), right32) : map23(self2, left32));
var firstSomeOf23 = (collection) => {
  let out = none223();
  for (out of collection) {
    if (isSome223(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable23 = (nullableValue) => nullableValue == null ? none223() : some323(nullableValue);
var liftNullable23 = (f222) => (...a222) => fromNullable23(f222(...a222));
var getOrNull23 = /* @__PURE__ */ getOrElse23(constNull23);
var getOrUndefined23 = /* @__PURE__ */ getOrElse23(constUndefined23);
var liftThrowable23 = (f222) => (...a222) => {
  try {
    return some323(f222(...a222));
  } catch (e222) {
    return none223();
  }
};
var getOrThrowWith23 = /* @__PURE__ */ dual23(2, (self2, onNone) => {
  if (isSome223(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow23 = /* @__PURE__ */ getOrThrowWith23(() => new Error("getOrThrow called on a None"));
var map23 = /* @__PURE__ */ dual23(2, (self2, f222) => isNone223(self2) ? none223() : some323(f222(self2.value)));
var as23 = /* @__PURE__ */ dual23(2, (self2, b222) => map23(self2, () => b222));
var asVoid23 = /* @__PURE__ */ as23(void 0);
var void_23 = /* @__PURE__ */ some323(void 0);
var flatMap23 = /* @__PURE__ */ dual23(2, (self2, f222) => isNone223(self2) ? none223() : f222(self2.value));
var andThen23 = /* @__PURE__ */ dual23(2, (self2, f222) => flatMap23(self2, (a222) => {
  const b222 = isFunction223(f222) ? f222(a222) : f222;
  return isOption223(b222) ? b222 : some323(b222);
}));
var flatMapNullable23 = /* @__PURE__ */ dual23(2, (self2, f222) => isNone223(self2) ? none223() : fromNullable23(f222(self2.value)));
var flatten23 = /* @__PURE__ */ flatMap23(identity23);
var zipRight23 = /* @__PURE__ */ dual23(2, (self2, that) => flatMap23(self2, () => that));
var composeK23 = /* @__PURE__ */ dual23(2, (afb, bfc) => (a222) => flatMap23(afb(a222), bfc));
var zipLeft23 = /* @__PURE__ */ dual23(2, (self2, that) => tap23(self2, () => that));
var tap23 = /* @__PURE__ */ dual23(2, (self2, f222) => flatMap23(self2, (a222) => map23(f222(a222), () => a222)));
var product223 = (self2, that) => isSome223(self2) && isSome223(that) ? some323([self2.value, that.value]) : none223();
var productMany223 = (self2, collection) => {
  if (isNone223(self2)) {
    return none223();
  }
  const out = [self2.value];
  for (const o222 of collection) {
    if (isNone223(o222)) {
      return none223();
    }
    out.push(o222.value);
  }
  return some323(out);
};
var all223 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o222 of input) {
      if (isNone223(o222)) {
        return none223();
      }
      out2.push(o222.value);
    }
    return some323(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o222 = input[key];
    if (isNone223(o222)) {
      return none223();
    }
    out[key] = o222.value;
  }
  return some323(out);
};
var zipWith23 = /* @__PURE__ */ dual23(3, (self2, that, f222) => map23(product223(self2, that), ([a222, b222]) => f222(a222, b222)));
var ap23 = /* @__PURE__ */ dual23(2, (self2, that) => zipWith23(self2, that, (f222, a222) => f222(a222)));
var reduceCompact23 = /* @__PURE__ */ dual23(3, (self2, b222, f222) => {
  let out = b222;
  for (const oa of self2) {
    if (isSome223(oa)) {
      out = f222(out, oa.value);
    }
  }
  return out;
});
var toArray23 = (self2) => isNone223(self2) ? [] : [self2.value];
var partitionMap23 = /* @__PURE__ */ dual23(2, (self2, f222) => {
  if (isNone223(self2)) {
    return [none223(), none223()];
  }
  const e222 = f222(self2.value);
  return isLeft23(e222) ? [some323(e222.left), none223()] : [none223(), some323(e222.right)];
});
var filterMap23 = /* @__PURE__ */ dual23(2, (self2, f222) => isNone223(self2) ? none223() : f222(self2.value));
var filter23 = /* @__PURE__ */ dual23(2, (self2, predicate) => filterMap23(self2, (b222) => predicate(b222) ? some223(b222) : none33));
var getEquivalence32 = (isEquivalent) => make62((x222, y222) => x222 === y222 || (isNone223(x222) ? isNone223(y222) : isNone223(y222) ? false : isEquivalent(x222.value, y222.value)));
var getOrder23 = (O222) => make223((self2, that) => isSome223(self2) ? isSome223(that) ? O222(self2.value, that.value) : 1 : -1);
var lift223 = (f222) => dual23(2, (self2, that) => zipWith23(self2, that, f222));
var liftPredicate23 = (predicate) => (b222) => predicate(b222) ? some323(b222) : none223();
var containsWith23 = (isEquivalent) => dual23(2, (self2, a222) => isNone223(self2) ? false : isEquivalent(self2.value, a222));
var _equivalence32 = /* @__PURE__ */ equivalence23();
var contains23 = /* @__PURE__ */ containsWith23(_equivalence32);
var exists23 = /* @__PURE__ */ dual23(2, (self2, refinement) => isNone223(self2) ? false : refinement(self2.value));
var bindTo223 = /* @__PURE__ */ bindTo33(map23);
var let_223 = /* @__PURE__ */ let_33(map23);
var bind223 = /* @__PURE__ */ bind33(map23, flatMap23);
var Do23 = /* @__PURE__ */ some323({});
var adapter223 = /* @__PURE__ */ adapter33();
var gen23 = (f222) => {
  const iterator = f222(adapter223);
  let state = iterator.next();
  if (state.done) {
    return some323(state.value);
  } else {
    let current = state.value;
    if (isGenKind23(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet23(current);
    }
    if (isNone223(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind23(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet23(current);
        }
        if (isNone223(current)) {
          return current;
        }
      }
    }
    return some323(state.value);
  }
};
var fromIterable223 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse32 = (self2) => Array.from(self2).reverse();
var reduce32 = /* @__PURE__ */ dual23(3, (self2, b222, f222) => fromIterable223(self2).reduce((b2222, a222, i222) => f222(b2222, a222, i222), b222));
var TagTypeId22 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey22 = "effect/STM";
var STMTypeId22 = /* @__PURE__ */ Symbol.for(STMSymbolKey22);
var TagProto22 = {
  ...EffectPrototype23,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId22]: effectVariance23,
  [TagTypeId22]: {
    _Service: (_222) => _222,
    _Identifier: (_222) => _222
  },
  toString() {
    return format23(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol23]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make323(this, self2);
  }
};
var makeGenericTag22 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto22);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId423 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto22 = {
  [TypeId423]: {
    _Services: (_222) => _222
  },
  [symbol223](that) {
    if (isContext22(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k222 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k222) || !equals23(this.unsafeMap.get(k222), that.unsafeMap.get(k222))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol33]() {
    return cached23(this, number23(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments23(this, arguments);
  },
  toString() {
    return format23(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON23)
    };
  },
  [NodeInspectSymbol23]() {
    return this.toJSON();
  }
};
var makeContext22 = (unsafeMap) => {
  const context = Object.create(ContextProto22);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext22 = (u222) => hasProperty23(u222, TypeId423);
var _empty62 = /* @__PURE__ */ makeContext22(/* @__PURE__ */ new Map());
var empty82 = () => _empty62;
var make323 = (tag, service) => makeContext22(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag22 = makeGenericTag22;
var empty222 = empty82;
var TypeId523 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy22(src, srcPos, dest, destPos, len) {
  for (let i222 = srcPos; i222 < Math.min(src.length, srcPos + len); i222++) {
    dest[destPos + i222 - srcPos] = src[i222];
  }
  return dest;
}
var emptyArray22 = [];
var getEquivalence223 = (isEquivalent) => make62((self2, that) => self2.length === that.length && toReadonlyArray22(self2).every((value, i222) => isEquivalent(value, unsafeGet222(that, i222))));
var _equivalence223 = /* @__PURE__ */ getEquivalence223(equals23);
var ChunkProto22 = {
  [TypeId523]: {
    _A: (_222) => _222
  },
  toString() {
    return format23(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray22(this).map(toJSON23)
    };
  },
  [NodeInspectSymbol23]() {
    return this.toJSON();
  },
  [symbol223](that) {
    return isChunk22(that) && _equivalence223(this, that);
  },
  [symbol33]() {
    return cached23(this, array32(toReadonlyArray22(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray22[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray22(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments23(this, arguments);
  }
};
var makeChunk22 = (backing) => {
  const chunk = Object.create(ChunkProto22);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty222;
      chunk.right = _empty222;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty222;
      chunk.right = _empty222;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty222;
      chunk.right = _empty222;
      break;
    }
  }
  return chunk;
};
var isChunk22 = (u222) => hasProperty23(u222, TypeId523);
var _empty222 = /* @__PURE__ */ makeChunk22({
  _tag: "IEmpty"
});
var empty322 = () => _empty222;
var make423 = (...as2322) => as2322.length === 1 ? of22(as2322[0]) : unsafeFromNonEmptyArray22(as2322);
var of22 = (a222) => makeChunk22({
  _tag: "ISingleton",
  a: a222
});
var copyToArray22 = (self2, array3222, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy22(self2.backing.array, 0, array3222, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray22(self2.left, array3222, initial);
      copyToArray22(self2.right, array3222, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array3222[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i222 = 0;
      let j222 = initial;
      while (i222 < self2.length) {
        array3222[j222] = unsafeGet222(self2, i222);
        i222 += 1;
        j222 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray22 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray22;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray22(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty222;
      self2.right = _empty222;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse222 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk22({
        _tag: "IArray",
        array: reverse32(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk22({
        _tag: "IConcat",
        left: reverse222(self2.backing.right),
        right: reverse222(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray22(reverse32(toReadonlyArray22(self2)));
  }
};
var unsafeFromArray22 = (self2) => makeChunk22({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray22 = (self2) => unsafeFromArray22(self2);
var unsafeGet222 = /* @__PURE__ */ dual23(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet222(self2.left, index) : unsafeGet222(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet222(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend22 = /* @__PURE__ */ dual23(2, (self2, elem) => appendAll22(of22(elem), self2));
var drop22 = /* @__PURE__ */ dual23(2, (self2, n222) => {
  if (n222 <= 0) {
    return self2;
  } else if (n222 >= self2.length) {
    return _empty222;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk22({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n222,
          length: self2.backing.length - n222
        });
      }
      case "IConcat": {
        if (n222 > self2.left.length) {
          return drop22(self2.right, n222 - self2.left.length);
        }
        return makeChunk22({
          _tag: "IConcat",
          left: drop22(self2.left, n222),
          right: self2.right
        });
      }
      default: {
        return makeChunk22({
          _tag: "ISlice",
          chunk: self2,
          offset: n222,
          length: self2.length - n222
        });
      }
    }
  }
});
var appendAll22 = /* @__PURE__ */ dual23(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff2222 = that.depth - self2.depth;
  if (Math.abs(diff2222) <= 1) {
    return makeChunk22({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff2222 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll22(self2.right, that);
      return makeChunk22({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll22(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk22({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk22({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk22({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk22({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll22(self2, that.left);
      return makeChunk22({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll22(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk22({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk22({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk22({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk22({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty22 = (self2) => self2.length === 0;
var isNonEmpty22 = (self2) => self2.length > 0;
var unsafeHead22 = (self2) => unsafeGet222(self2, 0);
var headNonEmpty22 = unsafeHead22;
var tailNonEmpty22 = (self2) => drop22(self2, 1);
var SIZE22 = 5;
var BUCKET_SIZE22 = /* @__PURE__ */ Math.pow(2, SIZE22);
var MASK22 = BUCKET_SIZE22 - 1;
var MAX_INDEX_NODE22 = BUCKET_SIZE22 / 2;
var MIN_ARRAY_NODE22 = BUCKET_SIZE22 / 4;
function popcount22(x222) {
  x222 -= x222 >> 1 & 1431655765;
  x222 = (x222 & 858993459) + (x222 >> 2 & 858993459);
  x222 = x222 + (x222 >> 4) & 252645135;
  x222 += x222 >> 8;
  x222 += x222 >> 16;
  return x222 & 127;
}
function hashFragment22(shift22, h222) {
  return h222 >>> shift22 & MASK22;
}
function toBitmap22(x222) {
  return 1 << x222;
}
function fromBitmap22(bitmap, bit) {
  return popcount22(bitmap & bit - 1);
}
var make522 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate22(mutate2222, at, v222, arr) {
  let out = arr;
  if (!mutate2222) {
    const len = arr.length;
    out = new Array(len);
    for (let i222 = 0; i222 < len; ++i222) out[i222] = arr[i222];
  }
  out[at] = v222;
  return out;
}
function arraySpliceOut22(mutate2222, at, arr) {
  const newLen = arr.length - 1;
  let i222 = 0;
  let g222 = 0;
  let out = arr;
  if (mutate2222) {
    i222 = g222 = at;
  } else {
    out = new Array(newLen);
    while (i222 < at) out[g222++] = arr[i222++];
  }
  ++i222;
  while (i222 <= newLen) out[g222++] = arr[i222++];
  if (mutate2222) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn22(mutate2222, at, v222, arr) {
  const len = arr.length;
  if (mutate2222) {
    let i2222 = len;
    while (i2222 >= at) arr[i2222--] = arr[i2222];
    arr[at] = v222;
    return arr;
  }
  let i222 = 0, g222 = 0;
  const out = new Array(len + 1);
  while (i222 < at) out[g222++] = arr[i222++];
  out[at] = v222;
  while (i222 < len) out[++g222] = arr[i222++];
  return out;
}
var EmptyNode22 = class _EmptyNode22 {
  _tag = "EmptyNode";
  modify(edit, _shift, f222, hash2322, key, size4222) {
    const v222 = f222(none223());
    if (isNone223(v222)) return new _EmptyNode22();
    ++size4222.value;
    return new LeafNode22(edit, hash2322, key, v222);
  }
};
function isEmptyNode22(a222) {
  return isTagged22(a222, "EmptyNode");
}
function isLeafNode22(node) {
  return isEmptyNode22(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode22(node, edit) {
  return isEmptyNode22(node) ? false : edit === node.edit;
}
var LeafNode22 = class _LeafNode22 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash2322, key, value) {
    this.edit = edit;
    this.hash = hash2322;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f222, hash2322, key, size4222) {
    if (equals23(key, this.key)) {
      const v2222 = f222(this.value);
      if (v2222 === this.value) return this;
      else if (isNone223(v2222)) {
        --size4222.value;
        return new EmptyNode22();
      }
      if (canEditNode22(this, edit)) {
        this.value = v2222;
        return this;
      }
      return new _LeafNode22(edit, hash2322, key, v2222);
    }
    const v222 = f222(none223());
    if (isNone223(v222)) return this;
    ++size4222.value;
    return mergeLeaves22(edit, shift22, this.hash, this, hash2322, new _LeafNode22(edit, hash2322, key, v222));
  }
};
var CollisionNode22 = class _CollisionNode22 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash2322, children) {
    this.edit = edit;
    this.hash = hash2322;
    this.children = children;
  }
  modify(edit, shift22, f222, hash2322, key, size4222) {
    if (hash2322 === this.hash) {
      const canEdit = canEditNode22(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f222, key, size4222);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode22(edit, this.hash, list) : list[0];
    }
    const v222 = f222(none223());
    if (isNone223(v222)) return this;
    ++size4222.value;
    return mergeLeaves22(edit, shift22, this.hash, this, hash2322, new LeafNode22(edit, hash2322, key, v222));
  }
  updateCollisionList(mutate2222, edit, hash2322, list, f222, key, size4222) {
    const len = list.length;
    for (let i222 = 0; i222 < len; ++i222) {
      const child = list[i222];
      if ("key" in child && equals23(key, child.key)) {
        const value = child.value;
        const newValue2 = f222(value);
        if (newValue2 === value) return list;
        if (isNone223(newValue2)) {
          --size4222.value;
          return arraySpliceOut22(mutate2222, i222, list);
        }
        return arrayUpdate22(mutate2222, i222, new LeafNode22(edit, hash2322, key, newValue2), list);
      }
    }
    const newValue = f222(none223());
    if (isNone223(newValue)) return list;
    ++size4222.value;
    return arrayUpdate22(mutate2222, len, new LeafNode22(edit, hash2322, key, newValue), list);
  }
};
var IndexedNode22 = class _IndexedNode22 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f222, hash2322, key, size4222) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment22(shift22, hash2322);
    const bit = toBitmap22(frag);
    const indx = fromBitmap22(mask, bit);
    const exists2322 = mask & bit;
    const canEdit = canEditNode22(this, edit);
    if (!exists2322) {
      const _newChild = new EmptyNode22().modify(edit, shift22 + SIZE22, f222, hash2322, key, size4222);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE22 ? expand22(edit, frag, _newChild, mask, children) : new _IndexedNode22(edit, mask | bit, arraySpliceIn22(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE22, f222, hash2322, key, size4222);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode22(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode22();
      if (children.length <= 2 && isLeafNode22(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut22(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate22(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode22(edit, bitmap, newChildren);
  }
};
var ArrayNode22 = class _ArrayNode22 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size4222, children) {
    this.edit = edit;
    this.size = size4222;
    this.children = children;
  }
  modify(edit, shift22, f222, hash2322, key, size4222) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment22(shift22, hash2322);
    const child = children[frag];
    const newChild = (child || new EmptyNode22()).modify(edit, shift22 + SIZE22, f222, hash2322, key, size4222);
    if (child === newChild) return this;
    const canEdit = canEditNode22(this, edit);
    let newChildren;
    if (isEmptyNode22(child) && !isEmptyNode22(newChild)) {
      ++count;
      newChildren = arrayUpdate22(canEdit, frag, newChild, children);
    } else if (!isEmptyNode22(child) && isEmptyNode22(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE22) {
        return pack22(edit, count, frag, children);
      }
      newChildren = arrayUpdate22(canEdit, frag, new EmptyNode22(), children);
    } else {
      newChildren = arrayUpdate22(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode22(edit, count, newChildren);
  }
};
function pack22(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g222 = 0;
  let bitmap = 0;
  for (let i222 = 0, len = elements.length; i222 < len; ++i222) {
    if (i222 !== removed) {
      const elem = elements[i222];
      if (elem && !isEmptyNode22(elem)) {
        children[g222++] = elem;
        bitmap |= 1 << i222;
      }
    }
  }
  return new IndexedNode22(edit, bitmap, children);
}
function expand22(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i222 = 0; bit; ++i222) {
    if (bit & 1) arr[i222] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode22(edit, count + 1, arr);
}
function mergeLeavesInner22(edit, shift22, h1, n1, h222, n222) {
  if (h1 === h222) return new CollisionNode22(edit, h1, [n222, n1]);
  const subH1 = hashFragment22(shift22, h1);
  const subH2 = hashFragment22(shift22, h222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode22(edit, toBitmap22(subH1) | toBitmap22(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n222] : [n222, n1];
    return new IndexedNode22(edit, toBitmap22(subH1) | toBitmap22(subH2), children);
  }
}
function mergeLeaves22(edit, shift22, h1, n1, h222, n222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner22(edit, currentShift, h1, n1, h222, n222);
    if (typeof res === "function") {
      stack = make522(res, stack);
      currentShift = currentShift + SIZE22;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey22 = "effect/HashMap";
var HashMapTypeId22 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey22);
var HashMapProto22 = {
  [HashMapTypeId22]: HashMapTypeId22,
  [Symbol.iterator]() {
    return new HashMapIterator22(this, (k222, v222) => [k222, v222]);
  },
  [symbol33]() {
    let hash2322 = hash23(HashMapSymbolKey22);
    for (const item of this) {
      hash2322 ^= pipe23(hash23(item[0]), combine32(hash23(item[1])));
    }
    return cached23(this, hash2322);
  },
  [symbol223](that) {
    if (isHashMap22(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe23(that, getHash22(item[0], hash23(item[0])));
        if (isNone223(elem)) {
          return false;
        } else {
          if (!equals23(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format23(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON23)
    };
  },
  [NodeInspectSymbol23]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments23(this, arguments);
  }
};
var makeImpl32 = (editable, edit, root, size4222) => {
  const map622 = Object.create(HashMapProto22);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size4222;
  return map622;
};
var HashMapIterator22 = class _HashMapIterator22 {
  map;
  f;
  v;
  constructor(map622, f222) {
    this.map = map622;
    this.f = f222;
    this.v = visitLazy22(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone223(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont22(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator22(this.map, this.f);
  }
};
var applyCont22 = (cont) => cont ? visitLazyChildren22(cont[0], cont[1], cont[2], cont[3], cont[4]) : none223();
var visitLazy22 = (node, f222, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome223(node.value)) {
        return some323({
          value: f222(node.key, node.value.value),
          cont
        });
      }
      return applyCont22(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren22(children.length, children, 0, f222, cont);
    }
    default: {
      return applyCont22(cont);
    }
  }
};
var visitLazyChildren22 = (len, children, i222, f222, cont) => {
  while (i222 < len) {
    const child = children[i222++];
    if (child && !isEmptyNode22(child)) {
      return visitLazy22(child, f222, [len, children, i222, f222, cont]);
    }
  }
  return applyCont22(cont);
};
var _empty322 = /* @__PURE__ */ makeImpl32(false, 0, /* @__PURE__ */ new EmptyNode22(), 0);
var empty422 = () => _empty322;
var isHashMap22 = (u222) => hasProperty23(u222, HashMapTypeId22);
var getHash22 = /* @__PURE__ */ dual23(3, (self2, key, hash2322) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals23(key, node.key) ? node.value : none223();
      }
      case "CollisionNode": {
        if (hash2322 === node.hash) {
          const children = node.children;
          for (let i222 = 0, len = children.length; i222 < len; ++i222) {
            const child = children[i222];
            if ("key" in child && equals23(key, child.key)) {
              return child.value;
            }
          }
        }
        return none223();
      }
      case "IndexedNode": {
        const frag = hashFragment22(shift22, hash2322);
        const bit = toBitmap22(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap22(node.mask, bit)];
          shift22 += SIZE22;
          break;
        }
        return none223();
      }
      case "ArrayNode": {
        node = node.children[hashFragment22(shift22, hash2322)];
        if (node) {
          shift22 += SIZE22;
          break;
        }
        return none223();
      }
      default:
        return none223();
    }
  }
});
var set23 = /* @__PURE__ */ dual23(3, (self2, key, value) => modifyAt22(self2, key, () => some323(value)));
var setTree22 = /* @__PURE__ */ dual23(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl32(self2._editable, self2._edit, newRoot, newSize);
});
var keys22 = (self2) => new HashMapIterator22(self2, (key) => key);
var size42 = (self2) => self2._size;
var beginMutation32 = (self2) => makeImpl32(true, self2._edit + 1, self2._root, self2._size);
var modifyAt22 = /* @__PURE__ */ dual23(3, (self2, key, f222) => modifyHash22(self2, key, hash23(key), f222));
var modifyHash22 = /* @__PURE__ */ dual23(4, (self2, key, hash2322, f222) => {
  const size4222 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f222, hash2322, key, size4222);
  return pipe23(self2, setTree22(newRoot, size4222.value));
});
var forEach32 = /* @__PURE__ */ dual23(2, (self2, f222) => reduce222(self2, void 0, (_222, value, key) => f222(value, key)));
var reduce222 = /* @__PURE__ */ dual23(3, (self2, zero, f222) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome223(root.value) ? f222(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i222 = 0, len = children.length; i222 < len; ) {
      const child = children[i222++];
      if (child && !isEmptyNode22(child)) {
        if (child._tag === "LeafNode") {
          if (isSome223(child.value)) {
            zero = f222(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey22 = "effect/HashSet";
var HashSetTypeId22 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey22);
var HashSetProto22 = {
  [HashSetTypeId22]: HashSetTypeId22,
  [Symbol.iterator]() {
    return keys22(this._keyMap);
  },
  [symbol33]() {
    return cached23(this, combine32(hash23(this._keyMap))(hash23(HashSetSymbolKey22)));
  },
  [symbol223](that) {
    if (isHashSet22(that)) {
      return size42(this._keyMap) === size42(that._keyMap) && equals23(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format23(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON23)
    };
  },
  [NodeInspectSymbol23]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments23(this, arguments);
  }
};
var makeImpl222 = (keyMap) => {
  const set2322 = Object.create(HashSetProto22);
  set2322._keyMap = keyMap;
  return set2322;
};
var isHashSet22 = (u222) => hasProperty23(u222, HashSetTypeId22);
var _empty422 = /* @__PURE__ */ makeImpl222(/* @__PURE__ */ empty422());
var empty522 = () => _empty422;
var size222 = (self2) => size42(self2._keyMap);
var beginMutation222 = (self2) => makeImpl222(beginMutation32(self2._keyMap));
var endMutation22 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate22 = /* @__PURE__ */ dual23(2, (self2, f222) => {
  const transient = beginMutation222(self2);
  f222(transient);
  return endMutation22(transient);
});
var add222 = /* @__PURE__ */ dual23(2, (self2, value) => self2._keyMap._editable ? (set23(value, true)(self2._keyMap), self2) : makeImpl222(set23(value, true)(self2._keyMap)));
var union222 = /* @__PURE__ */ dual23(2, (self2, that) => mutate22(empty522(), (set2322) => {
  forEach222(self2, (value) => add222(set2322, value));
  for (const value of that) {
    add222(set2322, value);
  }
}));
var forEach222 = /* @__PURE__ */ dual23(2, (self2, f222) => forEach32(self2._keyMap, (_222, k222) => f222(k222)));
var empty622 = empty522;
var size322 = size222;
var add322 = add222;
var union322 = union222;
var ArrayProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol33]() {
    return cached23(this, array32(this));
  },
  [symbol223](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v222, i222) => equals23(v222, that[i222]));
    } else {
      return false;
    }
  }
});
var Structural32 = /* @__PURE__ */ function() {
  function Structural3222(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural3222.prototype = StructuralPrototype23;
  return Structural3222;
}();
var struct222 = (as2322) => Object.assign(Object.create(StructuralPrototype23), as2322);
var ContextPatchTypeId22 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance32(a222) {
  return a222;
}
var PatchProto22 = {
  ...Structural32.prototype,
  [ContextPatchTypeId22]: {
    _Value: variance32,
    _Patch: variance32
  }
};
var EmptyProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto22), {
  _tag: "Empty"
});
var _empty522 = /* @__PURE__ */ Object.create(EmptyProto22);
var empty722 = () => _empty522;
var AndThenProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto22), {
  _tag: "AndThen"
});
var makeAndThen22 = (first, second) => {
  const o222 = Object.create(AndThenProto22);
  o222.first = first;
  o222.second = second;
  return o222;
};
var AddServiceProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto22), {
  _tag: "AddService"
});
var makeAddService22 = (key, service) => {
  const o222 = Object.create(AddServiceProto22);
  o222.key = key;
  o222.service = service;
  return o222;
};
var RemoveServiceProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto22), {
  _tag: "RemoveService"
});
var makeRemoveService22 = (key) => {
  const o222 = Object.create(RemoveServiceProto22);
  o222.key = key;
  return o222;
};
var UpdateServiceProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto22), {
  _tag: "UpdateService"
});
var makeUpdateService22 = (key, update222) => {
  const o222 = Object.create(UpdateServiceProto22);
  o222.key = key;
  o222.update = update222;
  return o222;
};
var diff22 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch2222 = empty722();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals23(old, newService)) {
        patch2222 = combine223(makeUpdateService22(tag, () => newService))(patch2222);
      }
    } else {
      missingServices.delete(tag);
      patch2222 = combine223(makeAddService22(tag, newService))(patch2222);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch2222 = combine223(makeRemoveService22(tag))(patch2222);
  }
  return patch2222;
};
var combine223 = /* @__PURE__ */ dual23(2, (self2, that) => makeAndThen22(self2, that));
var patch22 = /* @__PURE__ */ dual23(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of22(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty22(patches)) {
    const head222 = headNonEmpty22(patches);
    const tail222 = tailNonEmpty22(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail222;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail222;
        break;
      }
      case "AndThen": {
        patches = prepend22(prepend22(tail222, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail222;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail222;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext22(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s222] of updatedContext) {
    map622.set(tag, s222);
  }
  return makeContext22(map622);
});
var DifferTypeId22 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto22 = {
  [DifferTypeId22]: {
    _P: identity23,
    _V: identity23
  }
};
var make722 = (params) => {
  const differ = Object.create(DifferProto22);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment22 = () => make722({
  empty: empty722(),
  combine: (first, second) => combine223(second)(first),
  diff: (oldValue, newValue) => diff22(oldValue, newValue),
  patch: (patch2222, oldValue) => patch22(oldValue)(patch2222)
});
var OP_DIE22 = "Die";
var OP_EMPTY22 = "Empty";
var OP_FAIL22 = "Fail";
var OP_INTERRUPT22 = "Interrupt";
var OP_PARALLEL22 = "Parallel";
var OP_SEQUENTIAL22 = "Sequential";
var CauseSymbolKey22 = "effect/Cause";
var CauseTypeId22 = /* @__PURE__ */ Symbol.for(CauseSymbolKey22);
var variance222 = {
  /* c8 ignore next */
  _E: (_222) => _222
};
var proto22 = {
  [CauseTypeId22]: variance222,
  [symbol33]() {
    return pipe23(hash23(CauseSymbolKey22), combine32(hash23(flattenCause22(this))), cached23(this));
  },
  [symbol223](that) {
    return isCause22(that) && causeEquals22(this, that);
  },
  pipe() {
    return pipeArguments23(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON23(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON23(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON23(this.left),
          right: toJSON23(this.right)
        };
    }
  },
  toString() {
    return pretty22(this);
  },
  [NodeInspectSymbol23]() {
    return this.toJSON();
  }
};
var fail32 = (error) => {
  const o222 = Object.create(proto22);
  o222._tag = OP_FAIL22;
  o222.error = error;
  return o222;
};
var parallel22 = (left3222, right3222) => {
  const o222 = Object.create(proto22);
  o222._tag = OP_PARALLEL22;
  o222.left = left3222;
  o222.right = right3222;
  return o222;
};
var sequential22 = (left3222, right3222) => {
  const o222 = Object.create(proto22);
  o222._tag = OP_SEQUENTIAL22;
  o222.left = left3222;
  o222.right = right3222;
  return o222;
};
var isCause22 = (u222) => hasProperty23(u222, CauseTypeId22);
var isInterruptedOnly22 = (self2) => reduceWithContext22(void 0, IsInterruptedOnlyCauseReducer22)(self2);
var causeEquals22 = (left3222, right3222) => {
  let leftStack = of22(left3222);
  let rightStack = of22(right3222);
  while (isNonEmpty22(leftStack) && isNonEmpty22(rightStack)) {
    const [leftParallel, leftSequential] = pipe23(headNonEmpty22(leftStack), reduce422([empty622(), empty322()], ([parallel2222, sequential2222], cause) => {
      const [par, seq] = evaluateCause22(cause);
      return some323([pipe23(parallel2222, union322(par)), pipe23(sequential2222, appendAll22(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe23(headNonEmpty22(rightStack), reduce422([empty622(), empty322()], ([parallel2222, sequential2222], cause) => {
      const [par, seq] = evaluateCause22(cause);
      return some323([pipe23(parallel2222, union322(par)), pipe23(sequential2222, appendAll22(seq))]);
    }));
    if (!equals23(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause22 = (cause) => {
  return flattenCauseLoop22(of22(cause), empty322());
};
var flattenCauseLoop22 = (causes, flattened) => {
  while (1) {
    const [parallel2222, sequential2222] = pipe23(causes, reduce32([empty622(), empty322()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause22(cause);
      return [pipe23(parallel322, union322(par)), pipe23(sequential322, appendAll22(seq))];
    }));
    const updated = size322(parallel2222) > 0 ? pipe23(flattened, prepend22(parallel2222)) : flattened;
    if (isEmpty22(sequential2222)) {
      return reverse222(updated);
    }
    causes = sequential2222;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage23("Cause.flattenCauseLoop"));
};
var evaluateCause22 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty622();
  let _sequential = empty322();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY22: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL22: {
        _parallel = add322(_parallel, make423(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE22: {
        _parallel = add322(_parallel, make423(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT22: {
        _parallel = add322(_parallel, make423(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL22: {
        switch (cause.left._tag) {
          case OP_EMPTY22: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL22: {
            cause = sequential22(cause.left.left, sequential22(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL22: {
            cause = parallel22(sequential22(cause.left.left, cause.right), sequential22(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend22(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL22: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage23("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer22 = {
  emptyCase: constTrue23,
  failCase: constFalse23,
  dieCase: constFalse23,
  interruptCase: constTrue23,
  sequentialCase: (_222, left3222, right3222) => left3222 && right3222,
  parallelCase: (_222, left3222, right3222) => left3222 && right3222
};
var OP_SEQUENTIAL_CASE22 = "SequentialCase";
var OP_PARALLEL_CASE22 = "ParallelCase";
var reduce422 = /* @__PURE__ */ dual23(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome223(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL22: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL22: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext22 = /* @__PURE__ */ dual23(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY22: {
        output.push(right223(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL22: {
        output.push(right223(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE22: {
        output.push(right223(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT22: {
        output.push(right223(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL22: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left223({
          _tag: OP_SEQUENTIAL_CASE22
        }));
        break;
      }
      case OP_PARALLEL22: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left223({
          _tag: OP_PARALLEL_CASE22
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE22: {
            const left3222 = accumulator.pop();
            const right3222 = accumulator.pop();
            const value = reducer.sequentialCase(context, left3222, right3222);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE22: {
            const left3222 = accumulator.pop();
            const right3222 = accumulator.pop();
            const value = reducer.parallelCase(context, left3222, right3222);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty22 = (cause) => {
  if (isInterruptedOnly22(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors22(cause).map((e222) => e222.stack).join("\n");
};
var PrettyError22 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage22(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol32 in originalError) {
        this.span = originalError[spanSymbol32];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack22(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage22 = (u222) => {
  if (typeof u222 === "string") {
    return `Error: ${u222}`;
  }
  try {
    if (hasProperty23(u222, "toString") && isFunction322(u222["toString"]) && u222["toString"] !== Object.prototype.toString && u222["toString"] !== globalThis.Array.prototype.toString) {
      return u222["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u222)}`;
};
var locationRegex22 = /\((.*)\)/;
var spanToTrace22 = /* @__PURE__ */ globalValue23("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack22 = (message, stack, span22) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i222 = 1; i222 < lines.length; i222++) {
    if (lines[i222].includes("Generator.next")) {
      break;
    }
    if (lines[i222].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i222].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span22) {
    let current = span22;
    let i222 = 0;
    while (current && current._tag === "Span" && i222 < 10) {
      const stackFn = spanToTrace22.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex22);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined23(current.parent);
      i222++;
    }
  }
  return out.join("\n");
};
var spanSymbol32 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors22 = (cause) => reduceWithContext22(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_222, unknownError) => {
    return [new PrettyError22(unknownError)];
  },
  failCase: (_222, error) => {
    return [new PrettyError22(error)];
  },
  interruptCase: () => [],
  parallelCase: (_222, l222, r222) => [...l222, ...r222],
  sequentialCase: (_222, l222, r222) => [...l222, ...r222]
});
var SingleShotGen223 = class _SingleShotGen222 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a222) {
    return this.called ? {
      value: a222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a222) {
    return {
      value: a222,
      done: true
    };
  }
  throw(e222) {
    throw e222;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen222(this.self);
  }
};
var spanTag22 = /* @__PURE__ */ GenericTag22("effect/ParentSpan");
var EffectTypeId223 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive22 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId223] = effectVariance23;
  constructor(_op) {
    this._op = _op;
  }
  [symbol223](that) {
    return this === that;
  }
  [symbol33]() {
    return cached23(this, random23(this));
  }
  pipe() {
    return pipeArguments23(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON23(this.effect_instruction_i0),
      effect_instruction_i1: toJSON23(this.effect_instruction_i1),
      effect_instruction_i2: toJSON23(this.effect_instruction_i2)
    };
  }
  toString() {
    return format23(this.toJSON());
  }
  [NodeInspectSymbol23]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen223(new YieldWrap23(this));
  }
};
var EffectPrimitiveFailure22 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId223] = effectVariance23;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol223](that) {
    return exitIsExit22(that) && that._op === "Failure" && // @ts-expect-error
    equals23(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol33]() {
    return pipe23(
      // @ts-expect-error
      string23(this._tag),
      // @ts-expect-error
      combine32(hash23(this.effect_instruction_i0)),
      cached23(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments23(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format23(this.toJSON());
  }
  [NodeInspectSymbol23]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen223(new YieldWrap23(this));
  }
};
var isEffect22 = (u222) => hasProperty23(u222, EffectTypeId223);
var withFiberRuntime22 = (withRuntime) => {
  const effect = new EffectPrimitive22(OP_WITH_RUNTIME22);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol222 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol22 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture22 = (obj, span22) => {
  if (isSome223(span22)) {
    return new Proxy(obj, {
      has(target, p222) {
        return p222 === spanSymbol222 || p222 === originalSymbol22 || p222 in target;
      },
      get(target, p222) {
        if (p222 === spanSymbol222) {
          return span22.value;
        }
        if (p222 === originalSymbol22) {
          return obj;
        }
        return target[p222];
      }
    });
  }
  return obj;
};
var fail222 = (error) => isObject23(error) && !(spanSymbol222 in error) ? withFiberRuntime22((fiber) => failCause22(fail32(capture22(error, currentSpanFromFiber22(fiber))))) : failCause22(fail32(error));
var failCause22 = (cause) => {
  const effect = new EffectPrimitiveFailure22(OP_FAILURE22);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey22 = "effect/FiberRef";
var FiberRefTypeId22 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey22);
var fiberRefVariance22 = {
  /* c8 ignore next */
  _A: (_222) => _222
};
var fiberRefUnsafeMakeContext22 = (initial) => {
  const differ = environment22();
  return fiberRefUnsafeMakePatch22(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch22 = (initial, options) => ({
  [FiberRefTypeId22]: fiberRefVariance22,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch2222) => (oldValue) => options.differ.patch(patch2222, oldValue),
  fork: options.fork,
  join: options.join ?? ((_222, n222) => n222),
  pipe() {
    return pipeArguments23(this, arguments);
  }
});
var currentContext22 = /* @__PURE__ */ globalValue23(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext22(empty222()));
var YieldableError22 = /* @__PURE__ */ function() {
  class YieldableError2222 extends globalThis.Error {
    commit() {
      return fail222(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol23]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError2222.prototype, StructuralCommitPrototype23);
  return YieldableError2222;
}();
var exitIsExit22 = (u222) => isEffect22(u222) && "_tag" in u222 && (u222._tag === "Success" || u222._tag === "Failure");
var currentSpanFromFiber22 = (fiber) => {
  const span22 = fiber.getFiberRef(currentContext22).unsafeMap.get(spanTag22.key);
  return span22 !== void 0 && span22._tag === "Span" ? some323(span22) : none223();
};
var Data_exports23 = {};
__export223(Data_exports23, {
  Class: () => Class222,
  Error: () => Error222,
  Structural: () => Structural222,
  TaggedClass: () => TaggedClass22,
  TaggedError: () => TaggedError22,
  array: () => array222,
  case: () => _case22,
  struct: () => struct322,
  tagged: () => tagged22,
  taggedEnum: () => taggedEnum22,
  tuple: () => tuple222,
  unsafeArray: () => unsafeArray22,
  unsafeStruct: () => unsafeStruct22
});
var struct322 = struct222;
var unsafeStruct22 = (as2322) => Object.setPrototypeOf(as2322, StructuralPrototype23);
var tuple222 = (...as2322) => unsafeArray22(as2322);
var array222 = (as2322) => unsafeArray22(as2322.slice(0));
var unsafeArray22 = (as2322) => Object.setPrototypeOf(as2322, ArrayProto22);
var _case22 = () => (args) => args === void 0 ? Object.create(StructuralPrototype23) : struct322(args);
var tagged22 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype23) : struct322(args);
  value._tag = tag;
  return value;
};
var Class222 = Structural32;
var TaggedClass22 = (tag) => {
  class Base extends Class222 {
    _tag = tag;
  }
  return Base;
};
var Structural222 = Structural32;
var taggedEnum22 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged22;
    } else if (tag === "$match") {
      return taggedMatch22;
    }
    return tagged22(tag);
  }
});
function taggedMatch22() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error222 = /* @__PURE__ */ function() {
  return class Base extends YieldableError22 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError22 = (tag) => {
  class Base extends Error222 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp22 = Function_exports23.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType22.Program) return Option_exports23.none();
  return predicate(parent) ? Option_exports23.some(parent) : traverseUp22(parent, predicate);
});
var traverseUpGuard22 = Function_exports23.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType22.Program) return Option_exports23.none();
  return predicate(parent) ? Option_exports23.some(parent) : traverseUpGuard22(parent, predicate);
});
var ESLintCommunityESLintUtils22;
((ESLintCommunityESLintUtils2222) => {
  ESLintCommunityESLintUtils2222.getFunctionHeadLocation = getFunctionHeadLocation22;
  ESLintCommunityESLintUtils2222.getFunctionNameWithKind = getFunctionNameWithKind22;
  ESLintCommunityESLintUtils2222.getPropertyName = getPropertyName22;
  ESLintCommunityESLintUtils2222.getStaticValue = getStaticValue22;
  ESLintCommunityESLintUtils2222.getStringIfConstant = getStringIfConstant22;
  ESLintCommunityESLintUtils2222.hasSideEffect = hasSideEffect22;
  ESLintCommunityESLintUtils2222.isParenthesized = isParenthesized22;
})(ESLintCommunityESLintUtils22 || (ESLintCommunityESLintUtils22 = {}));
var Construction22 = Data_exports23.taggedEnum();
Construction22.None();
a({
  type: N.union([NodeType22.FunctionExpression, NodeType22.ArrowFunctionExpression]),
  parent: {
    type: NodeType22.Property,
    parent: {
      type: NodeType22.ObjectExpression
    }
  }
});
a({
  type: N.union([NodeType22.FunctionExpression, NodeType22.ArrowFunctionExpression]),
  parent: {
    type: NodeType22.MethodDefinition,
    parent: {
      type: NodeType22.ClassBody
    }
  }
});
a({
  type: N.union([NodeType22.FunctionExpression, NodeType22.ArrowFunctionExpression]),
  parent: {
    type: NodeType22.Property,
    parent: {
      type: NodeType22.ClassBody
    }
  }
});
var Function_exports222 = {};
__export32(Function_exports222, {
  SK: () => SK222,
  absurd: () => absurd222,
  apply: () => apply222,
  compose: () => compose322,
  constFalse: () => constFalse222,
  constNull: () => constNull222,
  constTrue: () => constTrue222,
  constUndefined: () => constUndefined222,
  constVoid: () => constVoid222,
  constant: () => constant222,
  dual: () => dual222,
  flip: () => flip222,
  flow: () => flow222,
  hole: () => hole222,
  identity: () => identity222,
  isFunction: () => isFunction42,
  pipe: () => pipe222,
  satisfies: () => satisfies222,
  tupled: () => tupled222,
  unsafeCoerce: () => unsafeCoerce222,
  untupled: () => untupled222
});
var isFunction42 = (input) => typeof input === "function";
var dual222 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a222, b222) {
        if (arguments.length >= 2) {
          return body(a222, b222);
        }
        return function(self2) {
          return body(self2, a222);
        };
      };
    case 3:
      return function(a222, b222, c222) {
        if (arguments.length >= 3) {
          return body(a222, b222, c222);
        }
        return function(self2) {
          return body(self2, a222, b222);
        };
      };
    case 4:
      return function(a222, b222, c222, d222) {
        if (arguments.length >= 4) {
          return body(a222, b222, c222, d222);
        }
        return function(self2) {
          return body(self2, a222, b222, c222);
        };
      };
    case 5:
      return function(a222, b222, c222, d222, e222) {
        if (arguments.length >= 5) {
          return body(a222, b222, c222, d222, e222);
        }
        return function(self2) {
          return body(self2, a222, b222, c222, d222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply222 = (a222) => (self2) => self2(a222);
var identity222 = (a222) => a222;
var satisfies222 = () => (b222) => b222;
var unsafeCoerce222 = identity222;
var constant222 = (value) => () => value;
var constTrue222 = /* @__PURE__ */ constant222(true);
var constFalse222 = /* @__PURE__ */ constant222(false);
var constNull222 = /* @__PURE__ */ constant222(null);
var constUndefined222 = /* @__PURE__ */ constant222(void 0);
var constVoid222 = constUndefined222;
var flip222 = (f222) => (...b222) => (...a222) => f222(...a222)(...b222);
var compose322 = /* @__PURE__ */ dual222(2, (ab, bc) => (a222) => bc(ab(a222)));
var absurd222 = (_222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled222 = (f222) => (a222) => f222(...a222);
var untupled222 = (f222) => (...a222) => f222(a222);
function pipe222(a222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a222;
    case 2:
      return ab(a222);
    case 3:
      return bc(ab(a222));
    case 4:
      return cd(bc(ab(a222)));
    case 5:
      return de(cd(bc(ab(a222))));
    case 6:
      return ef(de(cd(bc(ab(a222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a222))))))));
    default: {
      let ret = arguments[0];
      for (let i222 = 1; i222 < arguments.length; i222++) {
        ret = arguments[i222](ret);
      }
      return ret;
    }
  }
}
function flow222(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole222 = /* @__PURE__ */ unsafeCoerce222(absurd222);
var SK222 = (_222, b222) => b222;
var Array_exports2 = {};
__export32(Array_exports2, {
  Do: () => Do32,
  allocate: () => allocate2,
  append: () => append2,
  appendAll: () => appendAll222,
  bind: () => bind52,
  bindTo: () => bindTo52,
  cartesian: () => cartesian2,
  cartesianWith: () => cartesianWith2,
  chop: () => chop2,
  chunksOf: () => chunksOf2,
  contains: () => contains32,
  containsWith: () => containsWith32,
  copy: () => copy222,
  dedupe: () => dedupe2,
  dedupeAdjacent: () => dedupeAdjacent2,
  dedupeAdjacentWith: () => dedupeAdjacentWith2,
  dedupeWith: () => dedupeWith2,
  difference: () => difference2,
  differenceWith: () => differenceWith2,
  drop: () => drop222,
  dropRight: () => dropRight2,
  dropWhile: () => dropWhile2,
  empty: () => empty92,
  every: () => every32,
  extend: () => extend2,
  filter: () => filter32,
  filterMap: () => filterMap32,
  filterMapWhile: () => filterMapWhile2,
  findFirst: () => findFirst22,
  findFirstIndex: () => findFirstIndex2,
  findLast: () => findLast2,
  findLastIndex: () => findLastIndex2,
  flatMap: () => flatMap32,
  flatMapNullable: () => flatMapNullable32,
  flatten: () => flatten32,
  forEach: () => forEach322,
  fromIterable: () => fromIterable42,
  fromNullable: () => fromNullable32,
  fromOption: () => fromOption22,
  fromRecord: () => fromRecord2,
  get: () => get3,
  getEquivalence: () => getEquivalence42,
  getLefts: () => getLefts2,
  getOrder: () => getOrder32,
  getRights: () => getRights2,
  getSomes: () => getSomes2,
  group: () => group2,
  groupBy: () => groupBy2,
  groupWith: () => groupWith2,
  head: () => head2,
  headNonEmpty: () => headNonEmpty222,
  init: () => init2,
  initNonEmpty: () => initNonEmpty2,
  insertAt: () => insertAt2,
  intersection: () => intersection2,
  intersectionWith: () => intersectionWith2,
  intersperse: () => intersperse2,
  isArray: () => isArray2,
  isEmptyArray: () => isEmptyArray2,
  isEmptyReadonlyArray: () => isEmptyReadonlyArray2,
  isNonEmptyArray: () => isNonEmptyArray22,
  isNonEmptyReadonlyArray: () => isNonEmptyReadonlyArray2,
  join: () => join2,
  last: () => last2,
  lastNonEmpty: () => lastNonEmpty2,
  length: () => length2,
  let: () => let_52,
  liftEither: () => liftEither2,
  liftNullable: () => liftNullable32,
  liftOption: () => liftOption2,
  liftPredicate: () => liftPredicate32,
  make: () => make102,
  makeBy: () => makeBy2,
  map: () => map32,
  mapAccum: () => mapAccum2,
  match: () => match42,
  matchLeft: () => matchLeft2,
  matchRight: () => matchRight2,
  max: () => max22,
  min: () => min22,
  modify: () => modify2,
  modifyNonEmptyHead: () => modifyNonEmptyHead2,
  modifyNonEmptyLast: () => modifyNonEmptyLast2,
  modifyOption: () => modifyOption2,
  of: () => of222,
  partition: () => partition2,
  partitionMap: () => partitionMap32,
  prepend: () => prepend222,
  prependAll: () => prependAll2,
  range: () => range2,
  reduce: () => reduce322,
  reduceRight: () => reduceRight2,
  remove: () => remove2,
  replace: () => replace22,
  replaceOption: () => replaceOption2,
  replicate: () => replicate2,
  reverse: () => reverse322,
  rotate: () => rotate2,
  scan: () => scan2,
  scanRight: () => scanRight2,
  separate: () => separate2,
  setNonEmptyHead: () => setNonEmptyHead2,
  setNonEmptyLast: () => setNonEmptyLast2,
  some: () => some72,
  sort: () => sort2,
  sortBy: () => sortBy2,
  sortWith: () => sortWith2,
  span: () => span2,
  split: () => split2,
  splitAt: () => splitAt2,
  splitNonEmptyAt: () => splitNonEmptyAt2,
  splitWhere: () => splitWhere2,
  tail: () => tail2,
  tailNonEmpty: () => tailNonEmpty222,
  take: () => take2,
  takeRight: () => takeRight2,
  takeWhile: () => takeWhile2,
  unappend: () => unappend2,
  unfold: () => unfold2,
  union: () => union4,
  unionWith: () => unionWith2,
  unprepend: () => unprepend2,
  unsafeGet: () => unsafeGet3,
  unzip: () => unzip2,
  zip: () => zip2,
  zipWith: () => zipWith32
});
var make622 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var array322 = (item) => make622((self2, that) => {
  if (self2.length !== that.length) {
    return false;
  }
  for (let i222 = 0; i222 < self2.length; i222++) {
    const isEq = item(self2[i222], that[i222]);
    if (!isEq) {
      return false;
    }
  }
  return true;
});
var let_322 = (map522) => dual222(3, (self2, name2, f222) => map522(self2, (a222) => Object.assign({}, a222, {
  [name2]: f222(a222)
})));
var bindTo322 = (map522) => dual222(2, (self2, name2) => map522(self2, (a222) => ({
  [name2]: a222
})));
var bind322 = (map522, flatMap522) => dual222(3, (self2, name2, f222) => flatMap522(self2, (a222) => map522(f222(a222), (b222) => Object.assign({}, a222, {
  [name2]: b222
}))));
var moduleVersion222 = "3.2.8";
var getCurrentVersion222 = () => moduleVersion222;
var globalStoreId222 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion222()}`);
if (!(globalStoreId222 in globalThis)) {
  globalThis[globalStoreId222] = /* @__PURE__ */ new Map();
}
var globalStore222 = globalThis[globalStoreId222];
var globalValue222 = (id, compute) => {
  if (!globalStore222.has(id)) {
    globalStore222.set(id, compute());
  }
  return globalStore222.get(id);
};
var Predicate_exports222 = {};
__export32(Predicate_exports222, {
  all: () => all322,
  and: () => and222,
  compose: () => compose42,
  eqv: () => eqv222,
  every: () => every222,
  hasProperty: () => hasProperty222,
  implies: () => implies222,
  isBigInt: () => isBigInt222,
  isBoolean: () => isBoolean222,
  isDate: () => isDate222,
  isError: () => isError222,
  isFunction: () => isFunction52,
  isIterable: () => isIterable222,
  isMap: () => isMap222,
  isNever: () => isNever222,
  isNotNull: () => isNotNull222,
  isNotNullable: () => isNotNullable222,
  isNotUndefined: () => isNotUndefined222,
  isNull: () => isNull222,
  isNullable: () => isNullable222,
  isNumber: () => isNumber222,
  isObject: () => isObject222,
  isPromise: () => isPromise222,
  isPromiseLike: () => isPromiseLike222,
  isReadonlyRecord: () => isReadonlyRecord222,
  isRecord: () => isRecord222,
  isSet: () => isSet222,
  isString: () => isString222,
  isSymbol: () => isSymbol222,
  isTagged: () => isTagged222,
  isTruthy: () => isTruthy222,
  isUint8Array: () => isUint8Array222,
  isUndefined: () => isUndefined222,
  isUnknown: () => isUnknown222,
  mapInput: () => mapInput222,
  nand: () => nand222,
  nor: () => nor222,
  not: () => not222,
  or: () => or222,
  product: () => product322,
  productMany: () => productMany322,
  some: () => some422,
  struct: () => struct422,
  tuple: () => tuple322,
  xor: () => xor222
});
var mapInput222 = /* @__PURE__ */ dual222(2, (self2, f222) => (b222) => self2(f222(b222)));
var isTruthy222 = (input) => !!input;
var isSet222 = (input) => input instanceof Set;
var isMap222 = (input) => input instanceof Map;
var isString222 = (input) => typeof input === "string";
var isNumber222 = (input) => typeof input === "number";
var isBoolean222 = (input) => typeof input === "boolean";
var isBigInt222 = (input) => typeof input === "bigint";
var isSymbol222 = (input) => typeof input === "symbol";
var isFunction52 = isFunction42;
var isUndefined222 = (input) => input === void 0;
var isNotUndefined222 = (input) => input !== void 0;
var isNull222 = (input) => input === null;
var isNotNull222 = (input) => input !== null;
var isNever222 = (_222) => false;
var isUnknown222 = (_222) => true;
var isRecordOrArray222 = (input) => typeof input === "object" && input !== null;
var isObject222 = (input) => isRecordOrArray222(input) || isFunction52(input);
var hasProperty222 = /* @__PURE__ */ dual222(2, (self2, property) => isObject222(self2) && property in self2);
var isTagged222 = /* @__PURE__ */ dual222(2, (self2, tag) => hasProperty222(self2, "_tag") && self2["_tag"] === tag);
var isNullable222 = (input) => input === null || input === void 0;
var isNotNullable222 = (input) => input !== null && input !== void 0;
var isError222 = (input) => input instanceof Error;
var isUint8Array222 = (input) => input instanceof Uint8Array;
var isDate222 = (input) => input instanceof Date;
var isIterable222 = (input) => hasProperty222(input, Symbol.iterator);
var isRecord222 = (input) => isRecordOrArray222(input) && !Array.isArray(input);
var isReadonlyRecord222 = isRecord222;
var isPromise222 = (input) => hasProperty222(input, "then") && "catch" in input && isFunction52(input.then) && isFunction52(input.catch);
var isPromiseLike222 = (input) => hasProperty222(input, "then") && isFunction52(input.then);
var compose42 = /* @__PURE__ */ dual222(2, (ab, bc) => (a222) => ab(a222) && bc(a222));
var product322 = (self2, that) => ([a222, b222]) => self2(a222) && that(b222);
var all322 = (collection) => {
  return (as422) => {
    let collectionIndex = 0;
    for (const p222 of collection) {
      if (collectionIndex >= as422.length) {
        break;
      }
      if (p222(as422[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany322 = (self2, collection) => {
  const rest = all322(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple322 = (...elements) => all322(elements);
var struct422 = (fields) => {
  const keys422 = Object.keys(fields);
  return (a222) => {
    for (const key of keys422) {
      if (!fields[key](a222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not222 = (self2) => (a222) => !self2(a222);
var or222 = /* @__PURE__ */ dual222(2, (self2, that) => (a222) => self2(a222) || that(a222));
var and222 = /* @__PURE__ */ dual222(2, (self2, that) => (a222) => self2(a222) && that(a222));
var xor222 = /* @__PURE__ */ dual222(2, (self2, that) => (a222) => self2(a222) !== that(a222));
var eqv222 = /* @__PURE__ */ dual222(2, (self2, that) => (a222) => self2(a222) === that(a222));
var implies222 = /* @__PURE__ */ dual222(2, (self2, that) => (a222) => self2(a222) ? that(a222) : true);
var nor222 = /* @__PURE__ */ dual222(2, (self2, that) => (a222) => !(self2(a222) || that(a222)));
var nand222 = /* @__PURE__ */ dual222(2, (self2, that) => (a222) => !(self2(a222) && that(a222)));
var every222 = (collection) => (a222) => {
  for (const p222 of collection) {
    if (!p222(a222)) {
      return false;
    }
  }
  return true;
};
var some422 = (collection) => (a222) => {
  for (const p222 of collection) {
    if (p222(a222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage222 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId222 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind222 = (u222) => isObject222(u222) && GenKindTypeId222 in u222;
var GenKindImpl222 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity222;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_222) => _222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_222) => _222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_222) => _222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId222] = GenKindTypeId222;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen322(this);
  }
};
var SingleShotGen322 = class _SingleShotGen52 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a222) {
    return this.called ? {
      value: a222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a222) {
    return {
      value: a222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e222) {
    throw e222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen52(this.self);
  }
};
var adapter322 = () => function() {
  let x222 = arguments[0];
  for (let i222 = 1; i222 < arguments.length; i222++) {
    x222 = arguments[i222](x222);
  }
  return new GenKindImpl222(x222);
};
var defaultIncHi222 = 335903614;
var defaultIncLo222 = 4150755663;
var MUL_HI222 = 1481765933 >>> 0;
var MUL_LO222 = 1284865837 >>> 0;
var BIT_53222 = 9007199254740992;
var BIT_27222 = 134217728;
var PCGRandom222 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable222(seedLo) && isNullable222(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable222(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable222(incLo) && isNullable222(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo222;
      incHi = this._state ? this._state[2] : defaultIncHi222;
    } else if (isNullable222(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add64222(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max32) {
    if (!max32) {
      return this._next();
    }
    max32 = max32 >>> 0;
    if ((max32 & max32 - 1) === 0) {
      return this._next() & max32 - 1;
    }
    let num = 0;
    const skew = (-max32 >>> 0) % max32 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max32;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_27222 + lo) / BIT_53222;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul64222(this._state, oldHi, oldLo, MUL_HI222, MUL_LO222);
    add64222(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul64222(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add64222(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId222 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap222 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId222]() {
    return this.#value;
  }
};
function yieldWrapGet222(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId222 in self2) {
    return self2[YieldWrapTypeId222]();
  }
  throw new Error(getBugErrorMessage222("yieldWrapGet"));
}
var structuralRegionState222 = /* @__PURE__ */ globalValue222("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache222 = /* @__PURE__ */ globalValue222(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr222 = /* @__PURE__ */ globalValue222(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom222());
var symbol322 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash222 = (self2) => {
  if (structuralRegionState222.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number222(self2);
    case "bigint":
      return string222(self2.toString(10));
    case "boolean":
      return string222(String(self2));
    case "symbol":
      return string222(String(self2));
    case "string":
      return string222(self2);
    case "undefined":
      return string222("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string222("null");
      } else if (self2 instanceof Date) {
        return hash222(self2.toISOString());
      } else if (isHash222(self2)) {
        return self2[symbol322]();
      } else {
        return random222(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random222 = (self2) => {
  if (!randomHashCache222.has(self2)) {
    randomHashCache222.set(self2, number222(pcgr222.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache222.get(self2);
};
var combine322 = (b222) => (self2) => self2 * 53 ^ b222;
var optimize222 = (n222) => n222 & 3221225471 | n222 >>> 1 & 1073741824;
var isHash222 = (u222) => hasProperty222(u222, symbol322);
var number222 = (n222) => {
  if (n222 !== n222 || n222 === Infinity) {
    return 0;
  }
  let h222 = n222 | 0;
  if (h222 !== n222) {
    h222 ^= n222 * 4294967295;
  }
  while (n222 > 4294967295) {
    h222 ^= n222 /= 4294967295;
  }
  return optimize222(n222);
};
var string222 = (str) => {
  let h222 = 5381, i222 = str.length;
  while (i222) {
    h222 = h222 * 33 ^ str.charCodeAt(--i222);
  }
  return optimize222(h222);
};
var cached222 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash522) {
      Object.defineProperty(self3, symbol322, {
        value() {
          return hash522;
        },
        enumerable: false
      });
      return hash522;
    };
  }
  const self2 = arguments[0];
  const hash422 = arguments[1];
  Object.defineProperty(self2, symbol322, {
    value() {
      return hash422;
    },
    enumerable: false
  });
  return hash422;
};
var symbol42 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals222() {
  if (arguments.length === 1) {
    return (self2) => compareBoth222(self2, arguments[0]);
  }
  return compareBoth222(arguments[0], arguments[1]);
}
function compareBoth222(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual222(self2) && isEqual222(that)) {
        if (hash222(self2) === hash222(that) && self2[symbol42](that)) {
          return true;
        } else {
          return structuralRegionState222.enabled && structuralRegionState222.tester ? structuralRegionState222.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState222.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v222, i222) => compareBoth222(v222, that[i222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth222(self2[key], that[key]))) {
              return structuralRegionState222.tester ? structuralRegionState222.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState222.tester ? structuralRegionState222.tester(self2, that) : false;
    }
  }
  return structuralRegionState222.enabled && structuralRegionState222.tester ? structuralRegionState222.tester(self2, that) : false;
}
var isEqual222 = (u222) => hasProperty222(u222, symbol42);
var equivalence222 = () => equals222;
var NodeInspectSymbol222 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON222 = (x222) => {
  if (hasProperty222(x222, "toJSON") && isFunction52(x222["toJSON"]) && x222["toJSON"].length === 0) {
    return x222.toJSON();
  } else if (Array.isArray(x222)) {
    return x222.map(toJSON222);
  }
  return x222;
};
var format222 = (x222) => JSON.stringify(x222, null, 2);
var pipeArguments222 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i222 = 0, len = args.length; i222 < len; i222++) {
        ret = args[i222](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId322 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId222 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId222 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId222 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance222 = {
  /* c8 ignore next */
  _R: (_222) => _222,
  /* c8 ignore next */
  _E: (_222) => _222,
  /* c8 ignore next */
  _A: (_222) => _222,
  _V: /* @__PURE__ */ getCurrentVersion222()
};
var sinkVariance222 = {
  /* c8 ignore next */
  _A: (_222) => _222,
  /* c8 ignore next */
  _In: (_222) => _222,
  /* c8 ignore next */
  _L: (_222) => _222,
  /* c8 ignore next */
  _E: (_222) => _222,
  /* c8 ignore next */
  _R: (_222) => _222
};
var channelVariance222 = {
  /* c8 ignore next */
  _Env: (_222) => _222,
  /* c8 ignore next */
  _InErr: (_222) => _222,
  /* c8 ignore next */
  _InElem: (_222) => _222,
  /* c8 ignore next */
  _InDone: (_222) => _222,
  /* c8 ignore next */
  _OutErr: (_222) => _222,
  /* c8 ignore next */
  _OutElem: (_222) => _222,
  /* c8 ignore next */
  _OutDone: (_222) => _222
};
var EffectPrototype222 = {
  [EffectTypeId322]: effectVariance222,
  [StreamTypeId222]: effectVariance222,
  [SinkTypeId222]: sinkVariance222,
  [ChannelTypeId222]: channelVariance222,
  [symbol42](that) {
    return this === that;
  },
  [symbol322]() {
    return cached222(this, random222(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen322(new YieldWrap222(this));
  },
  pipe() {
    return pipeArguments222(this, arguments);
  }
};
var TypeId622 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto322 = {
  ...EffectPrototype222,
  [TypeId622]: {
    _A: (_222) => _222
  },
  [NodeInspectSymbol222]() {
    return this.toJSON();
  },
  toString() {
    return format222(this.toJSON());
  }
};
var SomeProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto322), {
  _tag: "Some",
  _op: "Some",
  [symbol42](that) {
    return isOption322(that) && isSome322(that) && equals222(this.value, that.value);
  },
  [symbol322]() {
    return cached222(this, combine322(hash222(this._tag))(hash222(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON222(this.value)
    };
  }
});
var NoneHash222 = /* @__PURE__ */ hash222("None");
var NoneProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto322), {
  _tag: "None",
  _op: "None",
  [symbol42](that) {
    return isOption322(that) && isNone322(that);
  },
  [symbol322]() {
    return NoneHash222;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption322 = (input) => hasProperty222(input, TypeId622);
var isNone322 = (fa) => fa._tag === "None";
var isSome322 = (fa) => fa._tag === "Some";
var none322 = /* @__PURE__ */ Object.create(NoneProto222);
var some52 = (value) => {
  const a222 = Object.create(SomeProto222);
  a222.value = value;
  return a222;
};
var TypeId72 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto42 = {
  ...EffectPrototype222,
  [TypeId72]: {
    _R: (_222) => _222
  },
  [NodeInspectSymbol222]() {
    return this.toJSON();
  },
  toString() {
    return format222(this.toJSON());
  }
};
var RightProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto42), {
  _tag: "Right",
  _op: "Right",
  [symbol42](that) {
    return isEither222(that) && isRight222(that) && equals222(this.right, that.right);
  },
  [symbol322]() {
    return combine322(hash222(this._tag))(hash222(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON222(this.right)
    };
  }
});
var LeftProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto42), {
  _tag: "Left",
  _op: "Left",
  [symbol42](that) {
    return isEither222(that) && isLeft222(that) && equals222(this.left, that.left);
  },
  [symbol322]() {
    return combine322(hash222(this._tag))(hash222(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON222(this.left)
    };
  }
});
var isEither222 = (input) => hasProperty222(input, TypeId72);
var isLeft222 = (ma) => ma._tag === "Left";
var isRight222 = (ma) => ma._tag === "Right";
var left322 = (left522) => {
  const a222 = Object.create(LeftProto222);
  a222.left = left522;
  return a222;
};
var right322 = (right522) => {
  const a222 = Object.create(RightProto222);
  a222.right = right522;
  return a222;
};
var getLeft322 = (self2) => isRight222(self2) ? none322 : some52(self2.left);
var getRight322 = (self2) => isLeft222(self2) ? none322 : some52(self2.right);
var isLeft32 = isLeft222;
var isRight32 = isRight222;
var isNonEmptyArray3 = (self2) => self2.length > 0;
var Option_exports222 = {};
__export32(Option_exports222, {
  Do: () => Do222,
  TypeId: () => TypeId82,
  all: () => all42,
  andThen: () => andThen222,
  ap: () => ap222,
  as: () => as222,
  asVoid: () => asVoid222,
  bind: () => bind42,
  bindTo: () => bindTo42,
  composeK: () => composeK222,
  contains: () => contains222,
  containsWith: () => containsWith222,
  exists: () => exists222,
  filter: () => filter222,
  filterMap: () => filterMap222,
  firstSomeOf: () => firstSomeOf222,
  flatMap: () => flatMap222,
  flatMapNullable: () => flatMapNullable222,
  flatten: () => flatten222,
  fromIterable: () => fromIterable322,
  fromNullable: () => fromNullable222,
  gen: () => gen222,
  getEquivalence: () => getEquivalence322,
  getLeft: () => getLeft42,
  getOrElse: () => getOrElse222,
  getOrNull: () => getOrNull222,
  getOrThrow: () => getOrThrow222,
  getOrThrowWith: () => getOrThrowWith222,
  getOrUndefined: () => getOrUndefined222,
  getOrder: () => getOrder222,
  getRight: () => getRight42,
  isNone: () => isNone42,
  isOption: () => isOption42,
  isSome: () => isSome42,
  let: () => let_42,
  lift2: () => lift2222,
  liftNullable: () => liftNullable222,
  liftPredicate: () => liftPredicate222,
  liftThrowable: () => liftThrowable222,
  map: () => map222,
  match: () => match32,
  none: () => none42,
  orElse: () => orElse222,
  orElseEither: () => orElseEither222,
  orElseSome: () => orElseSome222,
  partitionMap: () => partitionMap222,
  product: () => product42,
  productMany: () => productMany42,
  reduceCompact: () => reduceCompact222,
  some: () => some62,
  tap: () => tap222,
  toArray: () => toArray222,
  toRefinement: () => toRefinement222,
  void: () => void_222,
  zipLeft: () => zipLeft222,
  zipRight: () => zipRight222,
  zipWith: () => zipWith222
});
var make82 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var number32 = /* @__PURE__ */ make82((self2, that) => self2 < that ? -1 : 1);
var combineMany2 = /* @__PURE__ */ dual222(2, (self2, collection) => make82((a1, a222) => {
  let out = self2(a1, a222);
  if (out !== 0) {
    return out;
  }
  for (const O222 of collection) {
    out = O222(a1, a222);
    if (out !== 0) {
      return out;
    }
  }
  return out;
}));
var empty822 = () => make82(() => 0);
var combineAll2 = (collection) => combineMany2(empty822(), collection);
var mapInput32 = /* @__PURE__ */ dual222(2, (self2, f222) => make82((b1, b222) => self2(f222(b1), f222(b222))));
var array42 = (O222) => make82((self2, that) => {
  const aLen = self2.length;
  const bLen = that.length;
  const len = Math.min(aLen, bLen);
  for (let i222 = 0; i222 < len; i222++) {
    const o222 = O222(self2[i222], that[i222]);
    if (o222 !== 0) {
      return o222;
    }
  }
  return number32(aLen, bLen);
});
var min3 = (O222) => dual222(2, (self2, that) => self2 === that || O222(self2, that) < 1 ? self2 : that);
var max3 = (O222) => dual222(2, (self2, that) => self2 === that || O222(self2, that) > -1 ? self2 : that);
var TypeId82 = /* @__PURE__ */ Symbol.for("effect/Option");
var none42 = () => none322;
var some62 = some52;
var isOption42 = isOption322;
var isNone42 = isNone322;
var isSome42 = isSome322;
var match32 = /* @__PURE__ */ dual222(2, (self2, {
  onNone,
  onSome
}) => isNone42(self2) ? onNone() : onSome(self2.value));
var toRefinement222 = (f222) => (a222) => isSome42(f222(a222));
var fromIterable322 = (collection) => {
  for (const a222 of collection) {
    return some62(a222);
  }
  return none42();
};
var getRight42 = getRight322;
var getLeft42 = getLeft322;
var getOrElse222 = /* @__PURE__ */ dual222(2, (self2, onNone) => isNone42(self2) ? onNone() : self2.value);
var orElse222 = /* @__PURE__ */ dual222(2, (self2, that) => isNone42(self2) ? that() : self2);
var orElseSome222 = /* @__PURE__ */ dual222(2, (self2, onNone) => isNone42(self2) ? some62(onNone()) : self2);
var orElseEither222 = /* @__PURE__ */ dual222(2, (self2, that) => isNone42(self2) ? map222(that(), right322) : map222(self2, left322));
var firstSomeOf222 = (collection) => {
  let out = none42();
  for (out of collection) {
    if (isSome42(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable222 = (nullableValue) => nullableValue == null ? none42() : some62(nullableValue);
var liftNullable222 = (f222) => (...a222) => fromNullable222(f222(...a222));
var getOrNull222 = /* @__PURE__ */ getOrElse222(constNull222);
var getOrUndefined222 = /* @__PURE__ */ getOrElse222(constUndefined222);
var liftThrowable222 = (f222) => (...a222) => {
  try {
    return some62(f222(...a222));
  } catch (e222) {
    return none42();
  }
};
var getOrThrowWith222 = /* @__PURE__ */ dual222(2, (self2, onNone) => {
  if (isSome42(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow222 = /* @__PURE__ */ getOrThrowWith222(() => new Error("getOrThrow called on a None"));
var map222 = /* @__PURE__ */ dual222(2, (self2, f222) => isNone42(self2) ? none42() : some62(f222(self2.value)));
var as222 = /* @__PURE__ */ dual222(2, (self2, b222) => map222(self2, () => b222));
var asVoid222 = /* @__PURE__ */ as222(void 0);
var void_222 = /* @__PURE__ */ some62(void 0);
var flatMap222 = /* @__PURE__ */ dual222(2, (self2, f222) => isNone42(self2) ? none42() : f222(self2.value));
var andThen222 = /* @__PURE__ */ dual222(2, (self2, f222) => flatMap222(self2, (a222) => {
  const b222 = isFunction42(f222) ? f222(a222) : f222;
  return isOption42(b222) ? b222 : some62(b222);
}));
var flatMapNullable222 = /* @__PURE__ */ dual222(2, (self2, f222) => isNone42(self2) ? none42() : fromNullable222(f222(self2.value)));
var flatten222 = /* @__PURE__ */ flatMap222(identity222);
var zipRight222 = /* @__PURE__ */ dual222(2, (self2, that) => flatMap222(self2, () => that));
var composeK222 = /* @__PURE__ */ dual222(2, (afb, bfc) => (a222) => flatMap222(afb(a222), bfc));
var zipLeft222 = /* @__PURE__ */ dual222(2, (self2, that) => tap222(self2, () => that));
var tap222 = /* @__PURE__ */ dual222(2, (self2, f222) => flatMap222(self2, (a222) => map222(f222(a222), () => a222)));
var product42 = (self2, that) => isSome42(self2) && isSome42(that) ? some62([self2.value, that.value]) : none42();
var productMany42 = (self2, collection) => {
  if (isNone42(self2)) {
    return none42();
  }
  const out = [self2.value];
  for (const o222 of collection) {
    if (isNone42(o222)) {
      return none42();
    }
    out.push(o222.value);
  }
  return some62(out);
};
var all42 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o222 of input) {
      if (isNone42(o222)) {
        return none42();
      }
      out2.push(o222.value);
    }
    return some62(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o222 = input[key];
    if (isNone42(o222)) {
      return none42();
    }
    out[key] = o222.value;
  }
  return some62(out);
};
var zipWith222 = /* @__PURE__ */ dual222(3, (self2, that, f222) => map222(product42(self2, that), ([a222, b222]) => f222(a222, b222)));
var ap222 = /* @__PURE__ */ dual222(2, (self2, that) => zipWith222(self2, that, (f222, a222) => f222(a222)));
var reduceCompact222 = /* @__PURE__ */ dual222(3, (self2, b222, f222) => {
  let out = b222;
  for (const oa of self2) {
    if (isSome42(oa)) {
      out = f222(out, oa.value);
    }
  }
  return out;
});
var toArray222 = (self2) => isNone42(self2) ? [] : [self2.value];
var partitionMap222 = /* @__PURE__ */ dual222(2, (self2, f222) => {
  if (isNone42(self2)) {
    return [none42(), none42()];
  }
  const e222 = f222(self2.value);
  return isLeft222(e222) ? [some62(e222.left), none42()] : [none42(), some62(e222.right)];
});
var filterMap222 = /* @__PURE__ */ dual222(2, (self2, f222) => isNone42(self2) ? none42() : f222(self2.value));
var filter222 = /* @__PURE__ */ dual222(2, (self2, predicate) => filterMap222(self2, (b222) => predicate(b222) ? some52(b222) : none322));
var getEquivalence322 = (isEquivalent) => make622((x222, y222) => x222 === y222 || (isNone42(x222) ? isNone42(y222) : isNone42(y222) ? false : isEquivalent(x222.value, y222.value)));
var getOrder222 = (O222) => make82((self2, that) => isSome42(self2) ? isSome42(that) ? O222(self2.value, that.value) : 1 : -1);
var lift2222 = (f222) => dual222(2, (self2, that) => zipWith222(self2, that, f222));
var liftPredicate222 = (predicate) => (b222) => predicate(b222) ? some62(b222) : none42();
var containsWith222 = (isEquivalent) => dual222(2, (self2, a222) => isNone42(self2) ? false : isEquivalent(self2.value, a222));
var _equivalence322 = /* @__PURE__ */ equivalence222();
var contains222 = /* @__PURE__ */ containsWith222(_equivalence322);
var exists222 = /* @__PURE__ */ dual222(2, (self2, refinement) => isNone42(self2) ? false : refinement(self2.value));
var bindTo42 = /* @__PURE__ */ bindTo322(map222);
var let_42 = /* @__PURE__ */ let_322(map222);
var bind42 = /* @__PURE__ */ bind322(map222, flatMap222);
var Do222 = /* @__PURE__ */ some62({});
var adapter42 = /* @__PURE__ */ adapter322();
var gen222 = (f222) => {
  const iterator = f222(adapter42);
  let state = iterator.next();
  if (state.done) {
    return some62(state.value);
  } else {
    let current = state.value;
    if (isGenKind222(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet222(current);
    }
    if (isNone42(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind222(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet222(current);
        }
        if (isNone42(current)) {
          return current;
        }
      }
    }
    return some62(state.value);
  }
};
var make92 = (...elements) => elements;
var findFirst3 = /* @__PURE__ */ dual222(2, (self2, f222) => {
  let i222 = 0;
  for (const a222 of self2) {
    const o222 = f222(a222, i222);
    if (isBoolean222(o222)) {
      if (o222) {
        return some62(a222);
      }
    } else {
      if (isSome42(o222)) {
        return o222;
      }
    }
    i222++;
  }
  return none42();
});
var collect2 = /* @__PURE__ */ dual222(2, (self2, f222) => {
  const out = [];
  for (const key of keys222(self2)) {
    out.push(f222(key, self2[key]));
  }
  return out;
});
var toEntries2 = /* @__PURE__ */ collect2((key, value) => [key, value]);
var keys222 = (self2) => Object.keys(self2);
var make102 = (...elements) => elements;
var allocate2 = (n222) => new Array(n222);
var makeBy2 = (n222, f222) => {
  const max32 = Math.max(1, Math.floor(n222));
  const out = new Array(max32);
  for (let i222 = 0; i222 < max32; i222++) {
    out[i222] = f222(i222);
  }
  return out;
};
var range2 = (start, end) => start <= end ? makeBy2(end - start + 1, (i222) => start + i222) : [start];
var replicate2 = /* @__PURE__ */ dual222(2, (a222, n222) => makeBy2(n222, () => a222));
var fromIterable42 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var fromRecord2 = toEntries2;
var fromOption22 = toArray222;
var match42 = /* @__PURE__ */ dual222(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray2(self2) ? onNonEmpty(self2) : onEmpty());
var matchLeft2 = /* @__PURE__ */ dual222(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray2(self2) ? onNonEmpty(headNonEmpty222(self2), tailNonEmpty222(self2)) : onEmpty());
var matchRight2 = /* @__PURE__ */ dual222(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray2(self2) ? onNonEmpty(initNonEmpty2(self2), lastNonEmpty2(self2)) : onEmpty());
var prepend222 = /* @__PURE__ */ dual222(2, (self2, head222) => [head222, ...self2]);
var prependAll2 = /* @__PURE__ */ dual222(2, (self2, that) => fromIterable42(that).concat(fromIterable42(self2)));
var append2 = /* @__PURE__ */ dual222(2, (self2, last22) => [...self2, last22]);
var appendAll222 = /* @__PURE__ */ dual222(2, (self2, that) => fromIterable42(self2).concat(fromIterable42(that)));
var scan2 = /* @__PURE__ */ dual222(3, (self2, b222, f222) => {
  const out = [b222];
  let i222 = 0;
  for (const a222 of self2) {
    out[i222 + 1] = f222(out[i222], a222);
    i222++;
  }
  return out;
});
var scanRight2 = /* @__PURE__ */ dual222(3, (self2, b222, f222) => {
  const input = fromIterable42(self2);
  const out = new Array(input.length + 1);
  out[input.length] = b222;
  for (let i222 = input.length - 1; i222 >= 0; i222--) {
    out[i222] = f222(out[i222 + 1], input[i222]);
  }
  return out;
});
var isArray2 = Array.isArray;
var isEmptyArray2 = (self2) => self2.length === 0;
var isEmptyReadonlyArray2 = isEmptyArray2;
var isNonEmptyArray22 = isNonEmptyArray3;
var isNonEmptyReadonlyArray2 = isNonEmptyArray3;
var length2 = (self2) => self2.length;
var isOutOfBound2 = (i222, as422) => i222 < 0 || i222 >= as422.length;
var clamp2 = (i222, as422) => Math.floor(Math.min(Math.max(0, i222), as422.length));
var get3 = /* @__PURE__ */ dual222(2, (self2, index) => {
  const i222 = Math.floor(index);
  return isOutOfBound2(i222, self2) ? none42() : some62(self2[i222]);
});
var unsafeGet3 = /* @__PURE__ */ dual222(2, (self2, index) => {
  const i222 = Math.floor(index);
  if (isOutOfBound2(i222, self2)) {
    throw new Error(`Index ${i222} out of bounds`);
  }
  return self2[i222];
});
var unprepend2 = (self2) => [headNonEmpty222(self2), tailNonEmpty222(self2)];
var unappend2 = (self2) => [initNonEmpty2(self2), lastNonEmpty2(self2)];
var head2 = /* @__PURE__ */ get3(0);
var headNonEmpty222 = /* @__PURE__ */ unsafeGet3(0);
var last2 = (self2) => isNonEmptyReadonlyArray2(self2) ? some62(lastNonEmpty2(self2)) : none42();
var lastNonEmpty2 = (self2) => self2[self2.length - 1];
var tail2 = (self2) => {
  const input = fromIterable42(self2);
  return isNonEmptyReadonlyArray2(input) ? some62(tailNonEmpty222(input)) : none42();
};
var tailNonEmpty222 = (self2) => self2.slice(1);
var init2 = (self2) => {
  const input = fromIterable42(self2);
  return isNonEmptyReadonlyArray2(input) ? some62(initNonEmpty2(input)) : none42();
};
var initNonEmpty2 = (self2) => self2.slice(0, -1);
var take2 = /* @__PURE__ */ dual222(2, (self2, n222) => {
  const input = fromIterable42(self2);
  return input.slice(0, clamp2(n222, input));
});
var takeRight2 = /* @__PURE__ */ dual222(2, (self2, n222) => {
  const input = fromIterable42(self2);
  const i222 = clamp2(n222, input);
  return i222 === 0 ? [] : input.slice(-i222);
});
var takeWhile2 = /* @__PURE__ */ dual222(2, (self2, predicate) => {
  let i222 = 0;
  const out = [];
  for (const a222 of self2) {
    if (!predicate(a222, i222)) {
      break;
    }
    out.push(a222);
    i222++;
  }
  return out;
});
var spanIndex2 = (self2, predicate) => {
  let i222 = 0;
  for (const a222 of self2) {
    if (!predicate(a222, i222)) {
      break;
    }
    i222++;
  }
  return i222;
};
var span2 = /* @__PURE__ */ dual222(2, (self2, predicate) => splitAt2(self2, spanIndex2(self2, predicate)));
var drop222 = /* @__PURE__ */ dual222(2, (self2, n222) => {
  const input = fromIterable42(self2);
  return input.slice(clamp2(n222, input), input.length);
});
var dropRight2 = /* @__PURE__ */ dual222(2, (self2, n222) => {
  const input = fromIterable42(self2);
  return input.slice(0, input.length - clamp2(n222, input));
});
var dropWhile2 = /* @__PURE__ */ dual222(2, (self2, predicate) => fromIterable42(self2).slice(spanIndex2(self2, predicate)));
var findFirstIndex2 = /* @__PURE__ */ dual222(2, (self2, predicate) => {
  let i222 = 0;
  for (const a222 of self2) {
    if (predicate(a222, i222)) {
      return some62(i222);
    }
    i222++;
  }
  return none42();
});
var findLastIndex2 = /* @__PURE__ */ dual222(2, (self2, predicate) => {
  const input = fromIterable42(self2);
  for (let i222 = input.length - 1; i222 >= 0; i222--) {
    if (predicate(input[i222], i222)) {
      return some62(i222);
    }
  }
  return none42();
});
var findFirst22 = findFirst3;
var findLast2 = /* @__PURE__ */ dual222(2, (self2, f222) => {
  const input = fromIterable42(self2);
  for (let i222 = input.length - 1; i222 >= 0; i222--) {
    const a222 = input[i222];
    const o222 = f222(a222, i222);
    if (isBoolean222(o222)) {
      if (o222) {
        return some62(a222);
      }
    } else {
      if (isSome42(o222)) {
        return o222;
      }
    }
  }
  return none42();
});
var insertAt2 = /* @__PURE__ */ dual222(3, (self2, i222, b222) => {
  const out = Array.from(self2);
  if (i222 < 0 || i222 > out.length) {
    return none42();
  }
  out.splice(i222, 0, b222);
  return some62(out);
});
var replace22 = /* @__PURE__ */ dual222(3, (self2, i222, b222) => modify2(self2, i222, () => b222));
var replaceOption2 = /* @__PURE__ */ dual222(3, (self2, i222, b222) => modifyOption2(self2, i222, () => b222));
var modify2 = /* @__PURE__ */ dual222(3, (self2, i222, f222) => getOrElse222(modifyOption2(self2, i222, f222), () => Array.from(self2)));
var modifyOption2 = /* @__PURE__ */ dual222(3, (self2, i222, f222) => {
  const out = Array.from(self2);
  if (isOutOfBound2(i222, out)) {
    return none42();
  }
  const next = f222(out[i222]);
  out[i222] = next;
  return some62(out);
});
var remove2 = /* @__PURE__ */ dual222(2, (self2, i222) => {
  const out = Array.from(self2);
  if (isOutOfBound2(i222, out)) {
    return out;
  }
  out.splice(i222, 1);
  return out;
});
var reverse322 = (self2) => Array.from(self2).reverse();
var sort2 = /* @__PURE__ */ dual222(2, (self2, O222) => {
  const out = Array.from(self2);
  out.sort(O222);
  return out;
});
var sortWith2 = /* @__PURE__ */ dual222(3, (self2, f222, order) => sort2(self2, mapInput32(order, f222)));
var sortBy2 = (...orders) => {
  const sortByAll = sort2(combineAll2(orders));
  return (self2) => {
    const input = fromIterable42(self2);
    if (isNonEmptyReadonlyArray2(input)) {
      return sortByAll(input);
    }
    return [];
  };
};
var zip2 = /* @__PURE__ */ dual222(2, (self2, that) => zipWith32(self2, that, make92));
var zipWith32 = /* @__PURE__ */ dual222(3, (self2, that, f222) => {
  const as422 = fromIterable42(self2);
  const bs = fromIterable42(that);
  if (isNonEmptyReadonlyArray2(as422) && isNonEmptyReadonlyArray2(bs)) {
    const out = [f222(headNonEmpty222(as422), headNonEmpty222(bs))];
    const len = Math.min(as422.length, bs.length);
    for (let i222 = 1; i222 < len; i222++) {
      out[i222] = f222(as422[i222], bs[i222]);
    }
    return out;
  }
  return [];
});
var unzip2 = (self2) => {
  const input = fromIterable42(self2);
  if (isNonEmptyReadonlyArray2(input)) {
    const fa = [input[0][0]];
    const fb = [input[0][1]];
    for (let i222 = 1; i222 < input.length; i222++) {
      fa[i222] = input[i222][0];
      fb[i222] = input[i222][1];
    }
    return [fa, fb];
  }
  return [[], []];
};
var intersperse2 = /* @__PURE__ */ dual222(2, (self2, middle) => {
  const input = fromIterable42(self2);
  if (isNonEmptyReadonlyArray2(input)) {
    const out = [headNonEmpty222(input)];
    const tail222 = tailNonEmpty222(input);
    for (let i222 = 0; i222 < tail222.length; i222++) {
      if (i222 < tail222.length) {
        out.push(middle);
      }
      out.push(tail222[i222]);
    }
    return out;
  }
  return [];
});
var modifyNonEmptyHead2 = /* @__PURE__ */ dual222(2, (self2, f222) => [f222(headNonEmpty222(self2)), ...tailNonEmpty222(self2)]);
var setNonEmptyHead2 = /* @__PURE__ */ dual222(2, (self2, b222) => modifyNonEmptyHead2(self2, () => b222));
var modifyNonEmptyLast2 = /* @__PURE__ */ dual222(2, (self2, f222) => append2(initNonEmpty2(self2), f222(lastNonEmpty2(self2))));
var setNonEmptyLast2 = /* @__PURE__ */ dual222(2, (self2, b222) => modifyNonEmptyLast2(self2, () => b222));
var rotate2 = /* @__PURE__ */ dual222(2, (self2, n222) => {
  const input = fromIterable42(self2);
  if (isNonEmptyReadonlyArray2(input)) {
    const len = input.length;
    const m222 = Math.round(n222) % len;
    if (isOutOfBound2(Math.abs(m222), input) || m222 === 0) {
      return copy222(input);
    }
    if (m222 < 0) {
      const [f222, s222] = splitNonEmptyAt2(input, -m222);
      return appendAll222(s222, f222);
    } else {
      return rotate2(self2, m222 - len);
    }
  }
  return [];
});
var containsWith32 = (isEquivalent) => dual222(2, (self2, a222) => {
  for (const i222 of self2) {
    if (isEquivalent(a222, i222)) {
      return true;
    }
  }
  return false;
});
var _equivalence42 = /* @__PURE__ */ equivalence222();
var contains32 = /* @__PURE__ */ containsWith32(_equivalence42);
var chop2 = /* @__PURE__ */ dual222(2, (self2, f222) => {
  const input = fromIterable42(self2);
  if (isNonEmptyReadonlyArray2(input)) {
    const [b222, rest] = f222(input);
    const out = [b222];
    let next = rest;
    while (isNonEmptyArray3(next)) {
      const [b32, rest2] = f222(next);
      out.push(b32);
      next = rest2;
    }
    return out;
  }
  return [];
});
var splitAt2 = /* @__PURE__ */ dual222(2, (self2, n222) => {
  const input = Array.from(self2);
  const _n = Math.floor(n222);
  if (isNonEmptyReadonlyArray2(input)) {
    if (_n >= 1) {
      return splitNonEmptyAt2(input, _n);
    }
    return [[], input];
  }
  return [input, []];
});
var splitNonEmptyAt2 = /* @__PURE__ */ dual222(2, (self2, n222) => {
  const _n = Math.max(1, Math.floor(n222));
  return _n >= self2.length ? [copy222(self2), []] : [prepend222(self2.slice(1, _n), headNonEmpty222(self2)), self2.slice(_n)];
});
var split2 = /* @__PURE__ */ dual222(2, (self2, n222) => {
  const input = fromIterable42(self2);
  return chunksOf2(input, Math.ceil(input.length / Math.floor(n222)));
});
var splitWhere2 = /* @__PURE__ */ dual222(2, (self2, predicate) => span2(self2, (a222, i222) => !predicate(a222, i222)));
var copy222 = (self2) => self2.slice();
var chunksOf2 = /* @__PURE__ */ dual222(2, (self2, n222) => {
  const input = fromIterable42(self2);
  if (isNonEmptyReadonlyArray2(input)) {
    return chop2(input, splitNonEmptyAt2(n222));
  }
  return [];
});
var groupWith2 = /* @__PURE__ */ dual222(2, (self2, isEquivalent) => chop2(self2, (as422) => {
  const h222 = headNonEmpty222(as422);
  const out = [h222];
  let i222 = 1;
  for (; i222 < as422.length; i222++) {
    const a222 = as422[i222];
    if (isEquivalent(a222, h222)) {
      out.push(a222);
    } else {
      break;
    }
  }
  return [out, as422.slice(i222)];
}));
var group2 = /* @__PURE__ */ groupWith2(/* @__PURE__ */ equivalence222());
var groupBy2 = /* @__PURE__ */ dual222(2, (self2, f222) => {
  const out = {};
  for (const a222 of self2) {
    const k222 = f222(a222);
    if (Object.prototype.hasOwnProperty.call(out, k222)) {
      out[k222].push(a222);
    } else {
      out[k222] = [a222];
    }
  }
  return out;
});
var unionWith2 = /* @__PURE__ */ dual222(3, (self2, that, isEquivalent) => {
  const a222 = fromIterable42(self2);
  const b222 = fromIterable42(that);
  if (isNonEmptyReadonlyArray2(a222)) {
    if (isNonEmptyReadonlyArray2(b222)) {
      const dedupe22 = dedupeWith2(isEquivalent);
      return dedupe22(appendAll222(a222, b222));
    }
    return a222;
  }
  return b222;
});
var union4 = /* @__PURE__ */ dual222(2, (self2, that) => unionWith2(self2, that, _equivalence42));
var intersectionWith2 = (isEquivalent) => {
  const has22 = containsWith32(isEquivalent);
  return dual222(2, (self2, that) => fromIterable42(self2).filter((a222) => has22(that, a222)));
};
var intersection2 = /* @__PURE__ */ intersectionWith2(_equivalence42);
var differenceWith2 = (isEquivalent) => {
  const has22 = containsWith32(isEquivalent);
  return dual222(2, (self2, that) => fromIterable42(self2).filter((a222) => !has22(that, a222)));
};
var difference2 = /* @__PURE__ */ differenceWith2(_equivalence42);
var empty92 = () => [];
var of222 = (a222) => [a222];
var map32 = /* @__PURE__ */ dual222(2, (self2, f222) => self2.map(f222));
var flatMap32 = /* @__PURE__ */ dual222(2, (self2, f222) => {
  if (isEmptyReadonlyArray2(self2)) {
    return [];
  }
  const out = [];
  for (let i222 = 0; i222 < self2.length; i222++) {
    const inner = f222(self2[i222], i222);
    for (let j222 = 0; j222 < inner.length; j222++) {
      out.push(inner[j222]);
    }
  }
  return out;
});
var flatten32 = /* @__PURE__ */ flatMap32(identity222);
var filterMap32 = /* @__PURE__ */ dual222(2, (self2, f222) => {
  const as422 = fromIterable42(self2);
  const out = [];
  for (let i222 = 0; i222 < as422.length; i222++) {
    const o222 = f222(as422[i222], i222);
    if (isSome42(o222)) {
      out.push(o222.value);
    }
  }
  return out;
});
var filterMapWhile2 = /* @__PURE__ */ dual222(2, (self2, f222) => {
  let i222 = 0;
  const out = [];
  for (const a222 of self2) {
    const b222 = f222(a222, i222);
    if (isSome42(b222)) {
      out.push(b222.value);
    } else {
      break;
    }
    i222++;
  }
  return out;
});
var partitionMap32 = /* @__PURE__ */ dual222(2, (self2, f222) => {
  const left522 = [];
  const right522 = [];
  const as422 = fromIterable42(self2);
  for (let i222 = 0; i222 < as422.length; i222++) {
    const e222 = f222(as422[i222], i222);
    if (isLeft32(e222)) {
      left522.push(e222.left);
    } else {
      right522.push(e222.right);
    }
  }
  return [left522, right522];
});
var getSomes2 = /* @__PURE__ */ filterMap32(identity222);
var getLefts2 = (self2) => {
  const out = [];
  for (const a222 of self2) {
    if (isLeft32(a222)) {
      out.push(a222.left);
    }
  }
  return out;
};
var getRights2 = (self2) => {
  const out = [];
  for (const a222 of self2) {
    if (isRight32(a222)) {
      out.push(a222.right);
    }
  }
  return out;
};
var filter32 = /* @__PURE__ */ dual222(2, (self2, predicate) => {
  const as422 = fromIterable42(self2);
  const out = [];
  for (let i222 = 0; i222 < as422.length; i222++) {
    if (predicate(as422[i222], i222)) {
      out.push(as422[i222]);
    }
  }
  return out;
});
var partition2 = /* @__PURE__ */ dual222(2, (self2, predicate) => {
  const left522 = [];
  const right522 = [];
  const as422 = fromIterable42(self2);
  for (let i222 = 0; i222 < as422.length; i222++) {
    if (predicate(as422[i222], i222)) {
      right522.push(as422[i222]);
    } else {
      left522.push(as422[i222]);
    }
  }
  return [left522, right522];
});
var separate2 = /* @__PURE__ */ partitionMap32(identity222);
var reduce322 = /* @__PURE__ */ dual222(3, (self2, b222, f222) => fromIterable42(self2).reduce((b32, a222, i222) => f222(b32, a222, i222), b222));
var reduceRight2 = /* @__PURE__ */ dual222(3, (self2, b222, f222) => fromIterable42(self2).reduceRight((b32, a222, i222) => f222(b32, a222, i222), b222));
var liftPredicate32 = (predicate) => (b222) => predicate(b222) ? [b222] : [];
var liftOption2 = (f222) => (...a222) => fromOption22(f222(...a222));
var fromNullable32 = (a222) => a222 == null ? empty92() : [a222];
var liftNullable32 = (f222) => (...a222) => fromNullable32(f222(...a222));
var flatMapNullable32 = /* @__PURE__ */ dual222(2, (self2, f222) => flatMap32(self2, (a222) => fromNullable32(f222(a222))));
var liftEither2 = (f222) => (...a222) => {
  const e222 = f222(...a222);
  return isLeft32(e222) ? [] : [e222.right];
};
var every32 = /* @__PURE__ */ dual222(2, (self2, refinement) => self2.every(refinement));
var some72 = /* @__PURE__ */ dual222(2, (self2, predicate) => self2.some(predicate));
var extend2 = /* @__PURE__ */ dual222(2, (self2, f222) => self2.map((_222, i222, as422) => f222(as422.slice(i222))));
var min22 = /* @__PURE__ */ dual222(2, (self2, O222) => self2.reduce(min3(O222)));
var max22 = /* @__PURE__ */ dual222(2, (self2, O222) => self2.reduce(max3(O222)));
var unfold2 = (b222, f222) => {
  const out = [];
  let next = b222;
  let o222;
  while (isSome42(o222 = f222(next))) {
    const [a222, b32] = o222.value;
    out.push(a222);
    next = b32;
  }
  return out;
};
var getOrder32 = array42;
var getEquivalence42 = array322;
var forEach322 = /* @__PURE__ */ dual222(2, (self2, f222) => fromIterable42(self2).forEach((a222, i222) => f222(a222, i222)));
var dedupeWith2 = /* @__PURE__ */ dual222(2, (self2, isEquivalent) => {
  const input = fromIterable42(self2);
  if (isNonEmptyReadonlyArray2(input)) {
    const out = [headNonEmpty222(input)];
    const rest = tailNonEmpty222(input);
    for (const r222 of rest) {
      if (out.every((a222) => !isEquivalent(r222, a222))) {
        out.push(r222);
      }
    }
    return out;
  }
  return [];
});
var dedupe2 = (self2) => dedupeWith2(self2, equivalence222());
var dedupeAdjacentWith2 = /* @__PURE__ */ dual222(2, (self2, isEquivalent) => {
  const out = [];
  let lastA = none42();
  for (const a222 of self2) {
    if (isNone42(lastA) || !isEquivalent(a222, lastA.value)) {
      out.push(a222);
      lastA = some62(a222);
    }
  }
  return out;
});
var dedupeAdjacent2 = /* @__PURE__ */ dedupeAdjacentWith2(/* @__PURE__ */ equivalence222());
var join2 = /* @__PURE__ */ dual222(2, (self2, sep) => fromIterable42(self2).join(sep));
var mapAccum2 = /* @__PURE__ */ dual222(3, (self2, s222, f222) => {
  let i222 = 0;
  let s1 = s222;
  const out = [];
  for (const a222 of self2) {
    const r222 = f222(s1, a222, i222);
    s1 = r222[0];
    out.push(r222[1]);
    i222++;
  }
  return [s1, out];
});
var cartesianWith2 = /* @__PURE__ */ dual222(3, (self2, that, f222) => flatMap32(self2, (a222) => map32(that, (b222) => f222(a222, b222))));
var cartesian2 = /* @__PURE__ */ dual222(2, (self2, that) => cartesianWith2(self2, that, (a222, b222) => [a222, b222]));
var Do32 = /* @__PURE__ */ of222({});
var bind52 = /* @__PURE__ */ bind322(map32, flatMap32);
var bindTo52 = /* @__PURE__ */ bindTo322(map32);
var let_52 = /* @__PURE__ */ let_322(map32);
var __defProp322 = Object.defineProperty;
var __export322 = (target, all3222) => {
  for (var name2 in all3222)
    __defProp322(target, name2, { get: all3222[name2], enumerable: true });
};
var Function_exports32 = {};
__export322(Function_exports32, {
  SK: () => SK32,
  absurd: () => absurd32,
  apply: () => apply32,
  compose: () => compose52,
  constFalse: () => constFalse32,
  constNull: () => constNull32,
  constTrue: () => constTrue32,
  constUndefined: () => constUndefined32,
  constVoid: () => constVoid32,
  constant: () => constant32,
  dual: () => dual32,
  flip: () => flip32,
  flow: () => flow32,
  hole: () => hole32,
  identity: () => identity32,
  isFunction: () => isFunction62,
  pipe: () => pipe32,
  satisfies: () => satisfies32,
  tupled: () => tupled32,
  unsafeCoerce: () => unsafeCoerce32,
  untupled: () => untupled32
});
var isFunction62 = (input) => typeof input === "function";
var dual32 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a222, b222) {
        if (arguments.length >= 2) {
          return body(a222, b222);
        }
        return function(self2) {
          return body(self2, a222);
        };
      };
    case 3:
      return function(a222, b222, c222) {
        if (arguments.length >= 3) {
          return body(a222, b222, c222);
        }
        return function(self2) {
          return body(self2, a222, b222);
        };
      };
    case 4:
      return function(a222, b222, c222, d222) {
        if (arguments.length >= 4) {
          return body(a222, b222, c222, d222);
        }
        return function(self2) {
          return body(self2, a222, b222, c222);
        };
      };
    case 5:
      return function(a222, b222, c222, d222, e222) {
        if (arguments.length >= 5) {
          return body(a222, b222, c222, d222, e222);
        }
        return function(self2) {
          return body(self2, a222, b222, c222, d222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply32 = (a222) => (self2) => self2(a222);
var identity32 = (a222) => a222;
var satisfies32 = () => (b222) => b222;
var unsafeCoerce32 = identity32;
var constant32 = (value) => () => value;
var constTrue32 = /* @__PURE__ */ constant32(true);
var constFalse32 = /* @__PURE__ */ constant32(false);
var constNull32 = /* @__PURE__ */ constant32(null);
var constUndefined32 = /* @__PURE__ */ constant32(void 0);
var constVoid32 = constUndefined32;
var flip32 = (f222) => (...b222) => (...a222) => f222(...a222)(...b222);
var compose52 = /* @__PURE__ */ dual32(2, (ab, bc) => (a222) => bc(ab(a222)));
var absurd32 = (_222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled32 = (f222) => (a222) => f222(...a222);
var untupled32 = (f222) => (...a222) => f222(a222);
function pipe32(a222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a222;
    case 2:
      return ab(a222);
    case 3:
      return bc(ab(a222));
    case 4:
      return cd(bc(ab(a222)));
    case 5:
      return de(cd(bc(ab(a222))));
    case 6:
      return ef(de(cd(bc(ab(a222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a222))))))));
    default: {
      let ret = arguments[0];
      for (let i222 = 1; i222 < arguments.length; i222++) {
        ret = arguments[i222](ret);
      }
      return ret;
    }
  }
}
function flow32(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole32 = /* @__PURE__ */ unsafeCoerce32(absurd32);
var SK32 = (_222, b222) => b222;
var make112 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_62 = (map322) => dual32(3, (self2, name2, f222) => map322(self2, (a222) => Object.assign({}, a222, {
  [name2]: f222(a222)
})));
var bindTo62 = (map322) => dual32(2, (self2, name2) => map322(self2, (a222) => ({
  [name2]: a222
})));
var bind62 = (map322, flatMap322) => dual32(3, (self2, name2, f222) => flatMap322(self2, (a222) => map322(f222(a222), (b222) => Object.assign({}, a222, {
  [name2]: b222
}))));
var moduleVersion32 = "3.2.8";
var getCurrentVersion32 = () => moduleVersion32;
var globalStoreId32 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion32()}`);
if (!(globalStoreId32 in globalThis)) {
  globalThis[globalStoreId32] = /* @__PURE__ */ new Map();
}
var globalStore32 = globalThis[globalStoreId32];
var globalValue32 = (id, compute) => {
  if (!globalStore32.has(id)) {
    globalStore32.set(id, compute());
  }
  return globalStore32.get(id);
};
var isFunction2222 = isFunction62;
var isRecordOrArray32 = (input) => typeof input === "object" && input !== null;
var isObject32 = (input) => isRecordOrArray32(input) || isFunction2222(input);
var hasProperty32 = /* @__PURE__ */ dual32(2, (self2, property) => isObject32(self2) && property in self2);
var isNullable32 = (input) => input === null || input === void 0;
var getBugErrorMessage32 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId32 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind32 = (u222) => isObject32(u222) && GenKindTypeId32 in u222;
var GenKindImpl32 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity32;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_222) => _222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_222) => _222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_222) => _222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId32] = GenKindTypeId32;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen42(this);
  }
};
var SingleShotGen42 = class _SingleShotGen322 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a222) {
    return this.called ? {
      value: a222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a222) {
    return {
      value: a222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e222) {
    throw e222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen322(this.self);
  }
};
var adapter52 = () => function() {
  let x222 = arguments[0];
  for (let i222 = 1; i222 < arguments.length; i222++) {
    x222 = arguments[i222](x222);
  }
  return new GenKindImpl32(x222);
};
var defaultIncHi32 = 335903614;
var defaultIncLo32 = 4150755663;
var MUL_HI32 = 1481765933 >>> 0;
var MUL_LO32 = 1284865837 >>> 0;
var BIT_5332 = 9007199254740992;
var BIT_2732 = 134217728;
var PCGRandom32 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable32(seedLo) && isNullable32(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable32(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable32(incLo) && isNullable32(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo32;
      incHi = this._state ? this._state[2] : defaultIncHi32;
    } else if (isNullable32(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6432(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max32) {
    if (!max32) {
      return this._next();
    }
    max32 = max32 >>> 0;
    if ((max32 & max32 - 1) === 0) {
      return this._next() & max32 - 1;
    }
    let num = 0;
    const skew = (-max32 >>> 0) % max32 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max32;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2732 + lo) / BIT_5332;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6432(this._state, oldHi, oldLo, MUL_HI32, MUL_LO32);
    add6432(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6432(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6432(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId32 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap32 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId32]() {
    return this.#value;
  }
};
function yieldWrapGet32(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId32 in self2) {
    return self2[YieldWrapTypeId32]();
  }
  throw new Error(getBugErrorMessage32("yieldWrapGet"));
}
var structuralRegionState32 = /* @__PURE__ */ globalValue32("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache32 = /* @__PURE__ */ globalValue32(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr32 = /* @__PURE__ */ globalValue32(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom32());
var symbol52 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash32 = (self2) => {
  if (structuralRegionState32.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number42(self2);
    case "bigint":
      return string32(self2.toString(10));
    case "boolean":
      return string32(String(self2));
    case "symbol":
      return string32(String(self2));
    case "string":
      return string32(self2);
    case "undefined":
      return string32("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string32("null");
      } else if (self2 instanceof Date) {
        return hash32(self2.toISOString());
      } else if (isHash32(self2)) {
        return self2[symbol52]();
      } else {
        return random32(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random32 = (self2) => {
  if (!randomHashCache32.has(self2)) {
    randomHashCache32.set(self2, number42(pcgr32.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache32.get(self2);
};
var combine42 = (b222) => (self2) => self2 * 53 ^ b222;
var optimize32 = (n222) => n222 & 3221225471 | n222 >>> 1 & 1073741824;
var isHash32 = (u222) => hasProperty32(u222, symbol52);
var number42 = (n222) => {
  if (n222 !== n222 || n222 === Infinity) {
    return 0;
  }
  let h222 = n222 | 0;
  if (h222 !== n222) {
    h222 ^= n222 * 4294967295;
  }
  while (n222 > 4294967295) {
    h222 ^= n222 /= 4294967295;
  }
  return optimize32(n222);
};
var string32 = (str) => {
  let h222 = 5381, i222 = str.length;
  while (i222) {
    h222 = h222 * 33 ^ str.charCodeAt(--i222);
  }
  return optimize32(h222);
};
var cached32 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash422) {
      Object.defineProperty(self3, symbol52, {
        value() {
          return hash422;
        },
        enumerable: false
      });
      return hash422;
    };
  }
  const self2 = arguments[0];
  const hash322 = arguments[1];
  Object.defineProperty(self2, symbol52, {
    value() {
      return hash322;
    },
    enumerable: false
  });
  return hash322;
};
var symbol2222 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals32() {
  if (arguments.length === 1) {
    return (self2) => compareBoth32(self2, arguments[0]);
  }
  return compareBoth32(arguments[0], arguments[1]);
}
function compareBoth32(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual32(self2) && isEqual32(that)) {
        if (hash32(self2) === hash32(that) && self2[symbol2222](that)) {
          return true;
        } else {
          return structuralRegionState32.enabled && structuralRegionState32.tester ? structuralRegionState32.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState32.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v222, i222) => compareBoth32(v222, that[i222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth32(self2[key], that[key]))) {
              return structuralRegionState32.tester ? structuralRegionState32.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState32.tester ? structuralRegionState32.tester(self2, that) : false;
    }
  }
  return structuralRegionState32.enabled && structuralRegionState32.tester ? structuralRegionState32.tester(self2, that) : false;
}
var isEqual32 = (u222) => hasProperty32(u222, symbol2222);
var equivalence32 = () => equals32;
var NodeInspectSymbol32 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON32 = (x222) => {
  if (hasProperty32(x222, "toJSON") && isFunction2222(x222["toJSON"]) && x222["toJSON"].length === 0) {
    return x222.toJSON();
  } else if (Array.isArray(x222)) {
    return x222.map(toJSON32);
  }
  return x222;
};
var format32 = (x222) => JSON.stringify(x222, null, 2);
var pipeArguments32 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i222 = 0, len = args.length; i222 < len; i222++) {
        ret = args[i222](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId42 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId32 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId32 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId32 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance32 = {
  /* c8 ignore next */
  _R: (_222) => _222,
  /* c8 ignore next */
  _E: (_222) => _222,
  /* c8 ignore next */
  _A: (_222) => _222,
  _V: /* @__PURE__ */ getCurrentVersion32()
};
var sinkVariance32 = {
  /* c8 ignore next */
  _A: (_222) => _222,
  /* c8 ignore next */
  _In: (_222) => _222,
  /* c8 ignore next */
  _L: (_222) => _222,
  /* c8 ignore next */
  _E: (_222) => _222,
  /* c8 ignore next */
  _R: (_222) => _222
};
var channelVariance32 = {
  /* c8 ignore next */
  _Env: (_222) => _222,
  /* c8 ignore next */
  _InErr: (_222) => _222,
  /* c8 ignore next */
  _InElem: (_222) => _222,
  /* c8 ignore next */
  _InDone: (_222) => _222,
  /* c8 ignore next */
  _OutErr: (_222) => _222,
  /* c8 ignore next */
  _OutElem: (_222) => _222,
  /* c8 ignore next */
  _OutDone: (_222) => _222
};
var EffectPrototype32 = {
  [EffectTypeId42]: effectVariance32,
  [StreamTypeId32]: effectVariance32,
  [SinkTypeId32]: sinkVariance32,
  [ChannelTypeId32]: channelVariance32,
  [symbol2222](that) {
    return this === that;
  },
  [symbol52]() {
    return cached32(this, random32(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen42(new YieldWrap32(this));
  },
  pipe() {
    return pipeArguments32(this, arguments);
  }
};
var TypeId92 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto52 = {
  ...EffectPrototype32,
  [TypeId92]: {
    _A: (_222) => _222
  },
  [NodeInspectSymbol32]() {
    return this.toJSON();
  },
  toString() {
    return format32(this.toJSON());
  }
};
var SomeProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto52), {
  _tag: "Some",
  _op: "Some",
  [symbol2222](that) {
    return isOption52(that) && isSome52(that) && equals32(this.value, that.value);
  },
  [symbol52]() {
    return cached32(this, combine42(hash32(this._tag))(hash32(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON32(this.value)
    };
  }
});
var NoneHash32 = /* @__PURE__ */ hash32("None");
var NoneProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto52), {
  _tag: "None",
  _op: "None",
  [symbol2222](that) {
    return isOption52(that) && isNone52(that);
  },
  [symbol52]() {
    return NoneHash32;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption52 = (input) => hasProperty32(input, TypeId92);
var isNone52 = (fa) => fa._tag === "None";
var isSome52 = (fa) => fa._tag === "Some";
var none52 = /* @__PURE__ */ Object.create(NoneProto32);
var some82 = (value) => {
  const a222 = Object.create(SomeProto32);
  a222.value = value;
  return a222;
};
var TypeId2222 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto2222 = {
  ...EffectPrototype32,
  [TypeId2222]: {
    _R: (_222) => _222
  },
  [NodeInspectSymbol32]() {
    return this.toJSON();
  },
  toString() {
    return format32(this.toJSON());
  }
};
var RightProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2222), {
  _tag: "Right",
  _op: "Right",
  [symbol2222](that) {
    return isEither32(that) && isRight42(that) && equals32(this.right, that.right);
  },
  [symbol52]() {
    return combine42(hash32(this._tag))(hash32(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON32(this.right)
    };
  }
});
var LeftProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2222), {
  _tag: "Left",
  _op: "Left",
  [symbol2222](that) {
    return isEither32(that) && isLeft42(that) && equals32(this.left, that.left);
  },
  [symbol52]() {
    return combine42(hash32(this._tag))(hash32(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON32(this.left)
    };
  }
});
var isEither32 = (input) => hasProperty32(input, TypeId2222);
var isLeft42 = (ma) => ma._tag === "Left";
var isRight42 = (ma) => ma._tag === "Right";
var left42 = (left3222) => {
  const a222 = Object.create(LeftProto32);
  a222.left = left3222;
  return a222;
};
var right42 = (right3222) => {
  const a222 = Object.create(RightProto32);
  a222.right = right3222;
  return a222;
};
var getLeft52 = (self2) => isRight42(self2) ? none52 : some82(self2.left);
var getRight52 = (self2) => isLeft42(self2) ? none52 : some82(self2.right);
var Option_exports32 = {};
__export322(Option_exports32, {
  Do: () => Do42,
  TypeId: () => TypeId3222,
  all: () => all52,
  andThen: () => andThen32,
  ap: () => ap32,
  as: () => as32,
  asVoid: () => asVoid32,
  bind: () => bind2222,
  bindTo: () => bindTo2222,
  composeK: () => composeK32,
  contains: () => contains42,
  containsWith: () => containsWith42,
  exists: () => exists32,
  filter: () => filter42,
  filterMap: () => filterMap42,
  firstSomeOf: () => firstSomeOf32,
  flatMap: () => flatMap42,
  flatMapNullable: () => flatMapNullable42,
  flatten: () => flatten42,
  fromIterable: () => fromIterable52,
  fromNullable: () => fromNullable42,
  gen: () => gen32,
  getEquivalence: () => getEquivalence52,
  getLeft: () => getLeft2222,
  getOrElse: () => getOrElse32,
  getOrNull: () => getOrNull32,
  getOrThrow: () => getOrThrow32,
  getOrThrowWith: () => getOrThrowWith32,
  getOrUndefined: () => getOrUndefined32,
  getOrder: () => getOrder42,
  getRight: () => getRight2222,
  isNone: () => isNone2222,
  isOption: () => isOption2222,
  isSome: () => isSome2222,
  let: () => let_2222,
  lift2: () => lift232,
  liftNullable: () => liftNullable42,
  liftPredicate: () => liftPredicate42,
  liftThrowable: () => liftThrowable32,
  map: () => map42,
  match: () => match52,
  none: () => none2222,
  orElse: () => orElse32,
  orElseEither: () => orElseEither32,
  orElseSome: () => orElseSome32,
  partitionMap: () => partitionMap42,
  product: () => product52,
  productMany: () => productMany52,
  reduceCompact: () => reduceCompact32,
  some: () => some2222,
  tap: () => tap32,
  toArray: () => toArray32,
  toRefinement: () => toRefinement32,
  void: () => void_32,
  zipLeft: () => zipLeft32,
  zipRight: () => zipRight32,
  zipWith: () => zipWith42
});
var make2222 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId3222 = /* @__PURE__ */ Symbol.for("effect/Option");
var none2222 = () => none52;
var some2222 = some82;
var isOption2222 = isOption52;
var isNone2222 = isNone52;
var isSome2222 = isSome52;
var match52 = /* @__PURE__ */ dual32(2, (self2, {
  onNone,
  onSome
}) => isNone2222(self2) ? onNone() : onSome(self2.value));
var toRefinement32 = (f222) => (a222) => isSome2222(f222(a222));
var fromIterable52 = (collection) => {
  for (const a222 of collection) {
    return some2222(a222);
  }
  return none2222();
};
var getRight2222 = getRight52;
var getLeft2222 = getLeft52;
var getOrElse32 = /* @__PURE__ */ dual32(2, (self2, onNone) => isNone2222(self2) ? onNone() : self2.value);
var orElse32 = /* @__PURE__ */ dual32(2, (self2, that) => isNone2222(self2) ? that() : self2);
var orElseSome32 = /* @__PURE__ */ dual32(2, (self2, onNone) => isNone2222(self2) ? some2222(onNone()) : self2);
var orElseEither32 = /* @__PURE__ */ dual32(2, (self2, that) => isNone2222(self2) ? map42(that(), right42) : map42(self2, left42));
var firstSomeOf32 = (collection) => {
  let out = none2222();
  for (out of collection) {
    if (isSome2222(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable42 = (nullableValue) => nullableValue == null ? none2222() : some2222(nullableValue);
var liftNullable42 = (f222) => (...a222) => fromNullable42(f222(...a222));
var getOrNull32 = /* @__PURE__ */ getOrElse32(constNull32);
var getOrUndefined32 = /* @__PURE__ */ getOrElse32(constUndefined32);
var liftThrowable32 = (f222) => (...a222) => {
  try {
    return some2222(f222(...a222));
  } catch (e222) {
    return none2222();
  }
};
var getOrThrowWith32 = /* @__PURE__ */ dual32(2, (self2, onNone) => {
  if (isSome2222(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow32 = /* @__PURE__ */ getOrThrowWith32(() => new Error("getOrThrow called on a None"));
var map42 = /* @__PURE__ */ dual32(2, (self2, f222) => isNone2222(self2) ? none2222() : some2222(f222(self2.value)));
var as32 = /* @__PURE__ */ dual32(2, (self2, b222) => map42(self2, () => b222));
var asVoid32 = /* @__PURE__ */ as32(void 0);
var void_32 = /* @__PURE__ */ some2222(void 0);
var flatMap42 = /* @__PURE__ */ dual32(2, (self2, f222) => isNone2222(self2) ? none2222() : f222(self2.value));
var andThen32 = /* @__PURE__ */ dual32(2, (self2, f222) => flatMap42(self2, (a222) => {
  const b222 = isFunction62(f222) ? f222(a222) : f222;
  return isOption2222(b222) ? b222 : some2222(b222);
}));
var flatMapNullable42 = /* @__PURE__ */ dual32(2, (self2, f222) => isNone2222(self2) ? none2222() : fromNullable42(f222(self2.value)));
var flatten42 = /* @__PURE__ */ flatMap42(identity32);
var zipRight32 = /* @__PURE__ */ dual32(2, (self2, that) => flatMap42(self2, () => that));
var composeK32 = /* @__PURE__ */ dual32(2, (afb, bfc) => (a222) => flatMap42(afb(a222), bfc));
var zipLeft32 = /* @__PURE__ */ dual32(2, (self2, that) => tap32(self2, () => that));
var tap32 = /* @__PURE__ */ dual32(2, (self2, f222) => flatMap42(self2, (a222) => map42(f222(a222), () => a222)));
var product52 = (self2, that) => isSome2222(self2) && isSome2222(that) ? some2222([self2.value, that.value]) : none2222();
var productMany52 = (self2, collection) => {
  if (isNone2222(self2)) {
    return none2222();
  }
  const out = [self2.value];
  for (const o222 of collection) {
    if (isNone2222(o222)) {
      return none2222();
    }
    out.push(o222.value);
  }
  return some2222(out);
};
var all52 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o222 of input) {
      if (isNone2222(o222)) {
        return none2222();
      }
      out2.push(o222.value);
    }
    return some2222(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o222 = input[key];
    if (isNone2222(o222)) {
      return none2222();
    }
    out[key] = o222.value;
  }
  return some2222(out);
};
var zipWith42 = /* @__PURE__ */ dual32(3, (self2, that, f222) => map42(product52(self2, that), ([a222, b222]) => f222(a222, b222)));
var ap32 = /* @__PURE__ */ dual32(2, (self2, that) => zipWith42(self2, that, (f222, a222) => f222(a222)));
var reduceCompact32 = /* @__PURE__ */ dual32(3, (self2, b222, f222) => {
  let out = b222;
  for (const oa of self2) {
    if (isSome2222(oa)) {
      out = f222(out, oa.value);
    }
  }
  return out;
});
var toArray32 = (self2) => isNone2222(self2) ? [] : [self2.value];
var partitionMap42 = /* @__PURE__ */ dual32(2, (self2, f222) => {
  if (isNone2222(self2)) {
    return [none2222(), none2222()];
  }
  const e222 = f222(self2.value);
  return isLeft42(e222) ? [some2222(e222.left), none2222()] : [none2222(), some2222(e222.right)];
});
var filterMap42 = /* @__PURE__ */ dual32(2, (self2, f222) => isNone2222(self2) ? none2222() : f222(self2.value));
var filter42 = /* @__PURE__ */ dual32(2, (self2, predicate) => filterMap42(self2, (b222) => predicate(b222) ? some82(b222) : none52));
var getEquivalence52 = (isEquivalent) => make112((x222, y222) => x222 === y222 || (isNone2222(x222) ? isNone2222(y222) : isNone2222(y222) ? false : isEquivalent(x222.value, y222.value)));
var getOrder42 = (O222) => make2222((self2, that) => isSome2222(self2) ? isSome2222(that) ? O222(self2.value, that.value) : 1 : -1);
var lift232 = (f222) => dual32(2, (self2, that) => zipWith42(self2, that, f222));
var liftPredicate42 = (predicate) => (b222) => predicate(b222) ? some2222(b222) : none2222();
var containsWith42 = (isEquivalent) => dual32(2, (self2, a222) => isNone2222(self2) ? false : isEquivalent(self2.value, a222));
var _equivalence52 = /* @__PURE__ */ equivalence32();
var contains42 = /* @__PURE__ */ containsWith42(_equivalence52);
var exists32 = /* @__PURE__ */ dual32(2, (self2, refinement) => isNone2222(self2) ? false : refinement(self2.value));
var bindTo2222 = /* @__PURE__ */ bindTo62(map42);
var let_2222 = /* @__PURE__ */ let_62(map42);
var bind2222 = /* @__PURE__ */ bind62(map42, flatMap42);
var Do42 = /* @__PURE__ */ some2222({});
var adapter2222 = /* @__PURE__ */ adapter52();
var gen32 = (f222) => {
  const iterator = f222(adapter2222);
  let state = iterator.next();
  if (state.done) {
    return some2222(state.value);
  } else {
    let current = state.value;
    if (isGenKind32(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet32(current);
    }
    if (isNone2222(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind32(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet32(current);
        }
        if (isNone2222(current)) {
          return current;
        }
      }
    }
    return some2222(state.value);
  }
};
var MutableRef_exports22 = {};
__export322(MutableRef_exports22, {
  compareAndSet: () => compareAndSet2,
  decrement: () => decrement2,
  decrementAndGet: () => decrementAndGet2,
  get: () => get22,
  getAndDecrement: () => getAndDecrement2,
  getAndIncrement: () => getAndIncrement2,
  getAndSet: () => getAndSet2,
  getAndUpdate: () => getAndUpdate2,
  increment: () => increment2,
  incrementAndGet: () => incrementAndGet2,
  make: () => make3222,
  set: () => set222,
  setAndGet: () => setAndGet2,
  toggle: () => toggle2,
  update: () => update2,
  updateAndGet: () => updateAndGet2
});
var TypeId4222 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto2 = {
  [TypeId4222]: TypeId4222,
  toString() {
    return format32(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON32(this.current)
    };
  },
  [NodeInspectSymbol32]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments32(this, arguments);
  }
};
var make3222 = (value) => {
  const ref = Object.create(MutableRefProto2);
  ref.current = value;
  return ref;
};
var compareAndSet2 = /* @__PURE__ */ dual32(3, (self2, oldValue, newValue) => {
  if (equals32(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement2 = (self2) => update2(self2, (n222) => n222 - 1);
var decrementAndGet2 = (self2) => updateAndGet2(self2, (n222) => n222 - 1);
var get22 = (self2) => self2.current;
var getAndDecrement2 = (self2) => getAndUpdate2(self2, (n222) => n222 - 1);
var getAndIncrement2 = (self2) => getAndUpdate2(self2, (n222) => n222 + 1);
var getAndSet2 = /* @__PURE__ */ dual32(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate2 = /* @__PURE__ */ dual32(2, (self2, f222) => getAndSet2(self2, f222(get22(self2))));
var increment2 = (self2) => update2(self2, (n222) => n222 + 1);
var incrementAndGet2 = (self2) => updateAndGet2(self2, (n222) => n222 + 1);
var set222 = /* @__PURE__ */ dual32(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet2 = /* @__PURE__ */ dual32(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update2 = /* @__PURE__ */ dual32(2, (self2, f222) => set222(self2, f222(get22(self2))));
var updateAndGet2 = /* @__PURE__ */ dual32(2, (self2, f222) => setAndGet2(self2, f222(get22(self2))));
var toggle2 = (self2) => update2(self2, (_222) => !_222);
function getVariables2(initialScope) {
  const scopeRef = MutableRef_exports22.make(initialScope);
  const variablesRef = MutableRef_exports22.make(MutableRef_exports22.get(scopeRef).variables);
  while (MutableRef_exports22.get(scopeRef).type !== ScopeType.global) {
    MutableRef_exports22.set(scopeRef, MutableRef_exports22.get(scopeRef).upper);
    MutableRef_exports22.update(variablesRef, (variables) => variables.concat(MutableRef_exports22.get(scopeRef).variables));
  }
  return MutableRef_exports22.get(variablesRef).reverse();
}
var findVariable222 = Function_exports32.dual(2, (name2, initialScope) => {
  return Option_exports32.fromNullable(getVariables2(initialScope).find((variable) => variable.name === name2));
});
var t3 = Symbol.for("@ts-pattern/matcher");
var e3 = Symbol.for("@ts-pattern/isVariadic");
var n3 = "@ts-pattern/anonymous-select-key";
var r3 = (t222) => Boolean(t222 && "object" == typeof t222);
var i3 = (e222) => e222 && !!e222[t3];
var o3 = (n222, s222, c222) => {
  if (i3(n222)) {
    const e222 = n222[t3](), { matched: r222, selections: i222 } = e222.match(s222);
    return r222 && i222 && Object.keys(i222).forEach((t222) => c222(t222, i222[t222])), r222;
  }
  if (r3(n222)) {
    if (!r3(s222)) return false;
    if (Array.isArray(n222)) {
      if (!Array.isArray(s222)) return false;
      let t222 = [], r222 = [], a222 = [];
      for (const o222 of n222.keys()) {
        const s32 = n222[o222];
        i3(s32) && s32[e3] ? a222.push(s32) : a222.length ? r222.push(s32) : t222.push(s32);
      }
      if (a222.length) {
        if (a222.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s222.length < t222.length + r222.length) return false;
        const e222 = s222.slice(0, t222.length), n32 = 0 === r222.length ? [] : s222.slice(-r222.length), i222 = s222.slice(t222.length, 0 === r222.length ? Infinity : -r222.length);
        return t222.every((t32, n42) => o3(t32, e222[n42], c222)) && r222.every((t32, e32) => o3(t32, n32[e32], c222)) && (0 === a222.length || o3(a222[0], i222, c222));
      }
      return n222.length === s222.length && n222.every((t32, e222) => o3(t32, s222[e222], c222));
    }
    return Object.keys(n222).every((e222) => {
      const r222 = n222[e222];
      return (e222 in s222 || i3(a222 = r222) && "optional" === a222[t3]().matcherType) && o3(r222, s222[e222], c222);
      var a222;
    });
  }
  return Object.is(s222, n222);
};
var s3 = (e222) => {
  var n222, o222, a222;
  return r3(e222) ? i3(e222) ? null != (n222 = null == (o222 = (a222 = e222[t3]()).getSelectionKeys) ? void 0 : o222.call(a222)) ? n222 : [] : Array.isArray(e222) ? c3(e222, s3) : c3(Object.values(e222), s3) : [];
};
var c3 = (t222, e222) => t222.reduce((t32, n222) => t32.concat(e222(n222)), []);
function a3(...t222) {
  if (1 === t222.length) {
    const [e222] = t222;
    return (t32) => o3(e222, t32, () => {
    });
  }
  if (2 === t222.length) {
    const [e222, n222] = t222;
    return o3(e222, n222, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t222.length}.`);
}
function u3(t222) {
  return Object.assign(t222, { optional: () => l3(t222), and: (e222) => m3(t222, e222), or: (e222) => d3(t222, e222), select: (e222) => void 0 === e222 ? p3(t222) : p3(e222, t222) });
}
function h3(t222) {
  return Object.assign(((t32) => Object.assign(t32, { [Symbol.iterator]() {
    let n222 = 0;
    const r222 = [{ value: Object.assign(t32, { [e3]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t42;
      return null != (t42 = r222[n222++]) ? t42 : r222.at(-1);
    } };
  } }))(t222), { optional: () => h3(l3(t222)), select: (e222) => h3(void 0 === e222 ? p3(t222) : p3(e222, t222)) });
}
function l3(e222) {
  return u3({ [t3]: () => ({ match: (t222) => {
    let n222 = {};
    const r222 = (t32, e32) => {
      n222[t32] = e32;
    };
    return void 0 === t222 ? (s3(e222).forEach((t32) => r222(t32, void 0)), { matched: true, selections: n222 }) : { matched: o3(e222, t222, r222), selections: n222 };
  }, getSelectionKeys: () => s3(e222), matcherType: "optional" }) });
}
var f3 = (t222, e222) => {
  for (const n222 of t222) if (!e222(n222)) return false;
  return true;
};
var g3 = (t222, e222) => {
  for (const [n222, r222] of t222.entries()) if (!e222(r222, n222)) return false;
  return true;
};
function m3(...e222) {
  return u3({ [t3]: () => ({ match: (t222) => {
    let n222 = {};
    const r222 = (t32, e32) => {
      n222[t32] = e32;
    };
    return { matched: e222.every((e32) => o3(e32, t222, r222)), selections: n222 };
  }, getSelectionKeys: () => c3(e222, s3), matcherType: "and" }) });
}
function d3(...e222) {
  return u3({ [t3]: () => ({ match: (t222) => {
    let n222 = {};
    const r222 = (t32, e32) => {
      n222[t32] = e32;
    };
    return c3(e222, s3).forEach((t32) => r222(t32, void 0)), { matched: e222.some((e32) => o3(e32, t222, r222)), selections: n222 };
  }, getSelectionKeys: () => c3(e222, s3), matcherType: "or" }) });
}
function y3(e222) {
  return { [t3]: () => ({ match: (t222) => ({ matched: Boolean(e222(t222)) }) }) };
}
function p3(...e222) {
  const r222 = "string" == typeof e222[0] ? e222[0] : void 0, i222 = 2 === e222.length ? e222[1] : "string" == typeof e222[0] ? void 0 : e222[0];
  return u3({ [t3]: () => ({ match: (t222) => {
    let e32 = { [null != r222 ? r222 : n3]: t222 };
    return { matched: void 0 === i222 || o3(i222, t222, (t32, n222) => {
      e32[t32] = n222;
    }), selections: e32 };
  }, getSelectionKeys: () => [null != r222 ? r222 : n3].concat(void 0 === i222 ? [] : s3(i222)) }) });
}
function v3(t222) {
  return "number" == typeof t222;
}
function b3(t222) {
  return "string" == typeof t222;
}
function w3(t222) {
  return "bigint" == typeof t222;
}
var S3 = u3(y3(function(t222) {
  return true;
}));
var O3 = S3;
var j3 = (t222) => Object.assign(u3(t222), { startsWith: (e222) => {
  return j3(m3(t222, (n222 = e222, y3((t32) => b3(t32) && t32.startsWith(n222)))));
  var n222;
}, endsWith: (e222) => {
  return j3(m3(t222, (n222 = e222, y3((t32) => b3(t32) && t32.endsWith(n222)))));
  var n222;
}, minLength: (e222) => j3(m3(t222, ((t32) => y3((e32) => b3(e32) && e32.length >= t32))(e222))), maxLength: (e222) => j3(m3(t222, ((t32) => y3((e32) => b3(e32) && e32.length <= t32))(e222))), includes: (e222) => {
  return j3(m3(t222, (n222 = e222, y3((t32) => b3(t32) && t32.includes(n222)))));
  var n222;
}, regex: (e222) => {
  return j3(m3(t222, (n222 = e222, y3((t32) => b3(t32) && Boolean(t32.match(n222))))));
  var n222;
} });
var E3 = j3(y3(b3));
var K3 = (t222) => Object.assign(u3(t222), { between: (e222, n222) => K3(m3(t222, ((t32, e32) => y3((n32) => v3(n32) && t32 <= n32 && e32 >= n32))(e222, n222))), lt: (e222) => K3(m3(t222, ((t32) => y3((e32) => v3(e32) && e32 < t32))(e222))), gt: (e222) => K3(m3(t222, ((t32) => y3((e32) => v3(e32) && e32 > t32))(e222))), lte: (e222) => K3(m3(t222, ((t32) => y3((e32) => v3(e32) && e32 <= t32))(e222))), gte: (e222) => K3(m3(t222, ((t32) => y3((e32) => v3(e32) && e32 >= t32))(e222))), int: () => K3(m3(t222, y3((t32) => v3(t32) && Number.isInteger(t32)))), finite: () => K3(m3(t222, y3((t32) => v3(t32) && Number.isFinite(t32)))), positive: () => K3(m3(t222, y3((t32) => v3(t32) && t32 > 0))), negative: () => K3(m3(t222, y3((t32) => v3(t32) && t32 < 0))) });
var x3 = K3(y3(v3));
var A3 = (t222) => Object.assign(u3(t222), { between: (e222, n222) => A3(m3(t222, ((t32, e32) => y3((n32) => w3(n32) && t32 <= n32 && e32 >= n32))(e222, n222))), lt: (e222) => A3(m3(t222, ((t32) => y3((e32) => w3(e32) && e32 < t32))(e222))), gt: (e222) => A3(m3(t222, ((t32) => y3((e32) => w3(e32) && e32 > t32))(e222))), lte: (e222) => A3(m3(t222, ((t32) => y3((e32) => w3(e32) && e32 <= t32))(e222))), gte: (e222) => A3(m3(t222, ((t32) => y3((e32) => w3(e32) && e32 >= t32))(e222))), positive: () => A3(m3(t222, y3((t32) => w3(t32) && t32 > 0))), negative: () => A3(m3(t222, y3((t32) => w3(t32) && t32 < 0))) });
var P22 = A3(y3(w3));
var T3 = u3(y3(function(t222) {
  return "boolean" == typeof t222;
}));
var k3 = u3(y3(function(t222) {
  return "symbol" == typeof t222;
}));
var B3 = u3(y3(function(t222) {
  return null == t222;
}));
var _3 = u3(y3(function(t222) {
  return null != t222;
}));
var N3 = { __proto__: null, matcher: t3, optional: l3, array: function(...e222) {
  return h3({ [t3]: () => ({ match: (t222) => {
    if (!Array.isArray(t222)) return { matched: false };
    if (0 === e222.length) return { matched: true };
    const n222 = e222[0];
    let r222 = {};
    if (0 === t222.length) return s3(n222).forEach((t32) => {
      r222[t32] = [];
    }), { matched: true, selections: r222 };
    const i222 = (t32, e32) => {
      r222[t32] = (r222[t32] || []).concat([e32]);
    };
    return { matched: t222.every((t32) => o3(n222, t32, i222)), selections: r222 };
  }, getSelectionKeys: () => 0 === e222.length ? [] : s3(e222[0]) }) });
}, set: function(...e222) {
  return u3({ [t3]: () => ({ match: (t222) => {
    if (!(t222 instanceof Set)) return { matched: false };
    let n222 = {};
    if (0 === t222.size) return { matched: true, selections: n222 };
    if (0 === e222.length) return { matched: true };
    const r222 = (t32, e32) => {
      n222[t32] = (n222[t32] || []).concat([e32]);
    }, i222 = e222[0];
    return { matched: f3(t222, (t32) => o3(i222, t32, r222)), selections: n222 };
  }, getSelectionKeys: () => 0 === e222.length ? [] : s3(e222[0]) }) });
}, map: function(...e222) {
  return u3({ [t3]: () => ({ match: (t222) => {
    if (!(t222 instanceof Map)) return { matched: false };
    let n222 = {};
    if (0 === t222.size) return { matched: true, selections: n222 };
    const r222 = (t32, e32) => {
      n222[t32] = (n222[t32] || []).concat([e32]);
    };
    if (0 === e222.length) return { matched: true };
    var i222;
    if (1 === e222.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i222 = e222[0]) ? void 0 : i222.toString()}`);
    const [s222, c222] = e222;
    return { matched: g3(t222, (t32, e32) => {
      const n32 = o3(s222, e32, r222), i32 = o3(c222, t32, r222);
      return n32 && i32;
    }), selections: n222 };
  }, getSelectionKeys: () => 0 === e222.length ? [] : [...s3(e222[0]), ...s3(e222[1])] }) });
}, intersection: m3, union: d3, not: function(e222) {
  return u3({ [t3]: () => ({ match: (t222) => ({ matched: !o3(e222, t222, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y3, select: p3, any: S3, _: O3, string: E3, number: x3, bigint: P22, boolean: T3, symbol: k3, nullish: B3, nonNullable: _3, instanceOf: function(t222) {
  return u3(y3(/* @__PURE__ */ function(t32) {
    return (e222) => e222 instanceof t32;
  }(t222)));
}, shape: function(t222) {
  return u3(y3(a3(t222)));
} };
var KEYS222 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES222 = Object.keys(KEYS222);
for (const type of NODE_TYPES222) {
  Object.freeze(KEYS222[type]);
}
Object.freeze(KEYS222);
var visitor_keys_default222 = KEYS222;
var KEY_BLACKLIST222 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey222(key) {
  return !KEY_BLACKLIST222.has(key) && key[0] !== "_";
}
function getKeys222(node) {
  return Object.keys(node).filter(filterKey222);
}
function getInnermostScope222(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range22 = childScope.block.range;
      if (range22[0] <= location && location < range22[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable2222(initialScope, nameOrNode) {
  let name2 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name2 = nameOrNode;
  } else {
    name2 = nameOrNode.name;
    scope = getInnermostScope222(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name2);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate0222(token) {
  return !this(token);
}
function negate222(f222) {
  return negate0222.bind(f222);
}
function isPunctuatorTokenWithValue222(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken222(token) {
  return isPunctuatorTokenWithValue222(token, "=>");
}
function isCommaToken222(token) {
  return isPunctuatorTokenWithValue222(token, ",");
}
function isSemicolonToken222(token) {
  return isPunctuatorTokenWithValue222(token, ";");
}
function isColonToken222(token) {
  return isPunctuatorTokenWithValue222(token, ":");
}
function isOpeningParenToken222(token) {
  return isPunctuatorTokenWithValue222(token, "(");
}
function isClosingParenToken222(token) {
  return isPunctuatorTokenWithValue222(token, ")");
}
function isOpeningBracketToken222(token) {
  return isPunctuatorTokenWithValue222(token, "[");
}
function isClosingBracketToken222(token) {
  return isPunctuatorTokenWithValue222(token, "]");
}
function isOpeningBraceToken222(token) {
  return isPunctuatorTokenWithValue222(token, "{");
}
function isClosingBraceToken222(token) {
  return isPunctuatorTokenWithValue222(token, "}");
}
function isCommentToken222(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate222(isArrowToken222);
negate222(isCommaToken222);
negate222(isSemicolonToken222);
negate222(isColonToken222);
negate222(isOpeningParenToken222);
negate222(isClosingParenToken222);
negate222(isOpeningBracketToken222);
negate222(isClosingBracketToken222);
negate222(isOpeningBraceToken222);
negate222(isClosingBraceToken222);
negate222(isCommentToken222);
function getOpeningParenOfParams222(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken222) : sourceCode.getFirstToken(node, isOpeningParenToken222);
}
function getFunctionHeadLocation222(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken222);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams222(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams222(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject222 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames222 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed222 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k222) => k222 !== "random").map((k222) => Math[k222]).filter((f222) => typeof f222 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f222) => typeof f222 === "function")
);
var callPassThrough222 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed222 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor222(object22, name2) {
  let x222 = object22;
  while ((typeof x222 === "object" || typeof x222 === "function") && x222 !== null) {
    const d222 = Object.getOwnPropertyDescriptor(x222, name2);
    if (d222) {
      return d222;
    }
    x222 = Object.getPrototypeOf(x222);
  }
  return null;
}
function isGetter222(object22, name2) {
  const d222 = getPropertyDescriptor222(object22, name2);
  return d222 != null && d222.get != null;
}
function getElementValues222(nodeList, initialScope) {
  const valueList = [];
  for (let i222 = 0; i222 < nodeList.length; ++i222) {
    const elementNode = nodeList[i222];
    if (elementNode == null) {
      valueList.length = i222 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR222(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR222(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst222(variable) {
  const refs = variable.references;
  const inits = refs.filter((r222) => r222.init).length;
  const reads = refs.filter((r222) => r222.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations222 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues222(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR222(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left3222 = getStaticValueR222(node.left, initialScope);
    const right3222 = getStaticValueR222(node.right, initialScope);
    if (left3222 != null && right3222 != null) {
      switch (node.operator) {
        case "==":
          return { value: left3222.value == right3222.value };
        case "!=":
          return { value: left3222.value != right3222.value };
        case "===":
          return { value: left3222.value === right3222.value };
        case "!==":
          return { value: left3222.value !== right3222.value };
        case "<":
          return { value: left3222.value < right3222.value };
        case "<=":
          return { value: left3222.value <= right3222.value };
        case ">":
          return { value: left3222.value > right3222.value };
        case ">=":
          return { value: left3222.value >= right3222.value };
        case "<<":
          return { value: left3222.value << right3222.value };
        case ">>":
          return { value: left3222.value >> right3222.value };
        case ">>>":
          return { value: left3222.value >>> right3222.value };
        case "+":
          return { value: left3222.value + right3222.value };
        case "-":
          return { value: left3222.value - right3222.value };
        case "*":
          return { value: left3222.value * right3222.value };
        case "/":
          return { value: left3222.value / right3222.value };
        case "%":
          return { value: left3222.value % right3222.value };
        case "**":
          return { value: left3222.value ** right3222.value };
        case "|":
          return { value: left3222.value | right3222.value };
        case "^":
          return { value: left3222.value ^ right3222.value };
        case "&":
          return { value: left3222.value & right3222.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues222(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object22 = getStaticValueR222(calleeNode.object, initialScope);
        if (object22 != null) {
          if (object22.value == null && (object22.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue222(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object22.value;
            const methodName = property.value;
            if (callAllowed222.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough222.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR222(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed222.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough222.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR222(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR222(node.consequent, initialScope) : getStaticValueR222(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR222(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable2222(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames222.has(variable.name) && variable.name in globalObject222) {
        return { value: globalObject222[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst222(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR222(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left3222 = getStaticValueR222(node.left, initialScope);
    if (left3222 != null) {
      if (node.operator === "||" && Boolean(left3222.value) === true || node.operator === "&&" && Boolean(left3222.value) === false || node.operator === "??" && left3222.value != null) {
        return left3222;
      }
      const right3222 = getStaticValueR222(node.right, initialScope);
      if (right3222 != null) {
        return right3222;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object22 = getStaticValueR222(node.object, initialScope);
    if (object22 != null) {
      if (object22.value == null && (object22.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue222(node, initialScope);
      if (property != null) {
        if (!isGetter222(object22.value, property.value)) {
          return { value: object22.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed222) {
          if (object22.value instanceof classFn && allowed.has(property.value)) {
            return { value: object22.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR222(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR222(node.callee, initialScope);
    const args = getElementValues222(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed222.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object22 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue222(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR222(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object22[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR222(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object22, argument.value);
      } else {
        return null;
      }
    }
    return { value: object22 };
  },
  SequenceExpression(node, initialScope) {
    const last22 = node.expressions[node.expressions.length - 1];
    return getStaticValueR222(last22, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR222(node.tag, initialScope);
    const expressions = getElementValues222(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues222(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i222 = 0; i222 < expressions.length; ++i222) {
        value += expressions[i222];
        value += node.quasis[i222 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR222(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR222(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations222, node.type)) {
    return operations222[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue222(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR222(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue222(node, initialScope = null) {
  try {
    return getStaticValueR222(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant222(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue222(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName222(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant222(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant222(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind222(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name2 = getPropertyName222(parent);
      if (name2) {
        tokens.push(`'${name2}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps222 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps222 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode222(x222) {
  return x222 !== null && typeof x222 === "object" && typeof x222.type === "string";
}
var visitor222 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys222(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode222(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode222(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps222.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps222.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect222(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor222.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default222
  );
}
function getParentSyntaxParen222(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken222
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken222
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized222(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken222(maybeLeftParen) && isClosingParenToken222(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen222(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp2222 = Object.defineProperty;
var __export2222 = (target, all3222) => {
  for (var name2 in all3222)
    __defProp2222(target, name2, { get: all3222[name2], enumerable: true });
};
var NodeType222 = AST_NODE_TYPES;
var is222 = ASTUtils.isNodeOfType;
var isOneOf222 = ASTUtils.isNodeOfTypes;
isOneOf222([
  NodeType222.ArrowFunctionExpression,
  NodeType222.FunctionDeclaration,
  NodeType222.FunctionExpression
]);
isOneOf222([
  NodeType222.ArrowFunctionExpression,
  NodeType222.FunctionDeclaration,
  NodeType222.FunctionExpression,
  NodeType222.TSCallSignatureDeclaration,
  NodeType222.TSConstructSignatureDeclaration,
  NodeType222.TSDeclareFunction,
  NodeType222.TSEmptyBodyFunctionExpression,
  NodeType222.TSFunctionType,
  NodeType222.TSMethodSignature
]);
isOneOf222([NodeType222.ClassDeclaration, NodeType222.ClassExpression]);
isOneOf222([
  NodeType222.DoWhileStatement,
  NodeType222.ForInStatement,
  NodeType222.ForOfStatement,
  NodeType222.ForStatement,
  NodeType222.WhileStatement
]);
isOneOf222([NodeType222.TSArrayType, NodeType222.TSTupleType]);
isOneOf222([
  NodeType222.PropertyDefinition,
  NodeType222.TSIndexSignature,
  NodeType222.TSParameterProperty,
  NodeType222.TSPropertySignature
]);
is222(NodeType222.JSXElement);
is222(NodeType222.JSXFragment);
isOneOf222([
  NodeType222.JSXAttribute,
  NodeType222.JSXSpreadChild,
  NodeType222.JSXClosingElement,
  NodeType222.JSXClosingFragment,
  NodeType222.JSXElement,
  NodeType222.JSXEmptyExpression,
  NodeType222.JSXExpressionContainer,
  NodeType222.JSXFragment,
  NodeType222.JSXIdentifier,
  NodeType222.JSXMemberExpression,
  NodeType222.JSXNamespacedName,
  NodeType222.JSXOpeningElement,
  NodeType222.JSXOpeningFragment,
  NodeType222.JSXSpreadAttribute,
  NodeType222.JSXSpreadChild,
  NodeType222.JSXText
]);
isOneOf222([
  NodeType222.JSXIdentifier,
  NodeType222.JSXMemberExpression,
  NodeType222.JSXNamespacedName
]);
isOneOf222([
  NodeType222.ArrayPattern,
  NodeType222.AssignmentPattern,
  NodeType222.ObjectPattern,
  NodeType222.RestElement
]);
isOneOf222([
  NodeType222.TSInterfaceDeclaration,
  NodeType222.TSTypeAliasDeclaration
]);
isOneOf222([
  NodeType222.ArrayExpression,
  NodeType222.ArrayPattern,
  NodeType222.ArrowFunctionExpression,
  NodeType222.CallExpression,
  NodeType222.ClassExpression,
  NodeType222.FunctionExpression,
  NodeType222.Identifier,
  NodeType222.JSXElement,
  NodeType222.JSXFragment,
  NodeType222.Literal,
  NodeType222.TemplateLiteral,
  NodeType222.MemberExpression,
  NodeType222.MetaProperty,
  NodeType222.ObjectExpression,
  NodeType222.ObjectPattern,
  NodeType222.SequenceExpression,
  NodeType222.Super,
  NodeType222.TaggedTemplateExpression,
  NodeType222.ThisExpression
]);
isOneOf222([
  NodeType222.ArrayExpression,
  NodeType222.ArrayPattern,
  NodeType222.ArrowFunctionExpression,
  NodeType222.CallExpression,
  NodeType222.ClassExpression,
  NodeType222.FunctionExpression,
  NodeType222.Identifier,
  NodeType222.JSXElement,
  NodeType222.JSXFragment,
  NodeType222.Literal,
  NodeType222.TemplateLiteral,
  NodeType222.MemberExpression,
  NodeType222.MetaProperty,
  NodeType222.ObjectExpression,
  NodeType222.ObjectPattern,
  NodeType222.SequenceExpression,
  NodeType222.Super,
  NodeType222.TaggedTemplateExpression,
  NodeType222.ThisExpression,
  NodeType222.TSAsExpression,
  NodeType222.TSNonNullExpression,
  NodeType222.TSTypeAssertion
]);
var Function_exports2222 = {};
__export2222(Function_exports2222, {
  SK: () => SK2222,
  absurd: () => absurd2222,
  apply: () => apply2222,
  compose: () => compose2222,
  constFalse: () => constFalse2222,
  constNull: () => constNull2222,
  constTrue: () => constTrue2222,
  constUndefined: () => constUndefined2222,
  constVoid: () => constVoid2222,
  constant: () => constant2222,
  dual: () => dual2222,
  flip: () => flip2222,
  flow: () => flow2222,
  hole: () => hole2222,
  identity: () => identity2222,
  isFunction: () => isFunction22222,
  pipe: () => pipe2222,
  satisfies: () => satisfies2222,
  tupled: () => tupled2222,
  unsafeCoerce: () => unsafeCoerce2222,
  untupled: () => untupled2222
});
var isFunction22222 = (input) => typeof input === "function";
var dual2222 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a222, b222) {
        if (arguments.length >= 2) {
          return body(a222, b222);
        }
        return function(self2) {
          return body(self2, a222);
        };
      };
    case 3:
      return function(a222, b222, c222) {
        if (arguments.length >= 3) {
          return body(a222, b222, c222);
        }
        return function(self2) {
          return body(self2, a222, b222);
        };
      };
    case 4:
      return function(a222, b222, c222, d222) {
        if (arguments.length >= 4) {
          return body(a222, b222, c222, d222);
        }
        return function(self2) {
          return body(self2, a222, b222, c222);
        };
      };
    case 5:
      return function(a222, b222, c222, d222, e222) {
        if (arguments.length >= 5) {
          return body(a222, b222, c222, d222, e222);
        }
        return function(self2) {
          return body(self2, a222, b222, c222, d222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply2222 = (a222) => (self2) => self2(a222);
var identity2222 = (a222) => a222;
var satisfies2222 = () => (b222) => b222;
var unsafeCoerce2222 = identity2222;
var constant2222 = (value) => () => value;
var constTrue2222 = /* @__PURE__ */ constant2222(true);
var constFalse2222 = /* @__PURE__ */ constant2222(false);
var constNull2222 = /* @__PURE__ */ constant2222(null);
var constUndefined2222 = /* @__PURE__ */ constant2222(void 0);
var constVoid2222 = constUndefined2222;
var flip2222 = (f222) => (...b222) => (...a222) => f222(...a222)(...b222);
var compose2222 = /* @__PURE__ */ dual2222(2, (ab, bc) => (a222) => bc(ab(a222)));
var absurd2222 = (_222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled2222 = (f222) => (a222) => f222(...a222);
var untupled2222 = (f222) => (...a222) => f222(a222);
function pipe2222(a222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a222;
    case 2:
      return ab(a222);
    case 3:
      return bc(ab(a222));
    case 4:
      return cd(bc(ab(a222)));
    case 5:
      return de(cd(bc(ab(a222))));
    case 6:
      return ef(de(cd(bc(ab(a222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a222))))))));
    default: {
      let ret = arguments[0];
      for (let i222 = 1; i222 < arguments.length; i222++) {
        ret = arguments[i222](ret);
      }
      return ret;
    }
  }
}
function flow2222(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole2222 = /* @__PURE__ */ unsafeCoerce2222(absurd2222);
var SK2222 = (_222, b222) => b222;
var make4222 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_3222 = (map622) => dual2222(3, (self2, name2, f222) => map622(self2, (a222) => Object.assign({}, a222, {
  [name2]: f222(a222)
})));
var bindTo3222 = (map622) => dual2222(2, (self2, name2) => map622(self2, (a222) => ({
  [name2]: a222
})));
var bind3222 = (map622, flatMap422) => dual2222(3, (self2, name2, f222) => flatMap422(self2, (a222) => map622(f222(a222), (b222) => Object.assign({}, a222, {
  [name2]: b222
}))));
var moduleVersion2222 = "3.2.8";
var getCurrentVersion2222 = () => moduleVersion2222;
var globalStoreId2222 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion2222()}`);
if (!(globalStoreId2222 in globalThis)) {
  globalThis[globalStoreId2222] = /* @__PURE__ */ new Map();
}
var globalStore2222 = globalThis[globalStoreId2222];
var globalValue2222 = (id, compute) => {
  if (!globalStore2222.has(id)) {
    globalStore2222.set(id, compute());
  }
  return globalStore2222.get(id);
};
var Predicate_exports2222 = {};
__export2222(Predicate_exports2222, {
  all: () => all2222,
  and: () => and32,
  compose: () => compose22222,
  eqv: () => eqv32,
  every: () => every42,
  hasProperty: () => hasProperty2222,
  implies: () => implies32,
  isBigInt: () => isBigInt32,
  isBoolean: () => isBoolean32,
  isDate: () => isDate32,
  isError: () => isError32,
  isFunction: () => isFunction3222,
  isIterable: () => isIterable32,
  isMap: () => isMap32,
  isNever: () => isNever32,
  isNotNull: () => isNotNull32,
  isNotNullable: () => isNotNullable32,
  isNotUndefined: () => isNotUndefined32,
  isNull: () => isNull32,
  isNullable: () => isNullable2222,
  isNumber: () => isNumber32,
  isObject: () => isObject2222,
  isPromise: () => isPromise32,
  isPromiseLike: () => isPromiseLike32,
  isReadonlyRecord: () => isReadonlyRecord32,
  isRecord: () => isRecord32,
  isSet: () => isSet32,
  isString: () => isString32,
  isSymbol: () => isSymbol32,
  isTagged: () => isTagged32,
  isTruthy: () => isTruthy32,
  isUint8Array: () => isUint8Array32,
  isUndefined: () => isUndefined32,
  isUnknown: () => isUnknown32,
  mapInput: () => mapInput42,
  nand: () => nand32,
  nor: () => nor32,
  not: () => not32,
  or: () => or32,
  product: () => product2222,
  productMany: () => productMany2222,
  some: () => some3222,
  struct: () => struct52,
  tuple: () => tuple42,
  xor: () => xor32
});
var mapInput42 = /* @__PURE__ */ dual2222(2, (self2, f222) => (b222) => self2(f222(b222)));
var isTruthy32 = (input) => !!input;
var isSet32 = (input) => input instanceof Set;
var isMap32 = (input) => input instanceof Map;
var isString32 = (input) => typeof input === "string";
var isNumber32 = (input) => typeof input === "number";
var isBoolean32 = (input) => typeof input === "boolean";
var isBigInt32 = (input) => typeof input === "bigint";
var isSymbol32 = (input) => typeof input === "symbol";
var isFunction3222 = isFunction22222;
var isUndefined32 = (input) => input === void 0;
var isNotUndefined32 = (input) => input !== void 0;
var isNull32 = (input) => input === null;
var isNotNull32 = (input) => input !== null;
var isNever32 = (_222) => false;
var isUnknown32 = (_222) => true;
var isRecordOrArray2222 = (input) => typeof input === "object" && input !== null;
var isObject2222 = (input) => isRecordOrArray2222(input) || isFunction3222(input);
var hasProperty2222 = /* @__PURE__ */ dual2222(2, (self2, property) => isObject2222(self2) && property in self2);
var isTagged32 = /* @__PURE__ */ dual2222(2, (self2, tag) => hasProperty2222(self2, "_tag") && self2["_tag"] === tag);
var isNullable2222 = (input) => input === null || input === void 0;
var isNotNullable32 = (input) => input !== null && input !== void 0;
var isError32 = (input) => input instanceof Error;
var isUint8Array32 = (input) => input instanceof Uint8Array;
var isDate32 = (input) => input instanceof Date;
var isIterable32 = (input) => hasProperty2222(input, Symbol.iterator);
var isRecord32 = (input) => isRecordOrArray2222(input) && !Array.isArray(input);
var isReadonlyRecord32 = isRecord32;
var isPromise32 = (input) => hasProperty2222(input, "then") && "catch" in input && isFunction3222(input.then) && isFunction3222(input.catch);
var isPromiseLike32 = (input) => hasProperty2222(input, "then") && isFunction3222(input.then);
var compose22222 = /* @__PURE__ */ dual2222(2, (ab, bc) => (a222) => ab(a222) && bc(a222));
var product2222 = (self2, that) => ([a222, b222]) => self2(a222) && that(b222);
var all2222 = (collection) => {
  return (as22222) => {
    let collectionIndex = 0;
    for (const p222 of collection) {
      if (collectionIndex >= as22222.length) {
        break;
      }
      if (p222(as22222[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany2222 = (self2, collection) => {
  const rest = all2222(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple42 = (...elements) => all2222(elements);
var struct52 = (fields) => {
  const keys2222 = Object.keys(fields);
  return (a222) => {
    for (const key of keys2222) {
      if (!fields[key](a222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not32 = (self2) => (a222) => !self2(a222);
var or32 = /* @__PURE__ */ dual2222(2, (self2, that) => (a222) => self2(a222) || that(a222));
var and32 = /* @__PURE__ */ dual2222(2, (self2, that) => (a222) => self2(a222) && that(a222));
var xor32 = /* @__PURE__ */ dual2222(2, (self2, that) => (a222) => self2(a222) !== that(a222));
var eqv32 = /* @__PURE__ */ dual2222(2, (self2, that) => (a222) => self2(a222) === that(a222));
var implies32 = /* @__PURE__ */ dual2222(2, (self2, that) => (a222) => self2(a222) ? that(a222) : true);
var nor32 = /* @__PURE__ */ dual2222(2, (self2, that) => (a222) => !(self2(a222) || that(a222)));
var nand32 = /* @__PURE__ */ dual2222(2, (self2, that) => (a222) => !(self2(a222) && that(a222)));
var every42 = (collection) => (a222) => {
  for (const p222 of collection) {
    if (!p222(a222)) {
      return false;
    }
  }
  return true;
};
var some3222 = (collection) => (a222) => {
  for (const p222 of collection) {
    if (p222(a222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage2222 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId2222 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind2222 = (u222) => isObject2222(u222) && GenKindTypeId2222 in u222;
var GenKindImpl2222 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity2222;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_222) => _222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_222) => _222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_222) => _222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId2222] = GenKindTypeId2222;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen2222(this);
  }
};
var SingleShotGen2222 = class _SingleShotGen42 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a222) {
    return this.called ? {
      value: a222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a222) {
    return {
      value: a222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e222) {
    throw e222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen42(this.self);
  }
};
var adapter3222 = () => function() {
  let x222 = arguments[0];
  for (let i222 = 1; i222 < arguments.length; i222++) {
    x222 = arguments[i222](x222);
  }
  return new GenKindImpl2222(x222);
};
var defaultIncHi2222 = 335903614;
var defaultIncLo2222 = 4150755663;
var MUL_HI2222 = 1481765933 >>> 0;
var MUL_LO2222 = 1284865837 >>> 0;
var BIT_532222 = 9007199254740992;
var BIT_272222 = 134217728;
var PCGRandom2222 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable2222(seedLo) && isNullable2222(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable2222(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable2222(incLo) && isNullable2222(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo2222;
      incHi = this._state ? this._state[2] : defaultIncHi2222;
    } else if (isNullable2222(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add642222(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max32) {
    if (!max32) {
      return this._next();
    }
    max32 = max32 >>> 0;
    if ((max32 & max32 - 1) === 0) {
      return this._next() & max32 - 1;
    }
    let num = 0;
    const skew = (-max32 >>> 0) % max32 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max32;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_272222 + lo) / BIT_532222;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul642222(this._state, oldHi, oldLo, MUL_HI2222, MUL_LO2222);
    add642222(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul642222(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add642222(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId2222 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap2222 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId2222]() {
    return this.#value;
  }
};
function yieldWrapGet2222(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId2222 in self2) {
    return self2[YieldWrapTypeId2222]();
  }
  throw new Error(getBugErrorMessage2222("yieldWrapGet"));
}
var structuralRegionState2222 = /* @__PURE__ */ globalValue2222("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache2222 = /* @__PURE__ */ globalValue2222(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr2222 = /* @__PURE__ */ globalValue2222(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom2222());
var symbol3222 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash2222 = (self2) => {
  if (structuralRegionState2222.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number2222(self2);
    case "bigint":
      return string2222(self2.toString(10));
    case "boolean":
      return string2222(String(self2));
    case "symbol":
      return string2222(String(self2));
    case "string":
      return string2222(self2);
    case "undefined":
      return string2222("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string2222("null");
      } else if (self2 instanceof Date) {
        return hash2222(self2.toISOString());
      } else if (isHash2222(self2)) {
        return self2[symbol3222]();
      } else {
        return random2222(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random2222 = (self2) => {
  if (!randomHashCache2222.has(self2)) {
    randomHashCache2222.set(self2, number2222(pcgr2222.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache2222.get(self2);
};
var combine2222 = (b222) => (self2) => self2 * 53 ^ b222;
var optimize2222 = (n222) => n222 & 3221225471 | n222 >>> 1 & 1073741824;
var isHash2222 = (u222) => hasProperty2222(u222, symbol3222);
var number2222 = (n222) => {
  if (n222 !== n222 || n222 === Infinity) {
    return 0;
  }
  let h222 = n222 | 0;
  if (h222 !== n222) {
    h222 ^= n222 * 4294967295;
  }
  while (n222 > 4294967295) {
    h222 ^= n222 /= 4294967295;
  }
  return optimize2222(n222);
};
var string2222 = (str) => {
  let h222 = 5381, i222 = str.length;
  while (i222) {
    h222 = h222 * 33 ^ str.charCodeAt(--i222);
  }
  return optimize2222(h222);
};
var structureKeys222 = (o222, keys2222) => {
  let h222 = 12289;
  for (let i222 = 0; i222 < keys2222.length; i222++) {
    h222 ^= pipe2222(string2222(keys2222[i222]), combine2222(hash2222(o222[keys2222[i222]])));
  }
  return optimize2222(h222);
};
var structure222 = (o222) => structureKeys222(o222, Object.keys(o222));
var array52 = (arr) => {
  let h222 = 6151;
  for (let i222 = 0; i222 < arr.length; i222++) {
    h222 = pipe2222(h222, combine2222(hash2222(arr[i222])));
  }
  return optimize2222(h222);
};
var cached2222 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash322) {
      Object.defineProperty(self22, symbol3222, {
        value() {
          return hash322;
        },
        enumerable: false
      });
      return hash322;
    };
  }
  const self2 = arguments[0];
  const hash22222 = arguments[1];
  Object.defineProperty(self2, symbol3222, {
    value() {
      return hash22222;
    },
    enumerable: false
  });
  return hash22222;
};
var symbol22222 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals2222() {
  if (arguments.length === 1) {
    return (self2) => compareBoth2222(self2, arguments[0]);
  }
  return compareBoth2222(arguments[0], arguments[1]);
}
function compareBoth2222(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual2222(self2) && isEqual2222(that)) {
        if (hash2222(self2) === hash2222(that) && self2[symbol22222](that)) {
          return true;
        } else {
          return structuralRegionState2222.enabled && structuralRegionState2222.tester ? structuralRegionState2222.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState2222.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v222, i222) => compareBoth2222(v222, that[i222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth2222(self2[key], that[key]))) {
              return structuralRegionState2222.tester ? structuralRegionState2222.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState2222.tester ? structuralRegionState2222.tester(self2, that) : false;
    }
  }
  return structuralRegionState2222.enabled && structuralRegionState2222.tester ? structuralRegionState2222.tester(self2, that) : false;
}
var isEqual2222 = (u222) => hasProperty2222(u222, symbol22222);
var equivalence2222 = () => equals2222;
var NodeInspectSymbol2222 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON2222 = (x222) => {
  if (hasProperty2222(x222, "toJSON") && isFunction3222(x222["toJSON"]) && x222["toJSON"].length === 0) {
    return x222.toJSON();
  } else if (Array.isArray(x222)) {
    return x222.map(toJSON2222);
  }
  return x222;
};
var format2222 = (x222) => JSON.stringify(x222, null, 2);
var pipeArguments2222 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i222 = 0, len = args.length; i222 < len; i222++) {
        ret = args[i222](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT222 = "Commit";
var OP_FAILURE222 = "Failure";
var OP_WITH_RUNTIME222 = "WithRuntime";
var EffectTypeId2222 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId2222 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId2222 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId2222 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance2222 = {
  /* c8 ignore next */
  _R: (_222) => _222,
  /* c8 ignore next */
  _E: (_222) => _222,
  /* c8 ignore next */
  _A: (_222) => _222,
  _V: /* @__PURE__ */ getCurrentVersion2222()
};
var sinkVariance2222 = {
  /* c8 ignore next */
  _A: (_222) => _222,
  /* c8 ignore next */
  _In: (_222) => _222,
  /* c8 ignore next */
  _L: (_222) => _222,
  /* c8 ignore next */
  _E: (_222) => _222,
  /* c8 ignore next */
  _R: (_222) => _222
};
var channelVariance2222 = {
  /* c8 ignore next */
  _Env: (_222) => _222,
  /* c8 ignore next */
  _InErr: (_222) => _222,
  /* c8 ignore next */
  _InElem: (_222) => _222,
  /* c8 ignore next */
  _InDone: (_222) => _222,
  /* c8 ignore next */
  _OutErr: (_222) => _222,
  /* c8 ignore next */
  _OutElem: (_222) => _222,
  /* c8 ignore next */
  _OutDone: (_222) => _222
};
var EffectPrototype2222 = {
  [EffectTypeId2222]: effectVariance2222,
  [StreamTypeId2222]: effectVariance2222,
  [SinkTypeId2222]: sinkVariance2222,
  [ChannelTypeId2222]: channelVariance2222,
  [symbol22222](that) {
    return this === that;
  },
  [symbol3222]() {
    return cached2222(this, random2222(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen2222(new YieldWrap2222(this));
  },
  pipe() {
    return pipeArguments2222(this, arguments);
  }
};
var StructuralPrototype222 = {
  [symbol3222]() {
    return cached2222(this, structure222(this));
  },
  [symbol22222](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals2222(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype222 = {
  ...EffectPrototype2222,
  _op: OP_COMMIT222
};
var StructuralCommitPrototype222 = {
  ...CommitPrototype222,
  ...StructuralPrototype222
};
var TypeId5222 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto3222 = {
  ...EffectPrototype2222,
  [TypeId5222]: {
    _A: (_222) => _222
  },
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  },
  toString() {
    return format2222(this.toJSON());
  }
};
var SomeProto2222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto3222), {
  _tag: "Some",
  _op: "Some",
  [symbol22222](that) {
    return isOption3222(that) && isSome3222(that) && equals2222(this.value, that.value);
  },
  [symbol3222]() {
    return cached2222(this, combine2222(hash2222(this._tag))(hash2222(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON2222(this.value)
    };
  }
});
var NoneHash2222 = /* @__PURE__ */ hash2222("None");
var NoneProto2222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto3222), {
  _tag: "None",
  _op: "None",
  [symbol22222](that) {
    return isOption3222(that) && isNone3222(that);
  },
  [symbol3222]() {
    return NoneHash2222;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption3222 = (input) => hasProperty2222(input, TypeId5222);
var isNone3222 = (fa) => fa._tag === "None";
var isSome3222 = (fa) => fa._tag === "Some";
var none3222 = /* @__PURE__ */ Object.create(NoneProto2222);
var some22222 = (value) => {
  const a222 = Object.create(SomeProto2222);
  a222.value = value;
  return a222;
};
var TypeId22222 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto22222 = {
  ...EffectPrototype2222,
  [TypeId22222]: {
    _R: (_222) => _222
  },
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  },
  toString() {
    return format2222(this.toJSON());
  }
};
var RightProto2222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto22222), {
  _tag: "Right",
  _op: "Right",
  [symbol22222](that) {
    return isEither2222(that) && isRight2222(that) && equals2222(this.right, that.right);
  },
  [symbol3222]() {
    return combine2222(hash2222(this._tag))(hash2222(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON2222(this.right)
    };
  }
});
var LeftProto2222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto22222), {
  _tag: "Left",
  _op: "Left",
  [symbol22222](that) {
    return isEither2222(that) && isLeft2222(that) && equals2222(this.left, that.left);
  },
  [symbol3222]() {
    return combine2222(hash2222(this._tag))(hash2222(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON2222(this.left)
    };
  }
});
var isEither2222 = (input) => hasProperty2222(input, TypeId22222);
var isLeft2222 = (ma) => ma._tag === "Left";
var isRight2222 = (ma) => ma._tag === "Right";
var left2222 = (left3222) => {
  const a222 = Object.create(LeftProto2222);
  a222.left = left3222;
  return a222;
};
var right2222 = (right3222) => {
  const a222 = Object.create(RightProto2222);
  a222.right = right3222;
  return a222;
};
var getLeft3222 = (self2) => isRight2222(self2) ? none3222 : some22222(self2.left);
var getRight3222 = (self2) => isLeft2222(self2) ? none3222 : some22222(self2.right);
var right22222 = right2222;
var left22222 = left2222;
var Option_exports2222 = {};
__export2222(Option_exports2222, {
  Do: () => Do2222,
  TypeId: () => TypeId32222,
  all: () => all22222,
  andThen: () => andThen2222,
  ap: () => ap2222,
  as: () => as2222,
  asVoid: () => asVoid2222,
  bind: () => bind22222,
  bindTo: () => bindTo22222,
  composeK: () => composeK2222,
  contains: () => contains2222,
  containsWith: () => containsWith2222,
  exists: () => exists2222,
  filter: () => filter2222,
  filterMap: () => filterMap2222,
  firstSomeOf: () => firstSomeOf2222,
  flatMap: () => flatMap2222,
  flatMapNullable: () => flatMapNullable2222,
  flatten: () => flatten2222,
  fromIterable: () => fromIterable2222,
  fromNullable: () => fromNullable2222,
  gen: () => gen2222,
  getEquivalence: () => getEquivalence2222,
  getLeft: () => getLeft22222,
  getOrElse: () => getOrElse2222,
  getOrNull: () => getOrNull2222,
  getOrThrow: () => getOrThrow2222,
  getOrThrowWith: () => getOrThrowWith2222,
  getOrUndefined: () => getOrUndefined2222,
  getOrder: () => getOrder2222,
  getRight: () => getRight22222,
  isNone: () => isNone22222,
  isOption: () => isOption22222,
  isSome: () => isSome22222,
  let: () => let_22222,
  lift2: () => lift22222,
  liftNullable: () => liftNullable2222,
  liftPredicate: () => liftPredicate2222,
  liftThrowable: () => liftThrowable2222,
  map: () => map2222,
  match: () => match2222,
  none: () => none22222,
  orElse: () => orElse2222,
  orElseEither: () => orElseEither2222,
  orElseSome: () => orElseSome2222,
  partitionMap: () => partitionMap2222,
  product: () => product22222,
  productMany: () => productMany22222,
  reduceCompact: () => reduceCompact2222,
  some: () => some32222,
  tap: () => tap2222,
  toArray: () => toArray2222,
  toRefinement: () => toRefinement2222,
  void: () => void_2222,
  zipLeft: () => zipLeft2222,
  zipRight: () => zipRight2222,
  zipWith: () => zipWith2222
});
var make22222 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId32222 = /* @__PURE__ */ Symbol.for("effect/Option");
var none22222 = () => none3222;
var some32222 = some22222;
var isOption22222 = isOption3222;
var isNone22222 = isNone3222;
var isSome22222 = isSome3222;
var match2222 = /* @__PURE__ */ dual2222(2, (self2, {
  onNone,
  onSome
}) => isNone22222(self2) ? onNone() : onSome(self2.value));
var toRefinement2222 = (f222) => (a222) => isSome22222(f222(a222));
var fromIterable2222 = (collection) => {
  for (const a222 of collection) {
    return some32222(a222);
  }
  return none22222();
};
var getRight22222 = getRight3222;
var getLeft22222 = getLeft3222;
var getOrElse2222 = /* @__PURE__ */ dual2222(2, (self2, onNone) => isNone22222(self2) ? onNone() : self2.value);
var orElse2222 = /* @__PURE__ */ dual2222(2, (self2, that) => isNone22222(self2) ? that() : self2);
var orElseSome2222 = /* @__PURE__ */ dual2222(2, (self2, onNone) => isNone22222(self2) ? some32222(onNone()) : self2);
var orElseEither2222 = /* @__PURE__ */ dual2222(2, (self2, that) => isNone22222(self2) ? map2222(that(), right2222) : map2222(self2, left2222));
var firstSomeOf2222 = (collection) => {
  let out = none22222();
  for (out of collection) {
    if (isSome22222(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable2222 = (nullableValue) => nullableValue == null ? none22222() : some32222(nullableValue);
var liftNullable2222 = (f222) => (...a222) => fromNullable2222(f222(...a222));
var getOrNull2222 = /* @__PURE__ */ getOrElse2222(constNull2222);
var getOrUndefined2222 = /* @__PURE__ */ getOrElse2222(constUndefined2222);
var liftThrowable2222 = (f222) => (...a222) => {
  try {
    return some32222(f222(...a222));
  } catch (e222) {
    return none22222();
  }
};
var getOrThrowWith2222 = /* @__PURE__ */ dual2222(2, (self2, onNone) => {
  if (isSome22222(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow2222 = /* @__PURE__ */ getOrThrowWith2222(() => new Error("getOrThrow called on a None"));
var map2222 = /* @__PURE__ */ dual2222(2, (self2, f222) => isNone22222(self2) ? none22222() : some32222(f222(self2.value)));
var as2222 = /* @__PURE__ */ dual2222(2, (self2, b222) => map2222(self2, () => b222));
var asVoid2222 = /* @__PURE__ */ as2222(void 0);
var void_2222 = /* @__PURE__ */ some32222(void 0);
var flatMap2222 = /* @__PURE__ */ dual2222(2, (self2, f222) => isNone22222(self2) ? none22222() : f222(self2.value));
var andThen2222 = /* @__PURE__ */ dual2222(2, (self2, f222) => flatMap2222(self2, (a222) => {
  const b222 = isFunction22222(f222) ? f222(a222) : f222;
  return isOption22222(b222) ? b222 : some32222(b222);
}));
var flatMapNullable2222 = /* @__PURE__ */ dual2222(2, (self2, f222) => isNone22222(self2) ? none22222() : fromNullable2222(f222(self2.value)));
var flatten2222 = /* @__PURE__ */ flatMap2222(identity2222);
var zipRight2222 = /* @__PURE__ */ dual2222(2, (self2, that) => flatMap2222(self2, () => that));
var composeK2222 = /* @__PURE__ */ dual2222(2, (afb, bfc) => (a222) => flatMap2222(afb(a222), bfc));
var zipLeft2222 = /* @__PURE__ */ dual2222(2, (self2, that) => tap2222(self2, () => that));
var tap2222 = /* @__PURE__ */ dual2222(2, (self2, f222) => flatMap2222(self2, (a222) => map2222(f222(a222), () => a222)));
var product22222 = (self2, that) => isSome22222(self2) && isSome22222(that) ? some32222([self2.value, that.value]) : none22222();
var productMany22222 = (self2, collection) => {
  if (isNone22222(self2)) {
    return none22222();
  }
  const out = [self2.value];
  for (const o222 of collection) {
    if (isNone22222(o222)) {
      return none22222();
    }
    out.push(o222.value);
  }
  return some32222(out);
};
var all22222 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o222 of input) {
      if (isNone22222(o222)) {
        return none22222();
      }
      out2.push(o222.value);
    }
    return some32222(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o222 = input[key];
    if (isNone22222(o222)) {
      return none22222();
    }
    out[key] = o222.value;
  }
  return some32222(out);
};
var zipWith2222 = /* @__PURE__ */ dual2222(3, (self2, that, f222) => map2222(product22222(self2, that), ([a222, b222]) => f222(a222, b222)));
var ap2222 = /* @__PURE__ */ dual2222(2, (self2, that) => zipWith2222(self2, that, (f222, a222) => f222(a222)));
var reduceCompact2222 = /* @__PURE__ */ dual2222(3, (self2, b222, f222) => {
  let out = b222;
  for (const oa of self2) {
    if (isSome22222(oa)) {
      out = f222(out, oa.value);
    }
  }
  return out;
});
var toArray2222 = (self2) => isNone22222(self2) ? [] : [self2.value];
var partitionMap2222 = /* @__PURE__ */ dual2222(2, (self2, f222) => {
  if (isNone22222(self2)) {
    return [none22222(), none22222()];
  }
  const e222 = f222(self2.value);
  return isLeft2222(e222) ? [some32222(e222.left), none22222()] : [none22222(), some32222(e222.right)];
});
var filterMap2222 = /* @__PURE__ */ dual2222(2, (self2, f222) => isNone22222(self2) ? none22222() : f222(self2.value));
var filter2222 = /* @__PURE__ */ dual2222(2, (self2, predicate) => filterMap2222(self2, (b222) => predicate(b222) ? some22222(b222) : none3222));
var getEquivalence2222 = (isEquivalent) => make4222((x222, y222) => x222 === y222 || (isNone22222(x222) ? isNone22222(y222) : isNone22222(y222) ? false : isEquivalent(x222.value, y222.value)));
var getOrder2222 = (O222) => make22222((self2, that) => isSome22222(self2) ? isSome22222(that) ? O222(self2.value, that.value) : 1 : -1);
var lift22222 = (f222) => dual2222(2, (self2, that) => zipWith2222(self2, that, f222));
var liftPredicate2222 = (predicate) => (b222) => predicate(b222) ? some32222(b222) : none22222();
var containsWith2222 = (isEquivalent) => dual2222(2, (self2, a222) => isNone22222(self2) ? false : isEquivalent(self2.value, a222));
var _equivalence2222 = /* @__PURE__ */ equivalence2222();
var contains2222 = /* @__PURE__ */ containsWith2222(_equivalence2222);
var exists2222 = /* @__PURE__ */ dual2222(2, (self2, refinement) => isNone22222(self2) ? false : refinement(self2.value));
var bindTo22222 = /* @__PURE__ */ bindTo3222(map2222);
var let_22222 = /* @__PURE__ */ let_3222(map2222);
var bind22222 = /* @__PURE__ */ bind3222(map2222, flatMap2222);
var Do2222 = /* @__PURE__ */ some32222({});
var adapter22222 = /* @__PURE__ */ adapter3222();
var gen2222 = (f222) => {
  const iterator = f222(adapter22222);
  let state = iterator.next();
  if (state.done) {
    return some32222(state.value);
  } else {
    let current = state.value;
    if (isGenKind2222(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet2222(current);
    }
    if (isNone22222(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind2222(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet2222(current);
        }
        if (isNone22222(current)) {
          return current;
        }
      }
    }
    return some32222(state.value);
  }
};
var fromIterable22222 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse42 = (self2) => Array.from(self2).reverse();
var reduce52 = /* @__PURE__ */ dual2222(3, (self2, b222, f222) => fromIterable22222(self2).reduce((b2222, a222, i222) => f222(b2222, a222, i222), b222));
var TagTypeId222 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey222 = "effect/STM";
var STMTypeId222 = /* @__PURE__ */ Symbol.for(STMSymbolKey222);
var TagProto222 = {
  ...EffectPrototype2222,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId222]: effectVariance2222,
  [TagTypeId222]: {
    _Service: (_222) => _222,
    _Identifier: (_222) => _222
  },
  toString() {
    return format2222(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make32222(this, self2);
  }
};
var makeGenericTag222 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto222);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId42222 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto222 = {
  [TypeId42222]: {
    _Services: (_222) => _222
  },
  [symbol22222](that) {
    if (isContext222(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k222 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k222) || !equals2222(this.unsafeMap.get(k222), that.unsafeMap.get(k222))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol3222]() {
    return cached2222(this, number2222(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments2222(this, arguments);
  },
  toString() {
    return format2222(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON2222)
    };
  },
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  }
};
var makeContext222 = (unsafeMap) => {
  const context = Object.create(ContextProto222);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext222 = (u222) => hasProperty2222(u222, TypeId42222);
var _empty622 = /* @__PURE__ */ makeContext222(/* @__PURE__ */ new Map());
var empty102 = () => _empty622;
var make32222 = (tag, service) => makeContext222(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag222 = makeGenericTag222;
var empty2222 = empty102;
var TypeId52222 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy32(src, srcPos, dest, destPos, len) {
  for (let i222 = srcPos; i222 < Math.min(src.length, srcPos + len); i222++) {
    dest[destPos + i222 - srcPos] = src[i222];
  }
  return dest;
}
var emptyArray222 = [];
var getEquivalence22222 = (isEquivalent) => make4222((self2, that) => self2.length === that.length && toReadonlyArray222(self2).every((value, i222) => isEquivalent(value, unsafeGet2222(that, i222))));
var _equivalence22222 = /* @__PURE__ */ getEquivalence22222(equals2222);
var ChunkProto222 = {
  [TypeId52222]: {
    _A: (_222) => _222
  },
  toString() {
    return format2222(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray222(this).map(toJSON2222)
    };
  },
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  },
  [symbol22222](that) {
    return isChunk222(that) && _equivalence22222(this, that);
  },
  [symbol3222]() {
    return cached2222(this, array52(toReadonlyArray222(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray222[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray222(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments2222(this, arguments);
  }
};
var makeChunk222 = (backing) => {
  const chunk = Object.create(ChunkProto222);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty2222;
      chunk.right = _empty2222;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty2222;
      chunk.right = _empty2222;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty2222;
      chunk.right = _empty2222;
      break;
    }
  }
  return chunk;
};
var isChunk222 = (u222) => hasProperty2222(u222, TypeId52222);
var _empty2222 = /* @__PURE__ */ makeChunk222({
  _tag: "IEmpty"
});
var empty3222 = () => _empty2222;
var make42222 = (...as22222) => as22222.length === 1 ? of32(as22222[0]) : unsafeFromNonEmptyArray222(as22222);
var of32 = (a222) => makeChunk222({
  _tag: "ISingleton",
  a: a222
});
var copyToArray222 = (self2, array3222, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy32(self2.backing.array, 0, array3222, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray222(self2.left, array3222, initial);
      copyToArray222(self2.right, array3222, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array3222[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i222 = 0;
      let j222 = initial;
      while (i222 < self2.length) {
        array3222[j222] = unsafeGet2222(self2, i222);
        i222 += 1;
        j222 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray222 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray222;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray222(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty2222;
      self2.right = _empty2222;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse2222 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk222({
        _tag: "IArray",
        array: reverse42(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk222({
        _tag: "IConcat",
        left: reverse2222(self2.backing.right),
        right: reverse2222(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray222(reverse42(toReadonlyArray222(self2)));
  }
};
var unsafeFromArray222 = (self2) => makeChunk222({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray222 = (self2) => unsafeFromArray222(self2);
var unsafeGet2222 = /* @__PURE__ */ dual2222(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet2222(self2.left, index) : unsafeGet2222(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet2222(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend32 = /* @__PURE__ */ dual2222(2, (self2, elem) => appendAll32(of32(elem), self2));
var drop32 = /* @__PURE__ */ dual2222(2, (self2, n222) => {
  if (n222 <= 0) {
    return self2;
  } else if (n222 >= self2.length) {
    return _empty2222;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk222({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n222,
          length: self2.backing.length - n222
        });
      }
      case "IConcat": {
        if (n222 > self2.left.length) {
          return drop32(self2.right, n222 - self2.left.length);
        }
        return makeChunk222({
          _tag: "IConcat",
          left: drop32(self2.left, n222),
          right: self2.right
        });
      }
      default: {
        return makeChunk222({
          _tag: "ISlice",
          chunk: self2,
          offset: n222,
          length: self2.length - n222
        });
      }
    }
  }
});
var appendAll32 = /* @__PURE__ */ dual2222(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff2222 = that.depth - self2.depth;
  if (Math.abs(diff2222) <= 1) {
    return makeChunk222({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff2222 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll32(self2.right, that);
      return makeChunk222({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll32(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk222({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk222({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk222({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk222({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll32(self2, that.left);
      return makeChunk222({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll32(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk222({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk222({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk222({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk222({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty222 = (self2) => self2.length === 0;
var isNonEmpty222 = (self2) => self2.length > 0;
var unsafeHead222 = (self2) => unsafeGet2222(self2, 0);
var headNonEmpty32 = unsafeHead222;
var tailNonEmpty32 = (self2) => drop32(self2, 1);
var SIZE222 = 5;
var BUCKET_SIZE222 = /* @__PURE__ */ Math.pow(2, SIZE222);
var MASK222 = BUCKET_SIZE222 - 1;
var MAX_INDEX_NODE222 = BUCKET_SIZE222 / 2;
var MIN_ARRAY_NODE222 = BUCKET_SIZE222 / 4;
function popcount222(x222) {
  x222 -= x222 >> 1 & 1431655765;
  x222 = (x222 & 858993459) + (x222 >> 2 & 858993459);
  x222 = x222 + (x222 >> 4) & 252645135;
  x222 += x222 >> 8;
  x222 += x222 >> 16;
  return x222 & 127;
}
function hashFragment222(shift22, h222) {
  return h222 >>> shift22 & MASK222;
}
function toBitmap222(x222) {
  return 1 << x222;
}
function fromBitmap222(bitmap, bit) {
  return popcount222(bitmap & bit - 1);
}
var make5222 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate222(mutate2222, at, v222, arr) {
  let out = arr;
  if (!mutate2222) {
    const len = arr.length;
    out = new Array(len);
    for (let i222 = 0; i222 < len; ++i222) out[i222] = arr[i222];
  }
  out[at] = v222;
  return out;
}
function arraySpliceOut222(mutate2222, at, arr) {
  const newLen = arr.length - 1;
  let i222 = 0;
  let g222 = 0;
  let out = arr;
  if (mutate2222) {
    i222 = g222 = at;
  } else {
    out = new Array(newLen);
    while (i222 < at) out[g222++] = arr[i222++];
  }
  ++i222;
  while (i222 <= newLen) out[g222++] = arr[i222++];
  if (mutate2222) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn222(mutate2222, at, v222, arr) {
  const len = arr.length;
  if (mutate2222) {
    let i2222 = len;
    while (i2222 >= at) arr[i2222--] = arr[i2222];
    arr[at] = v222;
    return arr;
  }
  let i222 = 0, g222 = 0;
  const out = new Array(len + 1);
  while (i222 < at) out[g222++] = arr[i222++];
  out[at] = v222;
  while (i222 < len) out[++g222] = arr[i222++];
  return out;
}
var EmptyNode222 = class _EmptyNode222 {
  _tag = "EmptyNode";
  modify(edit, _shift, f222, hash22222, key, size4222) {
    const v222 = f222(none22222());
    if (isNone22222(v222)) return new _EmptyNode222();
    ++size4222.value;
    return new LeafNode222(edit, hash22222, key, v222);
  }
};
function isEmptyNode222(a222) {
  return isTagged32(a222, "EmptyNode");
}
function isLeafNode222(node) {
  return isEmptyNode222(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode222(node, edit) {
  return isEmptyNode222(node) ? false : edit === node.edit;
}
var LeafNode222 = class _LeafNode222 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash22222, key, value) {
    this.edit = edit;
    this.hash = hash22222;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f222, hash22222, key, size4222) {
    if (equals2222(key, this.key)) {
      const v2222 = f222(this.value);
      if (v2222 === this.value) return this;
      else if (isNone22222(v2222)) {
        --size4222.value;
        return new EmptyNode222();
      }
      if (canEditNode222(this, edit)) {
        this.value = v2222;
        return this;
      }
      return new _LeafNode222(edit, hash22222, key, v2222);
    }
    const v222 = f222(none22222());
    if (isNone22222(v222)) return this;
    ++size4222.value;
    return mergeLeaves222(edit, shift22, this.hash, this, hash22222, new _LeafNode222(edit, hash22222, key, v222));
  }
};
var CollisionNode222 = class _CollisionNode222 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash22222, children) {
    this.edit = edit;
    this.hash = hash22222;
    this.children = children;
  }
  modify(edit, shift22, f222, hash22222, key, size4222) {
    if (hash22222 === this.hash) {
      const canEdit = canEditNode222(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f222, key, size4222);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode222(edit, this.hash, list) : list[0];
    }
    const v222 = f222(none22222());
    if (isNone22222(v222)) return this;
    ++size4222.value;
    return mergeLeaves222(edit, shift22, this.hash, this, hash22222, new LeafNode222(edit, hash22222, key, v222));
  }
  updateCollisionList(mutate2222, edit, hash22222, list, f222, key, size4222) {
    const len = list.length;
    for (let i222 = 0; i222 < len; ++i222) {
      const child = list[i222];
      if ("key" in child && equals2222(key, child.key)) {
        const value = child.value;
        const newValue2 = f222(value);
        if (newValue2 === value) return list;
        if (isNone22222(newValue2)) {
          --size4222.value;
          return arraySpliceOut222(mutate2222, i222, list);
        }
        return arrayUpdate222(mutate2222, i222, new LeafNode222(edit, hash22222, key, newValue2), list);
      }
    }
    const newValue = f222(none22222());
    if (isNone22222(newValue)) return list;
    ++size4222.value;
    return arrayUpdate222(mutate2222, len, new LeafNode222(edit, hash22222, key, newValue), list);
  }
};
var IndexedNode222 = class _IndexedNode222 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f222, hash22222, key, size4222) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment222(shift22, hash22222);
    const bit = toBitmap222(frag);
    const indx = fromBitmap222(mask, bit);
    const exists22222 = mask & bit;
    const canEdit = canEditNode222(this, edit);
    if (!exists22222) {
      const _newChild = new EmptyNode222().modify(edit, shift22 + SIZE222, f222, hash22222, key, size4222);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE222 ? expand222(edit, frag, _newChild, mask, children) : new _IndexedNode222(edit, mask | bit, arraySpliceIn222(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE222, f222, hash22222, key, size4222);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode222(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode222();
      if (children.length <= 2 && isLeafNode222(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut222(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate222(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode222(edit, bitmap, newChildren);
  }
};
var ArrayNode222 = class _ArrayNode222 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size4222, children) {
    this.edit = edit;
    this.size = size4222;
    this.children = children;
  }
  modify(edit, shift22, f222, hash22222, key, size4222) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment222(shift22, hash22222);
    const child = children[frag];
    const newChild = (child || new EmptyNode222()).modify(edit, shift22 + SIZE222, f222, hash22222, key, size4222);
    if (child === newChild) return this;
    const canEdit = canEditNode222(this, edit);
    let newChildren;
    if (isEmptyNode222(child) && !isEmptyNode222(newChild)) {
      ++count;
      newChildren = arrayUpdate222(canEdit, frag, newChild, children);
    } else if (!isEmptyNode222(child) && isEmptyNode222(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE222) {
        return pack222(edit, count, frag, children);
      }
      newChildren = arrayUpdate222(canEdit, frag, new EmptyNode222(), children);
    } else {
      newChildren = arrayUpdate222(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode222(edit, count, newChildren);
  }
};
function pack222(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g222 = 0;
  let bitmap = 0;
  for (let i222 = 0, len = elements.length; i222 < len; ++i222) {
    if (i222 !== removed) {
      const elem = elements[i222];
      if (elem && !isEmptyNode222(elem)) {
        children[g222++] = elem;
        bitmap |= 1 << i222;
      }
    }
  }
  return new IndexedNode222(edit, bitmap, children);
}
function expand222(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i222 = 0; bit; ++i222) {
    if (bit & 1) arr[i222] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode222(edit, count + 1, arr);
}
function mergeLeavesInner222(edit, shift22, h1, n1, h222, n222) {
  if (h1 === h222) return new CollisionNode222(edit, h1, [n222, n1]);
  const subH1 = hashFragment222(shift22, h1);
  const subH2 = hashFragment222(shift22, h222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode222(edit, toBitmap222(subH1) | toBitmap222(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n222] : [n222, n1];
    return new IndexedNode222(edit, toBitmap222(subH1) | toBitmap222(subH2), children);
  }
}
function mergeLeaves222(edit, shift22, h1, n1, h222, n222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner222(edit, currentShift, h1, n1, h222, n222);
    if (typeof res === "function") {
      stack = make5222(res, stack);
      currentShift = currentShift + SIZE222;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey222 = "effect/HashMap";
var HashMapTypeId222 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey222);
var HashMapProto222 = {
  [HashMapTypeId222]: HashMapTypeId222,
  [Symbol.iterator]() {
    return new HashMapIterator222(this, (k222, v222) => [k222, v222]);
  },
  [symbol3222]() {
    let hash22222 = hash2222(HashMapSymbolKey222);
    for (const item of this) {
      hash22222 ^= pipe2222(hash2222(item[0]), combine2222(hash2222(item[1])));
    }
    return cached2222(this, hash22222);
  },
  [symbol22222](that) {
    if (isHashMap222(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe2222(that, getHash222(item[0], hash2222(item[0])));
        if (isNone22222(elem)) {
          return false;
        } else {
          if (!equals2222(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format2222(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON2222)
    };
  },
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments2222(this, arguments);
  }
};
var makeImpl322 = (editable, edit, root, size4222) => {
  const map622 = Object.create(HashMapProto222);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size4222;
  return map622;
};
var HashMapIterator222 = class _HashMapIterator222 {
  map;
  f;
  v;
  constructor(map622, f222) {
    this.map = map622;
    this.f = f222;
    this.v = visitLazy222(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone22222(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont222(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator222(this.map, this.f);
  }
};
var applyCont222 = (cont) => cont ? visitLazyChildren222(cont[0], cont[1], cont[2], cont[3], cont[4]) : none22222();
var visitLazy222 = (node, f222, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome22222(node.value)) {
        return some32222({
          value: f222(node.key, node.value.value),
          cont
        });
      }
      return applyCont222(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren222(children.length, children, 0, f222, cont);
    }
    default: {
      return applyCont222(cont);
    }
  }
};
var visitLazyChildren222 = (len, children, i222, f222, cont) => {
  while (i222 < len) {
    const child = children[i222++];
    if (child && !isEmptyNode222(child)) {
      return visitLazy222(child, f222, [len, children, i222, f222, cont]);
    }
  }
  return applyCont222(cont);
};
var _empty3222 = /* @__PURE__ */ makeImpl322(false, 0, /* @__PURE__ */ new EmptyNode222(), 0);
var empty4222 = () => _empty3222;
var isHashMap222 = (u222) => hasProperty2222(u222, HashMapTypeId222);
var getHash222 = /* @__PURE__ */ dual2222(3, (self2, key, hash22222) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals2222(key, node.key) ? node.value : none22222();
      }
      case "CollisionNode": {
        if (hash22222 === node.hash) {
          const children = node.children;
          for (let i222 = 0, len = children.length; i222 < len; ++i222) {
            const child = children[i222];
            if ("key" in child && equals2222(key, child.key)) {
              return child.value;
            }
          }
        }
        return none22222();
      }
      case "IndexedNode": {
        const frag = hashFragment222(shift22, hash22222);
        const bit = toBitmap222(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap222(node.mask, bit)];
          shift22 += SIZE222;
          break;
        }
        return none22222();
      }
      case "ArrayNode": {
        node = node.children[hashFragment222(shift22, hash22222)];
        if (node) {
          shift22 += SIZE222;
          break;
        }
        return none22222();
      }
      default:
        return none22222();
    }
  }
});
var set2222 = /* @__PURE__ */ dual2222(3, (self2, key, value) => modifyAt222(self2, key, () => some32222(value)));
var setTree222 = /* @__PURE__ */ dual2222(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl322(self2._editable, self2._edit, newRoot, newSize);
});
var keys32 = (self2) => new HashMapIterator222(self2, (key) => key);
var size422 = (self2) => self2._size;
var beginMutation322 = (self2) => makeImpl322(true, self2._edit + 1, self2._root, self2._size);
var modifyAt222 = /* @__PURE__ */ dual2222(3, (self2, key, f222) => modifyHash222(self2, key, hash2222(key), f222));
var modifyHash222 = /* @__PURE__ */ dual2222(4, (self2, key, hash22222, f222) => {
  const size4222 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f222, hash22222, key, size4222);
  return pipe2222(self2, setTree222(newRoot, size4222.value));
});
var forEach42 = /* @__PURE__ */ dual2222(2, (self2, f222) => reduce2222(self2, void 0, (_222, value, key) => f222(value, key)));
var reduce2222 = /* @__PURE__ */ dual2222(3, (self2, zero, f222) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome22222(root.value) ? f222(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i222 = 0, len = children.length; i222 < len; ) {
      const child = children[i222++];
      if (child && !isEmptyNode222(child)) {
        if (child._tag === "LeafNode") {
          if (isSome22222(child.value)) {
            zero = f222(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey222 = "effect/HashSet";
var HashSetTypeId222 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey222);
var HashSetProto222 = {
  [HashSetTypeId222]: HashSetTypeId222,
  [Symbol.iterator]() {
    return keys32(this._keyMap);
  },
  [symbol3222]() {
    return cached2222(this, combine2222(hash2222(this._keyMap))(hash2222(HashSetSymbolKey222)));
  },
  [symbol22222](that) {
    if (isHashSet222(that)) {
      return size422(this._keyMap) === size422(that._keyMap) && equals2222(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format2222(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON2222)
    };
  },
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments2222(this, arguments);
  }
};
var makeImpl2222 = (keyMap) => {
  const set22222 = Object.create(HashSetProto222);
  set22222._keyMap = keyMap;
  return set22222;
};
var isHashSet222 = (u222) => hasProperty2222(u222, HashSetTypeId222);
var _empty4222 = /* @__PURE__ */ makeImpl2222(/* @__PURE__ */ empty4222());
var empty5222 = () => _empty4222;
var size2222 = (self2) => size422(self2._keyMap);
var beginMutation2222 = (self2) => makeImpl2222(beginMutation322(self2._keyMap));
var endMutation222 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate222 = /* @__PURE__ */ dual2222(2, (self2, f222) => {
  const transient = beginMutation2222(self2);
  f222(transient);
  return endMutation222(transient);
});
var add2222 = /* @__PURE__ */ dual2222(2, (self2, value) => self2._keyMap._editable ? (set2222(value, true)(self2._keyMap), self2) : makeImpl2222(set2222(value, true)(self2._keyMap)));
var union2222 = /* @__PURE__ */ dual2222(2, (self2, that) => mutate222(empty5222(), (set22222) => {
  forEach2222(self2, (value) => add2222(set22222, value));
  for (const value of that) {
    add2222(set22222, value);
  }
}));
var forEach2222 = /* @__PURE__ */ dual2222(2, (self2, f222) => forEach42(self2._keyMap, (_222, k222) => f222(k222)));
var empty6222 = empty5222;
var size3222 = size2222;
var add3222 = add2222;
var union3222 = union2222;
var ArrayProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol3222]() {
    return cached2222(this, array52(this));
  },
  [symbol22222](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v222, i222) => equals2222(v222, that[i222]));
    } else {
      return false;
    }
  }
});
var Structural322 = /* @__PURE__ */ function() {
  function Structural3222(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural3222.prototype = StructuralPrototype222;
  return Structural3222;
}();
var struct2222 = (as22222) => Object.assign(Object.create(StructuralPrototype222), as22222);
var ContextPatchTypeId222 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance322(a222) {
  return a222;
}
var PatchProto222 = {
  ...Structural322.prototype,
  [ContextPatchTypeId222]: {
    _Value: variance322,
    _Patch: variance322
  }
};
var EmptyProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto222), {
  _tag: "Empty"
});
var _empty5222 = /* @__PURE__ */ Object.create(EmptyProto222);
var empty7222 = () => _empty5222;
var AndThenProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto222), {
  _tag: "AndThen"
});
var makeAndThen222 = (first, second) => {
  const o222 = Object.create(AndThenProto222);
  o222.first = first;
  o222.second = second;
  return o222;
};
var AddServiceProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto222), {
  _tag: "AddService"
});
var makeAddService222 = (key, service) => {
  const o222 = Object.create(AddServiceProto222);
  o222.key = key;
  o222.service = service;
  return o222;
};
var RemoveServiceProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto222), {
  _tag: "RemoveService"
});
var makeRemoveService222 = (key) => {
  const o222 = Object.create(RemoveServiceProto222);
  o222.key = key;
  return o222;
};
var UpdateServiceProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto222), {
  _tag: "UpdateService"
});
var makeUpdateService222 = (key, update222) => {
  const o222 = Object.create(UpdateServiceProto222);
  o222.key = key;
  o222.update = update222;
  return o222;
};
var diff222 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch2222 = empty7222();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals2222(old, newService)) {
        patch2222 = combine22222(makeUpdateService222(tag, () => newService))(patch2222);
      }
    } else {
      missingServices.delete(tag);
      patch2222 = combine22222(makeAddService222(tag, newService))(patch2222);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch2222 = combine22222(makeRemoveService222(tag))(patch2222);
  }
  return patch2222;
};
var combine22222 = /* @__PURE__ */ dual2222(2, (self2, that) => makeAndThen222(self2, that));
var patch222 = /* @__PURE__ */ dual2222(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of32(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty222(patches)) {
    const head222 = headNonEmpty32(patches);
    const tail222 = tailNonEmpty32(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail222;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail222;
        break;
      }
      case "AndThen": {
        patches = prepend32(prepend32(tail222, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail222;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail222;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext222(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s222] of updatedContext) {
    map622.set(tag, s222);
  }
  return makeContext222(map622);
});
var DifferTypeId222 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto222 = {
  [DifferTypeId222]: {
    _P: identity2222,
    _V: identity2222
  }
};
var make7222 = (params) => {
  const differ = Object.create(DifferProto222);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment222 = () => make7222({
  empty: empty7222(),
  combine: (first, second) => combine22222(second)(first),
  diff: (oldValue, newValue) => diff222(oldValue, newValue),
  patch: (patch2222, oldValue) => patch222(oldValue)(patch2222)
});
var OP_DIE222 = "Die";
var OP_EMPTY222 = "Empty";
var OP_FAIL222 = "Fail";
var OP_INTERRUPT222 = "Interrupt";
var OP_PARALLEL222 = "Parallel";
var OP_SEQUENTIAL222 = "Sequential";
var CauseSymbolKey222 = "effect/Cause";
var CauseTypeId222 = /* @__PURE__ */ Symbol.for(CauseSymbolKey222);
var variance2222 = {
  /* c8 ignore next */
  _E: (_222) => _222
};
var proto222 = {
  [CauseTypeId222]: variance2222,
  [symbol3222]() {
    return pipe2222(hash2222(CauseSymbolKey222), combine2222(hash2222(flattenCause222(this))), cached2222(this));
  },
  [symbol22222](that) {
    return isCause222(that) && causeEquals222(this, that);
  },
  pipe() {
    return pipeArguments2222(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON2222(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON2222(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON2222(this.left),
          right: toJSON2222(this.right)
        };
    }
  },
  toString() {
    return pretty222(this);
  },
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  }
};
var fail322 = (error) => {
  const o222 = Object.create(proto222);
  o222._tag = OP_FAIL222;
  o222.error = error;
  return o222;
};
var parallel222 = (left3222, right3222) => {
  const o222 = Object.create(proto222);
  o222._tag = OP_PARALLEL222;
  o222.left = left3222;
  o222.right = right3222;
  return o222;
};
var sequential222 = (left3222, right3222) => {
  const o222 = Object.create(proto222);
  o222._tag = OP_SEQUENTIAL222;
  o222.left = left3222;
  o222.right = right3222;
  return o222;
};
var isCause222 = (u222) => hasProperty2222(u222, CauseTypeId222);
var isInterruptedOnly222 = (self2) => reduceWithContext222(void 0, IsInterruptedOnlyCauseReducer222)(self2);
var causeEquals222 = (left3222, right3222) => {
  let leftStack = of32(left3222);
  let rightStack = of32(right3222);
  while (isNonEmpty222(leftStack) && isNonEmpty222(rightStack)) {
    const [leftParallel, leftSequential] = pipe2222(headNonEmpty32(leftStack), reduce4222([empty6222(), empty3222()], ([parallel2222, sequential2222], cause) => {
      const [par, seq] = evaluateCause222(cause);
      return some32222([pipe2222(parallel2222, union3222(par)), pipe2222(sequential2222, appendAll32(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe2222(headNonEmpty32(rightStack), reduce4222([empty6222(), empty3222()], ([parallel2222, sequential2222], cause) => {
      const [par, seq] = evaluateCause222(cause);
      return some32222([pipe2222(parallel2222, union3222(par)), pipe2222(sequential2222, appendAll32(seq))]);
    }));
    if (!equals2222(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause222 = (cause) => {
  return flattenCauseLoop222(of32(cause), empty3222());
};
var flattenCauseLoop222 = (causes, flattened) => {
  while (1) {
    const [parallel2222, sequential2222] = pipe2222(causes, reduce52([empty6222(), empty3222()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause222(cause);
      return [pipe2222(parallel322, union3222(par)), pipe2222(sequential322, appendAll32(seq))];
    }));
    const updated = size3222(parallel2222) > 0 ? pipe2222(flattened, prepend32(parallel2222)) : flattened;
    if (isEmpty222(sequential2222)) {
      return reverse2222(updated);
    }
    causes = sequential2222;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage2222("Cause.flattenCauseLoop"));
};
var evaluateCause222 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty6222();
  let _sequential = empty3222();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY222: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL222: {
        _parallel = add3222(_parallel, make42222(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE222: {
        _parallel = add3222(_parallel, make42222(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT222: {
        _parallel = add3222(_parallel, make42222(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL222: {
        switch (cause.left._tag) {
          case OP_EMPTY222: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL222: {
            cause = sequential222(cause.left.left, sequential222(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL222: {
            cause = parallel222(sequential222(cause.left.left, cause.right), sequential222(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend32(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL222: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage2222("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer222 = {
  emptyCase: constTrue2222,
  failCase: constFalse2222,
  dieCase: constFalse2222,
  interruptCase: constTrue2222,
  sequentialCase: (_222, left3222, right3222) => left3222 && right3222,
  parallelCase: (_222, left3222, right3222) => left3222 && right3222
};
var OP_SEQUENTIAL_CASE222 = "SequentialCase";
var OP_PARALLEL_CASE222 = "ParallelCase";
var reduce4222 = /* @__PURE__ */ dual2222(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome22222(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL222: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL222: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext222 = /* @__PURE__ */ dual2222(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY222: {
        output.push(right22222(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL222: {
        output.push(right22222(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE222: {
        output.push(right22222(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT222: {
        output.push(right22222(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL222: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left22222({
          _tag: OP_SEQUENTIAL_CASE222
        }));
        break;
      }
      case OP_PARALLEL222: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left22222({
          _tag: OP_PARALLEL_CASE222
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE222: {
            const left3222 = accumulator.pop();
            const right3222 = accumulator.pop();
            const value = reducer.sequentialCase(context, left3222, right3222);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE222: {
            const left3222 = accumulator.pop();
            const right3222 = accumulator.pop();
            const value = reducer.parallelCase(context, left3222, right3222);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty222 = (cause) => {
  if (isInterruptedOnly222(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors222(cause).map((e222) => e222.stack).join("\n");
};
var PrettyError222 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage222(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol322 in originalError) {
        this.span = originalError[spanSymbol322];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack222(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage222 = (u222) => {
  if (typeof u222 === "string") {
    return `Error: ${u222}`;
  }
  try {
    if (hasProperty2222(u222, "toString") && isFunction3222(u222["toString"]) && u222["toString"] !== Object.prototype.toString && u222["toString"] !== globalThis.Array.prototype.toString) {
      return u222["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u222)}`;
};
var locationRegex222 = /\((.*)\)/;
var spanToTrace222 = /* @__PURE__ */ globalValue2222("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack222 = (message, stack, span22) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i222 = 1; i222 < lines.length; i222++) {
    if (lines[i222].includes("Generator.next")) {
      break;
    }
    if (lines[i222].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i222].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span22) {
    let current = span22;
    let i222 = 0;
    while (current && current._tag === "Span" && i222 < 10) {
      const stackFn = spanToTrace222.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex222);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined2222(current.parent);
      i222++;
    }
  }
  return out.join("\n");
};
var spanSymbol322 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors222 = (cause) => reduceWithContext222(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_222, unknownError) => {
    return [new PrettyError222(unknownError)];
  },
  failCase: (_222, error) => {
    return [new PrettyError222(error)];
  },
  interruptCase: () => [],
  parallelCase: (_222, l222, r222) => [...l222, ...r222],
  sequentialCase: (_222, l222, r222) => [...l222, ...r222]
});
var SingleShotGen22222 = class _SingleShotGen2222 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a222) {
    return this.called ? {
      value: a222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a222) {
    return {
      value: a222,
      done: true
    };
  }
  throw(e222) {
    throw e222;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen2222(this.self);
  }
};
var spanTag222 = /* @__PURE__ */ GenericTag222("effect/ParentSpan");
var EffectTypeId22222 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive222 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId22222] = effectVariance2222;
  constructor(_op) {
    this._op = _op;
  }
  [symbol22222](that) {
    return this === that;
  }
  [symbol3222]() {
    return cached2222(this, random2222(this));
  }
  pipe() {
    return pipeArguments2222(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON2222(this.effect_instruction_i0),
      effect_instruction_i1: toJSON2222(this.effect_instruction_i1),
      effect_instruction_i2: toJSON2222(this.effect_instruction_i2)
    };
  }
  toString() {
    return format2222(this.toJSON());
  }
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen22222(new YieldWrap2222(this));
  }
};
var EffectPrimitiveFailure222 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId22222] = effectVariance2222;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol22222](that) {
    return exitIsExit222(that) && that._op === "Failure" && // @ts-expect-error
    equals2222(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol3222]() {
    return pipe2222(
      // @ts-expect-error
      string2222(this._tag),
      // @ts-expect-error
      combine2222(hash2222(this.effect_instruction_i0)),
      cached2222(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments2222(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format2222(this.toJSON());
  }
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen22222(new YieldWrap2222(this));
  }
};
var isEffect222 = (u222) => hasProperty2222(u222, EffectTypeId22222);
var withFiberRuntime222 = (withRuntime) => {
  const effect = new EffectPrimitive222(OP_WITH_RUNTIME222);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol2222 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol222 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture222 = (obj, span22) => {
  if (isSome22222(span22)) {
    return new Proxy(obj, {
      has(target, p222) {
        return p222 === spanSymbol2222 || p222 === originalSymbol222 || p222 in target;
      },
      get(target, p222) {
        if (p222 === spanSymbol2222) {
          return span22.value;
        }
        if (p222 === originalSymbol222) {
          return obj;
        }
        return target[p222];
      }
    });
  }
  return obj;
};
var fail2222 = (error) => isObject2222(error) && !(spanSymbol2222 in error) ? withFiberRuntime222((fiber) => failCause222(fail322(capture222(error, currentSpanFromFiber222(fiber))))) : failCause222(fail322(error));
var failCause222 = (cause) => {
  const effect = new EffectPrimitiveFailure222(OP_FAILURE222);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey222 = "effect/FiberRef";
var FiberRefTypeId222 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey222);
var fiberRefVariance222 = {
  /* c8 ignore next */
  _A: (_222) => _222
};
var fiberRefUnsafeMakeContext222 = (initial) => {
  const differ = environment222();
  return fiberRefUnsafeMakePatch222(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch222 = (initial, options) => ({
  [FiberRefTypeId222]: fiberRefVariance222,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch2222) => (oldValue) => options.differ.patch(patch2222, oldValue),
  fork: options.fork,
  join: options.join ?? ((_222, n222) => n222),
  pipe() {
    return pipeArguments2222(this, arguments);
  }
});
var currentContext222 = /* @__PURE__ */ globalValue2222(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext222(empty2222()));
var YieldableError222 = /* @__PURE__ */ function() {
  class YieldableError2222 extends globalThis.Error {
    commit() {
      return fail2222(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol2222]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError2222.prototype, StructuralCommitPrototype222);
  return YieldableError2222;
}();
var exitIsExit222 = (u222) => isEffect222(u222) && "_tag" in u222 && (u222._tag === "Success" || u222._tag === "Failure");
var currentSpanFromFiber222 = (fiber) => {
  const span22 = fiber.getFiberRef(currentContext222).unsafeMap.get(spanTag222.key);
  return span22 !== void 0 && span22._tag === "Span" ? some32222(span22) : none22222();
};
var Data_exports222 = {};
__export2222(Data_exports222, {
  Class: () => Class2222,
  Error: () => Error2222,
  Structural: () => Structural2222,
  TaggedClass: () => TaggedClass222,
  TaggedError: () => TaggedError222,
  array: () => array2222,
  case: () => _case222,
  struct: () => struct3222,
  tagged: () => tagged222,
  taggedEnum: () => taggedEnum222,
  tuple: () => tuple2222,
  unsafeArray: () => unsafeArray222,
  unsafeStruct: () => unsafeStruct222
});
var struct3222 = struct2222;
var unsafeStruct222 = (as22222) => Object.setPrototypeOf(as22222, StructuralPrototype222);
var tuple2222 = (...as22222) => unsafeArray222(as22222);
var array2222 = (as22222) => unsafeArray222(as22222.slice(0));
var unsafeArray222 = (as22222) => Object.setPrototypeOf(as22222, ArrayProto222);
var _case222 = () => (args) => args === void 0 ? Object.create(StructuralPrototype222) : struct3222(args);
var tagged222 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype222) : struct3222(args);
  value._tag = tag;
  return value;
};
var Class2222 = Structural322;
var TaggedClass222 = (tag) => {
  class Base extends Class2222 {
    _tag = tag;
  }
  return Base;
};
var Structural2222 = Structural322;
var taggedEnum222 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged32;
    } else if (tag === "$match") {
      return taggedMatch222;
    }
    return tagged222(tag);
  }
});
function taggedMatch222() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error2222 = /* @__PURE__ */ function() {
  return class Base extends YieldableError222 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError222 = (tag) => {
  class Base extends Error2222 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp222 = Function_exports2222.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType222.Program) return Option_exports2222.none();
  return predicate(parent) ? Option_exports2222.some(parent) : traverseUp222(parent, predicate);
});
var traverseUpGuard222 = Function_exports2222.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType222.Program) return Option_exports2222.none();
  return predicate(parent) ? Option_exports2222.some(parent) : traverseUpGuard222(parent, predicate);
});
var ESLintCommunityESLintUtils222;
((ESLintCommunityESLintUtils2222) => {
  ESLintCommunityESLintUtils2222.getFunctionHeadLocation = getFunctionHeadLocation222;
  ESLintCommunityESLintUtils2222.getFunctionNameWithKind = getFunctionNameWithKind222;
  ESLintCommunityESLintUtils2222.getPropertyName = getPropertyName222;
  ESLintCommunityESLintUtils2222.getStaticValue = getStaticValue222;
  ESLintCommunityESLintUtils2222.getStringIfConstant = getStringIfConstant222;
  ESLintCommunityESLintUtils2222.hasSideEffect = hasSideEffect222;
  ESLintCommunityESLintUtils2222.isParenthesized = isParenthesized222;
})(ESLintCommunityESLintUtils222 || (ESLintCommunityESLintUtils222 = {}));
var Construction222 = Data_exports222.taggedEnum();
Construction222.None();
a3({
  type: N3.union([NodeType222.FunctionExpression, NodeType222.ArrowFunctionExpression]),
  parent: {
    type: NodeType222.Property,
    parent: {
      type: NodeType222.ObjectExpression
    }
  }
});
a3({
  type: N3.union([NodeType222.FunctionExpression, NodeType222.ArrowFunctionExpression]),
  parent: {
    type: NodeType222.MethodDefinition,
    parent: {
      type: NodeType222.ClassBody
    }
  }
});
a3({
  type: N3.union([NodeType222.FunctionExpression, NodeType222.ArrowFunctionExpression]),
  parent: {
    type: NodeType222.Property,
    parent: {
      type: NodeType222.ClassBody
    }
  }
});
function getVariableInit2(at) {
  return (variable) => {
    return Function_exports32.pipe(
      Option_exports32.some(variable),
      Option_exports32.flatMapNullable((v222) => v222.defs.at(at)),
      Option_exports32.flatMap(
        (d222) => "init" in d222.node ? Option_exports32.fromNullable(d222.node.init) : Option_exports32.none()
      )
    );
  };
}
isOneOf22([NodeType22.Literal, NodeType22.JSXText]);
var JSXValueHint2 = {
  None: 0n,
  SkipNullLiteral: 1n << 0n,
  SkipUndefinedLiteral: 1n << 1n,
  SkipBooleanLiteral: 1n << 2n,
  SkipStringLiteral: 1n << 3n,
  SkipNumberLiteral: 1n << 4n,
  SkipCreateElement: 1n << 5n,
  StrictArray: 1n << 6n,
  StrictLogical: 1n << 7n,
  StrictConditional: 1n << 8n
};
var DEFAULT_JSX_VALUE_HINT2 = JSXValueHint2.SkipUndefinedLiteral | JSXValueHint2.SkipBooleanLiteral;
function isJSXValue(node, context, hint = DEFAULT_JSX_VALUE_HINT2) {
  if (!node) return false;
  return $(node).with({ type: NodeType22.JSXElement }, Function_exports222.constTrue).with({ type: NodeType22.JSXFragment }, Function_exports222.constTrue).with({ type: NodeType22.JSXMemberExpression }, Function_exports222.constTrue).with({ type: NodeType22.JSXNamespacedName }, Function_exports222.constTrue).with({ type: NodeType22.Literal }, (node2) => {
    return $(node2.value).with(null, () => !(hint & JSXValueHint2.SkipNullLiteral)).with(N.boolean, () => !(hint & JSXValueHint2.SkipBooleanLiteral)).with(N.string, () => !(hint & JSXValueHint2.SkipStringLiteral)).with(N.number, () => !(hint & JSXValueHint2.SkipNumberLiteral)).otherwise(Function_exports222.constFalse);
  }).with({ type: NodeType22.TemplateLiteral }, () => !(hint & JSXValueHint2.SkipStringLiteral)).with({ type: NodeType22.ArrayExpression }, (node2) => {
    if (hint & JSXValueHint2.StrictArray) return node2.elements.every((n222) => isJSXValue(n222, context, hint));
    return node2.elements.some((n222) => isJSXValue(n222, context, hint));
  }).with({ type: NodeType22.ConditionalExpression }, (node2) => {
    function leftHasJSX(node3) {
      if (Array.isArray(node3.consequent)) {
        if (hint & JSXValueHint2.StrictArray) {
          return node3.consequent.every((n222) => isJSXValue(n222, context, hint));
        }
        return node3.consequent.some((n222) => isJSXValue(n222, context, hint));
      }
      return isJSXValue(node3.consequent, context, hint);
    }
    function rightHasJSX(node3) {
      return isJSXValue(node3.alternate, context, hint);
    }
    if (hint & JSXValueHint2.StrictConditional) {
      return leftHasJSX(node2) && rightHasJSX(node2);
    }
    return leftHasJSX(node2) || rightHasJSX(node2);
  }).with({ type: NodeType22.LogicalExpression }, (node2) => {
    return isJSXValue(node2.left, context, hint) || isJSXValue(node2.right, context, hint);
  }).with({ type: NodeType22.SequenceExpression }, (node2) => {
    const exp = node2.expressions.at(-1);
    return isJSXValue(exp, context, hint);
  }).with({ type: NodeType22.CallExpression }, (node2) => {
    if (hint & JSXValueHint2.SkipCreateElement) return false;
    return $(node2.callee).with({ type: NodeType22.Identifier, name: "createElement" }, Function_exports222.constTrue).with({ type: NodeType22.MemberExpression, property: { name: "createElement" } }, Function_exports222.constTrue).otherwise(Function_exports222.constFalse);
  }).with({ type: NodeType22.Identifier }, (node2) => {
    const { name: name2 } = node2;
    if (name2 === "undefined") return !(hint & JSXValueHint2.SkipUndefinedLiteral);
    if (isJSXTagNameExpression22(node2)) return true;
    const initialScope = context.sourceCode.getScope(node2);
    const maybeVariable = findVariable222(name2, initialScope);
    return Function_exports222.pipe(
      maybeVariable,
      Option_exports222.flatMap(getVariableInit2(0)),
      Option_exports222.exists((n222) => isJSXValue(n222, context, hint))
    );
  }).otherwise(Function_exports222.constFalse);
}
var Function_exports42 = {};
__export5(Function_exports42, {
  SK: () => SK42,
  absurd: () => absurd42,
  apply: () => apply42,
  compose: () => compose62,
  constFalse: () => constFalse42,
  constNull: () => constNull42,
  constTrue: () => constTrue42,
  constUndefined: () => constUndefined42,
  constVoid: () => constVoid42,
  constant: () => constant42,
  dual: () => dual42,
  flip: () => flip42,
  flow: () => flow42,
  hole: () => hole42,
  identity: () => identity42,
  isFunction: () => isFunction72,
  pipe: () => pipe42,
  satisfies: () => satisfies42,
  tupled: () => tupled42,
  unsafeCoerce: () => unsafeCoerce42,
  untupled: () => untupled42
});
var isFunction72 = (input) => typeof input === "function";
var dual42 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a32, b32) {
        if (arguments.length >= 2) {
          return body(a32, b32);
        }
        return function(self2) {
          return body(self2, a32);
        };
      };
    case 3:
      return function(a32, b32, c32) {
        if (arguments.length >= 3) {
          return body(a32, b32, c32);
        }
        return function(self2) {
          return body(self2, a32, b32);
        };
      };
    case 4:
      return function(a32, b32, c32, d32) {
        if (arguments.length >= 4) {
          return body(a32, b32, c32, d32);
        }
        return function(self2) {
          return body(self2, a32, b32, c32);
        };
      };
    case 5:
      return function(a32, b32, c32, d32, e32) {
        if (arguments.length >= 5) {
          return body(a32, b32, c32, d32, e32);
        }
        return function(self2) {
          return body(self2, a32, b32, c32, d32);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply42 = (a32) => (self2) => self2(a32);
var identity42 = (a32) => a32;
var satisfies42 = () => (b32) => b32;
var unsafeCoerce42 = identity42;
var constant42 = (value) => () => value;
var constTrue42 = /* @__PURE__ */ constant42(true);
var constFalse42 = /* @__PURE__ */ constant42(false);
var constNull42 = /* @__PURE__ */ constant42(null);
var constUndefined42 = /* @__PURE__ */ constant42(void 0);
var constVoid42 = constUndefined42;
var flip42 = (f32) => (...b32) => (...a32) => f32(...a32)(...b32);
var compose62 = /* @__PURE__ */ dual42(2, (ab, bc) => (a32) => bc(ab(a32)));
var absurd42 = (_32) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled42 = (f32) => (a32) => f32(...a32);
var untupled42 = (f32) => (...a32) => f32(a32);
function pipe42(a32, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a32;
    case 2:
      return ab(a32);
    case 3:
      return bc(ab(a32));
    case 4:
      return cd(bc(ab(a32)));
    case 5:
      return de(cd(bc(ab(a32))));
    case 6:
      return ef(de(cd(bc(ab(a32)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a32))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a32)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a32))))))));
    default: {
      let ret = arguments[0];
      for (let i32 = 1; i32 < arguments.length; i32++) {
        ret = arguments[i32](ret);
      }
      return ret;
    }
  }
}
function flow42(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole42 = /* @__PURE__ */ unsafeCoerce42(absurd42);
var SK42 = (_32, b32) => b32;
var make122 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_72 = (map72) => dual42(3, (self2, name2, f32) => map72(self2, (a32) => Object.assign({}, a32, {
  [name2]: f32(a32)
})));
var bindTo72 = (map72) => dual42(2, (self2, name2) => map72(self2, (a32) => ({
  [name2]: a32
})));
var bind72 = (map72, flatMap72) => dual42(3, (self2, name2, f32) => flatMap72(self2, (a32) => map72(f32(a32), (b32) => Object.assign({}, a32, {
  [name2]: b32
}))));
var moduleVersion42 = "3.2.8";
var getCurrentVersion42 = () => moduleVersion42;
var globalStoreId42 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion42()}`);
if (!(globalStoreId42 in globalThis)) {
  globalThis[globalStoreId42] = /* @__PURE__ */ new Map();
}
var globalStore42 = globalThis[globalStoreId42];
var globalValue42 = (id, compute) => {
  if (!globalStore42.has(id)) {
    globalStore42.set(id, compute());
  }
  return globalStore42.get(id);
};
var Predicate_exports32 = {};
__export5(Predicate_exports32, {
  all: () => all62,
  and: () => and42,
  compose: () => compose72,
  eqv: () => eqv42,
  every: () => every52,
  hasProperty: () => hasProperty42,
  implies: () => implies42,
  isBigInt: () => isBigInt42,
  isBoolean: () => isBoolean42,
  isDate: () => isDate42,
  isError: () => isError42,
  isFunction: () => isFunction8,
  isIterable: () => isIterable42,
  isMap: () => isMap42,
  isNever: () => isNever42,
  isNotNull: () => isNotNull42,
  isNotNullable: () => isNotNullable42,
  isNotUndefined: () => isNotUndefined42,
  isNull: () => isNull42,
  isNullable: () => isNullable42,
  isNumber: () => isNumber42,
  isObject: () => isObject42,
  isPromise: () => isPromise42,
  isPromiseLike: () => isPromiseLike42,
  isReadonlyRecord: () => isReadonlyRecord42,
  isRecord: () => isRecord42,
  isSet: () => isSet42,
  isString: () => isString42,
  isSymbol: () => isSymbol42,
  isTagged: () => isTagged42,
  isTruthy: () => isTruthy42,
  isUint8Array: () => isUint8Array42,
  isUndefined: () => isUndefined42,
  isUnknown: () => isUnknown42,
  mapInput: () => mapInput52,
  nand: () => nand42,
  nor: () => nor42,
  not: () => not42,
  or: () => or42,
  product: () => product62,
  productMany: () => productMany62,
  some: () => some92,
  struct: () => struct62,
  tuple: () => tuple52,
  xor: () => xor42
});
var mapInput52 = /* @__PURE__ */ dual42(2, (self2, f32) => (b32) => self2(f32(b32)));
var isTruthy42 = (input) => !!input;
var isSet42 = (input) => input instanceof Set;
var isMap42 = (input) => input instanceof Map;
var isString42 = (input) => typeof input === "string";
var isNumber42 = (input) => typeof input === "number";
var isBoolean42 = (input) => typeof input === "boolean";
var isBigInt42 = (input) => typeof input === "bigint";
var isSymbol42 = (input) => typeof input === "symbol";
var isFunction8 = isFunction72;
var isUndefined42 = (input) => input === void 0;
var isNotUndefined42 = (input) => input !== void 0;
var isNull42 = (input) => input === null;
var isNotNull42 = (input) => input !== null;
var isNever42 = (_32) => false;
var isUnknown42 = (_32) => true;
var isRecordOrArray42 = (input) => typeof input === "object" && input !== null;
var isObject42 = (input) => isRecordOrArray42(input) || isFunction8(input);
var hasProperty42 = /* @__PURE__ */ dual42(2, (self2, property) => isObject42(self2) && property in self2);
var isTagged42 = /* @__PURE__ */ dual42(2, (self2, tag) => hasProperty42(self2, "_tag") && self2["_tag"] === tag);
var isNullable42 = (input) => input === null || input === void 0;
var isNotNullable42 = (input) => input !== null && input !== void 0;
var isError42 = (input) => input instanceof Error;
var isUint8Array42 = (input) => input instanceof Uint8Array;
var isDate42 = (input) => input instanceof Date;
var isIterable42 = (input) => hasProperty42(input, Symbol.iterator);
var isRecord42 = (input) => isRecordOrArray42(input) && !Array.isArray(input);
var isReadonlyRecord42 = isRecord42;
var isPromise42 = (input) => hasProperty42(input, "then") && "catch" in input && isFunction8(input.then) && isFunction8(input.catch);
var isPromiseLike42 = (input) => hasProperty42(input, "then") && isFunction8(input.then);
var compose72 = /* @__PURE__ */ dual42(2, (ab, bc) => (a32) => ab(a32) && bc(a32));
var product62 = (self2, that) => ([a32, b32]) => self2(a32) && that(b32);
var all62 = (collection) => {
  return (as62) => {
    let collectionIndex = 0;
    for (const p32 of collection) {
      if (collectionIndex >= as62.length) {
        break;
      }
      if (p32(as62[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany62 = (self2, collection) => {
  const rest = all62(collection);
  return ([head32, ...tail32]) => self2(head32) === false ? false : rest(tail32);
};
var tuple52 = (...elements) => all62(elements);
var struct62 = (fields) => {
  const keys52 = Object.keys(fields);
  return (a32) => {
    for (const key of keys52) {
      if (!fields[key](a32[key])) {
        return false;
      }
    }
    return true;
  };
};
var not42 = (self2) => (a32) => !self2(a32);
var or42 = /* @__PURE__ */ dual42(2, (self2, that) => (a32) => self2(a32) || that(a32));
var and42 = /* @__PURE__ */ dual42(2, (self2, that) => (a32) => self2(a32) && that(a32));
var xor42 = /* @__PURE__ */ dual42(2, (self2, that) => (a32) => self2(a32) !== that(a32));
var eqv42 = /* @__PURE__ */ dual42(2, (self2, that) => (a32) => self2(a32) === that(a32));
var implies42 = /* @__PURE__ */ dual42(2, (self2, that) => (a32) => self2(a32) ? that(a32) : true);
var nor42 = /* @__PURE__ */ dual42(2, (self2, that) => (a32) => !(self2(a32) || that(a32)));
var nand42 = /* @__PURE__ */ dual42(2, (self2, that) => (a32) => !(self2(a32) && that(a32)));
var every52 = (collection) => (a32) => {
  for (const p32 of collection) {
    if (!p32(a32)) {
      return false;
    }
  }
  return true;
};
var some92 = (collection) => (a32) => {
  for (const p32 of collection) {
    if (p32(a32)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage42 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId42 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind42 = (u32) => isObject42(u32) && GenKindTypeId42 in u32;
var GenKindImpl42 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity42;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_32) => _32;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_32) => _32;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_32) => _32;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId42] = GenKindTypeId42;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen52(this);
  }
};
var SingleShotGen52 = class _SingleShotGen72 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a32) {
    return this.called ? {
      value: a32,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a32) {
    return {
      value: a32,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e32) {
    throw e32;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen72(this.self);
  }
};
var adapter62 = () => function() {
  let x32 = arguments[0];
  for (let i32 = 1; i32 < arguments.length; i32++) {
    x32 = arguments[i32](x32);
  }
  return new GenKindImpl42(x32);
};
var defaultIncHi42 = 335903614;
var defaultIncLo42 = 4150755663;
var MUL_HI42 = 1481765933 >>> 0;
var MUL_LO42 = 1284865837 >>> 0;
var BIT_5342 = 9007199254740992;
var BIT_2742 = 134217728;
var PCGRandom42 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable42(seedLo) && isNullable42(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable42(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable42(incLo) && isNullable42(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo42;
      incHi = this._state ? this._state[2] : defaultIncHi42;
    } else if (isNullable42(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6442(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max32) {
    if (!max32) {
      return this._next();
    }
    max32 = max32 >>> 0;
    if ((max32 & max32 - 1) === 0) {
      return this._next() & max32 - 1;
    }
    let num = 0;
    const skew = (-max32 >>> 0) % max32 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max32;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2742 + lo) / BIT_5342;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6442(this._state, oldHi, oldLo, MUL_HI42, MUL_LO42);
    add6442(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6442(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6442(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId42 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap42 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId42]() {
    return this.#value;
  }
};
function yieldWrapGet42(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId42 in self2) {
    return self2[YieldWrapTypeId42]();
  }
  throw new Error(getBugErrorMessage42("yieldWrapGet"));
}
var structuralRegionState42 = /* @__PURE__ */ globalValue42("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache42 = /* @__PURE__ */ globalValue42(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr42 = /* @__PURE__ */ globalValue42(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom42());
var symbol62 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash42 = (self2) => {
  if (structuralRegionState42.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number52(self2);
    case "bigint":
      return string42(self2.toString(10));
    case "boolean":
      return string42(String(self2));
    case "symbol":
      return string42(String(self2));
    case "string":
      return string42(self2);
    case "undefined":
      return string42("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string42("null");
      } else if (self2 instanceof Date) {
        return hash42(self2.toISOString());
      } else if (isHash42(self2)) {
        return self2[symbol62]();
      } else {
        return random42(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random42 = (self2) => {
  if (!randomHashCache42.has(self2)) {
    randomHashCache42.set(self2, number52(pcgr42.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache42.get(self2);
};
var combine52 = (b32) => (self2) => self2 * 53 ^ b32;
var optimize42 = (n32) => n32 & 3221225471 | n32 >>> 1 & 1073741824;
var isHash42 = (u32) => hasProperty42(u32, symbol62);
var number52 = (n32) => {
  if (n32 !== n32 || n32 === Infinity) {
    return 0;
  }
  let h32 = n32 | 0;
  if (h32 !== n32) {
    h32 ^= n32 * 4294967295;
  }
  while (n32 > 4294967295) {
    h32 ^= n32 /= 4294967295;
  }
  return optimize42(n32);
};
var string42 = (str) => {
  let h32 = 5381, i32 = str.length;
  while (i32) {
    h32 = h32 * 33 ^ str.charCodeAt(--i32);
  }
  return optimize42(h32);
};
var cached42 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash72) {
      Object.defineProperty(self3, symbol62, {
        value() {
          return hash72;
        },
        enumerable: false
      });
      return hash72;
    };
  }
  const self2 = arguments[0];
  const hash62 = arguments[1];
  Object.defineProperty(self2, symbol62, {
    value() {
      return hash62;
    },
    enumerable: false
  });
  return hash62;
};
var symbol72 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals42() {
  if (arguments.length === 1) {
    return (self2) => compareBoth42(self2, arguments[0]);
  }
  return compareBoth42(arguments[0], arguments[1]);
}
function compareBoth42(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual42(self2) && isEqual42(that)) {
        if (hash42(self2) === hash42(that) && self2[symbol72](that)) {
          return true;
        } else {
          return structuralRegionState42.enabled && structuralRegionState42.tester ? structuralRegionState42.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState42.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v32, i32) => compareBoth42(v32, that[i32]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth42(self2[key], that[key]))) {
              return structuralRegionState42.tester ? structuralRegionState42.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState42.tester ? structuralRegionState42.tester(self2, that) : false;
    }
  }
  return structuralRegionState42.enabled && structuralRegionState42.tester ? structuralRegionState42.tester(self2, that) : false;
}
var isEqual42 = (u32) => hasProperty42(u32, symbol72);
var equivalence42 = () => equals42;
var NodeInspectSymbol42 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON42 = (x32) => {
  if (hasProperty42(x32, "toJSON") && isFunction8(x32["toJSON"]) && x32["toJSON"].length === 0) {
    return x32.toJSON();
  } else if (Array.isArray(x32)) {
    return x32.map(toJSON42);
  }
  return x32;
};
var format42 = (x32) => JSON.stringify(x32, null, 2);
var pipeArguments42 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i32 = 0, len = args.length; i32 < len; i32++) {
        ret = args[i32](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId52 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId42 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId42 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId42 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance42 = {
  /* c8 ignore next */
  _R: (_32) => _32,
  /* c8 ignore next */
  _E: (_32) => _32,
  /* c8 ignore next */
  _A: (_32) => _32,
  _V: /* @__PURE__ */ getCurrentVersion42()
};
var sinkVariance42 = {
  /* c8 ignore next */
  _A: (_32) => _32,
  /* c8 ignore next */
  _In: (_32) => _32,
  /* c8 ignore next */
  _L: (_32) => _32,
  /* c8 ignore next */
  _E: (_32) => _32,
  /* c8 ignore next */
  _R: (_32) => _32
};
var channelVariance42 = {
  /* c8 ignore next */
  _Env: (_32) => _32,
  /* c8 ignore next */
  _InErr: (_32) => _32,
  /* c8 ignore next */
  _InElem: (_32) => _32,
  /* c8 ignore next */
  _InDone: (_32) => _32,
  /* c8 ignore next */
  _OutErr: (_32) => _32,
  /* c8 ignore next */
  _OutElem: (_32) => _32,
  /* c8 ignore next */
  _OutDone: (_32) => _32
};
var EffectPrototype42 = {
  [EffectTypeId52]: effectVariance42,
  [StreamTypeId42]: effectVariance42,
  [SinkTypeId42]: sinkVariance42,
  [ChannelTypeId42]: channelVariance42,
  [symbol72](that) {
    return this === that;
  },
  [symbol62]() {
    return cached42(this, random42(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen52(new YieldWrap42(this));
  },
  pipe() {
    return pipeArguments42(this, arguments);
  }
};
var TypeId102 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto62 = {
  ...EffectPrototype42,
  [TypeId102]: {
    _A: (_32) => _32
  },
  [NodeInspectSymbol42]() {
    return this.toJSON();
  },
  toString() {
    return format42(this.toJSON());
  }
};
var SomeProto42 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto62), {
  _tag: "Some",
  _op: "Some",
  [symbol72](that) {
    return isOption62(that) && isSome62(that) && equals42(this.value, that.value);
  },
  [symbol62]() {
    return cached42(this, combine52(hash42(this._tag))(hash42(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON42(this.value)
    };
  }
});
var NoneHash42 = /* @__PURE__ */ hash42("None");
var NoneProto42 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto62), {
  _tag: "None",
  _op: "None",
  [symbol72](that) {
    return isOption62(that) && isNone62(that);
  },
  [symbol62]() {
    return NoneHash42;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption62 = (input) => hasProperty42(input, TypeId102);
var isNone62 = (fa) => fa._tag === "None";
var isSome62 = (fa) => fa._tag === "Some";
var none62 = /* @__PURE__ */ Object.create(NoneProto42);
var some102 = (value) => {
  const a32 = Object.create(SomeProto42);
  a32.value = value;
  return a32;
};
var TypeId112 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto72 = {
  ...EffectPrototype42,
  [TypeId112]: {
    _R: (_32) => _32
  },
  [NodeInspectSymbol42]() {
    return this.toJSON();
  },
  toString() {
    return format42(this.toJSON());
  }
};
var RightProto42 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto72), {
  _tag: "Right",
  _op: "Right",
  [symbol72](that) {
    return isEither42(that) && isRight52(that) && equals42(this.right, that.right);
  },
  [symbol62]() {
    return combine52(hash42(this._tag))(hash42(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON42(this.right)
    };
  }
});
var LeftProto42 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto72), {
  _tag: "Left",
  _op: "Left",
  [symbol72](that) {
    return isEither42(that) && isLeft52(that) && equals42(this.left, that.left);
  },
  [symbol62]() {
    return combine52(hash42(this._tag))(hash42(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON42(this.left)
    };
  }
});
var isEither42 = (input) => hasProperty42(input, TypeId112);
var isLeft52 = (ma) => ma._tag === "Left";
var isRight52 = (ma) => ma._tag === "Right";
var left52 = (left72) => {
  const a32 = Object.create(LeftProto42);
  a32.left = left72;
  return a32;
};
var right52 = (right72) => {
  const a32 = Object.create(RightProto42);
  a32.right = right72;
  return a32;
};
var getLeft62 = (self2) => isRight52(self2) ? none62 : some102(self2.left);
var getRight62 = (self2) => isLeft52(self2) ? none62 : some102(self2.right);
var Option_exports42 = {};
__export5(Option_exports42, {
  Do: () => Do52,
  TypeId: () => TypeId12,
  all: () => all72,
  andThen: () => andThen42,
  ap: () => ap42,
  as: () => as42,
  asVoid: () => asVoid42,
  bind: () => bind82,
  bindTo: () => bindTo82,
  composeK: () => composeK42,
  contains: () => contains52,
  containsWith: () => containsWith52,
  exists: () => exists42,
  filter: () => filter52,
  filterMap: () => filterMap52,
  firstSomeOf: () => firstSomeOf42,
  flatMap: () => flatMap52,
  flatMapNullable: () => flatMapNullable52,
  flatten: () => flatten52,
  fromIterable: () => fromIterable62,
  fromNullable: () => fromNullable52,
  gen: () => gen42,
  getEquivalence: () => getEquivalence62,
  getLeft: () => getLeft72,
  getOrElse: () => getOrElse42,
  getOrNull: () => getOrNull42,
  getOrThrow: () => getOrThrow42,
  getOrThrowWith: () => getOrThrowWith42,
  getOrUndefined: () => getOrUndefined42,
  getOrder: () => getOrder52,
  getRight: () => getRight72,
  isNone: () => isNone72,
  isOption: () => isOption72,
  isSome: () => isSome72,
  let: () => let_82,
  lift2: () => lift242,
  liftNullable: () => liftNullable52,
  liftPredicate: () => liftPredicate52,
  liftThrowable: () => liftThrowable42,
  map: () => map52,
  match: () => match6,
  none: () => none72,
  orElse: () => orElse42,
  orElseEither: () => orElseEither42,
  orElseSome: () => orElseSome42,
  partitionMap: () => partitionMap52,
  product: () => product72,
  productMany: () => productMany72,
  reduceCompact: () => reduceCompact42,
  some: () => some11,
  tap: () => tap42,
  toArray: () => toArray42,
  toRefinement: () => toRefinement42,
  void: () => void_42,
  zipLeft: () => zipLeft42,
  zipRight: () => zipRight42,
  zipWith: () => zipWith52
});
var make132 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId12 = /* @__PURE__ */ Symbol.for("effect/Option");
var none72 = () => none62;
var some11 = some102;
var isOption72 = isOption62;
var isNone72 = isNone62;
var isSome72 = isSome62;
var match6 = /* @__PURE__ */ dual42(2, (self2, {
  onNone,
  onSome
}) => isNone72(self2) ? onNone() : onSome(self2.value));
var toRefinement42 = (f32) => (a32) => isSome72(f32(a32));
var fromIterable62 = (collection) => {
  for (const a32 of collection) {
    return some11(a32);
  }
  return none72();
};
var getRight72 = getRight62;
var getLeft72 = getLeft62;
var getOrElse42 = /* @__PURE__ */ dual42(2, (self2, onNone) => isNone72(self2) ? onNone() : self2.value);
var orElse42 = /* @__PURE__ */ dual42(2, (self2, that) => isNone72(self2) ? that() : self2);
var orElseSome42 = /* @__PURE__ */ dual42(2, (self2, onNone) => isNone72(self2) ? some11(onNone()) : self2);
var orElseEither42 = /* @__PURE__ */ dual42(2, (self2, that) => isNone72(self2) ? map52(that(), right52) : map52(self2, left52));
var firstSomeOf42 = (collection) => {
  let out = none72();
  for (out of collection) {
    if (isSome72(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable52 = (nullableValue) => nullableValue == null ? none72() : some11(nullableValue);
var liftNullable52 = (f32) => (...a32) => fromNullable52(f32(...a32));
var getOrNull42 = /* @__PURE__ */ getOrElse42(constNull42);
var getOrUndefined42 = /* @__PURE__ */ getOrElse42(constUndefined42);
var liftThrowable42 = (f32) => (...a32) => {
  try {
    return some11(f32(...a32));
  } catch (e32) {
    return none72();
  }
};
var getOrThrowWith42 = /* @__PURE__ */ dual42(2, (self2, onNone) => {
  if (isSome72(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow42 = /* @__PURE__ */ getOrThrowWith42(() => new Error("getOrThrow called on a None"));
var map52 = /* @__PURE__ */ dual42(2, (self2, f32) => isNone72(self2) ? none72() : some11(f32(self2.value)));
var as42 = /* @__PURE__ */ dual42(2, (self2, b32) => map52(self2, () => b32));
var asVoid42 = /* @__PURE__ */ as42(void 0);
var void_42 = /* @__PURE__ */ some11(void 0);
var flatMap52 = /* @__PURE__ */ dual42(2, (self2, f32) => isNone72(self2) ? none72() : f32(self2.value));
var andThen42 = /* @__PURE__ */ dual42(2, (self2, f32) => flatMap52(self2, (a32) => {
  const b32 = isFunction72(f32) ? f32(a32) : f32;
  return isOption72(b32) ? b32 : some11(b32);
}));
var flatMapNullable52 = /* @__PURE__ */ dual42(2, (self2, f32) => isNone72(self2) ? none72() : fromNullable52(f32(self2.value)));
var flatten52 = /* @__PURE__ */ flatMap52(identity42);
var zipRight42 = /* @__PURE__ */ dual42(2, (self2, that) => flatMap52(self2, () => that));
var composeK42 = /* @__PURE__ */ dual42(2, (afb, bfc) => (a32) => flatMap52(afb(a32), bfc));
var zipLeft42 = /* @__PURE__ */ dual42(2, (self2, that) => tap42(self2, () => that));
var tap42 = /* @__PURE__ */ dual42(2, (self2, f32) => flatMap52(self2, (a32) => map52(f32(a32), () => a32)));
var product72 = (self2, that) => isSome72(self2) && isSome72(that) ? some11([self2.value, that.value]) : none72();
var productMany72 = (self2, collection) => {
  if (isNone72(self2)) {
    return none72();
  }
  const out = [self2.value];
  for (const o32 of collection) {
    if (isNone72(o32)) {
      return none72();
    }
    out.push(o32.value);
  }
  return some11(out);
};
var all72 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o32 of input) {
      if (isNone72(o32)) {
        return none72();
      }
      out2.push(o32.value);
    }
    return some11(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o32 = input[key];
    if (isNone72(o32)) {
      return none72();
    }
    out[key] = o32.value;
  }
  return some11(out);
};
var zipWith52 = /* @__PURE__ */ dual42(3, (self2, that, f32) => map52(product72(self2, that), ([a32, b32]) => f32(a32, b32)));
var ap42 = /* @__PURE__ */ dual42(2, (self2, that) => zipWith52(self2, that, (f32, a32) => f32(a32)));
var reduceCompact42 = /* @__PURE__ */ dual42(3, (self2, b32, f32) => {
  let out = b32;
  for (const oa of self2) {
    if (isSome72(oa)) {
      out = f32(out, oa.value);
    }
  }
  return out;
});
var toArray42 = (self2) => isNone72(self2) ? [] : [self2.value];
var partitionMap52 = /* @__PURE__ */ dual42(2, (self2, f32) => {
  if (isNone72(self2)) {
    return [none72(), none72()];
  }
  const e32 = f32(self2.value);
  return isLeft52(e32) ? [some11(e32.left), none72()] : [none72(), some11(e32.right)];
});
var filterMap52 = /* @__PURE__ */ dual42(2, (self2, f32) => isNone72(self2) ? none72() : f32(self2.value));
var filter52 = /* @__PURE__ */ dual42(2, (self2, predicate) => filterMap52(self2, (b32) => predicate(b32) ? some102(b32) : none62));
var getEquivalence62 = (isEquivalent) => make122((x32, y32) => x32 === y32 || (isNone72(x32) ? isNone72(y32) : isNone72(y32) ? false : isEquivalent(x32.value, y32.value)));
var getOrder52 = (O32) => make132((self2, that) => isSome72(self2) ? isSome72(that) ? O32(self2.value, that.value) : 1 : -1);
var lift242 = (f32) => dual42(2, (self2, that) => zipWith52(self2, that, f32));
var liftPredicate52 = (predicate) => (b32) => predicate(b32) ? some11(b32) : none72();
var containsWith52 = (isEquivalent) => dual42(2, (self2, a32) => isNone72(self2) ? false : isEquivalent(self2.value, a32));
var _equivalence62 = /* @__PURE__ */ equivalence42();
var contains52 = /* @__PURE__ */ containsWith52(_equivalence62);
var exists42 = /* @__PURE__ */ dual42(2, (self2, refinement) => isNone72(self2) ? false : refinement(self2.value));
var bindTo82 = /* @__PURE__ */ bindTo72(map52);
var let_82 = /* @__PURE__ */ let_72(map52);
var bind82 = /* @__PURE__ */ bind72(map52, flatMap52);
var Do52 = /* @__PURE__ */ some11({});
var adapter72 = /* @__PURE__ */ adapter62();
var gen42 = (f32) => {
  const iterator = f32(adapter72);
  let state = iterator.next();
  if (state.done) {
    return some11(state.value);
  } else {
    let current = state.value;
    if (isGenKind42(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet42(current);
    }
    if (isNone72(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind42(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet42(current);
        }
        if (isNone72(current)) {
          return current;
        }
      }
    }
    return some11(state.value);
  }
};
var MutableRef_exports = {};
__export5(MutableRef_exports, {
  compareAndSet: () => compareAndSet22,
  decrement: () => decrement22,
  decrementAndGet: () => decrementAndGet22,
  get: () => get32,
  getAndDecrement: () => getAndDecrement22,
  getAndIncrement: () => getAndIncrement22,
  getAndSet: () => getAndSet22,
  getAndUpdate: () => getAndUpdate22,
  increment: () => increment22,
  incrementAndGet: () => incrementAndGet22,
  make: () => make14,
  set: () => set32,
  setAndGet: () => setAndGet22,
  toggle: () => toggle22,
  update: () => update22,
  updateAndGet: () => updateAndGet22
});
var TypeId13 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto22 = {
  [TypeId13]: TypeId13,
  toString() {
    return format42(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON42(this.current)
    };
  },
  [NodeInspectSymbol42]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments42(this, arguments);
  }
};
var make14 = (value) => {
  const ref = Object.create(MutableRefProto22);
  ref.current = value;
  return ref;
};
var compareAndSet22 = /* @__PURE__ */ dual42(3, (self2, oldValue, newValue) => {
  if (equals42(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement22 = (self2) => update22(self2, (n32) => n32 - 1);
var decrementAndGet22 = (self2) => updateAndGet22(self2, (n32) => n32 - 1);
var get32 = (self2) => self2.current;
var getAndDecrement22 = (self2) => getAndUpdate22(self2, (n32) => n32 - 1);
var getAndIncrement22 = (self2) => getAndUpdate22(self2, (n32) => n32 + 1);
var getAndSet22 = /* @__PURE__ */ dual42(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate22 = /* @__PURE__ */ dual42(2, (self2, f32) => getAndSet22(self2, f32(get32(self2))));
var increment22 = (self2) => update22(self2, (n32) => n32 + 1);
var incrementAndGet22 = (self2) => updateAndGet22(self2, (n32) => n32 + 1);
var set32 = /* @__PURE__ */ dual42(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet22 = /* @__PURE__ */ dual42(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update22 = /* @__PURE__ */ dual42(2, (self2, f32) => set32(self2, f32(get32(self2))));
var updateAndGet22 = /* @__PURE__ */ dual42(2, (self2, f32) => setAndGet22(self2, f32(get32(self2))));
var toggle22 = (self2) => update22(self2, (_32) => !_32);
var MutableList_exports = {};
__export5(MutableList_exports, {
  append: () => append22,
  empty: () => empty112,
  forEach: () => forEach52,
  fromIterable: () => fromIterable72,
  head: () => head22,
  isEmpty: () => isEmpty32,
  length: () => length22,
  make: () => make15,
  pop: () => pop,
  prepend: () => prepend42,
  reset: () => reset,
  shift: () => shift,
  tail: () => tail22
});
var TypeId14 = /* @__PURE__ */ Symbol.for("effect/MutableList");
var MutableListProto = {
  [TypeId14]: TypeId14,
  [Symbol.iterator]() {
    let done = false;
    let head32 = this.head;
    return {
      next() {
        if (done) {
          return this.return();
        }
        if (head32 == null) {
          done = true;
          return this.return();
        }
        const value = head32.value;
        head32 = head32.next;
        return {
          done,
          value
        };
      },
      return(value) {
        if (!done) {
          done = true;
        }
        return {
          done: true,
          value
        };
      }
    };
  },
  toString() {
    return format42(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableList",
      values: Array.from(this).map(toJSON42)
    };
  },
  [NodeInspectSymbol42]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments42(this, arguments);
  }
};
var makeNode = (value) => ({
  value,
  removed: false,
  prev: void 0,
  next: void 0
});
var empty112 = () => {
  const list = Object.create(MutableListProto);
  list.head = void 0;
  list.tail = void 0;
  list._length = 0;
  return list;
};
var fromIterable72 = (iterable) => {
  const list = empty112();
  for (const element of iterable) {
    append22(list, element);
  }
  return list;
};
var make15 = (...elements) => fromIterable72(elements);
var isEmpty32 = (self2) => length22(self2) === 0;
var length22 = (self2) => self2._length;
var tail22 = (self2) => self2.tail === void 0 ? void 0 : self2.tail.value;
var head22 = (self2) => self2.head === void 0 ? void 0 : self2.head.value;
var forEach52 = /* @__PURE__ */ dual42(2, (self2, f32) => {
  let current = self2.head;
  while (current !== void 0) {
    f32(current.value);
    current = current.next;
  }
});
var reset = (self2) => {
  self2._length = 0;
  self2.head = void 0;
  self2.tail = void 0;
  return self2;
};
var append22 = /* @__PURE__ */ dual42(2, (self2, value) => {
  const node = makeNode(value);
  if (self2.head === void 0) {
    self2.head = node;
  }
  if (self2.tail === void 0) {
    self2.tail = node;
  } else {
    self2.tail.next = node;
    node.prev = self2.tail;
    self2.tail = node;
  }
  self2._length += 1;
  return self2;
});
var shift = (self2) => {
  const head32 = self2.head;
  if (head32 !== void 0) {
    remove22(self2, head32);
    return head32.value;
  }
  return void 0;
};
var pop = (self2) => {
  const tail32 = self2.tail;
  if (tail32 !== void 0) {
    remove22(self2, tail32);
    return tail32.value;
  }
  return void 0;
};
var prepend42 = /* @__PURE__ */ dual42(2, (self2, value) => {
  const node = makeNode(value);
  node.next = self2.head;
  if (self2.head !== void 0) {
    self2.head.prev = node;
  }
  self2.head = node;
  if (self2.tail === void 0) {
    self2.tail = node;
  }
  self2._length += 1;
  return self2;
});
var remove22 = (self2, node) => {
  if (node.removed) {
    return;
  }
  node.removed = true;
  if (node.prev !== void 0 && node.next !== void 0) {
    node.prev.next = node.next;
    node.next.prev = node.prev;
  } else if (node.prev !== void 0) {
    self2.tail = node.prev;
    node.prev.next = void 0;
  } else if (node.next !== void 0) {
    self2.head = node.next;
    node.next.prev = void 0;
  } else {
    self2.tail = void 0;
    self2.head = void 0;
  }
  if (self2._length > 0) {
    self2._length -= 1;
  }
};
var store22;
function getGlobalMessage2(lang) {
  return store22?.get(lang);
}
var store32;
function getSchemaMessage2(lang) {
  return store32?.get(lang);
}
var store42;
function getSpecificMessage2(reference, lang) {
  return store42?.get(reference)?.get(lang);
}
function _stringify2(input) {
  let type = typeof input;
  if (type === "object") {
    type = (input && Object.getPrototypeOf(input)?.constructor?.name) ?? "null";
  }
  return type === "string" ? `"${input}"` : type === "number" || type === "bigint" || type === "boolean" ? `${input}` : type;
}
function _addIssue2(context, label, dataset, config2, other) {
  const input = dataset.value;
  const expected = context.expects;
  const received = _stringify2(input);
  const issue = {
    kind: context.kind,
    type: context.type,
    input,
    expected,
    received,
    message: `Invalid ${label}: ${expected ? `Expected ${expected} but r` : "R"}eceived ${received}`,
    // @ts-expect-error
    requirement: context.requirement,
    path: other?.path,
    issues: other?.issues,
    lang: config2.lang,
    abortEarly: config2.abortEarly,
    abortPipeEarly: config2.abortPipeEarly,
    skipPipe: config2.skipPipe
  };
  const isSchema = context.kind === "schema";
  const message = (
    // @ts-expect-error
    context.message ?? getSpecificMessage2(context.reference, issue.lang) ?? (isSchema ? getSchemaMessage2(issue.lang) : null) ?? config2.message ?? getGlobalMessage2(issue.lang)
  );
  if (message) {
    issue.message = typeof message === "function" ? message(issue) : message;
  }
  if (isSchema) {
    dataset.typed = false;
  }
  if (dataset.issues) {
    dataset.issues.push(issue);
  } else {
    dataset.issues = [issue];
  }
}
function getDefault2(schema, dataset, config2) {
  return typeof schema.default === "function" ? (
    // @ts-expect-error
    schema.default(dataset, config2)
  ) : (
    // @ts-expect-error
    schema.default
  );
}
function array62(item, message) {
  return {
    kind: "schema",
    type: "array",
    reference: array62,
    expects: "Array",
    async: false,
    item,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (Array.isArray(input)) {
        dataset.typed = true;
        dataset.value = [];
        for (let key = 0; key < input.length; key++) {
          const value2 = input[key];
          const itemDataset = this.item._run({ typed: false, value: value2 }, config2);
          if (itemDataset.issues) {
            const pathItem = {
              type: "array",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of itemDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = itemDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!itemDataset.typed) {
            dataset.typed = false;
          }
          dataset.value.push(itemDataset.value);
        }
      } else {
        _addIssue2(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function object2(entries, message) {
  return {
    kind: "schema",
    type: "object",
    reference: object2,
    expects: "Object",
    async: false,
    entries,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (input && typeof input === "object") {
        dataset.typed = true;
        dataset.value = {};
        for (const key in this.entries) {
          const value2 = input[key];
          const valueDataset = this.entries[key]._run(
            { typed: false, value: value2 },
            config2
          );
          if (valueDataset.issues) {
            const pathItem = {
              type: "object",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of valueDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = valueDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!valueDataset.typed) {
            dataset.typed = false;
          }
          if (valueDataset.value !== void 0 || key in input) {
            dataset.value[key] = valueDataset.value;
          }
        }
      } else {
        _addIssue2(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function optional2(wrapped, ...args) {
  const schema = {
    kind: "schema",
    type: "optional",
    reference: optional2,
    expects: `${wrapped.expects} | undefined`,
    async: false,
    wrapped,
    _run(dataset, config2) {
      if (dataset.value === void 0) {
        if ("default" in this) {
          dataset.value = getDefault2(
            this,
            dataset,
            config2
          );
        }
        if (dataset.value === void 0) {
          dataset.typed = true;
          return dataset;
        }
      }
      return this.wrapped._run(dataset, config2);
    }
  };
  if (0 in args) {
    schema.default = args[0];
  }
  return schema;
}
function string52(message) {
  return {
    kind: "schema",
    type: "string",
    reference: string52,
    expects: "string",
    async: false,
    message,
    _run(dataset, config2) {
      if (typeof dataset.value === "string") {
        dataset.typed = true;
      } else {
        _addIssue2(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
var ESLintReactSettingsSchema2 = object2({
  additionalHooks: optional2(object2({
    use: optional2(string52()),
    useCallback: optional2(array62(string52())),
    useContext: optional2(array62(string52())),
    useDebugValue: optional2(array62(string52())),
    useDeferredValue: optional2(array62(string52())),
    useEffect: optional2(array62(string52())),
    useId: optional2(array62(string52())),
    useImperativeHandle: optional2(array62(string52())),
    useInsertionEffect: optional2(array62(string52())),
    useLayoutEffect: optional2(array62(string52())),
    useMemo: optional2(array62(string52())),
    useOptimistic: optional2(array62(string52())),
    useReducer: optional2(array62(string52())),
    useRef: optional2(array62(string52())),
    useState: optional2(array62(string52())),
    useSyncExternalStore: optional2(array62(string52())),
    useTransition: optional2(array62(string52()))
  })),
  importSource: optional2(string52()),
  jsxPragma: optional2(string52()),
  jsxPragmaFrag: optional2(string52()),
  version: optional2(string52())
});
var ESLintSettingsSchema2 = object2({
  reactOptions: optional2(ESLintReactSettingsSchema2)
});
var __defProp42 = Object.defineProperty;
var __export42 = (target, all33) => {
  for (var name2 in all33)
    __defProp42(target, name2, { get: all33[name2], enumerable: true });
};
var Function_exports52 = {};
__export42(Function_exports52, {
  SK: () => SK52,
  absurd: () => absurd52,
  apply: () => apply52,
  compose: () => compose8,
  constFalse: () => constFalse52,
  constNull: () => constNull52,
  constTrue: () => constTrue52,
  constUndefined: () => constUndefined52,
  constVoid: () => constVoid52,
  constant: () => constant52,
  dual: () => dual52,
  flip: () => flip52,
  flow: () => flow52,
  hole: () => hole52,
  identity: () => identity52,
  isFunction: () => isFunction9,
  pipe: () => pipe52,
  satisfies: () => satisfies52,
  tupled: () => tupled52,
  unsafeCoerce: () => unsafeCoerce52,
  untupled: () => untupled52
});
var isFunction9 = (input) => typeof input === "function";
var dual52 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a222, b222) {
        if (arguments.length >= 2) {
          return body(a222, b222);
        }
        return function(self2) {
          return body(self2, a222);
        };
      };
    case 3:
      return function(a222, b222, c222) {
        if (arguments.length >= 3) {
          return body(a222, b222, c222);
        }
        return function(self2) {
          return body(self2, a222, b222);
        };
      };
    case 4:
      return function(a222, b222, c222, d222) {
        if (arguments.length >= 4) {
          return body(a222, b222, c222, d222);
        }
        return function(self2) {
          return body(self2, a222, b222, c222);
        };
      };
    case 5:
      return function(a222, b222, c222, d222, e222) {
        if (arguments.length >= 5) {
          return body(a222, b222, c222, d222, e222);
        }
        return function(self2) {
          return body(self2, a222, b222, c222, d222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply52 = (a222) => (self2) => self2(a222);
var identity52 = (a222) => a222;
var satisfies52 = () => (b222) => b222;
var unsafeCoerce52 = identity52;
var constant52 = (value) => () => value;
var constTrue52 = /* @__PURE__ */ constant52(true);
var constFalse52 = /* @__PURE__ */ constant52(false);
var constNull52 = /* @__PURE__ */ constant52(null);
var constUndefined52 = /* @__PURE__ */ constant52(void 0);
var constVoid52 = constUndefined52;
var flip52 = (f222) => (...b222) => (...a222) => f222(...a222)(...b222);
var compose8 = /* @__PURE__ */ dual52(2, (ab, bc) => (a222) => bc(ab(a222)));
var absurd52 = (_222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled52 = (f222) => (a222) => f222(...a222);
var untupled52 = (f222) => (...a222) => f222(a222);
function pipe52(a222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a222;
    case 2:
      return ab(a222);
    case 3:
      return bc(ab(a222));
    case 4:
      return cd(bc(ab(a222)));
    case 5:
      return de(cd(bc(ab(a222))));
    case 6:
      return ef(de(cd(bc(ab(a222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a222))))))));
    default: {
      let ret = arguments[0];
      for (let i222 = 1; i222 < arguments.length; i222++) {
        ret = arguments[i222](ret);
      }
      return ret;
    }
  }
}
function flow52(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole52 = /* @__PURE__ */ unsafeCoerce52(absurd52);
var SK52 = (_222, b222) => b222;
var make16 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_9 = (map322) => dual52(3, (self2, name2, f222) => map322(self2, (a222) => Object.assign({}, a222, {
  [name2]: f222(a222)
})));
var bindTo9 = (map322) => dual52(2, (self2, name2) => map322(self2, (a222) => ({
  [name2]: a222
})));
var bind9 = (map322, flatMap322) => dual52(3, (self2, name2, f222) => flatMap322(self2, (a222) => map322(f222(a222), (b222) => Object.assign({}, a222, {
  [name2]: b222
}))));
var moduleVersion52 = "3.2.8";
var getCurrentVersion52 = () => moduleVersion52;
var globalStoreId52 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion52()}`);
if (!(globalStoreId52 in globalThis)) {
  globalThis[globalStoreId52] = /* @__PURE__ */ new Map();
}
var globalStore52 = globalThis[globalStoreId52];
var globalValue52 = (id, compute) => {
  if (!globalStore52.has(id)) {
    globalStore52.set(id, compute());
  }
  return globalStore52.get(id);
};
var isFunction232 = isFunction9;
var isRecordOrArray52 = (input) => typeof input === "object" && input !== null;
var isObject52 = (input) => isRecordOrArray52(input) || isFunction232(input);
var hasProperty52 = /* @__PURE__ */ dual52(2, (self2, property) => isObject52(self2) && property in self2);
var isNullable52 = (input) => input === null || input === void 0;
var getBugErrorMessage52 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId52 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind52 = (u222) => isObject52(u222) && GenKindTypeId52 in u222;
var GenKindImpl52 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity52;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_222) => _222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_222) => _222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_222) => _222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId52] = GenKindTypeId52;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen62(this);
  }
};
var SingleShotGen62 = class _SingleShotGen33 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a222) {
    return this.called ? {
      value: a222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a222) {
    return {
      value: a222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e222) {
    throw e222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen33(this.self);
  }
};
var adapter8 = () => function() {
  let x222 = arguments[0];
  for (let i222 = 1; i222 < arguments.length; i222++) {
    x222 = arguments[i222](x222);
  }
  return new GenKindImpl52(x222);
};
var defaultIncHi52 = 335903614;
var defaultIncLo52 = 4150755663;
var MUL_HI52 = 1481765933 >>> 0;
var MUL_LO52 = 1284865837 >>> 0;
var BIT_5352 = 9007199254740992;
var BIT_2752 = 134217728;
var PCGRandom52 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable52(seedLo) && isNullable52(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable52(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable52(incLo) && isNullable52(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo52;
      incHi = this._state ? this._state[2] : defaultIncHi52;
    } else if (isNullable52(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6452(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max32) {
    if (!max32) {
      return this._next();
    }
    max32 = max32 >>> 0;
    if ((max32 & max32 - 1) === 0) {
      return this._next() & max32 - 1;
    }
    let num = 0;
    const skew = (-max32 >>> 0) % max32 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max32;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2752 + lo) / BIT_5352;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6452(this._state, oldHi, oldLo, MUL_HI52, MUL_LO52);
    add6452(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6452(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6452(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId52 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap52 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId52]() {
    return this.#value;
  }
};
function yieldWrapGet52(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId52 in self2) {
    return self2[YieldWrapTypeId52]();
  }
  throw new Error(getBugErrorMessage52("yieldWrapGet"));
}
var structuralRegionState52 = /* @__PURE__ */ globalValue52("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache52 = /* @__PURE__ */ globalValue52(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr52 = /* @__PURE__ */ globalValue52(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom52());
var symbol8 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash52 = (self2) => {
  if (structuralRegionState52.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number62(self2);
    case "bigint":
      return string62(self2.toString(10));
    case "boolean":
      return string62(String(self2));
    case "symbol":
      return string62(String(self2));
    case "string":
      return string62(self2);
    case "undefined":
      return string62("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string62("null");
      } else if (self2 instanceof Date) {
        return hash52(self2.toISOString());
      } else if (isHash52(self2)) {
        return self2[symbol8]();
      } else {
        return random52(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random52 = (self2) => {
  if (!randomHashCache52.has(self2)) {
    randomHashCache52.set(self2, number62(pcgr52.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache52.get(self2);
};
var combine62 = (b222) => (self2) => self2 * 53 ^ b222;
var optimize52 = (n222) => n222 & 3221225471 | n222 >>> 1 & 1073741824;
var isHash52 = (u222) => hasProperty52(u222, symbol8);
var number62 = (n222) => {
  if (n222 !== n222 || n222 === Infinity) {
    return 0;
  }
  let h222 = n222 | 0;
  if (h222 !== n222) {
    h222 ^= n222 * 4294967295;
  }
  while (n222 > 4294967295) {
    h222 ^= n222 /= 4294967295;
  }
  return optimize52(n222);
};
var string62 = (str) => {
  let h222 = 5381, i222 = str.length;
  while (i222) {
    h222 = h222 * 33 ^ str.charCodeAt(--i222);
  }
  return optimize52(h222);
};
var cached52 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash422) {
      Object.defineProperty(self3, symbol8, {
        value() {
          return hash422;
        },
        enumerable: false
      });
      return hash422;
    };
  }
  const self2 = arguments[0];
  const hash322 = arguments[1];
  Object.defineProperty(self2, symbol8, {
    value() {
      return hash322;
    },
    enumerable: false
  });
  return hash322;
};
var symbol232 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals52() {
  if (arguments.length === 1) {
    return (self2) => compareBoth52(self2, arguments[0]);
  }
  return compareBoth52(arguments[0], arguments[1]);
}
function compareBoth52(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual52(self2) && isEqual52(that)) {
        if (hash52(self2) === hash52(that) && self2[symbol232](that)) {
          return true;
        } else {
          return structuralRegionState52.enabled && structuralRegionState52.tester ? structuralRegionState52.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState52.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v222, i222) => compareBoth52(v222, that[i222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth52(self2[key], that[key]))) {
              return structuralRegionState52.tester ? structuralRegionState52.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState52.tester ? structuralRegionState52.tester(self2, that) : false;
    }
  }
  return structuralRegionState52.enabled && structuralRegionState52.tester ? structuralRegionState52.tester(self2, that) : false;
}
var isEqual52 = (u222) => hasProperty52(u222, symbol232);
var equivalence52 = () => equals52;
var NodeInspectSymbol52 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON52 = (x222) => {
  if (hasProperty52(x222, "toJSON") && isFunction232(x222["toJSON"]) && x222["toJSON"].length === 0) {
    return x222.toJSON();
  } else if (Array.isArray(x222)) {
    return x222.map(toJSON52);
  }
  return x222;
};
var format52 = (x222) => JSON.stringify(x222, null, 2);
var pipeArguments52 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i222 = 0, len = args.length; i222 < len; i222++) {
        ret = args[i222](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId62 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId52 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId52 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId52 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance52 = {
  /* c8 ignore next */
  _R: (_222) => _222,
  /* c8 ignore next */
  _E: (_222) => _222,
  /* c8 ignore next */
  _A: (_222) => _222,
  _V: /* @__PURE__ */ getCurrentVersion52()
};
var sinkVariance52 = {
  /* c8 ignore next */
  _A: (_222) => _222,
  /* c8 ignore next */
  _In: (_222) => _222,
  /* c8 ignore next */
  _L: (_222) => _222,
  /* c8 ignore next */
  _E: (_222) => _222,
  /* c8 ignore next */
  _R: (_222) => _222
};
var channelVariance52 = {
  /* c8 ignore next */
  _Env: (_222) => _222,
  /* c8 ignore next */
  _InErr: (_222) => _222,
  /* c8 ignore next */
  _InElem: (_222) => _222,
  /* c8 ignore next */
  _InDone: (_222) => _222,
  /* c8 ignore next */
  _OutErr: (_222) => _222,
  /* c8 ignore next */
  _OutElem: (_222) => _222,
  /* c8 ignore next */
  _OutDone: (_222) => _222
};
var EffectPrototype52 = {
  [EffectTypeId62]: effectVariance52,
  [StreamTypeId52]: effectVariance52,
  [SinkTypeId52]: sinkVariance52,
  [ChannelTypeId52]: channelVariance52,
  [symbol232](that) {
    return this === that;
  },
  [symbol8]() {
    return cached52(this, random52(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen62(new YieldWrap52(this));
  },
  pipe() {
    return pipeArguments52(this, arguments);
  }
};
var TypeId15 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto8 = {
  ...EffectPrototype52,
  [TypeId15]: {
    _A: (_222) => _222
  },
  [NodeInspectSymbol52]() {
    return this.toJSON();
  },
  toString() {
    return format52(this.toJSON());
  }
};
var SomeProto52 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto8), {
  _tag: "Some",
  _op: "Some",
  [symbol232](that) {
    return isOption8(that) && isSome8(that) && equals52(this.value, that.value);
  },
  [symbol8]() {
    return cached52(this, combine62(hash52(this._tag))(hash52(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON52(this.value)
    };
  }
});
var NoneHash52 = /* @__PURE__ */ hash52("None");
var NoneProto52 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto8), {
  _tag: "None",
  _op: "None",
  [symbol232](that) {
    return isOption8(that) && isNone8(that);
  },
  [symbol8]() {
    return NoneHash52;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption8 = (input) => hasProperty52(input, TypeId15);
var isNone8 = (fa) => fa._tag === "None";
var isSome8 = (fa) => fa._tag === "Some";
var none8 = /* @__PURE__ */ Object.create(NoneProto52);
var some12 = (value) => {
  const a222 = Object.create(SomeProto52);
  a222.value = value;
  return a222;
};
var TypeId232 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto232 = {
  ...EffectPrototype52,
  [TypeId232]: {
    _R: (_222) => _222
  },
  [NodeInspectSymbol52]() {
    return this.toJSON();
  },
  toString() {
    return format52(this.toJSON());
  }
};
var RightProto52 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto232), {
  _tag: "Right",
  _op: "Right",
  [symbol232](that) {
    return isEither52(that) && isRight62(that) && equals52(this.right, that.right);
  },
  [symbol8]() {
    return combine62(hash52(this._tag))(hash52(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON52(this.right)
    };
  }
});
var LeftProto52 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto232), {
  _tag: "Left",
  _op: "Left",
  [symbol232](that) {
    return isEither52(that) && isLeft62(that) && equals52(this.left, that.left);
  },
  [symbol8]() {
    return combine62(hash52(this._tag))(hash52(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON52(this.left)
    };
  }
});
var isEither52 = (input) => hasProperty52(input, TypeId232);
var isLeft62 = (ma) => ma._tag === "Left";
var isRight62 = (ma) => ma._tag === "Right";
var left62 = (left33) => {
  const a222 = Object.create(LeftProto52);
  a222.left = left33;
  return a222;
};
var right62 = (right33) => {
  const a222 = Object.create(RightProto52);
  a222.right = right33;
  return a222;
};
var getLeft8 = (self2) => isRight62(self2) ? none8 : some12(self2.left);
var getRight8 = (self2) => isLeft62(self2) ? none8 : some12(self2.right);
var Option_exports52 = {};
__export42(Option_exports52, {
  Do: () => Do62,
  TypeId: () => TypeId332,
  all: () => all8,
  andThen: () => andThen52,
  ap: () => ap52,
  as: () => as52,
  asVoid: () => asVoid52,
  bind: () => bind232,
  bindTo: () => bindTo232,
  composeK: () => composeK52,
  contains: () => contains62,
  containsWith: () => containsWith62,
  exists: () => exists52,
  filter: () => filter62,
  filterMap: () => filterMap62,
  firstSomeOf: () => firstSomeOf52,
  flatMap: () => flatMap62,
  flatMapNullable: () => flatMapNullable62,
  flatten: () => flatten62,
  fromIterable: () => fromIterable8,
  fromNullable: () => fromNullable62,
  gen: () => gen52,
  getEquivalence: () => getEquivalence72,
  getLeft: () => getLeft232,
  getOrElse: () => getOrElse52,
  getOrNull: () => getOrNull52,
  getOrThrow: () => getOrThrow52,
  getOrThrowWith: () => getOrThrowWith52,
  getOrUndefined: () => getOrUndefined52,
  getOrder: () => getOrder62,
  getRight: () => getRight232,
  isNone: () => isNone232,
  isOption: () => isOption232,
  isSome: () => isSome232,
  let: () => let_232,
  lift2: () => lift252,
  liftNullable: () => liftNullable62,
  liftPredicate: () => liftPredicate62,
  liftThrowable: () => liftThrowable52,
  map: () => map62,
  match: () => match7,
  none: () => none232,
  orElse: () => orElse52,
  orElseEither: () => orElseEither52,
  orElseSome: () => orElseSome52,
  partitionMap: () => partitionMap62,
  product: () => product8,
  productMany: () => productMany8,
  reduceCompact: () => reduceCompact52,
  some: () => some232,
  tap: () => tap52,
  toArray: () => toArray52,
  toRefinement: () => toRefinement52,
  void: () => void_52,
  zipLeft: () => zipLeft52,
  zipRight: () => zipRight52,
  zipWith: () => zipWith62
});
var make232 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId332 = /* @__PURE__ */ Symbol.for("effect/Option");
var none232 = () => none8;
var some232 = some12;
var isOption232 = isOption8;
var isNone232 = isNone8;
var isSome232 = isSome8;
var match7 = /* @__PURE__ */ dual52(2, (self2, {
  onNone,
  onSome
}) => isNone232(self2) ? onNone() : onSome(self2.value));
var toRefinement52 = (f222) => (a222) => isSome232(f222(a222));
var fromIterable8 = (collection) => {
  for (const a222 of collection) {
    return some232(a222);
  }
  return none232();
};
var getRight232 = getRight8;
var getLeft232 = getLeft8;
var getOrElse52 = /* @__PURE__ */ dual52(2, (self2, onNone) => isNone232(self2) ? onNone() : self2.value);
var orElse52 = /* @__PURE__ */ dual52(2, (self2, that) => isNone232(self2) ? that() : self2);
var orElseSome52 = /* @__PURE__ */ dual52(2, (self2, onNone) => isNone232(self2) ? some232(onNone()) : self2);
var orElseEither52 = /* @__PURE__ */ dual52(2, (self2, that) => isNone232(self2) ? map62(that(), right62) : map62(self2, left62));
var firstSomeOf52 = (collection) => {
  let out = none232();
  for (out of collection) {
    if (isSome232(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable62 = (nullableValue) => nullableValue == null ? none232() : some232(nullableValue);
var liftNullable62 = (f222) => (...a222) => fromNullable62(f222(...a222));
var getOrNull52 = /* @__PURE__ */ getOrElse52(constNull52);
var getOrUndefined52 = /* @__PURE__ */ getOrElse52(constUndefined52);
var liftThrowable52 = (f222) => (...a222) => {
  try {
    return some232(f222(...a222));
  } catch (e222) {
    return none232();
  }
};
var getOrThrowWith52 = /* @__PURE__ */ dual52(2, (self2, onNone) => {
  if (isSome232(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow52 = /* @__PURE__ */ getOrThrowWith52(() => new Error("getOrThrow called on a None"));
var map62 = /* @__PURE__ */ dual52(2, (self2, f222) => isNone232(self2) ? none232() : some232(f222(self2.value)));
var as52 = /* @__PURE__ */ dual52(2, (self2, b222) => map62(self2, () => b222));
var asVoid52 = /* @__PURE__ */ as52(void 0);
var void_52 = /* @__PURE__ */ some232(void 0);
var flatMap62 = /* @__PURE__ */ dual52(2, (self2, f222) => isNone232(self2) ? none232() : f222(self2.value));
var andThen52 = /* @__PURE__ */ dual52(2, (self2, f222) => flatMap62(self2, (a222) => {
  const b222 = isFunction9(f222) ? f222(a222) : f222;
  return isOption232(b222) ? b222 : some232(b222);
}));
var flatMapNullable62 = /* @__PURE__ */ dual52(2, (self2, f222) => isNone232(self2) ? none232() : fromNullable62(f222(self2.value)));
var flatten62 = /* @__PURE__ */ flatMap62(identity52);
var zipRight52 = /* @__PURE__ */ dual52(2, (self2, that) => flatMap62(self2, () => that));
var composeK52 = /* @__PURE__ */ dual52(2, (afb, bfc) => (a222) => flatMap62(afb(a222), bfc));
var zipLeft52 = /* @__PURE__ */ dual52(2, (self2, that) => tap52(self2, () => that));
var tap52 = /* @__PURE__ */ dual52(2, (self2, f222) => flatMap62(self2, (a222) => map62(f222(a222), () => a222)));
var product8 = (self2, that) => isSome232(self2) && isSome232(that) ? some232([self2.value, that.value]) : none232();
var productMany8 = (self2, collection) => {
  if (isNone232(self2)) {
    return none232();
  }
  const out = [self2.value];
  for (const o222 of collection) {
    if (isNone232(o222)) {
      return none232();
    }
    out.push(o222.value);
  }
  return some232(out);
};
var all8 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o222 of input) {
      if (isNone232(o222)) {
        return none232();
      }
      out2.push(o222.value);
    }
    return some232(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o222 = input[key];
    if (isNone232(o222)) {
      return none232();
    }
    out[key] = o222.value;
  }
  return some232(out);
};
var zipWith62 = /* @__PURE__ */ dual52(3, (self2, that, f222) => map62(product8(self2, that), ([a222, b222]) => f222(a222, b222)));
var ap52 = /* @__PURE__ */ dual52(2, (self2, that) => zipWith62(self2, that, (f222, a222) => f222(a222)));
var reduceCompact52 = /* @__PURE__ */ dual52(3, (self2, b222, f222) => {
  let out = b222;
  for (const oa of self2) {
    if (isSome232(oa)) {
      out = f222(out, oa.value);
    }
  }
  return out;
});
var toArray52 = (self2) => isNone232(self2) ? [] : [self2.value];
var partitionMap62 = /* @__PURE__ */ dual52(2, (self2, f222) => {
  if (isNone232(self2)) {
    return [none232(), none232()];
  }
  const e222 = f222(self2.value);
  return isLeft62(e222) ? [some232(e222.left), none232()] : [none232(), some232(e222.right)];
});
var filterMap62 = /* @__PURE__ */ dual52(2, (self2, f222) => isNone232(self2) ? none232() : f222(self2.value));
var filter62 = /* @__PURE__ */ dual52(2, (self2, predicate) => filterMap62(self2, (b222) => predicate(b222) ? some12(b222) : none8));
var getEquivalence72 = (isEquivalent) => make16((x222, y222) => x222 === y222 || (isNone232(x222) ? isNone232(y222) : isNone232(y222) ? false : isEquivalent(x222.value, y222.value)));
var getOrder62 = (O222) => make232((self2, that) => isSome232(self2) ? isSome232(that) ? O222(self2.value, that.value) : 1 : -1);
var lift252 = (f222) => dual52(2, (self2, that) => zipWith62(self2, that, f222));
var liftPredicate62 = (predicate) => (b222) => predicate(b222) ? some232(b222) : none232();
var containsWith62 = (isEquivalent) => dual52(2, (self2, a222) => isNone232(self2) ? false : isEquivalent(self2.value, a222));
var _equivalence72 = /* @__PURE__ */ equivalence52();
var contains62 = /* @__PURE__ */ containsWith62(_equivalence72);
var exists52 = /* @__PURE__ */ dual52(2, (self2, refinement) => isNone232(self2) ? false : refinement(self2.value));
var bindTo232 = /* @__PURE__ */ bindTo9(map62);
var let_232 = /* @__PURE__ */ let_9(map62);
var bind232 = /* @__PURE__ */ bind9(map62, flatMap62);
var Do62 = /* @__PURE__ */ some232({});
var adapter232 = /* @__PURE__ */ adapter8();
var gen52 = (f222) => {
  const iterator = f222(adapter232);
  let state = iterator.next();
  if (state.done) {
    return some232(state.value);
  } else {
    let current = state.value;
    if (isGenKind52(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet52(current);
    }
    if (isNone232(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind52(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet52(current);
        }
        if (isNone232(current)) {
          return current;
        }
      }
    }
    return some232(state.value);
  }
};
var MutableRef_exports3 = {};
__export42(MutableRef_exports3, {
  compareAndSet: () => compareAndSet3,
  decrement: () => decrement3,
  decrementAndGet: () => decrementAndGet3,
  get: () => get4,
  getAndDecrement: () => getAndDecrement3,
  getAndIncrement: () => getAndIncrement3,
  getAndSet: () => getAndSet3,
  getAndUpdate: () => getAndUpdate3,
  increment: () => increment3,
  incrementAndGet: () => incrementAndGet3,
  make: () => make332,
  set: () => set42,
  setAndGet: () => setAndGet3,
  toggle: () => toggle3,
  update: () => update3,
  updateAndGet: () => updateAndGet3
});
var TypeId432 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto3 = {
  [TypeId432]: TypeId432,
  toString() {
    return format52(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON52(this.current)
    };
  },
  [NodeInspectSymbol52]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments52(this, arguments);
  }
};
var make332 = (value) => {
  const ref = Object.create(MutableRefProto3);
  ref.current = value;
  return ref;
};
var compareAndSet3 = /* @__PURE__ */ dual52(3, (self2, oldValue, newValue) => {
  if (equals52(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement3 = (self2) => update3(self2, (n222) => n222 - 1);
var decrementAndGet3 = (self2) => updateAndGet3(self2, (n222) => n222 - 1);
var get4 = (self2) => self2.current;
var getAndDecrement3 = (self2) => getAndUpdate3(self2, (n222) => n222 - 1);
var getAndIncrement3 = (self2) => getAndUpdate3(self2, (n222) => n222 + 1);
var getAndSet3 = /* @__PURE__ */ dual52(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate3 = /* @__PURE__ */ dual52(2, (self2, f222) => getAndSet3(self2, f222(get4(self2))));
var increment3 = (self2) => update3(self2, (n222) => n222 + 1);
var incrementAndGet3 = (self2) => updateAndGet3(self2, (n222) => n222 + 1);
var set42 = /* @__PURE__ */ dual52(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet3 = /* @__PURE__ */ dual52(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update3 = /* @__PURE__ */ dual52(2, (self2, f222) => set42(self2, f222(get4(self2))));
var updateAndGet3 = /* @__PURE__ */ dual52(2, (self2, f222) => setAndGet3(self2, f222(get4(self2))));
var toggle3 = (self2) => update3(self2, (_222) => !_222);
function getVariables22(initialScope) {
  const scopeRef = MutableRef_exports3.make(initialScope);
  const variablesRef = MutableRef_exports3.make(MutableRef_exports3.get(scopeRef).variables);
  while (MutableRef_exports3.get(scopeRef).type !== ScopeType.global) {
    MutableRef_exports3.set(scopeRef, MutableRef_exports3.get(scopeRef).upper);
    MutableRef_exports3.update(variablesRef, (variables) => variables.concat(MutableRef_exports3.get(scopeRef).variables));
  }
  return MutableRef_exports3.get(variablesRef).reverse();
}
var findVariable32 = Function_exports52.dual(2, (name2, initialScope) => {
  return Option_exports52.fromNullable(getVariables22(initialScope).find((variable) => variable.name === name2));
});
var t22 = Symbol.for("@ts-pattern/matcher");
var e22 = Symbol.for("@ts-pattern/isVariadic");
var n22 = "@ts-pattern/anonymous-select-key";
var r22 = (t222) => Boolean(t222 && "object" == typeof t222);
var i22 = (e222) => e222 && !!e222[t22];
var o22 = (n222, s222, c222) => {
  if (i22(n222)) {
    const e222 = n222[t22](), { matched: r222, selections: i222 } = e222.match(s222);
    return r222 && i222 && Object.keys(i222).forEach((t222) => c222(t222, i222[t222])), r222;
  }
  if (r22(n222)) {
    if (!r22(s222)) return false;
    if (Array.isArray(n222)) {
      if (!Array.isArray(s222)) return false;
      let t222 = [], r222 = [], a222 = [];
      for (const o222 of n222.keys()) {
        const s32 = n222[o222];
        i22(s32) && s32[e22] ? a222.push(s32) : a222.length ? r222.push(s32) : t222.push(s32);
      }
      if (a222.length) {
        if (a222.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s222.length < t222.length + r222.length) return false;
        const e222 = s222.slice(0, t222.length), n32 = 0 === r222.length ? [] : s222.slice(-r222.length), i222 = s222.slice(t222.length, 0 === r222.length ? Infinity : -r222.length);
        return t222.every((t32, n42) => o22(t32, e222[n42], c222)) && r222.every((t32, e32) => o22(t32, n32[e32], c222)) && (0 === a222.length || o22(a222[0], i222, c222));
      }
      return n222.length === s222.length && n222.every((t32, e222) => o22(t32, s222[e222], c222));
    }
    return Object.keys(n222).every((e222) => {
      const r222 = n222[e222];
      return (e222 in s222 || i22(a222 = r222) && "optional" === a222[t22]().matcherType) && o22(r222, s222[e222], c222);
      var a222;
    });
  }
  return Object.is(s222, n222);
};
var s22 = (e222) => {
  var n222, o222, a222;
  return r22(e222) ? i22(e222) ? null != (n222 = null == (o222 = (a222 = e222[t22]()).getSelectionKeys) ? void 0 : o222.call(a222)) ? n222 : [] : Array.isArray(e222) ? c22(e222, s22) : c22(Object.values(e222), s22) : [];
};
var c22 = (t222, e222) => t222.reduce((t32, n222) => t32.concat(e222(n222)), []);
function a22(...t222) {
  if (1 === t222.length) {
    const [e222] = t222;
    return (t32) => o22(e222, t32, () => {
    });
  }
  if (2 === t222.length) {
    const [e222, n222] = t222;
    return o22(e222, n222, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t222.length}.`);
}
function u22(t222) {
  return Object.assign(t222, { optional: () => l22(t222), and: (e222) => m22(t222, e222), or: (e222) => d22(t222, e222), select: (e222) => void 0 === e222 ? p22(t222) : p22(e222, t222) });
}
function h22(t222) {
  return Object.assign(((t32) => Object.assign(t32, { [Symbol.iterator]() {
    let n222 = 0;
    const r222 = [{ value: Object.assign(t32, { [e22]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t42;
      return null != (t42 = r222[n222++]) ? t42 : r222.at(-1);
    } };
  } }))(t222), { optional: () => h22(l22(t222)), select: (e222) => h22(void 0 === e222 ? p22(t222) : p22(e222, t222)) });
}
function l22(e222) {
  return u22({ [t22]: () => ({ match: (t222) => {
    let n222 = {};
    const r222 = (t32, e32) => {
      n222[t32] = e32;
    };
    return void 0 === t222 ? (s22(e222).forEach((t32) => r222(t32, void 0)), { matched: true, selections: n222 }) : { matched: o22(e222, t222, r222), selections: n222 };
  }, getSelectionKeys: () => s22(e222), matcherType: "optional" }) });
}
var f22 = (t222, e222) => {
  for (const n222 of t222) if (!e222(n222)) return false;
  return true;
};
var g22 = (t222, e222) => {
  for (const [n222, r222] of t222.entries()) if (!e222(r222, n222)) return false;
  return true;
};
function m22(...e222) {
  return u22({ [t22]: () => ({ match: (t222) => {
    let n222 = {};
    const r222 = (t32, e32) => {
      n222[t32] = e32;
    };
    return { matched: e222.every((e32) => o22(e32, t222, r222)), selections: n222 };
  }, getSelectionKeys: () => c22(e222, s22), matcherType: "and" }) });
}
function d22(...e222) {
  return u22({ [t22]: () => ({ match: (t222) => {
    let n222 = {};
    const r222 = (t32, e32) => {
      n222[t32] = e32;
    };
    return c22(e222, s22).forEach((t32) => r222(t32, void 0)), { matched: e222.some((e32) => o22(e32, t222, r222)), selections: n222 };
  }, getSelectionKeys: () => c22(e222, s22), matcherType: "or" }) });
}
function y22(e222) {
  return { [t22]: () => ({ match: (t222) => ({ matched: Boolean(e222(t222)) }) }) };
}
function p22(...e222) {
  const r222 = "string" == typeof e222[0] ? e222[0] : void 0, i222 = 2 === e222.length ? e222[1] : "string" == typeof e222[0] ? void 0 : e222[0];
  return u22({ [t22]: () => ({ match: (t222) => {
    let e32 = { [null != r222 ? r222 : n22]: t222 };
    return { matched: void 0 === i222 || o22(i222, t222, (t32, n222) => {
      e32[t32] = n222;
    }), selections: e32 };
  }, getSelectionKeys: () => [null != r222 ? r222 : n22].concat(void 0 === i222 ? [] : s22(i222)) }) });
}
function v22(t222) {
  return "number" == typeof t222;
}
function b22(t222) {
  return "string" == typeof t222;
}
function w22(t222) {
  return "bigint" == typeof t222;
}
var S22 = u22(y22(function(t222) {
  return true;
}));
var O22 = S22;
var j22 = (t222) => Object.assign(u22(t222), { startsWith: (e222) => {
  return j22(m22(t222, (n222 = e222, y22((t32) => b22(t32) && t32.startsWith(n222)))));
  var n222;
}, endsWith: (e222) => {
  return j22(m22(t222, (n222 = e222, y22((t32) => b22(t32) && t32.endsWith(n222)))));
  var n222;
}, minLength: (e222) => j22(m22(t222, ((t32) => y22((e32) => b22(e32) && e32.length >= t32))(e222))), maxLength: (e222) => j22(m22(t222, ((t32) => y22((e32) => b22(e32) && e32.length <= t32))(e222))), includes: (e222) => {
  return j22(m22(t222, (n222 = e222, y22((t32) => b22(t32) && t32.includes(n222)))));
  var n222;
}, regex: (e222) => {
  return j22(m22(t222, (n222 = e222, y22((t32) => b22(t32) && Boolean(t32.match(n222))))));
  var n222;
} });
var E22 = j22(y22(b22));
var K22 = (t222) => Object.assign(u22(t222), { between: (e222, n222) => K22(m22(t222, ((t32, e32) => y22((n32) => v22(n32) && t32 <= n32 && e32 >= n32))(e222, n222))), lt: (e222) => K22(m22(t222, ((t32) => y22((e32) => v22(e32) && e32 < t32))(e222))), gt: (e222) => K22(m22(t222, ((t32) => y22((e32) => v22(e32) && e32 > t32))(e222))), lte: (e222) => K22(m22(t222, ((t32) => y22((e32) => v22(e32) && e32 <= t32))(e222))), gte: (e222) => K22(m22(t222, ((t32) => y22((e32) => v22(e32) && e32 >= t32))(e222))), int: () => K22(m22(t222, y22((t32) => v22(t32) && Number.isInteger(t32)))), finite: () => K22(m22(t222, y22((t32) => v22(t32) && Number.isFinite(t32)))), positive: () => K22(m22(t222, y22((t32) => v22(t32) && t32 > 0))), negative: () => K22(m22(t222, y22((t32) => v22(t32) && t32 < 0))) });
var x22 = K22(y22(v22));
var A22 = (t222) => Object.assign(u22(t222), { between: (e222, n222) => A22(m22(t222, ((t32, e32) => y22((n32) => w22(n32) && t32 <= n32 && e32 >= n32))(e222, n222))), lt: (e222) => A22(m22(t222, ((t32) => y22((e32) => w22(e32) && e32 < t32))(e222))), gt: (e222) => A22(m22(t222, ((t32) => y22((e32) => w22(e32) && e32 > t32))(e222))), lte: (e222) => A22(m22(t222, ((t32) => y22((e32) => w22(e32) && e32 <= t32))(e222))), gte: (e222) => A22(m22(t222, ((t32) => y22((e32) => w22(e32) && e32 >= t32))(e222))), positive: () => A22(m22(t222, y22((t32) => w22(t32) && t32 > 0))), negative: () => A22(m22(t222, y22((t32) => w22(t32) && t32 < 0))) });
var P3 = A22(y22(w22));
var T22 = u22(y22(function(t222) {
  return "boolean" == typeof t222;
}));
var k22 = u22(y22(function(t222) {
  return "symbol" == typeof t222;
}));
var B22 = u22(y22(function(t222) {
  return null == t222;
}));
var _22 = u22(y22(function(t222) {
  return null != t222;
}));
var N22 = { __proto__: null, matcher: t22, optional: l22, array: function(...e222) {
  return h22({ [t22]: () => ({ match: (t222) => {
    if (!Array.isArray(t222)) return { matched: false };
    if (0 === e222.length) return { matched: true };
    const n222 = e222[0];
    let r222 = {};
    if (0 === t222.length) return s22(n222).forEach((t32) => {
      r222[t32] = [];
    }), { matched: true, selections: r222 };
    const i222 = (t32, e32) => {
      r222[t32] = (r222[t32] || []).concat([e32]);
    };
    return { matched: t222.every((t32) => o22(n222, t32, i222)), selections: r222 };
  }, getSelectionKeys: () => 0 === e222.length ? [] : s22(e222[0]) }) });
}, set: function(...e222) {
  return u22({ [t22]: () => ({ match: (t222) => {
    if (!(t222 instanceof Set)) return { matched: false };
    let n222 = {};
    if (0 === t222.size) return { matched: true, selections: n222 };
    if (0 === e222.length) return { matched: true };
    const r222 = (t32, e32) => {
      n222[t32] = (n222[t32] || []).concat([e32]);
    }, i222 = e222[0];
    return { matched: f22(t222, (t32) => o22(i222, t32, r222)), selections: n222 };
  }, getSelectionKeys: () => 0 === e222.length ? [] : s22(e222[0]) }) });
}, map: function(...e222) {
  return u22({ [t22]: () => ({ match: (t222) => {
    if (!(t222 instanceof Map)) return { matched: false };
    let n222 = {};
    if (0 === t222.size) return { matched: true, selections: n222 };
    const r222 = (t32, e32) => {
      n222[t32] = (n222[t32] || []).concat([e32]);
    };
    if (0 === e222.length) return { matched: true };
    var i222;
    if (1 === e222.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i222 = e222[0]) ? void 0 : i222.toString()}`);
    const [s222, c222] = e222;
    return { matched: g22(t222, (t32, e32) => {
      const n32 = o22(s222, e32, r222), i32 = o22(c222, t32, r222);
      return n32 && i32;
    }), selections: n222 };
  }, getSelectionKeys: () => 0 === e222.length ? [] : [...s22(e222[0]), ...s22(e222[1])] }) });
}, intersection: m22, union: d22, not: function(e222) {
  return u22({ [t22]: () => ({ match: (t222) => ({ matched: !o22(e222, t222, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y22, select: p22, any: S22, _: O22, string: E22, number: x22, bigint: P3, boolean: T22, symbol: k22, nullish: B22, nonNullable: _22, instanceOf: function(t222) {
  return u22(y22(/* @__PURE__ */ function(t32) {
    return (e222) => e222 instanceof t32;
  }(t222)));
}, shape: function(t222) {
  return u22(y22(a22(t222)));
} };
var KEYS32 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES32 = Object.keys(KEYS32);
for (const type of NODE_TYPES32) {
  Object.freeze(KEYS32[type]);
}
Object.freeze(KEYS32);
var visitor_keys_default32 = KEYS32;
var KEY_BLACKLIST32 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey32(key) {
  return !KEY_BLACKLIST32.has(key) && key[0] !== "_";
}
function getKeys32(node) {
  return Object.keys(node).filter(filterKey32);
}
function getInnermostScope32(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range22 = childScope.block.range;
      if (range22[0] <= location && location < range22[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable232(initialScope, nameOrNode) {
  let name2 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name2 = nameOrNode;
  } else {
    name2 = nameOrNode.name;
    scope = getInnermostScope32(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name2);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate032(token) {
  return !this(token);
}
function negate32(f222) {
  return negate032.bind(f222);
}
function isPunctuatorTokenWithValue32(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken32(token) {
  return isPunctuatorTokenWithValue32(token, "=>");
}
function isCommaToken32(token) {
  return isPunctuatorTokenWithValue32(token, ",");
}
function isSemicolonToken32(token) {
  return isPunctuatorTokenWithValue32(token, ";");
}
function isColonToken32(token) {
  return isPunctuatorTokenWithValue32(token, ":");
}
function isOpeningParenToken32(token) {
  return isPunctuatorTokenWithValue32(token, "(");
}
function isClosingParenToken32(token) {
  return isPunctuatorTokenWithValue32(token, ")");
}
function isOpeningBracketToken32(token) {
  return isPunctuatorTokenWithValue32(token, "[");
}
function isClosingBracketToken32(token) {
  return isPunctuatorTokenWithValue32(token, "]");
}
function isOpeningBraceToken32(token) {
  return isPunctuatorTokenWithValue32(token, "{");
}
function isClosingBraceToken32(token) {
  return isPunctuatorTokenWithValue32(token, "}");
}
function isCommentToken32(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate32(isArrowToken32);
negate32(isCommaToken32);
negate32(isSemicolonToken32);
negate32(isColonToken32);
negate32(isOpeningParenToken32);
negate32(isClosingParenToken32);
negate32(isOpeningBracketToken32);
negate32(isClosingBracketToken32);
negate32(isOpeningBraceToken32);
negate32(isClosingBraceToken32);
negate32(isCommentToken32);
function getOpeningParenOfParams32(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken32) : sourceCode.getFirstToken(node, isOpeningParenToken32);
}
function getFunctionHeadLocation32(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken32);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams32(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams32(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject32 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames32 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed32 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k222) => k222 !== "random").map((k222) => Math[k222]).filter((f222) => typeof f222 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f222) => typeof f222 === "function")
);
var callPassThrough32 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed32 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor32(object22, name2) {
  let x222 = object22;
  while ((typeof x222 === "object" || typeof x222 === "function") && x222 !== null) {
    const d222 = Object.getOwnPropertyDescriptor(x222, name2);
    if (d222) {
      return d222;
    }
    x222 = Object.getPrototypeOf(x222);
  }
  return null;
}
function isGetter32(object22, name2) {
  const d222 = getPropertyDescriptor32(object22, name2);
  return d222 != null && d222.get != null;
}
function getElementValues32(nodeList, initialScope) {
  const valueList = [];
  for (let i222 = 0; i222 < nodeList.length; ++i222) {
    const elementNode = nodeList[i222];
    if (elementNode == null) {
      valueList.length = i222 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR32(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR32(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst32(variable) {
  const refs = variable.references;
  const inits = refs.filter((r222) => r222.init).length;
  const reads = refs.filter((r222) => r222.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations32 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues32(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR32(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left33 = getStaticValueR32(node.left, initialScope);
    const right33 = getStaticValueR32(node.right, initialScope);
    if (left33 != null && right33 != null) {
      switch (node.operator) {
        case "==":
          return { value: left33.value == right33.value };
        case "!=":
          return { value: left33.value != right33.value };
        case "===":
          return { value: left33.value === right33.value };
        case "!==":
          return { value: left33.value !== right33.value };
        case "<":
          return { value: left33.value < right33.value };
        case "<=":
          return { value: left33.value <= right33.value };
        case ">":
          return { value: left33.value > right33.value };
        case ">=":
          return { value: left33.value >= right33.value };
        case "<<":
          return { value: left33.value << right33.value };
        case ">>":
          return { value: left33.value >> right33.value };
        case ">>>":
          return { value: left33.value >>> right33.value };
        case "+":
          return { value: left33.value + right33.value };
        case "-":
          return { value: left33.value - right33.value };
        case "*":
          return { value: left33.value * right33.value };
        case "/":
          return { value: left33.value / right33.value };
        case "%":
          return { value: left33.value % right33.value };
        case "**":
          return { value: left33.value ** right33.value };
        case "|":
          return { value: left33.value | right33.value };
        case "^":
          return { value: left33.value ^ right33.value };
        case "&":
          return { value: left33.value & right33.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues32(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object22 = getStaticValueR32(calleeNode.object, initialScope);
        if (object22 != null) {
          if (object22.value == null && (object22.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue32(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object22.value;
            const methodName = property.value;
            if (callAllowed32.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough32.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR32(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed32.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough32.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR32(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR32(node.consequent, initialScope) : getStaticValueR32(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR32(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable232(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames32.has(variable.name) && variable.name in globalObject32) {
        return { value: globalObject32[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst32(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR32(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left33 = getStaticValueR32(node.left, initialScope);
    if (left33 != null) {
      if (node.operator === "||" && Boolean(left33.value) === true || node.operator === "&&" && Boolean(left33.value) === false || node.operator === "??" && left33.value != null) {
        return left33;
      }
      const right33 = getStaticValueR32(node.right, initialScope);
      if (right33 != null) {
        return right33;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object22 = getStaticValueR32(node.object, initialScope);
    if (object22 != null) {
      if (object22.value == null && (object22.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue32(node, initialScope);
      if (property != null) {
        if (!isGetter32(object22.value, property.value)) {
          return { value: object22.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed32) {
          if (object22.value instanceof classFn && allowed.has(property.value)) {
            return { value: object22.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR32(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR32(node.callee, initialScope);
    const args = getElementValues32(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed32.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object22 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue32(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR32(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object22[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR32(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object22, argument.value);
      } else {
        return null;
      }
    }
    return { value: object22 };
  },
  SequenceExpression(node, initialScope) {
    const last22 = node.expressions[node.expressions.length - 1];
    return getStaticValueR32(last22, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR32(node.tag, initialScope);
    const expressions = getElementValues32(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues32(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i222 = 0; i222 < expressions.length; ++i222) {
        value += expressions[i222];
        value += node.quasis[i222 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR32(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR32(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations32, node.type)) {
    return operations32[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue32(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR32(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue42(node, initialScope = null) {
  try {
    return getStaticValueR32(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant32(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue42(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName32(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant32(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant32(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind32(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name2 = getPropertyName32(parent);
      if (name2) {
        tokens.push(`'${name2}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps32 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps32 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode32(x222) {
  return x222 !== null && typeof x222 === "object" && typeof x222.type === "string";
}
var visitor32 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys32(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode32(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode32(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps32.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps32.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect32(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor32.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default32
  );
}
function getParentSyntaxParen32(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken32
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken32
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized32(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken32(maybeLeftParen) && isClosingParenToken32(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen32(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp232 = Object.defineProperty;
var __export232 = (target, all33) => {
  for (var name2 in all33)
    __defProp232(target, name2, { get: all33[name2], enumerable: true });
};
var NodeType32 = AST_NODE_TYPES;
var is32 = ASTUtils.isNodeOfType;
var isOneOf32 = ASTUtils.isNodeOfTypes;
isOneOf32([
  NodeType32.ArrowFunctionExpression,
  NodeType32.FunctionDeclaration,
  NodeType32.FunctionExpression
]);
isOneOf32([
  NodeType32.ArrowFunctionExpression,
  NodeType32.FunctionDeclaration,
  NodeType32.FunctionExpression,
  NodeType32.TSCallSignatureDeclaration,
  NodeType32.TSConstructSignatureDeclaration,
  NodeType32.TSDeclareFunction,
  NodeType32.TSEmptyBodyFunctionExpression,
  NodeType32.TSFunctionType,
  NodeType32.TSMethodSignature
]);
isOneOf32([NodeType32.ClassDeclaration, NodeType32.ClassExpression]);
isOneOf32([
  NodeType32.DoWhileStatement,
  NodeType32.ForInStatement,
  NodeType32.ForOfStatement,
  NodeType32.ForStatement,
  NodeType32.WhileStatement
]);
isOneOf32([NodeType32.TSArrayType, NodeType32.TSTupleType]);
isOneOf32([
  NodeType32.PropertyDefinition,
  NodeType32.TSIndexSignature,
  NodeType32.TSParameterProperty,
  NodeType32.TSPropertySignature
]);
is32(NodeType32.JSXElement);
is32(NodeType32.JSXFragment);
isOneOf32([
  NodeType32.JSXAttribute,
  NodeType32.JSXSpreadChild,
  NodeType32.JSXClosingElement,
  NodeType32.JSXClosingFragment,
  NodeType32.JSXElement,
  NodeType32.JSXEmptyExpression,
  NodeType32.JSXExpressionContainer,
  NodeType32.JSXFragment,
  NodeType32.JSXIdentifier,
  NodeType32.JSXMemberExpression,
  NodeType32.JSXNamespacedName,
  NodeType32.JSXOpeningElement,
  NodeType32.JSXOpeningFragment,
  NodeType32.JSXSpreadAttribute,
  NodeType32.JSXSpreadChild,
  NodeType32.JSXText
]);
isOneOf32([
  NodeType32.JSXIdentifier,
  NodeType32.JSXMemberExpression,
  NodeType32.JSXNamespacedName
]);
isOneOf32([
  NodeType32.ArrayPattern,
  NodeType32.AssignmentPattern,
  NodeType32.ObjectPattern,
  NodeType32.RestElement
]);
isOneOf32([
  NodeType32.TSInterfaceDeclaration,
  NodeType32.TSTypeAliasDeclaration
]);
isOneOf32([
  NodeType32.ArrayExpression,
  NodeType32.ArrayPattern,
  NodeType32.ArrowFunctionExpression,
  NodeType32.CallExpression,
  NodeType32.ClassExpression,
  NodeType32.FunctionExpression,
  NodeType32.Identifier,
  NodeType32.JSXElement,
  NodeType32.JSXFragment,
  NodeType32.Literal,
  NodeType32.TemplateLiteral,
  NodeType32.MemberExpression,
  NodeType32.MetaProperty,
  NodeType32.ObjectExpression,
  NodeType32.ObjectPattern,
  NodeType32.SequenceExpression,
  NodeType32.Super,
  NodeType32.TaggedTemplateExpression,
  NodeType32.ThisExpression
]);
isOneOf32([
  NodeType32.ArrayExpression,
  NodeType32.ArrayPattern,
  NodeType32.ArrowFunctionExpression,
  NodeType32.CallExpression,
  NodeType32.ClassExpression,
  NodeType32.FunctionExpression,
  NodeType32.Identifier,
  NodeType32.JSXElement,
  NodeType32.JSXFragment,
  NodeType32.Literal,
  NodeType32.TemplateLiteral,
  NodeType32.MemberExpression,
  NodeType32.MetaProperty,
  NodeType32.ObjectExpression,
  NodeType32.ObjectPattern,
  NodeType32.SequenceExpression,
  NodeType32.Super,
  NodeType32.TaggedTemplateExpression,
  NodeType32.ThisExpression,
  NodeType32.TSAsExpression,
  NodeType32.TSNonNullExpression,
  NodeType32.TSTypeAssertion
]);
var Function_exports232 = {};
__export232(Function_exports232, {
  SK: () => SK232,
  absurd: () => absurd232,
  apply: () => apply232,
  compose: () => compose232,
  constFalse: () => constFalse232,
  constNull: () => constNull232,
  constTrue: () => constTrue232,
  constUndefined: () => constUndefined232,
  constVoid: () => constVoid232,
  constant: () => constant232,
  dual: () => dual232,
  flip: () => flip232,
  flow: () => flow232,
  hole: () => hole232,
  identity: () => identity232,
  isFunction: () => isFunction2232,
  pipe: () => pipe232,
  satisfies: () => satisfies232,
  tupled: () => tupled232,
  unsafeCoerce: () => unsafeCoerce232,
  untupled: () => untupled232
});
var isFunction2232 = (input) => typeof input === "function";
var dual232 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a222, b222) {
        if (arguments.length >= 2) {
          return body(a222, b222);
        }
        return function(self2) {
          return body(self2, a222);
        };
      };
    case 3:
      return function(a222, b222, c222) {
        if (arguments.length >= 3) {
          return body(a222, b222, c222);
        }
        return function(self2) {
          return body(self2, a222, b222);
        };
      };
    case 4:
      return function(a222, b222, c222, d222) {
        if (arguments.length >= 4) {
          return body(a222, b222, c222, d222);
        }
        return function(self2) {
          return body(self2, a222, b222, c222);
        };
      };
    case 5:
      return function(a222, b222, c222, d222, e222) {
        if (arguments.length >= 5) {
          return body(a222, b222, c222, d222, e222);
        }
        return function(self2) {
          return body(self2, a222, b222, c222, d222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply232 = (a222) => (self2) => self2(a222);
var identity232 = (a222) => a222;
var satisfies232 = () => (b222) => b222;
var unsafeCoerce232 = identity232;
var constant232 = (value) => () => value;
var constTrue232 = /* @__PURE__ */ constant232(true);
var constFalse232 = /* @__PURE__ */ constant232(false);
var constNull232 = /* @__PURE__ */ constant232(null);
var constUndefined232 = /* @__PURE__ */ constant232(void 0);
var constVoid232 = constUndefined232;
var flip232 = (f222) => (...b222) => (...a222) => f222(...a222)(...b222);
var compose232 = /* @__PURE__ */ dual232(2, (ab, bc) => (a222) => bc(ab(a222)));
var absurd232 = (_222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled232 = (f222) => (a222) => f222(...a222);
var untupled232 = (f222) => (...a222) => f222(a222);
function pipe232(a222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a222;
    case 2:
      return ab(a222);
    case 3:
      return bc(ab(a222));
    case 4:
      return cd(bc(ab(a222)));
    case 5:
      return de(cd(bc(ab(a222))));
    case 6:
      return ef(de(cd(bc(ab(a222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a222))))))));
    default: {
      let ret = arguments[0];
      for (let i222 = 1; i222 < arguments.length; i222++) {
        ret = arguments[i222](ret);
      }
      return ret;
    }
  }
}
function flow232(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole232 = /* @__PURE__ */ unsafeCoerce232(absurd232);
var SK232 = (_222, b222) => b222;
var make432 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_332 = (map622) => dual232(3, (self2, name2, f222) => map622(self2, (a222) => Object.assign({}, a222, {
  [name2]: f222(a222)
})));
var bindTo332 = (map622) => dual232(2, (self2, name2) => map622(self2, (a222) => ({
  [name2]: a222
})));
var bind332 = (map622, flatMap422) => dual232(3, (self2, name2, f222) => flatMap422(self2, (a222) => map622(f222(a222), (b222) => Object.assign({}, a222, {
  [name2]: b222
}))));
var moduleVersion232 = "3.2.8";
var getCurrentVersion232 = () => moduleVersion232;
var globalStoreId232 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion232()}`);
if (!(globalStoreId232 in globalThis)) {
  globalThis[globalStoreId232] = /* @__PURE__ */ new Map();
}
var globalStore232 = globalThis[globalStoreId232];
var globalValue232 = (id, compute) => {
  if (!globalStore232.has(id)) {
    globalStore232.set(id, compute());
  }
  return globalStore232.get(id);
};
var Predicate_exports232 = {};
__export232(Predicate_exports232, {
  all: () => all232,
  and: () => and52,
  compose: () => compose2232,
  eqv: () => eqv52,
  every: () => every62,
  hasProperty: () => hasProperty232,
  implies: () => implies52,
  isBigInt: () => isBigInt52,
  isBoolean: () => isBoolean52,
  isDate: () => isDate52,
  isError: () => isError52,
  isFunction: () => isFunction323,
  isIterable: () => isIterable52,
  isMap: () => isMap52,
  isNever: () => isNever52,
  isNotNull: () => isNotNull52,
  isNotNullable: () => isNotNullable52,
  isNotUndefined: () => isNotUndefined52,
  isNull: () => isNull52,
  isNullable: () => isNullable232,
  isNumber: () => isNumber52,
  isObject: () => isObject232,
  isPromise: () => isPromise52,
  isPromiseLike: () => isPromiseLike52,
  isReadonlyRecord: () => isReadonlyRecord52,
  isRecord: () => isRecord52,
  isSet: () => isSet52,
  isString: () => isString52,
  isSymbol: () => isSymbol52,
  isTagged: () => isTagged52,
  isTruthy: () => isTruthy52,
  isUint8Array: () => isUint8Array52,
  isUndefined: () => isUndefined52,
  isUnknown: () => isUnknown52,
  mapInput: () => mapInput62,
  nand: () => nand52,
  nor: () => nor52,
  not: () => not52,
  or: () => or52,
  product: () => product232,
  productMany: () => productMany232,
  some: () => some332,
  struct: () => struct72,
  tuple: () => tuple62,
  xor: () => xor52
});
var mapInput62 = /* @__PURE__ */ dual232(2, (self2, f222) => (b222) => self2(f222(b222)));
var isTruthy52 = (input) => !!input;
var isSet52 = (input) => input instanceof Set;
var isMap52 = (input) => input instanceof Map;
var isString52 = (input) => typeof input === "string";
var isNumber52 = (input) => typeof input === "number";
var isBoolean52 = (input) => typeof input === "boolean";
var isBigInt52 = (input) => typeof input === "bigint";
var isSymbol52 = (input) => typeof input === "symbol";
var isFunction323 = isFunction2232;
var isUndefined52 = (input) => input === void 0;
var isNotUndefined52 = (input) => input !== void 0;
var isNull52 = (input) => input === null;
var isNotNull52 = (input) => input !== null;
var isNever52 = (_222) => false;
var isUnknown52 = (_222) => true;
var isRecordOrArray232 = (input) => typeof input === "object" && input !== null;
var isObject232 = (input) => isRecordOrArray232(input) || isFunction323(input);
var hasProperty232 = /* @__PURE__ */ dual232(2, (self2, property) => isObject232(self2) && property in self2);
var isTagged52 = /* @__PURE__ */ dual232(2, (self2, tag) => hasProperty232(self2, "_tag") && self2["_tag"] === tag);
var isNullable232 = (input) => input === null || input === void 0;
var isNotNullable52 = (input) => input !== null && input !== void 0;
var isError52 = (input) => input instanceof Error;
var isUint8Array52 = (input) => input instanceof Uint8Array;
var isDate52 = (input) => input instanceof Date;
var isIterable52 = (input) => hasProperty232(input, Symbol.iterator);
var isRecord52 = (input) => isRecordOrArray232(input) && !Array.isArray(input);
var isReadonlyRecord52 = isRecord52;
var isPromise52 = (input) => hasProperty232(input, "then") && "catch" in input && isFunction323(input.then) && isFunction323(input.catch);
var isPromiseLike52 = (input) => hasProperty232(input, "then") && isFunction323(input.then);
var compose2232 = /* @__PURE__ */ dual232(2, (ab, bc) => (a222) => ab(a222) && bc(a222));
var product232 = (self2, that) => ([a222, b222]) => self2(a222) && that(b222);
var all232 = (collection) => {
  return (as223) => {
    let collectionIndex = 0;
    for (const p222 of collection) {
      if (collectionIndex >= as223.length) {
        break;
      }
      if (p222(as223[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany232 = (self2, collection) => {
  const rest = all232(collection);
  return ([head222, ...tail32]) => self2(head222) === false ? false : rest(tail32);
};
var tuple62 = (...elements) => all232(elements);
var struct72 = (fields) => {
  const keys23 = Object.keys(fields);
  return (a222) => {
    for (const key of keys23) {
      if (!fields[key](a222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not52 = (self2) => (a222) => !self2(a222);
var or52 = /* @__PURE__ */ dual232(2, (self2, that) => (a222) => self2(a222) || that(a222));
var and52 = /* @__PURE__ */ dual232(2, (self2, that) => (a222) => self2(a222) && that(a222));
var xor52 = /* @__PURE__ */ dual232(2, (self2, that) => (a222) => self2(a222) !== that(a222));
var eqv52 = /* @__PURE__ */ dual232(2, (self2, that) => (a222) => self2(a222) === that(a222));
var implies52 = /* @__PURE__ */ dual232(2, (self2, that) => (a222) => self2(a222) ? that(a222) : true);
var nor52 = /* @__PURE__ */ dual232(2, (self2, that) => (a222) => !(self2(a222) || that(a222)));
var nand52 = /* @__PURE__ */ dual232(2, (self2, that) => (a222) => !(self2(a222) && that(a222)));
var every62 = (collection) => (a222) => {
  for (const p222 of collection) {
    if (!p222(a222)) {
      return false;
    }
  }
  return true;
};
var some332 = (collection) => (a222) => {
  for (const p222 of collection) {
    if (p222(a222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage232 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId232 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind232 = (u222) => isObject232(u222) && GenKindTypeId232 in u222;
var GenKindImpl232 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity232;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_222) => _222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_222) => _222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_222) => _222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId232] = GenKindTypeId232;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen232(this);
  }
};
var SingleShotGen232 = class _SingleShotGen62 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a222) {
    return this.called ? {
      value: a222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a222) {
    return {
      value: a222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e222) {
    throw e222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen62(this.self);
  }
};
var adapter332 = () => function() {
  let x222 = arguments[0];
  for (let i222 = 1; i222 < arguments.length; i222++) {
    x222 = arguments[i222](x222);
  }
  return new GenKindImpl232(x222);
};
var defaultIncHi232 = 335903614;
var defaultIncLo232 = 4150755663;
var MUL_HI232 = 1481765933 >>> 0;
var MUL_LO232 = 1284865837 >>> 0;
var BIT_53232 = 9007199254740992;
var BIT_27232 = 134217728;
var PCGRandom232 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable232(seedLo) && isNullable232(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable232(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable232(incLo) && isNullable232(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo232;
      incHi = this._state ? this._state[2] : defaultIncHi232;
    } else if (isNullable232(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add64232(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max32) {
    if (!max32) {
      return this._next();
    }
    max32 = max32 >>> 0;
    if ((max32 & max32 - 1) === 0) {
      return this._next() & max32 - 1;
    }
    let num = 0;
    const skew = (-max32 >>> 0) % max32 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max32;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_27232 + lo) / BIT_53232;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul64232(this._state, oldHi, oldLo, MUL_HI232, MUL_LO232);
    add64232(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul64232(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add64232(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId232 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap232 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId232]() {
    return this.#value;
  }
};
function yieldWrapGet232(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId232 in self2) {
    return self2[YieldWrapTypeId232]();
  }
  throw new Error(getBugErrorMessage232("yieldWrapGet"));
}
var structuralRegionState232 = /* @__PURE__ */ globalValue232("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache232 = /* @__PURE__ */ globalValue232(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr232 = /* @__PURE__ */ globalValue232(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom232());
var symbol332 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash232 = (self2) => {
  if (structuralRegionState232.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number232(self2);
    case "bigint":
      return string232(self2.toString(10));
    case "boolean":
      return string232(String(self2));
    case "symbol":
      return string232(String(self2));
    case "string":
      return string232(self2);
    case "undefined":
      return string232("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string232("null");
      } else if (self2 instanceof Date) {
        return hash232(self2.toISOString());
      } else if (isHash232(self2)) {
        return self2[symbol332]();
      } else {
        return random232(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random232 = (self2) => {
  if (!randomHashCache232.has(self2)) {
    randomHashCache232.set(self2, number232(pcgr232.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache232.get(self2);
};
var combine232 = (b222) => (self2) => self2 * 53 ^ b222;
var optimize232 = (n222) => n222 & 3221225471 | n222 >>> 1 & 1073741824;
var isHash232 = (u222) => hasProperty232(u222, symbol332);
var number232 = (n222) => {
  if (n222 !== n222 || n222 === Infinity) {
    return 0;
  }
  let h222 = n222 | 0;
  if (h222 !== n222) {
    h222 ^= n222 * 4294967295;
  }
  while (n222 > 4294967295) {
    h222 ^= n222 /= 4294967295;
  }
  return optimize232(n222);
};
var string232 = (str) => {
  let h222 = 5381, i222 = str.length;
  while (i222) {
    h222 = h222 * 33 ^ str.charCodeAt(--i222);
  }
  return optimize232(h222);
};
var structureKeys232 = (o222, keys23) => {
  let h222 = 12289;
  for (let i222 = 0; i222 < keys23.length; i222++) {
    h222 ^= pipe232(string232(keys23[i222]), combine232(hash232(o222[keys23[i222]])));
  }
  return optimize232(h222);
};
var structure232 = (o222) => structureKeys232(o222, Object.keys(o222));
var array72 = (arr) => {
  let h222 = 6151;
  for (let i222 = 0; i222 < arr.length; i222++) {
    h222 = pipe232(h222, combine232(hash232(arr[i222])));
  }
  return optimize232(h222);
};
var cached232 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash322) {
      Object.defineProperty(self22, symbol332, {
        value() {
          return hash322;
        },
        enumerable: false
      });
      return hash322;
    };
  }
  const self2 = arguments[0];
  const hash223 = arguments[1];
  Object.defineProperty(self2, symbol332, {
    value() {
      return hash223;
    },
    enumerable: false
  });
  return hash223;
};
var symbol2232 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals232() {
  if (arguments.length === 1) {
    return (self2) => compareBoth232(self2, arguments[0]);
  }
  return compareBoth232(arguments[0], arguments[1]);
}
function compareBoth232(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual232(self2) && isEqual232(that)) {
        if (hash232(self2) === hash232(that) && self2[symbol2232](that)) {
          return true;
        } else {
          return structuralRegionState232.enabled && structuralRegionState232.tester ? structuralRegionState232.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState232.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v222, i222) => compareBoth232(v222, that[i222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth232(self2[key], that[key]))) {
              return structuralRegionState232.tester ? structuralRegionState232.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState232.tester ? structuralRegionState232.tester(self2, that) : false;
    }
  }
  return structuralRegionState232.enabled && structuralRegionState232.tester ? structuralRegionState232.tester(self2, that) : false;
}
var isEqual232 = (u222) => hasProperty232(u222, symbol2232);
var equivalence232 = () => equals232;
var NodeInspectSymbol232 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON232 = (x222) => {
  if (hasProperty232(x222, "toJSON") && isFunction323(x222["toJSON"]) && x222["toJSON"].length === 0) {
    return x222.toJSON();
  } else if (Array.isArray(x222)) {
    return x222.map(toJSON232);
  }
  return x222;
};
var format232 = (x222) => JSON.stringify(x222, null, 2);
var pipeArguments232 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i222 = 0, len = args.length; i222 < len; i222++) {
        ret = args[i222](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT232 = "Commit";
var OP_FAILURE32 = "Failure";
var OP_WITH_RUNTIME32 = "WithRuntime";
var EffectTypeId232 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId232 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId232 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId232 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance232 = {
  /* c8 ignore next */
  _R: (_222) => _222,
  /* c8 ignore next */
  _E: (_222) => _222,
  /* c8 ignore next */
  _A: (_222) => _222,
  _V: /* @__PURE__ */ getCurrentVersion232()
};
var sinkVariance232 = {
  /* c8 ignore next */
  _A: (_222) => _222,
  /* c8 ignore next */
  _In: (_222) => _222,
  /* c8 ignore next */
  _L: (_222) => _222,
  /* c8 ignore next */
  _E: (_222) => _222,
  /* c8 ignore next */
  _R: (_222) => _222
};
var channelVariance232 = {
  /* c8 ignore next */
  _Env: (_222) => _222,
  /* c8 ignore next */
  _InErr: (_222) => _222,
  /* c8 ignore next */
  _InElem: (_222) => _222,
  /* c8 ignore next */
  _InDone: (_222) => _222,
  /* c8 ignore next */
  _OutErr: (_222) => _222,
  /* c8 ignore next */
  _OutElem: (_222) => _222,
  /* c8 ignore next */
  _OutDone: (_222) => _222
};
var EffectPrototype232 = {
  [EffectTypeId232]: effectVariance232,
  [StreamTypeId232]: effectVariance232,
  [SinkTypeId232]: sinkVariance232,
  [ChannelTypeId232]: channelVariance232,
  [symbol2232](that) {
    return this === that;
  },
  [symbol332]() {
    return cached232(this, random232(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen232(new YieldWrap232(this));
  },
  pipe() {
    return pipeArguments232(this, arguments);
  }
};
var StructuralPrototype232 = {
  [symbol332]() {
    return cached232(this, structure232(this));
  },
  [symbol2232](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals232(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype232 = {
  ...EffectPrototype232,
  _op: OP_COMMIT232
};
var StructuralCommitPrototype232 = {
  ...CommitPrototype232,
  ...StructuralPrototype232
};
var TypeId532 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto332 = {
  ...EffectPrototype232,
  [TypeId532]: {
    _A: (_222) => _222
  },
  [NodeInspectSymbol232]() {
    return this.toJSON();
  },
  toString() {
    return format232(this.toJSON());
  }
};
var SomeProto232 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto332), {
  _tag: "Some",
  _op: "Some",
  [symbol2232](that) {
    return isOption332(that) && isSome332(that) && equals232(this.value, that.value);
  },
  [symbol332]() {
    return cached232(this, combine232(hash232(this._tag))(hash232(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON232(this.value)
    };
  }
});
var NoneHash232 = /* @__PURE__ */ hash232("None");
var NoneProto232 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto332), {
  _tag: "None",
  _op: "None",
  [symbol2232](that) {
    return isOption332(that) && isNone332(that);
  },
  [symbol332]() {
    return NoneHash232;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption332 = (input) => hasProperty232(input, TypeId532);
var isNone332 = (fa) => fa._tag === "None";
var isSome332 = (fa) => fa._tag === "Some";
var none332 = /* @__PURE__ */ Object.create(NoneProto232);
var some2232 = (value) => {
  const a222 = Object.create(SomeProto232);
  a222.value = value;
  return a222;
};
var TypeId2232 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto2232 = {
  ...EffectPrototype232,
  [TypeId2232]: {
    _R: (_222) => _222
  },
  [NodeInspectSymbol232]() {
    return this.toJSON();
  },
  toString() {
    return format232(this.toJSON());
  }
};
var RightProto232 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2232), {
  _tag: "Right",
  _op: "Right",
  [symbol2232](that) {
    return isEither232(that) && isRight232(that) && equals232(this.right, that.right);
  },
  [symbol332]() {
    return combine232(hash232(this._tag))(hash232(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON232(this.right)
    };
  }
});
var LeftProto232 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2232), {
  _tag: "Left",
  _op: "Left",
  [symbol2232](that) {
    return isEither232(that) && isLeft232(that) && equals232(this.left, that.left);
  },
  [symbol332]() {
    return combine232(hash232(this._tag))(hash232(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON232(this.left)
    };
  }
});
var isEither232 = (input) => hasProperty232(input, TypeId2232);
var isLeft232 = (ma) => ma._tag === "Left";
var isRight232 = (ma) => ma._tag === "Right";
var left232 = (left33) => {
  const a222 = Object.create(LeftProto232);
  a222.left = left33;
  return a222;
};
var right232 = (right33) => {
  const a222 = Object.create(RightProto232);
  a222.right = right33;
  return a222;
};
var getLeft332 = (self2) => isRight232(self2) ? none332 : some2232(self2.left);
var getRight332 = (self2) => isLeft232(self2) ? none332 : some2232(self2.right);
var right2232 = right232;
var left2232 = left232;
var Option_exports232 = {};
__export232(Option_exports232, {
  Do: () => Do232,
  TypeId: () => TypeId3232,
  all: () => all2232,
  andThen: () => andThen232,
  ap: () => ap232,
  as: () => as232,
  asVoid: () => asVoid232,
  bind: () => bind2232,
  bindTo: () => bindTo2232,
  composeK: () => composeK232,
  contains: () => contains232,
  containsWith: () => containsWith232,
  exists: () => exists232,
  filter: () => filter232,
  filterMap: () => filterMap232,
  firstSomeOf: () => firstSomeOf232,
  flatMap: () => flatMap232,
  flatMapNullable: () => flatMapNullable232,
  flatten: () => flatten232,
  fromIterable: () => fromIterable232,
  fromNullable: () => fromNullable232,
  gen: () => gen232,
  getEquivalence: () => getEquivalence232,
  getLeft: () => getLeft2232,
  getOrElse: () => getOrElse232,
  getOrNull: () => getOrNull232,
  getOrThrow: () => getOrThrow232,
  getOrThrowWith: () => getOrThrowWith232,
  getOrUndefined: () => getOrUndefined232,
  getOrder: () => getOrder232,
  getRight: () => getRight2232,
  isNone: () => isNone2232,
  isOption: () => isOption2232,
  isSome: () => isSome2232,
  let: () => let_2232,
  lift2: () => lift2232,
  liftNullable: () => liftNullable232,
  liftPredicate: () => liftPredicate232,
  liftThrowable: () => liftThrowable232,
  map: () => map232,
  match: () => match232,
  none: () => none2232,
  orElse: () => orElse232,
  orElseEither: () => orElseEither232,
  orElseSome: () => orElseSome232,
  partitionMap: () => partitionMap232,
  product: () => product2232,
  productMany: () => productMany2232,
  reduceCompact: () => reduceCompact232,
  some: () => some3232,
  tap: () => tap232,
  toArray: () => toArray232,
  toRefinement: () => toRefinement232,
  void: () => void_232,
  zipLeft: () => zipLeft232,
  zipRight: () => zipRight232,
  zipWith: () => zipWith232
});
var make2232 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId3232 = /* @__PURE__ */ Symbol.for("effect/Option");
var none2232 = () => none332;
var some3232 = some2232;
var isOption2232 = isOption332;
var isNone2232 = isNone332;
var isSome2232 = isSome332;
var match232 = /* @__PURE__ */ dual232(2, (self2, {
  onNone,
  onSome
}) => isNone2232(self2) ? onNone() : onSome(self2.value));
var toRefinement232 = (f222) => (a222) => isSome2232(f222(a222));
var fromIterable232 = (collection) => {
  for (const a222 of collection) {
    return some3232(a222);
  }
  return none2232();
};
var getRight2232 = getRight332;
var getLeft2232 = getLeft332;
var getOrElse232 = /* @__PURE__ */ dual232(2, (self2, onNone) => isNone2232(self2) ? onNone() : self2.value);
var orElse232 = /* @__PURE__ */ dual232(2, (self2, that) => isNone2232(self2) ? that() : self2);
var orElseSome232 = /* @__PURE__ */ dual232(2, (self2, onNone) => isNone2232(self2) ? some3232(onNone()) : self2);
var orElseEither232 = /* @__PURE__ */ dual232(2, (self2, that) => isNone2232(self2) ? map232(that(), right232) : map232(self2, left232));
var firstSomeOf232 = (collection) => {
  let out = none2232();
  for (out of collection) {
    if (isSome2232(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable232 = (nullableValue) => nullableValue == null ? none2232() : some3232(nullableValue);
var liftNullable232 = (f222) => (...a222) => fromNullable232(f222(...a222));
var getOrNull232 = /* @__PURE__ */ getOrElse232(constNull232);
var getOrUndefined232 = /* @__PURE__ */ getOrElse232(constUndefined232);
var liftThrowable232 = (f222) => (...a222) => {
  try {
    return some3232(f222(...a222));
  } catch (e222) {
    return none2232();
  }
};
var getOrThrowWith232 = /* @__PURE__ */ dual232(2, (self2, onNone) => {
  if (isSome2232(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow232 = /* @__PURE__ */ getOrThrowWith232(() => new Error("getOrThrow called on a None"));
var map232 = /* @__PURE__ */ dual232(2, (self2, f222) => isNone2232(self2) ? none2232() : some3232(f222(self2.value)));
var as232 = /* @__PURE__ */ dual232(2, (self2, b222) => map232(self2, () => b222));
var asVoid232 = /* @__PURE__ */ as232(void 0);
var void_232 = /* @__PURE__ */ some3232(void 0);
var flatMap232 = /* @__PURE__ */ dual232(2, (self2, f222) => isNone2232(self2) ? none2232() : f222(self2.value));
var andThen232 = /* @__PURE__ */ dual232(2, (self2, f222) => flatMap232(self2, (a222) => {
  const b222 = isFunction2232(f222) ? f222(a222) : f222;
  return isOption2232(b222) ? b222 : some3232(b222);
}));
var flatMapNullable232 = /* @__PURE__ */ dual232(2, (self2, f222) => isNone2232(self2) ? none2232() : fromNullable232(f222(self2.value)));
var flatten232 = /* @__PURE__ */ flatMap232(identity232);
var zipRight232 = /* @__PURE__ */ dual232(2, (self2, that) => flatMap232(self2, () => that));
var composeK232 = /* @__PURE__ */ dual232(2, (afb, bfc) => (a222) => flatMap232(afb(a222), bfc));
var zipLeft232 = /* @__PURE__ */ dual232(2, (self2, that) => tap232(self2, () => that));
var tap232 = /* @__PURE__ */ dual232(2, (self2, f222) => flatMap232(self2, (a222) => map232(f222(a222), () => a222)));
var product2232 = (self2, that) => isSome2232(self2) && isSome2232(that) ? some3232([self2.value, that.value]) : none2232();
var productMany2232 = (self2, collection) => {
  if (isNone2232(self2)) {
    return none2232();
  }
  const out = [self2.value];
  for (const o222 of collection) {
    if (isNone2232(o222)) {
      return none2232();
    }
    out.push(o222.value);
  }
  return some3232(out);
};
var all2232 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o222 of input) {
      if (isNone2232(o222)) {
        return none2232();
      }
      out2.push(o222.value);
    }
    return some3232(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o222 = input[key];
    if (isNone2232(o222)) {
      return none2232();
    }
    out[key] = o222.value;
  }
  return some3232(out);
};
var zipWith232 = /* @__PURE__ */ dual232(3, (self2, that, f222) => map232(product2232(self2, that), ([a222, b222]) => f222(a222, b222)));
var ap232 = /* @__PURE__ */ dual232(2, (self2, that) => zipWith232(self2, that, (f222, a222) => f222(a222)));
var reduceCompact232 = /* @__PURE__ */ dual232(3, (self2, b222, f222) => {
  let out = b222;
  for (const oa of self2) {
    if (isSome2232(oa)) {
      out = f222(out, oa.value);
    }
  }
  return out;
});
var toArray232 = (self2) => isNone2232(self2) ? [] : [self2.value];
var partitionMap232 = /* @__PURE__ */ dual232(2, (self2, f222) => {
  if (isNone2232(self2)) {
    return [none2232(), none2232()];
  }
  const e222 = f222(self2.value);
  return isLeft232(e222) ? [some3232(e222.left), none2232()] : [none2232(), some3232(e222.right)];
});
var filterMap232 = /* @__PURE__ */ dual232(2, (self2, f222) => isNone2232(self2) ? none2232() : f222(self2.value));
var filter232 = /* @__PURE__ */ dual232(2, (self2, predicate) => filterMap232(self2, (b222) => predicate(b222) ? some2232(b222) : none332));
var getEquivalence232 = (isEquivalent) => make432((x222, y222) => x222 === y222 || (isNone2232(x222) ? isNone2232(y222) : isNone2232(y222) ? false : isEquivalent(x222.value, y222.value)));
var getOrder232 = (O222) => make2232((self2, that) => isSome2232(self2) ? isSome2232(that) ? O222(self2.value, that.value) : 1 : -1);
var lift2232 = (f222) => dual232(2, (self2, that) => zipWith232(self2, that, f222));
var liftPredicate232 = (predicate) => (b222) => predicate(b222) ? some3232(b222) : none2232();
var containsWith232 = (isEquivalent) => dual232(2, (self2, a222) => isNone2232(self2) ? false : isEquivalent(self2.value, a222));
var _equivalence232 = /* @__PURE__ */ equivalence232();
var contains232 = /* @__PURE__ */ containsWith232(_equivalence232);
var exists232 = /* @__PURE__ */ dual232(2, (self2, refinement) => isNone2232(self2) ? false : refinement(self2.value));
var bindTo2232 = /* @__PURE__ */ bindTo332(map232);
var let_2232 = /* @__PURE__ */ let_332(map232);
var bind2232 = /* @__PURE__ */ bind332(map232, flatMap232);
var Do232 = /* @__PURE__ */ some3232({});
var adapter2232 = /* @__PURE__ */ adapter332();
var gen232 = (f222) => {
  const iterator = f222(adapter2232);
  let state = iterator.next();
  if (state.done) {
    return some3232(state.value);
  } else {
    let current = state.value;
    if (isGenKind232(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet232(current);
    }
    if (isNone2232(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind232(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet232(current);
        }
        if (isNone2232(current)) {
          return current;
        }
      }
    }
    return some3232(state.value);
  }
};
var fromIterable2232 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse52 = (self2) => Array.from(self2).reverse();
var reduce62 = /* @__PURE__ */ dual232(3, (self2, b222, f222) => fromIterable2232(self2).reduce((b2222, a222, i222) => f222(b2222, a222, i222), b222));
var TagTypeId32 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey32 = "effect/STM";
var STMTypeId32 = /* @__PURE__ */ Symbol.for(STMSymbolKey32);
var TagProto32 = {
  ...EffectPrototype232,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId32]: effectVariance232,
  [TagTypeId32]: {
    _Service: (_222) => _222,
    _Identifier: (_222) => _222
  },
  toString() {
    return format232(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol232]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make3232(this, self2);
  }
};
var makeGenericTag32 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto32);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId4232 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto32 = {
  [TypeId4232]: {
    _Services: (_222) => _222
  },
  [symbol2232](that) {
    if (isContext32(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k222 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k222) || !equals232(this.unsafeMap.get(k222), that.unsafeMap.get(k222))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol332]() {
    return cached232(this, number232(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments232(this, arguments);
  },
  toString() {
    return format232(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON232)
    };
  },
  [NodeInspectSymbol232]() {
    return this.toJSON();
  }
};
var makeContext32 = (unsafeMap) => {
  const context = Object.create(ContextProto32);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext32 = (u222) => hasProperty232(u222, TypeId4232);
var _empty72 = /* @__PURE__ */ makeContext32(/* @__PURE__ */ new Map());
var empty122 = () => _empty72;
var make3232 = (tag, service) => makeContext32(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag32 = makeGenericTag32;
var empty232 = empty122;
var TypeId5232 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy42(src, srcPos, dest, destPos, len) {
  for (let i222 = srcPos; i222 < Math.min(src.length, srcPos + len); i222++) {
    dest[destPos + i222 - srcPos] = src[i222];
  }
  return dest;
}
var emptyArray32 = [];
var getEquivalence2232 = (isEquivalent) => make432((self2, that) => self2.length === that.length && toReadonlyArray32(self2).every((value, i222) => isEquivalent(value, unsafeGet232(that, i222))));
var _equivalence2232 = /* @__PURE__ */ getEquivalence2232(equals232);
var ChunkProto32 = {
  [TypeId5232]: {
    _A: (_222) => _222
  },
  toString() {
    return format232(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray32(this).map(toJSON232)
    };
  },
  [NodeInspectSymbol232]() {
    return this.toJSON();
  },
  [symbol2232](that) {
    return isChunk32(that) && _equivalence2232(this, that);
  },
  [symbol332]() {
    return cached232(this, array72(toReadonlyArray32(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray32[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray32(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments232(this, arguments);
  }
};
var makeChunk32 = (backing) => {
  const chunk = Object.create(ChunkProto32);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty232;
      chunk.right = _empty232;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty232;
      chunk.right = _empty232;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty232;
      chunk.right = _empty232;
      break;
    }
  }
  return chunk;
};
var isChunk32 = (u222) => hasProperty232(u222, TypeId5232);
var _empty232 = /* @__PURE__ */ makeChunk32({
  _tag: "IEmpty"
});
var empty332 = () => _empty232;
var make4232 = (...as223) => as223.length === 1 ? of42(as223[0]) : unsafeFromNonEmptyArray32(as223);
var of42 = (a222) => makeChunk32({
  _tag: "ISingleton",
  a: a222
});
var copyToArray32 = (self2, array33, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy42(self2.backing.array, 0, array33, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray32(self2.left, array33, initial);
      copyToArray32(self2.right, array33, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array33[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i222 = 0;
      let j222 = initial;
      while (i222 < self2.length) {
        array33[j222] = unsafeGet232(self2, i222);
        i222 += 1;
        j222 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray32 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray32;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray32(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty232;
      self2.right = _empty232;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse232 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk32({
        _tag: "IArray",
        array: reverse52(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk32({
        _tag: "IConcat",
        left: reverse232(self2.backing.right),
        right: reverse232(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray32(reverse52(toReadonlyArray32(self2)));
  }
};
var unsafeFromArray32 = (self2) => makeChunk32({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray32 = (self2) => unsafeFromArray32(self2);
var unsafeGet232 = /* @__PURE__ */ dual232(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet232(self2.left, index) : unsafeGet232(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet232(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend52 = /* @__PURE__ */ dual232(2, (self2, elem) => appendAll42(of42(elem), self2));
var drop42 = /* @__PURE__ */ dual232(2, (self2, n222) => {
  if (n222 <= 0) {
    return self2;
  } else if (n222 >= self2.length) {
    return _empty232;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk32({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n222,
          length: self2.backing.length - n222
        });
      }
      case "IConcat": {
        if (n222 > self2.left.length) {
          return drop42(self2.right, n222 - self2.left.length);
        }
        return makeChunk32({
          _tag: "IConcat",
          left: drop42(self2.left, n222),
          right: self2.right
        });
      }
      default: {
        return makeChunk32({
          _tag: "ISlice",
          chunk: self2,
          offset: n222,
          length: self2.length - n222
        });
      }
    }
  }
});
var appendAll42 = /* @__PURE__ */ dual232(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff23 = that.depth - self2.depth;
  if (Math.abs(diff23) <= 1) {
    return makeChunk32({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff23 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll42(self2.right, that);
      return makeChunk32({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll42(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk32({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk32({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk32({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk32({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll42(self2, that.left);
      return makeChunk32({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll42(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk32({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk32({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk32({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk32({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty42 = (self2) => self2.length === 0;
var isNonEmpty32 = (self2) => self2.length > 0;
var unsafeHead32 = (self2) => unsafeGet232(self2, 0);
var headNonEmpty42 = unsafeHead32;
var tailNonEmpty42 = (self2) => drop42(self2, 1);
var SIZE32 = 5;
var BUCKET_SIZE32 = /* @__PURE__ */ Math.pow(2, SIZE32);
var MASK32 = BUCKET_SIZE32 - 1;
var MAX_INDEX_NODE32 = BUCKET_SIZE32 / 2;
var MIN_ARRAY_NODE32 = BUCKET_SIZE32 / 4;
function popcount32(x222) {
  x222 -= x222 >> 1 & 1431655765;
  x222 = (x222 & 858993459) + (x222 >> 2 & 858993459);
  x222 = x222 + (x222 >> 4) & 252645135;
  x222 += x222 >> 8;
  x222 += x222 >> 16;
  return x222 & 127;
}
function hashFragment32(shift22, h222) {
  return h222 >>> shift22 & MASK32;
}
function toBitmap32(x222) {
  return 1 << x222;
}
function fromBitmap32(bitmap, bit) {
  return popcount32(bitmap & bit - 1);
}
var make532 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate32(mutate23, at, v222, arr) {
  let out = arr;
  if (!mutate23) {
    const len = arr.length;
    out = new Array(len);
    for (let i222 = 0; i222 < len; ++i222) out[i222] = arr[i222];
  }
  out[at] = v222;
  return out;
}
function arraySpliceOut32(mutate23, at, arr) {
  const newLen = arr.length - 1;
  let i222 = 0;
  let g222 = 0;
  let out = arr;
  if (mutate23) {
    i222 = g222 = at;
  } else {
    out = new Array(newLen);
    while (i222 < at) out[g222++] = arr[i222++];
  }
  ++i222;
  while (i222 <= newLen) out[g222++] = arr[i222++];
  if (mutate23) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn32(mutate23, at, v222, arr) {
  const len = arr.length;
  if (mutate23) {
    let i2222 = len;
    while (i2222 >= at) arr[i2222--] = arr[i2222];
    arr[at] = v222;
    return arr;
  }
  let i222 = 0, g222 = 0;
  const out = new Array(len + 1);
  while (i222 < at) out[g222++] = arr[i222++];
  out[at] = v222;
  while (i222 < len) out[++g222] = arr[i222++];
  return out;
}
var EmptyNode32 = class _EmptyNode32 {
  _tag = "EmptyNode";
  modify(edit, _shift, f222, hash223, key, size43) {
    const v222 = f222(none2232());
    if (isNone2232(v222)) return new _EmptyNode32();
    ++size43.value;
    return new LeafNode32(edit, hash223, key, v222);
  }
};
function isEmptyNode32(a222) {
  return isTagged52(a222, "EmptyNode");
}
function isLeafNode32(node) {
  return isEmptyNode32(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode32(node, edit) {
  return isEmptyNode32(node) ? false : edit === node.edit;
}
var LeafNode32 = class _LeafNode32 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash223, key, value) {
    this.edit = edit;
    this.hash = hash223;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f222, hash223, key, size43) {
    if (equals232(key, this.key)) {
      const v2222 = f222(this.value);
      if (v2222 === this.value) return this;
      else if (isNone2232(v2222)) {
        --size43.value;
        return new EmptyNode32();
      }
      if (canEditNode32(this, edit)) {
        this.value = v2222;
        return this;
      }
      return new _LeafNode32(edit, hash223, key, v2222);
    }
    const v222 = f222(none2232());
    if (isNone2232(v222)) return this;
    ++size43.value;
    return mergeLeaves32(edit, shift22, this.hash, this, hash223, new _LeafNode32(edit, hash223, key, v222));
  }
};
var CollisionNode32 = class _CollisionNode32 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash223, children) {
    this.edit = edit;
    this.hash = hash223;
    this.children = children;
  }
  modify(edit, shift22, f222, hash223, key, size43) {
    if (hash223 === this.hash) {
      const canEdit = canEditNode32(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f222, key, size43);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode32(edit, this.hash, list) : list[0];
    }
    const v222 = f222(none2232());
    if (isNone2232(v222)) return this;
    ++size43.value;
    return mergeLeaves32(edit, shift22, this.hash, this, hash223, new LeafNode32(edit, hash223, key, v222));
  }
  updateCollisionList(mutate23, edit, hash223, list, f222, key, size43) {
    const len = list.length;
    for (let i222 = 0; i222 < len; ++i222) {
      const child = list[i222];
      if ("key" in child && equals232(key, child.key)) {
        const value = child.value;
        const newValue2 = f222(value);
        if (newValue2 === value) return list;
        if (isNone2232(newValue2)) {
          --size43.value;
          return arraySpliceOut32(mutate23, i222, list);
        }
        return arrayUpdate32(mutate23, i222, new LeafNode32(edit, hash223, key, newValue2), list);
      }
    }
    const newValue = f222(none2232());
    if (isNone2232(newValue)) return list;
    ++size43.value;
    return arrayUpdate32(mutate23, len, new LeafNode32(edit, hash223, key, newValue), list);
  }
};
var IndexedNode32 = class _IndexedNode32 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f222, hash223, key, size43) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment32(shift22, hash223);
    const bit = toBitmap32(frag);
    const indx = fromBitmap32(mask, bit);
    const exists223 = mask & bit;
    const canEdit = canEditNode32(this, edit);
    if (!exists223) {
      const _newChild = new EmptyNode32().modify(edit, shift22 + SIZE32, f222, hash223, key, size43);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE32 ? expand32(edit, frag, _newChild, mask, children) : new _IndexedNode32(edit, mask | bit, arraySpliceIn32(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE32, f222, hash223, key, size43);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode32(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode32();
      if (children.length <= 2 && isLeafNode32(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut32(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate32(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode32(edit, bitmap, newChildren);
  }
};
var ArrayNode32 = class _ArrayNode32 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size43, children) {
    this.edit = edit;
    this.size = size43;
    this.children = children;
  }
  modify(edit, shift22, f222, hash223, key, size43) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment32(shift22, hash223);
    const child = children[frag];
    const newChild = (child || new EmptyNode32()).modify(edit, shift22 + SIZE32, f222, hash223, key, size43);
    if (child === newChild) return this;
    const canEdit = canEditNode32(this, edit);
    let newChildren;
    if (isEmptyNode32(child) && !isEmptyNode32(newChild)) {
      ++count;
      newChildren = arrayUpdate32(canEdit, frag, newChild, children);
    } else if (!isEmptyNode32(child) && isEmptyNode32(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE32) {
        return pack32(edit, count, frag, children);
      }
      newChildren = arrayUpdate32(canEdit, frag, new EmptyNode32(), children);
    } else {
      newChildren = arrayUpdate32(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode32(edit, count, newChildren);
  }
};
function pack32(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g222 = 0;
  let bitmap = 0;
  for (let i222 = 0, len = elements.length; i222 < len; ++i222) {
    if (i222 !== removed) {
      const elem = elements[i222];
      if (elem && !isEmptyNode32(elem)) {
        children[g222++] = elem;
        bitmap |= 1 << i222;
      }
    }
  }
  return new IndexedNode32(edit, bitmap, children);
}
function expand32(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i222 = 0; bit; ++i222) {
    if (bit & 1) arr[i222] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode32(edit, count + 1, arr);
}
function mergeLeavesInner32(edit, shift22, h1, n1, h222, n222) {
  if (h1 === h222) return new CollisionNode32(edit, h1, [n222, n1]);
  const subH1 = hashFragment32(shift22, h1);
  const subH2 = hashFragment32(shift22, h222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode32(edit, toBitmap32(subH1) | toBitmap32(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n222] : [n222, n1];
    return new IndexedNode32(edit, toBitmap32(subH1) | toBitmap32(subH2), children);
  }
}
function mergeLeaves32(edit, shift22, h1, n1, h222, n222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner32(edit, currentShift, h1, n1, h222, n222);
    if (typeof res === "function") {
      stack = make532(res, stack);
      currentShift = currentShift + SIZE32;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey32 = "effect/HashMap";
var HashMapTypeId32 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey32);
var HashMapProto32 = {
  [HashMapTypeId32]: HashMapTypeId32,
  [Symbol.iterator]() {
    return new HashMapIterator32(this, (k222, v222) => [k222, v222]);
  },
  [symbol332]() {
    let hash223 = hash232(HashMapSymbolKey32);
    for (const item of this) {
      hash223 ^= pipe232(hash232(item[0]), combine232(hash232(item[1])));
    }
    return cached232(this, hash223);
  },
  [symbol2232](that) {
    if (isHashMap32(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe232(that, getHash32(item[0], hash232(item[0])));
        if (isNone2232(elem)) {
          return false;
        } else {
          if (!equals232(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format232(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON232)
    };
  },
  [NodeInspectSymbol232]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments232(this, arguments);
  }
};
var makeImpl42 = (editable, edit, root, size43) => {
  const map622 = Object.create(HashMapProto32);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size43;
  return map622;
};
var HashMapIterator32 = class _HashMapIterator32 {
  map;
  f;
  v;
  constructor(map622, f222) {
    this.map = map622;
    this.f = f222;
    this.v = visitLazy32(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone2232(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont32(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator32(this.map, this.f);
  }
};
var applyCont32 = (cont) => cont ? visitLazyChildren32(cont[0], cont[1], cont[2], cont[3], cont[4]) : none2232();
var visitLazy32 = (node, f222, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome2232(node.value)) {
        return some3232({
          value: f222(node.key, node.value.value),
          cont
        });
      }
      return applyCont32(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren32(children.length, children, 0, f222, cont);
    }
    default: {
      return applyCont32(cont);
    }
  }
};
var visitLazyChildren32 = (len, children, i222, f222, cont) => {
  while (i222 < len) {
    const child = children[i222++];
    if (child && !isEmptyNode32(child)) {
      return visitLazy32(child, f222, [len, children, i222, f222, cont]);
    }
  }
  return applyCont32(cont);
};
var _empty332 = /* @__PURE__ */ makeImpl42(false, 0, /* @__PURE__ */ new EmptyNode32(), 0);
var empty432 = () => _empty332;
var isHashMap32 = (u222) => hasProperty232(u222, HashMapTypeId32);
var getHash32 = /* @__PURE__ */ dual232(3, (self2, key, hash223) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals232(key, node.key) ? node.value : none2232();
      }
      case "CollisionNode": {
        if (hash223 === node.hash) {
          const children = node.children;
          for (let i222 = 0, len = children.length; i222 < len; ++i222) {
            const child = children[i222];
            if ("key" in child && equals232(key, child.key)) {
              return child.value;
            }
          }
        }
        return none2232();
      }
      case "IndexedNode": {
        const frag = hashFragment32(shift22, hash223);
        const bit = toBitmap32(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap32(node.mask, bit)];
          shift22 += SIZE32;
          break;
        }
        return none2232();
      }
      case "ArrayNode": {
        node = node.children[hashFragment32(shift22, hash223)];
        if (node) {
          shift22 += SIZE32;
          break;
        }
        return none2232();
      }
      default:
        return none2232();
    }
  }
});
var set232 = /* @__PURE__ */ dual232(3, (self2, key, value) => modifyAt32(self2, key, () => some3232(value)));
var setTree32 = /* @__PURE__ */ dual232(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl42(self2._editable, self2._edit, newRoot, newSize);
});
var keys42 = (self2) => new HashMapIterator32(self2, (key) => key);
var size52 = (self2) => self2._size;
var beginMutation42 = (self2) => makeImpl42(true, self2._edit + 1, self2._root, self2._size);
var modifyAt32 = /* @__PURE__ */ dual232(3, (self2, key, f222) => modifyHash32(self2, key, hash232(key), f222));
var modifyHash32 = /* @__PURE__ */ dual232(4, (self2, key, hash223, f222) => {
  const size43 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f222, hash223, key, size43);
  return pipe232(self2, setTree32(newRoot, size43.value));
});
var forEach62 = /* @__PURE__ */ dual232(2, (self2, f222) => reduce232(self2, void 0, (_222, value, key) => f222(value, key)));
var reduce232 = /* @__PURE__ */ dual232(3, (self2, zero, f222) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome2232(root.value) ? f222(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i222 = 0, len = children.length; i222 < len; ) {
      const child = children[i222++];
      if (child && !isEmptyNode32(child)) {
        if (child._tag === "LeafNode") {
          if (isSome2232(child.value)) {
            zero = f222(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey32 = "effect/HashSet";
var HashSetTypeId32 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey32);
var HashSetProto32 = {
  [HashSetTypeId32]: HashSetTypeId32,
  [Symbol.iterator]() {
    return keys42(this._keyMap);
  },
  [symbol332]() {
    return cached232(this, combine232(hash232(this._keyMap))(hash232(HashSetSymbolKey32)));
  },
  [symbol2232](that) {
    if (isHashSet32(that)) {
      return size52(this._keyMap) === size52(that._keyMap) && equals232(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format232(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON232)
    };
  },
  [NodeInspectSymbol232]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments232(this, arguments);
  }
};
var makeImpl232 = (keyMap) => {
  const set223 = Object.create(HashSetProto32);
  set223._keyMap = keyMap;
  return set223;
};
var isHashSet32 = (u222) => hasProperty232(u222, HashSetTypeId32);
var _empty432 = /* @__PURE__ */ makeImpl232(/* @__PURE__ */ empty432());
var empty532 = () => _empty432;
var size232 = (self2) => size52(self2._keyMap);
var beginMutation232 = (self2) => makeImpl232(beginMutation42(self2._keyMap));
var endMutation32 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate32 = /* @__PURE__ */ dual232(2, (self2, f222) => {
  const transient = beginMutation232(self2);
  f222(transient);
  return endMutation32(transient);
});
var add232 = /* @__PURE__ */ dual232(2, (self2, value) => self2._keyMap._editable ? (set232(value, true)(self2._keyMap), self2) : makeImpl232(set232(value, true)(self2._keyMap)));
var union232 = /* @__PURE__ */ dual232(2, (self2, that) => mutate32(empty532(), (set223) => {
  forEach232(self2, (value) => add232(set223, value));
  for (const value of that) {
    add232(set223, value);
  }
}));
var forEach232 = /* @__PURE__ */ dual232(2, (self2, f222) => forEach62(self2._keyMap, (_222, k222) => f222(k222)));
var empty632 = empty532;
var size332 = size232;
var add332 = add232;
var union332 = union232;
var ArrayProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol332]() {
    return cached232(this, array72(this));
  },
  [symbol2232](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v222, i222) => equals232(v222, that[i222]));
    } else {
      return false;
    }
  }
});
var Structural42 = /* @__PURE__ */ function() {
  function Structural33(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural33.prototype = StructuralPrototype232;
  return Structural33;
}();
var struct232 = (as223) => Object.assign(Object.create(StructuralPrototype232), as223);
var ContextPatchTypeId32 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance42(a222) {
  return a222;
}
var PatchProto32 = {
  ...Structural42.prototype,
  [ContextPatchTypeId32]: {
    _Value: variance42,
    _Patch: variance42
  }
};
var EmptyProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto32), {
  _tag: "Empty"
});
var _empty532 = /* @__PURE__ */ Object.create(EmptyProto32);
var empty732 = () => _empty532;
var AndThenProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto32), {
  _tag: "AndThen"
});
var makeAndThen32 = (first, second) => {
  const o222 = Object.create(AndThenProto32);
  o222.first = first;
  o222.second = second;
  return o222;
};
var AddServiceProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto32), {
  _tag: "AddService"
});
var makeAddService32 = (key, service) => {
  const o222 = Object.create(AddServiceProto32);
  o222.key = key;
  o222.service = service;
  return o222;
};
var RemoveServiceProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto32), {
  _tag: "RemoveService"
});
var makeRemoveService32 = (key) => {
  const o222 = Object.create(RemoveServiceProto32);
  o222.key = key;
  return o222;
};
var UpdateServiceProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto32), {
  _tag: "UpdateService"
});
var makeUpdateService32 = (key, update222) => {
  const o222 = Object.create(UpdateServiceProto32);
  o222.key = key;
  o222.update = update222;
  return o222;
};
var diff32 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch23 = empty732();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals232(old, newService)) {
        patch23 = combine2232(makeUpdateService32(tag, () => newService))(patch23);
      }
    } else {
      missingServices.delete(tag);
      patch23 = combine2232(makeAddService32(tag, newService))(patch23);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch23 = combine2232(makeRemoveService32(tag))(patch23);
  }
  return patch23;
};
var combine2232 = /* @__PURE__ */ dual232(2, (self2, that) => makeAndThen32(self2, that));
var patch32 = /* @__PURE__ */ dual232(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of42(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty32(patches)) {
    const head222 = headNonEmpty42(patches);
    const tail32 = tailNonEmpty42(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail32;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail32;
        break;
      }
      case "AndThen": {
        patches = prepend52(prepend52(tail32, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail32;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail32;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext32(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s222] of updatedContext) {
    map622.set(tag, s222);
  }
  return makeContext32(map622);
});
var DifferTypeId32 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto32 = {
  [DifferTypeId32]: {
    _P: identity232,
    _V: identity232
  }
};
var make732 = (params) => {
  const differ = Object.create(DifferProto32);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment32 = () => make732({
  empty: empty732(),
  combine: (first, second) => combine2232(second)(first),
  diff: (oldValue, newValue) => diff32(oldValue, newValue),
  patch: (patch23, oldValue) => patch32(oldValue)(patch23)
});
var OP_DIE32 = "Die";
var OP_EMPTY32 = "Empty";
var OP_FAIL32 = "Fail";
var OP_INTERRUPT32 = "Interrupt";
var OP_PARALLEL32 = "Parallel";
var OP_SEQUENTIAL32 = "Sequential";
var CauseSymbolKey32 = "effect/Cause";
var CauseTypeId32 = /* @__PURE__ */ Symbol.for(CauseSymbolKey32);
var variance232 = {
  /* c8 ignore next */
  _E: (_222) => _222
};
var proto32 = {
  [CauseTypeId32]: variance232,
  [symbol332]() {
    return pipe232(hash232(CauseSymbolKey32), combine232(hash232(flattenCause32(this))), cached232(this));
  },
  [symbol2232](that) {
    return isCause32(that) && causeEquals32(this, that);
  },
  pipe() {
    return pipeArguments232(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON232(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON232(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON232(this.left),
          right: toJSON232(this.right)
        };
    }
  },
  toString() {
    return pretty32(this);
  },
  [NodeInspectSymbol232]() {
    return this.toJSON();
  }
};
var fail42 = (error) => {
  const o222 = Object.create(proto32);
  o222._tag = OP_FAIL32;
  o222.error = error;
  return o222;
};
var parallel32 = (left33, right33) => {
  const o222 = Object.create(proto32);
  o222._tag = OP_PARALLEL32;
  o222.left = left33;
  o222.right = right33;
  return o222;
};
var sequential32 = (left33, right33) => {
  const o222 = Object.create(proto32);
  o222._tag = OP_SEQUENTIAL32;
  o222.left = left33;
  o222.right = right33;
  return o222;
};
var isCause32 = (u222) => hasProperty232(u222, CauseTypeId32);
var isInterruptedOnly32 = (self2) => reduceWithContext32(void 0, IsInterruptedOnlyCauseReducer32)(self2);
var causeEquals32 = (left33, right33) => {
  let leftStack = of42(left33);
  let rightStack = of42(right33);
  while (isNonEmpty32(leftStack) && isNonEmpty32(rightStack)) {
    const [leftParallel, leftSequential] = pipe232(headNonEmpty42(leftStack), reduce432([empty632(), empty332()], ([parallel23, sequential23], cause) => {
      const [par, seq] = evaluateCause32(cause);
      return some3232([pipe232(parallel23, union332(par)), pipe232(sequential23, appendAll42(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe232(headNonEmpty42(rightStack), reduce432([empty632(), empty332()], ([parallel23, sequential23], cause) => {
      const [par, seq] = evaluateCause32(cause);
      return some3232([pipe232(parallel23, union332(par)), pipe232(sequential23, appendAll42(seq))]);
    }));
    if (!equals232(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause32 = (cause) => {
  return flattenCauseLoop32(of42(cause), empty332());
};
var flattenCauseLoop32 = (causes, flattened) => {
  while (1) {
    const [parallel23, sequential23] = pipe232(causes, reduce62([empty632(), empty332()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause32(cause);
      return [pipe232(parallel322, union332(par)), pipe232(sequential322, appendAll42(seq))];
    }));
    const updated = size332(parallel23) > 0 ? pipe232(flattened, prepend52(parallel23)) : flattened;
    if (isEmpty42(sequential23)) {
      return reverse232(updated);
    }
    causes = sequential23;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage232("Cause.flattenCauseLoop"));
};
var evaluateCause32 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty632();
  let _sequential = empty332();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY32: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL32: {
        _parallel = add332(_parallel, make4232(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE32: {
        _parallel = add332(_parallel, make4232(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT32: {
        _parallel = add332(_parallel, make4232(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL32: {
        switch (cause.left._tag) {
          case OP_EMPTY32: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL32: {
            cause = sequential32(cause.left.left, sequential32(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL32: {
            cause = parallel32(sequential32(cause.left.left, cause.right), sequential32(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend52(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL32: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage232("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer32 = {
  emptyCase: constTrue232,
  failCase: constFalse232,
  dieCase: constFalse232,
  interruptCase: constTrue232,
  sequentialCase: (_222, left33, right33) => left33 && right33,
  parallelCase: (_222, left33, right33) => left33 && right33
};
var OP_SEQUENTIAL_CASE32 = "SequentialCase";
var OP_PARALLEL_CASE32 = "ParallelCase";
var reduce432 = /* @__PURE__ */ dual232(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome2232(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL32: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL32: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext32 = /* @__PURE__ */ dual232(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY32: {
        output.push(right2232(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL32: {
        output.push(right2232(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE32: {
        output.push(right2232(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT32: {
        output.push(right2232(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL32: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2232({
          _tag: OP_SEQUENTIAL_CASE32
        }));
        break;
      }
      case OP_PARALLEL32: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2232({
          _tag: OP_PARALLEL_CASE32
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE32: {
            const left33 = accumulator.pop();
            const right33 = accumulator.pop();
            const value = reducer.sequentialCase(context, left33, right33);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE32: {
            const left33 = accumulator.pop();
            const right33 = accumulator.pop();
            const value = reducer.parallelCase(context, left33, right33);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty32 = (cause) => {
  if (isInterruptedOnly32(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors32(cause).map((e222) => e222.stack).join("\n");
};
var PrettyError32 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage32(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol42 in originalError) {
        this.span = originalError[spanSymbol42];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack32(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage32 = (u222) => {
  if (typeof u222 === "string") {
    return `Error: ${u222}`;
  }
  try {
    if (hasProperty232(u222, "toString") && isFunction323(u222["toString"]) && u222["toString"] !== Object.prototype.toString && u222["toString"] !== globalThis.Array.prototype.toString) {
      return u222["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u222)}`;
};
var locationRegex32 = /\((.*)\)/;
var spanToTrace32 = /* @__PURE__ */ globalValue232("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack32 = (message, stack, span22) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i222 = 1; i222 < lines.length; i222++) {
    if (lines[i222].includes("Generator.next")) {
      break;
    }
    if (lines[i222].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i222].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span22) {
    let current = span22;
    let i222 = 0;
    while (current && current._tag === "Span" && i222 < 10) {
      const stackFn = spanToTrace32.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex32);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined232(current.parent);
      i222++;
    }
  }
  return out.join("\n");
};
var spanSymbol42 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors32 = (cause) => reduceWithContext32(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_222, unknownError) => {
    return [new PrettyError32(unknownError)];
  },
  failCase: (_222, error) => {
    return [new PrettyError32(error)];
  },
  interruptCase: () => [],
  parallelCase: (_222, l222, r222) => [...l222, ...r222],
  sequentialCase: (_222, l222, r222) => [...l222, ...r222]
});
var SingleShotGen2232 = class _SingleShotGen232 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a222) {
    return this.called ? {
      value: a222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a222) {
    return {
      value: a222,
      done: true
    };
  }
  throw(e222) {
    throw e222;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen232(this.self);
  }
};
var spanTag32 = /* @__PURE__ */ GenericTag32("effect/ParentSpan");
var EffectTypeId2232 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive32 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2232] = effectVariance232;
  constructor(_op) {
    this._op = _op;
  }
  [symbol2232](that) {
    return this === that;
  }
  [symbol332]() {
    return cached232(this, random232(this));
  }
  pipe() {
    return pipeArguments232(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON232(this.effect_instruction_i0),
      effect_instruction_i1: toJSON232(this.effect_instruction_i1),
      effect_instruction_i2: toJSON232(this.effect_instruction_i2)
    };
  }
  toString() {
    return format232(this.toJSON());
  }
  [NodeInspectSymbol232]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2232(new YieldWrap232(this));
  }
};
var EffectPrimitiveFailure32 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2232] = effectVariance232;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol2232](that) {
    return exitIsExit32(that) && that._op === "Failure" && // @ts-expect-error
    equals232(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol332]() {
    return pipe232(
      // @ts-expect-error
      string232(this._tag),
      // @ts-expect-error
      combine232(hash232(this.effect_instruction_i0)),
      cached232(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments232(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format232(this.toJSON());
  }
  [NodeInspectSymbol232]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2232(new YieldWrap232(this));
  }
};
var isEffect32 = (u222) => hasProperty232(u222, EffectTypeId2232);
var withFiberRuntime32 = (withRuntime) => {
  const effect = new EffectPrimitive32(OP_WITH_RUNTIME32);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol232 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol32 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture32 = (obj, span22) => {
  if (isSome2232(span22)) {
    return new Proxy(obj, {
      has(target, p222) {
        return p222 === spanSymbol232 || p222 === originalSymbol32 || p222 in target;
      },
      get(target, p222) {
        if (p222 === spanSymbol232) {
          return span22.value;
        }
        if (p222 === originalSymbol32) {
          return obj;
        }
        return target[p222];
      }
    });
  }
  return obj;
};
var fail232 = (error) => isObject232(error) && !(spanSymbol232 in error) ? withFiberRuntime32((fiber) => failCause32(fail42(capture32(error, currentSpanFromFiber32(fiber))))) : failCause32(fail42(error));
var failCause32 = (cause) => {
  const effect = new EffectPrimitiveFailure32(OP_FAILURE32);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey32 = "effect/FiberRef";
var FiberRefTypeId32 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey32);
var fiberRefVariance32 = {
  /* c8 ignore next */
  _A: (_222) => _222
};
var fiberRefUnsafeMakeContext32 = (initial) => {
  const differ = environment32();
  return fiberRefUnsafeMakePatch32(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch32 = (initial, options) => ({
  [FiberRefTypeId32]: fiberRefVariance32,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch23) => (oldValue) => options.differ.patch(patch23, oldValue),
  fork: options.fork,
  join: options.join ?? ((_222, n222) => n222),
  pipe() {
    return pipeArguments232(this, arguments);
  }
});
var currentContext32 = /* @__PURE__ */ globalValue232(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext32(empty232()));
var YieldableError32 = /* @__PURE__ */ function() {
  class YieldableError23 extends globalThis.Error {
    commit() {
      return fail232(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol232]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError23.prototype, StructuralCommitPrototype232);
  return YieldableError23;
}();
var exitIsExit32 = (u222) => isEffect32(u222) && "_tag" in u222 && (u222._tag === "Success" || u222._tag === "Failure");
var currentSpanFromFiber32 = (fiber) => {
  const span22 = fiber.getFiberRef(currentContext32).unsafeMap.get(spanTag32.key);
  return span22 !== void 0 && span22._tag === "Span" ? some3232(span22) : none2232();
};
var Data_exports232 = {};
__export232(Data_exports232, {
  Class: () => Class232,
  Error: () => Error232,
  Structural: () => Structural232,
  TaggedClass: () => TaggedClass32,
  TaggedError: () => TaggedError32,
  array: () => array232,
  case: () => _case32,
  struct: () => struct332,
  tagged: () => tagged32,
  taggedEnum: () => taggedEnum32,
  tuple: () => tuple232,
  unsafeArray: () => unsafeArray32,
  unsafeStruct: () => unsafeStruct32
});
var struct332 = struct232;
var unsafeStruct32 = (as223) => Object.setPrototypeOf(as223, StructuralPrototype232);
var tuple232 = (...as223) => unsafeArray32(as223);
var array232 = (as223) => unsafeArray32(as223.slice(0));
var unsafeArray32 = (as223) => Object.setPrototypeOf(as223, ArrayProto32);
var _case32 = () => (args) => args === void 0 ? Object.create(StructuralPrototype232) : struct332(args);
var tagged32 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype232) : struct332(args);
  value._tag = tag;
  return value;
};
var Class232 = Structural42;
var TaggedClass32 = (tag) => {
  class Base extends Class232 {
    _tag = tag;
  }
  return Base;
};
var Structural232 = Structural42;
var taggedEnum32 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged52;
    } else if (tag === "$match") {
      return taggedMatch32;
    }
    return tagged32(tag);
  }
});
function taggedMatch32() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error232 = /* @__PURE__ */ function() {
  return class Base extends YieldableError32 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError32 = (tag) => {
  class Base extends Error232 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp32 = Function_exports232.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType32.Program) return Option_exports232.none();
  return predicate(parent) ? Option_exports232.some(parent) : traverseUp32(parent, predicate);
});
var traverseUpGuard32 = Function_exports232.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType32.Program) return Option_exports232.none();
  return predicate(parent) ? Option_exports232.some(parent) : traverseUpGuard32(parent, predicate);
});
var ESLintCommunityESLintUtils32;
((ESLintCommunityESLintUtils23) => {
  ESLintCommunityESLintUtils23.getFunctionHeadLocation = getFunctionHeadLocation32;
  ESLintCommunityESLintUtils23.getFunctionNameWithKind = getFunctionNameWithKind32;
  ESLintCommunityESLintUtils23.getPropertyName = getPropertyName32;
  ESLintCommunityESLintUtils23.getStaticValue = getStaticValue42;
  ESLintCommunityESLintUtils23.getStringIfConstant = getStringIfConstant32;
  ESLintCommunityESLintUtils23.hasSideEffect = hasSideEffect32;
  ESLintCommunityESLintUtils23.isParenthesized = isParenthesized32;
})(ESLintCommunityESLintUtils32 || (ESLintCommunityESLintUtils32 = {}));
var Construction32 = Data_exports232.taggedEnum();
Construction32.None();
a22({
  type: N22.union([NodeType32.FunctionExpression, NodeType32.ArrowFunctionExpression]),
  parent: {
    type: NodeType32.Property,
    parent: {
      type: NodeType32.ObjectExpression
    }
  }
});
a22({
  type: N22.union([NodeType32.FunctionExpression, NodeType32.ArrowFunctionExpression]),
  parent: {
    type: NodeType32.MethodDefinition,
    parent: {
      type: NodeType32.ClassBody
    }
  }
});
a22({
  type: N22.union([NodeType32.FunctionExpression, NodeType32.ArrowFunctionExpression]),
  parent: {
    type: NodeType32.Property,
    parent: {
      type: NodeType32.ClassBody
    }
  }
});
function isInitializedFromReact(variableName, context, initialScope) {
  if (variableName.toLowerCase() === "react") return true;
  const maybeVariable = findVariable32(variableName, initialScope);
  const maybeLatestDef = Option_exports42.flatMapNullable(maybeVariable, (v32) => v32.defs.at(-1));
  if (Option_exports42.isNone(maybeLatestDef)) return false;
  const latestDef = maybeLatestDef.value;
  const { node, parent } = latestDef;
  const settings = parse(ESLintSettingsSchema2, context.settings);
  const importSource = settings.reactOptions?.importSource ?? "react";
  if (node.type === NodeType4.VariableDeclarator && node.init) {
    const { init: init22 } = node;
    if (init22.type === NodeType4.MemberExpression && init22.object.type === NodeType4.Identifier) {
      return isInitializedFromReact(init22.object.name, context, initialScope);
    }
    if (init22.type === NodeType4.Identifier) {
      return isInitializedFromReact(init22.name, context, initialScope);
    }
    const maybeRequireExpression = $(init22).with({
      type: NodeType4.CallExpression,
      callee: { type: NodeType4.Identifier, name: "require" }
    }, (exp) => Option_exports42.some(exp)).with(
      {
        type: NodeType4.MemberExpression,
        object: {
          type: NodeType4.CallExpression,
          callee: { type: NodeType4.Identifier, name: "require" }
        }
      },
      ({ object: object22 }) => Option_exports42.some(object22)
    ).otherwise(Option_exports42.none);
    if (Option_exports42.isNone(maybeRequireExpression)) return false;
    const requireExpression = maybeRequireExpression.value;
    const [firstArg] = requireExpression.arguments;
    if (firstArg?.type !== NodeType4.Literal || !Predicate_exports32.isString(firstArg.value)) return false;
    return firstArg.value === importSource || firstArg.value.startsWith(`${importSource}/`);
  }
  return a({ type: "ImportDeclaration", source: { value: importSource } }, parent);
}
function isFromReact(name2) {
  return (node, context) => {
    const initialScope = context.sourceCode.getScope(node);
    if (node.type === NodeType4.MemberExpression) {
      return node.object.type === NodeType4.Identifier && node.property.type === NodeType4.Identifier && node.property.name === name2 && isInitializedFromReact(node.object.name, context, initialScope);
    }
    if (node.name === name2) return isInitializedFromReact(name2, context, initialScope);
    return false;
  };
}
function isFromReactMember(memberName, name2) {
  return (node, context) => {
    const initialScope = context.sourceCode.getScope(node);
    if (node.property.type !== NodeType4.Identifier || node.property.name !== name2) return false;
    if (node.object.type === NodeType4.Identifier && node.object.name === memberName) {
      return isInitializedFromReact(node.object.name, context, initialScope);
    }
    if (node.object.type === NodeType4.MemberExpression && node.object.object.type === NodeType4.Identifier && isInitializedFromReact(node.object.object.name, context, initialScope) && node.object.property.type === NodeType4.Identifier) {
      return node.object.property.name === memberName;
    }
    return false;
  };
}
function isCallFromReact(name2) {
  return (node, context) => {
    if (!isOneOf4([NodeType4.Identifier, NodeType4.MemberExpression])(node.callee)) return false;
    return isFromReact(name2)(node.callee, context);
  };
}
function isCallFromReactMember(pragmaMemberName, name2) {
  return (node, context) => {
    if (!is4(NodeType4.MemberExpression)(node.callee)) return false;
    return isFromReactMember(pragmaMemberName, name2)(node.callee, context);
  };
}
function isReactAPIWithName(name2, member) {
  return member ? isFromReactMember(name2, member) : isFromReact(name2);
}
function isReactAPICallWithName(name2, member) {
  return member ? isCallFromReactMember(name2, member) : isCallFromReact(name2);
}
var isChildrenCount = isReactAPIWithName("Children", "count");
var isChildrenForEach = isReactAPIWithName("Children", "forEach");
var isChildrenMap = isReactAPIWithName("Children", "map");
var isChildrenOnly = isReactAPIWithName("Children", "only");
var isChildrenToArray = isReactAPIWithName("Children", "toArray");
var isCloneElementCall = isReactAPICallWithName("cloneElement");
var isCreateElementCall = isReactAPICallWithName("createElement");
var isCreateRefCall = isReactAPICallWithName("createRef");
var isForwardRefCall = isReactAPICallWithName("forwardRef");
var isMemoCall = isReactAPICallWithName("memo");
function isInsideCreateElementProps(node, context) {
  return Function_exports42.pipe(
    traverseUp4(node, (n32) => is4(NodeType4.CallExpression)(n32) && isCreateElementCall(n32, context)),
    Option_exports42.filter(is4(NodeType4.CallExpression)),
    Option_exports42.flatMapNullable((c32) => c32.arguments.at(1)),
    Option_exports42.filter(is4(NodeType4.ObjectExpression)),
    Option_exports42.zipWith(traverseUp4(node, is4(NodeType4.ObjectExpression)), (a32, b32) => a32 === b32),
    Option_exports42.getOrElse(Function_exports42.constFalse)
  );
}
function isChildrenOfCreateElement(node, context) {
  return Function_exports42.pipe(
    Option_exports42.fromNullable(node.parent),
    Option_exports42.filter(is4(NodeType4.CallExpression)),
    Option_exports42.filter((n32) => isCreateElementCall(n32, context)),
    Option_exports42.exists(
      (n32) => n32.arguments.slice(2).some((arg) => arg === node)
    )
  );
}
function isFragmentElement(node, context) {
  const fragment = parse(ESLintSettingsSchema2, context.settings).reactOptions?.jsxPragmaFrag ?? "Fragment";
  const { name: name2 } = node.openingElement;
  if (name2.type === NodeType4.JSXIdentifier && name2.name === fragment) return true;
  const initialScope = context.sourceCode.getScope(node);
  return name2.type === NodeType4.JSXMemberExpression && name2.object.type === NodeType4.JSXIdentifier && isInitializedFromReact(name2.object.name, context, initialScope) && name2.property.name === fragment;
}
var RE_HOOK_NAME = /^use[A-Z\d]/u;
function isReactHookName(name2) {
  return name2 === "use" || RE_HOOK_NAME.test(name2);
}
function isReactHookCall(node) {
  if (node.callee.type === NodeType4.Identifier) return isReactHookName(node.callee.name);
  if (node.callee.type === NodeType4.MemberExpression) {
    return node.callee.property.type === NodeType4.Identifier && isReactHookName(node.callee.property.name);
  }
  return false;
}
function isReactHookCallWithNameLoose(name2) {
  return (node) => {
    return $(node.callee).with({ type: NodeType4.Identifier, name: name2 }, Function_exports42.constTrue).with({ type: NodeType4.MemberExpression, property: { name: name2 } }, Function_exports42.constTrue).otherwise(Function_exports42.constFalse);
  };
}
new import_short_unique_id.default({ length: 10 });
var ERComponentHint = {
  ...JSXValueHint2,
  // 1n << 0n - 1n << 63n are reserved for JSXValueHint
  // Skip function component created by React.memo
  SkipMemo: 1n << 64n,
  // Skip function component created by React.forwardRef
  SkipForwardRef: 1n << 65n,
  // Skip function component defined in map function callback
  SkipMapCallback: 1n << 66n,
  // Skip function component defined on object method
  SkipObjectMethod: 1n << 67n,
  // Skip function component defined on class method
  SkipClassMethod: 1n << 68n,
  // Skip function component defined on class property
  SkipClassProperty: 1n << 69n
};
var DEFAULT_COMPONENT_HINT = 0n | ERComponentHint.SkipUndefinedLiteral | ERComponentHint.SkipBooleanLiteral | ERComponentHint.SkipStringLiteral | ERComponentHint.SkipNumberLiteral;
var ERClassComponentFlag = {
  None: 0n,
  PureComponent: 1n << 0n
  // Reserved for future use
  // CreateElement: 1n << 1n,
};
var ERFunctionComponentFlag = {
  None: 0n,
  Memo: 1n << 0n,
  ForwardRef: 1n << 1n
  // Reserved for future use
  // CreateElement: 1n << 2n,
  // Reserved for future use
  // hasHooks: 1n << 3n,
  // Reserved for future use
  // Async: 1n << 4n,
};
function isComponentWrapperCall(node, context) {
  if (node.type !== NodeType4.CallExpression) return false;
  return isMemoCall(node, context) || isForwardRefCall(node, context) || isReactHookCallWithNameLoose("useCallback")(node);
}
function getFunctionComponentIdentifier(node, context) {
  const functionId = getFunctionIdentifier2(node);
  if (Option_exports42.isSome(functionId)) return functionId;
  const { parent } = node;
  if (parent.type === NodeType4.CallExpression && isComponentWrapperCall(parent, context) && parent.parent.type === NodeType4.VariableDeclarator && parent.parent.id.type === NodeType4.Identifier && parent.parent.parent.type === NodeType4.VariableDeclaration) {
    return Option_exports42.some(parent.parent.id);
  }
  if (parent.type === NodeType4.CallExpression && isComponentWrapperCall(parent, context) && parent.parent.type === NodeType4.CallExpression && isComponentWrapperCall(parent.parent, context) && parent.parent.parent.type === NodeType4.VariableDeclarator && parent.parent.parent.id.type === NodeType4.Identifier && parent.parent.parent.parent.type === NodeType4.VariableDeclaration) {
    return Option_exports42.some(parent.parent.parent.id);
  }
  return Option_exports42.none();
}
function getComponentInitPath(node) {
  const { parent } = node;
  if (node.type === NodeType4.FunctionDeclaration) return Option_exports42.some([node]);
  if (parent.type === NodeType4.VariableDeclarator && parent.parent.type === NodeType4.VariableDeclaration) {
    return Option_exports42.some([
      parent.parent,
      parent,
      node
    ]);
  }
  if (parent.type === NodeType4.CallExpression && parent.parent.type === NodeType4.VariableDeclarator && parent.parent.parent.type === NodeType4.VariableDeclaration) {
    return Option_exports42.some([
      parent.parent.parent,
      parent.parent,
      parent,
      node
    ]);
  }
  if (parent.type === NodeType4.CallExpression && parent.parent.type === NodeType4.CallExpression && parent.parent.parent.type === NodeType4.VariableDeclarator && parent.parent.parent.parent.type === NodeType4.VariableDeclaration) {
    return Option_exports42.some([
      parent.parent.parent.parent,
      parent.parent.parent,
      parent.parent,
      parent,
      node
    ]);
  }
  if (parent.type === NodeType4.Property && parent.parent.type === NodeType4.ObjectExpression && parent.parent.parent.type === NodeType4.VariableDeclarator && parent.parent.parent.parent.type === NodeType4.VariableDeclaration) {
    return Option_exports42.some([
      parent.parent.parent.parent,
      parent.parent.parent,
      parent.parent,
      parent,
      node
    ]);
  }
  if (parent.type === NodeType4.MethodDefinition && parent.parent.type === NodeType4.ClassBody && parent.parent.parent.type === NodeType4.ClassDeclaration) {
    return Option_exports42.some([
      parent.parent.parent,
      parent.parent,
      parent,
      node
    ]);
  }
  if (parent.type === NodeType4.PropertyDefinition && parent.parent.type === NodeType4.ClassBody && parent.parent.parent.type === NodeType4.ClassDeclaration) {
    return Option_exports42.some([
      parent.parent.parent,
      parent.parent,
      parent,
      node
    ]);
  }
  return Option_exports42.none();
}
function hasCallInInitPath(callName) {
  return (initPath) => {
    return Function_exports42.pipe(
      initPath,
      Option_exports42.filter((p32) => p32.length > 0),
      Option_exports42.exists((nodes) => {
        return nodes.some(
          // callName.includes(".")
          //   ? n => {
          //     const [objectName, propertyName] = callName.split(".");
          //     return "callee" in n
          //       && n.callee.type === NodeType.MemberExpression
          //       && n.callee.object.type === NodeType.Identifier
          //       && n.callee.object.name === objectName
          //       && n.callee.property.type === NodeType.Identifier
          //       && n.callee.property.name === propertyName;
          //   }
          //   : n => {
          //     return "callee" in n
          //       && n.callee.type === NodeType.Identifier
          //       && n.callee.name === callName;
          //   },
          (n32) => {
            if (n32.type !== NodeType4.CallExpression) return false;
            if (n32.callee.type === NodeType4.Identifier) return n32.callee.name === callName;
            return a({ callee: { property: { name: callName } } }, n32);
          }
        );
      })
    );
  };
}
var RE_COMPONENT_NAME = /^[A-Z]/u;
function getComponentNameFromIdentifier(node) {
  return Array.isArray(node) ? node.map((n32) => n32.name).join(".") : node.name;
}
function isComponentName(name2) {
  return !!name2 && RE_COMPONENT_NAME.test(name2);
}
function hasNoneOrValidComponentName(node, context) {
  return Option_exports42.match(
    getFunctionComponentIdentifier(node, context),
    {
      onNone: Function_exports42.constTrue,
      onSome: (id) => {
        const name2 = Array.isArray(id) ? id.at(-1)?.name : id.name;
        return !!name2 && isComponentName(name2);
      }
    }
  );
}
var uid2 = new import_short_unique_id.default({ length: 10 });
function isClassComponent(node) {
  if (!("superClass" in node && node.superClass)) return false;
  const { superClass } = node;
  return $(superClass).with({ type: NodeType4.Identifier, name: N.string }, ({ name: name2 }) => /^(Pure)?Component$/u.test(name2)).with({
    type: NodeType4.MemberExpression,
    property: { name: N.string }
  }, ({ property }) => /^(Pure)?Component$/u.test(property.name)).otherwise(() => false);
}
function isPureComponent(node) {
  if ("superClass" in node && node.superClass) {
    return $(node.superClass).with({ type: NodeType4.Identifier, name: N.string }, ({ name: name2 }) => /^PureComponent$/u.test(name2)).with({
      type: NodeType4.MemberExpression,
      property: { name: N.string }
    }, ({ property }) => /^PureComponent$/u.test(property.name)).otherwise(() => false);
  }
  return false;
}
function useComponentCollectorLegacy() {
  const components = /* @__PURE__ */ new Map();
  const ctx = {
    getAllComponents(_32) {
      return components;
    },
    getCurrentComponents() {
      return new Map(components);
    }
  };
  const collect22 = (node) => {
    if (!isClassComponent(node)) return;
    const id = getClassIdentifier2(node);
    const key = uid2.rnd();
    const flag = isPureComponent(node) ? ERClassComponentFlag.PureComponent : ERClassComponentFlag.None;
    components.set(
      key,
      {
        _: key,
        id,
        kind: "class",
        name: Option_exports42.flatMapNullable(id, (n32) => n32.name),
        // TODO: get displayName of class component
        displayName: Option_exports42.none(),
        flag,
        hint: 0n,
        // TODO: get methods of class component
        methods: [],
        node
      }
    );
  };
  const listeners = {
    ClassDeclaration: collect22,
    ClassExpression: collect22
  };
  return {
    ctx,
    listeners
  };
}
var isRenderMethodLike = a({
  key: {
    type: NodeType4.Identifier,
    name: "render"
  },
  type: N.union(NodeType4.MethodDefinition, NodeType4.PropertyDefinition),
  parent: {
    type: NodeType4.ClassBody,
    parent: {
      type: NodeType4.ClassDeclaration
    }
  }
});
function isFunctionOfRenderMethod(node) {
  if (!isRenderMethodLike(node.parent)) return false;
  return isClassComponent(node.parent.parent.parent);
}
function isInsideRenderMethod(node) {
  const predicate = (node2) => {
    return isRenderMethodLike(node2) && isClassComponent(node2.parent.parent);
  };
  return Option_exports42.isSome(traverseUp4(node, predicate));
}
var uid3 = new import_short_unique_id.default({ length: 10 });
var isMapCall = a({
  callee: {
    type: NodeType4.MemberExpression,
    property: {
      name: "map"
    }
  }
});
function hasValidHierarchy(node, context, hint) {
  if (isChildrenOfCreateElement(node, context) || isFunctionOfRenderMethod(node)) {
    return false;
  }
  if (hint & ERComponentHint.SkipMapCallback && isMapCall(node.parent)) {
    return false;
  }
  if (hint & ERComponentHint.SkipObjectMethod && isFunctionOfObjectMethod2(node.parent)) {
    return false;
  }
  if (hint & ERComponentHint.SkipClassMethod && isFunctionOfClassMethod2(node.parent)) {
    return false;
  }
  if (hint & ERComponentHint.SkipClassProperty && isFunctionOfClassProperty2(node.parent)) {
    return false;
  }
  return !Function_exports42.pipe(
    traverseUp4(
      node,
      isOneOf4([
        NodeType4.JSXExpressionContainer,
        NodeType4.ArrowFunctionExpression,
        NodeType4.FunctionExpression,
        NodeType4.Property,
        NodeType4.ClassBody
      ])
    ),
    Option_exports42.exists(is4(NodeType4.JSXExpressionContainer))
  );
}
function getComponentFlag(initPath) {
  const flagRef = MutableRef_exports.make(ERFunctionComponentFlag.None);
  if (hasCallInInitPath("memo")(initPath)) {
    MutableRef_exports.update(flagRef, (f32) => f32 | ERFunctionComponentFlag.Memo);
  }
  if (hasCallInInitPath("forwardRef")(initPath)) {
    MutableRef_exports.update(flagRef, (f32) => f32 | ERFunctionComponentFlag.ForwardRef);
  }
  return MutableRef_exports.get(flagRef);
}
function useComponentCollector(context, hint = DEFAULT_COMPONENT_HINT) {
  const components = /* @__PURE__ */ new Map();
  const functionStack = MutableList_exports.make();
  const getCurrentFunction = () => Option_exports42.fromNullable(MutableList_exports.tail(functionStack));
  const onFunctionEnter = (node) => MutableList_exports.append(functionStack, [node, false, []]);
  const onFunctionExit = () => MutableList_exports.pop(functionStack);
  const ctx = {
    getAllComponents(_32) {
      return components;
    },
    getCurrentComponents() {
      return new Map(components);
    },
    getCurrentFunction,
    getCurrentFunctionStack() {
      return [...functionStack];
    }
  };
  const listeners = {
    ":function": onFunctionEnter,
    ":function:exit": onFunctionExit,
    ReturnStatement(node) {
      const maybeCurrentFn = getCurrentFunction();
      if (Option_exports42.isNone(maybeCurrentFn)) return;
      const [currentFn, isKnown, hookCalls] = maybeCurrentFn.value;
      if (isKnown) return;
      const isComponent = hasNoneOrValidComponentName(currentFn, context) && isJSXValue(node.argument, context, hint) && hasValidHierarchy(currentFn, context, hint);
      if (!isComponent) return;
      MutableList_exports.pop(functionStack);
      MutableList_exports.append(functionStack, [currentFn, true, []]);
      const initPath = getComponentInitPath(currentFn);
      const id = getFunctionComponentIdentifier(currentFn, context);
      const name2 = Option_exports42.flatMapNullable(id, getComponentNameFromIdentifier);
      const key = uid3.rnd();
      components.set(key, {
        _: key,
        id,
        kind: "function",
        name: name2,
        displayName: Option_exports42.none(),
        flag: getComponentFlag(initPath),
        hint,
        hookCalls,
        initPath,
        node: currentFn
      });
    },
    // eslint-disable-next-line perfectionist/sort-objects
    "ArrowFunctionExpression[body.type!='BlockStatement']"() {
      const maybeCurrentFn = getCurrentFunction();
      if (Option_exports42.isNone(maybeCurrentFn)) return;
      const [currentFn, _32, hookCalls] = maybeCurrentFn.value;
      const { body } = currentFn;
      const isComponent = Function_exports42.constTrue() && hasNoneOrValidComponentName(currentFn, context) && isJSXValue(body, context, hint) && hasValidHierarchy(currentFn, context, hint);
      if (!isComponent) return;
      const initPath = getComponentInitPath(currentFn);
      const id = getFunctionComponentIdentifier(currentFn, context);
      const name2 = Option_exports42.flatMapNullable(id, getComponentNameFromIdentifier);
      const key = uid3.rnd();
      components.set(key, {
        _: key,
        id,
        kind: "function",
        name: name2,
        displayName: Option_exports42.none(),
        flag: getComponentFlag(initPath),
        hint,
        hookCalls,
        initPath,
        node: currentFn
      });
    },
    "CallExpression:exit"(node) {
      if (!isReactHookCall(node)) return;
      const maybeCurrentFn = getCurrentFunction();
      if (Option_exports42.isNone(maybeCurrentFn)) return;
      const [currentFn, IsComponent, hookCalls] = maybeCurrentFn.value;
      MutableList_exports.pop(functionStack);
      MutableList_exports.append(functionStack, [currentFn, IsComponent, [...hookCalls, node]]);
    },
    // eslint-disable-next-line perfectionist/sort-objects
    "AssignmentExpression[operator='='][left.type='MemberExpression'][left.property.name='displayName']"(node) {
      if (node.type !== NodeType4.AssignmentExpression) return;
      const { left: left72, right: right72 } = node;
      if (left72.type !== NodeType4.MemberExpression) return;
      const maybeComponentName = $(left72.object).with({ type: NodeType4.Identifier }, (n32) => Option_exports42.some(n32.name)).otherwise(Option_exports42.none);
      if (Option_exports42.isNone(maybeComponentName)) return;
      const component = Array.from(components.values()).findLast(({ name: name2 }) => Option_exports42.exists(name2, (n32) => n32 === maybeComponentName.value));
      if (!component) return;
      components.set(component._, {
        ...component,
        displayName: Option_exports42.some(right72)
      });
    }
  };
  return {
    ctx,
    listeners
  };
}
function unsafeIsDirectValueOfRenderProperty(node) {
  const matching = a({
    key: {
      type: NodeType4.Identifier,
      name: N.string.startsWith("render")
    },
    type: NodeType4.Property
  });
  return matching(node) || matching(node.parent);
}
function unsafeIsDeclaredInRenderProp(node) {
  if (unsafeIsDirectValueOfRenderProperty(node)) {
    return true;
  }
  return Function_exports42.pipe(
    traverseUpGuard4(node, is4(NodeType4.JSXExpressionContainer)),
    Option_exports42.flatMapNullable((c32) => c32.parent),
    Option_exports42.filter(is4(NodeType4.JSXAttribute)),
    Option_exports42.flatMapNullable((a32) => a32.name),
    Option_exports42.exists(a({
      type: NodeType4.JSXIdentifier,
      name: N.string.startsWith("render")
    }))
  );
}

// src/rules/avoid-shorthand-boolean.ts
var RULE_NAME = "avoid-shorthand-boolean";
var avoid_shorthand_boolean_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "enforce boolean attributes notation in JSX",
      requiresTypeChecking: false
    },
    messages: {
      AVOID_SHORTHAND_BOOLEAN: "Avoid using shorthand boolean attribute '{{propName}}'"
    },
    schema: []
  },
  name: RULE_NAME,
  create(context) {
    return {
      JSXAttribute(node) {
        const { value } = node;
        const propName = getPropName(node);
        if (value === null) {
          context.report({
            data: {
              propName
            },
            messageId: "AVOID_SHORTHAND_BOOLEAN",
            node
          });
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/avoid-shorthand-fragment.ts
var RULE_NAME2 = "avoid-shorthand-fragment";
var avoid_shorthand_fragment_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "enforce using fragment component instead of shorthand fragment syntax",
      requiresTypeChecking: false
    },
    messages: {
      AVOID_SHORTHAND_FRAGMENT: "Avoid shorthand fragment syntax, use fragment component instead."
    },
    schema: []
  },
  name: RULE_NAME2,
  create(context) {
    return {
      JSXFragment(node) {
        context.report({
          messageId: "AVOID_SHORTHAND_FRAGMENT",
          node
        });
      }
    };
  },
  defaultOptions: []
});

// src/rules/ensure-forward-ref-using-ref.ts
var RULE_NAME3 = "ensure-forward-ref-using-ref";
var ensure_forward_ref_using_ref_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "require all 'forwardRef' components include a 'ref' parameter",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      ENSURE_FORWARD_REF_USING_REF: "A 'forwardRef' is used with this component but no 'ref' parameter is set."
    },
    schema: []
  },
  name: RULE_NAME3,
  create(context) {
    return {
      CallExpression(node) {
        if (!isForwardRefCall(node, context)) return;
        const [component] = node.arguments;
        if (!component || !isFunction(component)) return;
        const [_5, ref] = component.params;
        if (!ref) {
          context.report({
            messageId: "ENSURE_FORWARD_REF_USING_REF",
            node: component
          });
        }
      }
    };
  },
  defaultOptions: []
});

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/Function.js
var Function_exports6 = {};
__export(Function_exports6, {
  SK: () => SK6,
  absurd: () => absurd6,
  apply: () => apply6,
  compose: () => compose9,
  constFalse: () => constFalse6,
  constNull: () => constNull6,
  constTrue: () => constTrue6,
  constUndefined: () => constUndefined6,
  constVoid: () => constVoid6,
  constant: () => constant6,
  dual: () => dual6,
  flip: () => flip6,
  flow: () => flow6,
  hole: () => hole6,
  identity: () => identity6,
  isFunction: () => isFunction10,
  pipe: () => pipe6,
  satisfies: () => satisfies6,
  tupled: () => tupled6,
  unsafeCoerce: () => unsafeCoerce6,
  untupled: () => untupled6
});
var isFunction10 = (input) => typeof input === "function";
var dual6 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a5, b5) {
        if (arguments.length >= 2) {
          return body(a5, b5);
        }
        return function(self2) {
          return body(self2, a5);
        };
      };
    case 3:
      return function(a5, b5, c5) {
        if (arguments.length >= 3) {
          return body(a5, b5, c5);
        }
        return function(self2) {
          return body(self2, a5, b5);
        };
      };
    case 4:
      return function(a5, b5, c5, d5) {
        if (arguments.length >= 4) {
          return body(a5, b5, c5, d5);
        }
        return function(self2) {
          return body(self2, a5, b5, c5);
        };
      };
    case 5:
      return function(a5, b5, c5, d5, e5) {
        if (arguments.length >= 5) {
          return body(a5, b5, c5, d5, e5);
        }
        return function(self2) {
          return body(self2, a5, b5, c5, d5);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply6 = (a5) => (self2) => self2(a5);
var identity6 = (a5) => a5;
var satisfies6 = () => (b5) => b5;
var unsafeCoerce6 = identity6;
var constant6 = (value) => () => value;
var constTrue6 = /* @__PURE__ */ constant6(true);
var constFalse6 = /* @__PURE__ */ constant6(false);
var constNull6 = /* @__PURE__ */ constant6(null);
var constUndefined6 = /* @__PURE__ */ constant6(void 0);
var constVoid6 = constUndefined6;
var flip6 = (f5) => (...b5) => (...a5) => f5(...a5)(...b5);
var compose9 = /* @__PURE__ */ dual6(2, (ab, bc) => (a5) => bc(ab(a5)));
var absurd6 = (_5) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled6 = (f5) => (a5) => f5(...a5);
var untupled6 = (f5) => (...a5) => f5(a5);
function pipe6(a5, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a5;
    case 2:
      return ab(a5);
    case 3:
      return bc(ab(a5));
    case 4:
      return cd(bc(ab(a5)));
    case 5:
      return de(cd(bc(ab(a5))));
    case 6:
      return ef(de(cd(bc(ab(a5)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a5))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a5)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a5))))))));
    default: {
      let ret = arguments[0];
      for (let i5 = 1; i5 < arguments.length; i5++) {
        ret = arguments[i5](ret);
      }
      return ret;
    }
  }
}
function flow6(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole6 = /* @__PURE__ */ unsafeCoerce6(absurd6);
var SK6 = (_5, b5) => b5;

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/Equivalence.js
var make17 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/internal/doNotation.js
var let_10 = (map10) => dual6(3, (self2, name2, f5) => map10(self2, (a5) => Object.assign({}, a5, {
  [name2]: f5(a5)
})));
var bindTo10 = (map10) => dual6(2, (self2, name2) => map10(self2, (a5) => ({
  [name2]: a5
})));
var bind10 = (map10, flatMap9) => dual6(3, (self2, name2, f5) => flatMap9(self2, (a5) => map10(f5(a5), (b5) => Object.assign({}, a5, {
  [name2]: b5
}))));

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/internal/version.js
var moduleVersion6 = "3.2.8";
var getCurrentVersion6 = () => moduleVersion6;

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/GlobalValue.js
var globalStoreId6 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion6()}`);
if (!(globalStoreId6 in globalThis)) {
  globalThis[globalStoreId6] = /* @__PURE__ */ new Map();
}
var globalStore6 = globalThis[globalStoreId6];
var globalValue6 = (id, compute) => {
  if (!globalStore6.has(id)) {
    globalStore6.set(id, compute());
  }
  return globalStore6.get(id);
};

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/Predicate.js
var Predicate_exports5 = {};
__export(Predicate_exports5, {
  all: () => all9,
  and: () => and6,
  compose: () => compose10,
  eqv: () => eqv6,
  every: () => every7,
  hasProperty: () => hasProperty6,
  implies: () => implies6,
  isBigInt: () => isBigInt6,
  isBoolean: () => isBoolean6,
  isDate: () => isDate6,
  isError: () => isError6,
  isFunction: () => isFunction11,
  isIterable: () => isIterable6,
  isMap: () => isMap6,
  isNever: () => isNever6,
  isNotNull: () => isNotNull6,
  isNotNullable: () => isNotNullable6,
  isNotUndefined: () => isNotUndefined6,
  isNull: () => isNull6,
  isNullable: () => isNullable6,
  isNumber: () => isNumber6,
  isObject: () => isObject6,
  isPromise: () => isPromise6,
  isPromiseLike: () => isPromiseLike6,
  isReadonlyRecord: () => isReadonlyRecord6,
  isRecord: () => isRecord6,
  isSet: () => isSet6,
  isString: () => isString6,
  isSymbol: () => isSymbol6,
  isTagged: () => isTagged6,
  isTruthy: () => isTruthy6,
  isUint8Array: () => isUint8Array6,
  isUndefined: () => isUndefined6,
  isUnknown: () => isUnknown6,
  mapInput: () => mapInput7,
  nand: () => nand6,
  nor: () => nor6,
  not: () => not6,
  or: () => or6,
  product: () => product9,
  productMany: () => productMany9,
  some: () => some13,
  struct: () => struct8,
  tuple: () => tuple7,
  xor: () => xor6
});
var mapInput7 = /* @__PURE__ */ dual6(2, (self2, f5) => (b5) => self2(f5(b5)));
var isTruthy6 = (input) => !!input;
var isSet6 = (input) => input instanceof Set;
var isMap6 = (input) => input instanceof Map;
var isString6 = (input) => typeof input === "string";
var isNumber6 = (input) => typeof input === "number";
var isBoolean6 = (input) => typeof input === "boolean";
var isBigInt6 = (input) => typeof input === "bigint";
var isSymbol6 = (input) => typeof input === "symbol";
var isFunction11 = isFunction10;
var isUndefined6 = (input) => input === void 0;
var isNotUndefined6 = (input) => input !== void 0;
var isNull6 = (input) => input === null;
var isNotNull6 = (input) => input !== null;
var isNever6 = (_5) => false;
var isUnknown6 = (_5) => true;
var isRecordOrArray6 = (input) => typeof input === "object" && input !== null;
var isObject6 = (input) => isRecordOrArray6(input) || isFunction11(input);
var hasProperty6 = /* @__PURE__ */ dual6(2, (self2, property) => isObject6(self2) && property in self2);
var isTagged6 = /* @__PURE__ */ dual6(2, (self2, tag) => hasProperty6(self2, "_tag") && self2["_tag"] === tag);
var isNullable6 = (input) => input === null || input === void 0;
var isNotNullable6 = (input) => input !== null && input !== void 0;
var isError6 = (input) => input instanceof Error;
var isUint8Array6 = (input) => input instanceof Uint8Array;
var isDate6 = (input) => input instanceof Date;
var isIterable6 = (input) => hasProperty6(input, Symbol.iterator);
var isRecord6 = (input) => isRecordOrArray6(input) && !Array.isArray(input);
var isReadonlyRecord6 = isRecord6;
var isPromise6 = (input) => hasProperty6(input, "then") && "catch" in input && isFunction11(input.then) && isFunction11(input.catch);
var isPromiseLike6 = (input) => hasProperty6(input, "then") && isFunction11(input.then);
var compose10 = /* @__PURE__ */ dual6(2, (ab, bc) => (a5) => ab(a5) && bc(a5));
var product9 = (self2, that) => ([a5, b5]) => self2(a5) && that(b5);
var all9 = (collection) => {
  return (as8) => {
    let collectionIndex = 0;
    for (const p5 of collection) {
      if (collectionIndex >= as8.length) {
        break;
      }
      if (p5(as8[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany9 = (self2, collection) => {
  const rest = all9(collection);
  return ([head4, ...tail4]) => self2(head4) === false ? false : rest(tail4);
};
var tuple7 = (...elements) => all9(elements);
var struct8 = (fields) => {
  const keys8 = Object.keys(fields);
  return (a5) => {
    for (const key of keys8) {
      if (!fields[key](a5[key])) {
        return false;
      }
    }
    return true;
  };
};
var not6 = (self2) => (a5) => !self2(a5);
var or6 = /* @__PURE__ */ dual6(2, (self2, that) => (a5) => self2(a5) || that(a5));
var and6 = /* @__PURE__ */ dual6(2, (self2, that) => (a5) => self2(a5) && that(a5));
var xor6 = /* @__PURE__ */ dual6(2, (self2, that) => (a5) => self2(a5) !== that(a5));
var eqv6 = /* @__PURE__ */ dual6(2, (self2, that) => (a5) => self2(a5) === that(a5));
var implies6 = /* @__PURE__ */ dual6(2, (self2, that) => (a5) => self2(a5) ? that(a5) : true);
var nor6 = /* @__PURE__ */ dual6(2, (self2, that) => (a5) => !(self2(a5) || that(a5)));
var nand6 = /* @__PURE__ */ dual6(2, (self2, that) => (a5) => !(self2(a5) && that(a5)));
var every7 = (collection) => (a5) => {
  for (const p5 of collection) {
    if (!p5(a5)) {
      return false;
    }
  }
  return true;
};
var some13 = (collection) => (a5) => {
  for (const p5 of collection) {
    if (p5(a5)) {
      return true;
    }
  }
  return false;
};

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/internal/errors.js
var getBugErrorMessage6 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/Utils.js
var GenKindTypeId6 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind6 = (u5) => isObject6(u5) && GenKindTypeId6 in u5;
var GenKindImpl6 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity6;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_5) => _5;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_5) => _5;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_5) => _5;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId6] = GenKindTypeId6;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen7(this);
  }
};
var SingleShotGen7 = class _SingleShotGen10 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a5) {
    return this.called ? {
      value: a5,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a5) {
    return {
      value: a5,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e5) {
    throw e5;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen10(this.self);
  }
};
var adapter9 = () => function() {
  let x5 = arguments[0];
  for (let i5 = 1; i5 < arguments.length; i5++) {
    x5 = arguments[i5](x5);
  }
  return new GenKindImpl6(x5);
};
var defaultIncHi6 = 335903614;
var defaultIncLo6 = 4150755663;
var MUL_HI6 = 1481765933 >>> 0;
var MUL_LO6 = 1284865837 >>> 0;
var BIT_536 = 9007199254740992;
var BIT_276 = 134217728;
var PCGRandom6 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable6(seedLo) && isNullable6(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable6(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable6(incLo) && isNullable6(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo6;
      incHi = this._state ? this._state[2] : defaultIncHi6;
    } else if (isNullable6(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add646(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max4) {
    if (!max4) {
      return this._next();
    }
    max4 = max4 >>> 0;
    if ((max4 & max4 - 1) === 0) {
      return this._next() & max4 - 1;
    }
    let num = 0;
    const skew = (-max4 >>> 0) % max4 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max4;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_276 + lo) / BIT_536;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul646(this._state, oldHi, oldLo, MUL_HI6, MUL_LO6);
    add646(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul646(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add646(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId6 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap6 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId6]() {
    return this.#value;
  }
};
function yieldWrapGet6(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId6 in self2) {
    return self2[YieldWrapTypeId6]();
  }
  throw new Error(getBugErrorMessage6("yieldWrapGet"));
}
var structuralRegionState6 = /* @__PURE__ */ globalValue6("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/Hash.js
var randomHashCache6 = /* @__PURE__ */ globalValue6(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr6 = /* @__PURE__ */ globalValue6(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom6());
var symbol9 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash6 = (self2) => {
  if (structuralRegionState6.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number7(self2);
    case "bigint":
      return string7(self2.toString(10));
    case "boolean":
      return string7(String(self2));
    case "symbol":
      return string7(String(self2));
    case "string":
      return string7(self2);
    case "undefined":
      return string7("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string7("null");
      } else if (self2 instanceof Date) {
        return hash6(self2.toISOString());
      } else if (isHash6(self2)) {
        return self2[symbol9]();
      } else {
        return random6(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random6 = (self2) => {
  if (!randomHashCache6.has(self2)) {
    randomHashCache6.set(self2, number7(pcgr6.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache6.get(self2);
};
var combine7 = (b5) => (self2) => self2 * 53 ^ b5;
var optimize6 = (n5) => n5 & 3221225471 | n5 >>> 1 & 1073741824;
var isHash6 = (u5) => hasProperty6(u5, symbol9);
var number7 = (n5) => {
  if (n5 !== n5 || n5 === Infinity) {
    return 0;
  }
  let h5 = n5 | 0;
  if (h5 !== n5) {
    h5 ^= n5 * 4294967295;
  }
  while (n5 > 4294967295) {
    h5 ^= n5 /= 4294967295;
  }
  return optimize6(n5);
};
var string7 = (str) => {
  let h5 = 5381, i5 = str.length;
  while (i5) {
    h5 = h5 * 33 ^ str.charCodeAt(--i5);
  }
  return optimize6(h5);
};
var cached6 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash9) {
      Object.defineProperty(self3, symbol9, {
        value() {
          return hash9;
        },
        enumerable: false
      });
      return hash9;
    };
  }
  const self2 = arguments[0];
  const hash8 = arguments[1];
  Object.defineProperty(self2, symbol9, {
    value() {
      return hash8;
    },
    enumerable: false
  });
  return hash8;
};

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/Equal.js
var symbol10 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals6() {
  if (arguments.length === 1) {
    return (self2) => compareBoth6(self2, arguments[0]);
  }
  return compareBoth6(arguments[0], arguments[1]);
}
function compareBoth6(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual6(self2) && isEqual6(that)) {
        if (hash6(self2) === hash6(that) && self2[symbol10](that)) {
          return true;
        } else {
          return structuralRegionState6.enabled && structuralRegionState6.tester ? structuralRegionState6.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState6.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v5, i5) => compareBoth6(v5, that[i5]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth6(self2[key], that[key]))) {
              return structuralRegionState6.tester ? structuralRegionState6.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState6.tester ? structuralRegionState6.tester(self2, that) : false;
    }
  }
  return structuralRegionState6.enabled && structuralRegionState6.tester ? structuralRegionState6.tester(self2, that) : false;
}
var isEqual6 = (u5) => hasProperty6(u5, symbol10);
var equivalence6 = () => equals6;

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/Inspectable.js
var NodeInspectSymbol6 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON6 = (x5) => {
  if (hasProperty6(x5, "toJSON") && isFunction11(x5["toJSON"]) && x5["toJSON"].length === 0) {
    return x5.toJSON();
  } else if (Array.isArray(x5)) {
    return x5.map(toJSON6);
  }
  return x5;
};
var format6 = (x5) => JSON.stringify(x5, null, 2);

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/Pipeable.js
var pipeArguments6 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i5 = 0, len = args.length; i5 < len; i5++) {
        ret = args[i5](ret);
      }
      return ret;
    }
  }
};

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/internal/effectable.js
var EffectTypeId7 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId6 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId6 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId6 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance6 = {
  /* c8 ignore next */
  _R: (_5) => _5,
  /* c8 ignore next */
  _E: (_5) => _5,
  /* c8 ignore next */
  _A: (_5) => _5,
  _V: /* @__PURE__ */ getCurrentVersion6()
};
var sinkVariance6 = {
  /* c8 ignore next */
  _A: (_5) => _5,
  /* c8 ignore next */
  _In: (_5) => _5,
  /* c8 ignore next */
  _L: (_5) => _5,
  /* c8 ignore next */
  _E: (_5) => _5,
  /* c8 ignore next */
  _R: (_5) => _5
};
var channelVariance6 = {
  /* c8 ignore next */
  _Env: (_5) => _5,
  /* c8 ignore next */
  _InErr: (_5) => _5,
  /* c8 ignore next */
  _InElem: (_5) => _5,
  /* c8 ignore next */
  _InDone: (_5) => _5,
  /* c8 ignore next */
  _OutErr: (_5) => _5,
  /* c8 ignore next */
  _OutElem: (_5) => _5,
  /* c8 ignore next */
  _OutDone: (_5) => _5
};
var EffectPrototype6 = {
  [EffectTypeId7]: effectVariance6,
  [StreamTypeId6]: effectVariance6,
  [SinkTypeId6]: sinkVariance6,
  [ChannelTypeId6]: channelVariance6,
  [symbol10](that) {
    return this === that;
  },
  [symbol9]() {
    return cached6(this, random6(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen7(new YieldWrap6(this));
  },
  pipe() {
    return pipeArguments6(this, arguments);
  }
};

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/internal/option.js
var TypeId16 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto9 = {
  ...EffectPrototype6,
  [TypeId16]: {
    _A: (_5) => _5
  },
  [NodeInspectSymbol6]() {
    return this.toJSON();
  },
  toString() {
    return format6(this.toJSON());
  }
};
var SomeProto6 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto9), {
  _tag: "Some",
  _op: "Some",
  [symbol10](that) {
    return isOption9(that) && isSome9(that) && equals6(this.value, that.value);
  },
  [symbol9]() {
    return cached6(this, combine7(hash6(this._tag))(hash6(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON6(this.value)
    };
  }
});
var NoneHash6 = /* @__PURE__ */ hash6("None");
var NoneProto6 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto9), {
  _tag: "None",
  _op: "None",
  [symbol10](that) {
    return isOption9(that) && isNone9(that);
  },
  [symbol9]() {
    return NoneHash6;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption9 = (input) => hasProperty6(input, TypeId16);
var isNone9 = (fa) => fa._tag === "None";
var isSome9 = (fa) => fa._tag === "Some";
var none9 = /* @__PURE__ */ Object.create(NoneProto6);
var some14 = (value) => {
  const a5 = Object.create(SomeProto6);
  a5.value = value;
  return a5;
};

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/internal/either.js
var TypeId17 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto10 = {
  ...EffectPrototype6,
  [TypeId17]: {
    _R: (_5) => _5
  },
  [NodeInspectSymbol6]() {
    return this.toJSON();
  },
  toString() {
    return format6(this.toJSON());
  }
};
var RightProto6 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto10), {
  _tag: "Right",
  _op: "Right",
  [symbol10](that) {
    return isEither6(that) && isRight7(that) && equals6(this.right, that.right);
  },
  [symbol9]() {
    return combine7(hash6(this._tag))(hash6(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON6(this.right)
    };
  }
});
var LeftProto6 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto10), {
  _tag: "Left",
  _op: "Left",
  [symbol10](that) {
    return isEither6(that) && isLeft7(that) && equals6(this.left, that.left);
  },
  [symbol9]() {
    return combine7(hash6(this._tag))(hash6(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON6(this.left)
    };
  }
});
var isEither6 = (input) => hasProperty6(input, TypeId17);
var isLeft7 = (ma) => ma._tag === "Left";
var isRight7 = (ma) => ma._tag === "Right";
var left7 = (left9) => {
  const a5 = Object.create(LeftProto6);
  a5.left = left9;
  return a5;
};
var right7 = (right9) => {
  const a5 = Object.create(RightProto6);
  a5.right = right9;
  return a5;
};
var getLeft9 = (self2) => isRight7(self2) ? none9 : some14(self2.left);
var getRight9 = (self2) => isLeft7(self2) ? none9 : some14(self2.right);

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/Either.js
var isLeft8 = isLeft7;
var isRight8 = isRight7;

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/Option.js
var Option_exports6 = {};
__export(Option_exports6, {
  Do: () => Do7,
  TypeId: () => TypeId18,
  all: () => all10,
  andThen: () => andThen6,
  ap: () => ap6,
  as: () => as6,
  asVoid: () => asVoid6,
  bind: () => bind11,
  bindTo: () => bindTo11,
  composeK: () => composeK6,
  contains: () => contains7,
  containsWith: () => containsWith7,
  exists: () => exists6,
  filter: () => filter7,
  filterMap: () => filterMap7,
  firstSomeOf: () => firstSomeOf6,
  flatMap: () => flatMap7,
  flatMapNullable: () => flatMapNullable7,
  flatten: () => flatten7,
  fromIterable: () => fromIterable9,
  fromNullable: () => fromNullable7,
  gen: () => gen6,
  getEquivalence: () => getEquivalence8,
  getLeft: () => getLeft10,
  getOrElse: () => getOrElse6,
  getOrNull: () => getOrNull6,
  getOrThrow: () => getOrThrow6,
  getOrThrowWith: () => getOrThrowWith6,
  getOrUndefined: () => getOrUndefined6,
  getOrder: () => getOrder7,
  getRight: () => getRight10,
  isNone: () => isNone10,
  isOption: () => isOption10,
  isSome: () => isSome10,
  let: () => let_11,
  lift2: () => lift26,
  liftNullable: () => liftNullable7,
  liftPredicate: () => liftPredicate7,
  liftThrowable: () => liftThrowable6,
  map: () => map7,
  match: () => match,
  none: () => none10,
  orElse: () => orElse6,
  orElseEither: () => orElseEither6,
  orElseSome: () => orElseSome6,
  partitionMap: () => partitionMap7,
  product: () => product10,
  productMany: () => productMany10,
  reduceCompact: () => reduceCompact6,
  some: () => some15,
  tap: () => tap6,
  toArray: () => toArray6,
  toRefinement: () => toRefinement6,
  void: () => void_6,
  zipLeft: () => zipLeft6,
  zipRight: () => zipRight6,
  zipWith: () => zipWith7
});

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/Order.js
var make18 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/Option.js
var TypeId18 = /* @__PURE__ */ Symbol.for("effect/Option");
var none10 = () => none9;
var some15 = some14;
var isOption10 = isOption9;
var isNone10 = isNone9;
var isSome10 = isSome9;
var match = /* @__PURE__ */ dual6(2, (self2, {
  onNone,
  onSome
}) => isNone10(self2) ? onNone() : onSome(self2.value));
var toRefinement6 = (f5) => (a5) => isSome10(f5(a5));
var fromIterable9 = (collection) => {
  for (const a5 of collection) {
    return some15(a5);
  }
  return none10();
};
var getRight10 = getRight9;
var getLeft10 = getLeft9;
var getOrElse6 = /* @__PURE__ */ dual6(2, (self2, onNone) => isNone10(self2) ? onNone() : self2.value);
var orElse6 = /* @__PURE__ */ dual6(2, (self2, that) => isNone10(self2) ? that() : self2);
var orElseSome6 = /* @__PURE__ */ dual6(2, (self2, onNone) => isNone10(self2) ? some15(onNone()) : self2);
var orElseEither6 = /* @__PURE__ */ dual6(2, (self2, that) => isNone10(self2) ? map7(that(), right7) : map7(self2, left7));
var firstSomeOf6 = (collection) => {
  let out = none10();
  for (out of collection) {
    if (isSome10(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable7 = (nullableValue) => nullableValue == null ? none10() : some15(nullableValue);
var liftNullable7 = (f5) => (...a5) => fromNullable7(f5(...a5));
var getOrNull6 = /* @__PURE__ */ getOrElse6(constNull6);
var getOrUndefined6 = /* @__PURE__ */ getOrElse6(constUndefined6);
var liftThrowable6 = (f5) => (...a5) => {
  try {
    return some15(f5(...a5));
  } catch (e5) {
    return none10();
  }
};
var getOrThrowWith6 = /* @__PURE__ */ dual6(2, (self2, onNone) => {
  if (isSome10(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow6 = /* @__PURE__ */ getOrThrowWith6(() => new Error("getOrThrow called on a None"));
var map7 = /* @__PURE__ */ dual6(2, (self2, f5) => isNone10(self2) ? none10() : some15(f5(self2.value)));
var as6 = /* @__PURE__ */ dual6(2, (self2, b5) => map7(self2, () => b5));
var asVoid6 = /* @__PURE__ */ as6(void 0);
var void_6 = /* @__PURE__ */ some15(void 0);
var flatMap7 = /* @__PURE__ */ dual6(2, (self2, f5) => isNone10(self2) ? none10() : f5(self2.value));
var andThen6 = /* @__PURE__ */ dual6(2, (self2, f5) => flatMap7(self2, (a5) => {
  const b5 = isFunction10(f5) ? f5(a5) : f5;
  return isOption10(b5) ? b5 : some15(b5);
}));
var flatMapNullable7 = /* @__PURE__ */ dual6(2, (self2, f5) => isNone10(self2) ? none10() : fromNullable7(f5(self2.value)));
var flatten7 = /* @__PURE__ */ flatMap7(identity6);
var zipRight6 = /* @__PURE__ */ dual6(2, (self2, that) => flatMap7(self2, () => that));
var composeK6 = /* @__PURE__ */ dual6(2, (afb, bfc) => (a5) => flatMap7(afb(a5), bfc));
var zipLeft6 = /* @__PURE__ */ dual6(2, (self2, that) => tap6(self2, () => that));
var tap6 = /* @__PURE__ */ dual6(2, (self2, f5) => flatMap7(self2, (a5) => map7(f5(a5), () => a5)));
var product10 = (self2, that) => isSome10(self2) && isSome10(that) ? some15([self2.value, that.value]) : none10();
var productMany10 = (self2, collection) => {
  if (isNone10(self2)) {
    return none10();
  }
  const out = [self2.value];
  for (const o5 of collection) {
    if (isNone10(o5)) {
      return none10();
    }
    out.push(o5.value);
  }
  return some15(out);
};
var all10 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o5 of input) {
      if (isNone10(o5)) {
        return none10();
      }
      out2.push(o5.value);
    }
    return some15(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o5 = input[key];
    if (isNone10(o5)) {
      return none10();
    }
    out[key] = o5.value;
  }
  return some15(out);
};
var zipWith7 = /* @__PURE__ */ dual6(3, (self2, that, f5) => map7(product10(self2, that), ([a5, b5]) => f5(a5, b5)));
var ap6 = /* @__PURE__ */ dual6(2, (self2, that) => zipWith7(self2, that, (f5, a5) => f5(a5)));
var reduceCompact6 = /* @__PURE__ */ dual6(3, (self2, b5, f5) => {
  let out = b5;
  for (const oa of self2) {
    if (isSome10(oa)) {
      out = f5(out, oa.value);
    }
  }
  return out;
});
var toArray6 = (self2) => isNone10(self2) ? [] : [self2.value];
var partitionMap7 = /* @__PURE__ */ dual6(2, (self2, f5) => {
  if (isNone10(self2)) {
    return [none10(), none10()];
  }
  const e5 = f5(self2.value);
  return isLeft7(e5) ? [some15(e5.left), none10()] : [none10(), some15(e5.right)];
});
var filterMap7 = /* @__PURE__ */ dual6(2, (self2, f5) => isNone10(self2) ? none10() : f5(self2.value));
var filter7 = /* @__PURE__ */ dual6(2, (self2, predicate) => filterMap7(self2, (b5) => predicate(b5) ? some14(b5) : none9));
var getEquivalence8 = (isEquivalent) => make17((x5, y5) => x5 === y5 || (isNone10(x5) ? isNone10(y5) : isNone10(y5) ? false : isEquivalent(x5.value, y5.value)));
var getOrder7 = (O5) => make18((self2, that) => isSome10(self2) ? isSome10(that) ? O5(self2.value, that.value) : 1 : -1);
var lift26 = (f5) => dual6(2, (self2, that) => zipWith7(self2, that, f5));
var liftPredicate7 = (predicate) => (b5) => predicate(b5) ? some15(b5) : none10();
var containsWith7 = (isEquivalent) => dual6(2, (self2, a5) => isNone10(self2) ? false : isEquivalent(self2.value, a5));
var _equivalence8 = /* @__PURE__ */ equivalence6();
var contains7 = /* @__PURE__ */ containsWith7(_equivalence8);
var exists6 = /* @__PURE__ */ dual6(2, (self2, refinement) => isNone10(self2) ? false : refinement(self2.value));
var bindTo11 = /* @__PURE__ */ bindTo10(map7);
var let_11 = /* @__PURE__ */ let_10(map7);
var bind11 = /* @__PURE__ */ bind10(map7, flatMap7);
var Do7 = /* @__PURE__ */ some15({});
var adapter10 = /* @__PURE__ */ adapter9();
var gen6 = (f5) => {
  const iterator = f5(adapter10);
  let state = iterator.next();
  if (state.done) {
    return some15(state.value);
  } else {
    let current = state.value;
    if (isGenKind6(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet6(current);
    }
    if (isNone10(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind6(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet6(current);
        }
        if (isNone10(current)) {
          return current;
        }
      }
    }
    return some15(state.value);
  }
};

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/Record.js
var Record_exports = {};
__export(Record_exports, {
  collect: () => collect3,
  difference: () => difference3,
  empty: () => empty13,
  every: () => every8,
  filter: () => filter8,
  filterMap: () => filterMap8,
  fromEntries: () => fromEntries,
  fromIterableBy: () => fromIterableBy,
  fromIterableWith: () => fromIterableWith,
  get: () => get5,
  getEquivalence: () => getEquivalence9,
  getLefts: () => getLefts3,
  getRights: () => getRights3,
  getSomes: () => getSomes3,
  has: () => has2,
  intersection: () => intersection3,
  isEmptyReadonlyRecord: () => isEmptyReadonlyRecord,
  isEmptyRecord: () => isEmptyRecord,
  isSubrecord: () => isSubrecord,
  isSubrecordBy: () => isSubrecordBy,
  keys: () => keys6,
  map: () => map8,
  mapEntries: () => mapEntries,
  mapKeys: () => mapKeys,
  modify: () => modify3,
  modifyOption: () => modifyOption3,
  partition: () => partition3,
  partitionMap: () => partitionMap8,
  pop: () => pop2,
  reduce: () => reduce8,
  remove: () => remove3,
  replace: () => replace3,
  replaceOption: () => replaceOption3,
  separate: () => separate3,
  set: () => set5,
  singleton: () => singleton,
  size: () => size7,
  some: () => some16,
  toEntries: () => toEntries3,
  union: () => union5,
  values: () => values
});
var empty13 = () => ({});
var isEmptyRecord = (self2) => keys6(self2).length === 0;
var isEmptyReadonlyRecord = isEmptyRecord;
var fromIterableWith = /* @__PURE__ */ dual6(2, (self2, f5) => {
  const out = empty13();
  for (const a5 of self2) {
    const [k5, b5] = f5(a5);
    out[k5] = b5;
  }
  return out;
});
var fromIterableBy = (items, f5) => fromIterableWith(items, (a5) => [f5(a5), a5]);
var fromEntries = Object.fromEntries;
var collect3 = /* @__PURE__ */ dual6(2, (self2, f5) => {
  const out = [];
  for (const key of keys6(self2)) {
    out.push(f5(key, self2[key]));
  }
  return out;
});
var toEntries3 = /* @__PURE__ */ collect3((key, value) => [key, value]);
var size7 = (self2) => keys6(self2).length;
var has2 = /* @__PURE__ */ dual6(2, (self2, key) => Object.prototype.hasOwnProperty.call(self2, key));
var get5 = /* @__PURE__ */ dual6(2, (self2, key) => has2(self2, key) ? some15(self2[key]) : none10());
var modify3 = /* @__PURE__ */ dual6(3, (self2, key, f5) => {
  if (!has2(self2, key)) {
    return {
      ...self2
    };
  }
  return {
    ...self2,
    [key]: f5(self2[key])
  };
});
var modifyOption3 = /* @__PURE__ */ dual6(3, (self2, key, f5) => {
  if (!has2(self2, key)) {
    return none10();
  }
  return some15({
    ...self2,
    [key]: f5(self2[key])
  });
});
var replaceOption3 = /* @__PURE__ */ dual6(3, (self2, key, b5) => modifyOption3(self2, key, () => b5));
var remove3 = /* @__PURE__ */ dual6(2, (self2, key) => {
  if (!has2(self2, key)) {
    return {
      ...self2
    };
  }
  const out = {
    ...self2
  };
  delete out[key];
  return out;
});
var pop2 = /* @__PURE__ */ dual6(2, (self2, key) => has2(self2, key) ? some15([self2[key], remove3(self2, key)]) : none10());
var map8 = /* @__PURE__ */ dual6(2, (self2, f5) => {
  const out = {
    ...self2
  };
  for (const key of keys6(self2)) {
    out[key] = f5(self2[key], key);
  }
  return out;
});
var mapKeys = /* @__PURE__ */ dual6(2, (self2, f5) => {
  const out = {};
  for (const key of keys6(self2)) {
    const a5 = self2[key];
    out[f5(key, a5)] = a5;
  }
  return out;
});
var mapEntries = /* @__PURE__ */ dual6(2, (self2, f5) => {
  const out = {};
  for (const key of keys6(self2)) {
    const [k5, b5] = f5(self2[key], key);
    out[k5] = b5;
  }
  return out;
});
var filterMap8 = /* @__PURE__ */ dual6(2, (self2, f5) => {
  const out = empty13();
  for (const key of keys6(self2)) {
    const o5 = f5(self2[key], key);
    if (isSome10(o5)) {
      out[key] = o5.value;
    }
  }
  return out;
});
var filter8 = /* @__PURE__ */ dual6(2, (self2, predicate) => {
  const out = empty13();
  for (const key of keys6(self2)) {
    if (predicate(self2[key], key)) {
      out[key] = self2[key];
    }
  }
  return out;
});
var getSomes3 = /* @__PURE__ */ filterMap8(identity6);
var getLefts3 = (self2) => {
  const out = empty13();
  for (const key of keys6(self2)) {
    const value = self2[key];
    if (isLeft8(value)) {
      out[key] = value.left;
    }
  }
  return out;
};
var getRights3 = (self2) => {
  const out = empty13();
  for (const key of keys6(self2)) {
    const value = self2[key];
    if (isRight8(value)) {
      out[key] = value.right;
    }
  }
  return out;
};
var partitionMap8 = /* @__PURE__ */ dual6(2, (self2, f5) => {
  const left9 = empty13();
  const right9 = empty13();
  for (const key of keys6(self2)) {
    const e5 = f5(self2[key], key);
    if (isLeft8(e5)) {
      left9[key] = e5.left;
    } else {
      right9[key] = e5.right;
    }
  }
  return [left9, right9];
});
var separate3 = /* @__PURE__ */ partitionMap8(identity6);
var partition3 = /* @__PURE__ */ dual6(2, (self2, predicate) => {
  const left9 = empty13();
  const right9 = empty13();
  for (const key of keys6(self2)) {
    if (predicate(self2[key], key)) {
      right9[key] = self2[key];
    } else {
      left9[key] = self2[key];
    }
  }
  return [left9, right9];
});
var keys6 = (self2) => Object.keys(self2);
var values = (self2) => collect3(self2, (_5, a5) => a5);
var set5 = /* @__PURE__ */ dual6(3, (self2, key, value) => {
  return {
    ...self2,
    [key]: value
  };
});
var replace3 = /* @__PURE__ */ dual6(3, (self2, key, value) => {
  if (has2(self2, key)) {
    return {
      ...self2,
      [key]: value
    };
  }
  return {
    ...self2
  };
});
var isSubrecordBy = (equivalence8) => dual6(2, (self2, that) => {
  for (const key of keys6(self2)) {
    if (!has2(that, key) || !equivalence8(self2[key], that[key])) {
      return false;
    }
  }
  return true;
});
var isSubrecord = /* @__PURE__ */ isSubrecordBy(/* @__PURE__ */ equivalence6());
var reduce8 = /* @__PURE__ */ dual6(3, (self2, zero, f5) => {
  let out = zero;
  for (const key of keys6(self2)) {
    out = f5(out, self2[key], key);
  }
  return out;
});
var every8 = /* @__PURE__ */ dual6(2, (self2, refinement) => {
  for (const key of keys6(self2)) {
    if (!refinement(self2[key], key)) {
      return false;
    }
  }
  return true;
});
var some16 = /* @__PURE__ */ dual6(2, (self2, predicate) => {
  for (const key of keys6(self2)) {
    if (predicate(self2[key], key)) {
      return true;
    }
  }
  return false;
});
var union5 = /* @__PURE__ */ dual6(3, (self2, that, combine9) => {
  if (isEmptyRecord(self2)) {
    return {
      ...that
    };
  }
  if (isEmptyRecord(that)) {
    return {
      ...self2
    };
  }
  const out = empty13();
  for (const key of keys6(self2)) {
    if (has2(that, key)) {
      out[key] = combine9(self2[key], that[key]);
    } else {
      out[key] = self2[key];
    }
  }
  for (const key of keys6(that)) {
    if (!has2(out, key)) {
      out[key] = that[key];
    }
  }
  return out;
});
var intersection3 = /* @__PURE__ */ dual6(3, (self2, that, combine9) => {
  const out = empty13();
  if (isEmptyRecord(self2) || isEmptyRecord(that)) {
    return out;
  }
  for (const key of keys6(self2)) {
    if (has2(that, key)) {
      out[key] = combine9(self2[key], that[key]);
    }
  }
  return out;
});
var difference3 = /* @__PURE__ */ dual6(2, (self2, that) => {
  if (isEmptyRecord(self2)) {
    return {
      ...that
    };
  }
  if (isEmptyRecord(that)) {
    return {
      ...self2
    };
  }
  const out = {};
  for (const key of keys6(self2)) {
    if (!has2(that, key)) {
      out[key] = self2[key];
    }
  }
  for (const key of keys6(that)) {
    if (!has2(self2, key)) {
      out[key] = that[key];
    }
  }
  return out;
});
var getEquivalence9 = (equivalence8) => {
  const is6 = isSubrecordBy(equivalence8);
  return (self2, that) => is6(self2, that) && is6(that, self2);
};
var singleton = (key, value) => ({
  [key]: value
});

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/MutableRef.js
var MutableRef_exports4 = {};
__export(MutableRef_exports4, {
  compareAndSet: () => compareAndSet4,
  decrement: () => decrement4,
  decrementAndGet: () => decrementAndGet4,
  get: () => get6,
  getAndDecrement: () => getAndDecrement4,
  getAndIncrement: () => getAndIncrement4,
  getAndSet: () => getAndSet4,
  getAndUpdate: () => getAndUpdate4,
  increment: () => increment4,
  incrementAndGet: () => incrementAndGet4,
  make: () => make19,
  set: () => set6,
  setAndGet: () => setAndGet4,
  toggle: () => toggle4,
  update: () => update4,
  updateAndGet: () => updateAndGet4
});
var TypeId19 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto4 = {
  [TypeId19]: TypeId19,
  toString() {
    return format6(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON6(this.current)
    };
  },
  [NodeInspectSymbol6]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments6(this, arguments);
  }
};
var make19 = (value) => {
  const ref = Object.create(MutableRefProto4);
  ref.current = value;
  return ref;
};
var compareAndSet4 = /* @__PURE__ */ dual6(3, (self2, oldValue, newValue) => {
  if (equals6(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement4 = (self2) => update4(self2, (n5) => n5 - 1);
var decrementAndGet4 = (self2) => updateAndGet4(self2, (n5) => n5 - 1);
var get6 = (self2) => self2.current;
var getAndDecrement4 = (self2) => getAndUpdate4(self2, (n5) => n5 - 1);
var getAndIncrement4 = (self2) => getAndUpdate4(self2, (n5) => n5 + 1);
var getAndSet4 = /* @__PURE__ */ dual6(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate4 = /* @__PURE__ */ dual6(2, (self2, f5) => getAndSet4(self2, f5(get6(self2))));
var increment4 = (self2) => update4(self2, (n5) => n5 + 1);
var incrementAndGet4 = (self2) => updateAndGet4(self2, (n5) => n5 + 1);
var set6 = /* @__PURE__ */ dual6(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet4 = /* @__PURE__ */ dual6(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update4 = /* @__PURE__ */ dual6(2, (self2, f5) => set6(self2, f5(get6(self2))));
var updateAndGet4 = /* @__PURE__ */ dual6(2, (self2, f5) => setAndGet4(self2, f5(get6(self2))));
var toggle4 = (self2) => update4(self2, (_5) => !_5);

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/MutableList.js
var MutableList_exports2 = {};
__export(MutableList_exports2, {
  append: () => append3,
  empty: () => empty14,
  forEach: () => forEach7,
  fromIterable: () => fromIterable10,
  head: () => head3,
  isEmpty: () => isEmpty5,
  length: () => length3,
  make: () => make20,
  pop: () => pop3,
  prepend: () => prepend6,
  reset: () => reset2,
  shift: () => shift2,
  tail: () => tail3
});
var TypeId20 = /* @__PURE__ */ Symbol.for("effect/MutableList");
var MutableListProto2 = {
  [TypeId20]: TypeId20,
  [Symbol.iterator]() {
    let done = false;
    let head4 = this.head;
    return {
      next() {
        if (done) {
          return this.return();
        }
        if (head4 == null) {
          done = true;
          return this.return();
        }
        const value = head4.value;
        head4 = head4.next;
        return {
          done,
          value
        };
      },
      return(value) {
        if (!done) {
          done = true;
        }
        return {
          done: true,
          value
        };
      }
    };
  },
  toString() {
    return format6(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableList",
      values: Array.from(this).map(toJSON6)
    };
  },
  [NodeInspectSymbol6]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments6(this, arguments);
  }
};
var makeNode2 = (value) => ({
  value,
  removed: false,
  prev: void 0,
  next: void 0
});
var empty14 = () => {
  const list = Object.create(MutableListProto2);
  list.head = void 0;
  list.tail = void 0;
  list._length = 0;
  return list;
};
var fromIterable10 = (iterable) => {
  const list = empty14();
  for (const element of iterable) {
    append3(list, element);
  }
  return list;
};
var make20 = (...elements) => fromIterable10(elements);
var isEmpty5 = (self2) => length3(self2) === 0;
var length3 = (self2) => self2._length;
var tail3 = (self2) => self2.tail === void 0 ? void 0 : self2.tail.value;
var head3 = (self2) => self2.head === void 0 ? void 0 : self2.head.value;
var forEach7 = /* @__PURE__ */ dual6(2, (self2, f5) => {
  let current = self2.head;
  while (current !== void 0) {
    f5(current.value);
    current = current.next;
  }
});
var reset2 = (self2) => {
  self2._length = 0;
  self2.head = void 0;
  self2.tail = void 0;
  return self2;
};
var append3 = /* @__PURE__ */ dual6(2, (self2, value) => {
  const node = makeNode2(value);
  if (self2.head === void 0) {
    self2.head = node;
  }
  if (self2.tail === void 0) {
    self2.tail = node;
  } else {
    self2.tail.next = node;
    node.prev = self2.tail;
    self2.tail = node;
  }
  self2._length += 1;
  return self2;
});
var shift2 = (self2) => {
  const head4 = self2.head;
  if (head4 !== void 0) {
    remove4(self2, head4);
    return head4.value;
  }
  return void 0;
};
var pop3 = (self2) => {
  const tail4 = self2.tail;
  if (tail4 !== void 0) {
    remove4(self2, tail4);
    return tail4.value;
  }
  return void 0;
};
var prepend6 = /* @__PURE__ */ dual6(2, (self2, value) => {
  const node = makeNode2(value);
  node.next = self2.head;
  if (self2.head !== void 0) {
    self2.head.prev = node;
  }
  self2.head = node;
  if (self2.tail === void 0) {
    self2.tail = node;
  }
  self2._length += 1;
  return self2;
});
var remove4 = (self2, node) => {
  if (node.removed) {
    return;
  }
  node.removed = true;
  if (node.prev !== void 0 && node.next !== void 0) {
    node.prev.next = node.next;
    node.next.prev = node.prev;
  } else if (node.prev !== void 0) {
    self2.tail = node.prev;
    node.prev.next = void 0;
  } else if (node.next !== void 0) {
    self2.head = node.next;
    node.next.prev = void 0;
  } else {
    self2.tail = void 0;
    self2.head = void 0;
  }
  if (self2._length > 0) {
    self2._length -= 1;
  }
};

// src/rules/no-access-state-in-setstate.ts
var RULE_NAME4 = "no-access-state-in-setstate";
function isKeyLiteralLike(node, property) {
  return property.type === NodeType3.Literal || property.type === NodeType3.TemplateLiteral && property.expressions.length === 0 || !node.computed && property.type === NodeType3.Identifier;
}
function isThisSetState(node) {
  const { callee } = node;
  return callee.type === NodeType3.MemberExpression && isThisExpression(callee.object) && callee.property.type === NodeType3.Identifier && callee.property.name === "setState";
}
function getName(node) {
  if (node.type === NodeType3.TSAsExpression) {
    return getName(node.expression);
  }
  if (node.type === NodeType3.Identifier || node.type === NodeType3.PrivateIdentifier) {
    return Option_exports6.some(node.name);
  }
  if (node.type === NodeType3.Literal) {
    return Option_exports6.some(String(node.value));
  }
  if (node.type === NodeType3.TemplateLiteral && node.expressions.length === 0) {
    return Option_exports6.fromNullable(node.quasis[0]?.value.raw);
  }
  return Option_exports6.none();
}
var no_access_state_in_setstate_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow accessing 'this.state' within 'setState'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_ACCESS_STATE_IN_SETSTATE: "Do not access 'this.state' within 'setState'. Use 'setState' callback instead."
    },
    schema: []
  },
  name: RULE_NAME4,
  create(context) {
    const classStack = MutableList_exports2.make();
    const methodStack = MutableList_exports2.make();
    const setStateStack = MutableList_exports2.make();
    return {
      CallExpression(node) {
        if (!isThisSetState(node)) return;
        MutableList_exports2.append(setStateStack, [node, false]);
      },
      "CallExpression:exit"(node) {
        if (!isThisSetState(node)) return;
        MutableList_exports2.pop(setStateStack);
      },
      ClassDeclaration(node) {
        MutableList_exports2.append(classStack, [node, isClassComponent(node)]);
      },
      "ClassDeclaration:exit"() {
        MutableList_exports2.pop(classStack);
      },
      ClassExpression(node) {
        MutableList_exports2.append(classStack, [node, isClassComponent(node)]);
      },
      "ClassExpression:exit"() {
        MutableList_exports2.pop(classStack);
      },
      MemberExpression(node) {
        if (!isThisExpression(node.object)) return;
        const [currentClass, isComponent] = MutableList_exports2.tail(classStack) ?? [];
        if (!currentClass || !isComponent) return;
        const [currentMethod, isStatic] = MutableList_exports2.tail(methodStack) ?? [];
        if (!currentMethod || isStatic) return;
        const [setState, hasThisState] = MutableList_exports2.tail(setStateStack) ?? [];
        if (!setState || hasThisState) return;
        if (!Option_exports6.exists(getName(node.property), (name2) => name2 === "state")) return;
        context.report({ messageId: "NO_ACCESS_STATE_IN_SETSTATE", node });
      },
      MethodDefinition(node) {
        MutableList_exports2.append(methodStack, [node, node.static]);
      },
      "MethodDefinition:exit"() {
        MutableList_exports2.pop(methodStack);
      },
      PropertyDefinition(node) {
        MutableList_exports2.append(methodStack, [node, node.static]);
      },
      "PropertyDefinition:exit"() {
        MutableList_exports2.pop(methodStack);
      },
      VariableDeclarator(node) {
        const [currentClass, isComponent] = MutableList_exports2.tail(classStack) ?? [];
        if (!currentClass || !isComponent) return;
        const [currentMethod, isStatic] = MutableList_exports2.tail(methodStack) ?? [];
        if (!currentMethod || isStatic) return;
        const [setState, hasThisState] = MutableList_exports2.tail(setStateStack) ?? [];
        if (!setState || hasThisState) return;
        if (!(node.init && isThisExpression(node.init) && node.id.type === NodeType3.ObjectPattern)) return;
        const hasState = node.id.properties.some((prop) => {
          if (prop.type === NodeType3.Property && isKeyLiteralLike(prop, prop.key)) {
            return Option_exports6.exists(getName(prop.key), (name2) => name2 === "state");
          }
          return false;
        });
        if (!hasState) return;
        context.report({ messageId: "NO_ACCESS_STATE_IN_SETSTATE", node });
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-array-index-key.ts
var RULE_NAME5 = "no-array-index-key";
var reactChildrenMethod = ["forEach", "map"];
function isReactChildrenMethod(name2) {
  return reactChildrenMethod.some((method) => method === name2);
}
var iteratorFunctionIndexParamPosition = {
  every: 1,
  filter: 1,
  find: 1,
  findIndex: 1,
  findLast: 1,
  findLastIndex: 1,
  flatMap: 1,
  forEach: 1,
  map: 1,
  reduce: 2,
  reduceRight: 2,
  some: 1
};
function isUsingReactChildren(node, context) {
  const { callee } = node;
  if (!("property" in callee) || !("object" in callee) || !("name" in callee.property)) {
    return false;
  }
  if (!isReactChildrenMethod(callee.property.name)) return false;
  const initialScope = context.sourceCode.getScope(node);
  return $(callee.object).with({ type: NodeType3.Identifier, name: "Children" }, () => true).with(
    { type: NodeType3.MemberExpression, object: { type: NodeType3.Identifier, name: N.string } },
    ({ object: object3 }) => isInitializedFromReact(object3.name, context, initialScope)
  ).otherwise(() => false);
}
function getMapIndexParamName(node, context) {
  const { callee } = node;
  if (callee.type !== NodeType3.MemberExpression) return Option_exports6.none();
  if (callee.property.type !== NodeType3.Identifier) return Option_exports6.none();
  const { name: name2 } = callee.property;
  if (!Record_exports.has(iteratorFunctionIndexParamPosition, name2)) return Option_exports6.none();
  const callbackArg = node.arguments[isUsingReactChildren(node, context) ? 1 : 0];
  if (!callbackArg) return Option_exports6.none();
  if (!isOneOf3([NodeType3.ArrowFunctionExpression, NodeType3.FunctionExpression])(callbackArg)) return Option_exports6.none();
  const { params } = callbackArg;
  const maybeIndexParamPosition = Record_exports.get(iteratorFunctionIndexParamPosition, name2);
  if (Option_exports6.isNone(maybeIndexParamPosition)) return Option_exports6.none();
  const indexParamPosition = maybeIndexParamPosition.value;
  if (params.length < indexParamPosition + 1) return Option_exports6.none();
  const param = params.at(indexParamPosition);
  return param && "name" in param ? Option_exports6.some(param.name) : Option_exports6.none();
}
function getIdentifiersFromBinaryExpression(side) {
  if (side.type === NodeType3.Identifier) return [side];
  if (side.type === NodeType3.BinaryExpression) {
    return [
      ...getIdentifiersFromBinaryExpression(side.left),
      ...getIdentifiersFromBinaryExpression(side.right)
    ].filter(Boolean);
  }
  return [];
}
var no_array_index_key_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow using Array index as key",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_ARRAY_INDEX_KEY: "Do not use Array index as key."
    },
    schema: []
  },
  name: RULE_NAME5,
  create(context) {
    const indexParamNames = [];
    function pushIndexParamName(node) {
      Option_exports6.map(getMapIndexParamName(node, context), (name2) => indexParamNames.push(name2));
    }
    function popIndexParamName(node) {
      Option_exports6.map(getMapIndexParamName(node, context), () => indexParamNames.pop());
    }
    function isArrayIndex(node) {
      return node.type === NodeType3.Identifier && indexParamNames.some((name2) => name2 === node.name);
    }
    function checkPropValue(node) {
      if (isArrayIndex(node)) {
        return [{ messageId: "NO_ARRAY_INDEX_KEY", node }];
      }
      if (isOneOf3([NodeType3.TemplateLiteral, NodeType3.BinaryExpression])(node)) {
        const exps = NodeType3.TemplateLiteral === node.type ? node.expressions : getIdentifiersFromBinaryExpression(node);
        return exps.reduce((acc, exp) => {
          if (isArrayIndex(exp)) return [...acc, { messageId: "NO_ARRAY_INDEX_KEY", node: exp }];
          return acc;
        }, []);
      }
      const isToStringCall = a({
        type: NodeType3.CallExpression,
        callee: {
          type: NodeType3.MemberExpression,
          property: {
            type: NodeType3.Identifier,
            name: "toString"
          }
        }
      }, node);
      if (isToStringCall) {
        if (!("object" in node.callee && isArrayIndex(node.callee.object))) return [];
        return [{ messageId: "NO_ARRAY_INDEX_KEY", node: node.callee.object }];
      }
      const isStringCall = a({
        type: NodeType3.CallExpression,
        callee: {
          type: NodeType3.Identifier,
          name: "String"
        }
      }, node);
      if (isStringCall) {
        const [arg] = node.arguments;
        if (arg && isArrayIndex(arg)) return [{ messageId: "NO_ARRAY_INDEX_KEY", node: arg }];
      }
      return [];
    }
    return {
      CallExpression(node) {
        if ((isCreateElementCall(node, context) || isCloneElementCall(node, context)) && node.arguments.length > 1) {
          if (indexParamNames.length === 0) return;
          const props = node.arguments[1];
          if (props?.type !== NodeType3.ObjectExpression) return;
          for (const prop of props.properties) {
            if (!a({ key: { name: "key" } }, prop)) continue;
            if (!("value" in prop)) continue;
            const descriptors = checkPropValue(prop.value);
            for (const descriptor of descriptors) {
              context.report(descriptor);
            }
          }
        }
        pushIndexParamName(node);
      },
      "CallExpression:exit": popIndexParamName,
      JSXAttribute(node) {
        if (node.name.name !== "key") return;
        if (indexParamNames.length === 0) return;
        const { value } = node;
        if (value?.type !== NodeType3.JSXExpressionContainer) return;
        const descriptors = checkPropValue(value.expression);
        for (const descriptor of descriptors) {
          context.report(descriptor);
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-children-count.ts
var RULE_NAME6 = "no-children-count";
var no_children_count_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'Children.count'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_CHILDREN_COUNT: "Using 'Children.count' is uncommon and can lead to fragile code. Use alternatives instead."
    },
    schema: []
  },
  name: RULE_NAME6,
  create(context) {
    return {
      MemberExpression(node) {
        if (isChildrenCount(node, context)) {
          context.report({
            messageId: "NO_CHILDREN_COUNT",
            node: node.property
          });
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-children-for-each.ts
var RULE_NAME7 = "no-children-for-each";
var no_children_for_each_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'Children.forEach'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_CHILDREN_FOR_EACH: "Using 'Children.forEach' is uncommon and can lead to fragile code. Use alternatives instead."
    },
    schema: []
  },
  name: RULE_NAME7,
  create(context) {
    return {
      MemberExpression(node) {
        if (isChildrenForEach(node, context)) {
          context.report({
            messageId: "NO_CHILDREN_FOR_EACH",
            node: node.property
          });
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-children-map.ts
var RULE_NAME8 = "no-children-map";
var no_children_map_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'Children.map'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_CHILDREN_MAP: "Using 'Children.map' is uncommon and can lead to fragile code. Use alternatives instead."
    },
    schema: []
  },
  name: RULE_NAME8,
  create(context) {
    return {
      MemberExpression(node) {
        if (isChildrenMap(node, context)) {
          context.report({
            messageId: "NO_CHILDREN_MAP",
            node: node.property
          });
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-children-only.ts
var RULE_NAME9 = "no-children-only";
var no_children_only_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'Children.only'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_CHILDREN_ONLY: "Using 'Children.only' is uncommon and can lead to fragile code. Use alternatives instead."
    },
    schema: []
  },
  name: RULE_NAME9,
  create(context) {
    return {
      MemberExpression(node) {
        if (isChildrenOnly(node, context)) {
          context.report({
            messageId: "NO_CHILDREN_ONLY",
            node: node.property
          });
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-children-prop.ts
var RULE_NAME10 = "no-children-prop";
var no_children_prop_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow passing of 'children' as props",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_CHILDREN_PROP: "Do not pass children as props."
    },
    schema: []
  },
  name: RULE_NAME10,
  create(context) {
    return {
      CallExpression(node) {
        if (node.arguments.length === 0) return;
        const initialScope = context.sourceCode.getScope(node);
        if (!isCreateElementCall(node, context)) return;
        const [_5, props] = node.arguments;
        if (!props || props.type !== NodeType3.ObjectExpression) return;
        Option_exports6.map(findPropInProperties(props.properties, context, initialScope)("children"), (prop) => {
          context.report({
            messageId: "NO_CHILDREN_PROP",
            node: prop
          });
        });
      },
      JSXElement(node) {
        const initialScope = context.sourceCode.getScope(node);
        Option_exports6.map(getProp(node.openingElement.attributes, "children", context, initialScope), (prop) => {
          context.report({
            messageId: "NO_CHILDREN_PROP",
            node: prop
          });
        });
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-children-to-array.ts
var RULE_NAME11 = "no-children-to-array";
var no_children_to_array_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'Children.toArray'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_CHILDREN_TO_ARRAY: "Using 'Children.toArray' is uncommon and can lead to fragile code. Use alternatives instead."
    },
    schema: []
  },
  name: RULE_NAME11,
  create(context) {
    return {
      MemberExpression(node) {
        if (isChildrenToArray(node, context)) {
          context.report({
            messageId: "NO_CHILDREN_TO_ARRAY",
            node: node.property
          });
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-class-component.ts
var RULE_NAME12 = "no-class-component";
var isComponentDidCatch = a({
  key: {
    type: NodeType3.Identifier,
    name: "componentDidCatch"
  },
  type: N.union(NodeType3.MethodDefinition, NodeType3.PropertyDefinition),
  static: false
});
var isGetDerivedStateFromError = a({
  key: {
    type: NodeType3.Identifier,
    name: "getDerivedStateFromError"
  },
  type: N.union(NodeType3.MethodDefinition, NodeType3.PropertyDefinition),
  static: true
});
var no_class_component_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow class component"
    },
    messages: {
      NO_CLASS_COMPONENT: "Do not use class components. Use function components instead."
    },
    schema: []
  },
  name: RULE_NAME12,
  create(context) {
    const { ctx, listeners } = useComponentCollectorLegacy();
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { name: name2, node: component } of components.values()) {
          if (component.body.body.some((m5) => isComponentDidCatch(m5) || isGetDerivedStateFromError(m5))) continue;
          context.report({
            data: {
              name: Option_exports6.getOrElse(Function_exports6.constant("anonymous"))(name2)
            },
            messageId: "NO_CLASS_COMPONENT",
            node: component
          });
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-clone-element.ts
var RULE_NAME13 = "no-clone-element";
var no_clone_element_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'cloneElement'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_CLONE_ELEMENT: "Using 'cloneElement' is uncommon and can lead to fragile code. Use alternatives instead."
    },
    schema: []
  },
  name: RULE_NAME13,
  create(context) {
    return {
      CallExpression(node) {
        if (!isCloneElementCall(node, context)) return;
        context.report({
          messageId: "NO_CLONE_ELEMENT",
          node
        });
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME14 = "no-comment-textnodes";
var no_comment_textnodes_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow comments from being inserted as text nodes",
      requiresTypeChecking: false
    },
    messages: {
      NO_COMMENT_TEXTNODES: "Possible misused comment in text node. Comments inside children section of tag should be placed inside braces."
    },
    schema: []
  },
  name: RULE_NAME14,
  create(context) {
    function checkText(node) {
      if (isOneOf3([AST_NODE_TYPES.JSXAttribute, AST_NODE_TYPES.JSXExpressionContainer])(node.parent)) return false;
      const rawValue = context.sourceCode.getText(node);
      return /^\s*\/(\/|\*)/mu.test(rawValue) && node.parent.type.includes("JSX");
    }
    const check = (node) => {
      if (!isOneOf3([AST_NODE_TYPES.JSXElement, AST_NODE_TYPES.JSXFragment])(node.parent)) return;
      if (!checkText(node)) return;
      context.report({
        messageId: "NO_COMMENT_TEXTNODES",
        node
      });
    };
    return {
      JSXText: check,
      Literal: check
    };
  },
  defaultOptions: []
});

// src/rules/no-complicated-conditional-rendering.ts
var RULE_NAME15 = "no-complicated-conditional-rendering";
var no_complicated_conditional_rendering_default = createRule({
  meta: {
    type: "problem",
    deprecated: true,
    docs: {
      description: "disallow complicated conditional rendering",
      requiresTypeChecking: true
    },
    messages: {
      NO_COMPLICATED_CONDITIONAL_RENDERING: "Avoid complicated conditional rendering. Extract the logic into separate elements or components."
    },
    schema: []
  },
  name: RULE_NAME15,
  create(context) {
    function check(node) {
      const jsxExpContainer = node.parent?.parent;
      if (!is3(NodeType3.JSXExpressionContainer)(jsxExpContainer)) return;
      if (!isOneOf3([NodeType3.JSXElement, NodeType3.JSXFragment])(jsxExpContainer.parent)) return;
      if (!jsxExpContainer.parent.children.includes(jsxExpContainer)) return;
      context.report({ messageId: "NO_COMPLICATED_CONDITIONAL_RENDERING", node: jsxExpContainer });
    }
    return {
      "JSXExpressionContainer > ConditionalExpression > ConditionalExpression": check,
      "JSXExpressionContainer > ConditionalExpression > LogicalExpression": check,
      "JSXExpressionContainer > LogicalExpression > ConditionalExpression": check,
      "JSXExpressionContainer > LogicalExpression[operator='&&'] > LogicalExpression[operator='||']": check,
      "JSXExpressionContainer > LogicalExpression[operator='||'] > LogicalExpression[operator='&&']": check
    };
  },
  defaultOptions: []
});

// src/rules/no-component-will-mount.ts
var RULE_NAME16 = "no-component-will-mount";
function isComponentWillMount(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "componentWillMount";
}
var no_component_will_mount_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of 'componentWillMount'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_COMPONENT_WILL_MOUNT: "[Deprecated] Use 'UNSAFE_componentWillMount' instead."
    },
    schema: []
  },
  name: RULE_NAME16,
  create(context) {
    const { ctx, listeners } = useComponentCollectorLegacy();
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { node: component } of components.values()) {
          const { body } = component.body;
          for (const member of body) {
            if (isComponentWillMount(member)) {
              context.report({
                messageId: "NO_COMPONENT_WILL_MOUNT",
                node: member
              });
            }
          }
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-component-will-receive-props.ts
var RULE_NAME17 = "no-component-will-receive-props";
function isComponentWillUpdate(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "componentWillReceiveProps";
}
var no_component_will_receive_props_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of 'componentWillReceiveProps'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_COMPONENT_WILL_RECEIVE_PROPS: "[Deprecated] Use 'UNSAFE_componentWillReceiveProps' instead."
    },
    schema: []
  },
  name: RULE_NAME17,
  create(context) {
    const { ctx, listeners } = useComponentCollectorLegacy();
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { node: component } of components.values()) {
          const { body } = component.body;
          for (const member of body) {
            if (isComponentWillUpdate(member)) {
              context.report({
                messageId: "NO_COMPONENT_WILL_RECEIVE_PROPS",
                node: member
              });
            }
          }
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-component-will-update.ts
var RULE_NAME18 = "no-component-will-update";
function isComponentWillUpdate2(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "componentWillUpdate";
}
var no_component_will_update_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of 'componentWillUpdate'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_COMPONENT_WILL_UPDATE: "[Deprecated] Use 'UNSAFE_componentWillUpdate' instead."
    },
    schema: []
  },
  name: RULE_NAME18,
  create(context) {
    const { ctx, listeners } = useComponentCollectorLegacy();
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { node: component } of components.values()) {
          const { body } = component.body;
          for (const member of body) {
            if (isComponentWillUpdate2(member)) {
              context.report({
                messageId: "NO_COMPONENT_WILL_UPDATE",
                node: member
              });
            }
          }
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-create-ref.ts
var RULE_NAME19 = "no-create-ref";
var no_create_ref_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'createRef' in function components",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_CREATE_REF: "A 'createRef' is not allowed in function components. Use 'useRef' instead."
    },
    schema: []
  },
  name: RULE_NAME19,
  create(context) {
    const { ctx, listeners } = useComponentCollector(context);
    const possibleCreateRefCalls = /* @__PURE__ */ new Map();
    return {
      ...listeners,
      CallExpression(node) {
        if (!isCreateRefCall(node, context)) return;
        Option_exports6.map(
          ctx.getCurrentFunction(),
          ([currentFn]) => possibleCreateRefCalls.set(currentFn, [...possibleCreateRefCalls.get(currentFn) ?? [], node])
        );
      },
      "Program:exit"(node) {
        const components = Array.from(ctx.getAllComponents(node).values());
        for (const { node: component } of components) {
          const createRefCalls = possibleCreateRefCalls.get(component);
          if (!createRefCalls) continue;
          for (const createRefCall of createRefCalls) {
            context.report({
              messageId: "NO_CREATE_REF",
              node: createRefCall
            });
          }
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-direct-mutation-state.ts
var RULE_NAME20 = "no-direct-mutation-state";
function getName2(node) {
  if (node.type === NodeType3.TSAsExpression) {
    return getName2(node.expression);
  }
  if (node.type === NodeType3.Identifier || node.type === NodeType3.PrivateIdentifier) {
    return Option_exports6.some(node.name);
  }
  if (node.type === NodeType3.Literal) {
    return Option_exports6.some(String(node.value));
  }
  if (node.type === NodeType3.TemplateLiteral && node.expressions.length === 0) {
    return Option_exports6.fromNullable(node.quasis[0]?.value.raw);
  }
  return Option_exports6.none();
}
function isAssignmentToThisState(node) {
  const { left: left9 } = node;
  return left9.type === NodeType3.MemberExpression && isThisExpression(left9.object) && Option_exports6.exists(getName2(left9.property), (name2) => name2 === "state");
}
function isConstructorFunction(node) {
  return isOneOf3([NodeType3.FunctionDeclaration, NodeType3.FunctionExpression])(node) && isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node.parent) && node.parent.key.type === NodeType3.Identifier && node.parent.key.name === "constructor" && node.parent.parent.type === NodeType3.ClassBody;
}
var no_direct_mutation_state_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow direct mutation of state",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_DIRECT_MUTATION_STATE: "Do not mutate state directly. Use 'setState()' instead."
    },
    schema: []
  },
  name: RULE_NAME20,
  create(context) {
    return {
      AssignmentExpression(node) {
        if (!isAssignmentToThisState(node)) return;
        const maybeParentClass = traverseUpGuard3(node, isOneOf3([NodeType3.ClassDeclaration, NodeType3.ClassExpression]));
        if (Option_exports6.isNone(maybeParentClass)) return;
        const parentClass = maybeParentClass.value;
        if (!isClassComponent(parentClass)) return;
        const maybeParentConstructor = traverseUpGuard3(node, isConstructorFunction);
        if (Option_exports6.exists(maybeParentConstructor, (n5) => context.sourceCode.getScope(node).block === n5)) return;
        context.report({
          messageId: "NO_DIRECT_MUTATION_STATE",
          node
        });
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-duplicate-key.ts
var RULE_NAME21 = "no-duplicate-key";
var no_duplicate_key_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow duplicate keys in 'key' prop when rendering list",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_DUPLICATE_KEY: "A key must be unique. '{{value}}' is duplicated."
    },
    schema: []
  },
  name: RULE_NAME21,
  create(context) {
    const childrenToArraySelector = getChildrenToArraySelector();
    const isWithinChildrenToArrayRef = MutableRef_exports4.make(false);
    function checkIteratorElement(node) {
      if (node.type !== NodeType3.JSXElement) return Option_exports6.none();
      const initialScope = context.sourceCode.getScope(node);
      return Function_exports6.pipe(
        findPropInAttributes(node.openingElement.attributes, context, initialScope)("key"),
        Option_exports6.flatMap((k5) => "value" in k5 ? Option_exports6.fromNullable(k5.value) : Option_exports6.none()),
        Option_exports6.flatMap((v5) => {
          return isNodeEqual(v5, v5) ? Option_exports6.some({
            data: {
              value: context.sourceCode.getText(v5)
            },
            messageId: "NO_DUPLICATE_KEY",
            node: v5
          }) : Option_exports6.none();
        })
      );
    }
    function checkExpression(node) {
      return $(node).with({ type: NodeType3.JSXElement }, checkIteratorElement).with({ type: NodeType3.JSXFragment }, checkIteratorElement).with({ type: NodeType3.ConditionalExpression }, (n5) => {
        if (!("consequent" in n5)) return Option_exports6.none();
        return Option_exports6.orElse(checkIteratorElement(n5.consequent), () => checkIteratorElement(n5.alternate));
      }).with({ type: NodeType3.LogicalExpression }, (n5) => {
        if (!("left" in n5)) return Option_exports6.none();
        return Option_exports6.orElse(checkIteratorElement(n5.left), () => checkIteratorElement(n5.right));
      }).otherwise(Option_exports6.none);
    }
    function checkBlockStatement(node) {
      return getNestedReturnStatements(node).reduce((acc, statement) => {
        if (!statement.argument) return acc;
        const maybeDescriptor = checkIteratorElement(statement.argument);
        if (Option_exports6.isNone(maybeDescriptor)) return acc;
        const descriptor = maybeDescriptor.value;
        return [...acc, descriptor];
      }, []);
    }
    const seen = /* @__PURE__ */ new WeakSet();
    return {
      [`${childrenToArraySelector}:exit`]() {
        MutableRef_exports4.set(isWithinChildrenToArrayRef, false);
      },
      "ArrayExpression, JSXElement > JSXElement"(node) {
        if (MutableRef_exports4.get(isWithinChildrenToArrayRef)) return;
        const elements = $(node).with({ type: NodeType3.ArrayExpression }, ({ elements: elements2 }) => elements2).with({ type: NodeType3.JSXElement }, ({ parent }) => "children" in parent ? parent.children : []).otherwise(() => []).filter(is3(NodeType3.JSXElement)).filter((element) => !seen.has(element));
        const keys8 = elements.reduce(
          (acc, element) => {
            const attr = element.openingElement.attributes.findLast(a({
              type: NodeType3.JSXAttribute,
              name: {
                name: "key"
              }
            }));
            if (!attr || !("value" in attr) || attr.value === null) return acc;
            const { value } = attr;
            if (acc.length === 0) return [[element, attr, value]];
            if (acc.some(([_5, _1, v5]) => isNodeEqual(v5, value))) {
              return [...acc, [element, attr, value]];
            }
            return acc;
          },
          []
        );
        if (keys8.length < 2) return;
        for (const [element, attr, value] of keys8) {
          seen.add(element);
          context.report({
            data: {
              value: context.sourceCode.getText(value)
            },
            messageId: "NO_DUPLICATE_KEY",
            node: attr
          });
        }
      },
      CallExpression(node) {
        const isMapCall2 = a({
          callee: {
            type: NodeType3.MemberExpression,
            property: {
              name: "map"
            }
          }
        }, node);
        const isArrayFromCall = a({
          type: NodeType3.CallExpression,
          callee: {
            type: NodeType3.MemberExpression,
            property: {
              name: "from"
            }
          }
        }, node);
        if (!isMapCall2 && !isArrayFromCall) return;
        if (MutableRef_exports4.get(isWithinChildrenToArrayRef)) return;
        const fn = node.arguments[isMapCall2 ? 0 : 1];
        if (!isOneOf3([NodeType3.ArrowFunctionExpression, NodeType3.FunctionExpression])(fn)) return;
        if (fn.body.type === NodeType3.BlockStatement) {
          for (const descriptor of checkBlockStatement(fn.body)) {
            context.report(descriptor);
          }
          return;
        }
        Option_exports6.map(checkExpression(fn.body), context.report);
      },
      [childrenToArraySelector]() {
        MutableRef_exports4.set(isWithinChildrenToArrayRef, true);
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-implicit-key.ts
var RULE_NAME22 = "no-implicit-key";
var no_implicit_key_default = createRule({
  meta: {
    type: "problem",
    deprecated: true,
    docs: {
      description: "disallow spreading 'key' from objects.",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_IMPLICIT_KEY: "Prefer specifying key explicitly instead of spreading it from object."
    },
    schema: []
  },
  name: RULE_NAME22,
  create(context) {
    function check(node) {
      const initialScope = context.sourceCode.getScope(node);
      return Function_exports6.pipe(
        findPropInAttributes(node.attributes, context, initialScope)("key"),
        Option_exports6.filter(is3(NodeType3.JSXSpreadAttribute)),
        Option_exports6.map((key) => ({
          messageId: "NO_IMPLICIT_KEY",
          node: key
        }))
      );
    }
    return {
      JSXOpeningElement: Function_exports6.flow(check, Option_exports6.map(context.report))
    };
  },
  defaultOptions: []
});
var __defProp6 = Object.defineProperty;
var __export6 = (target, all33) => {
  for (var name2 in all33)
    __defProp6(target, name2, { get: all33[name2], enumerable: true });
};
var Function_exports7 = {};
__export6(Function_exports7, {
  SK: () => SK7,
  absurd: () => absurd7,
  apply: () => apply7,
  compose: () => compose11,
  constFalse: () => constFalse7,
  constNull: () => constNull7,
  constTrue: () => constTrue7,
  constUndefined: () => constUndefined7,
  constVoid: () => constVoid7,
  constant: () => constant7,
  dual: () => dual7,
  flip: () => flip7,
  flow: () => flow7,
  hole: () => hole7,
  identity: () => identity7,
  isFunction: () => isFunction12,
  pipe: () => pipe7,
  satisfies: () => satisfies7,
  tupled: () => tupled7,
  unsafeCoerce: () => unsafeCoerce7,
  untupled: () => untupled7
});
var isFunction12 = (input) => typeof input === "function";
var dual7 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a23, b23) {
        if (arguments.length >= 2) {
          return body(a23, b23);
        }
        return function(self2) {
          return body(self2, a23);
        };
      };
    case 3:
      return function(a23, b23, c23) {
        if (arguments.length >= 3) {
          return body(a23, b23, c23);
        }
        return function(self2) {
          return body(self2, a23, b23);
        };
      };
    case 4:
      return function(a23, b23, c23, d23) {
        if (arguments.length >= 4) {
          return body(a23, b23, c23, d23);
        }
        return function(self2) {
          return body(self2, a23, b23, c23);
        };
      };
    case 5:
      return function(a23, b23, c23, d23, e23) {
        if (arguments.length >= 5) {
          return body(a23, b23, c23, d23, e23);
        }
        return function(self2) {
          return body(self2, a23, b23, c23, d23);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply7 = (a23) => (self2) => self2(a23);
var identity7 = (a23) => a23;
var satisfies7 = () => (b23) => b23;
var unsafeCoerce7 = identity7;
var constant7 = (value) => () => value;
var constTrue7 = /* @__PURE__ */ constant7(true);
var constFalse7 = /* @__PURE__ */ constant7(false);
var constNull7 = /* @__PURE__ */ constant7(null);
var constUndefined7 = /* @__PURE__ */ constant7(void 0);
var constVoid7 = constUndefined7;
var flip7 = (f23) => (...b23) => (...a23) => f23(...a23)(...b23);
var compose11 = /* @__PURE__ */ dual7(2, (ab, bc) => (a23) => bc(ab(a23)));
var absurd7 = (_23) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled7 = (f23) => (a23) => f23(...a23);
var untupled7 = (f23) => (...a23) => f23(a23);
function pipe7(a23, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a23;
    case 2:
      return ab(a23);
    case 3:
      return bc(ab(a23));
    case 4:
      return cd(bc(ab(a23)));
    case 5:
      return de(cd(bc(ab(a23))));
    case 6:
      return ef(de(cd(bc(ab(a23)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a23))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a23)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a23))))))));
    default: {
      let ret = arguments[0];
      for (let i23 = 1; i23 < arguments.length; i23++) {
        ret = arguments[i23](ret);
      }
      return ret;
    }
  }
}
function flow7(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole7 = /* @__PURE__ */ unsafeCoerce7(absurd7);
var SK7 = (_23, b23) => b23;
var make21 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_12 = (map33) => dual7(3, (self2, name2, f23) => map33(self2, (a23) => Object.assign({}, a23, {
  [name2]: f23(a23)
})));
var bindTo12 = (map33) => dual7(2, (self2, name2) => map33(self2, (a23) => ({
  [name2]: a23
})));
var bind12 = (map33, flatMap33) => dual7(3, (self2, name2, f23) => flatMap33(self2, (a23) => map33(f23(a23), (b23) => Object.assign({}, a23, {
  [name2]: b23
}))));
var moduleVersion7 = "3.2.8";
var getCurrentVersion7 = () => moduleVersion7;
var globalStoreId7 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion7()}`);
if (!(globalStoreId7 in globalThis)) {
  globalThis[globalStoreId7] = /* @__PURE__ */ new Map();
}
var globalStore7 = globalThis[globalStoreId7];
var globalValue7 = (id, compute) => {
  if (!globalStore7.has(id)) {
    globalStore7.set(id, compute());
  }
  return globalStore7.get(id);
};
var isFunction25 = isFunction12;
var isRecordOrArray7 = (input) => typeof input === "object" && input !== null;
var isObject7 = (input) => isRecordOrArray7(input) || isFunction25(input);
var hasProperty7 = /* @__PURE__ */ dual7(2, (self2, property) => isObject7(self2) && property in self2);
var isNullable7 = (input) => input === null || input === void 0;
var getBugErrorMessage7 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId7 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind7 = (u23) => isObject7(u23) && GenKindTypeId7 in u23;
var GenKindImpl7 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity7;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_23) => _23;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_23) => _23;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_23) => _23;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId7] = GenKindTypeId7;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen8(this);
  }
};
var SingleShotGen8 = class _SingleShotGen34 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a23) {
    return this.called ? {
      value: a23,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a23) {
    return {
      value: a23,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e23) {
    throw e23;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen34(this.self);
  }
};
var adapter11 = () => function() {
  let x23 = arguments[0];
  for (let i23 = 1; i23 < arguments.length; i23++) {
    x23 = arguments[i23](x23);
  }
  return new GenKindImpl7(x23);
};
var defaultIncHi7 = 335903614;
var defaultIncLo7 = 4150755663;
var MUL_HI7 = 1481765933 >>> 0;
var MUL_LO7 = 1284865837 >>> 0;
var BIT_537 = 9007199254740992;
var BIT_277 = 134217728;
var PCGRandom7 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable7(seedLo) && isNullable7(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable7(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable7(incLo) && isNullable7(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo7;
      incHi = this._state ? this._state[2] : defaultIncHi7;
    } else if (isNullable7(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add647(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max4) {
    if (!max4) {
      return this._next();
    }
    max4 = max4 >>> 0;
    if ((max4 & max4 - 1) === 0) {
      return this._next() & max4 - 1;
    }
    let num = 0;
    const skew = (-max4 >>> 0) % max4 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max4;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_277 + lo) / BIT_537;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul647(this._state, oldHi, oldLo, MUL_HI7, MUL_LO7);
    add647(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul647(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add647(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId7 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap7 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId7]() {
    return this.#value;
  }
};
function yieldWrapGet7(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId7 in self2) {
    return self2[YieldWrapTypeId7]();
  }
  throw new Error(getBugErrorMessage7("yieldWrapGet"));
}
var structuralRegionState7 = /* @__PURE__ */ globalValue7("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache7 = /* @__PURE__ */ globalValue7(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr7 = /* @__PURE__ */ globalValue7(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom7());
var symbol11 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash7 = (self2) => {
  if (structuralRegionState7.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number8(self2);
    case "bigint":
      return string8(self2.toString(10));
    case "boolean":
      return string8(String(self2));
    case "symbol":
      return string8(String(self2));
    case "string":
      return string8(self2);
    case "undefined":
      return string8("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string8("null");
      } else if (self2 instanceof Date) {
        return hash7(self2.toISOString());
      } else if (isHash7(self2)) {
        return self2[symbol11]();
      } else {
        return random7(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random7 = (self2) => {
  if (!randomHashCache7.has(self2)) {
    randomHashCache7.set(self2, number8(pcgr7.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache7.get(self2);
};
var combine8 = (b23) => (self2) => self2 * 53 ^ b23;
var optimize7 = (n23) => n23 & 3221225471 | n23 >>> 1 & 1073741824;
var isHash7 = (u23) => hasProperty7(u23, symbol11);
var number8 = (n23) => {
  if (n23 !== n23 || n23 === Infinity) {
    return 0;
  }
  let h23 = n23 | 0;
  if (h23 !== n23) {
    h23 ^= n23 * 4294967295;
  }
  while (n23 > 4294967295) {
    h23 ^= n23 /= 4294967295;
  }
  return optimize7(n23);
};
var string8 = (str) => {
  let h23 = 5381, i23 = str.length;
  while (i23) {
    h23 = h23 * 33 ^ str.charCodeAt(--i23);
  }
  return optimize7(h23);
};
var cached7 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash43) {
      Object.defineProperty(self3, symbol11, {
        value() {
          return hash43;
        },
        enumerable: false
      });
      return hash43;
    };
  }
  const self2 = arguments[0];
  const hash33 = arguments[1];
  Object.defineProperty(self2, symbol11, {
    value() {
      return hash33;
    },
    enumerable: false
  });
  return hash33;
};
var symbol25 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals7() {
  if (arguments.length === 1) {
    return (self2) => compareBoth7(self2, arguments[0]);
  }
  return compareBoth7(arguments[0], arguments[1]);
}
function compareBoth7(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual7(self2) && isEqual7(that)) {
        if (hash7(self2) === hash7(that) && self2[symbol25](that)) {
          return true;
        } else {
          return structuralRegionState7.enabled && structuralRegionState7.tester ? structuralRegionState7.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState7.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v23, i23) => compareBoth7(v23, that[i23]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth7(self2[key], that[key]))) {
              return structuralRegionState7.tester ? structuralRegionState7.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState7.tester ? structuralRegionState7.tester(self2, that) : false;
    }
  }
  return structuralRegionState7.enabled && structuralRegionState7.tester ? structuralRegionState7.tester(self2, that) : false;
}
var isEqual7 = (u23) => hasProperty7(u23, symbol25);
var equivalence7 = () => equals7;
var NodeInspectSymbol7 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON7 = (x23) => {
  if (hasProperty7(x23, "toJSON") && isFunction25(x23["toJSON"]) && x23["toJSON"].length === 0) {
    return x23.toJSON();
  } else if (Array.isArray(x23)) {
    return x23.map(toJSON7);
  }
  return x23;
};
var format7 = (x23) => JSON.stringify(x23, null, 2);
var pipeArguments7 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i23 = 0, len = args.length; i23 < len; i23++) {
        ret = args[i23](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId8 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId7 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId7 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId7 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance7 = {
  /* c8 ignore next */
  _R: (_23) => _23,
  /* c8 ignore next */
  _E: (_23) => _23,
  /* c8 ignore next */
  _A: (_23) => _23,
  _V: /* @__PURE__ */ getCurrentVersion7()
};
var sinkVariance7 = {
  /* c8 ignore next */
  _A: (_23) => _23,
  /* c8 ignore next */
  _In: (_23) => _23,
  /* c8 ignore next */
  _L: (_23) => _23,
  /* c8 ignore next */
  _E: (_23) => _23,
  /* c8 ignore next */
  _R: (_23) => _23
};
var channelVariance7 = {
  /* c8 ignore next */
  _Env: (_23) => _23,
  /* c8 ignore next */
  _InErr: (_23) => _23,
  /* c8 ignore next */
  _InElem: (_23) => _23,
  /* c8 ignore next */
  _InDone: (_23) => _23,
  /* c8 ignore next */
  _OutErr: (_23) => _23,
  /* c8 ignore next */
  _OutElem: (_23) => _23,
  /* c8 ignore next */
  _OutDone: (_23) => _23
};
var EffectPrototype7 = {
  [EffectTypeId8]: effectVariance7,
  [StreamTypeId7]: effectVariance7,
  [SinkTypeId7]: sinkVariance7,
  [ChannelTypeId7]: channelVariance7,
  [symbol25](that) {
    return this === that;
  },
  [symbol11]() {
    return cached7(this, random7(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen8(new YieldWrap7(this));
  },
  pipe() {
    return pipeArguments7(this, arguments);
  }
};
var TypeId21 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto11 = {
  ...EffectPrototype7,
  [TypeId21]: {
    _A: (_23) => _23
  },
  [NodeInspectSymbol7]() {
    return this.toJSON();
  },
  toString() {
    return format7(this.toJSON());
  }
};
var SomeProto7 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto11), {
  _tag: "Some",
  _op: "Some",
  [symbol25](that) {
    return isOption11(that) && isSome11(that) && equals7(this.value, that.value);
  },
  [symbol11]() {
    return cached7(this, combine8(hash7(this._tag))(hash7(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON7(this.value)
    };
  }
});
var NoneHash7 = /* @__PURE__ */ hash7("None");
var NoneProto7 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto11), {
  _tag: "None",
  _op: "None",
  [symbol25](that) {
    return isOption11(that) && isNone11(that);
  },
  [symbol11]() {
    return NoneHash7;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption11 = (input) => hasProperty7(input, TypeId21);
var isNone11 = (fa) => fa._tag === "None";
var isSome11 = (fa) => fa._tag === "Some";
var none11 = /* @__PURE__ */ Object.create(NoneProto7);
var some17 = (value) => {
  const a23 = Object.create(SomeProto7);
  a23.value = value;
  return a23;
};
var TypeId25 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto25 = {
  ...EffectPrototype7,
  [TypeId25]: {
    _R: (_23) => _23
  },
  [NodeInspectSymbol7]() {
    return this.toJSON();
  },
  toString() {
    return format7(this.toJSON());
  }
};
var RightProto7 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto25), {
  _tag: "Right",
  _op: "Right",
  [symbol25](that) {
    return isEither7(that) && isRight9(that) && equals7(this.right, that.right);
  },
  [symbol11]() {
    return combine8(hash7(this._tag))(hash7(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON7(this.right)
    };
  }
});
var LeftProto7 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto25), {
  _tag: "Left",
  _op: "Left",
  [symbol25](that) {
    return isEither7(that) && isLeft9(that) && equals7(this.left, that.left);
  },
  [symbol11]() {
    return combine8(hash7(this._tag))(hash7(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON7(this.left)
    };
  }
});
var isEither7 = (input) => hasProperty7(input, TypeId25);
var isLeft9 = (ma) => ma._tag === "Left";
var isRight9 = (ma) => ma._tag === "Right";
var left8 = (left33) => {
  const a23 = Object.create(LeftProto7);
  a23.left = left33;
  return a23;
};
var right8 = (right33) => {
  const a23 = Object.create(RightProto7);
  a23.right = right33;
  return a23;
};
var getLeft11 = (self2) => isRight9(self2) ? none11 : some17(self2.left);
var getRight11 = (self2) => isLeft9(self2) ? none11 : some17(self2.right);
var Option_exports7 = {};
__export6(Option_exports7, {
  Do: () => Do8,
  TypeId: () => TypeId35,
  all: () => all11,
  andThen: () => andThen7,
  ap: () => ap7,
  as: () => as7,
  asVoid: () => asVoid7,
  bind: () => bind25,
  bindTo: () => bindTo25,
  composeK: () => composeK7,
  contains: () => contains8,
  containsWith: () => containsWith8,
  exists: () => exists7,
  filter: () => filter9,
  filterMap: () => filterMap9,
  firstSomeOf: () => firstSomeOf7,
  flatMap: () => flatMap8,
  flatMapNullable: () => flatMapNullable8,
  flatten: () => flatten8,
  fromIterable: () => fromIterable11,
  fromNullable: () => fromNullable8,
  gen: () => gen7,
  getEquivalence: () => getEquivalence10,
  getLeft: () => getLeft25,
  getOrElse: () => getOrElse7,
  getOrNull: () => getOrNull7,
  getOrThrow: () => getOrThrow7,
  getOrThrowWith: () => getOrThrowWith7,
  getOrUndefined: () => getOrUndefined7,
  getOrder: () => getOrder8,
  getRight: () => getRight25,
  isNone: () => isNone25,
  isOption: () => isOption25,
  isSome: () => isSome25,
  let: () => let_25,
  lift2: () => lift27,
  liftNullable: () => liftNullable8,
  liftPredicate: () => liftPredicate8,
  liftThrowable: () => liftThrowable7,
  map: () => map9,
  match: () => match8,
  none: () => none25,
  orElse: () => orElse7,
  orElseEither: () => orElseEither7,
  orElseSome: () => orElseSome7,
  partitionMap: () => partitionMap9,
  product: () => product11,
  productMany: () => productMany11,
  reduceCompact: () => reduceCompact7,
  some: () => some25,
  tap: () => tap7,
  toArray: () => toArray7,
  toRefinement: () => toRefinement7,
  void: () => void_7,
  zipLeft: () => zipLeft7,
  zipRight: () => zipRight7,
  zipWith: () => zipWith8
});
var make25 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId35 = /* @__PURE__ */ Symbol.for("effect/Option");
var none25 = () => none11;
var some25 = some17;
var isOption25 = isOption11;
var isNone25 = isNone11;
var isSome25 = isSome11;
var match8 = /* @__PURE__ */ dual7(2, (self2, {
  onNone,
  onSome
}) => isNone25(self2) ? onNone() : onSome(self2.value));
var toRefinement7 = (f23) => (a23) => isSome25(f23(a23));
var fromIterable11 = (collection) => {
  for (const a23 of collection) {
    return some25(a23);
  }
  return none25();
};
var getRight25 = getRight11;
var getLeft25 = getLeft11;
var getOrElse7 = /* @__PURE__ */ dual7(2, (self2, onNone) => isNone25(self2) ? onNone() : self2.value);
var orElse7 = /* @__PURE__ */ dual7(2, (self2, that) => isNone25(self2) ? that() : self2);
var orElseSome7 = /* @__PURE__ */ dual7(2, (self2, onNone) => isNone25(self2) ? some25(onNone()) : self2);
var orElseEither7 = /* @__PURE__ */ dual7(2, (self2, that) => isNone25(self2) ? map9(that(), right8) : map9(self2, left8));
var firstSomeOf7 = (collection) => {
  let out = none25();
  for (out of collection) {
    if (isSome25(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable8 = (nullableValue) => nullableValue == null ? none25() : some25(nullableValue);
var liftNullable8 = (f23) => (...a23) => fromNullable8(f23(...a23));
var getOrNull7 = /* @__PURE__ */ getOrElse7(constNull7);
var getOrUndefined7 = /* @__PURE__ */ getOrElse7(constUndefined7);
var liftThrowable7 = (f23) => (...a23) => {
  try {
    return some25(f23(...a23));
  } catch (e23) {
    return none25();
  }
};
var getOrThrowWith7 = /* @__PURE__ */ dual7(2, (self2, onNone) => {
  if (isSome25(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow7 = /* @__PURE__ */ getOrThrowWith7(() => new Error("getOrThrow called on a None"));
var map9 = /* @__PURE__ */ dual7(2, (self2, f23) => isNone25(self2) ? none25() : some25(f23(self2.value)));
var as7 = /* @__PURE__ */ dual7(2, (self2, b23) => map9(self2, () => b23));
var asVoid7 = /* @__PURE__ */ as7(void 0);
var void_7 = /* @__PURE__ */ some25(void 0);
var flatMap8 = /* @__PURE__ */ dual7(2, (self2, f23) => isNone25(self2) ? none25() : f23(self2.value));
var andThen7 = /* @__PURE__ */ dual7(2, (self2, f23) => flatMap8(self2, (a23) => {
  const b23 = isFunction12(f23) ? f23(a23) : f23;
  return isOption25(b23) ? b23 : some25(b23);
}));
var flatMapNullable8 = /* @__PURE__ */ dual7(2, (self2, f23) => isNone25(self2) ? none25() : fromNullable8(f23(self2.value)));
var flatten8 = /* @__PURE__ */ flatMap8(identity7);
var zipRight7 = /* @__PURE__ */ dual7(2, (self2, that) => flatMap8(self2, () => that));
var composeK7 = /* @__PURE__ */ dual7(2, (afb, bfc) => (a23) => flatMap8(afb(a23), bfc));
var zipLeft7 = /* @__PURE__ */ dual7(2, (self2, that) => tap7(self2, () => that));
var tap7 = /* @__PURE__ */ dual7(2, (self2, f23) => flatMap8(self2, (a23) => map9(f23(a23), () => a23)));
var product11 = (self2, that) => isSome25(self2) && isSome25(that) ? some25([self2.value, that.value]) : none25();
var productMany11 = (self2, collection) => {
  if (isNone25(self2)) {
    return none25();
  }
  const out = [self2.value];
  for (const o23 of collection) {
    if (isNone25(o23)) {
      return none25();
    }
    out.push(o23.value);
  }
  return some25(out);
};
var all11 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o23 of input) {
      if (isNone25(o23)) {
        return none25();
      }
      out2.push(o23.value);
    }
    return some25(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o23 = input[key];
    if (isNone25(o23)) {
      return none25();
    }
    out[key] = o23.value;
  }
  return some25(out);
};
var zipWith8 = /* @__PURE__ */ dual7(3, (self2, that, f23) => map9(product11(self2, that), ([a23, b23]) => f23(a23, b23)));
var ap7 = /* @__PURE__ */ dual7(2, (self2, that) => zipWith8(self2, that, (f23, a23) => f23(a23)));
var reduceCompact7 = /* @__PURE__ */ dual7(3, (self2, b23, f23) => {
  let out = b23;
  for (const oa of self2) {
    if (isSome25(oa)) {
      out = f23(out, oa.value);
    }
  }
  return out;
});
var toArray7 = (self2) => isNone25(self2) ? [] : [self2.value];
var partitionMap9 = /* @__PURE__ */ dual7(2, (self2, f23) => {
  if (isNone25(self2)) {
    return [none25(), none25()];
  }
  const e23 = f23(self2.value);
  return isLeft9(e23) ? [some25(e23.left), none25()] : [none25(), some25(e23.right)];
});
var filterMap9 = /* @__PURE__ */ dual7(2, (self2, f23) => isNone25(self2) ? none25() : f23(self2.value));
var filter9 = /* @__PURE__ */ dual7(2, (self2, predicate) => filterMap9(self2, (b23) => predicate(b23) ? some17(b23) : none11));
var getEquivalence10 = (isEquivalent) => make21((x23, y23) => x23 === y23 || (isNone25(x23) ? isNone25(y23) : isNone25(y23) ? false : isEquivalent(x23.value, y23.value)));
var getOrder8 = (O23) => make25((self2, that) => isSome25(self2) ? isSome25(that) ? O23(self2.value, that.value) : 1 : -1);
var lift27 = (f23) => dual7(2, (self2, that) => zipWith8(self2, that, f23));
var liftPredicate8 = (predicate) => (b23) => predicate(b23) ? some25(b23) : none25();
var containsWith8 = (isEquivalent) => dual7(2, (self2, a23) => isNone25(self2) ? false : isEquivalent(self2.value, a23));
var _equivalence9 = /* @__PURE__ */ equivalence7();
var contains8 = /* @__PURE__ */ containsWith8(_equivalence9);
var exists7 = /* @__PURE__ */ dual7(2, (self2, refinement) => isNone25(self2) ? false : refinement(self2.value));
var bindTo25 = /* @__PURE__ */ bindTo12(map9);
var let_25 = /* @__PURE__ */ let_12(map9);
var bind25 = /* @__PURE__ */ bind12(map9, flatMap8);
var Do8 = /* @__PURE__ */ some25({});
var adapter25 = /* @__PURE__ */ adapter11();
var gen7 = (f23) => {
  const iterator = f23(adapter25);
  let state = iterator.next();
  if (state.done) {
    return some25(state.value);
  } else {
    let current = state.value;
    if (isGenKind7(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet7(current);
    }
    if (isNone25(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind7(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet7(current);
        }
        if (isNone25(current)) {
          return current;
        }
      }
    }
    return some25(state.value);
  }
};
var MutableRef_exports5 = {};
__export6(MutableRef_exports5, {
  compareAndSet: () => compareAndSet5,
  decrement: () => decrement5,
  decrementAndGet: () => decrementAndGet5,
  get: () => get7,
  getAndDecrement: () => getAndDecrement5,
  getAndIncrement: () => getAndIncrement5,
  getAndSet: () => getAndSet5,
  getAndUpdate: () => getAndUpdate5,
  increment: () => increment5,
  incrementAndGet: () => incrementAndGet5,
  make: () => make35,
  set: () => set7,
  setAndGet: () => setAndGet5,
  toggle: () => toggle5,
  update: () => update5,
  updateAndGet: () => updateAndGet5
});
var TypeId45 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto5 = {
  [TypeId45]: TypeId45,
  toString() {
    return format7(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON7(this.current)
    };
  },
  [NodeInspectSymbol7]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments7(this, arguments);
  }
};
var make35 = (value) => {
  const ref = Object.create(MutableRefProto5);
  ref.current = value;
  return ref;
};
var compareAndSet5 = /* @__PURE__ */ dual7(3, (self2, oldValue, newValue) => {
  if (equals7(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement5 = (self2) => update5(self2, (n23) => n23 - 1);
var decrementAndGet5 = (self2) => updateAndGet5(self2, (n23) => n23 - 1);
var get7 = (self2) => self2.current;
var getAndDecrement5 = (self2) => getAndUpdate5(self2, (n23) => n23 - 1);
var getAndIncrement5 = (self2) => getAndUpdate5(self2, (n23) => n23 + 1);
var getAndSet5 = /* @__PURE__ */ dual7(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate5 = /* @__PURE__ */ dual7(2, (self2, f23) => getAndSet5(self2, f23(get7(self2))));
var increment5 = (self2) => update5(self2, (n23) => n23 + 1);
var incrementAndGet5 = (self2) => updateAndGet5(self2, (n23) => n23 + 1);
var set7 = /* @__PURE__ */ dual7(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet5 = /* @__PURE__ */ dual7(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update5 = /* @__PURE__ */ dual7(2, (self2, f23) => set7(self2, f23(get7(self2))));
var updateAndGet5 = /* @__PURE__ */ dual7(2, (self2, f23) => setAndGet5(self2, f23(get7(self2))));
var toggle5 = (self2) => update5(self2, (_23) => !_23);
function getVariables3(initialScope) {
  const scopeRef = MutableRef_exports5.make(initialScope);
  const variablesRef = MutableRef_exports5.make(MutableRef_exports5.get(scopeRef).variables);
  while (MutableRef_exports5.get(scopeRef).type !== ScopeType.global) {
    MutableRef_exports5.set(scopeRef, MutableRef_exports5.get(scopeRef).upper);
    MutableRef_exports5.update(variablesRef, (variables) => variables.concat(MutableRef_exports5.get(scopeRef).variables));
  }
  return MutableRef_exports5.get(variablesRef).reverse();
}
var findVariable5 = Function_exports7.dual(2, (name2, initialScope) => {
  return Option_exports7.fromNullable(getVariables3(initialScope).find((variable) => variable.name === name2));
});
var t4 = Symbol.for("@ts-pattern/matcher");
var e4 = Symbol.for("@ts-pattern/isVariadic");
var n4 = "@ts-pattern/anonymous-select-key";
var r4 = (t23) => Boolean(t23 && "object" == typeof t23);
var i4 = (e23) => e23 && !!e23[t4];
var o4 = (n23, s23, c23) => {
  if (i4(n23)) {
    const e23 = n23[t4](), { matched: r23, selections: i23 } = e23.match(s23);
    return r23 && i23 && Object.keys(i23).forEach((t23) => c23(t23, i23[t23])), r23;
  }
  if (r4(n23)) {
    if (!r4(s23)) return false;
    if (Array.isArray(n23)) {
      if (!Array.isArray(s23)) return false;
      let t23 = [], r23 = [], a23 = [];
      for (const o23 of n23.keys()) {
        const s32 = n23[o23];
        i4(s32) && s32[e4] ? a23.push(s32) : a23.length ? r23.push(s32) : t23.push(s32);
      }
      if (a23.length) {
        if (a23.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s23.length < t23.length + r23.length) return false;
        const e23 = s23.slice(0, t23.length), n32 = 0 === r23.length ? [] : s23.slice(-r23.length), i23 = s23.slice(t23.length, 0 === r23.length ? Infinity : -r23.length);
        return t23.every((t32, n42) => o4(t32, e23[n42], c23)) && r23.every((t32, e32) => o4(t32, n32[e32], c23)) && (0 === a23.length || o4(a23[0], i23, c23));
      }
      return n23.length === s23.length && n23.every((t32, e23) => o4(t32, s23[e23], c23));
    }
    return Object.keys(n23).every((e23) => {
      const r23 = n23[e23];
      return (e23 in s23 || i4(a23 = r23) && "optional" === a23[t4]().matcherType) && o4(r23, s23[e23], c23);
      var a23;
    });
  }
  return Object.is(s23, n23);
};
var s4 = (e23) => {
  var n23, o23, a23;
  return r4(e23) ? i4(e23) ? null != (n23 = null == (o23 = (a23 = e23[t4]()).getSelectionKeys) ? void 0 : o23.call(a23)) ? n23 : [] : Array.isArray(e23) ? c4(e23, s4) : c4(Object.values(e23), s4) : [];
};
var c4 = (t23, e23) => t23.reduce((t32, n23) => t32.concat(e23(n23)), []);
function a4(...t23) {
  if (1 === t23.length) {
    const [e23] = t23;
    return (t32) => o4(e23, t32, () => {
    });
  }
  if (2 === t23.length) {
    const [e23, n23] = t23;
    return o4(e23, n23, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t23.length}.`);
}
function u4(t23) {
  return Object.assign(t23, { optional: () => l4(t23), and: (e23) => m4(t23, e23), or: (e23) => d4(t23, e23), select: (e23) => void 0 === e23 ? p4(t23) : p4(e23, t23) });
}
function h4(t23) {
  return Object.assign(((t32) => Object.assign(t32, { [Symbol.iterator]() {
    let n23 = 0;
    const r23 = [{ value: Object.assign(t32, { [e4]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t42;
      return null != (t42 = r23[n23++]) ? t42 : r23.at(-1);
    } };
  } }))(t23), { optional: () => h4(l4(t23)), select: (e23) => h4(void 0 === e23 ? p4(t23) : p4(e23, t23)) });
}
function l4(e23) {
  return u4({ [t4]: () => ({ match: (t23) => {
    let n23 = {};
    const r23 = (t32, e32) => {
      n23[t32] = e32;
    };
    return void 0 === t23 ? (s4(e23).forEach((t32) => r23(t32, void 0)), { matched: true, selections: n23 }) : { matched: o4(e23, t23, r23), selections: n23 };
  }, getSelectionKeys: () => s4(e23), matcherType: "optional" }) });
}
var f4 = (t23, e23) => {
  for (const n23 of t23) if (!e23(n23)) return false;
  return true;
};
var g4 = (t23, e23) => {
  for (const [n23, r23] of t23.entries()) if (!e23(r23, n23)) return false;
  return true;
};
function m4(...e23) {
  return u4({ [t4]: () => ({ match: (t23) => {
    let n23 = {};
    const r23 = (t32, e32) => {
      n23[t32] = e32;
    };
    return { matched: e23.every((e32) => o4(e32, t23, r23)), selections: n23 };
  }, getSelectionKeys: () => c4(e23, s4), matcherType: "and" }) });
}
function d4(...e23) {
  return u4({ [t4]: () => ({ match: (t23) => {
    let n23 = {};
    const r23 = (t32, e32) => {
      n23[t32] = e32;
    };
    return c4(e23, s4).forEach((t32) => r23(t32, void 0)), { matched: e23.some((e32) => o4(e32, t23, r23)), selections: n23 };
  }, getSelectionKeys: () => c4(e23, s4), matcherType: "or" }) });
}
function y4(e23) {
  return { [t4]: () => ({ match: (t23) => ({ matched: Boolean(e23(t23)) }) }) };
}
function p4(...e23) {
  const r23 = "string" == typeof e23[0] ? e23[0] : void 0, i23 = 2 === e23.length ? e23[1] : "string" == typeof e23[0] ? void 0 : e23[0];
  return u4({ [t4]: () => ({ match: (t23) => {
    let e32 = { [null != r23 ? r23 : n4]: t23 };
    return { matched: void 0 === i23 || o4(i23, t23, (t32, n23) => {
      e32[t32] = n23;
    }), selections: e32 };
  }, getSelectionKeys: () => [null != r23 ? r23 : n4].concat(void 0 === i23 ? [] : s4(i23)) }) });
}
function v4(t23) {
  return "number" == typeof t23;
}
function b4(t23) {
  return "string" == typeof t23;
}
function w4(t23) {
  return "bigint" == typeof t23;
}
var S4 = u4(y4(function(t23) {
  return true;
}));
var O4 = S4;
var j4 = (t23) => Object.assign(u4(t23), { startsWith: (e23) => {
  return j4(m4(t23, (n23 = e23, y4((t32) => b4(t32) && t32.startsWith(n23)))));
  var n23;
}, endsWith: (e23) => {
  return j4(m4(t23, (n23 = e23, y4((t32) => b4(t32) && t32.endsWith(n23)))));
  var n23;
}, minLength: (e23) => j4(m4(t23, ((t32) => y4((e32) => b4(e32) && e32.length >= t32))(e23))), maxLength: (e23) => j4(m4(t23, ((t32) => y4((e32) => b4(e32) && e32.length <= t32))(e23))), includes: (e23) => {
  return j4(m4(t23, (n23 = e23, y4((t32) => b4(t32) && t32.includes(n23)))));
  var n23;
}, regex: (e23) => {
  return j4(m4(t23, (n23 = e23, y4((t32) => b4(t32) && Boolean(t32.match(n23))))));
  var n23;
} });
var E4 = j4(y4(b4));
var K4 = (t23) => Object.assign(u4(t23), { between: (e23, n23) => K4(m4(t23, ((t32, e32) => y4((n32) => v4(n32) && t32 <= n32 && e32 >= n32))(e23, n23))), lt: (e23) => K4(m4(t23, ((t32) => y4((e32) => v4(e32) && e32 < t32))(e23))), gt: (e23) => K4(m4(t23, ((t32) => y4((e32) => v4(e32) && e32 > t32))(e23))), lte: (e23) => K4(m4(t23, ((t32) => y4((e32) => v4(e32) && e32 <= t32))(e23))), gte: (e23) => K4(m4(t23, ((t32) => y4((e32) => v4(e32) && e32 >= t32))(e23))), int: () => K4(m4(t23, y4((t32) => v4(t32) && Number.isInteger(t32)))), finite: () => K4(m4(t23, y4((t32) => v4(t32) && Number.isFinite(t32)))), positive: () => K4(m4(t23, y4((t32) => v4(t32) && t32 > 0))), negative: () => K4(m4(t23, y4((t32) => v4(t32) && t32 < 0))) });
var x4 = K4(y4(v4));
var A4 = (t23) => Object.assign(u4(t23), { between: (e23, n23) => A4(m4(t23, ((t32, e32) => y4((n32) => w4(n32) && t32 <= n32 && e32 >= n32))(e23, n23))), lt: (e23) => A4(m4(t23, ((t32) => y4((e32) => w4(e32) && e32 < t32))(e23))), gt: (e23) => A4(m4(t23, ((t32) => y4((e32) => w4(e32) && e32 > t32))(e23))), lte: (e23) => A4(m4(t23, ((t32) => y4((e32) => w4(e32) && e32 <= t32))(e23))), gte: (e23) => A4(m4(t23, ((t32) => y4((e32) => w4(e32) && e32 >= t32))(e23))), positive: () => A4(m4(t23, y4((t32) => w4(t32) && t32 > 0))), negative: () => A4(m4(t23, y4((t32) => w4(t32) && t32 < 0))) });
var P4 = A4(y4(w4));
var T4 = u4(y4(function(t23) {
  return "boolean" == typeof t23;
}));
var k4 = u4(y4(function(t23) {
  return "symbol" == typeof t23;
}));
var B4 = u4(y4(function(t23) {
  return null == t23;
}));
var _4 = u4(y4(function(t23) {
  return null != t23;
}));
var N5 = { __proto__: null, matcher: t4, optional: l4, array: function(...e23) {
  return h4({ [t4]: () => ({ match: (t23) => {
    if (!Array.isArray(t23)) return { matched: false };
    if (0 === e23.length) return { matched: true };
    const n23 = e23[0];
    let r23 = {};
    if (0 === t23.length) return s4(n23).forEach((t32) => {
      r23[t32] = [];
    }), { matched: true, selections: r23 };
    const i23 = (t32, e32) => {
      r23[t32] = (r23[t32] || []).concat([e32]);
    };
    return { matched: t23.every((t32) => o4(n23, t32, i23)), selections: r23 };
  }, getSelectionKeys: () => 0 === e23.length ? [] : s4(e23[0]) }) });
}, set: function(...e23) {
  return u4({ [t4]: () => ({ match: (t23) => {
    if (!(t23 instanceof Set)) return { matched: false };
    let n23 = {};
    if (0 === t23.size) return { matched: true, selections: n23 };
    if (0 === e23.length) return { matched: true };
    const r23 = (t32, e32) => {
      n23[t32] = (n23[t32] || []).concat([e32]);
    }, i23 = e23[0];
    return { matched: f4(t23, (t32) => o4(i23, t32, r23)), selections: n23 };
  }, getSelectionKeys: () => 0 === e23.length ? [] : s4(e23[0]) }) });
}, map: function(...e23) {
  return u4({ [t4]: () => ({ match: (t23) => {
    if (!(t23 instanceof Map)) return { matched: false };
    let n23 = {};
    if (0 === t23.size) return { matched: true, selections: n23 };
    const r23 = (t32, e32) => {
      n23[t32] = (n23[t32] || []).concat([e32]);
    };
    if (0 === e23.length) return { matched: true };
    var i23;
    if (1 === e23.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i23 = e23[0]) ? void 0 : i23.toString()}`);
    const [s23, c23] = e23;
    return { matched: g4(t23, (t32, e32) => {
      const n32 = o4(s23, e32, r23), i32 = o4(c23, t32, r23);
      return n32 && i32;
    }), selections: n23 };
  }, getSelectionKeys: () => 0 === e23.length ? [] : [...s4(e23[0]), ...s4(e23[1])] }) });
}, intersection: m4, union: d4, not: function(e23) {
  return u4({ [t4]: () => ({ match: (t23) => ({ matched: !o4(e23, t23, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y4, select: p4, any: S4, _: O4, string: E4, number: x4, bigint: P4, boolean: T4, symbol: k4, nullish: B4, nonNullable: _4, instanceOf: function(t23) {
  return u4(y4(/* @__PURE__ */ function(t32) {
    return (e23) => e23 instanceof t32;
  }(t23)));
}, shape: function(t23) {
  return u4(y4(a4(t23)));
} };
var KEYS5 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES5 = Object.keys(KEYS5);
for (const type of NODE_TYPES5) {
  Object.freeze(KEYS5[type]);
}
Object.freeze(KEYS5);
var visitor_keys_default5 = KEYS5;
var KEY_BLACKLIST5 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey5(key) {
  return !KEY_BLACKLIST5.has(key) && key[0] !== "_";
}
function getKeys5(node) {
  return Object.keys(node).filter(filterKey5);
}
function getInnermostScope5(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range3 = childScope.block.range;
      if (range3[0] <= location && location < range3[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable24(initialScope, nameOrNode) {
  let name2 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name2 = nameOrNode;
  } else {
    name2 = nameOrNode.name;
    scope = getInnermostScope5(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name2);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate05(token) {
  return !this(token);
}
function negate5(f23) {
  return negate05.bind(f23);
}
function isPunctuatorTokenWithValue5(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken5(token) {
  return isPunctuatorTokenWithValue5(token, "=>");
}
function isCommaToken5(token) {
  return isPunctuatorTokenWithValue5(token, ",");
}
function isSemicolonToken5(token) {
  return isPunctuatorTokenWithValue5(token, ";");
}
function isColonToken5(token) {
  return isPunctuatorTokenWithValue5(token, ":");
}
function isOpeningParenToken5(token) {
  return isPunctuatorTokenWithValue5(token, "(");
}
function isClosingParenToken5(token) {
  return isPunctuatorTokenWithValue5(token, ")");
}
function isOpeningBracketToken5(token) {
  return isPunctuatorTokenWithValue5(token, "[");
}
function isClosingBracketToken5(token) {
  return isPunctuatorTokenWithValue5(token, "]");
}
function isOpeningBraceToken5(token) {
  return isPunctuatorTokenWithValue5(token, "{");
}
function isClosingBraceToken5(token) {
  return isPunctuatorTokenWithValue5(token, "}");
}
function isCommentToken5(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate5(isArrowToken5);
negate5(isCommaToken5);
negate5(isSemicolonToken5);
negate5(isColonToken5);
negate5(isOpeningParenToken5);
negate5(isClosingParenToken5);
negate5(isOpeningBracketToken5);
negate5(isClosingBracketToken5);
negate5(isOpeningBraceToken5);
negate5(isClosingBraceToken5);
negate5(isCommentToken5);
function getOpeningParenOfParams5(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken5) : sourceCode.getFirstToken(node, isOpeningParenToken5);
}
function getFunctionHeadLocation5(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken5);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams5(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams5(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject5 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames5 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed5 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k23) => k23 !== "random").map((k23) => Math[k23]).filter((f23) => typeof f23 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f23) => typeof f23 === "function")
);
var callPassThrough5 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed5 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor5(object3, name2) {
  let x23 = object3;
  while ((typeof x23 === "object" || typeof x23 === "function") && x23 !== null) {
    const d23 = Object.getOwnPropertyDescriptor(x23, name2);
    if (d23) {
      return d23;
    }
    x23 = Object.getPrototypeOf(x23);
  }
  return null;
}
function isGetter5(object3, name2) {
  const d23 = getPropertyDescriptor5(object3, name2);
  return d23 != null && d23.get != null;
}
function getElementValues5(nodeList, initialScope) {
  const valueList = [];
  for (let i23 = 0; i23 < nodeList.length; ++i23) {
    const elementNode = nodeList[i23];
    if (elementNode == null) {
      valueList.length = i23 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR5(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR5(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst5(variable) {
  const refs = variable.references;
  const inits = refs.filter((r23) => r23.init).length;
  const reads = refs.filter((r23) => r23.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations5 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues5(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR5(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left33 = getStaticValueR5(node.left, initialScope);
    const right33 = getStaticValueR5(node.right, initialScope);
    if (left33 != null && right33 != null) {
      switch (node.operator) {
        case "==":
          return { value: left33.value == right33.value };
        case "!=":
          return { value: left33.value != right33.value };
        case "===":
          return { value: left33.value === right33.value };
        case "!==":
          return { value: left33.value !== right33.value };
        case "<":
          return { value: left33.value < right33.value };
        case "<=":
          return { value: left33.value <= right33.value };
        case ">":
          return { value: left33.value > right33.value };
        case ">=":
          return { value: left33.value >= right33.value };
        case "<<":
          return { value: left33.value << right33.value };
        case ">>":
          return { value: left33.value >> right33.value };
        case ">>>":
          return { value: left33.value >>> right33.value };
        case "+":
          return { value: left33.value + right33.value };
        case "-":
          return { value: left33.value - right33.value };
        case "*":
          return { value: left33.value * right33.value };
        case "/":
          return { value: left33.value / right33.value };
        case "%":
          return { value: left33.value % right33.value };
        case "**":
          return { value: left33.value ** right33.value };
        case "|":
          return { value: left33.value | right33.value };
        case "^":
          return { value: left33.value ^ right33.value };
        case "&":
          return { value: left33.value & right33.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues5(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object3 = getStaticValueR5(calleeNode.object, initialScope);
        if (object3 != null) {
          if (object3.value == null && (object3.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue5(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object3.value;
            const methodName = property.value;
            if (callAllowed5.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough5.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR5(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed5.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough5.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR5(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR5(node.consequent, initialScope) : getStaticValueR5(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR5(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable24(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames5.has(variable.name) && variable.name in globalObject5) {
        return { value: globalObject5[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst5(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR5(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left33 = getStaticValueR5(node.left, initialScope);
    if (left33 != null) {
      if (node.operator === "||" && Boolean(left33.value) === true || node.operator === "&&" && Boolean(left33.value) === false || node.operator === "??" && left33.value != null) {
        return left33;
      }
      const right33 = getStaticValueR5(node.right, initialScope);
      if (right33 != null) {
        return right33;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object3 = getStaticValueR5(node.object, initialScope);
    if (object3 != null) {
      if (object3.value == null && (object3.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue5(node, initialScope);
      if (property != null) {
        if (!isGetter5(object3.value, property.value)) {
          return { value: object3.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed5) {
          if (object3.value instanceof classFn && allowed.has(property.value)) {
            return { value: object3.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR5(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR5(node.callee, initialScope);
    const args = getElementValues5(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed5.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object3 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue5(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR5(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object3[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR5(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object3, argument.value);
      } else {
        return null;
      }
    }
    return { value: object3 };
  },
  SequenceExpression(node, initialScope) {
    const last3 = node.expressions[node.expressions.length - 1];
    return getStaticValueR5(last3, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR5(node.tag, initialScope);
    const expressions = getElementValues5(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues5(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i23 = 0; i23 < expressions.length; ++i23) {
        value += expressions[i23];
        value += node.quasis[i23 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR5(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR5(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations5, node.type)) {
    return operations5[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue5(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR5(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue6(node, initialScope = null) {
  try {
    return getStaticValueR5(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant5(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue6(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName5(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant5(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant5(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind5(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name2 = getPropertyName5(parent);
      if (name2) {
        tokens.push(`'${name2}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps5 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps5 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode5(x23) {
  return x23 !== null && typeof x23 === "object" && typeof x23.type === "string";
}
var visitor5 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys5(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode5(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode5(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps5.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps5.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect5(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor5.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default5
  );
}
function getParentSyntaxParen5(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken5
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken5
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized5(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken5(maybeLeftParen) && isClosingParenToken5(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen5(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp24 = Object.defineProperty;
var __export24 = (target, all33) => {
  for (var name2 in all33)
    __defProp24(target, name2, { get: all33[name2], enumerable: true });
};
var NodeType5 = AST_NODE_TYPES;
var is5 = ASTUtils.isNodeOfType;
var isOneOf5 = ASTUtils.isNodeOfTypes;
isOneOf5([
  NodeType5.ArrowFunctionExpression,
  NodeType5.FunctionDeclaration,
  NodeType5.FunctionExpression
]);
isOneOf5([
  NodeType5.ArrowFunctionExpression,
  NodeType5.FunctionDeclaration,
  NodeType5.FunctionExpression,
  NodeType5.TSCallSignatureDeclaration,
  NodeType5.TSConstructSignatureDeclaration,
  NodeType5.TSDeclareFunction,
  NodeType5.TSEmptyBodyFunctionExpression,
  NodeType5.TSFunctionType,
  NodeType5.TSMethodSignature
]);
isOneOf5([NodeType5.ClassDeclaration, NodeType5.ClassExpression]);
isOneOf5([
  NodeType5.DoWhileStatement,
  NodeType5.ForInStatement,
  NodeType5.ForOfStatement,
  NodeType5.ForStatement,
  NodeType5.WhileStatement
]);
isOneOf5([NodeType5.TSArrayType, NodeType5.TSTupleType]);
isOneOf5([
  NodeType5.PropertyDefinition,
  NodeType5.TSIndexSignature,
  NodeType5.TSParameterProperty,
  NodeType5.TSPropertySignature
]);
is5(NodeType5.JSXElement);
is5(NodeType5.JSXFragment);
isOneOf5([
  NodeType5.JSXAttribute,
  NodeType5.JSXSpreadChild,
  NodeType5.JSXClosingElement,
  NodeType5.JSXClosingFragment,
  NodeType5.JSXElement,
  NodeType5.JSXEmptyExpression,
  NodeType5.JSXExpressionContainer,
  NodeType5.JSXFragment,
  NodeType5.JSXIdentifier,
  NodeType5.JSXMemberExpression,
  NodeType5.JSXNamespacedName,
  NodeType5.JSXOpeningElement,
  NodeType5.JSXOpeningFragment,
  NodeType5.JSXSpreadAttribute,
  NodeType5.JSXSpreadChild,
  NodeType5.JSXText
]);
isOneOf5([
  NodeType5.JSXIdentifier,
  NodeType5.JSXMemberExpression,
  NodeType5.JSXNamespacedName
]);
isOneOf5([
  NodeType5.ArrayPattern,
  NodeType5.AssignmentPattern,
  NodeType5.ObjectPattern,
  NodeType5.RestElement
]);
isOneOf5([
  NodeType5.TSInterfaceDeclaration,
  NodeType5.TSTypeAliasDeclaration
]);
isOneOf5([
  NodeType5.ArrayExpression,
  NodeType5.ArrayPattern,
  NodeType5.ArrowFunctionExpression,
  NodeType5.CallExpression,
  NodeType5.ClassExpression,
  NodeType5.FunctionExpression,
  NodeType5.Identifier,
  NodeType5.JSXElement,
  NodeType5.JSXFragment,
  NodeType5.Literal,
  NodeType5.TemplateLiteral,
  NodeType5.MemberExpression,
  NodeType5.MetaProperty,
  NodeType5.ObjectExpression,
  NodeType5.ObjectPattern,
  NodeType5.SequenceExpression,
  NodeType5.Super,
  NodeType5.TaggedTemplateExpression,
  NodeType5.ThisExpression
]);
isOneOf5([
  NodeType5.ArrayExpression,
  NodeType5.ArrayPattern,
  NodeType5.ArrowFunctionExpression,
  NodeType5.CallExpression,
  NodeType5.ClassExpression,
  NodeType5.FunctionExpression,
  NodeType5.Identifier,
  NodeType5.JSXElement,
  NodeType5.JSXFragment,
  NodeType5.Literal,
  NodeType5.TemplateLiteral,
  NodeType5.MemberExpression,
  NodeType5.MetaProperty,
  NodeType5.ObjectExpression,
  NodeType5.ObjectPattern,
  NodeType5.SequenceExpression,
  NodeType5.Super,
  NodeType5.TaggedTemplateExpression,
  NodeType5.ThisExpression,
  NodeType5.TSAsExpression,
  NodeType5.TSNonNullExpression,
  NodeType5.TSTypeAssertion
]);
var Function_exports24 = {};
__export24(Function_exports24, {
  SK: () => SK24,
  absurd: () => absurd24,
  apply: () => apply24,
  compose: () => compose25,
  constFalse: () => constFalse24,
  constNull: () => constNull24,
  constTrue: () => constTrue24,
  constUndefined: () => constUndefined24,
  constVoid: () => constVoid24,
  constant: () => constant24,
  dual: () => dual24,
  flip: () => flip24,
  flow: () => flow24,
  hole: () => hole24,
  identity: () => identity24,
  isFunction: () => isFunction224,
  pipe: () => pipe24,
  satisfies: () => satisfies24,
  tupled: () => tupled24,
  unsafeCoerce: () => unsafeCoerce24,
  untupled: () => untupled24
});
var isFunction224 = (input) => typeof input === "function";
var dual24 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a23, b23) {
        if (arguments.length >= 2) {
          return body(a23, b23);
        }
        return function(self2) {
          return body(self2, a23);
        };
      };
    case 3:
      return function(a23, b23, c23) {
        if (arguments.length >= 3) {
          return body(a23, b23, c23);
        }
        return function(self2) {
          return body(self2, a23, b23);
        };
      };
    case 4:
      return function(a23, b23, c23, d23) {
        if (arguments.length >= 4) {
          return body(a23, b23, c23, d23);
        }
        return function(self2) {
          return body(self2, a23, b23, c23);
        };
      };
    case 5:
      return function(a23, b23, c23, d23, e23) {
        if (arguments.length >= 5) {
          return body(a23, b23, c23, d23, e23);
        }
        return function(self2) {
          return body(self2, a23, b23, c23, d23);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply24 = (a23) => (self2) => self2(a23);
var identity24 = (a23) => a23;
var satisfies24 = () => (b23) => b23;
var unsafeCoerce24 = identity24;
var constant24 = (value) => () => value;
var constTrue24 = /* @__PURE__ */ constant24(true);
var constFalse24 = /* @__PURE__ */ constant24(false);
var constNull24 = /* @__PURE__ */ constant24(null);
var constUndefined24 = /* @__PURE__ */ constant24(void 0);
var constVoid24 = constUndefined24;
var flip24 = (f23) => (...b23) => (...a23) => f23(...a23)(...b23);
var compose25 = /* @__PURE__ */ dual24(2, (ab, bc) => (a23) => bc(ab(a23)));
var absurd24 = (_23) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled24 = (f23) => (a23) => f23(...a23);
var untupled24 = (f23) => (...a23) => f23(a23);
function pipe24(a23, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a23;
    case 2:
      return ab(a23);
    case 3:
      return bc(ab(a23));
    case 4:
      return cd(bc(ab(a23)));
    case 5:
      return de(cd(bc(ab(a23))));
    case 6:
      return ef(de(cd(bc(ab(a23)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a23))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a23)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a23))))))));
    default: {
      let ret = arguments[0];
      for (let i23 = 1; i23 < arguments.length; i23++) {
        ret = arguments[i23](ret);
      }
      return ret;
    }
  }
}
function flow24(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole24 = /* @__PURE__ */ unsafeCoerce24(absurd24);
var SK24 = (_23, b23) => b23;
var make45 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_34 = (map63) => dual24(3, (self2, name2, f23) => map63(self2, (a23) => Object.assign({}, a23, {
  [name2]: f23(a23)
})));
var bindTo34 = (map63) => dual24(2, (self2, name2) => map63(self2, (a23) => ({
  [name2]: a23
})));
var bind34 = (map63, flatMap43) => dual24(3, (self2, name2, f23) => flatMap43(self2, (a23) => map63(f23(a23), (b23) => Object.assign({}, a23, {
  [name2]: b23
}))));
var moduleVersion24 = "3.2.8";
var getCurrentVersion24 = () => moduleVersion24;
var globalStoreId24 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion24()}`);
if (!(globalStoreId24 in globalThis)) {
  globalThis[globalStoreId24] = /* @__PURE__ */ new Map();
}
var globalStore24 = globalThis[globalStoreId24];
var globalValue24 = (id, compute) => {
  if (!globalStore24.has(id)) {
    globalStore24.set(id, compute());
  }
  return globalStore24.get(id);
};
var Predicate_exports24 = {};
__export24(Predicate_exports24, {
  all: () => all25,
  and: () => and7,
  compose: () => compose224,
  eqv: () => eqv7,
  every: () => every9,
  hasProperty: () => hasProperty24,
  implies: () => implies7,
  isBigInt: () => isBigInt7,
  isBoolean: () => isBoolean7,
  isDate: () => isDate7,
  isError: () => isError7,
  isFunction: () => isFunction324,
  isIterable: () => isIterable7,
  isMap: () => isMap7,
  isNever: () => isNever7,
  isNotNull: () => isNotNull7,
  isNotNullable: () => isNotNullable7,
  isNotUndefined: () => isNotUndefined7,
  isNull: () => isNull7,
  isNullable: () => isNullable24,
  isNumber: () => isNumber7,
  isObject: () => isObject24,
  isPromise: () => isPromise7,
  isPromiseLike: () => isPromiseLike7,
  isReadonlyRecord: () => isReadonlyRecord7,
  isRecord: () => isRecord7,
  isSet: () => isSet7,
  isString: () => isString7,
  isSymbol: () => isSymbol7,
  isTagged: () => isTagged7,
  isTruthy: () => isTruthy7,
  isUint8Array: () => isUint8Array7,
  isUndefined: () => isUndefined7,
  isUnknown: () => isUnknown7,
  mapInput: () => mapInput8,
  nand: () => nand7,
  nor: () => nor7,
  not: () => not7,
  or: () => or7,
  product: () => product25,
  productMany: () => productMany25,
  some: () => some35,
  struct: () => struct9,
  tuple: () => tuple8,
  xor: () => xor7
});
var mapInput8 = /* @__PURE__ */ dual24(2, (self2, f23) => (b23) => self2(f23(b23)));
var isTruthy7 = (input) => !!input;
var isSet7 = (input) => input instanceof Set;
var isMap7 = (input) => input instanceof Map;
var isString7 = (input) => typeof input === "string";
var isNumber7 = (input) => typeof input === "number";
var isBoolean7 = (input) => typeof input === "boolean";
var isBigInt7 = (input) => typeof input === "bigint";
var isSymbol7 = (input) => typeof input === "symbol";
var isFunction324 = isFunction224;
var isUndefined7 = (input) => input === void 0;
var isNotUndefined7 = (input) => input !== void 0;
var isNull7 = (input) => input === null;
var isNotNull7 = (input) => input !== null;
var isNever7 = (_23) => false;
var isUnknown7 = (_23) => true;
var isRecordOrArray24 = (input) => typeof input === "object" && input !== null;
var isObject24 = (input) => isRecordOrArray24(input) || isFunction324(input);
var hasProperty24 = /* @__PURE__ */ dual24(2, (self2, property) => isObject24(self2) && property in self2);
var isTagged7 = /* @__PURE__ */ dual24(2, (self2, tag) => hasProperty24(self2, "_tag") && self2["_tag"] === tag);
var isNullable24 = (input) => input === null || input === void 0;
var isNotNullable7 = (input) => input !== null && input !== void 0;
var isError7 = (input) => input instanceof Error;
var isUint8Array7 = (input) => input instanceof Uint8Array;
var isDate7 = (input) => input instanceof Date;
var isIterable7 = (input) => hasProperty24(input, Symbol.iterator);
var isRecord7 = (input) => isRecordOrArray24(input) && !Array.isArray(input);
var isReadonlyRecord7 = isRecord7;
var isPromise7 = (input) => hasProperty24(input, "then") && "catch" in input && isFunction324(input.then) && isFunction324(input.catch);
var isPromiseLike7 = (input) => hasProperty24(input, "then") && isFunction324(input.then);
var compose224 = /* @__PURE__ */ dual24(2, (ab, bc) => (a23) => ab(a23) && bc(a23));
var product25 = (self2, that) => ([a23, b23]) => self2(a23) && that(b23);
var all25 = (collection) => {
  return (as223) => {
    let collectionIndex = 0;
    for (const p23 of collection) {
      if (collectionIndex >= as223.length) {
        break;
      }
      if (p23(as223[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany25 = (self2, collection) => {
  const rest = all25(collection);
  return ([head23, ...tail4]) => self2(head23) === false ? false : rest(tail4);
};
var tuple8 = (...elements) => all25(elements);
var struct9 = (fields) => {
  const keys23 = Object.keys(fields);
  return (a23) => {
    for (const key of keys23) {
      if (!fields[key](a23[key])) {
        return false;
      }
    }
    return true;
  };
};
var not7 = (self2) => (a23) => !self2(a23);
var or7 = /* @__PURE__ */ dual24(2, (self2, that) => (a23) => self2(a23) || that(a23));
var and7 = /* @__PURE__ */ dual24(2, (self2, that) => (a23) => self2(a23) && that(a23));
var xor7 = /* @__PURE__ */ dual24(2, (self2, that) => (a23) => self2(a23) !== that(a23));
var eqv7 = /* @__PURE__ */ dual24(2, (self2, that) => (a23) => self2(a23) === that(a23));
var implies7 = /* @__PURE__ */ dual24(2, (self2, that) => (a23) => self2(a23) ? that(a23) : true);
var nor7 = /* @__PURE__ */ dual24(2, (self2, that) => (a23) => !(self2(a23) || that(a23)));
var nand7 = /* @__PURE__ */ dual24(2, (self2, that) => (a23) => !(self2(a23) && that(a23)));
var every9 = (collection) => (a23) => {
  for (const p23 of collection) {
    if (!p23(a23)) {
      return false;
    }
  }
  return true;
};
var some35 = (collection) => (a23) => {
  for (const p23 of collection) {
    if (p23(a23)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage24 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId24 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind24 = (u23) => isObject24(u23) && GenKindTypeId24 in u23;
var GenKindImpl24 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity24;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_23) => _23;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_23) => _23;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_23) => _23;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId24] = GenKindTypeId24;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen25(this);
  }
};
var SingleShotGen25 = class _SingleShotGen9 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a23) {
    return this.called ? {
      value: a23,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a23) {
    return {
      value: a23,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e23) {
    throw e23;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen9(this.self);
  }
};
var adapter34 = () => function() {
  let x23 = arguments[0];
  for (let i23 = 1; i23 < arguments.length; i23++) {
    x23 = arguments[i23](x23);
  }
  return new GenKindImpl24(x23);
};
var defaultIncHi24 = 335903614;
var defaultIncLo24 = 4150755663;
var MUL_HI24 = 1481765933 >>> 0;
var MUL_LO24 = 1284865837 >>> 0;
var BIT_5324 = 9007199254740992;
var BIT_2724 = 134217728;
var PCGRandom24 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable24(seedLo) && isNullable24(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable24(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable24(incLo) && isNullable24(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo24;
      incHi = this._state ? this._state[2] : defaultIncHi24;
    } else if (isNullable24(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6424(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max4) {
    if (!max4) {
      return this._next();
    }
    max4 = max4 >>> 0;
    if ((max4 & max4 - 1) === 0) {
      return this._next() & max4 - 1;
    }
    let num = 0;
    const skew = (-max4 >>> 0) % max4 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max4;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2724 + lo) / BIT_5324;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6424(this._state, oldHi, oldLo, MUL_HI24, MUL_LO24);
    add6424(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6424(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6424(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId24 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap24 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId24]() {
    return this.#value;
  }
};
function yieldWrapGet24(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId24 in self2) {
    return self2[YieldWrapTypeId24]();
  }
  throw new Error(getBugErrorMessage24("yieldWrapGet"));
}
var structuralRegionState24 = /* @__PURE__ */ globalValue24("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache24 = /* @__PURE__ */ globalValue24(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr24 = /* @__PURE__ */ globalValue24(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom24());
var symbol34 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash24 = (self2) => {
  if (structuralRegionState24.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number24(self2);
    case "bigint":
      return string24(self2.toString(10));
    case "boolean":
      return string24(String(self2));
    case "symbol":
      return string24(String(self2));
    case "string":
      return string24(self2);
    case "undefined":
      return string24("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string24("null");
      } else if (self2 instanceof Date) {
        return hash24(self2.toISOString());
      } else if (isHash24(self2)) {
        return self2[symbol34]();
      } else {
        return random24(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random24 = (self2) => {
  if (!randomHashCache24.has(self2)) {
    randomHashCache24.set(self2, number24(pcgr24.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache24.get(self2);
};
var combine25 = (b23) => (self2) => self2 * 53 ^ b23;
var optimize24 = (n23) => n23 & 3221225471 | n23 >>> 1 & 1073741824;
var isHash24 = (u23) => hasProperty24(u23, symbol34);
var number24 = (n23) => {
  if (n23 !== n23 || n23 === Infinity) {
    return 0;
  }
  let h23 = n23 | 0;
  if (h23 !== n23) {
    h23 ^= n23 * 4294967295;
  }
  while (n23 > 4294967295) {
    h23 ^= n23 /= 4294967295;
  }
  return optimize24(n23);
};
var string24 = (str) => {
  let h23 = 5381, i23 = str.length;
  while (i23) {
    h23 = h23 * 33 ^ str.charCodeAt(--i23);
  }
  return optimize24(h23);
};
var structureKeys24 = (o23, keys23) => {
  let h23 = 12289;
  for (let i23 = 0; i23 < keys23.length; i23++) {
    h23 ^= pipe24(string24(keys23[i23]), combine25(hash24(o23[keys23[i23]])));
  }
  return optimize24(h23);
};
var structure24 = (o23) => structureKeys24(o23, Object.keys(o23));
var array9 = (arr) => {
  let h23 = 6151;
  for (let i23 = 0; i23 < arr.length; i23++) {
    h23 = pipe24(h23, combine25(hash24(arr[i23])));
  }
  return optimize24(h23);
};
var cached24 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash33) {
      Object.defineProperty(self22, symbol34, {
        value() {
          return hash33;
        },
        enumerable: false
      });
      return hash33;
    };
  }
  const self2 = arguments[0];
  const hash223 = arguments[1];
  Object.defineProperty(self2, symbol34, {
    value() {
      return hash223;
    },
    enumerable: false
  });
  return hash223;
};
var symbol224 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals24() {
  if (arguments.length === 1) {
    return (self2) => compareBoth24(self2, arguments[0]);
  }
  return compareBoth24(arguments[0], arguments[1]);
}
function compareBoth24(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual24(self2) && isEqual24(that)) {
        if (hash24(self2) === hash24(that) && self2[symbol224](that)) {
          return true;
        } else {
          return structuralRegionState24.enabled && structuralRegionState24.tester ? structuralRegionState24.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState24.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v23, i23) => compareBoth24(v23, that[i23]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth24(self2[key], that[key]))) {
              return structuralRegionState24.tester ? structuralRegionState24.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState24.tester ? structuralRegionState24.tester(self2, that) : false;
    }
  }
  return structuralRegionState24.enabled && structuralRegionState24.tester ? structuralRegionState24.tester(self2, that) : false;
}
var isEqual24 = (u23) => hasProperty24(u23, symbol224);
var equivalence24 = () => equals24;
var NodeInspectSymbol24 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON24 = (x23) => {
  if (hasProperty24(x23, "toJSON") && isFunction324(x23["toJSON"]) && x23["toJSON"].length === 0) {
    return x23.toJSON();
  } else if (Array.isArray(x23)) {
    return x23.map(toJSON24);
  }
  return x23;
};
var format24 = (x23) => JSON.stringify(x23, null, 2);
var pipeArguments24 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i23 = 0, len = args.length; i23 < len; i23++) {
        ret = args[i23](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT24 = "Commit";
var OP_FAILURE5 = "Failure";
var OP_WITH_RUNTIME5 = "WithRuntime";
var EffectTypeId25 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId24 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId24 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId24 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance24 = {
  /* c8 ignore next */
  _R: (_23) => _23,
  /* c8 ignore next */
  _E: (_23) => _23,
  /* c8 ignore next */
  _A: (_23) => _23,
  _V: /* @__PURE__ */ getCurrentVersion24()
};
var sinkVariance24 = {
  /* c8 ignore next */
  _A: (_23) => _23,
  /* c8 ignore next */
  _In: (_23) => _23,
  /* c8 ignore next */
  _L: (_23) => _23,
  /* c8 ignore next */
  _E: (_23) => _23,
  /* c8 ignore next */
  _R: (_23) => _23
};
var channelVariance24 = {
  /* c8 ignore next */
  _Env: (_23) => _23,
  /* c8 ignore next */
  _InErr: (_23) => _23,
  /* c8 ignore next */
  _InElem: (_23) => _23,
  /* c8 ignore next */
  _InDone: (_23) => _23,
  /* c8 ignore next */
  _OutErr: (_23) => _23,
  /* c8 ignore next */
  _OutElem: (_23) => _23,
  /* c8 ignore next */
  _OutDone: (_23) => _23
};
var EffectPrototype24 = {
  [EffectTypeId25]: effectVariance24,
  [StreamTypeId24]: effectVariance24,
  [SinkTypeId24]: sinkVariance24,
  [ChannelTypeId24]: channelVariance24,
  [symbol224](that) {
    return this === that;
  },
  [symbol34]() {
    return cached24(this, random24(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen25(new YieldWrap24(this));
  },
  pipe() {
    return pipeArguments24(this, arguments);
  }
};
var StructuralPrototype24 = {
  [symbol34]() {
    return cached24(this, structure24(this));
  },
  [symbol224](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals24(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype24 = {
  ...EffectPrototype24,
  _op: OP_COMMIT24
};
var StructuralCommitPrototype24 = {
  ...CommitPrototype24,
  ...StructuralPrototype24
};
var TypeId55 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto34 = {
  ...EffectPrototype24,
  [TypeId55]: {
    _A: (_23) => _23
  },
  [NodeInspectSymbol24]() {
    return this.toJSON();
  },
  toString() {
    return format24(this.toJSON());
  }
};
var SomeProto24 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto34), {
  _tag: "Some",
  _op: "Some",
  [symbol224](that) {
    return isOption34(that) && isSome34(that) && equals24(this.value, that.value);
  },
  [symbol34]() {
    return cached24(this, combine25(hash24(this._tag))(hash24(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON24(this.value)
    };
  }
});
var NoneHash24 = /* @__PURE__ */ hash24("None");
var NoneProto24 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto34), {
  _tag: "None",
  _op: "None",
  [symbol224](that) {
    return isOption34(that) && isNone34(that);
  },
  [symbol34]() {
    return NoneHash24;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption34 = (input) => hasProperty24(input, TypeId55);
var isNone34 = (fa) => fa._tag === "None";
var isSome34 = (fa) => fa._tag === "Some";
var none34 = /* @__PURE__ */ Object.create(NoneProto24);
var some224 = (value) => {
  const a23 = Object.create(SomeProto24);
  a23.value = value;
  return a23;
};
var TypeId224 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto224 = {
  ...EffectPrototype24,
  [TypeId224]: {
    _R: (_23) => _23
  },
  [NodeInspectSymbol24]() {
    return this.toJSON();
  },
  toString() {
    return format24(this.toJSON());
  }
};
var RightProto24 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto224), {
  _tag: "Right",
  _op: "Right",
  [symbol224](that) {
    return isEither24(that) && isRight24(that) && equals24(this.right, that.right);
  },
  [symbol34]() {
    return combine25(hash24(this._tag))(hash24(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON24(this.right)
    };
  }
});
var LeftProto24 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto224), {
  _tag: "Left",
  _op: "Left",
  [symbol224](that) {
    return isEither24(that) && isLeft24(that) && equals24(this.left, that.left);
  },
  [symbol34]() {
    return combine25(hash24(this._tag))(hash24(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON24(this.left)
    };
  }
});
var isEither24 = (input) => hasProperty24(input, TypeId224);
var isLeft24 = (ma) => ma._tag === "Left";
var isRight24 = (ma) => ma._tag === "Right";
var left25 = (left33) => {
  const a23 = Object.create(LeftProto24);
  a23.left = left33;
  return a23;
};
var right25 = (right33) => {
  const a23 = Object.create(RightProto24);
  a23.right = right33;
  return a23;
};
var getLeft34 = (self2) => isRight24(self2) ? none34 : some224(self2.left);
var getRight34 = (self2) => isLeft24(self2) ? none34 : some224(self2.right);
var right224 = right25;
var left224 = left25;
var Option_exports24 = {};
__export24(Option_exports24, {
  Do: () => Do24,
  TypeId: () => TypeId324,
  all: () => all224,
  andThen: () => andThen24,
  ap: () => ap24,
  as: () => as24,
  asVoid: () => asVoid24,
  bind: () => bind224,
  bindTo: () => bindTo224,
  composeK: () => composeK24,
  contains: () => contains24,
  containsWith: () => containsWith24,
  exists: () => exists24,
  filter: () => filter24,
  filterMap: () => filterMap24,
  firstSomeOf: () => firstSomeOf24,
  flatMap: () => flatMap24,
  flatMapNullable: () => flatMapNullable24,
  flatten: () => flatten24,
  fromIterable: () => fromIterable25,
  fromNullable: () => fromNullable24,
  gen: () => gen24,
  getEquivalence: () => getEquivalence25,
  getLeft: () => getLeft224,
  getOrElse: () => getOrElse24,
  getOrNull: () => getOrNull24,
  getOrThrow: () => getOrThrow24,
  getOrThrowWith: () => getOrThrowWith24,
  getOrUndefined: () => getOrUndefined24,
  getOrder: () => getOrder24,
  getRight: () => getRight224,
  isNone: () => isNone224,
  isOption: () => isOption224,
  isSome: () => isSome224,
  let: () => let_224,
  lift2: () => lift224,
  liftNullable: () => liftNullable24,
  liftPredicate: () => liftPredicate24,
  liftThrowable: () => liftThrowable24,
  map: () => map24,
  match: () => match25,
  none: () => none224,
  orElse: () => orElse24,
  orElseEither: () => orElseEither24,
  orElseSome: () => orElseSome24,
  partitionMap: () => partitionMap24,
  product: () => product224,
  productMany: () => productMany224,
  reduceCompact: () => reduceCompact24,
  some: () => some324,
  tap: () => tap24,
  toArray: () => toArray24,
  toRefinement: () => toRefinement24,
  void: () => void_24,
  zipLeft: () => zipLeft24,
  zipRight: () => zipRight24,
  zipWith: () => zipWith24
});
var make224 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId324 = /* @__PURE__ */ Symbol.for("effect/Option");
var none224 = () => none34;
var some324 = some224;
var isOption224 = isOption34;
var isNone224 = isNone34;
var isSome224 = isSome34;
var match25 = /* @__PURE__ */ dual24(2, (self2, {
  onNone,
  onSome
}) => isNone224(self2) ? onNone() : onSome(self2.value));
var toRefinement24 = (f23) => (a23) => isSome224(f23(a23));
var fromIterable25 = (collection) => {
  for (const a23 of collection) {
    return some324(a23);
  }
  return none224();
};
var getRight224 = getRight34;
var getLeft224 = getLeft34;
var getOrElse24 = /* @__PURE__ */ dual24(2, (self2, onNone) => isNone224(self2) ? onNone() : self2.value);
var orElse24 = /* @__PURE__ */ dual24(2, (self2, that) => isNone224(self2) ? that() : self2);
var orElseSome24 = /* @__PURE__ */ dual24(2, (self2, onNone) => isNone224(self2) ? some324(onNone()) : self2);
var orElseEither24 = /* @__PURE__ */ dual24(2, (self2, that) => isNone224(self2) ? map24(that(), right25) : map24(self2, left25));
var firstSomeOf24 = (collection) => {
  let out = none224();
  for (out of collection) {
    if (isSome224(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable24 = (nullableValue) => nullableValue == null ? none224() : some324(nullableValue);
var liftNullable24 = (f23) => (...a23) => fromNullable24(f23(...a23));
var getOrNull24 = /* @__PURE__ */ getOrElse24(constNull24);
var getOrUndefined24 = /* @__PURE__ */ getOrElse24(constUndefined24);
var liftThrowable24 = (f23) => (...a23) => {
  try {
    return some324(f23(...a23));
  } catch (e23) {
    return none224();
  }
};
var getOrThrowWith24 = /* @__PURE__ */ dual24(2, (self2, onNone) => {
  if (isSome224(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow24 = /* @__PURE__ */ getOrThrowWith24(() => new Error("getOrThrow called on a None"));
var map24 = /* @__PURE__ */ dual24(2, (self2, f23) => isNone224(self2) ? none224() : some324(f23(self2.value)));
var as24 = /* @__PURE__ */ dual24(2, (self2, b23) => map24(self2, () => b23));
var asVoid24 = /* @__PURE__ */ as24(void 0);
var void_24 = /* @__PURE__ */ some324(void 0);
var flatMap24 = /* @__PURE__ */ dual24(2, (self2, f23) => isNone224(self2) ? none224() : f23(self2.value));
var andThen24 = /* @__PURE__ */ dual24(2, (self2, f23) => flatMap24(self2, (a23) => {
  const b23 = isFunction224(f23) ? f23(a23) : f23;
  return isOption224(b23) ? b23 : some324(b23);
}));
var flatMapNullable24 = /* @__PURE__ */ dual24(2, (self2, f23) => isNone224(self2) ? none224() : fromNullable24(f23(self2.value)));
var flatten24 = /* @__PURE__ */ flatMap24(identity24);
var zipRight24 = /* @__PURE__ */ dual24(2, (self2, that) => flatMap24(self2, () => that));
var composeK24 = /* @__PURE__ */ dual24(2, (afb, bfc) => (a23) => flatMap24(afb(a23), bfc));
var zipLeft24 = /* @__PURE__ */ dual24(2, (self2, that) => tap24(self2, () => that));
var tap24 = /* @__PURE__ */ dual24(2, (self2, f23) => flatMap24(self2, (a23) => map24(f23(a23), () => a23)));
var product224 = (self2, that) => isSome224(self2) && isSome224(that) ? some324([self2.value, that.value]) : none224();
var productMany224 = (self2, collection) => {
  if (isNone224(self2)) {
    return none224();
  }
  const out = [self2.value];
  for (const o23 of collection) {
    if (isNone224(o23)) {
      return none224();
    }
    out.push(o23.value);
  }
  return some324(out);
};
var all224 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o23 of input) {
      if (isNone224(o23)) {
        return none224();
      }
      out2.push(o23.value);
    }
    return some324(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o23 = input[key];
    if (isNone224(o23)) {
      return none224();
    }
    out[key] = o23.value;
  }
  return some324(out);
};
var zipWith24 = /* @__PURE__ */ dual24(3, (self2, that, f23) => map24(product224(self2, that), ([a23, b23]) => f23(a23, b23)));
var ap24 = /* @__PURE__ */ dual24(2, (self2, that) => zipWith24(self2, that, (f23, a23) => f23(a23)));
var reduceCompact24 = /* @__PURE__ */ dual24(3, (self2, b23, f23) => {
  let out = b23;
  for (const oa of self2) {
    if (isSome224(oa)) {
      out = f23(out, oa.value);
    }
  }
  return out;
});
var toArray24 = (self2) => isNone224(self2) ? [] : [self2.value];
var partitionMap24 = /* @__PURE__ */ dual24(2, (self2, f23) => {
  if (isNone224(self2)) {
    return [none224(), none224()];
  }
  const e23 = f23(self2.value);
  return isLeft24(e23) ? [some324(e23.left), none224()] : [none224(), some324(e23.right)];
});
var filterMap24 = /* @__PURE__ */ dual24(2, (self2, f23) => isNone224(self2) ? none224() : f23(self2.value));
var filter24 = /* @__PURE__ */ dual24(2, (self2, predicate) => filterMap24(self2, (b23) => predicate(b23) ? some224(b23) : none34));
var getEquivalence25 = (isEquivalent) => make45((x23, y23) => x23 === y23 || (isNone224(x23) ? isNone224(y23) : isNone224(y23) ? false : isEquivalent(x23.value, y23.value)));
var getOrder24 = (O23) => make224((self2, that) => isSome224(self2) ? isSome224(that) ? O23(self2.value, that.value) : 1 : -1);
var lift224 = (f23) => dual24(2, (self2, that) => zipWith24(self2, that, f23));
var liftPredicate24 = (predicate) => (b23) => predicate(b23) ? some324(b23) : none224();
var containsWith24 = (isEquivalent) => dual24(2, (self2, a23) => isNone224(self2) ? false : isEquivalent(self2.value, a23));
var _equivalence25 = /* @__PURE__ */ equivalence24();
var contains24 = /* @__PURE__ */ containsWith24(_equivalence25);
var exists24 = /* @__PURE__ */ dual24(2, (self2, refinement) => isNone224(self2) ? false : refinement(self2.value));
var bindTo224 = /* @__PURE__ */ bindTo34(map24);
var let_224 = /* @__PURE__ */ let_34(map24);
var bind224 = /* @__PURE__ */ bind34(map24, flatMap24);
var Do24 = /* @__PURE__ */ some324({});
var adapter224 = /* @__PURE__ */ adapter34();
var gen24 = (f23) => {
  const iterator = f23(adapter224);
  let state = iterator.next();
  if (state.done) {
    return some324(state.value);
  } else {
    let current = state.value;
    if (isGenKind24(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet24(current);
    }
    if (isNone224(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind24(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet24(current);
        }
        if (isNone224(current)) {
          return current;
        }
      }
    }
    return some324(state.value);
  }
};
var fromIterable224 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse7 = (self2) => Array.from(self2).reverse();
var reduce9 = /* @__PURE__ */ dual24(3, (self2, b23, f23) => fromIterable224(self2).reduce((b222, a23, i23) => f23(b222, a23, i23), b23));
var TagTypeId5 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey5 = "effect/STM";
var STMTypeId5 = /* @__PURE__ */ Symbol.for(STMSymbolKey5);
var TagProto5 = {
  ...EffectPrototype24,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId5]: effectVariance24,
  [TagTypeId5]: {
    _Service: (_23) => _23,
    _Identifier: (_23) => _23
  },
  toString() {
    return format24(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol24]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make324(this, self2);
  }
};
var makeGenericTag5 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto5);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId424 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto5 = {
  [TypeId424]: {
    _Services: (_23) => _23
  },
  [symbol224](that) {
    if (isContext5(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k23 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k23) || !equals24(this.unsafeMap.get(k23), that.unsafeMap.get(k23))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol34]() {
    return cached24(this, number24(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments24(this, arguments);
  },
  toString() {
    return format24(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON24)
    };
  },
  [NodeInspectSymbol24]() {
    return this.toJSON();
  }
};
var makeContext5 = (unsafeMap) => {
  const context = Object.create(ContextProto5);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext5 = (u23) => hasProperty24(u23, TypeId424);
var _empty9 = /* @__PURE__ */ makeContext5(/* @__PURE__ */ new Map());
var empty15 = () => _empty9;
var make324 = (tag, service) => makeContext5(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag5 = makeGenericTag5;
var empty25 = empty15;
var TypeId524 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy6(src, srcPos, dest, destPos, len) {
  for (let i23 = srcPos; i23 < Math.min(src.length, srcPos + len); i23++) {
    dest[destPos + i23 - srcPos] = src[i23];
  }
  return dest;
}
var emptyArray5 = [];
var getEquivalence224 = (isEquivalent) => make45((self2, that) => self2.length === that.length && toReadonlyArray5(self2).every((value, i23) => isEquivalent(value, unsafeGet25(that, i23))));
var _equivalence224 = /* @__PURE__ */ getEquivalence224(equals24);
var ChunkProto5 = {
  [TypeId524]: {
    _A: (_23) => _23
  },
  toString() {
    return format24(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray5(this).map(toJSON24)
    };
  },
  [NodeInspectSymbol24]() {
    return this.toJSON();
  },
  [symbol224](that) {
    return isChunk5(that) && _equivalence224(this, that);
  },
  [symbol34]() {
    return cached24(this, array9(toReadonlyArray5(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray5[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray5(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments24(this, arguments);
  }
};
var makeChunk5 = (backing) => {
  const chunk = Object.create(ChunkProto5);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty25;
      chunk.right = _empty25;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty25;
      chunk.right = _empty25;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty25;
      chunk.right = _empty25;
      break;
    }
  }
  return chunk;
};
var isChunk5 = (u23) => hasProperty24(u23, TypeId524);
var _empty25 = /* @__PURE__ */ makeChunk5({
  _tag: "IEmpty"
});
var empty35 = () => _empty25;
var make424 = (...as223) => as223.length === 1 ? of6(as223[0]) : unsafeFromNonEmptyArray5(as223);
var of6 = (a23) => makeChunk5({
  _tag: "ISingleton",
  a: a23
});
var copyToArray5 = (self2, array33, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy6(self2.backing.array, 0, array33, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray5(self2.left, array33, initial);
      copyToArray5(self2.right, array33, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array33[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i23 = 0;
      let j23 = initial;
      while (i23 < self2.length) {
        array33[j23] = unsafeGet25(self2, i23);
        i23 += 1;
        j23 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray5 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray5;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray5(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty25;
      self2.right = _empty25;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse25 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk5({
        _tag: "IArray",
        array: reverse7(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk5({
        _tag: "IConcat",
        left: reverse25(self2.backing.right),
        right: reverse25(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray5(reverse7(toReadonlyArray5(self2)));
  }
};
var unsafeFromArray5 = (self2) => makeChunk5({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray5 = (self2) => unsafeFromArray5(self2);
var unsafeGet25 = /* @__PURE__ */ dual24(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet25(self2.left, index) : unsafeGet25(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet25(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend7 = /* @__PURE__ */ dual24(2, (self2, elem) => appendAll6(of6(elem), self2));
var drop6 = /* @__PURE__ */ dual24(2, (self2, n23) => {
  if (n23 <= 0) {
    return self2;
  } else if (n23 >= self2.length) {
    return _empty25;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk5({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n23,
          length: self2.backing.length - n23
        });
      }
      case "IConcat": {
        if (n23 > self2.left.length) {
          return drop6(self2.right, n23 - self2.left.length);
        }
        return makeChunk5({
          _tag: "IConcat",
          left: drop6(self2.left, n23),
          right: self2.right
        });
      }
      default: {
        return makeChunk5({
          _tag: "ISlice",
          chunk: self2,
          offset: n23,
          length: self2.length - n23
        });
      }
    }
  }
});
var appendAll6 = /* @__PURE__ */ dual24(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff23 = that.depth - self2.depth;
  if (Math.abs(diff23) <= 1) {
    return makeChunk5({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff23 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll6(self2.right, that);
      return makeChunk5({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll6(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk5({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk5({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk5({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk5({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll6(self2, that.left);
      return makeChunk5({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll6(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk5({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk5({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk5({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk5({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty6 = (self2) => self2.length === 0;
var isNonEmpty5 = (self2) => self2.length > 0;
var unsafeHead5 = (self2) => unsafeGet25(self2, 0);
var headNonEmpty6 = unsafeHead5;
var tailNonEmpty6 = (self2) => drop6(self2, 1);
var SIZE5 = 5;
var BUCKET_SIZE5 = /* @__PURE__ */ Math.pow(2, SIZE5);
var MASK5 = BUCKET_SIZE5 - 1;
var MAX_INDEX_NODE5 = BUCKET_SIZE5 / 2;
var MIN_ARRAY_NODE5 = BUCKET_SIZE5 / 4;
function popcount5(x23) {
  x23 -= x23 >> 1 & 1431655765;
  x23 = (x23 & 858993459) + (x23 >> 2 & 858993459);
  x23 = x23 + (x23 >> 4) & 252645135;
  x23 += x23 >> 8;
  x23 += x23 >> 16;
  return x23 & 127;
}
function hashFragment5(shift3, h23) {
  return h23 >>> shift3 & MASK5;
}
function toBitmap5(x23) {
  return 1 << x23;
}
function fromBitmap5(bitmap, bit) {
  return popcount5(bitmap & bit - 1);
}
var make55 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate5(mutate23, at, v23, arr) {
  let out = arr;
  if (!mutate23) {
    const len = arr.length;
    out = new Array(len);
    for (let i23 = 0; i23 < len; ++i23) out[i23] = arr[i23];
  }
  out[at] = v23;
  return out;
}
function arraySpliceOut5(mutate23, at, arr) {
  const newLen = arr.length - 1;
  let i23 = 0;
  let g23 = 0;
  let out = arr;
  if (mutate23) {
    i23 = g23 = at;
  } else {
    out = new Array(newLen);
    while (i23 < at) out[g23++] = arr[i23++];
  }
  ++i23;
  while (i23 <= newLen) out[g23++] = arr[i23++];
  if (mutate23) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn5(mutate23, at, v23, arr) {
  const len = arr.length;
  if (mutate23) {
    let i222 = len;
    while (i222 >= at) arr[i222--] = arr[i222];
    arr[at] = v23;
    return arr;
  }
  let i23 = 0, g23 = 0;
  const out = new Array(len + 1);
  while (i23 < at) out[g23++] = arr[i23++];
  out[at] = v23;
  while (i23 < len) out[++g23] = arr[i23++];
  return out;
}
var EmptyNode5 = class _EmptyNode5 {
  _tag = "EmptyNode";
  modify(edit, _shift, f23, hash223, key, size43) {
    const v23 = f23(none224());
    if (isNone224(v23)) return new _EmptyNode5();
    ++size43.value;
    return new LeafNode5(edit, hash223, key, v23);
  }
};
function isEmptyNode5(a23) {
  return isTagged7(a23, "EmptyNode");
}
function isLeafNode5(node) {
  return isEmptyNode5(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode5(node, edit) {
  return isEmptyNode5(node) ? false : edit === node.edit;
}
var LeafNode5 = class _LeafNode5 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash223, key, value) {
    this.edit = edit;
    this.hash = hash223;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift3, f23, hash223, key, size43) {
    if (equals24(key, this.key)) {
      const v222 = f23(this.value);
      if (v222 === this.value) return this;
      else if (isNone224(v222)) {
        --size43.value;
        return new EmptyNode5();
      }
      if (canEditNode5(this, edit)) {
        this.value = v222;
        return this;
      }
      return new _LeafNode5(edit, hash223, key, v222);
    }
    const v23 = f23(none224());
    if (isNone224(v23)) return this;
    ++size43.value;
    return mergeLeaves5(edit, shift3, this.hash, this, hash223, new _LeafNode5(edit, hash223, key, v23));
  }
};
var CollisionNode5 = class _CollisionNode5 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash223, children) {
    this.edit = edit;
    this.hash = hash223;
    this.children = children;
  }
  modify(edit, shift3, f23, hash223, key, size43) {
    if (hash223 === this.hash) {
      const canEdit = canEditNode5(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f23, key, size43);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode5(edit, this.hash, list) : list[0];
    }
    const v23 = f23(none224());
    if (isNone224(v23)) return this;
    ++size43.value;
    return mergeLeaves5(edit, shift3, this.hash, this, hash223, new LeafNode5(edit, hash223, key, v23));
  }
  updateCollisionList(mutate23, edit, hash223, list, f23, key, size43) {
    const len = list.length;
    for (let i23 = 0; i23 < len; ++i23) {
      const child = list[i23];
      if ("key" in child && equals24(key, child.key)) {
        const value = child.value;
        const newValue2 = f23(value);
        if (newValue2 === value) return list;
        if (isNone224(newValue2)) {
          --size43.value;
          return arraySpliceOut5(mutate23, i23, list);
        }
        return arrayUpdate5(mutate23, i23, new LeafNode5(edit, hash223, key, newValue2), list);
      }
    }
    const newValue = f23(none224());
    if (isNone224(newValue)) return list;
    ++size43.value;
    return arrayUpdate5(mutate23, len, new LeafNode5(edit, hash223, key, newValue), list);
  }
};
var IndexedNode5 = class _IndexedNode5 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift3, f23, hash223, key, size43) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment5(shift3, hash223);
    const bit = toBitmap5(frag);
    const indx = fromBitmap5(mask, bit);
    const exists223 = mask & bit;
    const canEdit = canEditNode5(this, edit);
    if (!exists223) {
      const _newChild = new EmptyNode5().modify(edit, shift3 + SIZE5, f23, hash223, key, size43);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE5 ? expand5(edit, frag, _newChild, mask, children) : new _IndexedNode5(edit, mask | bit, arraySpliceIn5(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift3 + SIZE5, f23, hash223, key, size43);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode5(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode5();
      if (children.length <= 2 && isLeafNode5(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut5(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate5(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode5(edit, bitmap, newChildren);
  }
};
var ArrayNode5 = class _ArrayNode5 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size43, children) {
    this.edit = edit;
    this.size = size43;
    this.children = children;
  }
  modify(edit, shift3, f23, hash223, key, size43) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment5(shift3, hash223);
    const child = children[frag];
    const newChild = (child || new EmptyNode5()).modify(edit, shift3 + SIZE5, f23, hash223, key, size43);
    if (child === newChild) return this;
    const canEdit = canEditNode5(this, edit);
    let newChildren;
    if (isEmptyNode5(child) && !isEmptyNode5(newChild)) {
      ++count;
      newChildren = arrayUpdate5(canEdit, frag, newChild, children);
    } else if (!isEmptyNode5(child) && isEmptyNode5(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE5) {
        return pack5(edit, count, frag, children);
      }
      newChildren = arrayUpdate5(canEdit, frag, new EmptyNode5(), children);
    } else {
      newChildren = arrayUpdate5(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode5(edit, count, newChildren);
  }
};
function pack5(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g23 = 0;
  let bitmap = 0;
  for (let i23 = 0, len = elements.length; i23 < len; ++i23) {
    if (i23 !== removed) {
      const elem = elements[i23];
      if (elem && !isEmptyNode5(elem)) {
        children[g23++] = elem;
        bitmap |= 1 << i23;
      }
    }
  }
  return new IndexedNode5(edit, bitmap, children);
}
function expand5(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i23 = 0; bit; ++i23) {
    if (bit & 1) arr[i23] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode5(edit, count + 1, arr);
}
function mergeLeavesInner5(edit, shift3, h1, n1, h23, n23) {
  if (h1 === h23) return new CollisionNode5(edit, h1, [n23, n1]);
  const subH1 = hashFragment5(shift3, h1);
  const subH2 = hashFragment5(shift3, h23);
  if (subH1 === subH2) {
    return (child) => new IndexedNode5(edit, toBitmap5(subH1) | toBitmap5(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n23] : [n23, n1];
    return new IndexedNode5(edit, toBitmap5(subH1) | toBitmap5(subH2), children);
  }
}
function mergeLeaves5(edit, shift3, h1, n1, h23, n23) {
  let stack = void 0;
  let currentShift = shift3;
  while (true) {
    const res = mergeLeavesInner5(edit, currentShift, h1, n1, h23, n23);
    if (typeof res === "function") {
      stack = make55(res, stack);
      currentShift = currentShift + SIZE5;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey5 = "effect/HashMap";
var HashMapTypeId5 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey5);
var HashMapProto5 = {
  [HashMapTypeId5]: HashMapTypeId5,
  [Symbol.iterator]() {
    return new HashMapIterator5(this, (k23, v23) => [k23, v23]);
  },
  [symbol34]() {
    let hash223 = hash24(HashMapSymbolKey5);
    for (const item of this) {
      hash223 ^= pipe24(hash24(item[0]), combine25(hash24(item[1])));
    }
    return cached24(this, hash223);
  },
  [symbol224](that) {
    if (isHashMap5(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe24(that, getHash5(item[0], hash24(item[0])));
        if (isNone224(elem)) {
          return false;
        } else {
          if (!equals24(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format24(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON24)
    };
  },
  [NodeInspectSymbol24]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments24(this, arguments);
  }
};
var makeImpl6 = (editable, edit, root, size43) => {
  const map63 = Object.create(HashMapProto5);
  map63._editable = editable;
  map63._edit = edit;
  map63._root = root;
  map63._size = size43;
  return map63;
};
var HashMapIterator5 = class _HashMapIterator5 {
  map;
  f;
  v;
  constructor(map63, f23) {
    this.map = map63;
    this.f = f23;
    this.v = visitLazy5(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone224(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont5(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator5(this.map, this.f);
  }
};
var applyCont5 = (cont) => cont ? visitLazyChildren5(cont[0], cont[1], cont[2], cont[3], cont[4]) : none224();
var visitLazy5 = (node, f23, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome224(node.value)) {
        return some324({
          value: f23(node.key, node.value.value),
          cont
        });
      }
      return applyCont5(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren5(children.length, children, 0, f23, cont);
    }
    default: {
      return applyCont5(cont);
    }
  }
};
var visitLazyChildren5 = (len, children, i23, f23, cont) => {
  while (i23 < len) {
    const child = children[i23++];
    if (child && !isEmptyNode5(child)) {
      return visitLazy5(child, f23, [len, children, i23, f23, cont]);
    }
  }
  return applyCont5(cont);
};
var _empty35 = /* @__PURE__ */ makeImpl6(false, 0, /* @__PURE__ */ new EmptyNode5(), 0);
var empty45 = () => _empty35;
var isHashMap5 = (u23) => hasProperty24(u23, HashMapTypeId5);
var getHash5 = /* @__PURE__ */ dual24(3, (self2, key, hash223) => {
  let node = self2._root;
  let shift3 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals24(key, node.key) ? node.value : none224();
      }
      case "CollisionNode": {
        if (hash223 === node.hash) {
          const children = node.children;
          for (let i23 = 0, len = children.length; i23 < len; ++i23) {
            const child = children[i23];
            if ("key" in child && equals24(key, child.key)) {
              return child.value;
            }
          }
        }
        return none224();
      }
      case "IndexedNode": {
        const frag = hashFragment5(shift3, hash223);
        const bit = toBitmap5(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap5(node.mask, bit)];
          shift3 += SIZE5;
          break;
        }
        return none224();
      }
      case "ArrayNode": {
        node = node.children[hashFragment5(shift3, hash223)];
        if (node) {
          shift3 += SIZE5;
          break;
        }
        return none224();
      }
      default:
        return none224();
    }
  }
});
var set24 = /* @__PURE__ */ dual24(3, (self2, key, value) => modifyAt5(self2, key, () => some324(value)));
var setTree5 = /* @__PURE__ */ dual24(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl6(self2._editable, self2._edit, newRoot, newSize);
});
var keys7 = (self2) => new HashMapIterator5(self2, (key) => key);
var size8 = (self2) => self2._size;
var beginMutation6 = (self2) => makeImpl6(true, self2._edit + 1, self2._root, self2._size);
var modifyAt5 = /* @__PURE__ */ dual24(3, (self2, key, f23) => modifyHash5(self2, key, hash24(key), f23));
var modifyHash5 = /* @__PURE__ */ dual24(4, (self2, key, hash223, f23) => {
  const size43 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f23, hash223, key, size43);
  return pipe24(self2, setTree5(newRoot, size43.value));
});
var forEach8 = /* @__PURE__ */ dual24(2, (self2, f23) => reduce25(self2, void 0, (_23, value, key) => f23(value, key)));
var reduce25 = /* @__PURE__ */ dual24(3, (self2, zero, f23) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome224(root.value) ? f23(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i23 = 0, len = children.length; i23 < len; ) {
      const child = children[i23++];
      if (child && !isEmptyNode5(child)) {
        if (child._tag === "LeafNode") {
          if (isSome224(child.value)) {
            zero = f23(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey5 = "effect/HashSet";
var HashSetTypeId5 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey5);
var HashSetProto5 = {
  [HashSetTypeId5]: HashSetTypeId5,
  [Symbol.iterator]() {
    return keys7(this._keyMap);
  },
  [symbol34]() {
    return cached24(this, combine25(hash24(this._keyMap))(hash24(HashSetSymbolKey5)));
  },
  [symbol224](that) {
    if (isHashSet5(that)) {
      return size8(this._keyMap) === size8(that._keyMap) && equals24(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format24(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON24)
    };
  },
  [NodeInspectSymbol24]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments24(this, arguments);
  }
};
var makeImpl25 = (keyMap) => {
  const set223 = Object.create(HashSetProto5);
  set223._keyMap = keyMap;
  return set223;
};
var isHashSet5 = (u23) => hasProperty24(u23, HashSetTypeId5);
var _empty45 = /* @__PURE__ */ makeImpl25(/* @__PURE__ */ empty45());
var empty55 = () => _empty45;
var size25 = (self2) => size8(self2._keyMap);
var beginMutation25 = (self2) => makeImpl25(beginMutation6(self2._keyMap));
var endMutation5 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate5 = /* @__PURE__ */ dual24(2, (self2, f23) => {
  const transient = beginMutation25(self2);
  f23(transient);
  return endMutation5(transient);
});
var add25 = /* @__PURE__ */ dual24(2, (self2, value) => self2._keyMap._editable ? (set24(value, true)(self2._keyMap), self2) : makeImpl25(set24(value, true)(self2._keyMap)));
var union25 = /* @__PURE__ */ dual24(2, (self2, that) => mutate5(empty55(), (set223) => {
  forEach25(self2, (value) => add25(set223, value));
  for (const value of that) {
    add25(set223, value);
  }
}));
var forEach25 = /* @__PURE__ */ dual24(2, (self2, f23) => forEach8(self2._keyMap, (_23, k23) => f23(k23)));
var empty65 = empty55;
var size35 = size25;
var add35 = add25;
var union35 = union25;
var ArrayProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol34]() {
    return cached24(this, array9(this));
  },
  [symbol224](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v23, i23) => equals24(v23, that[i23]));
    } else {
      return false;
    }
  }
});
var Structural6 = /* @__PURE__ */ function() {
  function Structural33(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural33.prototype = StructuralPrototype24;
  return Structural33;
}();
var struct25 = (as223) => Object.assign(Object.create(StructuralPrototype24), as223);
var ContextPatchTypeId5 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance6(a23) {
  return a23;
}
var PatchProto5 = {
  ...Structural6.prototype,
  [ContextPatchTypeId5]: {
    _Value: variance6,
    _Patch: variance6
  }
};
var EmptyProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto5), {
  _tag: "Empty"
});
var _empty55 = /* @__PURE__ */ Object.create(EmptyProto5);
var empty75 = () => _empty55;
var AndThenProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto5), {
  _tag: "AndThen"
});
var makeAndThen5 = (first, second) => {
  const o23 = Object.create(AndThenProto5);
  o23.first = first;
  o23.second = second;
  return o23;
};
var AddServiceProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto5), {
  _tag: "AddService"
});
var makeAddService5 = (key, service) => {
  const o23 = Object.create(AddServiceProto5);
  o23.key = key;
  o23.service = service;
  return o23;
};
var RemoveServiceProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto5), {
  _tag: "RemoveService"
});
var makeRemoveService5 = (key) => {
  const o23 = Object.create(RemoveServiceProto5);
  o23.key = key;
  return o23;
};
var UpdateServiceProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto5), {
  _tag: "UpdateService"
});
var makeUpdateService5 = (key, update23) => {
  const o23 = Object.create(UpdateServiceProto5);
  o23.key = key;
  o23.update = update23;
  return o23;
};
var diff5 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch23 = empty75();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals24(old, newService)) {
        patch23 = combine224(makeUpdateService5(tag, () => newService))(patch23);
      }
    } else {
      missingServices.delete(tag);
      patch23 = combine224(makeAddService5(tag, newService))(patch23);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch23 = combine224(makeRemoveService5(tag))(patch23);
  }
  return patch23;
};
var combine224 = /* @__PURE__ */ dual24(2, (self2, that) => makeAndThen5(self2, that));
var patch5 = /* @__PURE__ */ dual24(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of6(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty5(patches)) {
    const head23 = headNonEmpty6(patches);
    const tail4 = tailNonEmpty6(patches);
    switch (head23._tag) {
      case "Empty": {
        patches = tail4;
        break;
      }
      case "AddService": {
        updatedContext.set(head23.key, head23.service);
        patches = tail4;
        break;
      }
      case "AndThen": {
        patches = prepend7(prepend7(tail4, head23.second), head23.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head23.key);
        patches = tail4;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head23.key, head23.update(updatedContext.get(head23.key)));
        wasServiceUpdated = true;
        patches = tail4;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext5(updatedContext);
  }
  const map63 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map63.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s23] of updatedContext) {
    map63.set(tag, s23);
  }
  return makeContext5(map63);
});
var DifferTypeId5 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto5 = {
  [DifferTypeId5]: {
    _P: identity24,
    _V: identity24
  }
};
var make75 = (params) => {
  const differ = Object.create(DifferProto5);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment5 = () => make75({
  empty: empty75(),
  combine: (first, second) => combine224(second)(first),
  diff: (oldValue, newValue) => diff5(oldValue, newValue),
  patch: (patch23, oldValue) => patch5(oldValue)(patch23)
});
var OP_DIE5 = "Die";
var OP_EMPTY5 = "Empty";
var OP_FAIL5 = "Fail";
var OP_INTERRUPT5 = "Interrupt";
var OP_PARALLEL5 = "Parallel";
var OP_SEQUENTIAL5 = "Sequential";
var CauseSymbolKey5 = "effect/Cause";
var CauseTypeId5 = /* @__PURE__ */ Symbol.for(CauseSymbolKey5);
var variance25 = {
  /* c8 ignore next */
  _E: (_23) => _23
};
var proto5 = {
  [CauseTypeId5]: variance25,
  [symbol34]() {
    return pipe24(hash24(CauseSymbolKey5), combine25(hash24(flattenCause5(this))), cached24(this));
  },
  [symbol224](that) {
    return isCause5(that) && causeEquals5(this, that);
  },
  pipe() {
    return pipeArguments24(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON24(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON24(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON24(this.left),
          right: toJSON24(this.right)
        };
    }
  },
  toString() {
    return pretty5(this);
  },
  [NodeInspectSymbol24]() {
    return this.toJSON();
  }
};
var fail6 = (error) => {
  const o23 = Object.create(proto5);
  o23._tag = OP_FAIL5;
  o23.error = error;
  return o23;
};
var parallel5 = (left33, right33) => {
  const o23 = Object.create(proto5);
  o23._tag = OP_PARALLEL5;
  o23.left = left33;
  o23.right = right33;
  return o23;
};
var sequential5 = (left33, right33) => {
  const o23 = Object.create(proto5);
  o23._tag = OP_SEQUENTIAL5;
  o23.left = left33;
  o23.right = right33;
  return o23;
};
var isCause5 = (u23) => hasProperty24(u23, CauseTypeId5);
var isInterruptedOnly5 = (self2) => reduceWithContext5(void 0, IsInterruptedOnlyCauseReducer5)(self2);
var causeEquals5 = (left33, right33) => {
  let leftStack = of6(left33);
  let rightStack = of6(right33);
  while (isNonEmpty5(leftStack) && isNonEmpty5(rightStack)) {
    const [leftParallel, leftSequential] = pipe24(headNonEmpty6(leftStack), reduce45([empty65(), empty35()], ([parallel23, sequential23], cause) => {
      const [par, seq] = evaluateCause5(cause);
      return some324([pipe24(parallel23, union35(par)), pipe24(sequential23, appendAll6(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe24(headNonEmpty6(rightStack), reduce45([empty65(), empty35()], ([parallel23, sequential23], cause) => {
      const [par, seq] = evaluateCause5(cause);
      return some324([pipe24(parallel23, union35(par)), pipe24(sequential23, appendAll6(seq))]);
    }));
    if (!equals24(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause5 = (cause) => {
  return flattenCauseLoop5(of6(cause), empty35());
};
var flattenCauseLoop5 = (causes, flattened) => {
  while (1) {
    const [parallel23, sequential23] = pipe24(causes, reduce9([empty65(), empty35()], ([parallel33, sequential33], cause) => {
      const [par, seq] = evaluateCause5(cause);
      return [pipe24(parallel33, union35(par)), pipe24(sequential33, appendAll6(seq))];
    }));
    const updated = size35(parallel23) > 0 ? pipe24(flattened, prepend7(parallel23)) : flattened;
    if (isEmpty6(sequential23)) {
      return reverse25(updated);
    }
    causes = sequential23;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage24("Cause.flattenCauseLoop"));
};
var evaluateCause5 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty65();
  let _sequential = empty35();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY5: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL5: {
        _parallel = add35(_parallel, make424(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE5: {
        _parallel = add35(_parallel, make424(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT5: {
        _parallel = add35(_parallel, make424(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL5: {
        switch (cause.left._tag) {
          case OP_EMPTY5: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL5: {
            cause = sequential5(cause.left.left, sequential5(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL5: {
            cause = parallel5(sequential5(cause.left.left, cause.right), sequential5(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend7(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL5: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage24("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer5 = {
  emptyCase: constTrue24,
  failCase: constFalse24,
  dieCase: constFalse24,
  interruptCase: constTrue24,
  sequentialCase: (_23, left33, right33) => left33 && right33,
  parallelCase: (_23, left33, right33) => left33 && right33
};
var OP_SEQUENTIAL_CASE5 = "SequentialCase";
var OP_PARALLEL_CASE5 = "ParallelCase";
var reduce45 = /* @__PURE__ */ dual24(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome224(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL5: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL5: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext5 = /* @__PURE__ */ dual24(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY5: {
        output.push(right224(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL5: {
        output.push(right224(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE5: {
        output.push(right224(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT5: {
        output.push(right224(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL5: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left224({
          _tag: OP_SEQUENTIAL_CASE5
        }));
        break;
      }
      case OP_PARALLEL5: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left224({
          _tag: OP_PARALLEL_CASE5
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE5: {
            const left33 = accumulator.pop();
            const right33 = accumulator.pop();
            const value = reducer.sequentialCase(context, left33, right33);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE5: {
            const left33 = accumulator.pop();
            const right33 = accumulator.pop();
            const value = reducer.parallelCase(context, left33, right33);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty5 = (cause) => {
  if (isInterruptedOnly5(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors5(cause).map((e23) => e23.stack).join("\n");
};
var PrettyError5 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage5(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol6 in originalError) {
        this.span = originalError[spanSymbol6];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack5(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage5 = (u23) => {
  if (typeof u23 === "string") {
    return `Error: ${u23}`;
  }
  try {
    if (hasProperty24(u23, "toString") && isFunction324(u23["toString"]) && u23["toString"] !== Object.prototype.toString && u23["toString"] !== globalThis.Array.prototype.toString) {
      return u23["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u23)}`;
};
var locationRegex5 = /\((.*)\)/;
var spanToTrace5 = /* @__PURE__ */ globalValue24("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack5 = (message, stack, span3) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i23 = 1; i23 < lines.length; i23++) {
    if (lines[i23].includes("Generator.next")) {
      break;
    }
    if (lines[i23].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i23].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span3) {
    let current = span3;
    let i23 = 0;
    while (current && current._tag === "Span" && i23 < 10) {
      const stackFn = spanToTrace5.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex5);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined24(current.parent);
      i23++;
    }
  }
  return out.join("\n");
};
var spanSymbol6 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors5 = (cause) => reduceWithContext5(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_23, unknownError) => {
    return [new PrettyError5(unknownError)];
  },
  failCase: (_23, error) => {
    return [new PrettyError5(error)];
  },
  interruptCase: () => [],
  parallelCase: (_23, l23, r23) => [...l23, ...r23],
  sequentialCase: (_23, l23, r23) => [...l23, ...r23]
});
var SingleShotGen224 = class _SingleShotGen24 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a23) {
    return this.called ? {
      value: a23,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a23) {
    return {
      value: a23,
      done: true
    };
  }
  throw(e23) {
    throw e23;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen24(this.self);
  }
};
var spanTag5 = /* @__PURE__ */ GenericTag5("effect/ParentSpan");
var EffectTypeId224 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive5 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId224] = effectVariance24;
  constructor(_op) {
    this._op = _op;
  }
  [symbol224](that) {
    return this === that;
  }
  [symbol34]() {
    return cached24(this, random24(this));
  }
  pipe() {
    return pipeArguments24(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON24(this.effect_instruction_i0),
      effect_instruction_i1: toJSON24(this.effect_instruction_i1),
      effect_instruction_i2: toJSON24(this.effect_instruction_i2)
    };
  }
  toString() {
    return format24(this.toJSON());
  }
  [NodeInspectSymbol24]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen224(new YieldWrap24(this));
  }
};
var EffectPrimitiveFailure5 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId224] = effectVariance24;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol224](that) {
    return exitIsExit5(that) && that._op === "Failure" && // @ts-expect-error
    equals24(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol34]() {
    return pipe24(
      // @ts-expect-error
      string24(this._tag),
      // @ts-expect-error
      combine25(hash24(this.effect_instruction_i0)),
      cached24(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments24(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format24(this.toJSON());
  }
  [NodeInspectSymbol24]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen224(new YieldWrap24(this));
  }
};
var isEffect5 = (u23) => hasProperty24(u23, EffectTypeId224);
var withFiberRuntime5 = (withRuntime) => {
  const effect = new EffectPrimitive5(OP_WITH_RUNTIME5);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol25 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol5 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture5 = (obj, span3) => {
  if (isSome224(span3)) {
    return new Proxy(obj, {
      has(target, p23) {
        return p23 === spanSymbol25 || p23 === originalSymbol5 || p23 in target;
      },
      get(target, p23) {
        if (p23 === spanSymbol25) {
          return span3.value;
        }
        if (p23 === originalSymbol5) {
          return obj;
        }
        return target[p23];
      }
    });
  }
  return obj;
};
var fail25 = (error) => isObject24(error) && !(spanSymbol25 in error) ? withFiberRuntime5((fiber) => failCause5(fail6(capture5(error, currentSpanFromFiber5(fiber))))) : failCause5(fail6(error));
var failCause5 = (cause) => {
  const effect = new EffectPrimitiveFailure5(OP_FAILURE5);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey5 = "effect/FiberRef";
var FiberRefTypeId5 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey5);
var fiberRefVariance5 = {
  /* c8 ignore next */
  _A: (_23) => _23
};
var fiberRefUnsafeMakeContext5 = (initial) => {
  const differ = environment5();
  return fiberRefUnsafeMakePatch5(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch5 = (initial, options) => ({
  [FiberRefTypeId5]: fiberRefVariance5,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch23) => (oldValue) => options.differ.patch(patch23, oldValue),
  fork: options.fork,
  join: options.join ?? ((_23, n23) => n23),
  pipe() {
    return pipeArguments24(this, arguments);
  }
});
var currentContext5 = /* @__PURE__ */ globalValue24(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext5(empty25()));
var YieldableError5 = /* @__PURE__ */ function() {
  class YieldableError23 extends globalThis.Error {
    commit() {
      return fail25(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol24]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError23.prototype, StructuralCommitPrototype24);
  return YieldableError23;
}();
var exitIsExit5 = (u23) => isEffect5(u23) && "_tag" in u23 && (u23._tag === "Success" || u23._tag === "Failure");
var currentSpanFromFiber5 = (fiber) => {
  const span3 = fiber.getFiberRef(currentContext5).unsafeMap.get(spanTag5.key);
  return span3 !== void 0 && span3._tag === "Span" ? some324(span3) : none224();
};
var Data_exports24 = {};
__export24(Data_exports24, {
  Class: () => Class25,
  Error: () => Error25,
  Structural: () => Structural25,
  TaggedClass: () => TaggedClass5,
  TaggedError: () => TaggedError5,
  array: () => array25,
  case: () => _case5,
  struct: () => struct35,
  tagged: () => tagged5,
  taggedEnum: () => taggedEnum5,
  tuple: () => tuple25,
  unsafeArray: () => unsafeArray5,
  unsafeStruct: () => unsafeStruct5
});
var struct35 = struct25;
var unsafeStruct5 = (as223) => Object.setPrototypeOf(as223, StructuralPrototype24);
var tuple25 = (...as223) => unsafeArray5(as223);
var array25 = (as223) => unsafeArray5(as223.slice(0));
var unsafeArray5 = (as223) => Object.setPrototypeOf(as223, ArrayProto5);
var _case5 = () => (args) => args === void 0 ? Object.create(StructuralPrototype24) : struct35(args);
var tagged5 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype24) : struct35(args);
  value._tag = tag;
  return value;
};
var Class25 = Structural6;
var TaggedClass5 = (tag) => {
  class Base extends Class25 {
    _tag = tag;
  }
  return Base;
};
var Structural25 = Structural6;
var taggedEnum5 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged7;
    } else if (tag === "$match") {
      return taggedMatch5;
    }
    return tagged5(tag);
  }
});
function taggedMatch5() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error25 = /* @__PURE__ */ function() {
  return class Base extends YieldableError5 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError5 = (tag) => {
  class Base extends Error25 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp5 = Function_exports24.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType5.Program) return Option_exports24.none();
  return predicate(parent) ? Option_exports24.some(parent) : traverseUp5(parent, predicate);
});
var traverseUpGuard5 = Function_exports24.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType5.Program) return Option_exports24.none();
  return predicate(parent) ? Option_exports24.some(parent) : traverseUpGuard5(parent, predicate);
});
var ESLintCommunityESLintUtils5;
((ESLintCommunityESLintUtils23) => {
  ESLintCommunityESLintUtils23.getFunctionHeadLocation = getFunctionHeadLocation5;
  ESLintCommunityESLintUtils23.getFunctionNameWithKind = getFunctionNameWithKind5;
  ESLintCommunityESLintUtils23.getPropertyName = getPropertyName5;
  ESLintCommunityESLintUtils23.getStaticValue = getStaticValue6;
  ESLintCommunityESLintUtils23.getStringIfConstant = getStringIfConstant5;
  ESLintCommunityESLintUtils23.hasSideEffect = hasSideEffect5;
  ESLintCommunityESLintUtils23.isParenthesized = isParenthesized5;
})(ESLintCommunityESLintUtils5 || (ESLintCommunityESLintUtils5 = {}));
var Construction5 = Data_exports24.taggedEnum();
Construction5.None();
a4({
  type: N5.union([NodeType5.FunctionExpression, NodeType5.ArrowFunctionExpression]),
  parent: {
    type: NodeType5.Property,
    parent: {
      type: NodeType5.ObjectExpression
    }
  }
});
a4({
  type: N5.union([NodeType5.FunctionExpression, NodeType5.ArrowFunctionExpression]),
  parent: {
    type: NodeType5.MethodDefinition,
    parent: {
      type: NodeType5.ClassBody
    }
  }
});
a4({
  type: N5.union([NodeType5.FunctionExpression, NodeType5.ArrowFunctionExpression]),
  parent: {
    type: NodeType5.Property,
    parent: {
      type: NodeType5.ClassBody
    }
  }
});
function isInitExpression(node) {
  return node.type !== NodeType5.VariableDeclaration;
}
function getVariableInitExpression(at) {
  return (variable) => {
    return Function_exports7.pipe(
      Option_exports7.some(variable),
      Option_exports7.flatMapNullable((v23) => v23.defs.at(at)),
      Option_exports7.flatMap(
        (d23) => "init" in d23.node ? Option_exports7.fromNullable(d23.node.init) : Option_exports7.none()
      ),
      Option_exports7.filter(isInitExpression)
    );
  };
}
var RULE_NAME23 = "no-leaked-conditional-rendering";
var allowedVariants = [
  "nullish",
  "boolean",
  "string",
  "falsy string",
  "truthy boolean",
  "truthy string"
];
function inspectVariantTypes(types) {
  const variantTypes = /* @__PURE__ */ new Set();
  if (types.some((type) => tsutils.isTypeFlagSet(type, ts.TypeFlags.Null | ts.TypeFlags.Undefined | ts.TypeFlags.VoidLike))) {
    variantTypes.add("nullish");
  }
  const booleans = types.filter((type) => tsutils.isTypeFlagSet(type, ts.TypeFlags.BooleanLike));
  switch (true) {
    case (booleans.length === 1 && !!booleans[0]): {
      const [first] = booleans;
      Function_exports6.pipe(
        $(first).when(tsutils.isTrueLiteralType, () => Option_exports6.some("truthy boolean")).when(tsutils.isFalseLiteralType, () => Option_exports6.some("falsy boolean")).otherwise(Option_exports6.none),
        Option_exports6.map((v5) => variantTypes.add(v5))
      );
      break;
    }
    case booleans.length === 2: {
      variantTypes.add("boolean");
      break;
    }
  }
  const strings = types.filter((type) => tsutils.isTypeFlagSet(type, ts.TypeFlags.StringLike));
  if (strings.length > 0) {
    const evaluated = $(strings).when(
      (types2) => types2.every((type) => type.isStringLiteral() && type.value !== ""),
      Function_exports6.constant("truthy string")
    ).when(
      (types2) => types2.every((type) => type.isStringLiteral() && type.value === ""),
      Function_exports6.constant("falsy string")
    ).otherwise(Function_exports6.constant("string"));
    variantTypes.add(evaluated);
  }
  const numbers = types.filter(
    (type) => tsutils.isTypeFlagSet(
      type,
      ts.TypeFlags.NumberLike | ts.TypeFlags.BigIntLike
    )
  );
  if (numbers.length > 0) {
    const evaluated = $(numbers).when(
      (types2) => types2.every((type) => type.isNumberLiteral() && type.value !== 0),
      Function_exports6.constant("truthy number")
    ).when(
      (types2) => types2.every((type) => type.isNumberLiteral() && type.value === 0),
      Function_exports6.constant("falsy number")
    ).otherwise(Function_exports6.constant("number"));
    variantTypes.add(evaluated);
  }
  if (types.some((type) => tsutils.isTypeFlagSet(type, ts.TypeFlags.EnumLike))) {
    variantTypes.add("enum");
  }
  if (types.some(
    (type) => !tsutils.isTypeFlagSet(
      type,
      ts.TypeFlags.Null | ts.TypeFlags.Undefined | ts.TypeFlags.VoidLike | ts.TypeFlags.BooleanLike | ts.TypeFlags.StringLike | ts.TypeFlags.NumberLike | ts.TypeFlags.BigIntLike | ts.TypeFlags.TypeParameter | ts.TypeFlags.Any | ts.TypeFlags.Unknown | ts.TypeFlags.Never
    )
  )) {
    variantTypes.add("object");
  }
  if (types.some(
    (type) => tsutils.isTypeFlagSet(
      type,
      ts.TypeFlags.TypeParameter | ts.TypeFlags.Any | ts.TypeFlags.Unknown
    )
  )) {
    variantTypes.add("any");
  }
  if (types.some((type) => tsutils.isTypeFlagSet(type, ts.TypeFlags.Never))) {
    variantTypes.add("never");
  }
  return variantTypes;
}
var no_leaked_conditional_rendering_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow problematic leaked values from being rendered",
      recommended: "recommended",
      requiresTypeChecking: true
    },
    messages: {
      NO_LEAKED_CONDITIONAL_RENDERING: "Potential leaked value that might cause unintentionally rendered values or rendering crashes"
    },
    schema: []
  },
  name: RULE_NAME23,
  create(context) {
    const services = ESLintUtils.getParserServices(context);
    function checkExpression(node) {
      return $(node).when(isJSX, Option_exports6.none).with({ type: NodeType3.LogicalExpression, operator: "&&" }, ({ left: left9, right: right9 }) => {
        const isLeftUnaryNot = a({
          type: NodeType3.UnaryExpression,
          operator: "!"
        }, left9);
        if (isLeftUnaryNot) return checkExpression(right9);
        const leftType = getConstrainedTypeAtLocation(services, left9);
        const leftTypeVariants = inspectVariantTypes(tsutils.unionTypeParts(leftType));
        const isLeftValid = Array.from(leftTypeVariants.values()).every((type) => allowedVariants.some((allowed) => allowed === type));
        if (isLeftValid) return checkExpression(right9);
        return Option_exports6.some({
          messageId: "NO_LEAKED_CONDITIONAL_RENDERING",
          node: left9
        });
      }).with({ type: NodeType3.ConditionalExpression }, ({ alternate, consequent }) => {
        return Option_exports6.orElse(checkExpression(consequent), () => checkExpression(alternate));
      }).with({ type: NodeType3.Identifier }, (n5) => {
        const initialScope = context.sourceCode.getScope(n5);
        return Function_exports6.pipe(
          findVariable5(n5.name, initialScope),
          Option_exports6.flatMap(getVariableInitExpression(0)),
          Option_exports6.flatMap(checkExpression)
        );
      }).otherwise(Option_exports6.none);
    }
    return {
      "JSXExpressionContainer > ConditionalExpression"(node) {
        Option_exports6.map(checkExpression(node), context.report);
      },
      "JSXExpressionContainer > LogicalExpression"(node) {
        Option_exports6.map(checkExpression(node), context.report);
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-missing-component-display-name.ts
var RULE_NAME24 = "no-missing-component-display-name";
var no_missing_component_display_name_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "require 'displayName' for memo and forwardRef components",
      requiresTypeChecking: false
    },
    messages: {
      NO_MISSING_COMPONENT_DISPLAY_NAME: "Add missing 'displayName' for component."
    },
    schema: []
  },
  name: RULE_NAME24,
  create(context) {
    const { ctx, listeners } = useComponentCollector(context);
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { displayName, flag, node: node2 } of components.values()) {
          const isMemoOrForwardRef = Boolean(flag & ERFunctionComponentFlag.ForwardRef) || Boolean(flag & ERFunctionComponentFlag.Memo);
          if (Option_exports6.isSome(getFunctionIdentifier(node2))) continue;
          if (!isMemoOrForwardRef) continue;
          if (Option_exports6.isNone(displayName)) {
            context.report({
              messageId: "NO_MISSING_COMPONENT_DISPLAY_NAME",
              node: node2
            });
          }
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-missing-key.ts
var RULE_NAME25 = "no-missing-key";
var no_missing_key_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "require 'key' prop when rendering list",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_MISSING_KEY: "Missing 'key' prop for element when rendering list",
      NO_MISSING_KEY_WITH_FRAGMENT: "Use fragment component instead of '<>' because it does not support key prop"
    },
    schema: []
  },
  name: RULE_NAME25,
  create(context) {
    const childrenToArraySelector = getChildrenToArraySelector();
    const isWithinChildrenToArrayRef = MutableRef_exports4.make(false);
    function checkIteratorElement(node) {
      const initialScope = context.sourceCode.getScope(node);
      if (node.type === NodeType3.JSXElement && !hasProp(node.openingElement.attributes, "key", context, initialScope)) {
        return Option_exports6.some({
          messageId: "NO_MISSING_KEY",
          node
        });
      }
      if (node.type === NodeType3.JSXFragment) {
        return Option_exports6.some({
          messageId: "NO_MISSING_KEY_WITH_FRAGMENT",
          node
        });
      }
      return Option_exports6.none();
    }
    function checkExpression(node) {
      return $(node).with({ type: NodeType3.JSXElement }, checkIteratorElement).with({ type: NodeType3.JSXFragment }, checkIteratorElement).with({ type: NodeType3.ConditionalExpression }, (n5) => {
        if (!("consequent" in n5)) return Option_exports6.none();
        return Option_exports6.orElse(checkIteratorElement(n5.consequent), () => checkIteratorElement(n5.alternate));
      }).with({ type: NodeType3.LogicalExpression }, (n5) => {
        if (!("left" in n5)) return Option_exports6.none();
        return Option_exports6.orElse(checkIteratorElement(n5.left), () => checkIteratorElement(n5.right));
      }).otherwise(Option_exports6.none);
    }
    function checkBlockStatement(node) {
      return getNestedReturnStatements(node).reduce((acc, statement) => {
        if (!statement.argument) return acc;
        const maybeDescriptor = checkIteratorElement(statement.argument);
        if (Option_exports6.isNone(maybeDescriptor)) return acc;
        const descriptor = maybeDescriptor.value;
        return [...acc, descriptor];
      }, []);
    }
    return {
      [`${childrenToArraySelector}:exit`]() {
        MutableRef_exports4.set(isWithinChildrenToArrayRef, false);
      },
      ArrayExpression(node) {
        if (MutableRef_exports4.get(isWithinChildrenToArrayRef)) return;
        const elements = node.elements.filter(is3(NodeType3.JSXElement));
        if (elements.length === 0) return;
        const initialScope = context.sourceCode.getScope(node);
        for (const element of elements) {
          if (!hasProp(element.openingElement.attributes, "key", context, initialScope)) {
            context.report({
              messageId: "NO_MISSING_KEY",
              node: element
            });
          }
        }
      },
      CallExpression(node) {
        const isMapCall2 = a({
          callee: {
            type: NodeType3.MemberExpression,
            property: {
              name: "map"
            }
          }
        }, node);
        const isArrayFromCall = a({
          type: NodeType3.CallExpression,
          callee: {
            type: NodeType3.MemberExpression,
            property: {
              name: "from"
            }
          }
        }, node);
        if (!isMapCall2 && !isArrayFromCall) return;
        if (MutableRef_exports4.get(isWithinChildrenToArrayRef)) return;
        const fn = node.arguments[isMapCall2 ? 0 : 1];
        if (!isOneOf3([NodeType3.ArrowFunctionExpression, NodeType3.FunctionExpression])(fn)) return;
        if (fn.body.type === NodeType3.BlockStatement) {
          for (const descriptor of checkBlockStatement(fn.body)) {
            context.report(descriptor);
          }
          return;
        }
        Option_exports6.map(checkExpression(fn.body), context.report);
      },
      JSXFragment(node) {
        if (MutableRef_exports4.get(isWithinChildrenToArrayRef)) return;
        if (node.parent.type === NodeType3.ArrayExpression) {
          context.report({
            messageId: "NO_MISSING_KEY_WITH_FRAGMENT",
            node
          });
        }
      },
      [childrenToArraySelector]() {
        MutableRef_exports4.set(isWithinChildrenToArrayRef, true);
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-nested-components.ts
var RULE_NAME26 = "no-nested-components";
var no_nested_components_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of unstable nested components",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NESTED_COMPONENT: "Do not nest components inside other components. Move it to the top level.",
      NESTED_COMPONENT_IN_PROPS: "Do not nest components inside props. Move it to the top level or pass it as a prop."
    },
    schema: []
  },
  name: RULE_NAME26,
  create(context) {
    const hint = ERComponentHint.SkipMapCallback | ERComponentHint.SkipNullLiteral | ERComponentHint.SkipUndefinedLiteral | ERComponentHint.SkipBooleanLiteral | ERComponentHint.SkipStringLiteral | ERComponentHint.SkipNumberLiteral | ERComponentHint.StrictLogical | ERComponentHint.StrictConditional;
    const collector = useComponentCollector(context, hint);
    const collectorLegacy = useComponentCollectorLegacy();
    return {
      ...collector.listeners,
      ...collectorLegacy.listeners,
      "Program:exit"(node) {
        const functionComponents = Array.from(collector.ctx.getAllComponents(node).values());
        const classComponents = Array.from(collectorLegacy.ctx.getAllComponents(node).values());
        const isFunctionComponent = (node2) => {
          return isFunction(node2) && functionComponents.some((component) => component.node === node2);
        };
        const isClassComponent2 = (node2) => {
          return isClass(node2) && classComponents.some((component) => component.node === node2);
        };
        for (const { name: componentName, node: component } of functionComponents) {
          if (unsafeIsDirectValueOfRenderProperty(component)) continue;
          if (Option_exports6.isNone(componentName)) continue;
          const name2 = componentName.value;
          const isInsideProperty = component.parent.type === NodeType3.Property;
          const isInsideJSXPropValue = isInsidePropValue(component);
          if (isInsideJSXPropValue) {
            if (!unsafeIsDeclaredInRenderProp(component)) {
              context.report({
                data: {
                  name: name2
                },
                messageId: "NESTED_COMPONENT_IN_PROPS",
                node: component
              });
            }
            continue;
          }
          if (isInsideCreateElementProps(component, context)) {
            context.report({
              data: {
                name: name2
              },
              messageId: "NESTED_COMPONENT_IN_PROPS",
              node: component
            });
            continue;
          }
          const maybeParentComponent = traverseUpGuard3(component, isFunctionComponent);
          if (Option_exports6.isSome(maybeParentComponent) && !unsafeIsDirectValueOfRenderProperty(maybeParentComponent.value)) {
            context.report({
              data: {
                name: name2
              },
              messageId: isInsideProperty ? "NESTED_COMPONENT_IN_PROPS" : "NESTED_COMPONENT",
              node: component
            });
            continue;
          }
          const isInsideClassComponentRenderMethod = isInsideRenderMethod(component);
          if (isInsideClassComponentRenderMethod) {
            context.report({
              data: {
                name: name2
              },
              messageId: "NESTED_COMPONENT",
              node: component
            });
          }
        }
        for (const { name: name2, node: component } of classComponents) {
          if (Option_exports6.isNone(traverseUp3(component, (node2) => isClassComponent2(node2) || isFunctionComponent(node2)))) continue;
          context.report({
            data: {
              name: Option_exports6.getOrElse(() => "unknown")(name2)
            },
            messageId: "NESTED_COMPONENT",
            node: component
          });
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-redundant-should-component-update.ts
var RULE_NAME27 = "no-redundant-should-component-update";
function isShouldComponentUpdate(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "shouldComponentUpdate";
}
var no_redundant_should_component_update_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of 'shouldComponentUpdate' in class component extends 'React.PureComponent'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_REDUNDANT_SHOULD_COMPONENT_UPDATE: "'{{componentName}}' does not need 'shouldComponentUpdate' when extending 'React.PureComponent'."
    },
    schema: []
  },
  name: RULE_NAME27,
  create(context) {
    const { ctx, listeners } = useComponentCollectorLegacy();
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { name: name2, flag, node: component } of components.values()) {
          if (!(flag & ERClassComponentFlag.PureComponent)) continue;
          const { body } = component.body;
          for (const member of body) {
            if (isShouldComponentUpdate(member)) {
              context.report({
                data: {
                  componentName: Option_exports6.getOrElse(() => "PureComponent")(name2)
                },
                messageId: "NO_REDUNDANT_SHOULD_COMPONENT_UPDATE",
                node: member
              });
            }
          }
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-set-state-in-component-did-mount.ts
var RULE_NAME28 = "no-set-state-in-component-did-mount";
function isThisSetState2(node) {
  const { callee } = node;
  return callee.type === NodeType3.MemberExpression && callee.object.type === NodeType3.ThisExpression && callee.property.type === NodeType3.Identifier && callee.property.name === "setState";
}
function isComponentDidMount(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "componentDidMount";
}
var no_set_state_in_component_did_mount_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'setState' in 'componentDidMount'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_SET_STATE_IN_COMPONENT_DID_MOUNT: "Do not call `this.setState` in `componentDidMount` outside of functions, such as callbacks."
    },
    schema: []
  },
  name: RULE_NAME28,
  create(context) {
    return {
      CallExpression(node) {
        if (!isThisSetState2(node)) return;
        const maybeParentClass = traverseUp3(node, isOneOf3([NodeType3.ClassDeclaration, NodeType3.ClassExpression]));
        if (Option_exports6.isNone(maybeParentClass)) return;
        const parentClass = maybeParentClass.value;
        if (!isClassComponent(parentClass)) return;
        const maybeParentMethod = traverseUp3(node, isComponentDidMount);
        if (Option_exports6.isNone(maybeParentMethod)) return;
        const parentMethod = maybeParentMethod.value;
        if (parentMethod.parent !== parentClass.body) return;
        if (context.sourceCode.getScope(node).upper !== context.sourceCode.getScope(parentMethod)) return;
        context.report({
          messageId: "NO_SET_STATE_IN_COMPONENT_DID_MOUNT",
          node
        });
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-set-state-in-component-did-update.ts
var RULE_NAME29 = "no-set-state-in-component-did-update";
function isThisSetState3(node) {
  const { callee } = node;
  return callee.type === NodeType3.MemberExpression && callee.object.type === NodeType3.ThisExpression && callee.property.type === NodeType3.Identifier && callee.property.name === "setState";
}
function isComponentDidUpdate(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "componentDidUpdate";
}
var no_set_state_in_component_did_update_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'setState' in 'componentDidUpdate'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_SET_STATE_IN_COMPONENT_DID_UPDATE: "Do not call `this.setState` in `componentDidUpdate` outside of functions, such as callbacks."
    },
    schema: []
  },
  name: RULE_NAME29,
  create(context) {
    return {
      CallExpression(node) {
        if (!isThisSetState3(node)) return;
        const maybeParentClass = traverseUp3(node, isOneOf3([NodeType3.ClassDeclaration, NodeType3.ClassExpression]));
        if (Option_exports6.isNone(maybeParentClass)) return;
        const parentClass = maybeParentClass.value;
        if (!isClassComponent(parentClass)) return;
        const maybeParentMethod = traverseUp3(node, isComponentDidUpdate);
        if (Option_exports6.isNone(maybeParentMethod)) return;
        const parentMethod = maybeParentMethod.value;
        if (parentMethod.parent !== parentClass.body) return;
        if (context.sourceCode.getScope(node).upper !== context.sourceCode.getScope(parentMethod)) return;
        context.report({
          messageId: "NO_SET_STATE_IN_COMPONENT_DID_UPDATE",
          node
        });
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-set-state-in-component-will-update.ts
var RULE_NAME30 = "no-set-state-in-component-will-update";
function isThisSetState4(node) {
  const { callee } = node;
  return callee.type === NodeType3.MemberExpression && callee.object.type === NodeType3.ThisExpression && callee.property.type === NodeType3.Identifier && callee.property.name === "setState";
}
function isComponentWillUpdate3(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "componentWillUpdate";
}
var no_set_state_in_component_will_update_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'setState' in 'componentWillUpdate'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_SET_STATE_IN_COMPONENT_WILL_UPDATE: "Do not call `this.setState` in `componentWillUpdate` outside of functions, such as callbacks."
    },
    schema: []
  },
  name: RULE_NAME30,
  create(context) {
    return {
      CallExpression(node) {
        if (!isThisSetState4(node)) return;
        const maybeParentClass = traverseUp3(node, isOneOf3([NodeType3.ClassDeclaration, NodeType3.ClassExpression]));
        if (Option_exports6.isNone(maybeParentClass)) return;
        const parentClass = maybeParentClass.value;
        if (!isClassComponent(parentClass)) return;
        const maybeParentMethod = traverseUp3(node, isComponentWillUpdate3);
        if (Option_exports6.isNone(maybeParentMethod)) return;
        const parentMethod = maybeParentMethod.value;
        if (parentMethod.parent !== parentClass.body) return;
        if (context.sourceCode.getScope(node).upper !== context.sourceCode.getScope(parentMethod)) return;
        context.report({
          messageId: "NO_SET_STATE_IN_COMPONENT_WILL_UPDATE",
          node
        });
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-string-refs.ts
var RULE_NAME31 = "no-string-refs";
function containsStringLiteral({ value }) {
  return value?.type === NodeType3.Literal && Predicate_exports5.isString(value.value);
}
function containsStringExpressionContainer({ value }) {
  if (value?.type !== NodeType3.JSXExpressionContainer) return false;
  if (value.expression.type === NodeType3.Literal) return Predicate_exports5.isString(value.expression.value);
  return value.expression.type === NodeType3.TemplateLiteral;
}
var no_string_refs_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow using deprecated string refs",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_STRING_REFS: "[Deprecated] Use callback refs instead."
    },
    schema: []
  },
  name: RULE_NAME31,
  create(context) {
    return {
      JSXAttribute(node) {
        if (node.name.name !== "ref") return;
        if (containsStringLiteral(node) || containsStringExpressionContainer(node)) {
          context.report({
            messageId: "NO_STRING_REFS",
            node
          });
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-unsafe-component-will-mount.ts
var RULE_NAME32 = "no-unsafe-component-will-mount";
function isUnsafeComponentWillMount(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "UNSAFE_componentWillMount";
}
var no_unsafe_component_will_mount_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of 'UNSAFE_componentWillMount'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_UNSAFE_COMPONENT_WILL_MOUNT: "Do not use 'UNSAFE_componentWillMount'."
    },
    schema: []
  },
  name: RULE_NAME32,
  create(context) {
    const { ctx, listeners } = useComponentCollectorLegacy();
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { node: component } of components.values()) {
          const { body } = component.body;
          for (const member of body) {
            if (isUnsafeComponentWillMount(member)) {
              context.report({
                messageId: "NO_UNSAFE_COMPONENT_WILL_MOUNT",
                node: member
              });
            }
          }
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-unsafe-component-will-receive-props.ts
var RULE_NAME33 = "no-unsafe-component-will-receive-props";
function isUnsafeComponentWillReceiveProps(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "UNSAFE_componentWillReceiveProps";
}
var no_unsafe_component_will_receive_props_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of 'UNSAFE_componentWillReceiveProps'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_UNSAFE_COMPONENT_WILL_RECEIVE_PROPS: "Do not use 'UNSAFE_componentWillReceiveProps'."
    },
    schema: []
  },
  name: RULE_NAME33,
  create(context) {
    const { ctx, listeners } = useComponentCollectorLegacy();
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { node: component } of components.values()) {
          const { body } = component.body;
          for (const member of body) {
            if (isUnsafeComponentWillReceiveProps(member)) {
              context.report({
                messageId: "NO_UNSAFE_COMPONENT_WILL_RECEIVE_PROPS",
                node: member
              });
            }
          }
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-unsafe-component-will-update.ts
var RULE_NAME34 = "no-unsafe-component-will-update";
function isUnsafeComponentWillMount2(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "UNSAFE_componentWillUpdate";
}
var no_unsafe_component_will_update_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of 'UNSAFE_componentWillUpdate'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_UNSAFE_COMPONENT_WILL_UPDATE: "Do not use 'UNSAFE_componentWillUpdate'."
    },
    schema: []
  },
  name: RULE_NAME34,
  create(context) {
    const { ctx, listeners } = useComponentCollectorLegacy();
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { node: component } of components.values()) {
          const { body } = component.body;
          for (const member of body) {
            if (isUnsafeComponentWillMount2(member)) {
              context.report({
                messageId: "NO_UNSAFE_COMPONENT_WILL_UPDATE",
                node: member
              });
            }
          }
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-unstable-context-value.ts
var RULE_NAME35 = "no-unstable-context-value";
var no_unstable_context_value_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow passing constructed values to context providers",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_UNSTABLE_CONTEXT_VALUE: "A/an '{{type}}' passed as the value prop to the context provider should not be constructed. It will change on every render.",
      NO_UNSTABLE_CONTEXT_VALUE_WITH_FUNCTION: "A/an '{{type}}' passed as the value prop to the context provider should not be constructed. It will change on every render. Consider wrapping it in a useCallback hook.",
      NO_UNSTABLE_CONTEXT_VALUE_WITH_IDENTIFIER: "A/an '{{type}}' passed as the value prop to the context provider should not be constructed. It will change on every render. Consider wrapping it in a useMemo hook."
    },
    schema: []
  },
  name: RULE_NAME35,
  create(context) {
    const { ctx, listeners } = useComponentCollector(context);
    const possibleValueConstructions = /* @__PURE__ */ new Map();
    return {
      ...listeners,
      JSXOpeningElement(node) {
        const openingElementName = node.name;
        if (openingElementName.type !== NodeType3.JSXMemberExpression) return;
        if (openingElementName.property.name !== "Provider") return;
        const maybeJSXValueAttribute = Option_exports6.fromNullable(
          node.attributes.find((attribute) => {
            return attribute.type === NodeType3.JSXAttribute && attribute.name.name === "value";
          })
        );
        if (Option_exports6.isNone(maybeJSXValueAttribute) || !("value" in maybeJSXValueAttribute.value)) return;
        const valueNode = maybeJSXValueAttribute.value.value;
        if (valueNode?.type !== NodeType3.JSXExpressionContainer) return;
        const valueExpression = valueNode.expression;
        const construction = inspectConstruction(valueExpression, context);
        if (construction._tag === "None") return;
        Option_exports6.map(
          ctx.getCurrentFunction(),
          ([currentFn]) => possibleValueConstructions.set(currentFn, [
            ...possibleValueConstructions.get(currentFn) ?? [],
            construction
          ])
        );
      },
      "Program:exit"(node) {
        const components = Array.from(ctx.getAllComponents(node).values());
        for (const { node: component } of components) {
          const constructions = possibleValueConstructions.get(component);
          if (!constructions) continue;
          for (const construction of constructions) {
            if (construction._tag === "None") continue;
            const { _tag, node: constructionNode } = construction;
            const messageId = _tag.startsWith("Function") ? "NO_UNSTABLE_CONTEXT_VALUE_WITH_FUNCTION" : "NO_UNSTABLE_CONTEXT_VALUE_WITH_IDENTIFIER";
            context.report({
              data: {
                type: readableNodeType(constructionNode)
              },
              messageId,
              node: constructionNode
            });
          }
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-unstable-default-props.ts
var RULE_NAME36 = "no-unstable-default-props";
var no_unstable_default_props_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of unstable value as default param in function component",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_UNSTABLE_DEFAULT_PROPS: "A/an '{{forbiddenType}}' as default prop. This could lead to potential infinite render loop in React. Use a variable instead of '{{forbiddenType}}'."
    },
    schema: []
  },
  name: RULE_NAME36,
  create(context) {
    const { ctx, listeners } = useComponentCollector(context);
    const possibleDestructuringDeclarators = /* @__PURE__ */ new WeakMap();
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { node: component } of components.values()) {
          const { params } = component;
          const [props] = params;
          if (!props) continue;
          const properties = $(props).with({ type: NodeType3.ObjectPattern }, ({ properties: properties2 }) => properties2).with({ type: NodeType3.Identifier }, ({ name: name2 }) => {
            const variableDeclarators = possibleDestructuringDeclarators.get(component);
            if (!variableDeclarators) return [];
            const declarators = variableDeclarators.filter((d5) => d5.init.name === name2);
            return declarators.flatMap((d5) => d5.id.properties);
          }).otherwise(() => []);
          for (const prop of properties) {
            if (prop.type !== NodeType3.Property || prop.value.type !== NodeType3.AssignmentPattern) continue;
            const { value } = prop;
            const { right: right9 } = value;
            const construction = inspectConstruction(value, context, ConstructionHint.StrictCallExpression);
            if (construction._tag === "None") continue;
            const forbiddenType = readableNodeType(right9);
            context.report({
              data: {
                forbiddenType
              },
              messageId: "NO_UNSTABLE_DEFAULT_PROPS",
              node: right9
            });
          }
        }
      },
      "VariableDeclarator[id.type='ObjectPattern'][init.type='Identifier']"(node) {
        Option_exports6.map(
          ctx.getCurrentFunction(),
          ([currentFn]) => possibleDestructuringDeclarators.set(currentFn, [
            ...possibleDestructuringDeclarators.get(currentFn) ?? [],
            node
          ])
        );
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-unused-class-component-members.ts
var RULE_NAME37 = "no-unused-class-component-members";
var LIFECYCLE_METHODS = /* @__PURE__ */ new Set([
  "constructor",
  "componentDidCatch",
  "componentDidMount",
  "componentDidUpdate",
  "componentWillMount",
  "componentWillReceiveProps",
  "componentWillUnmount",
  "componentWillUpdate",
  "getSnapshotBeforeUpdate",
  "shouldComponentUpdate",
  "UNSAFE_componentWillMount",
  "UNSAFE_componentWillReceiveProps",
  "UNSAFE_componentWillUpdate",
  "state",
  "render"
]);
function isKeyLiteralLike2(node, property) {
  return property.type === NodeType3.Literal || property.type === NodeType3.TemplateLiteral && property.expressions.length === 0 || !node.computed && property.type === NodeType3.Identifier;
}
function getName3(node) {
  if (node.type === NodeType3.TSAsExpression) {
    return getName3(node.expression);
  }
  if (node.type === NodeType3.Identifier || node.type === NodeType3.PrivateIdentifier) {
    return Option_exports6.some(node.name);
  }
  if (node.type === NodeType3.Literal) {
    return Option_exports6.some(String(node.value));
  }
  if (node.type === NodeType3.TemplateLiteral && node.expressions.length === 0) {
    return Option_exports6.fromNullable(node.quasis[0]?.value.raw);
  }
  return Option_exports6.none();
}
var no_unused_class_component_members_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow unused class component members",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_UNUSED_CLASS_COMPONENT_MEMBERS: "Unused method or property '{{methodName}}'' of class '{{className}}'."
    },
    schema: []
  },
  name: RULE_NAME37,
  create(context) {
    const classStack = MutableList_exports2.make();
    const methodStack = MutableList_exports2.make();
    const propertyDefs = /* @__PURE__ */ new WeakMap();
    const propertyUsages = /* @__PURE__ */ new WeakMap();
    function classEnter(node) {
      MutableList_exports2.append(classStack, node);
      if (!isClassComponent(node)) return;
      propertyDefs.set(node, /* @__PURE__ */ new Set());
      propertyUsages.set(node, /* @__PURE__ */ new Set());
    }
    function classExit() {
      const currentClass = MutableList_exports2.pop(classStack);
      if (!currentClass || !isClassComponent(currentClass)) return;
      const className = Option_exports6.map(getClassIdentifier(currentClass), (id) => id.name);
      const defs = propertyDefs.get(currentClass);
      const usages = propertyUsages.get(currentClass);
      if (!defs) return;
      for (const def of defs) {
        const name2 = getName3(def);
        if (Option_exports6.isNone(name2)) continue;
        if (!!usages?.has(name2.value) || LIFECYCLE_METHODS.has(name2.value)) continue;
        context.report({
          data: {
            className: Option_exports6.getOrElse(className, () => "Component"),
            methodName: name2.value
          },
          messageId: "NO_UNUSED_CLASS_COMPONENT_MEMBERS",
          node: def
        });
      }
    }
    function methodEnter(node) {
      MutableList_exports2.append(methodStack, node);
      const currentClass = MutableList_exports2.tail(classStack);
      if (!currentClass || !isClassComponent(currentClass)) return;
      if (node.static) return;
      if (isKeyLiteralLike2(node, node.key)) {
        propertyDefs.get(currentClass)?.add(node.key);
      }
    }
    function methodExit() {
      MutableList_exports2.pop(methodStack);
    }
    return {
      ClassDeclaration: classEnter,
      "ClassDeclaration:exit": classExit,
      ClassExpression: classEnter,
      "ClassExpression:exit": classExit,
      MemberExpression(node) {
        const currentClass = MutableList_exports2.tail(classStack);
        const currentMethod = MutableList_exports2.tail(methodStack);
        if (!currentClass || !currentMethod) return;
        if (!isClassComponent(currentClass) || currentMethod.static) return;
        if (!isThisExpression(node.object) || !isKeyLiteralLike2(node, node.property)) return;
        if (node.parent.type === NodeType3.AssignmentExpression && node.parent.left === node) {
          propertyDefs.get(currentClass)?.add(node.property);
          return;
        }
        Option_exports6.map(getName3(node.property), (name2) => propertyUsages.get(currentClass)?.add(name2));
      },
      MethodDefinition: methodEnter,
      "MethodDefinition:exit": methodExit,
      PropertyDefinition: methodEnter,
      "PropertyDefinition:exit": methodExit,
      VariableDeclarator(node) {
        const currentClass = MutableList_exports2.tail(classStack);
        const currentMethod = MutableList_exports2.tail(methodStack);
        if (!currentClass || !currentMethod) return;
        if (!isClassComponent(currentClass) || currentMethod.static) return;
        if (node.init && isThisExpression(node.init) && node.id.type === NodeType3.ObjectPattern) {
          for (const prop of node.id.properties) {
            if (prop.type === NodeType3.Property && isKeyLiteralLike2(prop, prop.key)) {
              Option_exports6.map(getName3(prop.key), (name2) => propertyUsages.get(currentClass)?.add(name2));
            }
          }
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-unused-state.ts
var RULE_NAME38 = "no-unused-state";
function isKeyLiteralLike3(node, property) {
  return property.type === NodeType3.Literal || property.type === NodeType3.TemplateLiteral && property.expressions.length === 0 || !node.computed && property.type === NodeType3.Identifier;
}
function getName4(node) {
  if (node.type === NodeType3.TSAsExpression) {
    return getName4(node.expression);
  }
  if (node.type === NodeType3.Identifier || node.type === NodeType3.PrivateIdentifier) {
    return Option_exports6.some(node.name);
  }
  if (node.type === NodeType3.Literal) {
    return Option_exports6.some(String(node.value));
  }
  if (node.type === NodeType3.TemplateLiteral && node.expressions.length === 0) {
    return Option_exports6.fromNullable(node.quasis[0]?.value.raw);
  }
  return Option_exports6.none();
}
function isAssignmentToThisState2(node) {
  const { left: left9 } = node;
  return left9.type === NodeType3.MemberExpression && isThisExpression(left9.object) && Option_exports6.exists(getName4(left9.property), (name2) => name2 === "state");
}
var isGetDerivedStateFromProps = a({
  key: {
    name: "getDerivedStateFromProps"
  },
  static: true,
  value: {
    params: N.array()
  }
});
var no_unused_state_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "Prevents unused state of class component.",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_UNUSED_STATE: "Unused class component state."
    },
    schema: []
  },
  name: RULE_NAME38,
  create(context) {
    const classStack = MutableList_exports2.make();
    const methodStack = MutableList_exports2.make();
    const constructorStack = MutableList_exports2.make();
    const stateDefs = /* @__PURE__ */ new WeakMap();
    function classEnter(node) {
      MutableList_exports2.append(classStack, node);
    }
    function classExit() {
      const currentClass = MutableList_exports2.pop(classStack);
      if (!currentClass || !isClassComponent(currentClass)) return;
      const className = Option_exports6.map(getClassIdentifier(currentClass), (id) => id.name);
      const [def, isUsed] = stateDefs.get(currentClass) ?? [Option_exports6.none(), false];
      if (Option_exports6.isNone(def) || isUsed) return;
      context.report({
        data: {
          className: Option_exports6.getOrElse(className, () => "Component")
        },
        messageId: "NO_UNUSED_STATE",
        node: def.value
      });
    }
    function methodEnter(node) {
      MutableList_exports2.append(methodStack, node);
      const currentClass = MutableList_exports2.tail(classStack);
      if (!currentClass || !isClassComponent(currentClass)) return;
      if (node.static) {
        if (isGetDerivedStateFromProps(node) && node.value.params.length > 1) {
          const [def] = stateDefs.get(currentClass) ?? [Option_exports6.none()];
          stateDefs.set(currentClass, [def, true]);
        }
        return;
      }
      if (Option_exports6.exists(getName4(node.key), (name2) => name2 === "state")) {
        stateDefs.set(currentClass, [Option_exports6.some(node.key), false]);
      }
    }
    function methodExit() {
      MutableList_exports2.pop(methodStack);
    }
    function constructorEnter(node) {
      MutableList_exports2.append(constructorStack, node);
    }
    function constructorExit() {
      MutableList_exports2.pop(constructorStack);
    }
    return {
      AssignmentExpression(node) {
        if (!isAssignmentToThisState2(node)) return;
        const currentClass = MutableList_exports2.tail(classStack);
        if (!currentClass || !isClassComponent(currentClass)) return;
        const currentConstructor = MutableList_exports2.tail(constructorStack);
        if (!currentConstructor || !currentClass.body.body.includes(currentConstructor)) return;
        const [_5, isUsed] = stateDefs.get(currentClass) ?? [Option_exports6.none(), false];
        stateDefs.set(currentClass, [Option_exports6.some(node.left), isUsed]);
      },
      ClassDeclaration: classEnter,
      "ClassDeclaration:exit": classExit,
      ClassExpression: classEnter,
      "ClassExpression:exit": classExit,
      MemberExpression(node) {
        if (!isThisExpression(node.object)) return;
        if (!Option_exports6.exists(getName4(node.property), (name2) => name2 === "state")) return;
        const currentClass = MutableList_exports2.tail(classStack);
        if (!currentClass || !isClassComponent(currentClass)) return;
        const currentMethod = MutableList_exports2.tail(methodStack);
        if (!currentMethod || currentMethod.static) return;
        if (currentMethod === MutableList_exports2.tail(constructorStack)) return;
        if (!currentClass.body.body.includes(currentMethod)) return;
        const [def] = stateDefs.get(currentClass) ?? [Option_exports6.none(), false];
        stateDefs.set(currentClass, [def, true]);
      },
      MethodDefinition: methodEnter,
      "MethodDefinition:exit": methodExit,
      "MethodDefinition[key.name='constructor']": constructorEnter,
      "MethodDefinition[key.name='constructor']:exit": constructorExit,
      PropertyDefinition: methodEnter,
      "PropertyDefinition:exit": methodExit,
      VariableDeclarator(node) {
        const currentClass = MutableList_exports2.tail(classStack);
        if (!currentClass || !isClassComponent(currentClass)) return;
        const currentMethod = MutableList_exports2.tail(methodStack);
        if (!currentMethod || currentMethod.static) return;
        if (currentMethod === MutableList_exports2.tail(constructorStack)) return;
        if (!currentClass.body.body.includes(currentMethod)) return;
        if (!(node.init && isThisExpression(node.init) && node.id.type === NodeType3.ObjectPattern)) return;
        const hasState = node.id.properties.some((prop) => {
          if (prop.type === NodeType3.Property && isKeyLiteralLike3(prop, prop.key)) {
            return Option_exports6.exists(getName4(prop.key), (name2) => name2 === "state");
          }
          return false;
        });
        if (!hasState) return;
        const [def] = stateDefs.get(currentClass) ?? [Option_exports6.none(), false];
        stateDefs.set(currentClass, [def, true]);
      }
    };
  },
  defaultOptions: []
});

// src/rules/no-useless-fragment.ts
var RULE_NAME39 = "no-useless-fragment";
function isFragmentWithOnlyTextAndIsNotChild(node) {
  return node.children.length === 1 && isLiteral(node.children[0]) && !(node.parent.type === NodeType3.JSXElement || node.parent.type === NodeType3.JSXFragment);
}
function containsCallExpression(node) {
  return node.type === NodeType3.JSXExpressionContainer && node.expression.type === NodeType3.CallExpression;
}
function isFragmentHasLessThanTwoChildren(node) {
  const nonPaddingChildren = node.children.filter(
    (child) => !isPaddingSpaces(child)
  );
  if (nonPaddingChildren.length === 1 && nonPaddingChildren[0]) {
    return !containsCallExpression(nonPaddingChildren[0]);
  }
  return nonPaddingChildren.length === 0;
}
function isFragmentWithSingleExpression(node) {
  const children = node.children.filter((child) => !isPaddingSpaces(child));
  return children.length === 1 && children[0]?.type === NodeType3.JSXExpressionContainer;
}
var no_useless_fragment_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow unnecessary fragments",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_USELESS_FRAGMENT: "A fragment containing a single element is usually unnecessary.",
      NO_USELESS_FRAGMENT_IN_BUILT_IN: "Passing a fragment to a host component is unnecessary."
    },
    schema: []
  },
  name: RULE_NAME39,
  create(context) {
    function checkNode(node) {
      const initialScope = context.sourceCode.getScope(node);
      if (node.type === NodeType3.JSXElement && hasProp(
        node.openingElement.attributes,
        "key",
        context,
        initialScope
      )) {
        return;
      }
      if (isFragmentHasLessThanTwoChildren(node) && !isFragmentWithOnlyTextAndIsNotChild(node) && !(isFragmentWithSingleExpression(node))) {
        context.report({
          messageId: "NO_USELESS_FRAGMENT",
          node
        });
      }
      if (node.parent.type === NodeType3.JSXElement && isJSXElementOfBuiltinComponent(node.parent)) {
        context.report({
          messageId: "NO_USELESS_FRAGMENT_IN_BUILT_IN",
          node
        });
      }
    }
    return {
      JSXElement(node) {
        if (isFragmentElement(node, context)) {
          checkNode(node);
        }
      },
      JSXFragment: checkNode
    };
  },
  defaultOptions: []
});

// src/rules/prefer-destructuring-assignment.ts
var RULE_NAME40 = "prefer-destructuring-assignment";
function isMemberExpressionWithObjectName(node) {
  return node.object.type === NodeType3.Identifier && "name" in node.object;
}
var prefer_destructuring_assignment_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "enforce using destructuring assignment in component props and context",
      recommended: "recommended"
    },
    messages: {
      PREFER_DESTRUCTURING_ASSIGNMENT: "Prefer destructuring assignment."
    },
    schema: []
  },
  name: RULE_NAME40,
  create(context) {
    const { ctx, listeners } = useComponentCollector(context);
    const memberExpressionWithNames = [];
    return {
      ...listeners,
      MemberExpression(node) {
        if (isMemberExpressionWithObjectName(node)) {
          const scope = context.sourceCode.getScope(node);
          memberExpressionWithNames.push([scope, node]);
        }
      },
      "Program:exit"(node) {
        const components = Array.from(ctx.getAllComponents(node).values());
        function isFunctionComponent(block) {
          if (!isFunction(block)) return false;
          const maybeId = getFunctionIdentifier(block);
          return Option_exports6.isSome(maybeId) && isComponentName(maybeId.value.name) && components.some((component) => component.node === block);
        }
        for (const [scope, memberExpression] of memberExpressionWithNames) {
          const scopeRef = MutableRef_exports4.make(scope);
          const isComponentRef = MutableRef_exports4.make(isFunctionComponent(scope.block));
          while (!MutableRef_exports4.get(isComponentRef) && MutableRef_exports4.get(scopeRef).upper && MutableRef_exports4.get(scopeRef).upper !== MutableRef_exports4.get(scopeRef)) {
            MutableRef_exports4.set(scopeRef, MutableRef_exports4.get(scopeRef).upper);
            MutableRef_exports4.set(isComponentRef, isFunctionComponent(MutableRef_exports4.get(scopeRef).block));
          }
          if (!MutableRef_exports4.get(isComponentRef)) continue;
          const component = MutableRef_exports4.get(scopeRef).block;
          if (!("params" in component)) continue;
          const [props, ctx2] = component.params;
          const isMatch = a({ name: memberExpression.object.name });
          if (isMatch(props)) {
            context.report({
              messageId: "PREFER_DESTRUCTURING_ASSIGNMENT",
              node: memberExpression
            });
          }
          if (isMatch(ctx2)) {
            context.report({
              messageId: "PREFER_DESTRUCTURING_ASSIGNMENT",
              node: memberExpression
            });
          }
        }
      }
    };
  },
  defaultOptions: []
});

// src/rules/prefer-shorthand-boolean.ts
var RULE_NAME41 = "prefer-shorthand-boolean";
var prefer_shorthand_boolean_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "enforce boolean attributes notation in JSX",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      PREFER_SHORTHAND_BOOLEAN: "Prefer using shorthand boolean attribute '{{propName}}'"
    },
    schema: []
  },
  name: RULE_NAME41,
  create(context) {
    return {
      JSXAttribute(node) {
        const { value } = node;
        const propName = getPropName(node);
        const hasValueTrue = value?.type === NodeType3.JSXExpressionContainer && value.expression.type === NodeType3.Literal && value.expression.value === true;
        if (!hasValueTrue) return;
        context.report({
          data: {
            propName
          },
          messageId: "PREFER_SHORTHAND_BOOLEAN",
          node
        });
      }
    };
  },
  defaultOptions: []
});

// src/rules/prefer-shorthand-fragment.ts
var RULE_NAME42 = "prefer-shorthand-fragment";
var prefer_shorthand_fragment_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "enforce using fragment syntax instead of Fragment component",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      PREFER_SHORTHAND_FRAGMENT: "Prefer shorthand fragment syntax instead of fragment component."
    },
    schema: []
  },
  name: RULE_NAME42,
  create(context) {
    return {
      JSXElement(node) {
        if (isFragmentElement(node, context)) {
          const hasAttributes = node.openingElement.attributes.length > 0;
          if (hasAttributes) return;
          context.report({
            messageId: "PREFER_SHORTHAND_FRAGMENT",
            node
          });
        }
      }
    };
  },
  defaultOptions: []
});

// src/index.ts
var meta = {
  name,
  version
};
var rules = {
  "avoid-shorthand-boolean": avoid_shorthand_boolean_default,
  "avoid-shorthand-fragment": avoid_shorthand_fragment_default,
  "ensure-forward-ref-using-ref": ensure_forward_ref_using_ref_default,
  "no-access-state-in-setstate": no_access_state_in_setstate_default,
  "no-array-index-key": no_array_index_key_default,
  "no-children-count": no_children_count_default,
  "no-children-for-each": no_children_for_each_default,
  "no-children-map": no_children_map_default,
  "no-children-only": no_children_only_default,
  "no-children-prop": no_children_prop_default,
  "no-children-to-array": no_children_to_array_default,
  "no-class-component": no_class_component_default,
  "no-clone-element": no_clone_element_default,
  "no-comment-textnodes": no_comment_textnodes_default,
  "no-complicated-conditional-rendering": no_complicated_conditional_rendering_default,
  "no-component-will-mount": no_component_will_mount_default,
  "no-component-will-receive-props": no_component_will_receive_props_default,
  "no-component-will-update": no_component_will_update_default,
  "no-create-ref": no_create_ref_default,
  "no-direct-mutation-state": no_direct_mutation_state_default,
  "no-duplicate-key": no_duplicate_key_default,
  "no-implicit-key": no_implicit_key_default,
  "no-leaked-conditional-rendering": no_leaked_conditional_rendering_default,
  "no-missing-component-display-name": no_missing_component_display_name_default,
  "no-missing-key": no_missing_key_default,
  "no-nested-components": no_nested_components_default,
  "no-redundant-should-component-update": no_redundant_should_component_update_default,
  "no-set-state-in-component-did-mount": no_set_state_in_component_did_mount_default,
  "no-set-state-in-component-did-update": no_set_state_in_component_did_update_default,
  "no-set-state-in-component-will-update": no_set_state_in_component_will_update_default,
  "no-string-refs": no_string_refs_default,
  "no-unsafe-component-will-mount": no_unsafe_component_will_mount_default,
  "no-unsafe-component-will-receive-props": no_unsafe_component_will_receive_props_default,
  "no-unsafe-component-will-update": no_unsafe_component_will_update_default,
  "no-unstable-context-value": no_unstable_context_value_default,
  "no-unstable-default-props": no_unstable_default_props_default,
  "no-unused-class-component-members": no_unused_class_component_members_default,
  "no-unused-state": no_unused_state_default,
  "no-useless-fragment": no_useless_fragment_default,
  "prefer-destructuring-assignment": prefer_destructuring_assignment_default,
  "prefer-shorthand-boolean": prefer_shorthand_boolean_default,
  "prefer-shorthand-fragment": prefer_shorthand_fragment_default
};

export { meta, rules };
